""" Cisco_IOS_XR_qos_ma_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR qos\-ma\-oper package operational data.

This module contains definitions
for the following management objects\:
  qos\: QoS operational data

Copyright (c) 2013\-2017 by Cisco Systems, Inc.
All rights reserved.

"""
from ydk.entity_utils import get_relative_entity_path as _get_relative_entity_path
from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YPYError, YPYModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error


class CacState(Enum):
    """
    CacState

    CAC/UBRL class states

    .. data:: unknown = 0

    	unknown

    .. data:: admit = 1

    	admit

    .. data:: redirect = 2

    	redirect

    .. data:: ubrl = 3

    	ubrl

    """

    unknown = Enum.YLeaf(0, "unknown")

    admit = Enum.YLeaf(1, "admit")

    redirect = Enum.YLeaf(2, "redirect")

    ubrl = Enum.YLeaf(3, "ubrl")


class PolicyParamUnit(Enum):
    """
    PolicyParamUnit

    Policy param unit

    .. data:: policy_param_unit_invalid = 0

    	policy param unit invalid

    .. data:: policy_param_unit_bytes = 1

    	policy param unit bytes

    .. data:: policy_param_unit_kbytes = 2

    	policy param unit kbytes

    .. data:: policy_param_unit_mbytes = 3

    	policy param unit mbytes

    .. data:: policy_param_unit_gbytes = 4

    	policy param unit gbytes

    .. data:: policy_param_unit_bitsps = 5

    	policy param unit bitsps

    .. data:: policy_param_unit_kbitsps = 6

    	policy param unit kbitsps

    .. data:: policy_param_unit_mbitsps = 7

    	policy param unit mbitsps

    .. data:: policy_param_unit_gbitsps = 8

    	policy param unit gbitsps

    .. data:: policy_param_unit_cells_ps = 9

    	policy param unit cells ps

    .. data:: policy_param_unit_packets_ps = 10

    	policy param unit packets ps

    .. data:: policy_param_unit_us = 11

    	policy param unit us

    .. data:: policy_param_unit_ms = 12

    	policy param unit ms

    .. data:: policy_param_unit_seconds = 13

    	policy param unit seconds

    .. data:: policy_param_unit_packets = 14

    	policy param unit packets

    .. data:: policy_param_unit_cells = 15

    	policy param unit cells

    .. data:: policy_param_unit_percent = 16

    	policy param unit percent

    .. data:: policy_param_unit_per_thousand = 17

    	policy param unit per thousand

    .. data:: policy_param_unit_per_million = 18

    	policy param unit per million

    .. data:: policy_param_unit_hz = 19

    	policy param unit hz

    .. data:: policy_param_unit_khz = 20

    	policy param unit khz

    .. data:: policy_param_unit_mhz = 21

    	policy param unit mhz

    .. data:: policy_param_unit_ratio = 22

    	policy param unit ratio

    .. data:: policy_param_unit_max = 23

    	policy param unit max

    """

    policy_param_unit_invalid = Enum.YLeaf(0, "policy-param-unit-invalid")

    policy_param_unit_bytes = Enum.YLeaf(1, "policy-param-unit-bytes")

    policy_param_unit_kbytes = Enum.YLeaf(2, "policy-param-unit-kbytes")

    policy_param_unit_mbytes = Enum.YLeaf(3, "policy-param-unit-mbytes")

    policy_param_unit_gbytes = Enum.YLeaf(4, "policy-param-unit-gbytes")

    policy_param_unit_bitsps = Enum.YLeaf(5, "policy-param-unit-bitsps")

    policy_param_unit_kbitsps = Enum.YLeaf(6, "policy-param-unit-kbitsps")

    policy_param_unit_mbitsps = Enum.YLeaf(7, "policy-param-unit-mbitsps")

    policy_param_unit_gbitsps = Enum.YLeaf(8, "policy-param-unit-gbitsps")

    policy_param_unit_cells_ps = Enum.YLeaf(9, "policy-param-unit-cells-ps")

    policy_param_unit_packets_ps = Enum.YLeaf(10, "policy-param-unit-packets-ps")

    policy_param_unit_us = Enum.YLeaf(11, "policy-param-unit-us")

    policy_param_unit_ms = Enum.YLeaf(12, "policy-param-unit-ms")

    policy_param_unit_seconds = Enum.YLeaf(13, "policy-param-unit-seconds")

    policy_param_unit_packets = Enum.YLeaf(14, "policy-param-unit-packets")

    policy_param_unit_cells = Enum.YLeaf(15, "policy-param-unit-cells")

    policy_param_unit_percent = Enum.YLeaf(16, "policy-param-unit-percent")

    policy_param_unit_per_thousand = Enum.YLeaf(17, "policy-param-unit-per-thousand")

    policy_param_unit_per_million = Enum.YLeaf(18, "policy-param-unit-per-million")

    policy_param_unit_hz = Enum.YLeaf(19, "policy-param-unit-hz")

    policy_param_unit_khz = Enum.YLeaf(20, "policy-param-unit-khz")

    policy_param_unit_mhz = Enum.YLeaf(21, "policy-param-unit-mhz")

    policy_param_unit_ratio = Enum.YLeaf(22, "policy-param-unit-ratio")

    policy_param_unit_max = Enum.YLeaf(23, "policy-param-unit-max")


class PolicyState(Enum):
    """
    PolicyState

    Different Interface states

    .. data:: active = 0

    	active

    .. data:: suspended = 1

    	suspended

    """

    active = Enum.YLeaf(0, "active")

    suspended = Enum.YLeaf(1, "suspended")


class QosCapsOperationEnum(Enum):
    """
    QosCapsOperationEnum

    Satellite QOS offload operation

    .. data:: add = 0

    	Add

    .. data:: remove = 1

    	Remove

    .. data:: replace = 2

    	Replace

    .. data:: modify = 3

    	Modify

    .. data:: unknown = 4

    	Unknown

    """

    add = Enum.YLeaf(0, "add")

    remove = Enum.YLeaf(1, "remove")

    replace = Enum.YLeaf(2, "replace")

    modify = Enum.YLeaf(3, "modify")

    unknown = Enum.YLeaf(4, "unknown")


class QosMaSatCapsTypeEnum(Enum):
    """
    QosMaSatCapsTypeEnum

    Satellite capsulation information

    .. data:: input = 0

    	Input

    .. data:: output = 1

    	Output

    .. data:: unknown = 2

    	Unknown

    """

    input = Enum.YLeaf(0, "input")

    output = Enum.YLeaf(1, "output")

    unknown = Enum.YLeaf(2, "unknown")


class Wred(Enum):
    """
    Wred

    Wred

    .. data:: wred_cos_cmd = 0

    	wred cos cmd

    .. data:: wred_dscp_cmd = 1

    	wred dscp cmd

    .. data:: wred_precedence_cmd = 2

    	wred precedence cmd

    .. data:: wred_discard_class_cmd = 3

    	wred discard class cmd

    .. data:: wred_mpls_exp_cmd = 4

    	wred mpls exp cmd

    .. data:: red_with_user_min_max = 5

    	red with user min max

    .. data:: red_with_default_min_max = 6

    	red with default min max

    .. data:: wred_dei_cmd = 7

    	wred dei cmd

    .. data:: wred_ecn_cmd = 8

    	wred ecn cmd

    .. data:: wred_invalid_cmd = 9

    	wred invalid cmd

    """

    wred_cos_cmd = Enum.YLeaf(0, "wred-cos-cmd")

    wred_dscp_cmd = Enum.YLeaf(1, "wred-dscp-cmd")

    wred_precedence_cmd = Enum.YLeaf(2, "wred-precedence-cmd")

    wred_discard_class_cmd = Enum.YLeaf(3, "wred-discard-class-cmd")

    wred_mpls_exp_cmd = Enum.YLeaf(4, "wred-mpls-exp-cmd")

    red_with_user_min_max = Enum.YLeaf(5, "red-with-user-min-max")

    red_with_default_min_max = Enum.YLeaf(6, "red-with-default-min-max")

    wred_dei_cmd = Enum.YLeaf(7, "wred-dei-cmd")

    wred_ecn_cmd = Enum.YLeaf(8, "wred-ecn-cmd")

    wred_invalid_cmd = Enum.YLeaf(9, "wred-invalid-cmd")



class Qos(Entity):
    """
    QoS operational data
    
    .. attribute:: interface_table
    
    	Operational data for all interfaces
    	**type**\:   :py:class:`InterfaceTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable>`
    
    .. attribute:: nodes
    
    	Node\-specific QoS operational data
    	**type**\:   :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes>`
    
    .. attribute:: nv_interface_table
    
    	Operational data for satellite interfaces
    	**type**\:   :py:class:`NvInterfaceTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable>`
    
    .. attribute:: nv_satellite
    
    	Satellite table
    	**type**\:   :py:class:`NvSatellite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite>`
    
    .. attribute:: qos_global
    
    	For global registrations
    	**type**\:   :py:class:`QosGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal>`
    
    

    """

    _prefix = 'qos-ma-oper'
    _revision = '2017-04-10'

    def __init__(self):
        super(Qos, self).__init__()
        self._top_entity = None

        self.yang_name = "qos"
        self.yang_parent_name = "Cisco-IOS-XR-qos-ma-oper"

        self.interface_table = Qos.InterfaceTable()
        self.interface_table.parent = self
        self._children_name_map["interface_table"] = "interface-table"
        self._children_yang_names.add("interface-table")

        self.nodes = Qos.Nodes()
        self.nodes.parent = self
        self._children_name_map["nodes"] = "nodes"
        self._children_yang_names.add("nodes")

        self.nv_interface_table = Qos.NvInterfaceTable()
        self.nv_interface_table.parent = self
        self._children_name_map["nv_interface_table"] = "nv-interface-table"
        self._children_yang_names.add("nv-interface-table")

        self.nv_satellite = Qos.NvSatellite()
        self.nv_satellite.parent = self
        self._children_name_map["nv_satellite"] = "nv-satellite"
        self._children_yang_names.add("nv-satellite")

        self.qos_global = Qos.QosGlobal()
        self.qos_global.parent = self
        self._children_name_map["qos_global"] = "qos-global"
        self._children_yang_names.add("qos-global")


    class NvInterfaceTable(Entity):
        """
        Operational data for satellite interfaces
        
        .. attribute:: interface
        
        	QoS policy\-map operational data for a particular interface
        	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface>`
        
        

        """

        _prefix = 'qos-ma-oper'
        _revision = '2017-04-10'

        def __init__(self):
            super(Qos.NvInterfaceTable, self).__init__()

            self.yang_name = "nv-interface-table"
            self.yang_parent_name = "qos"

            self.interface = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(Qos.NvInterfaceTable, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(Qos.NvInterfaceTable, self).__setattr__(name, value)


        class Interface(Entity):
            """
            QoS policy\-map operational data for a particular
            interface
            
            .. attribute:: interface_name  <key>
            
            	Name of the interface
            	**type**\:  str
            
            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
            
            .. attribute:: input
            
            	A piece of QoS policy\-map operational data for an interface
            	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input>`
            
            .. attribute:: member_interfaces
            
            	QoS policy\-map member interface table
            	**type**\:   :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces>`
            
            .. attribute:: nodes
            
            	QoS policy\-map node table
            	**type**\:   :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes>`
            
            .. attribute:: output
            
            	A piece of QoS policy\-map operational data for an interface
            	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output>`
            
            .. attribute:: satellite_ids
            
            	Satellite ID information
            	**type**\:   :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds>`
            
            

            """

            _prefix = 'qos-ma-oper'
            _revision = '2017-04-10'

            def __init__(self):
                super(Qos.NvInterfaceTable.Interface, self).__init__()

                self.yang_name = "interface"
                self.yang_parent_name = "nv-interface-table"

                self.interface_name = YLeaf(YType.str, "interface-name")

                self.input = Qos.NvInterfaceTable.Interface.Input()
                self.input.parent = self
                self._children_name_map["input"] = "input"
                self._children_yang_names.add("input")

                self.member_interfaces = Qos.NvInterfaceTable.Interface.MemberInterfaces()
                self.member_interfaces.parent = self
                self._children_name_map["member_interfaces"] = "member-interfaces"
                self._children_yang_names.add("member-interfaces")

                self.nodes = Qos.NvInterfaceTable.Interface.Nodes()
                self.nodes.parent = self
                self._children_name_map["nodes"] = "nodes"
                self._children_yang_names.add("nodes")

                self.output = Qos.NvInterfaceTable.Interface.Output()
                self.output.parent = self
                self._children_name_map["output"] = "output"
                self._children_yang_names.add("output")

                self.satellite_ids = Qos.NvInterfaceTable.Interface.SatelliteIds()
                self.satellite_ids.parent = self
                self._children_name_map["satellite_ids"] = "satellite-ids"
                self._children_yang_names.add("satellite-ids")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("interface_name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(Qos.NvInterfaceTable.Interface, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(Qos.NvInterfaceTable.Interface, self).__setattr__(name, value)


            class Nodes(Entity):
                """
                QoS policy\-map node table
                
                .. attribute:: node
                
                	QoS operational data for a particular node
                	**type**\: list of    :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.NvInterfaceTable.Interface.Nodes, self).__init__()

                    self.yang_name = "nodes"
                    self.yang_parent_name = "interface"

                    self.node = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Qos.NvInterfaceTable.Interface.Nodes, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Qos.NvInterfaceTable.Interface.Nodes, self).__setattr__(name, value)


                class Node(Entity):
                    """
                    QoS operational data for a particular node
                    
                    .. attribute:: node_name  <key>
                    
                    	The node
                    	**type**\:  str
                    
                    	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
                    
                    .. attribute:: input
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input>`
                    
                    .. attribute:: output
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.NvInterfaceTable.Interface.Nodes.Node, self).__init__()

                        self.yang_name = "node"
                        self.yang_parent_name = "nodes"

                        self.node_name = YLeaf(YType.str, "node-name")

                        self.input = Qos.NvInterfaceTable.Interface.Nodes.Node.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"
                        self._children_yang_names.add("input")

                        self.output = Qos.NvInterfaceTable.Interface.Nodes.Node.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._children_yang_names.add("output")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("node_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.NvInterfaceTable.Interface.Nodes.Node, self).__setattr__(name, value)


                    class Input(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames>`
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "node"

                            self.service_policy_names = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._children_yang_names.add("service-policy-names")

                            self.statistics = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "input"

                                self.service_policy_instance = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, self).__setattr__(name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  <key>
                                
                                	Name of the policy instance
                                	**type**\:  str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"

                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("service_policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.service_policy_name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.service_policy_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "service-policy-name"):
                                        self.service_policy_name = value
                                        self.service_policy_name.value_namespace = name_space
                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.service_policy_instance:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.service_policy_instance:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "service-policy-names" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-instance"):
                                    for c in self.service_policy_instance:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.service_policy_instance.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-instance"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "input"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.child_policy = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                    self._children_yang_names.add("child-policy")

                                    self.general_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.general_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "child-policy" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "child-policy"):
                                        if (self.child_policy is None):
                                            self.child_policy = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                        return self.child_policy

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "input" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "service-policy-names"):
                                if (self.service_policy_names is None):
                                    self.service_policy_names = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                return self.service_policy_names

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = Qos.NvInterfaceTable.Interface.Nodes.Node.Input.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-names" or name == "statistics"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Output(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames>`
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "node"

                            self.service_policy_names = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._children_yang_names.add("service-policy-names")

                            self.statistics = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "output"

                                self.service_policy_instance = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, self).__setattr__(name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  <key>
                                
                                	Name of the policy instance
                                	**type**\:  str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"

                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("service_policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.service_policy_name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.service_policy_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "service-policy-name"):
                                        self.service_policy_name = value
                                        self.service_policy_name.value_namespace = name_space
                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.service_policy_instance:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.service_policy_instance:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "service-policy-names" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-instance"):
                                    for c in self.service_policy_instance:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.service_policy_instance.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-instance"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "output"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.child_policy = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                    self._children_yang_names.add("child-policy")

                                    self.general_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.general_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "child-policy" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "child-policy"):
                                        if (self.child_policy is None):
                                            self.child_policy = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                        return self.child_policy

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "output" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "service-policy-names"):
                                if (self.service_policy_names is None):
                                    self.service_policy_names = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                return self.service_policy_names

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = Qos.NvInterfaceTable.Interface.Nodes.Node.Output.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-names" or name == "statistics"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.node_name.is_set or
                            (self.input is not None and self.input.has_data()) or
                            (self.output is not None and self.output.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.node_name.yfilter != YFilter.not_set or
                            (self.input is not None and self.input.has_operation()) or
                            (self.output is not None and self.output.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "node" + "[node-name='" + self.node_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.node_name.is_set or self.node_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "input"):
                            if (self.input is None):
                                self.input = Qos.NvInterfaceTable.Interface.Nodes.Node.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"
                            return self.input

                        if (child_yang_name == "output"):
                            if (self.output is None):
                                self.output = Qos.NvInterfaceTable.Interface.Nodes.Node.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                            return self.output

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "input" or name == "output" or name == "node-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "node-name"):
                            self.node_name = value
                            self.node_name.value_namespace = name_space
                            self.node_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.node:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.node:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "nodes" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "node"):
                        for c in self.node:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Qos.NvInterfaceTable.Interface.Nodes.Node()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.node.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "node"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class MemberInterfaces(Entity):
                """
                QoS policy\-map member interface table
                
                .. attribute:: member_interface
                
                	QoS policy\-map member interface statistics
                	**type**\: list of    :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces, self).__init__()

                    self.yang_name = "member-interfaces"
                    self.yang_parent_name = "interface"

                    self.member_interface = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces, self).__setattr__(name, value)


                class MemberInterface(Entity):
                    """
                    QoS policy\-map member interface statistics
                    
                    .. attribute:: interface_name  <key>
                    
                    	Name of member interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: input
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input>`
                    
                    .. attribute:: output
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output>`
                    
                    .. attribute:: satellite_ids
                    
                    	Satellite ID information
                    	**type**\:   :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface, self).__init__()

                        self.yang_name = "member-interface"
                        self.yang_parent_name = "member-interfaces"

                        self.interface_name = YLeaf(YType.str, "interface-name")

                        self.input = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"
                        self._children_yang_names.add("input")

                        self.output = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._children_yang_names.add("output")

                        self.satellite_ids = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds()
                        self.satellite_ids.parent = self
                        self._children_name_map["satellite_ids"] = "satellite-ids"
                        self._children_yang_names.add("satellite-ids")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("interface_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface, self).__setattr__(name, value)


                    class SatelliteIds(Entity):
                        """
                        Satellite ID information
                        
                        .. attribute:: satellite_id
                        
                        	Satellite ID information
                        	**type**\: list of    :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, self).__init__()

                            self.yang_name = "satellite-ids"
                            self.yang_parent_name = "member-interface"

                            self.satellite_id = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, self).__setattr__(name, value)


                        class SatelliteId(Entity):
                            """
                            Satellite ID information
                            
                            .. attribute:: nv_satellite_id  <key>
                            
                            	Satellite ID
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: input
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input>`
                            
                            .. attribute:: output
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__init__()

                                self.yang_name = "satellite-id"
                                self.yang_parent_name = "satellite-ids"

                                self.nv_satellite_id = YLeaf(YType.int32, "nv-satellite-id")

                                self.input = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"
                                self._children_yang_names.add("input")

                                self.output = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                                self._children_yang_names.add("output")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nv_satellite_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__setattr__(name, value)


                            class Input(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: service_policy_names
                                
                                	Operational data for all Policy instance
                                	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, self).__init__()

                                    self.yang_name = "input"
                                    self.yang_parent_name = "satellite-id"

                                    self.service_policy_names = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                    self._children_yang_names.add("service-policy-names")

                                    self.statistics = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._children_yang_names.add("statistics")


                                class ServicePolicyNames(Entity):
                                    """
                                    Operational data for all Policy instance
                                    
                                    .. attribute:: service_policy_instance
                                    
                                    	QoS policy\-map operational data for a particular Policy 
                                    	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                        self.yang_name = "service-policy-names"
                                        self.yang_parent_name = "input"

                                        self.service_policy_instance = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)


                                    class ServicePolicyInstance(Entity):
                                        """
                                        QoS policy\-map operational data for a
                                        particular Policy 
                                        
                                        .. attribute:: service_policy_name  <key>
                                        
                                        	Name of the policy instance
                                        	**type**\:  str
                                        
                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                            self.yang_name = "service-policy-instance"
                                            self.yang_parent_name = "service-policy-names"

                                            self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("service_policy_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.service_policy_name.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.service_policy_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "service-policy-name"):
                                                self.service_policy_name = value
                                                self.service_policy_name.value_namespace = name_space
                                                self.service_policy_name.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.service_policy_instance:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.service_policy_instance:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "service-policy-names" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-instance"):
                                            for c in self.service_policy_instance:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.service_policy_instance.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-instance"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "input"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.child_policy = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                            self._children_yang_names.add("child-policy")

                                            self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\:  str
                                            
                                            	**length:** 0..128
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.satid = YLeaf(YType.uint32, "satid")

                                                self.state = YLeaf(YType.enumeration, "state")

                                                self.state_description = YLeaf(YType.str, "state-description")

                                                self.class_stats = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("policy_name",
                                                                "satid",
                                                                "state",
                                                                "state_description") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\:  str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"

                                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                    self._children_yang_names.add("cac-stats")

                                                    self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                    self._children_yang_names.add("general-stats")

                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    self._children_yang_names.add("iphc-stats")

                                                    self.police_stats_array = YList(self)
                                                    self.queue_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("cac_state",
                                                                    "class_name",
                                                                    "counter_validity_bitmask",
                                                                    "queue_descr",
                                                                    "shared_queue_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("match_data_rate",
                                                                        "pre_policy_matched_bytes",
                                                                        "pre_policy_matched_packets",
                                                                        "total_drop_bytes",
                                                                        "total_drop_packets",
                                                                        "total_drop_rate",
                                                                        "total_transmit_rate",
                                                                        "transmit_bytes",
                                                                        "transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.match_data_rate.is_set or
                                                            self.pre_policy_matched_bytes.is_set or
                                                            self.pre_policy_matched_packets.is_set or
                                                            self.total_drop_bytes.is_set or
                                                            self.total_drop_packets.is_set or
                                                            self.total_drop_rate.is_set or
                                                            self.total_transmit_rate.is_set or
                                                            self.transmit_bytes.is_set or
                                                            self.transmit_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.match_data_rate.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                                            self.transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "general-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "match-data-rate"):
                                                            self.match_data_rate = value
                                                            self.match_data_rate.value_namespace = name_space
                                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-bytes"):
                                                            self.pre_policy_matched_bytes = value
                                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-packets"):
                                                            self.pre_policy_matched_packets = value
                                                            self.pre_policy_matched_packets.value_namespace = name_space
                                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-bytes"):
                                                            self.total_drop_bytes = value
                                                            self.total_drop_bytes.value_namespace = name_space
                                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-packets"):
                                                            self.total_drop_packets = value
                                                            self.total_drop_packets.value_namespace = name_space
                                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-rate"):
                                                            self.total_drop_rate = value
                                                            self.total_drop_rate.value_namespace = name_space
                                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-transmit-rate"):
                                                            self.total_transmit_rate = value
                                                            self.total_transmit_rate.value_namespace = name_space
                                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-bytes"):
                                                            self.transmit_bytes = value
                                                            self.transmit_bytes.value_namespace = name_space
                                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-packets"):
                                                            self.transmit_packets = value
                                                            self.transmit_packets.value_namespace = name_space
                                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("non_tcp_bytes_saved",
                                                                        "non_tcp_bytes_sent_rate",
                                                                        "non_tcp_compressed_packets_out",
                                                                        "non_tcp_full_header_packets_out",
                                                                        "non_tcp_total_out_bytes",
                                                                        "non_tcp_total_out_packets",
                                                                        "tcp_bytes_saved",
                                                                        "tcp_bytes_sent_rate",
                                                                        "tcp_compressed_packets_out",
                                                                        "tcp_full_header_packets_out",
                                                                        "tcp_total_out_bytes",
                                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.non_tcp_bytes_saved.is_set or
                                                            self.non_tcp_bytes_sent_rate.is_set or
                                                            self.non_tcp_compressed_packets_out.is_set or
                                                            self.non_tcp_full_header_packets_out.is_set or
                                                            self.non_tcp_total_out_bytes.is_set or
                                                            self.non_tcp_total_out_packets.is_set or
                                                            self.tcp_bytes_saved.is_set or
                                                            self.tcp_bytes_sent_rate.is_set or
                                                            self.tcp_compressed_packets_out.is_set or
                                                            self.tcp_full_header_packets_out.is_set or
                                                            self.tcp_total_out_bytes.is_set or
                                                            self.tcp_total_out_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "iphc-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "non-tcp-bytes-saved"):
                                                            self.non_tcp_bytes_saved = value
                                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                                            self.non_tcp_bytes_sent_rate = value
                                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-compressed-packets-out"):
                                                            self.non_tcp_compressed_packets_out = value
                                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-full-header-packets-out"):
                                                            self.non_tcp_full_header_packets_out = value
                                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-bytes"):
                                                            self.non_tcp_total_out_bytes = value
                                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-packets"):
                                                            self.non_tcp_total_out_packets = value
                                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-saved"):
                                                            self.tcp_bytes_saved = value
                                                            self.tcp_bytes_saved.value_namespace = name_space
                                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-sent-rate"):
                                                            self.tcp_bytes_sent_rate = value
                                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-compressed-packets-out"):
                                                            self.tcp_compressed_packets_out = value
                                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-full-header-packets-out"):
                                                            self.tcp_full_header_packets_out = value
                                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-bytes"):
                                                            self.tcp_total_out_bytes = value
                                                            self.tcp_total_out_bytes.value_namespace = name_space
                                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-packets"):
                                                            self.tcp_total_out_packets = value
                                                            self.tcp_total_out_packets.value_namespace = name_space
                                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("admit_bytes",
                                                                        "admit_rates",
                                                                        "admitpackets",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "drop_rates") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.admit_bytes.is_set or
                                                            self.admit_rates.is_set or
                                                            self.admitpackets.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.drop_rates.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.admit_bytes.yfilter != YFilter.not_set or
                                                            self.admit_rates.yfilter != YFilter.not_set or
                                                            self.admitpackets.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.drop_rates.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cac-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "admit-bytes"):
                                                            self.admit_bytes = value
                                                            self.admit_bytes.value_namespace = name_space
                                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admit-rates"):
                                                            self.admit_rates = value
                                                            self.admit_rates.value_namespace = name_space
                                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admitpackets"):
                                                            self.admitpackets = value
                                                            self.admitpackets.value_namespace = name_space
                                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-rates"):
                                                            self.drop_rates = value
                                                            self.drop_rates.value_namespace = name_space
                                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                        self.queue_average_length = YList(self)
                                                        self.queue_instance_length = YList(self)
                                                        self.queue_max_length = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("atm_clp0_drop_bytes",
                                                                        "atm_clp0_drop_packets",
                                                                        "atm_clp1_drop_bytes",
                                                                        "atm_clp1_drop_packets",
                                                                        "conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "forced_wred_stats_display",
                                                                        "max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "queue_drop_threshold",
                                                                        "queue_id",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "tail_drop_bytes",
                                                                        "tail_drop_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-instance-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-average-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-max-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.atm_clp0_drop_bytes.is_set or
                                                            self.atm_clp0_drop_packets.is_set or
                                                            self.atm_clp1_drop_bytes.is_set or
                                                            self.atm_clp1_drop_packets.is_set or
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.forced_wred_stats_display.is_set or
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.queue_drop_threshold.is_set or
                                                            self.queue_id.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.tail_drop_bytes.is_set or
                                                            self.tail_drop_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                            self.queue_id.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "queue-average-length"):
                                                            for c in self.queue_average_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_average_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-instance-length"):
                                                            for c in self.queue_instance_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_instance_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-max-length"):
                                                            for c in self.queue_max_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_max_length.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "atm-clp0-drop-bytes"):
                                                            self.atm_clp0_drop_bytes = value
                                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp0-drop-packets"):
                                                            self.atm_clp0_drop_packets = value
                                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-bytes"):
                                                            self.atm_clp1_drop_bytes = value
                                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-packets"):
                                                            self.atm_clp1_drop_packets = value
                                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "forced-wred-stats-display"):
                                                            self.forced_wred_stats_display = value
                                                            self.forced_wred_stats_display.value_namespace = name_space
                                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-drop-threshold"):
                                                            self.queue_drop_threshold = value
                                                            self.queue_drop_threshold.value_namespace = name_space
                                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-id"):
                                                            self.queue_id = value
                                                            self.queue_id.value_namespace = name_space
                                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-bytes"):
                                                            self.tail_drop_bytes = value
                                                            self.tail_drop_bytes.value_namespace = name_space
                                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-packets"):
                                                            self.tail_drop_packets = value
                                                            self.tail_drop_packets.value_namespace = name_space
                                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._children_yang_names.add("color-class-stats")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "parent_drop_bytes",
                                                                        "parent_drop_packets",
                                                                        "violate_bytes",
                                                                        "violate_packets",
                                                                        "violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"

                                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_class_conform_bytes",
                                                                            "conform_class_conform_packets",
                                                                            "conform_class_conform_rate",
                                                                            "conform_class_exceed_bytes",
                                                                            "conform_class_exceed_packets",
                                                                            "conform_class_exceed_rate",
                                                                            "conform_class_violate_bytes",
                                                                            "conform_class_violate_packets",
                                                                            "conform_class_violate_rate",
                                                                            "exceed_class_exceed_bytes",
                                                                            "exceed_class_exceed_packets",
                                                                            "exceed_class_exceed_rate",
                                                                            "exceed_class_violate_bytes",
                                                                            "exceed_class_violate_packets",
                                                                            "exceed_class_violate_rate",
                                                                            "violate_class_violate_bytes",
                                                                            "violate_class_violate_packets",
                                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.conform_class_conform_bytes.is_set or
                                                                self.conform_class_conform_packets.is_set or
                                                                self.conform_class_conform_rate.is_set or
                                                                self.conform_class_exceed_bytes.is_set or
                                                                self.conform_class_exceed_packets.is_set or
                                                                self.conform_class_exceed_rate.is_set or
                                                                self.conform_class_violate_bytes.is_set or
                                                                self.conform_class_violate_packets.is_set or
                                                                self.conform_class_violate_rate.is_set or
                                                                self.exceed_class_exceed_bytes.is_set or
                                                                self.exceed_class_exceed_packets.is_set or
                                                                self.exceed_class_exceed_rate.is_set or
                                                                self.exceed_class_violate_bytes.is_set or
                                                                self.exceed_class_violate_packets.is_set or
                                                                self.exceed_class_violate_rate.is_set or
                                                                self.violate_class_violate_bytes.is_set or
                                                                self.violate_class_violate_packets.is_set or
                                                                self.violate_class_violate_rate.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "color-class-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-class-conform-bytes"):
                                                                self.conform_class_conform_bytes = value
                                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-packets"):
                                                                self.conform_class_conform_packets = value
                                                                self.conform_class_conform_packets.value_namespace = name_space
                                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-rate"):
                                                                self.conform_class_conform_rate = value
                                                                self.conform_class_conform_rate.value_namespace = name_space
                                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-bytes"):
                                                                self.conform_class_exceed_bytes = value
                                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-packets"):
                                                                self.conform_class_exceed_packets = value
                                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-rate"):
                                                                self.conform_class_exceed_rate = value
                                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-bytes"):
                                                                self.conform_class_violate_bytes = value
                                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-packets"):
                                                                self.conform_class_violate_packets = value
                                                                self.conform_class_violate_packets.value_namespace = name_space
                                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-rate"):
                                                                self.conform_class_violate_rate = value
                                                                self.conform_class_violate_rate.value_namespace = name_space
                                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-bytes"):
                                                                self.exceed_class_exceed_bytes = value
                                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-packets"):
                                                                self.exceed_class_exceed_packets = value
                                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-rate"):
                                                                self.exceed_class_exceed_rate = value
                                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-bytes"):
                                                                self.exceed_class_violate_bytes = value
                                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-packets"):
                                                                self.exceed_class_violate_packets = value
                                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-rate"):
                                                                self.exceed_class_violate_rate = value
                                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-bytes"):
                                                                self.violate_class_violate_bytes = value
                                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-packets"):
                                                                self.violate_class_violate_packets = value
                                                                self.violate_class_violate_packets.value_namespace = name_space
                                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-rate"):
                                                                self.violate_class_violate_rate = value
                                                                self.violate_class_violate_rate.value_namespace = name_space
                                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.parent_drop_bytes.is_set or
                                                            self.parent_drop_packets.is_set or
                                                            self.violate_bytes.is_set or
                                                            self.violate_packets.is_set or
                                                            self.violate_rate.is_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                                            self.violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_rate.yfilter != YFilter.not_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "color-class-stats"):
                                                            if (self.color_class_stats is None):
                                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            return self.color_class_stats

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-bytes"):
                                                            self.parent_drop_bytes = value
                                                            self.parent_drop_bytes.value_namespace = name_space
                                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-packets"):
                                                            self.parent_drop_packets = value
                                                            self.parent_drop_packets.value_namespace = name_space
                                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-bytes"):
                                                            self.violate_bytes = value
                                                            self.violate_bytes.value_namespace = name_space
                                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-packets"):
                                                            self.violate_packets = value
                                                            self.violate_packets.value_namespace = name_space
                                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-rate"):
                                                            self.violate_rate = value
                                                            self.violate_rate.value_namespace = name_space
                                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                        self.red_label = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "profile_title",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "red_ecn_marked_bytes",
                                                                        "red_ecn_marked_packets",
                                                                        "red_transmit_bytes",
                                                                        "red_transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"

                                                            self.value = YLeaf(YType.uint8, "value")

                                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("value",
                                                                            "wred_type") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.value.is_set or
                                                                self.wred_type.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set or
                                                                self.wred_type.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "red-label" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())
                                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "value" or name == "wred-type"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "wred-type"):
                                                                self.wred_type = value
                                                                self.wred_type.value_namespace = name_space
                                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.red_label:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.profile_title.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.red_ecn_marked_bytes.is_set or
                                                            self.red_ecn_marked_packets.is_set or
                                                            self.red_transmit_bytes.is_set or
                                                            self.red_transmit_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.red_label:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.profile_title.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "wred-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "red-label"):
                                                            for c in self.red_label:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.red_label.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "profile-title"):
                                                            self.profile_title = value
                                                            self.profile_title.value_namespace = name_space
                                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-bytes"):
                                                            self.red_ecn_marked_bytes = value
                                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-packets"):
                                                            self.red_ecn_marked_packets = value
                                                            self.red_ecn_marked_packets.value_namespace = name_space
                                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-bytes"):
                                                            self.red_transmit_bytes = value
                                                            self.red_transmit_bytes.value_namespace = name_space
                                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-packets"):
                                                            self.red_transmit_packets = value
                                                            self.red_transmit_packets.value_namespace = name_space
                                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.cac_state.is_set or
                                                        self.class_name.is_set or
                                                        self.counter_validity_bitmask.is_set or
                                                        self.queue_descr.is_set or
                                                        self.shared_queue_id.is_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                def has_operation(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.cac_state.yfilter != YFilter.not_set or
                                                        self.class_name.yfilter != YFilter.not_set or
                                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                        self.queue_descr.yfilter != YFilter.not_set or
                                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cac-stats"):
                                                        if (self.cac_stats is None):
                                                            self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                        return self.cac_stats

                                                    if (child_yang_name == "general-stats"):
                                                        if (self.general_stats is None):
                                                            self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"
                                                        return self.general_stats

                                                    if (child_yang_name == "iphc-stats"):
                                                        if (self.iphc_stats is None):
                                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        return self.iphc_stats

                                                    if (child_yang_name == "police-stats-array"):
                                                        for c in self.police_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.police_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-stats-array"):
                                                        for c in self.queue_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "wred-stats-array"):
                                                        for c in self.wred_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.wred_stats_array.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "cac-state"):
                                                        self.cac_state = value
                                                        self.cac_state.value_namespace = name_space
                                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "class-name"):
                                                        self.class_name = value
                                                        self.class_name.value_namespace = name_space
                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "counter-validity-bitmask"):
                                                        self.counter_validity_bitmask = value
                                                        self.counter_validity_bitmask.value_namespace = name_space
                                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-descr"):
                                                        self.queue_descr = value
                                                        self.queue_descr.value_namespace = name_space
                                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "shared-queue-id"):
                                                        self.shared_queue_id = value
                                                        self.shared_queue_id.value_namespace = name_space
                                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.class_stats:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.policy_name.is_set or
                                                    self.satid.is_set or
                                                    self.state.is_set or
                                                    self.state_description.is_set)

                                            def has_operation(self):
                                                for c in self.class_stats:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    self.satid.yfilter != YFilter.not_set or
                                                    self.state.yfilter != YFilter.not_set or
                                                    self.state_description.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "child-policy" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state.get_name_leafdata())
                                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "class-stats"):
                                                    for c in self.class_stats:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.class_stats.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "satid"):
                                                    self.satid = value
                                                    self.satid.value_namespace = name_space
                                                    self.satid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state"):
                                                    self.state = value
                                                    self.state.value_namespace = name_space
                                                    self.state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state-description"):
                                                    self.state_description = value
                                                    self.state_description.value_namespace = name_space
                                                    self.state_description.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.child_policy is not None and self.child_policy.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.child_policy is not None and self.child_policy.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "child-policy"):
                                                if (self.child_policy is None):
                                                    self.child_policy = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"
                                                return self.child_policy

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "statistics" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                        (self.statistics is not None and self.statistics.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                        (self.statistics is not None and self.statistics.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "input" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "service-policy-names"):
                                        if (self.service_policy_names is None):
                                            self.service_policy_names = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                            self.service_policy_names.parent = self
                                            self._children_name_map["service_policy_names"] = "service-policy-names"
                                        return self.service_policy_names

                                    if (child_yang_name == "statistics"):
                                        if (self.statistics is None):
                                            self.statistics = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                        return self.statistics

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-names" or name == "statistics"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Output(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: service_policy_names
                                
                                	Operational data for all Policy instance
                                	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, self).__init__()

                                    self.yang_name = "output"
                                    self.yang_parent_name = "satellite-id"

                                    self.service_policy_names = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                    self._children_yang_names.add("service-policy-names")

                                    self.statistics = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._children_yang_names.add("statistics")


                                class ServicePolicyNames(Entity):
                                    """
                                    Operational data for all Policy instance
                                    
                                    .. attribute:: service_policy_instance
                                    
                                    	QoS policy\-map operational data for a particular Policy 
                                    	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                        self.yang_name = "service-policy-names"
                                        self.yang_parent_name = "output"

                                        self.service_policy_instance = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)


                                    class ServicePolicyInstance(Entity):
                                        """
                                        QoS policy\-map operational data for a
                                        particular Policy 
                                        
                                        .. attribute:: service_policy_name  <key>
                                        
                                        	Name of the policy instance
                                        	**type**\:  str
                                        
                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                            self.yang_name = "service-policy-instance"
                                            self.yang_parent_name = "service-policy-names"

                                            self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("service_policy_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.service_policy_name.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.service_policy_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "service-policy-name"):
                                                self.service_policy_name = value
                                                self.service_policy_name.value_namespace = name_space
                                                self.service_policy_name.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.service_policy_instance:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.service_policy_instance:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "service-policy-names" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-instance"):
                                            for c in self.service_policy_instance:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.service_policy_instance.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-instance"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "output"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.child_policy = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                            self._children_yang_names.add("child-policy")

                                            self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\:  str
                                            
                                            	**length:** 0..128
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.satid = YLeaf(YType.uint32, "satid")

                                                self.state = YLeaf(YType.enumeration, "state")

                                                self.state_description = YLeaf(YType.str, "state-description")

                                                self.class_stats = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("policy_name",
                                                                "satid",
                                                                "state",
                                                                "state_description") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\:  str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"

                                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                    self._children_yang_names.add("cac-stats")

                                                    self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                    self._children_yang_names.add("general-stats")

                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    self._children_yang_names.add("iphc-stats")

                                                    self.police_stats_array = YList(self)
                                                    self.queue_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("cac_state",
                                                                    "class_name",
                                                                    "counter_validity_bitmask",
                                                                    "queue_descr",
                                                                    "shared_queue_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("match_data_rate",
                                                                        "pre_policy_matched_bytes",
                                                                        "pre_policy_matched_packets",
                                                                        "total_drop_bytes",
                                                                        "total_drop_packets",
                                                                        "total_drop_rate",
                                                                        "total_transmit_rate",
                                                                        "transmit_bytes",
                                                                        "transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.match_data_rate.is_set or
                                                            self.pre_policy_matched_bytes.is_set or
                                                            self.pre_policy_matched_packets.is_set or
                                                            self.total_drop_bytes.is_set or
                                                            self.total_drop_packets.is_set or
                                                            self.total_drop_rate.is_set or
                                                            self.total_transmit_rate.is_set or
                                                            self.transmit_bytes.is_set or
                                                            self.transmit_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.match_data_rate.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                                            self.transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "general-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "match-data-rate"):
                                                            self.match_data_rate = value
                                                            self.match_data_rate.value_namespace = name_space
                                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-bytes"):
                                                            self.pre_policy_matched_bytes = value
                                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-packets"):
                                                            self.pre_policy_matched_packets = value
                                                            self.pre_policy_matched_packets.value_namespace = name_space
                                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-bytes"):
                                                            self.total_drop_bytes = value
                                                            self.total_drop_bytes.value_namespace = name_space
                                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-packets"):
                                                            self.total_drop_packets = value
                                                            self.total_drop_packets.value_namespace = name_space
                                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-rate"):
                                                            self.total_drop_rate = value
                                                            self.total_drop_rate.value_namespace = name_space
                                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-transmit-rate"):
                                                            self.total_transmit_rate = value
                                                            self.total_transmit_rate.value_namespace = name_space
                                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-bytes"):
                                                            self.transmit_bytes = value
                                                            self.transmit_bytes.value_namespace = name_space
                                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-packets"):
                                                            self.transmit_packets = value
                                                            self.transmit_packets.value_namespace = name_space
                                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("non_tcp_bytes_saved",
                                                                        "non_tcp_bytes_sent_rate",
                                                                        "non_tcp_compressed_packets_out",
                                                                        "non_tcp_full_header_packets_out",
                                                                        "non_tcp_total_out_bytes",
                                                                        "non_tcp_total_out_packets",
                                                                        "tcp_bytes_saved",
                                                                        "tcp_bytes_sent_rate",
                                                                        "tcp_compressed_packets_out",
                                                                        "tcp_full_header_packets_out",
                                                                        "tcp_total_out_bytes",
                                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.non_tcp_bytes_saved.is_set or
                                                            self.non_tcp_bytes_sent_rate.is_set or
                                                            self.non_tcp_compressed_packets_out.is_set or
                                                            self.non_tcp_full_header_packets_out.is_set or
                                                            self.non_tcp_total_out_bytes.is_set or
                                                            self.non_tcp_total_out_packets.is_set or
                                                            self.tcp_bytes_saved.is_set or
                                                            self.tcp_bytes_sent_rate.is_set or
                                                            self.tcp_compressed_packets_out.is_set or
                                                            self.tcp_full_header_packets_out.is_set or
                                                            self.tcp_total_out_bytes.is_set or
                                                            self.tcp_total_out_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "iphc-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "non-tcp-bytes-saved"):
                                                            self.non_tcp_bytes_saved = value
                                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                                            self.non_tcp_bytes_sent_rate = value
                                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-compressed-packets-out"):
                                                            self.non_tcp_compressed_packets_out = value
                                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-full-header-packets-out"):
                                                            self.non_tcp_full_header_packets_out = value
                                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-bytes"):
                                                            self.non_tcp_total_out_bytes = value
                                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-packets"):
                                                            self.non_tcp_total_out_packets = value
                                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-saved"):
                                                            self.tcp_bytes_saved = value
                                                            self.tcp_bytes_saved.value_namespace = name_space
                                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-sent-rate"):
                                                            self.tcp_bytes_sent_rate = value
                                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-compressed-packets-out"):
                                                            self.tcp_compressed_packets_out = value
                                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-full-header-packets-out"):
                                                            self.tcp_full_header_packets_out = value
                                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-bytes"):
                                                            self.tcp_total_out_bytes = value
                                                            self.tcp_total_out_bytes.value_namespace = name_space
                                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-packets"):
                                                            self.tcp_total_out_packets = value
                                                            self.tcp_total_out_packets.value_namespace = name_space
                                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("admit_bytes",
                                                                        "admit_rates",
                                                                        "admitpackets",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "drop_rates") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.admit_bytes.is_set or
                                                            self.admit_rates.is_set or
                                                            self.admitpackets.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.drop_rates.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.admit_bytes.yfilter != YFilter.not_set or
                                                            self.admit_rates.yfilter != YFilter.not_set or
                                                            self.admitpackets.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.drop_rates.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cac-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "admit-bytes"):
                                                            self.admit_bytes = value
                                                            self.admit_bytes.value_namespace = name_space
                                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admit-rates"):
                                                            self.admit_rates = value
                                                            self.admit_rates.value_namespace = name_space
                                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admitpackets"):
                                                            self.admitpackets = value
                                                            self.admitpackets.value_namespace = name_space
                                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-rates"):
                                                            self.drop_rates = value
                                                            self.drop_rates.value_namespace = name_space
                                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                        self.queue_average_length = YList(self)
                                                        self.queue_instance_length = YList(self)
                                                        self.queue_max_length = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("atm_clp0_drop_bytes",
                                                                        "atm_clp0_drop_packets",
                                                                        "atm_clp1_drop_bytes",
                                                                        "atm_clp1_drop_packets",
                                                                        "conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "forced_wred_stats_display",
                                                                        "max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "queue_drop_threshold",
                                                                        "queue_id",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "tail_drop_bytes",
                                                                        "tail_drop_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-instance-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-average-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-max-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.atm_clp0_drop_bytes.is_set or
                                                            self.atm_clp0_drop_packets.is_set or
                                                            self.atm_clp1_drop_bytes.is_set or
                                                            self.atm_clp1_drop_packets.is_set or
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.forced_wred_stats_display.is_set or
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.queue_drop_threshold.is_set or
                                                            self.queue_id.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.tail_drop_bytes.is_set or
                                                            self.tail_drop_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                            self.queue_id.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "queue-average-length"):
                                                            for c in self.queue_average_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_average_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-instance-length"):
                                                            for c in self.queue_instance_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_instance_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-max-length"):
                                                            for c in self.queue_max_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_max_length.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "atm-clp0-drop-bytes"):
                                                            self.atm_clp0_drop_bytes = value
                                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp0-drop-packets"):
                                                            self.atm_clp0_drop_packets = value
                                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-bytes"):
                                                            self.atm_clp1_drop_bytes = value
                                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-packets"):
                                                            self.atm_clp1_drop_packets = value
                                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "forced-wred-stats-display"):
                                                            self.forced_wred_stats_display = value
                                                            self.forced_wred_stats_display.value_namespace = name_space
                                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-drop-threshold"):
                                                            self.queue_drop_threshold = value
                                                            self.queue_drop_threshold.value_namespace = name_space
                                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-id"):
                                                            self.queue_id = value
                                                            self.queue_id.value_namespace = name_space
                                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-bytes"):
                                                            self.tail_drop_bytes = value
                                                            self.tail_drop_bytes.value_namespace = name_space
                                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-packets"):
                                                            self.tail_drop_packets = value
                                                            self.tail_drop_packets.value_namespace = name_space
                                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._children_yang_names.add("color-class-stats")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "parent_drop_bytes",
                                                                        "parent_drop_packets",
                                                                        "violate_bytes",
                                                                        "violate_packets",
                                                                        "violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"

                                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_class_conform_bytes",
                                                                            "conform_class_conform_packets",
                                                                            "conform_class_conform_rate",
                                                                            "conform_class_exceed_bytes",
                                                                            "conform_class_exceed_packets",
                                                                            "conform_class_exceed_rate",
                                                                            "conform_class_violate_bytes",
                                                                            "conform_class_violate_packets",
                                                                            "conform_class_violate_rate",
                                                                            "exceed_class_exceed_bytes",
                                                                            "exceed_class_exceed_packets",
                                                                            "exceed_class_exceed_rate",
                                                                            "exceed_class_violate_bytes",
                                                                            "exceed_class_violate_packets",
                                                                            "exceed_class_violate_rate",
                                                                            "violate_class_violate_bytes",
                                                                            "violate_class_violate_packets",
                                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.conform_class_conform_bytes.is_set or
                                                                self.conform_class_conform_packets.is_set or
                                                                self.conform_class_conform_rate.is_set or
                                                                self.conform_class_exceed_bytes.is_set or
                                                                self.conform_class_exceed_packets.is_set or
                                                                self.conform_class_exceed_rate.is_set or
                                                                self.conform_class_violate_bytes.is_set or
                                                                self.conform_class_violate_packets.is_set or
                                                                self.conform_class_violate_rate.is_set or
                                                                self.exceed_class_exceed_bytes.is_set or
                                                                self.exceed_class_exceed_packets.is_set or
                                                                self.exceed_class_exceed_rate.is_set or
                                                                self.exceed_class_violate_bytes.is_set or
                                                                self.exceed_class_violate_packets.is_set or
                                                                self.exceed_class_violate_rate.is_set or
                                                                self.violate_class_violate_bytes.is_set or
                                                                self.violate_class_violate_packets.is_set or
                                                                self.violate_class_violate_rate.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "color-class-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-class-conform-bytes"):
                                                                self.conform_class_conform_bytes = value
                                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-packets"):
                                                                self.conform_class_conform_packets = value
                                                                self.conform_class_conform_packets.value_namespace = name_space
                                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-rate"):
                                                                self.conform_class_conform_rate = value
                                                                self.conform_class_conform_rate.value_namespace = name_space
                                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-bytes"):
                                                                self.conform_class_exceed_bytes = value
                                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-packets"):
                                                                self.conform_class_exceed_packets = value
                                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-rate"):
                                                                self.conform_class_exceed_rate = value
                                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-bytes"):
                                                                self.conform_class_violate_bytes = value
                                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-packets"):
                                                                self.conform_class_violate_packets = value
                                                                self.conform_class_violate_packets.value_namespace = name_space
                                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-rate"):
                                                                self.conform_class_violate_rate = value
                                                                self.conform_class_violate_rate.value_namespace = name_space
                                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-bytes"):
                                                                self.exceed_class_exceed_bytes = value
                                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-packets"):
                                                                self.exceed_class_exceed_packets = value
                                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-rate"):
                                                                self.exceed_class_exceed_rate = value
                                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-bytes"):
                                                                self.exceed_class_violate_bytes = value
                                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-packets"):
                                                                self.exceed_class_violate_packets = value
                                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-rate"):
                                                                self.exceed_class_violate_rate = value
                                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-bytes"):
                                                                self.violate_class_violate_bytes = value
                                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-packets"):
                                                                self.violate_class_violate_packets = value
                                                                self.violate_class_violate_packets.value_namespace = name_space
                                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-rate"):
                                                                self.violate_class_violate_rate = value
                                                                self.violate_class_violate_rate.value_namespace = name_space
                                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.parent_drop_bytes.is_set or
                                                            self.parent_drop_packets.is_set or
                                                            self.violate_bytes.is_set or
                                                            self.violate_packets.is_set or
                                                            self.violate_rate.is_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                                            self.violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_rate.yfilter != YFilter.not_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "color-class-stats"):
                                                            if (self.color_class_stats is None):
                                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            return self.color_class_stats

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-bytes"):
                                                            self.parent_drop_bytes = value
                                                            self.parent_drop_bytes.value_namespace = name_space
                                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-packets"):
                                                            self.parent_drop_packets = value
                                                            self.parent_drop_packets.value_namespace = name_space
                                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-bytes"):
                                                            self.violate_bytes = value
                                                            self.violate_bytes.value_namespace = name_space
                                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-packets"):
                                                            self.violate_packets = value
                                                            self.violate_packets.value_namespace = name_space
                                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-rate"):
                                                            self.violate_rate = value
                                                            self.violate_rate.value_namespace = name_space
                                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                        self.red_label = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "profile_title",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "red_ecn_marked_bytes",
                                                                        "red_ecn_marked_packets",
                                                                        "red_transmit_bytes",
                                                                        "red_transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"

                                                            self.value = YLeaf(YType.uint8, "value")

                                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("value",
                                                                            "wred_type") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.value.is_set or
                                                                self.wred_type.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set or
                                                                self.wred_type.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "red-label" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())
                                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "value" or name == "wred-type"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "wred-type"):
                                                                self.wred_type = value
                                                                self.wred_type.value_namespace = name_space
                                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.red_label:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.profile_title.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.red_ecn_marked_bytes.is_set or
                                                            self.red_ecn_marked_packets.is_set or
                                                            self.red_transmit_bytes.is_set or
                                                            self.red_transmit_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.red_label:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.profile_title.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "wred-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "red-label"):
                                                            for c in self.red_label:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.red_label.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "profile-title"):
                                                            self.profile_title = value
                                                            self.profile_title.value_namespace = name_space
                                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-bytes"):
                                                            self.red_ecn_marked_bytes = value
                                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-packets"):
                                                            self.red_ecn_marked_packets = value
                                                            self.red_ecn_marked_packets.value_namespace = name_space
                                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-bytes"):
                                                            self.red_transmit_bytes = value
                                                            self.red_transmit_bytes.value_namespace = name_space
                                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-packets"):
                                                            self.red_transmit_packets = value
                                                            self.red_transmit_packets.value_namespace = name_space
                                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.cac_state.is_set or
                                                        self.class_name.is_set or
                                                        self.counter_validity_bitmask.is_set or
                                                        self.queue_descr.is_set or
                                                        self.shared_queue_id.is_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                def has_operation(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.cac_state.yfilter != YFilter.not_set or
                                                        self.class_name.yfilter != YFilter.not_set or
                                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                        self.queue_descr.yfilter != YFilter.not_set or
                                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cac-stats"):
                                                        if (self.cac_stats is None):
                                                            self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                        return self.cac_stats

                                                    if (child_yang_name == "general-stats"):
                                                        if (self.general_stats is None):
                                                            self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"
                                                        return self.general_stats

                                                    if (child_yang_name == "iphc-stats"):
                                                        if (self.iphc_stats is None):
                                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        return self.iphc_stats

                                                    if (child_yang_name == "police-stats-array"):
                                                        for c in self.police_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.police_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-stats-array"):
                                                        for c in self.queue_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "wred-stats-array"):
                                                        for c in self.wred_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.wred_stats_array.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "cac-state"):
                                                        self.cac_state = value
                                                        self.cac_state.value_namespace = name_space
                                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "class-name"):
                                                        self.class_name = value
                                                        self.class_name.value_namespace = name_space
                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "counter-validity-bitmask"):
                                                        self.counter_validity_bitmask = value
                                                        self.counter_validity_bitmask.value_namespace = name_space
                                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-descr"):
                                                        self.queue_descr = value
                                                        self.queue_descr.value_namespace = name_space
                                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "shared-queue-id"):
                                                        self.shared_queue_id = value
                                                        self.shared_queue_id.value_namespace = name_space
                                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.class_stats:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.policy_name.is_set or
                                                    self.satid.is_set or
                                                    self.state.is_set or
                                                    self.state_description.is_set)

                                            def has_operation(self):
                                                for c in self.class_stats:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    self.satid.yfilter != YFilter.not_set or
                                                    self.state.yfilter != YFilter.not_set or
                                                    self.state_description.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "child-policy" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state.get_name_leafdata())
                                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "class-stats"):
                                                    for c in self.class_stats:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.class_stats.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "satid"):
                                                    self.satid = value
                                                    self.satid.value_namespace = name_space
                                                    self.satid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state"):
                                                    self.state = value
                                                    self.state.value_namespace = name_space
                                                    self.state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state-description"):
                                                    self.state_description = value
                                                    self.state_description.value_namespace = name_space
                                                    self.state_description.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.child_policy is not None and self.child_policy.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.child_policy is not None and self.child_policy.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "child-policy"):
                                                if (self.child_policy is None):
                                                    self.child_policy = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"
                                                return self.child_policy

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "statistics" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                        (self.statistics is not None and self.statistics.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                        (self.statistics is not None and self.statistics.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "output" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "service-policy-names"):
                                        if (self.service_policy_names is None):
                                            self.service_policy_names = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                            self.service_policy_names.parent = self
                                            self._children_name_map["service_policy_names"] = "service-policy-names"
                                        return self.service_policy_names

                                    if (child_yang_name == "statistics"):
                                        if (self.statistics is None):
                                            self.statistics = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                        return self.statistics

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-names" or name == "statistics"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.nv_satellite_id.is_set or
                                    (self.input is not None and self.input.has_data()) or
                                    (self.output is not None and self.output.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nv_satellite_id.yfilter != YFilter.not_set or
                                    (self.input is not None and self.input.has_operation()) or
                                    (self.output is not None and self.output.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "satellite-id" + "[nv-satellite-id='" + self.nv_satellite_id.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nv_satellite_id.is_set or self.nv_satellite_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nv_satellite_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "input"):
                                    if (self.input is None):
                                        self.input = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                        self.input.parent = self
                                        self._children_name_map["input"] = "input"
                                    return self.input

                                if (child_yang_name == "output"):
                                    if (self.output is None):
                                        self.output = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                        self.output.parent = self
                                        self._children_name_map["output"] = "output"
                                    return self.output

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "input" or name == "output" or name == "nv-satellite-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nv-satellite-id"):
                                    self.nv_satellite_id = value
                                    self.nv_satellite_id.value_namespace = name_space
                                    self.nv_satellite_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.satellite_id:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.satellite_id:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "satellite-ids" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "satellite-id"):
                                for c in self.satellite_id:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.satellite_id.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "satellite-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Input(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames>`
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "member-interface"

                            self.service_policy_names = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._children_yang_names.add("service-policy-names")

                            self.statistics = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "input"

                                self.service_policy_instance = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__setattr__(name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  <key>
                                
                                	Name of the policy instance
                                	**type**\:  str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"

                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("service_policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.service_policy_name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.service_policy_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "service-policy-name"):
                                        self.service_policy_name = value
                                        self.service_policy_name.value_namespace = name_space
                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.service_policy_instance:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.service_policy_instance:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "service-policy-names" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-instance"):
                                    for c in self.service_policy_instance:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.service_policy_instance.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-instance"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "input"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.child_policy = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                    self._children_yang_names.add("child-policy")

                                    self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "child-policy" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "child-policy"):
                                        if (self.child_policy is None):
                                            self.child_policy = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                        return self.child_policy

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "input" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "service-policy-names"):
                                if (self.service_policy_names is None):
                                    self.service_policy_names = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                return self.service_policy_names

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-names" or name == "statistics"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Output(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames>`
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "member-interface"

                            self.service_policy_names = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._children_yang_names.add("service-policy-names")

                            self.statistics = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "output"

                                self.service_policy_instance = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__setattr__(name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  <key>
                                
                                	Name of the policy instance
                                	**type**\:  str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"

                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("service_policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.service_policy_name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.service_policy_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "service-policy-name"):
                                        self.service_policy_name = value
                                        self.service_policy_name.value_namespace = name_space
                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.service_policy_instance:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.service_policy_instance:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "service-policy-names" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-instance"):
                                    for c in self.service_policy_instance:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.service_policy_instance.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-instance"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "output"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.child_policy = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                    self._children_yang_names.add("child-policy")

                                    self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "child-policy" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "child-policy"):
                                        if (self.child_policy is None):
                                            self.child_policy = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                        return self.child_policy

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "output" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "service-policy-names"):
                                if (self.service_policy_names is None):
                                    self.service_policy_names = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                return self.service_policy_names

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-names" or name == "statistics"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.interface_name.is_set or
                            (self.input is not None and self.input.has_data()) or
                            (self.output is not None and self.output.has_data()) or
                            (self.satellite_ids is not None and self.satellite_ids.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.interface_name.yfilter != YFilter.not_set or
                            (self.input is not None and self.input.has_operation()) or
                            (self.output is not None and self.output.has_operation()) or
                            (self.satellite_ids is not None and self.satellite_ids.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "member-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "input"):
                            if (self.input is None):
                                self.input = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"
                            return self.input

                        if (child_yang_name == "output"):
                            if (self.output is None):
                                self.output = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                            return self.output

                        if (child_yang_name == "satellite-ids"):
                            if (self.satellite_ids is None):
                                self.satellite_ids = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds()
                                self.satellite_ids.parent = self
                                self._children_name_map["satellite_ids"] = "satellite-ids"
                            return self.satellite_ids

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "input" or name == "output" or name == "satellite-ids" or name == "interface-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "interface-name"):
                            self.interface_name = value
                            self.interface_name.value_namespace = name_space
                            self.interface_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.member_interface:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.member_interface:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "member-interfaces" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "member-interface"):
                        for c in self.member_interface:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Qos.NvInterfaceTable.Interface.MemberInterfaces.MemberInterface()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.member_interface.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "member-interface"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class SatelliteIds(Entity):
                """
                Satellite ID information
                
                .. attribute:: satellite_id
                
                	Satellite ID information
                	**type**\: list of    :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.NvInterfaceTable.Interface.SatelliteIds, self).__init__()

                    self.yang_name = "satellite-ids"
                    self.yang_parent_name = "interface"

                    self.satellite_id = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Qos.NvInterfaceTable.Interface.SatelliteIds, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Qos.NvInterfaceTable.Interface.SatelliteIds, self).__setattr__(name, value)


                class SatelliteId(Entity):
                    """
                    Satellite ID information
                    
                    .. attribute:: nv_satellite_id  <key>
                    
                    	Satellite ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: input
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input>`
                    
                    .. attribute:: output
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId, self).__init__()

                        self.yang_name = "satellite-id"
                        self.yang_parent_name = "satellite-ids"

                        self.nv_satellite_id = YLeaf(YType.int32, "nv-satellite-id")

                        self.input = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"
                        self._children_yang_names.add("input")

                        self.output = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._children_yang_names.add("output")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("nv_satellite_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId, self).__setattr__(name, value)


                    class Input(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "satellite-id"

                            self.service_policy_names = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._children_yang_names.add("service-policy-names")

                            self.statistics = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "input"

                                self.service_policy_instance = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  <key>
                                
                                	Name of the policy instance
                                	**type**\:  str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"

                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("service_policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.service_policy_name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.service_policy_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "service-policy-name"):
                                        self.service_policy_name = value
                                        self.service_policy_name.value_namespace = name_space
                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.service_policy_instance:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.service_policy_instance:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "service-policy-names" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-instance"):
                                    for c in self.service_policy_instance:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.service_policy_instance.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-instance"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "input"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.child_policy = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                    self._children_yang_names.add("child-policy")

                                    self.general_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.general_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "child-policy" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "child-policy"):
                                        if (self.child_policy is None):
                                            self.child_policy = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                        return self.child_policy

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "input" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "service-policy-names"):
                                if (self.service_policy_names is None):
                                    self.service_policy_names = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                return self.service_policy_names

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-names" or name == "statistics"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Output(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "satellite-id"

                            self.service_policy_names = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._children_yang_names.add("service-policy-names")

                            self.statistics = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "output"

                                self.service_policy_instance = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  <key>
                                
                                	Name of the policy instance
                                	**type**\:  str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"

                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("service_policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.service_policy_name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.service_policy_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "service-policy-name"):
                                        self.service_policy_name = value
                                        self.service_policy_name.value_namespace = name_space
                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.service_policy_instance:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.service_policy_instance:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "service-policy-names" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-instance"):
                                    for c in self.service_policy_instance:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.service_policy_instance.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-instance"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "output"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.child_policy = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                    self._children_yang_names.add("child-policy")

                                    self.general_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.general_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "child-policy" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "child-policy"):
                                        if (self.child_policy is None):
                                            self.child_policy = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                        return self.child_policy

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "output" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "service-policy-names"):
                                if (self.service_policy_names is None):
                                    self.service_policy_names = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                return self.service_policy_names

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-names" or name == "statistics"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.nv_satellite_id.is_set or
                            (self.input is not None and self.input.has_data()) or
                            (self.output is not None and self.output.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.nv_satellite_id.yfilter != YFilter.not_set or
                            (self.input is not None and self.input.has_operation()) or
                            (self.output is not None and self.output.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "satellite-id" + "[nv-satellite-id='" + self.nv_satellite_id.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.nv_satellite_id.is_set or self.nv_satellite_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nv_satellite_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "input"):
                            if (self.input is None):
                                self.input = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"
                            return self.input

                        if (child_yang_name == "output"):
                            if (self.output is None):
                                self.output = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                            return self.output

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "input" or name == "output" or name == "nv-satellite-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "nv-satellite-id"):
                            self.nv_satellite_id = value
                            self.nv_satellite_id.value_namespace = name_space
                            self.nv_satellite_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.satellite_id:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.satellite_id:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "satellite-ids" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "satellite-id"):
                        for c in self.satellite_id:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Qos.NvInterfaceTable.Interface.SatelliteIds.SatelliteId()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.satellite_id.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "satellite-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Input(Entity):
                """
                A piece of QoS policy\-map operational data for
                an interface
                
                .. attribute:: service_policy_names
                
                	Operational data for all Policy instance
                	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames>`
                
                .. attribute:: statistics
                
                	Policy\-map statistics operational data for an interface
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.NvInterfaceTable.Interface.Input, self).__init__()

                    self.yang_name = "input"
                    self.yang_parent_name = "interface"

                    self.service_policy_names = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames()
                    self.service_policy_names.parent = self
                    self._children_name_map["service_policy_names"] = "service-policy-names"
                    self._children_yang_names.add("service-policy-names")

                    self.statistics = Qos.NvInterfaceTable.Interface.Input.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")


                class ServicePolicyNames(Entity):
                    """
                    Operational data for all Policy instance
                    
                    .. attribute:: service_policy_instance
                    
                    	QoS policy\-map operational data for a particular Policy 
                    	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames, self).__init__()

                        self.yang_name = "service-policy-names"
                        self.yang_parent_name = "input"

                        self.service_policy_instance = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames, self).__setattr__(name, value)


                    class ServicePolicyInstance(Entity):
                        """
                        QoS policy\-map operational data for a
                        particular Policy 
                        
                        .. attribute:: service_policy_name  <key>
                        
                        	Name of the policy instance
                        	**type**\:  str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                            self.yang_name = "service-policy-instance"
                            self.yang_parent_name = "service-policy-names"

                            self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("service_policy_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                        def has_data(self):
                            return self.service_policy_name.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.service_policy_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "service-policy-name"):
                                self.service_policy_name = value
                                self.service_policy_name.value_namespace = name_space
                                self.service_policy_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.service_policy_instance:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.service_policy_instance:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "service-policy-names" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "service-policy-instance"):
                            for c in self.service_policy_instance:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.service_policy_instance.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "service-policy-instance"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Statistics(Entity):
                    """
                    Policy\-map statistics operational data for an
                    interface
                    
                    .. attribute:: class_stats
                    
                    	array of classes contained in policy
                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats>`
                    
                    .. attribute:: policy_name
                    
                    	PolicyName
                    	**type**\:  str
                    
                    	**length:** 0..65
                    
                    .. attribute:: satid
                    
                    	to maintain satellite id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: state
                    
                    	State
                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                    
                    .. attribute:: state_description
                    
                    	StateDescription
                    	**type**\:  str
                    
                    	**length:** 0..128
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.NvInterfaceTable.Interface.Input.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "input"

                        self.policy_name = YLeaf(YType.str, "policy-name")

                        self.satid = YLeaf(YType.uint32, "satid")

                        self.state = YLeaf(YType.enumeration, "state")

                        self.state_description = YLeaf(YType.str, "state-description")

                        self.class_stats = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("policy_name",
                                        "satid",
                                        "state",
                                        "state_description") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.NvInterfaceTable.Interface.Input.Statistics, self).__setattr__(name, value)


                    class ClassStats(Entity):
                        """
                        array of classes contained in policy
                        
                        .. attribute:: cac_state
                        
                        	CACState
                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                        
                        .. attribute:: cac_stats
                        
                        	bag for cac stats
                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.CacStats>`
                        
                        .. attribute:: child_policy
                        
                        	child policy
                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy>`
                        
                        .. attribute:: class_name
                        
                        	ClassName
                        	**type**\:  str
                        
                        	**length:** 0..65
                        
                        .. attribute:: counter_validity_bitmask
                        
                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: megabyte
                        
                        .. attribute:: general_stats
                        
                        	general stats
                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats>`
                        
                        .. attribute:: iphc_stats
                        
                        	IPHC stats
                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats>`
                        
                        .. attribute:: police_stats_array
                        
                        	array of police stats
                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray>`
                        
                        .. attribute:: queue_descr
                        
                        	Description of queue for the class
                        	**type**\:  str
                        
                        	**length:** 0..256
                        
                        .. attribute:: queue_stats_array
                        
                        	array of queue stats
                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray>`
                        
                        .. attribute:: shared_queue_id
                        
                        	q\-id of the  shared queue for this class
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: wred_stats_array
                        
                        	array of red stats
                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats, self).__init__()

                            self.yang_name = "class-stats"
                            self.yang_parent_name = "statistics"

                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                            self.class_name = YLeaf(YType.str, "class-name")

                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                            self.cac_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.CacStats()
                            self.cac_stats.parent = self
                            self._children_name_map["cac_stats"] = "cac-stats"
                            self._children_yang_names.add("cac-stats")

                            self.child_policy = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy()
                            self.child_policy.parent = self
                            self._children_name_map["child_policy"] = "child-policy"
                            self._children_yang_names.add("child-policy")

                            self.general_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats()
                            self.general_stats.parent = self
                            self._children_name_map["general_stats"] = "general-stats"
                            self._children_yang_names.add("general-stats")

                            self.iphc_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats()
                            self.iphc_stats.parent = self
                            self._children_name_map["iphc_stats"] = "iphc-stats"
                            self._children_yang_names.add("iphc-stats")

                            self.police_stats_array = YList(self)
                            self.queue_stats_array = YList(self)
                            self.wred_stats_array = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("cac_state",
                                            "class_name",
                                            "counter_validity_bitmask",
                                            "queue_descr",
                                            "shared_queue_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats, self).__setattr__(name, value)


                        class GeneralStats(Entity):
                            """
                            general stats
                            
                            .. attribute:: match_data_rate
                            
                            	Incoming matched data rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: pre_policy_matched_bytes
                            
                            	Matched bytes before applying policy
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: pre_policy_matched_packets
                            
                            	Matched pkts before applying policy
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: total_drop_bytes
                            
                            	Dropped bytes (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: total_drop_packets
                            
                            	Dropped packets (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: total_drop_rate
                            
                            	Total drop rate (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: total_transmit_rate
                            
                            	Total transmit rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: transmit_bytes
                            
                            	Transmitted bytes (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: transmit_packets
                            
                            	Transmitted packets (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                self.yang_name = "general-stats"
                                self.yang_parent_name = "class-stats"

                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("match_data_rate",
                                                "pre_policy_matched_bytes",
                                                "pre_policy_matched_packets",
                                                "total_drop_bytes",
                                                "total_drop_packets",
                                                "total_drop_rate",
                                                "total_transmit_rate",
                                                "transmit_bytes",
                                                "transmit_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.match_data_rate.is_set or
                                    self.pre_policy_matched_bytes.is_set or
                                    self.pre_policy_matched_packets.is_set or
                                    self.total_drop_bytes.is_set or
                                    self.total_drop_packets.is_set or
                                    self.total_drop_rate.is_set or
                                    self.total_transmit_rate.is_set or
                                    self.transmit_bytes.is_set or
                                    self.transmit_packets.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.match_data_rate.yfilter != YFilter.not_set or
                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                    self.transmit_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "general-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "match-data-rate"):
                                    self.match_data_rate = value
                                    self.match_data_rate.value_namespace = name_space
                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "pre-policy-matched-bytes"):
                                    self.pre_policy_matched_bytes = value
                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "pre-policy-matched-packets"):
                                    self.pre_policy_matched_packets = value
                                    self.pre_policy_matched_packets.value_namespace = name_space
                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-drop-bytes"):
                                    self.total_drop_bytes = value
                                    self.total_drop_bytes.value_namespace = name_space
                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-drop-packets"):
                                    self.total_drop_packets = value
                                    self.total_drop_packets.value_namespace = name_space
                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-drop-rate"):
                                    self.total_drop_rate = value
                                    self.total_drop_rate.value_namespace = name_space
                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-transmit-rate"):
                                    self.total_transmit_rate = value
                                    self.total_transmit_rate.value_namespace = name_space
                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "transmit-bytes"):
                                    self.transmit_bytes = value
                                    self.transmit_bytes.value_namespace = name_space
                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "transmit-packets"):
                                    self.transmit_packets = value
                                    self.transmit_packets.value_namespace = name_space
                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                        class IphcStats(Entity):
                            """
                            IPHC stats
                            
                            .. attribute:: non_tcp_bytes_saved
                            
                            	Non Tcp Bytes saved due to compression
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: non_tcp_bytes_sent_rate
                            
                            	Compressed Non Tcp Bytes sent rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: non_tcp_compressed_packets_out
                            
                            	Num of non tcp compressed pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: non_tcp_full_header_packets_out
                            
                            	Num of non tcp fullheader pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: non_tcp_total_out_bytes
                            
                            	TotalNum of Non Tcp Bytes sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: non_tcp_total_out_packets
                            
                            	TotalNum of Non tcp pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tcp_bytes_saved
                            
                            	Tcp Bytes saved due to compression
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: tcp_bytes_sent_rate
                            
                            	Compressed Tcp Bytes sent rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: tcp_compressed_packets_out
                            
                            	Num of tcp compressed pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tcp_full_header_packets_out
                            
                            	Num of tcp fullheader pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tcp_total_out_bytes
                            
                            	TotalNum of Tcp Bytes sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: tcp_total_out_packets
                            
                            	Total Num of tcp pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                self.yang_name = "iphc-stats"
                                self.yang_parent_name = "class-stats"

                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("non_tcp_bytes_saved",
                                                "non_tcp_bytes_sent_rate",
                                                "non_tcp_compressed_packets_out",
                                                "non_tcp_full_header_packets_out",
                                                "non_tcp_total_out_bytes",
                                                "non_tcp_total_out_packets",
                                                "tcp_bytes_saved",
                                                "tcp_bytes_sent_rate",
                                                "tcp_compressed_packets_out",
                                                "tcp_full_header_packets_out",
                                                "tcp_total_out_bytes",
                                                "tcp_total_out_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.non_tcp_bytes_saved.is_set or
                                    self.non_tcp_bytes_sent_rate.is_set or
                                    self.non_tcp_compressed_packets_out.is_set or
                                    self.non_tcp_full_header_packets_out.is_set or
                                    self.non_tcp_total_out_bytes.is_set or
                                    self.non_tcp_total_out_packets.is_set or
                                    self.tcp_bytes_saved.is_set or
                                    self.tcp_bytes_sent_rate.is_set or
                                    self.tcp_compressed_packets_out.is_set or
                                    self.tcp_full_header_packets_out.is_set or
                                    self.tcp_total_out_bytes.is_set or
                                    self.tcp_total_out_packets.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "iphc-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "non-tcp-bytes-saved"):
                                    self.non_tcp_bytes_saved = value
                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-bytes-sent-rate"):
                                    self.non_tcp_bytes_sent_rate = value
                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-compressed-packets-out"):
                                    self.non_tcp_compressed_packets_out = value
                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-full-header-packets-out"):
                                    self.non_tcp_full_header_packets_out = value
                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-total-out-bytes"):
                                    self.non_tcp_total_out_bytes = value
                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-total-out-packets"):
                                    self.non_tcp_total_out_packets = value
                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-bytes-saved"):
                                    self.tcp_bytes_saved = value
                                    self.tcp_bytes_saved.value_namespace = name_space
                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-bytes-sent-rate"):
                                    self.tcp_bytes_sent_rate = value
                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-compressed-packets-out"):
                                    self.tcp_compressed_packets_out = value
                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-full-header-packets-out"):
                                    self.tcp_full_header_packets_out = value
                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-total-out-bytes"):
                                    self.tcp_total_out_bytes = value
                                    self.tcp_total_out_bytes.value_namespace = name_space
                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-total-out-packets"):
                                    self.tcp_total_out_packets = value
                                    self.tcp_total_out_packets.value_namespace = name_space
                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                        class ChildPolicy(Entity):
                            """
                            child policy
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                self.yang_name = "child-policy"
                                self.yang_parent_name = "class-stats"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "child-policy"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.general_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "child-policy" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix


                        class CacStats(Entity):
                            """
                            bag for cac stats
                            
                            .. attribute:: admit_bytes
                            
                            	Admitted bytes (pkts/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: admit_rates
                            
                            	CAC admit rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: admitpackets
                            
                            	Admitted packets (pkts/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: drop_bytes
                            
                            	CAC dropped bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: drop_packets
                            
                            	CAC dropped packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: drop_rates
                            
                            	CAC dropped rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.CacStats, self).__init__()

                                self.yang_name = "cac-stats"
                                self.yang_parent_name = "class-stats"

                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("admit_bytes",
                                                "admit_rates",
                                                "admitpackets",
                                                "drop_bytes",
                                                "drop_packets",
                                                "drop_rates") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.admit_bytes.is_set or
                                    self.admit_rates.is_set or
                                    self.admitpackets.is_set or
                                    self.drop_bytes.is_set or
                                    self.drop_packets.is_set or
                                    self.drop_rates.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.admit_bytes.yfilter != YFilter.not_set or
                                    self.admit_rates.yfilter != YFilter.not_set or
                                    self.admitpackets.yfilter != YFilter.not_set or
                                    self.drop_bytes.yfilter != YFilter.not_set or
                                    self.drop_packets.yfilter != YFilter.not_set or
                                    self.drop_rates.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "cac-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "admit-bytes"):
                                    self.admit_bytes = value
                                    self.admit_bytes.value_namespace = name_space
                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "admit-rates"):
                                    self.admit_rates = value
                                    self.admit_rates.value_namespace = name_space
                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                if(value_path == "admitpackets"):
                                    self.admitpackets = value
                                    self.admitpackets.value_namespace = name_space
                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-bytes"):
                                    self.drop_bytes = value
                                    self.drop_bytes.value_namespace = name_space
                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-packets"):
                                    self.drop_packets = value
                                    self.drop_packets.value_namespace = name_space
                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-rates"):
                                    self.drop_rates = value
                                    self.drop_rates.value_namespace = name_space
                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                        class QueueStatsArray(Entity):
                            """
                            array of queue stats
                            
                            .. attribute:: atm_clp0_drop_bytes
                            
                            	ATP CLP 0 matched bytes dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: atm_clp0_drop_packets
                            
                            	ATP CLP 0 matched packets dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: atm_clp1_drop_bytes
                            
                            	ATP CLP 0 matched bytes dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: atm_clp1_drop_packets
                            
                            	ATP CLP 0 matched packets dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: conform_bytes
                            
                            	Bytes that conform to the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: conform_packets
                            
                            	Packets that conform  to the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: conform_rate
                            
                            	Conform rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: exceed_bytes
                            
                            	Bytes that exceed  the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: exceed_packets
                            
                            	Packets that exceed the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: exceed_rate
                            
                            	Exceed rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: forced_wred_stats_display
                            
                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                            	**type**\:  bool
                            
                            .. attribute:: max_threshold_bytes
                            
                            	Dropped bytes with the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: max_threshold_packets
                            
                            	Dropped packets with the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: queue_average_length
                            
                            	Queue average length
                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                            
                            .. attribute:: queue_drop_threshold
                            
                            	tail drop threshold of the queue in bytes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: queue_id
                            
                            	Queue Id used for Fabric Stats
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: queue_instance_length
                            
                            	Queue instance length
                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                            
                            .. attribute:: queue_max_length
                            
                            	Queue maximum length
                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                            
                            .. attribute:: random_drop_bytes
                            
                            	Bytes probabilistically dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: random_drop_packets
                            
                            	Packets probabilistically dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tail_drop_bytes
                            
                            	Bytes tail dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: tail_drop_packets
                            
                            	Packets tail dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                self.yang_name = "queue-stats-array"
                                self.yang_parent_name = "class-stats"

                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                self.queue_average_length = YList(self)
                                self.queue_instance_length = YList(self)
                                self.queue_max_length = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("atm_clp0_drop_bytes",
                                                "atm_clp0_drop_packets",
                                                "atm_clp1_drop_bytes",
                                                "atm_clp1_drop_packets",
                                                "conform_bytes",
                                                "conform_packets",
                                                "conform_rate",
                                                "exceed_bytes",
                                                "exceed_packets",
                                                "exceed_rate",
                                                "forced_wred_stats_display",
                                                "max_threshold_bytes",
                                                "max_threshold_packets",
                                                "queue_drop_threshold",
                                                "queue_id",
                                                "random_drop_bytes",
                                                "random_drop_packets",
                                                "tail_drop_bytes",
                                                "tail_drop_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                            class QueueInstanceLength(Entity):
                                """
                                Queue instance length
                                
                                .. attribute:: unit
                                
                                	unit
                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                
                                .. attribute:: value
                                
                                	value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                    self.yang_name = "queue-instance-length"
                                    self.yang_parent_name = "queue-stats-array"

                                    self.unit = YLeaf(YType.enumeration, "unit")

                                    self.value = YLeaf(YType.uint32, "value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("unit",
                                                    "value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.unit.is_set or
                                        self.value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.unit.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "queue-instance-length" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "unit" or name == "value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "unit"):
                                        self.unit = value
                                        self.unit.value_namespace = name_space
                                        self.unit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix


                            class QueueAverageLength(Entity):
                                """
                                Queue average length
                                
                                .. attribute:: unit
                                
                                	unit
                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                
                                .. attribute:: value
                                
                                	value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                    self.yang_name = "queue-average-length"
                                    self.yang_parent_name = "queue-stats-array"

                                    self.unit = YLeaf(YType.enumeration, "unit")

                                    self.value = YLeaf(YType.uint32, "value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("unit",
                                                    "value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.unit.is_set or
                                        self.value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.unit.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "queue-average-length" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "unit" or name == "value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "unit"):
                                        self.unit = value
                                        self.unit.value_namespace = name_space
                                        self.unit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix


                            class QueueMaxLength(Entity):
                                """
                                Queue maximum length
                                
                                .. attribute:: unit
                                
                                	unit
                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                
                                .. attribute:: value
                                
                                	value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                    self.yang_name = "queue-max-length"
                                    self.yang_parent_name = "queue-stats-array"

                                    self.unit = YLeaf(YType.enumeration, "unit")

                                    self.value = YLeaf(YType.uint32, "value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("unit",
                                                    "value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.unit.is_set or
                                        self.value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.unit.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "queue-max-length" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "unit" or name == "value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "unit"):
                                        self.unit = value
                                        self.unit.value_namespace = name_space
                                        self.unit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.queue_average_length:
                                    if (c.has_data()):
                                        return True
                                for c in self.queue_instance_length:
                                    if (c.has_data()):
                                        return True
                                for c in self.queue_max_length:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.atm_clp0_drop_bytes.is_set or
                                    self.atm_clp0_drop_packets.is_set or
                                    self.atm_clp1_drop_bytes.is_set or
                                    self.atm_clp1_drop_packets.is_set or
                                    self.conform_bytes.is_set or
                                    self.conform_packets.is_set or
                                    self.conform_rate.is_set or
                                    self.exceed_bytes.is_set or
                                    self.exceed_packets.is_set or
                                    self.exceed_rate.is_set or
                                    self.forced_wred_stats_display.is_set or
                                    self.max_threshold_bytes.is_set or
                                    self.max_threshold_packets.is_set or
                                    self.queue_drop_threshold.is_set or
                                    self.queue_id.is_set or
                                    self.random_drop_bytes.is_set or
                                    self.random_drop_packets.is_set or
                                    self.tail_drop_bytes.is_set or
                                    self.tail_drop_packets.is_set)

                            def has_operation(self):
                                for c in self.queue_average_length:
                                    if (c.has_operation()):
                                        return True
                                for c in self.queue_instance_length:
                                    if (c.has_operation()):
                                        return True
                                for c in self.queue_max_length:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                    self.conform_bytes.yfilter != YFilter.not_set or
                                    self.conform_packets.yfilter != YFilter.not_set or
                                    self.conform_rate.yfilter != YFilter.not_set or
                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                    self.exceed_packets.yfilter != YFilter.not_set or
                                    self.exceed_rate.yfilter != YFilter.not_set or
                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                    self.queue_id.yfilter != YFilter.not_set or
                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "queue-stats-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "queue-average-length"):
                                    for c in self.queue_average_length:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.queue_average_length.append(c)
                                    return c

                                if (child_yang_name == "queue-instance-length"):
                                    for c in self.queue_instance_length:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.queue_instance_length.append(c)
                                    return c

                                if (child_yang_name == "queue-max-length"):
                                    for c in self.queue_max_length:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.queue_max_length.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "atm-clp0-drop-bytes"):
                                    self.atm_clp0_drop_bytes = value
                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "atm-clp0-drop-packets"):
                                    self.atm_clp0_drop_packets = value
                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "atm-clp1-drop-bytes"):
                                    self.atm_clp1_drop_bytes = value
                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "atm-clp1-drop-packets"):
                                    self.atm_clp1_drop_packets = value
                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-bytes"):
                                    self.conform_bytes = value
                                    self.conform_bytes.value_namespace = name_space
                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-packets"):
                                    self.conform_packets = value
                                    self.conform_packets.value_namespace = name_space
                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-rate"):
                                    self.conform_rate = value
                                    self.conform_rate.value_namespace = name_space
                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-bytes"):
                                    self.exceed_bytes = value
                                    self.exceed_bytes.value_namespace = name_space
                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-packets"):
                                    self.exceed_packets = value
                                    self.exceed_packets.value_namespace = name_space
                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-rate"):
                                    self.exceed_rate = value
                                    self.exceed_rate.value_namespace = name_space
                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "forced-wred-stats-display"):
                                    self.forced_wred_stats_display = value
                                    self.forced_wred_stats_display.value_namespace = name_space
                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-threshold-bytes"):
                                    self.max_threshold_bytes = value
                                    self.max_threshold_bytes.value_namespace = name_space
                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-threshold-packets"):
                                    self.max_threshold_packets = value
                                    self.max_threshold_packets.value_namespace = name_space
                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "queue-drop-threshold"):
                                    self.queue_drop_threshold = value
                                    self.queue_drop_threshold.value_namespace = name_space
                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                if(value_path == "queue-id"):
                                    self.queue_id = value
                                    self.queue_id.value_namespace = name_space
                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-bytes"):
                                    self.random_drop_bytes = value
                                    self.random_drop_bytes.value_namespace = name_space
                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-packets"):
                                    self.random_drop_packets = value
                                    self.random_drop_packets.value_namespace = name_space
                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "tail-drop-bytes"):
                                    self.tail_drop_bytes = value
                                    self.tail_drop_bytes.value_namespace = name_space
                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "tail-drop-packets"):
                                    self.tail_drop_packets = value
                                    self.tail_drop_packets.value_namespace = name_space
                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                        class PoliceStatsArray(Entity):
                            """
                            array of police stats
                            
                            .. attribute:: color_class_stats
                            
                            	color class stats
                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                            
                            .. attribute:: conform_bytes
                            
                            	Bytes that conform to the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: conform_packets
                            
                            	Packets that conform  to the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: conform_rate
                            
                            	Conform rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: drop_bytes
                            
                            	Police dropped bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: drop_packets
                            
                            	Police dropped packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: exceed_bytes
                            
                            	Bytes that exceed  the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: exceed_packets
                            
                            	Packets that exceed the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: exceed_rate
                            
                            	Exceed rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: parent_drop_bytes
                            
                            	Dropped bytes by the parent policer
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: parent_drop_packets
                            
                            	Dropped pkts by the parent policer
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: violate_bytes
                            
                            	Bytes that violate the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: violate_packets
                            
                            	Packets violating the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: violate_rate
                            
                            	Violate rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                self.yang_name = "police-stats-array"
                                self.yang_parent_name = "class-stats"

                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                self.color_class_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                self.color_class_stats.parent = self
                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                self._children_yang_names.add("color-class-stats")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("conform_bytes",
                                                "conform_packets",
                                                "conform_rate",
                                                "drop_bytes",
                                                "drop_packets",
                                                "exceed_bytes",
                                                "exceed_packets",
                                                "exceed_rate",
                                                "parent_drop_bytes",
                                                "parent_drop_packets",
                                                "violate_bytes",
                                                "violate_packets",
                                                "violate_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                            class ColorClassStats(Entity):
                                """
                                color class stats
                                
                                .. attribute:: conform_class_conform_bytes
                                
                                	Bytes with classification result conform and policer result conform
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: conform_class_conform_packets
                                
                                	Packets with classification result conform and policer result conform
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: conform_class_conform_rate
                                
                                	Conform Class Conform rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: conform_class_exceed_bytes
                                
                                	Bytes with classification result conform and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: conform_class_exceed_packets
                                
                                	Packets with classification result conform and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: conform_class_exceed_rate
                                
                                	Conform Class Exceed rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: conform_class_violate_bytes
                                
                                	Bytes with classification result conform and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: conform_class_violate_packets
                                
                                	Packets with classification result conform and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: conform_class_violate_rate
                                
                                	Conform Class Violate rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: exceed_class_exceed_bytes
                                
                                	Bytes with classification result exceed and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: exceed_class_exceed_packets
                                
                                	Packets with classification result exceed and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: exceed_class_exceed_rate
                                
                                	Exceed Class Exceed rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: exceed_class_violate_bytes
                                
                                	Bytes with classification result exceed and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: exceed_class_violate_packets
                                
                                	Packets with classification result exceed and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: exceed_class_violate_rate
                                
                                	Exceed Class Violate rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: violate_class_violate_bytes
                                
                                	Bytes with classification result violate and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: violate_class_violate_packets
                                
                                	Packets with classification result violate and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: violate_class_violate_rate
                                
                                	Violate Class Violate rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                    self.yang_name = "color-class-stats"
                                    self.yang_parent_name = "police-stats-array"

                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("conform_class_conform_bytes",
                                                    "conform_class_conform_packets",
                                                    "conform_class_conform_rate",
                                                    "conform_class_exceed_bytes",
                                                    "conform_class_exceed_packets",
                                                    "conform_class_exceed_rate",
                                                    "conform_class_violate_bytes",
                                                    "conform_class_violate_packets",
                                                    "conform_class_violate_rate",
                                                    "exceed_class_exceed_bytes",
                                                    "exceed_class_exceed_packets",
                                                    "exceed_class_exceed_rate",
                                                    "exceed_class_violate_bytes",
                                                    "exceed_class_violate_packets",
                                                    "exceed_class_violate_rate",
                                                    "violate_class_violate_bytes",
                                                    "violate_class_violate_packets",
                                                    "violate_class_violate_rate") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.conform_class_conform_bytes.is_set or
                                        self.conform_class_conform_packets.is_set or
                                        self.conform_class_conform_rate.is_set or
                                        self.conform_class_exceed_bytes.is_set or
                                        self.conform_class_exceed_packets.is_set or
                                        self.conform_class_exceed_rate.is_set or
                                        self.conform_class_violate_bytes.is_set or
                                        self.conform_class_violate_packets.is_set or
                                        self.conform_class_violate_rate.is_set or
                                        self.exceed_class_exceed_bytes.is_set or
                                        self.exceed_class_exceed_packets.is_set or
                                        self.exceed_class_exceed_rate.is_set or
                                        self.exceed_class_violate_bytes.is_set or
                                        self.exceed_class_violate_packets.is_set or
                                        self.exceed_class_violate_rate.is_set or
                                        self.violate_class_violate_bytes.is_set or
                                        self.violate_class_violate_packets.is_set or
                                        self.violate_class_violate_rate.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "color-class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "conform-class-conform-bytes"):
                                        self.conform_class_conform_bytes = value
                                        self.conform_class_conform_bytes.value_namespace = name_space
                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-conform-packets"):
                                        self.conform_class_conform_packets = value
                                        self.conform_class_conform_packets.value_namespace = name_space
                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-conform-rate"):
                                        self.conform_class_conform_rate = value
                                        self.conform_class_conform_rate.value_namespace = name_space
                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-exceed-bytes"):
                                        self.conform_class_exceed_bytes = value
                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-exceed-packets"):
                                        self.conform_class_exceed_packets = value
                                        self.conform_class_exceed_packets.value_namespace = name_space
                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-exceed-rate"):
                                        self.conform_class_exceed_rate = value
                                        self.conform_class_exceed_rate.value_namespace = name_space
                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-violate-bytes"):
                                        self.conform_class_violate_bytes = value
                                        self.conform_class_violate_bytes.value_namespace = name_space
                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-violate-packets"):
                                        self.conform_class_violate_packets = value
                                        self.conform_class_violate_packets.value_namespace = name_space
                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-violate-rate"):
                                        self.conform_class_violate_rate = value
                                        self.conform_class_violate_rate.value_namespace = name_space
                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-exceed-bytes"):
                                        self.exceed_class_exceed_bytes = value
                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-exceed-packets"):
                                        self.exceed_class_exceed_packets = value
                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-exceed-rate"):
                                        self.exceed_class_exceed_rate = value
                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-violate-bytes"):
                                        self.exceed_class_violate_bytes = value
                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-violate-packets"):
                                        self.exceed_class_violate_packets = value
                                        self.exceed_class_violate_packets.value_namespace = name_space
                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-violate-rate"):
                                        self.exceed_class_violate_rate = value
                                        self.exceed_class_violate_rate.value_namespace = name_space
                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "violate-class-violate-bytes"):
                                        self.violate_class_violate_bytes = value
                                        self.violate_class_violate_bytes.value_namespace = name_space
                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "violate-class-violate-packets"):
                                        self.violate_class_violate_packets = value
                                        self.violate_class_violate_packets.value_namespace = name_space
                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "violate-class-violate-rate"):
                                        self.violate_class_violate_rate = value
                                        self.violate_class_violate_rate.value_namespace = name_space
                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.conform_bytes.is_set or
                                    self.conform_packets.is_set or
                                    self.conform_rate.is_set or
                                    self.drop_bytes.is_set or
                                    self.drop_packets.is_set or
                                    self.exceed_bytes.is_set or
                                    self.exceed_packets.is_set or
                                    self.exceed_rate.is_set or
                                    self.parent_drop_bytes.is_set or
                                    self.parent_drop_packets.is_set or
                                    self.violate_bytes.is_set or
                                    self.violate_packets.is_set or
                                    self.violate_rate.is_set or
                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.conform_bytes.yfilter != YFilter.not_set or
                                    self.conform_packets.yfilter != YFilter.not_set or
                                    self.conform_rate.yfilter != YFilter.not_set or
                                    self.drop_bytes.yfilter != YFilter.not_set or
                                    self.drop_packets.yfilter != YFilter.not_set or
                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                    self.exceed_packets.yfilter != YFilter.not_set or
                                    self.exceed_rate.yfilter != YFilter.not_set or
                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                    self.violate_bytes.yfilter != YFilter.not_set or
                                    self.violate_packets.yfilter != YFilter.not_set or
                                    self.violate_rate.yfilter != YFilter.not_set or
                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "police-stats-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "color-class-stats"):
                                    if (self.color_class_stats is None):
                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                    return self.color_class_stats

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "conform-bytes"):
                                    self.conform_bytes = value
                                    self.conform_bytes.value_namespace = name_space
                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-packets"):
                                    self.conform_packets = value
                                    self.conform_packets.value_namespace = name_space
                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-rate"):
                                    self.conform_rate = value
                                    self.conform_rate.value_namespace = name_space
                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-bytes"):
                                    self.drop_bytes = value
                                    self.drop_bytes.value_namespace = name_space
                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-packets"):
                                    self.drop_packets = value
                                    self.drop_packets.value_namespace = name_space
                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-bytes"):
                                    self.exceed_bytes = value
                                    self.exceed_bytes.value_namespace = name_space
                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-packets"):
                                    self.exceed_packets = value
                                    self.exceed_packets.value_namespace = name_space
                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-rate"):
                                    self.exceed_rate = value
                                    self.exceed_rate.value_namespace = name_space
                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-drop-bytes"):
                                    self.parent_drop_bytes = value
                                    self.parent_drop_bytes.value_namespace = name_space
                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-drop-packets"):
                                    self.parent_drop_packets = value
                                    self.parent_drop_packets.value_namespace = name_space
                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "violate-bytes"):
                                    self.violate_bytes = value
                                    self.violate_bytes.value_namespace = name_space
                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "violate-packets"):
                                    self.violate_packets = value
                                    self.violate_packets.value_namespace = name_space
                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "violate-rate"):
                                    self.violate_rate = value
                                    self.violate_rate.value_namespace = name_space
                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                        class WredStatsArray(Entity):
                            """
                            array of red stats
                            
                            .. attribute:: max_threshold_bytes
                            
                            	Dropped bytes with  the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: max_threshold_packets
                            
                            	Dropped packets with  the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: profile_title
                            
                            	ProfileTitle
                            	**type**\:  str
                            
                            	**length:** 0..300
                            
                            .. attribute:: random_drop_bytes
                            
                            	Probabilisticallydropped bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: random_drop_packets
                            
                            	Probabilistically dropped  packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: red_ecn_marked_bytes
                            
                            	ECN marked bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: red_ecn_marked_packets
                            
                            	ECN marked packets 
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: red_label
                            
                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                            
                            .. attribute:: red_transmit_bytes
                            
                            	Transmitted bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: red_transmit_packets
                            
                            	Transmitted packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                self.yang_name = "wred-stats-array"
                                self.yang_parent_name = "class-stats"

                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                self.profile_title = YLeaf(YType.str, "profile-title")

                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                self.red_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("max_threshold_bytes",
                                                "max_threshold_packets",
                                                "profile_title",
                                                "random_drop_bytes",
                                                "random_drop_packets",
                                                "red_ecn_marked_bytes",
                                                "red_ecn_marked_packets",
                                                "red_transmit_bytes",
                                                "red_transmit_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                            class RedLabel(Entity):
                                """
                                Array of WRED Typevalues as in PRP stats is
                                available per threshold   
                                
                                .. attribute:: value
                                
                                	WRED value for this type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: wred_type
                                
                                	WRED type DSCP, EXP, PREC etc
                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                    self.yang_name = "red-label"
                                    self.yang_parent_name = "wred-stats-array"

                                    self.value = YLeaf(YType.uint8, "value")

                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("value",
                                                    "wred_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.value.is_set or
                                        self.wred_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set or
                                        self.wred_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "red-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())
                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "value" or name == "wred-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix
                                    if(value_path == "wred-type"):
                                        self.wred_type = value
                                        self.wred_type.value_namespace = name_space
                                        self.wred_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.red_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.max_threshold_bytes.is_set or
                                    self.max_threshold_packets.is_set or
                                    self.profile_title.is_set or
                                    self.random_drop_bytes.is_set or
                                    self.random_drop_packets.is_set or
                                    self.red_ecn_marked_bytes.is_set or
                                    self.red_ecn_marked_packets.is_set or
                                    self.red_transmit_bytes.is_set or
                                    self.red_transmit_packets.is_set)

                            def has_operation(self):
                                for c in self.red_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                    self.profile_title.yfilter != YFilter.not_set or
                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "wred-stats-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "red-label"):
                                    for c in self.red_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.red_label.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "max-threshold-bytes"):
                                    self.max_threshold_bytes = value
                                    self.max_threshold_bytes.value_namespace = name_space
                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-threshold-packets"):
                                    self.max_threshold_packets = value
                                    self.max_threshold_packets.value_namespace = name_space
                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "profile-title"):
                                    self.profile_title = value
                                    self.profile_title.value_namespace = name_space
                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-bytes"):
                                    self.random_drop_bytes = value
                                    self.random_drop_bytes.value_namespace = name_space
                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-packets"):
                                    self.random_drop_packets = value
                                    self.random_drop_packets.value_namespace = name_space
                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-ecn-marked-bytes"):
                                    self.red_ecn_marked_bytes = value
                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-ecn-marked-packets"):
                                    self.red_ecn_marked_packets = value
                                    self.red_ecn_marked_packets.value_namespace = name_space
                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-transmit-bytes"):
                                    self.red_transmit_bytes = value
                                    self.red_transmit_bytes.value_namespace = name_space
                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-transmit-packets"):
                                    self.red_transmit_packets = value
                                    self.red_transmit_packets.value_namespace = name_space
                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.police_stats_array:
                                if (c.has_data()):
                                    return True
                            for c in self.queue_stats_array:
                                if (c.has_data()):
                                    return True
                            for c in self.wred_stats_array:
                                if (c.has_data()):
                                    return True
                            return (
                                self.cac_state.is_set or
                                self.class_name.is_set or
                                self.counter_validity_bitmask.is_set or
                                self.queue_descr.is_set or
                                self.shared_queue_id.is_set or
                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                (self.child_policy is not None and self.child_policy.has_data()) or
                                (self.general_stats is not None and self.general_stats.has_data()) or
                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                        def has_operation(self):
                            for c in self.police_stats_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.queue_stats_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.wred_stats_array:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.cac_state.yfilter != YFilter.not_set or
                                self.class_name.yfilter != YFilter.not_set or
                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                self.queue_descr.yfilter != YFilter.not_set or
                                self.shared_queue_id.yfilter != YFilter.not_set or
                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                (self.child_policy is not None and self.child_policy.has_operation()) or
                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "class-stats" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.class_name.get_name_leafdata())
                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "cac-stats"):
                                if (self.cac_stats is None):
                                    self.cac_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                return self.cac_stats

                            if (child_yang_name == "child-policy"):
                                if (self.child_policy is None):
                                    self.child_policy = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                return self.child_policy

                            if (child_yang_name == "general-stats"):
                                if (self.general_stats is None):
                                    self.general_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                return self.general_stats

                            if (child_yang_name == "iphc-stats"):
                                if (self.iphc_stats is None):
                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                return self.iphc_stats

                            if (child_yang_name == "police-stats-array"):
                                for c in self.police_stats_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.police_stats_array.append(c)
                                return c

                            if (child_yang_name == "queue-stats-array"):
                                for c in self.queue_stats_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.queue_stats_array.append(c)
                                return c

                            if (child_yang_name == "wred-stats-array"):
                                for c in self.wred_stats_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.wred_stats_array.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "cac-state"):
                                self.cac_state = value
                                self.cac_state.value_namespace = name_space
                                self.cac_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "class-name"):
                                self.class_name = value
                                self.class_name.value_namespace = name_space
                                self.class_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "counter-validity-bitmask"):
                                self.counter_validity_bitmask = value
                                self.counter_validity_bitmask.value_namespace = name_space
                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                            if(value_path == "queue-descr"):
                                self.queue_descr = value
                                self.queue_descr.value_namespace = name_space
                                self.queue_descr.value_namespace_prefix = name_space_prefix
                            if(value_path == "shared-queue-id"):
                                self.shared_queue_id = value
                                self.shared_queue_id.value_namespace = name_space
                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.class_stats:
                            if (c.has_data()):
                                return True
                        return (
                            self.policy_name.is_set or
                            self.satid.is_set or
                            self.state.is_set or
                            self.state_description.is_set)

                    def has_operation(self):
                        for c in self.class_stats:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.policy_name.yfilter != YFilter.not_set or
                            self.satid.yfilter != YFilter.not_set or
                            self.state.yfilter != YFilter.not_set or
                            self.state_description.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.satid.get_name_leafdata())
                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.state.get_name_leafdata())
                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.state_description.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "class-stats"):
                            for c in self.class_stats:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Qos.NvInterfaceTable.Interface.Input.Statistics.ClassStats()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.class_stats.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "policy-name"):
                            self.policy_name = value
                            self.policy_name.value_namespace = name_space
                            self.policy_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "satid"):
                            self.satid = value
                            self.satid.value_namespace = name_space
                            self.satid.value_namespace_prefix = name_space_prefix
                        if(value_path == "state"):
                            self.state = value
                            self.state.value_namespace = name_space
                            self.state.value_namespace_prefix = name_space_prefix
                        if(value_path == "state-description"):
                            self.state_description = value
                            self.state_description.value_namespace = name_space
                            self.state_description.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "input" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "service-policy-names"):
                        if (self.service_policy_names is None):
                            self.service_policy_names = Qos.NvInterfaceTable.Interface.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                        return self.service_policy_names

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = Qos.NvInterfaceTable.Interface.Input.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "service-policy-names" or name == "statistics"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Output(Entity):
                """
                A piece of QoS policy\-map operational data for
                an interface
                
                .. attribute:: service_policy_names
                
                	Operational data for all Policy instance
                	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames>`
                
                .. attribute:: statistics
                
                	Policy\-map statistics operational data for an interface
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.NvInterfaceTable.Interface.Output, self).__init__()

                    self.yang_name = "output"
                    self.yang_parent_name = "interface"

                    self.service_policy_names = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames()
                    self.service_policy_names.parent = self
                    self._children_name_map["service_policy_names"] = "service-policy-names"
                    self._children_yang_names.add("service-policy-names")

                    self.statistics = Qos.NvInterfaceTable.Interface.Output.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")


                class ServicePolicyNames(Entity):
                    """
                    Operational data for all Policy instance
                    
                    .. attribute:: service_policy_instance
                    
                    	QoS policy\-map operational data for a particular Policy 
                    	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames, self).__init__()

                        self.yang_name = "service-policy-names"
                        self.yang_parent_name = "output"

                        self.service_policy_instance = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames, self).__setattr__(name, value)


                    class ServicePolicyInstance(Entity):
                        """
                        QoS policy\-map operational data for a
                        particular Policy 
                        
                        .. attribute:: service_policy_name  <key>
                        
                        	Name of the policy instance
                        	**type**\:  str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                            self.yang_name = "service-policy-instance"
                            self.yang_parent_name = "service-policy-names"

                            self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("service_policy_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                        def has_data(self):
                            return self.service_policy_name.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.service_policy_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "service-policy-name"):
                                self.service_policy_name = value
                                self.service_policy_name.value_namespace = name_space
                                self.service_policy_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.service_policy_instance:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.service_policy_instance:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "service-policy-names" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "service-policy-instance"):
                            for c in self.service_policy_instance:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.service_policy_instance.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "service-policy-instance"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Statistics(Entity):
                    """
                    Policy\-map statistics operational data for an
                    interface
                    
                    .. attribute:: class_stats
                    
                    	array of classes contained in policy
                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats>`
                    
                    .. attribute:: policy_name
                    
                    	PolicyName
                    	**type**\:  str
                    
                    	**length:** 0..65
                    
                    .. attribute:: satid
                    
                    	to maintain satellite id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: state
                    
                    	State
                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                    
                    .. attribute:: state_description
                    
                    	StateDescription
                    	**type**\:  str
                    
                    	**length:** 0..128
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.NvInterfaceTable.Interface.Output.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "output"

                        self.policy_name = YLeaf(YType.str, "policy-name")

                        self.satid = YLeaf(YType.uint32, "satid")

                        self.state = YLeaf(YType.enumeration, "state")

                        self.state_description = YLeaf(YType.str, "state-description")

                        self.class_stats = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("policy_name",
                                        "satid",
                                        "state",
                                        "state_description") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.NvInterfaceTable.Interface.Output.Statistics, self).__setattr__(name, value)


                    class ClassStats(Entity):
                        """
                        array of classes contained in policy
                        
                        .. attribute:: cac_state
                        
                        	CACState
                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                        
                        .. attribute:: cac_stats
                        
                        	bag for cac stats
                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.CacStats>`
                        
                        .. attribute:: child_policy
                        
                        	child policy
                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy>`
                        
                        .. attribute:: class_name
                        
                        	ClassName
                        	**type**\:  str
                        
                        	**length:** 0..65
                        
                        .. attribute:: counter_validity_bitmask
                        
                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: megabyte
                        
                        .. attribute:: general_stats
                        
                        	general stats
                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats>`
                        
                        .. attribute:: iphc_stats
                        
                        	IPHC stats
                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats>`
                        
                        .. attribute:: police_stats_array
                        
                        	array of police stats
                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray>`
                        
                        .. attribute:: queue_descr
                        
                        	Description of queue for the class
                        	**type**\:  str
                        
                        	**length:** 0..256
                        
                        .. attribute:: queue_stats_array
                        
                        	array of queue stats
                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray>`
                        
                        .. attribute:: shared_queue_id
                        
                        	q\-id of the  shared queue for this class
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: wred_stats_array
                        
                        	array of red stats
                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats, self).__init__()

                            self.yang_name = "class-stats"
                            self.yang_parent_name = "statistics"

                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                            self.class_name = YLeaf(YType.str, "class-name")

                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                            self.cac_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.CacStats()
                            self.cac_stats.parent = self
                            self._children_name_map["cac_stats"] = "cac-stats"
                            self._children_yang_names.add("cac-stats")

                            self.child_policy = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy()
                            self.child_policy.parent = self
                            self._children_name_map["child_policy"] = "child-policy"
                            self._children_yang_names.add("child-policy")

                            self.general_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats()
                            self.general_stats.parent = self
                            self._children_name_map["general_stats"] = "general-stats"
                            self._children_yang_names.add("general-stats")

                            self.iphc_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats()
                            self.iphc_stats.parent = self
                            self._children_name_map["iphc_stats"] = "iphc-stats"
                            self._children_yang_names.add("iphc-stats")

                            self.police_stats_array = YList(self)
                            self.queue_stats_array = YList(self)
                            self.wred_stats_array = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("cac_state",
                                            "class_name",
                                            "counter_validity_bitmask",
                                            "queue_descr",
                                            "shared_queue_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats, self).__setattr__(name, value)


                        class GeneralStats(Entity):
                            """
                            general stats
                            
                            .. attribute:: match_data_rate
                            
                            	Incoming matched data rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: pre_policy_matched_bytes
                            
                            	Matched bytes before applying policy
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: pre_policy_matched_packets
                            
                            	Matched pkts before applying policy
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: total_drop_bytes
                            
                            	Dropped bytes (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: total_drop_packets
                            
                            	Dropped packets (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: total_drop_rate
                            
                            	Total drop rate (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: total_transmit_rate
                            
                            	Total transmit rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: transmit_bytes
                            
                            	Transmitted bytes (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: transmit_packets
                            
                            	Transmitted packets (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                self.yang_name = "general-stats"
                                self.yang_parent_name = "class-stats"

                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("match_data_rate",
                                                "pre_policy_matched_bytes",
                                                "pre_policy_matched_packets",
                                                "total_drop_bytes",
                                                "total_drop_packets",
                                                "total_drop_rate",
                                                "total_transmit_rate",
                                                "transmit_bytes",
                                                "transmit_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.match_data_rate.is_set or
                                    self.pre_policy_matched_bytes.is_set or
                                    self.pre_policy_matched_packets.is_set or
                                    self.total_drop_bytes.is_set or
                                    self.total_drop_packets.is_set or
                                    self.total_drop_rate.is_set or
                                    self.total_transmit_rate.is_set or
                                    self.transmit_bytes.is_set or
                                    self.transmit_packets.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.match_data_rate.yfilter != YFilter.not_set or
                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                    self.transmit_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "general-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "match-data-rate"):
                                    self.match_data_rate = value
                                    self.match_data_rate.value_namespace = name_space
                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "pre-policy-matched-bytes"):
                                    self.pre_policy_matched_bytes = value
                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "pre-policy-matched-packets"):
                                    self.pre_policy_matched_packets = value
                                    self.pre_policy_matched_packets.value_namespace = name_space
                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-drop-bytes"):
                                    self.total_drop_bytes = value
                                    self.total_drop_bytes.value_namespace = name_space
                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-drop-packets"):
                                    self.total_drop_packets = value
                                    self.total_drop_packets.value_namespace = name_space
                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-drop-rate"):
                                    self.total_drop_rate = value
                                    self.total_drop_rate.value_namespace = name_space
                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-transmit-rate"):
                                    self.total_transmit_rate = value
                                    self.total_transmit_rate.value_namespace = name_space
                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "transmit-bytes"):
                                    self.transmit_bytes = value
                                    self.transmit_bytes.value_namespace = name_space
                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "transmit-packets"):
                                    self.transmit_packets = value
                                    self.transmit_packets.value_namespace = name_space
                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                        class IphcStats(Entity):
                            """
                            IPHC stats
                            
                            .. attribute:: non_tcp_bytes_saved
                            
                            	Non Tcp Bytes saved due to compression
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: non_tcp_bytes_sent_rate
                            
                            	Compressed Non Tcp Bytes sent rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: non_tcp_compressed_packets_out
                            
                            	Num of non tcp compressed pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: non_tcp_full_header_packets_out
                            
                            	Num of non tcp fullheader pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: non_tcp_total_out_bytes
                            
                            	TotalNum of Non Tcp Bytes sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: non_tcp_total_out_packets
                            
                            	TotalNum of Non tcp pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tcp_bytes_saved
                            
                            	Tcp Bytes saved due to compression
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: tcp_bytes_sent_rate
                            
                            	Compressed Tcp Bytes sent rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: tcp_compressed_packets_out
                            
                            	Num of tcp compressed pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tcp_full_header_packets_out
                            
                            	Num of tcp fullheader pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tcp_total_out_bytes
                            
                            	TotalNum of Tcp Bytes sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: tcp_total_out_packets
                            
                            	Total Num of tcp pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                self.yang_name = "iphc-stats"
                                self.yang_parent_name = "class-stats"

                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("non_tcp_bytes_saved",
                                                "non_tcp_bytes_sent_rate",
                                                "non_tcp_compressed_packets_out",
                                                "non_tcp_full_header_packets_out",
                                                "non_tcp_total_out_bytes",
                                                "non_tcp_total_out_packets",
                                                "tcp_bytes_saved",
                                                "tcp_bytes_sent_rate",
                                                "tcp_compressed_packets_out",
                                                "tcp_full_header_packets_out",
                                                "tcp_total_out_bytes",
                                                "tcp_total_out_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.non_tcp_bytes_saved.is_set or
                                    self.non_tcp_bytes_sent_rate.is_set or
                                    self.non_tcp_compressed_packets_out.is_set or
                                    self.non_tcp_full_header_packets_out.is_set or
                                    self.non_tcp_total_out_bytes.is_set or
                                    self.non_tcp_total_out_packets.is_set or
                                    self.tcp_bytes_saved.is_set or
                                    self.tcp_bytes_sent_rate.is_set or
                                    self.tcp_compressed_packets_out.is_set or
                                    self.tcp_full_header_packets_out.is_set or
                                    self.tcp_total_out_bytes.is_set or
                                    self.tcp_total_out_packets.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "iphc-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "non-tcp-bytes-saved"):
                                    self.non_tcp_bytes_saved = value
                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-bytes-sent-rate"):
                                    self.non_tcp_bytes_sent_rate = value
                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-compressed-packets-out"):
                                    self.non_tcp_compressed_packets_out = value
                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-full-header-packets-out"):
                                    self.non_tcp_full_header_packets_out = value
                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-total-out-bytes"):
                                    self.non_tcp_total_out_bytes = value
                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-total-out-packets"):
                                    self.non_tcp_total_out_packets = value
                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-bytes-saved"):
                                    self.tcp_bytes_saved = value
                                    self.tcp_bytes_saved.value_namespace = name_space
                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-bytes-sent-rate"):
                                    self.tcp_bytes_sent_rate = value
                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-compressed-packets-out"):
                                    self.tcp_compressed_packets_out = value
                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-full-header-packets-out"):
                                    self.tcp_full_header_packets_out = value
                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-total-out-bytes"):
                                    self.tcp_total_out_bytes = value
                                    self.tcp_total_out_bytes.value_namespace = name_space
                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-total-out-packets"):
                                    self.tcp_total_out_packets = value
                                    self.tcp_total_out_packets.value_namespace = name_space
                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                        class ChildPolicy(Entity):
                            """
                            child policy
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                self.yang_name = "child-policy"
                                self.yang_parent_name = "class-stats"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "child-policy"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.general_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "child-policy" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix


                        class CacStats(Entity):
                            """
                            bag for cac stats
                            
                            .. attribute:: admit_bytes
                            
                            	Admitted bytes (pkts/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: admit_rates
                            
                            	CAC admit rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: admitpackets
                            
                            	Admitted packets (pkts/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: drop_bytes
                            
                            	CAC dropped bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: drop_packets
                            
                            	CAC dropped packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: drop_rates
                            
                            	CAC dropped rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.CacStats, self).__init__()

                                self.yang_name = "cac-stats"
                                self.yang_parent_name = "class-stats"

                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("admit_bytes",
                                                "admit_rates",
                                                "admitpackets",
                                                "drop_bytes",
                                                "drop_packets",
                                                "drop_rates") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.admit_bytes.is_set or
                                    self.admit_rates.is_set or
                                    self.admitpackets.is_set or
                                    self.drop_bytes.is_set or
                                    self.drop_packets.is_set or
                                    self.drop_rates.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.admit_bytes.yfilter != YFilter.not_set or
                                    self.admit_rates.yfilter != YFilter.not_set or
                                    self.admitpackets.yfilter != YFilter.not_set or
                                    self.drop_bytes.yfilter != YFilter.not_set or
                                    self.drop_packets.yfilter != YFilter.not_set or
                                    self.drop_rates.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "cac-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "admit-bytes"):
                                    self.admit_bytes = value
                                    self.admit_bytes.value_namespace = name_space
                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "admit-rates"):
                                    self.admit_rates = value
                                    self.admit_rates.value_namespace = name_space
                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                if(value_path == "admitpackets"):
                                    self.admitpackets = value
                                    self.admitpackets.value_namespace = name_space
                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-bytes"):
                                    self.drop_bytes = value
                                    self.drop_bytes.value_namespace = name_space
                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-packets"):
                                    self.drop_packets = value
                                    self.drop_packets.value_namespace = name_space
                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-rates"):
                                    self.drop_rates = value
                                    self.drop_rates.value_namespace = name_space
                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                        class QueueStatsArray(Entity):
                            """
                            array of queue stats
                            
                            .. attribute:: atm_clp0_drop_bytes
                            
                            	ATP CLP 0 matched bytes dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: atm_clp0_drop_packets
                            
                            	ATP CLP 0 matched packets dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: atm_clp1_drop_bytes
                            
                            	ATP CLP 0 matched bytes dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: atm_clp1_drop_packets
                            
                            	ATP CLP 0 matched packets dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: conform_bytes
                            
                            	Bytes that conform to the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: conform_packets
                            
                            	Packets that conform  to the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: conform_rate
                            
                            	Conform rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: exceed_bytes
                            
                            	Bytes that exceed  the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: exceed_packets
                            
                            	Packets that exceed the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: exceed_rate
                            
                            	Exceed rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: forced_wred_stats_display
                            
                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                            	**type**\:  bool
                            
                            .. attribute:: max_threshold_bytes
                            
                            	Dropped bytes with the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: max_threshold_packets
                            
                            	Dropped packets with the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: queue_average_length
                            
                            	Queue average length
                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                            
                            .. attribute:: queue_drop_threshold
                            
                            	tail drop threshold of the queue in bytes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: queue_id
                            
                            	Queue Id used for Fabric Stats
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: queue_instance_length
                            
                            	Queue instance length
                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                            
                            .. attribute:: queue_max_length
                            
                            	Queue maximum length
                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                            
                            .. attribute:: random_drop_bytes
                            
                            	Bytes probabilistically dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: random_drop_packets
                            
                            	Packets probabilistically dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tail_drop_bytes
                            
                            	Bytes tail dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: tail_drop_packets
                            
                            	Packets tail dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                self.yang_name = "queue-stats-array"
                                self.yang_parent_name = "class-stats"

                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                self.queue_average_length = YList(self)
                                self.queue_instance_length = YList(self)
                                self.queue_max_length = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("atm_clp0_drop_bytes",
                                                "atm_clp0_drop_packets",
                                                "atm_clp1_drop_bytes",
                                                "atm_clp1_drop_packets",
                                                "conform_bytes",
                                                "conform_packets",
                                                "conform_rate",
                                                "exceed_bytes",
                                                "exceed_packets",
                                                "exceed_rate",
                                                "forced_wred_stats_display",
                                                "max_threshold_bytes",
                                                "max_threshold_packets",
                                                "queue_drop_threshold",
                                                "queue_id",
                                                "random_drop_bytes",
                                                "random_drop_packets",
                                                "tail_drop_bytes",
                                                "tail_drop_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                            class QueueInstanceLength(Entity):
                                """
                                Queue instance length
                                
                                .. attribute:: unit
                                
                                	unit
                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                
                                .. attribute:: value
                                
                                	value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                    self.yang_name = "queue-instance-length"
                                    self.yang_parent_name = "queue-stats-array"

                                    self.unit = YLeaf(YType.enumeration, "unit")

                                    self.value = YLeaf(YType.uint32, "value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("unit",
                                                    "value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.unit.is_set or
                                        self.value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.unit.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "queue-instance-length" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "unit" or name == "value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "unit"):
                                        self.unit = value
                                        self.unit.value_namespace = name_space
                                        self.unit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix


                            class QueueAverageLength(Entity):
                                """
                                Queue average length
                                
                                .. attribute:: unit
                                
                                	unit
                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                
                                .. attribute:: value
                                
                                	value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                    self.yang_name = "queue-average-length"
                                    self.yang_parent_name = "queue-stats-array"

                                    self.unit = YLeaf(YType.enumeration, "unit")

                                    self.value = YLeaf(YType.uint32, "value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("unit",
                                                    "value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.unit.is_set or
                                        self.value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.unit.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "queue-average-length" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "unit" or name == "value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "unit"):
                                        self.unit = value
                                        self.unit.value_namespace = name_space
                                        self.unit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix


                            class QueueMaxLength(Entity):
                                """
                                Queue maximum length
                                
                                .. attribute:: unit
                                
                                	unit
                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                
                                .. attribute:: value
                                
                                	value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                    self.yang_name = "queue-max-length"
                                    self.yang_parent_name = "queue-stats-array"

                                    self.unit = YLeaf(YType.enumeration, "unit")

                                    self.value = YLeaf(YType.uint32, "value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("unit",
                                                    "value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.unit.is_set or
                                        self.value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.unit.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "queue-max-length" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "unit" or name == "value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "unit"):
                                        self.unit = value
                                        self.unit.value_namespace = name_space
                                        self.unit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.queue_average_length:
                                    if (c.has_data()):
                                        return True
                                for c in self.queue_instance_length:
                                    if (c.has_data()):
                                        return True
                                for c in self.queue_max_length:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.atm_clp0_drop_bytes.is_set or
                                    self.atm_clp0_drop_packets.is_set or
                                    self.atm_clp1_drop_bytes.is_set or
                                    self.atm_clp1_drop_packets.is_set or
                                    self.conform_bytes.is_set or
                                    self.conform_packets.is_set or
                                    self.conform_rate.is_set or
                                    self.exceed_bytes.is_set or
                                    self.exceed_packets.is_set or
                                    self.exceed_rate.is_set or
                                    self.forced_wred_stats_display.is_set or
                                    self.max_threshold_bytes.is_set or
                                    self.max_threshold_packets.is_set or
                                    self.queue_drop_threshold.is_set or
                                    self.queue_id.is_set or
                                    self.random_drop_bytes.is_set or
                                    self.random_drop_packets.is_set or
                                    self.tail_drop_bytes.is_set or
                                    self.tail_drop_packets.is_set)

                            def has_operation(self):
                                for c in self.queue_average_length:
                                    if (c.has_operation()):
                                        return True
                                for c in self.queue_instance_length:
                                    if (c.has_operation()):
                                        return True
                                for c in self.queue_max_length:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                    self.conform_bytes.yfilter != YFilter.not_set or
                                    self.conform_packets.yfilter != YFilter.not_set or
                                    self.conform_rate.yfilter != YFilter.not_set or
                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                    self.exceed_packets.yfilter != YFilter.not_set or
                                    self.exceed_rate.yfilter != YFilter.not_set or
                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                    self.queue_id.yfilter != YFilter.not_set or
                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "queue-stats-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "queue-average-length"):
                                    for c in self.queue_average_length:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.queue_average_length.append(c)
                                    return c

                                if (child_yang_name == "queue-instance-length"):
                                    for c in self.queue_instance_length:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.queue_instance_length.append(c)
                                    return c

                                if (child_yang_name == "queue-max-length"):
                                    for c in self.queue_max_length:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.queue_max_length.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "atm-clp0-drop-bytes"):
                                    self.atm_clp0_drop_bytes = value
                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "atm-clp0-drop-packets"):
                                    self.atm_clp0_drop_packets = value
                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "atm-clp1-drop-bytes"):
                                    self.atm_clp1_drop_bytes = value
                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "atm-clp1-drop-packets"):
                                    self.atm_clp1_drop_packets = value
                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-bytes"):
                                    self.conform_bytes = value
                                    self.conform_bytes.value_namespace = name_space
                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-packets"):
                                    self.conform_packets = value
                                    self.conform_packets.value_namespace = name_space
                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-rate"):
                                    self.conform_rate = value
                                    self.conform_rate.value_namespace = name_space
                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-bytes"):
                                    self.exceed_bytes = value
                                    self.exceed_bytes.value_namespace = name_space
                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-packets"):
                                    self.exceed_packets = value
                                    self.exceed_packets.value_namespace = name_space
                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-rate"):
                                    self.exceed_rate = value
                                    self.exceed_rate.value_namespace = name_space
                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "forced-wred-stats-display"):
                                    self.forced_wred_stats_display = value
                                    self.forced_wred_stats_display.value_namespace = name_space
                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-threshold-bytes"):
                                    self.max_threshold_bytes = value
                                    self.max_threshold_bytes.value_namespace = name_space
                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-threshold-packets"):
                                    self.max_threshold_packets = value
                                    self.max_threshold_packets.value_namespace = name_space
                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "queue-drop-threshold"):
                                    self.queue_drop_threshold = value
                                    self.queue_drop_threshold.value_namespace = name_space
                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                if(value_path == "queue-id"):
                                    self.queue_id = value
                                    self.queue_id.value_namespace = name_space
                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-bytes"):
                                    self.random_drop_bytes = value
                                    self.random_drop_bytes.value_namespace = name_space
                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-packets"):
                                    self.random_drop_packets = value
                                    self.random_drop_packets.value_namespace = name_space
                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "tail-drop-bytes"):
                                    self.tail_drop_bytes = value
                                    self.tail_drop_bytes.value_namespace = name_space
                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "tail-drop-packets"):
                                    self.tail_drop_packets = value
                                    self.tail_drop_packets.value_namespace = name_space
                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                        class PoliceStatsArray(Entity):
                            """
                            array of police stats
                            
                            .. attribute:: color_class_stats
                            
                            	color class stats
                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                            
                            .. attribute:: conform_bytes
                            
                            	Bytes that conform to the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: conform_packets
                            
                            	Packets that conform  to the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: conform_rate
                            
                            	Conform rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: drop_bytes
                            
                            	Police dropped bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: drop_packets
                            
                            	Police dropped packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: exceed_bytes
                            
                            	Bytes that exceed  the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: exceed_packets
                            
                            	Packets that exceed the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: exceed_rate
                            
                            	Exceed rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: parent_drop_bytes
                            
                            	Dropped bytes by the parent policer
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: parent_drop_packets
                            
                            	Dropped pkts by the parent policer
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: violate_bytes
                            
                            	Bytes that violate the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: violate_packets
                            
                            	Packets violating the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: violate_rate
                            
                            	Violate rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                self.yang_name = "police-stats-array"
                                self.yang_parent_name = "class-stats"

                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                self.color_class_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                self.color_class_stats.parent = self
                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                self._children_yang_names.add("color-class-stats")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("conform_bytes",
                                                "conform_packets",
                                                "conform_rate",
                                                "drop_bytes",
                                                "drop_packets",
                                                "exceed_bytes",
                                                "exceed_packets",
                                                "exceed_rate",
                                                "parent_drop_bytes",
                                                "parent_drop_packets",
                                                "violate_bytes",
                                                "violate_packets",
                                                "violate_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                            class ColorClassStats(Entity):
                                """
                                color class stats
                                
                                .. attribute:: conform_class_conform_bytes
                                
                                	Bytes with classification result conform and policer result conform
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: conform_class_conform_packets
                                
                                	Packets with classification result conform and policer result conform
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: conform_class_conform_rate
                                
                                	Conform Class Conform rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: conform_class_exceed_bytes
                                
                                	Bytes with classification result conform and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: conform_class_exceed_packets
                                
                                	Packets with classification result conform and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: conform_class_exceed_rate
                                
                                	Conform Class Exceed rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: conform_class_violate_bytes
                                
                                	Bytes with classification result conform and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: conform_class_violate_packets
                                
                                	Packets with classification result conform and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: conform_class_violate_rate
                                
                                	Conform Class Violate rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: exceed_class_exceed_bytes
                                
                                	Bytes with classification result exceed and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: exceed_class_exceed_packets
                                
                                	Packets with classification result exceed and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: exceed_class_exceed_rate
                                
                                	Exceed Class Exceed rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: exceed_class_violate_bytes
                                
                                	Bytes with classification result exceed and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: exceed_class_violate_packets
                                
                                	Packets with classification result exceed and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: exceed_class_violate_rate
                                
                                	Exceed Class Violate rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: violate_class_violate_bytes
                                
                                	Bytes with classification result violate and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: violate_class_violate_packets
                                
                                	Packets with classification result violate and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: violate_class_violate_rate
                                
                                	Violate Class Violate rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                    self.yang_name = "color-class-stats"
                                    self.yang_parent_name = "police-stats-array"

                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("conform_class_conform_bytes",
                                                    "conform_class_conform_packets",
                                                    "conform_class_conform_rate",
                                                    "conform_class_exceed_bytes",
                                                    "conform_class_exceed_packets",
                                                    "conform_class_exceed_rate",
                                                    "conform_class_violate_bytes",
                                                    "conform_class_violate_packets",
                                                    "conform_class_violate_rate",
                                                    "exceed_class_exceed_bytes",
                                                    "exceed_class_exceed_packets",
                                                    "exceed_class_exceed_rate",
                                                    "exceed_class_violate_bytes",
                                                    "exceed_class_violate_packets",
                                                    "exceed_class_violate_rate",
                                                    "violate_class_violate_bytes",
                                                    "violate_class_violate_packets",
                                                    "violate_class_violate_rate") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.conform_class_conform_bytes.is_set or
                                        self.conform_class_conform_packets.is_set or
                                        self.conform_class_conform_rate.is_set or
                                        self.conform_class_exceed_bytes.is_set or
                                        self.conform_class_exceed_packets.is_set or
                                        self.conform_class_exceed_rate.is_set or
                                        self.conform_class_violate_bytes.is_set or
                                        self.conform_class_violate_packets.is_set or
                                        self.conform_class_violate_rate.is_set or
                                        self.exceed_class_exceed_bytes.is_set or
                                        self.exceed_class_exceed_packets.is_set or
                                        self.exceed_class_exceed_rate.is_set or
                                        self.exceed_class_violate_bytes.is_set or
                                        self.exceed_class_violate_packets.is_set or
                                        self.exceed_class_violate_rate.is_set or
                                        self.violate_class_violate_bytes.is_set or
                                        self.violate_class_violate_packets.is_set or
                                        self.violate_class_violate_rate.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "color-class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "conform-class-conform-bytes"):
                                        self.conform_class_conform_bytes = value
                                        self.conform_class_conform_bytes.value_namespace = name_space
                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-conform-packets"):
                                        self.conform_class_conform_packets = value
                                        self.conform_class_conform_packets.value_namespace = name_space
                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-conform-rate"):
                                        self.conform_class_conform_rate = value
                                        self.conform_class_conform_rate.value_namespace = name_space
                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-exceed-bytes"):
                                        self.conform_class_exceed_bytes = value
                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-exceed-packets"):
                                        self.conform_class_exceed_packets = value
                                        self.conform_class_exceed_packets.value_namespace = name_space
                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-exceed-rate"):
                                        self.conform_class_exceed_rate = value
                                        self.conform_class_exceed_rate.value_namespace = name_space
                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-violate-bytes"):
                                        self.conform_class_violate_bytes = value
                                        self.conform_class_violate_bytes.value_namespace = name_space
                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-violate-packets"):
                                        self.conform_class_violate_packets = value
                                        self.conform_class_violate_packets.value_namespace = name_space
                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-violate-rate"):
                                        self.conform_class_violate_rate = value
                                        self.conform_class_violate_rate.value_namespace = name_space
                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-exceed-bytes"):
                                        self.exceed_class_exceed_bytes = value
                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-exceed-packets"):
                                        self.exceed_class_exceed_packets = value
                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-exceed-rate"):
                                        self.exceed_class_exceed_rate = value
                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-violate-bytes"):
                                        self.exceed_class_violate_bytes = value
                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-violate-packets"):
                                        self.exceed_class_violate_packets = value
                                        self.exceed_class_violate_packets.value_namespace = name_space
                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-violate-rate"):
                                        self.exceed_class_violate_rate = value
                                        self.exceed_class_violate_rate.value_namespace = name_space
                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "violate-class-violate-bytes"):
                                        self.violate_class_violate_bytes = value
                                        self.violate_class_violate_bytes.value_namespace = name_space
                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "violate-class-violate-packets"):
                                        self.violate_class_violate_packets = value
                                        self.violate_class_violate_packets.value_namespace = name_space
                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "violate-class-violate-rate"):
                                        self.violate_class_violate_rate = value
                                        self.violate_class_violate_rate.value_namespace = name_space
                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.conform_bytes.is_set or
                                    self.conform_packets.is_set or
                                    self.conform_rate.is_set or
                                    self.drop_bytes.is_set or
                                    self.drop_packets.is_set or
                                    self.exceed_bytes.is_set or
                                    self.exceed_packets.is_set or
                                    self.exceed_rate.is_set or
                                    self.parent_drop_bytes.is_set or
                                    self.parent_drop_packets.is_set or
                                    self.violate_bytes.is_set or
                                    self.violate_packets.is_set or
                                    self.violate_rate.is_set or
                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.conform_bytes.yfilter != YFilter.not_set or
                                    self.conform_packets.yfilter != YFilter.not_set or
                                    self.conform_rate.yfilter != YFilter.not_set or
                                    self.drop_bytes.yfilter != YFilter.not_set or
                                    self.drop_packets.yfilter != YFilter.not_set or
                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                    self.exceed_packets.yfilter != YFilter.not_set or
                                    self.exceed_rate.yfilter != YFilter.not_set or
                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                    self.violate_bytes.yfilter != YFilter.not_set or
                                    self.violate_packets.yfilter != YFilter.not_set or
                                    self.violate_rate.yfilter != YFilter.not_set or
                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "police-stats-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "color-class-stats"):
                                    if (self.color_class_stats is None):
                                        self.color_class_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                    return self.color_class_stats

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "conform-bytes"):
                                    self.conform_bytes = value
                                    self.conform_bytes.value_namespace = name_space
                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-packets"):
                                    self.conform_packets = value
                                    self.conform_packets.value_namespace = name_space
                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-rate"):
                                    self.conform_rate = value
                                    self.conform_rate.value_namespace = name_space
                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-bytes"):
                                    self.drop_bytes = value
                                    self.drop_bytes.value_namespace = name_space
                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-packets"):
                                    self.drop_packets = value
                                    self.drop_packets.value_namespace = name_space
                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-bytes"):
                                    self.exceed_bytes = value
                                    self.exceed_bytes.value_namespace = name_space
                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-packets"):
                                    self.exceed_packets = value
                                    self.exceed_packets.value_namespace = name_space
                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-rate"):
                                    self.exceed_rate = value
                                    self.exceed_rate.value_namespace = name_space
                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-drop-bytes"):
                                    self.parent_drop_bytes = value
                                    self.parent_drop_bytes.value_namespace = name_space
                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-drop-packets"):
                                    self.parent_drop_packets = value
                                    self.parent_drop_packets.value_namespace = name_space
                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "violate-bytes"):
                                    self.violate_bytes = value
                                    self.violate_bytes.value_namespace = name_space
                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "violate-packets"):
                                    self.violate_packets = value
                                    self.violate_packets.value_namespace = name_space
                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "violate-rate"):
                                    self.violate_rate = value
                                    self.violate_rate.value_namespace = name_space
                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                        class WredStatsArray(Entity):
                            """
                            array of red stats
                            
                            .. attribute:: max_threshold_bytes
                            
                            	Dropped bytes with  the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: max_threshold_packets
                            
                            	Dropped packets with  the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: profile_title
                            
                            	ProfileTitle
                            	**type**\:  str
                            
                            	**length:** 0..300
                            
                            .. attribute:: random_drop_bytes
                            
                            	Probabilisticallydropped bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: random_drop_packets
                            
                            	Probabilistically dropped  packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: red_ecn_marked_bytes
                            
                            	ECN marked bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: red_ecn_marked_packets
                            
                            	ECN marked packets 
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: red_label
                            
                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                            
                            .. attribute:: red_transmit_bytes
                            
                            	Transmitted bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: red_transmit_packets
                            
                            	Transmitted packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                self.yang_name = "wred-stats-array"
                                self.yang_parent_name = "class-stats"

                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                self.profile_title = YLeaf(YType.str, "profile-title")

                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                self.red_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("max_threshold_bytes",
                                                "max_threshold_packets",
                                                "profile_title",
                                                "random_drop_bytes",
                                                "random_drop_packets",
                                                "red_ecn_marked_bytes",
                                                "red_ecn_marked_packets",
                                                "red_transmit_bytes",
                                                "red_transmit_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                            class RedLabel(Entity):
                                """
                                Array of WRED Typevalues as in PRP stats is
                                available per threshold   
                                
                                .. attribute:: value
                                
                                	WRED value for this type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: wred_type
                                
                                	WRED type DSCP, EXP, PREC etc
                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                    self.yang_name = "red-label"
                                    self.yang_parent_name = "wred-stats-array"

                                    self.value = YLeaf(YType.uint8, "value")

                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("value",
                                                    "wred_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.value.is_set or
                                        self.wred_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set or
                                        self.wred_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "red-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())
                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "value" or name == "wred-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix
                                    if(value_path == "wred-type"):
                                        self.wred_type = value
                                        self.wred_type.value_namespace = name_space
                                        self.wred_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.red_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.max_threshold_bytes.is_set or
                                    self.max_threshold_packets.is_set or
                                    self.profile_title.is_set or
                                    self.random_drop_bytes.is_set or
                                    self.random_drop_packets.is_set or
                                    self.red_ecn_marked_bytes.is_set or
                                    self.red_ecn_marked_packets.is_set or
                                    self.red_transmit_bytes.is_set or
                                    self.red_transmit_packets.is_set)

                            def has_operation(self):
                                for c in self.red_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                    self.profile_title.yfilter != YFilter.not_set or
                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "wred-stats-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "red-label"):
                                    for c in self.red_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.red_label.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "max-threshold-bytes"):
                                    self.max_threshold_bytes = value
                                    self.max_threshold_bytes.value_namespace = name_space
                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-threshold-packets"):
                                    self.max_threshold_packets = value
                                    self.max_threshold_packets.value_namespace = name_space
                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "profile-title"):
                                    self.profile_title = value
                                    self.profile_title.value_namespace = name_space
                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-bytes"):
                                    self.random_drop_bytes = value
                                    self.random_drop_bytes.value_namespace = name_space
                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-packets"):
                                    self.random_drop_packets = value
                                    self.random_drop_packets.value_namespace = name_space
                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-ecn-marked-bytes"):
                                    self.red_ecn_marked_bytes = value
                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-ecn-marked-packets"):
                                    self.red_ecn_marked_packets = value
                                    self.red_ecn_marked_packets.value_namespace = name_space
                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-transmit-bytes"):
                                    self.red_transmit_bytes = value
                                    self.red_transmit_bytes.value_namespace = name_space
                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-transmit-packets"):
                                    self.red_transmit_packets = value
                                    self.red_transmit_packets.value_namespace = name_space
                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.police_stats_array:
                                if (c.has_data()):
                                    return True
                            for c in self.queue_stats_array:
                                if (c.has_data()):
                                    return True
                            for c in self.wred_stats_array:
                                if (c.has_data()):
                                    return True
                            return (
                                self.cac_state.is_set or
                                self.class_name.is_set or
                                self.counter_validity_bitmask.is_set or
                                self.queue_descr.is_set or
                                self.shared_queue_id.is_set or
                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                (self.child_policy is not None and self.child_policy.has_data()) or
                                (self.general_stats is not None and self.general_stats.has_data()) or
                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                        def has_operation(self):
                            for c in self.police_stats_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.queue_stats_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.wred_stats_array:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.cac_state.yfilter != YFilter.not_set or
                                self.class_name.yfilter != YFilter.not_set or
                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                self.queue_descr.yfilter != YFilter.not_set or
                                self.shared_queue_id.yfilter != YFilter.not_set or
                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                (self.child_policy is not None and self.child_policy.has_operation()) or
                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "class-stats" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.class_name.get_name_leafdata())
                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "cac-stats"):
                                if (self.cac_stats is None):
                                    self.cac_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                return self.cac_stats

                            if (child_yang_name == "child-policy"):
                                if (self.child_policy is None):
                                    self.child_policy = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                return self.child_policy

                            if (child_yang_name == "general-stats"):
                                if (self.general_stats is None):
                                    self.general_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                return self.general_stats

                            if (child_yang_name == "iphc-stats"):
                                if (self.iphc_stats is None):
                                    self.iphc_stats = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                return self.iphc_stats

                            if (child_yang_name == "police-stats-array"):
                                for c in self.police_stats_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.police_stats_array.append(c)
                                return c

                            if (child_yang_name == "queue-stats-array"):
                                for c in self.queue_stats_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.queue_stats_array.append(c)
                                return c

                            if (child_yang_name == "wred-stats-array"):
                                for c in self.wred_stats_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.wred_stats_array.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "cac-state"):
                                self.cac_state = value
                                self.cac_state.value_namespace = name_space
                                self.cac_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "class-name"):
                                self.class_name = value
                                self.class_name.value_namespace = name_space
                                self.class_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "counter-validity-bitmask"):
                                self.counter_validity_bitmask = value
                                self.counter_validity_bitmask.value_namespace = name_space
                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                            if(value_path == "queue-descr"):
                                self.queue_descr = value
                                self.queue_descr.value_namespace = name_space
                                self.queue_descr.value_namespace_prefix = name_space_prefix
                            if(value_path == "shared-queue-id"):
                                self.shared_queue_id = value
                                self.shared_queue_id.value_namespace = name_space
                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.class_stats:
                            if (c.has_data()):
                                return True
                        return (
                            self.policy_name.is_set or
                            self.satid.is_set or
                            self.state.is_set or
                            self.state_description.is_set)

                    def has_operation(self):
                        for c in self.class_stats:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.policy_name.yfilter != YFilter.not_set or
                            self.satid.yfilter != YFilter.not_set or
                            self.state.yfilter != YFilter.not_set or
                            self.state_description.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.satid.get_name_leafdata())
                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.state.get_name_leafdata())
                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.state_description.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "class-stats"):
                            for c in self.class_stats:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Qos.NvInterfaceTable.Interface.Output.Statistics.ClassStats()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.class_stats.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "policy-name"):
                            self.policy_name = value
                            self.policy_name.value_namespace = name_space
                            self.policy_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "satid"):
                            self.satid = value
                            self.satid.value_namespace = name_space
                            self.satid.value_namespace_prefix = name_space_prefix
                        if(value_path == "state"):
                            self.state = value
                            self.state.value_namespace = name_space
                            self.state.value_namespace_prefix = name_space_prefix
                        if(value_path == "state-description"):
                            self.state_description = value
                            self.state_description.value_namespace = name_space
                            self.state_description.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "output" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "service-policy-names"):
                        if (self.service_policy_names is None):
                            self.service_policy_names = Qos.NvInterfaceTable.Interface.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                        return self.service_policy_names

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = Qos.NvInterfaceTable.Interface.Output.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "service-policy-names" or name == "statistics"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (
                    self.interface_name.is_set or
                    (self.input is not None and self.input.has_data()) or
                    (self.member_interfaces is not None and self.member_interfaces.has_data()) or
                    (self.nodes is not None and self.nodes.has_data()) or
                    (self.output is not None and self.output.has_data()) or
                    (self.satellite_ids is not None and self.satellite_ids.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.interface_name.yfilter != YFilter.not_set or
                    (self.input is not None and self.input.has_operation()) or
                    (self.member_interfaces is not None and self.member_interfaces.has_operation()) or
                    (self.nodes is not None and self.nodes.has_operation()) or
                    (self.output is not None and self.output.has_operation()) or
                    (self.satellite_ids is not None and self.satellite_ids.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/nv-interface-table/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface_name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "input"):
                    if (self.input is None):
                        self.input = Qos.NvInterfaceTable.Interface.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"
                    return self.input

                if (child_yang_name == "member-interfaces"):
                    if (self.member_interfaces is None):
                        self.member_interfaces = Qos.NvInterfaceTable.Interface.MemberInterfaces()
                        self.member_interfaces.parent = self
                        self._children_name_map["member_interfaces"] = "member-interfaces"
                    return self.member_interfaces

                if (child_yang_name == "nodes"):
                    if (self.nodes is None):
                        self.nodes = Qos.NvInterfaceTable.Interface.Nodes()
                        self.nodes.parent = self
                        self._children_name_map["nodes"] = "nodes"
                    return self.nodes

                if (child_yang_name == "output"):
                    if (self.output is None):
                        self.output = Qos.NvInterfaceTable.Interface.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                    return self.output

                if (child_yang_name == "satellite-ids"):
                    if (self.satellite_ids is None):
                        self.satellite_ids = Qos.NvInterfaceTable.Interface.SatelliteIds()
                        self.satellite_ids.parent = self
                        self._children_name_map["satellite_ids"] = "satellite-ids"
                    return self.satellite_ids

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "input" or name == "member-interfaces" or name == "nodes" or name == "output" or name == "satellite-ids" or name == "interface-name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "interface-name"):
                    self.interface_name = value
                    self.interface_name.value_namespace = name_space
                    self.interface_name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.interface:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.interface:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "nv-interface-table" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "interface"):
                for c in self.interface:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = Qos.NvInterfaceTable.Interface()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.interface.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "interface"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class NvSatellite(Entity):
        """
        Satellite table
        
        .. attribute:: nv_satellite_statistics
        
        	Satellite statistics based on Satellite ID
        	**type**\:   :py:class:`NvSatelliteStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics>`
        
        .. attribute:: nv_satellite_status
        
        	Satellite QOS offload status based on Satellite ID
        	**type**\:   :py:class:`NvSatelliteStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus>`
        
        

        """

        _prefix = 'qos-ma-oper'
        _revision = '2017-04-10'

        def __init__(self):
            super(Qos.NvSatellite, self).__init__()

            self.yang_name = "nv-satellite"
            self.yang_parent_name = "qos"

            self.nv_satellite_statistics = Qos.NvSatellite.NvSatelliteStatistics()
            self.nv_satellite_statistics.parent = self
            self._children_name_map["nv_satellite_statistics"] = "nv-satellite-statistics"
            self._children_yang_names.add("nv-satellite-statistics")

            self.nv_satellite_status = Qos.NvSatellite.NvSatelliteStatus()
            self.nv_satellite_status.parent = self
            self._children_name_map["nv_satellite_status"] = "nv-satellite-status"
            self._children_yang_names.add("nv-satellite-status")


        class NvSatelliteStatistics(Entity):
            """
            Satellite statistics based on Satellite ID
            
            .. attribute:: nv_satellite_ids
            
            	Satellite ID table
            	**type**\:   :py:class:`NvSatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds>`
            
            

            """

            _prefix = 'qos-ma-oper'
            _revision = '2017-04-10'

            def __init__(self):
                super(Qos.NvSatellite.NvSatelliteStatistics, self).__init__()

                self.yang_name = "nv-satellite-statistics"
                self.yang_parent_name = "nv-satellite"

                self.nv_satellite_ids = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds()
                self.nv_satellite_ids.parent = self
                self._children_name_map["nv_satellite_ids"] = "nv-satellite-ids"
                self._children_yang_names.add("nv-satellite-ids")


            class NvSatelliteIds(Entity):
                """
                Satellite ID table
                
                .. attribute:: nv_satellite_id
                
                	Satellite ID information
                	**type**\: list of    :py:class:`NvSatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds, self).__init__()

                    self.yang_name = "nv-satellite-ids"
                    self.yang_parent_name = "nv-satellite-statistics"

                    self.nv_satellite_id = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds, self).__setattr__(name, value)


                class NvSatelliteId(Entity):
                    """
                    Satellite ID information
                    
                    .. attribute:: satellite_id  <key>
                    
                    	Satellite ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nv_satellite_interfaces
                    
                    	Operational data of satellite interface of a particular satellite
                    	**type**\:   :py:class:`NvSatelliteInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId, self).__init__()

                        self.yang_name = "nv-satellite-id"
                        self.yang_parent_name = "nv-satellite-ids"

                        self.satellite_id = YLeaf(YType.int32, "satellite-id")

                        self.nv_satellite_interfaces = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces()
                        self.nv_satellite_interfaces.parent = self
                        self._children_name_map["nv_satellite_interfaces"] = "nv-satellite-interfaces"
                        self._children_yang_names.add("nv-satellite-interfaces")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("satellite_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId, self).__setattr__(name, value)


                    class NvSatelliteInterfaces(Entity):
                        """
                        Operational data of satellite interface of a
                        particular satellite
                        
                        .. attribute:: nv_satellite_interface
                        
                        	Operational data for a particular satellite interface
                        	**type**\: list of    :py:class:`NvSatelliteInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces, self).__init__()

                            self.yang_name = "nv-satellite-interfaces"
                            self.yang_parent_name = "nv-satellite-id"

                            self.nv_satellite_interface = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces, self).__setattr__(name, value)


                        class NvSatelliteInterface(Entity):
                            """
                            Operational data for a particular satellite
                            interface
                            
                            .. attribute:: interface_name  <key>
                            
                            	Name of the interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: input
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input>`
                            
                            .. attribute:: member_interfaces
                            
                            	QoS policy\-map member interface table
                            	**type**\:   :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces>`
                            
                            .. attribute:: output
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface, self).__init__()

                                self.yang_name = "nv-satellite-interface"
                                self.yang_parent_name = "nv-satellite-interfaces"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.input = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"
                                self._children_yang_names.add("input")

                                self.member_interfaces = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces()
                                self.member_interfaces.parent = self
                                self._children_name_map["member_interfaces"] = "member-interfaces"
                                self._children_yang_names.add("member-interfaces")

                                self.output = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                                self._children_yang_names.add("output")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface, self).__setattr__(name, value)


                            class MemberInterfaces(Entity):
                                """
                                QoS policy\-map member interface table
                                
                                .. attribute:: member_interface
                                
                                	QoS policy\-map member interface statistics
                                	**type**\: list of    :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces, self).__init__()

                                    self.yang_name = "member-interfaces"
                                    self.yang_parent_name = "nv-satellite-interface"

                                    self.member_interface = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces, self).__setattr__(name, value)


                                class MemberInterface(Entity):
                                    """
                                    QoS policy\-map member interface statistics
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	Name of member interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: input
                                    
                                    	A piece of QoS policy\-map operational data for an interface
                                    	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input>`
                                    
                                    .. attribute:: output
                                    
                                    	A piece of QoS policy\-map operational data for an interface
                                    	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output>`
                                    
                                    .. attribute:: satellite_ids
                                    
                                    	Satellite ID information
                                    	**type**\:   :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface, self).__init__()

                                        self.yang_name = "member-interface"
                                        self.yang_parent_name = "member-interfaces"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.input = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input()
                                        self.input.parent = self
                                        self._children_name_map["input"] = "input"
                                        self._children_yang_names.add("input")

                                        self.output = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output()
                                        self.output.parent = self
                                        self._children_name_map["output"] = "output"
                                        self._children_yang_names.add("output")

                                        self.satellite_ids = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds()
                                        self.satellite_ids.parent = self
                                        self._children_name_map["satellite_ids"] = "satellite-ids"
                                        self._children_yang_names.add("satellite-ids")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface, self).__setattr__(name, value)


                                    class SatelliteIds(Entity):
                                        """
                                        Satellite ID information
                                        
                                        .. attribute:: satellite_id
                                        
                                        	Satellite ID information
                                        	**type**\: list of    :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds, self).__init__()

                                            self.yang_name = "satellite-ids"
                                            self.yang_parent_name = "member-interface"

                                            self.satellite_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds, self).__setattr__(name, value)


                                        class SatelliteId(Entity):
                                            """
                                            Satellite ID information
                                            
                                            .. attribute:: nv_satellite_id  <key>
                                            
                                            	Satellite ID
                                            	**type**\:  int
                                            
                                            	**range:** \-2147483648..2147483647
                                            
                                            .. attribute:: input
                                            
                                            	A piece of QoS policy\-map operational data for an interface
                                            	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input>`
                                            
                                            .. attribute:: output
                                            
                                            	A piece of QoS policy\-map operational data for an interface
                                            	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__init__()

                                                self.yang_name = "satellite-id"
                                                self.yang_parent_name = "satellite-ids"

                                                self.nv_satellite_id = YLeaf(YType.int32, "nv-satellite-id")

                                                self.input = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                                self.input.parent = self
                                                self._children_name_map["input"] = "input"
                                                self._children_yang_names.add("input")

                                                self.output = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                                self.output.parent = self
                                                self._children_name_map["output"] = "output"
                                                self._children_yang_names.add("output")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("nv_satellite_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__setattr__(name, value)


                                            class Input(Entity):
                                                """
                                                A piece of QoS policy\-map operational data for
                                                an interface
                                                
                                                .. attribute:: service_policy_names
                                                
                                                	Operational data for all Policy instance
                                                	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                                                
                                                .. attribute:: statistics
                                                
                                                	Policy\-map statistics operational data for an interface
                                                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, self).__init__()

                                                    self.yang_name = "input"
                                                    self.yang_parent_name = "satellite-id"

                                                    self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                                    self.service_policy_names.parent = self
                                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                                    self._children_yang_names.add("service-policy-names")

                                                    self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics()
                                                    self.statistics.parent = self
                                                    self._children_name_map["statistics"] = "statistics"
                                                    self._children_yang_names.add("statistics")


                                                class ServicePolicyNames(Entity):
                                                    """
                                                    Operational data for all Policy instance
                                                    
                                                    .. attribute:: service_policy_instance
                                                    
                                                    	QoS policy\-map operational data for a particular Policy 
                                                    	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                                        self.yang_name = "service-policy-names"
                                                        self.yang_parent_name = "input"

                                                        self.service_policy_instance = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in () and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)


                                                    class ServicePolicyInstance(Entity):
                                                        """
                                                        QoS policy\-map operational data for a
                                                        particular Policy 
                                                        
                                                        .. attribute:: service_policy_name  <key>
                                                        
                                                        	Name of the policy instance
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                            self.yang_name = "service-policy-instance"
                                                            self.yang_parent_name = "service-policy-names"

                                                            self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("service_policy_name") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return self.service_policy_name.is_set

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.service_policy_name.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "service-policy-name"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "service-policy-name"):
                                                                self.service_policy_name = value
                                                                self.service_policy_name.value_namespace = name_space
                                                                self.service_policy_name.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.service_policy_instance:
                                                            if (c.has_data()):
                                                                return True
                                                        return False

                                                    def has_operation(self):
                                                        for c in self.service_policy_instance:
                                                            if (c.has_operation()):
                                                                return True
                                                        return self.yfilter != YFilter.not_set

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "service-policy-names" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "service-policy-instance"):
                                                            for c in self.service_policy_instance:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.service_policy_instance.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "service-policy-instance"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass


                                                class Statistics(Entity):
                                                    """
                                                    Policy\-map statistics operational data for an
                                                    interface
                                                    
                                                    .. attribute:: class_stats
                                                    
                                                    	array of classes contained in policy
                                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats>`
                                                    
                                                    .. attribute:: policy_name
                                                    
                                                    	PolicyName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: satid
                                                    
                                                    	to maintain satellite id
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: state
                                                    
                                                    	State
                                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                    
                                                    .. attribute:: state_description
                                                    
                                                    	StateDescription
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..128
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__init__()

                                                        self.yang_name = "statistics"
                                                        self.yang_parent_name = "input"

                                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                                        self.satid = YLeaf(YType.uint32, "satid")

                                                        self.state = YLeaf(YType.enumeration, "state")

                                                        self.state_description = YLeaf(YType.str, "state-description")

                                                        self.class_stats = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("policy_name",
                                                                        "satid",
                                                                        "state",
                                                                        "state_description") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)


                                                    class ClassStats(Entity):
                                                        """
                                                        array of classes contained in policy
                                                        
                                                        .. attribute:: cac_state
                                                        
                                                        	CACState
                                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                        
                                                        .. attribute:: cac_stats
                                                        
                                                        	bag for cac stats
                                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats>`
                                                        
                                                        .. attribute:: child_policy
                                                        
                                                        	child policy
                                                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy>`
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	ClassName
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: counter_validity_bitmask
                                                        
                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: megabyte
                                                        
                                                        .. attribute:: general_stats
                                                        
                                                        	general stats
                                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats>`
                                                        
                                                        .. attribute:: iphc_stats
                                                        
                                                        	IPHC stats
                                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats>`
                                                        
                                                        .. attribute:: police_stats_array
                                                        
                                                        	array of police stats
                                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray>`
                                                        
                                                        .. attribute:: queue_descr
                                                        
                                                        	Description of queue for the class
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..256
                                                        
                                                        .. attribute:: queue_stats_array
                                                        
                                                        	array of queue stats
                                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray>`
                                                        
                                                        .. attribute:: shared_queue_id
                                                        
                                                        	q\-id of the  shared queue for this class
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: wred_stats_array
                                                        
                                                        	array of red stats
                                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__init__()

                                                            self.yang_name = "class-stats"
                                                            self.yang_parent_name = "statistics"

                                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                            self.class_name = YLeaf(YType.str, "class-name")

                                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                            self._children_yang_names.add("cac-stats")

                                                            self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                                            self.child_policy.parent = self
                                                            self._children_name_map["child_policy"] = "child-policy"
                                                            self._children_yang_names.add("child-policy")

                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"
                                                            self._children_yang_names.add("general-stats")

                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            self._children_yang_names.add("iphc-stats")

                                                            self.police_stats_array = YList(self)
                                                            self.queue_stats_array = YList(self)
                                                            self.wred_stats_array = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("cac_state",
                                                                            "class_name",
                                                                            "counter_validity_bitmask",
                                                                            "queue_descr",
                                                                            "shared_queue_id") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                                        class GeneralStats(Entity):
                                                            """
                                                            general stats
                                                            
                                                            .. attribute:: match_data_rate
                                                            
                                                            	Incoming matched data rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: pre_policy_matched_bytes
                                                            
                                                            	Matched bytes before applying policy
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: pre_policy_matched_packets
                                                            
                                                            	Matched pkts before applying policy
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: total_drop_bytes
                                                            
                                                            	Dropped bytes (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_packets
                                                            
                                                            	Dropped packets (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_rate
                                                            
                                                            	Total drop rate (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_transmit_rate
                                                            
                                                            	Total transmit rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: transmit_bytes
                                                            
                                                            	Transmitted bytes (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: transmit_packets
                                                            
                                                            	Transmitted packets (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                                                self.yang_name = "general-stats"
                                                                self.yang_parent_name = "class-stats"

                                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("match_data_rate",
                                                                                "pre_policy_matched_bytes",
                                                                                "pre_policy_matched_packets",
                                                                                "total_drop_bytes",
                                                                                "total_drop_packets",
                                                                                "total_drop_rate",
                                                                                "total_transmit_rate",
                                                                                "transmit_bytes",
                                                                                "transmit_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.match_data_rate.is_set or
                                                                    self.pre_policy_matched_bytes.is_set or
                                                                    self.pre_policy_matched_packets.is_set or
                                                                    self.total_drop_bytes.is_set or
                                                                    self.total_drop_packets.is_set or
                                                                    self.total_drop_rate.is_set or
                                                                    self.total_transmit_rate.is_set or
                                                                    self.transmit_bytes.is_set or
                                                                    self.transmit_packets.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "general-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "match-data-rate"):
                                                                    self.match_data_rate = value
                                                                    self.match_data_rate.value_namespace = name_space
                                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "pre-policy-matched-bytes"):
                                                                    self.pre_policy_matched_bytes = value
                                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "pre-policy-matched-packets"):
                                                                    self.pre_policy_matched_packets = value
                                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-drop-bytes"):
                                                                    self.total_drop_bytes = value
                                                                    self.total_drop_bytes.value_namespace = name_space
                                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-drop-packets"):
                                                                    self.total_drop_packets = value
                                                                    self.total_drop_packets.value_namespace = name_space
                                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-drop-rate"):
                                                                    self.total_drop_rate = value
                                                                    self.total_drop_rate.value_namespace = name_space
                                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-transmit-rate"):
                                                                    self.total_transmit_rate = value
                                                                    self.total_transmit_rate.value_namespace = name_space
                                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "transmit-bytes"):
                                                                    self.transmit_bytes = value
                                                                    self.transmit_bytes.value_namespace = name_space
                                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "transmit-packets"):
                                                                    self.transmit_packets = value
                                                                    self.transmit_packets.value_namespace = name_space
                                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                        class IphcStats(Entity):
                                                            """
                                                            IPHC stats
                                                            
                                                            .. attribute:: non_tcp_bytes_saved
                                                            
                                                            	Non Tcp Bytes saved due to compression
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                            
                                                            	Compressed Non Tcp Bytes sent rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_compressed_packets_out
                                                            
                                                            	Num of non tcp compressed pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_full_header_packets_out
                                                            
                                                            	Num of non tcp fullheader pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_total_out_bytes
                                                            
                                                            	TotalNum of Non Tcp Bytes sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_total_out_packets
                                                            
                                                            	TotalNum of Non tcp pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_bytes_saved
                                                            
                                                            	Tcp Bytes saved due to compression
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_bytes_sent_rate
                                                            
                                                            	Compressed Tcp Bytes sent rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_compressed_packets_out
                                                            
                                                            	Num of tcp compressed pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_full_header_packets_out
                                                            
                                                            	Num of tcp fullheader pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_bytes
                                                            
                                                            	TotalNum of Tcp Bytes sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_total_out_packets
                                                            
                                                            	Total Num of tcp pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                                                self.yang_name = "iphc-stats"
                                                                self.yang_parent_name = "class-stats"

                                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("non_tcp_bytes_saved",
                                                                                "non_tcp_bytes_sent_rate",
                                                                                "non_tcp_compressed_packets_out",
                                                                                "non_tcp_full_header_packets_out",
                                                                                "non_tcp_total_out_bytes",
                                                                                "non_tcp_total_out_packets",
                                                                                "tcp_bytes_saved",
                                                                                "tcp_bytes_sent_rate",
                                                                                "tcp_compressed_packets_out",
                                                                                "tcp_full_header_packets_out",
                                                                                "tcp_total_out_bytes",
                                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.non_tcp_bytes_saved.is_set or
                                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                                    self.non_tcp_compressed_packets_out.is_set or
                                                                    self.non_tcp_full_header_packets_out.is_set or
                                                                    self.non_tcp_total_out_bytes.is_set or
                                                                    self.non_tcp_total_out_packets.is_set or
                                                                    self.tcp_bytes_saved.is_set or
                                                                    self.tcp_bytes_sent_rate.is_set or
                                                                    self.tcp_compressed_packets_out.is_set or
                                                                    self.tcp_full_header_packets_out.is_set or
                                                                    self.tcp_total_out_bytes.is_set or
                                                                    self.tcp_total_out_packets.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "iphc-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "non-tcp-bytes-saved"):
                                                                    self.non_tcp_bytes_saved = value
                                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                                    self.non_tcp_bytes_sent_rate = value
                                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                                    self.non_tcp_compressed_packets_out = value
                                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                                    self.non_tcp_full_header_packets_out = value
                                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-total-out-bytes"):
                                                                    self.non_tcp_total_out_bytes = value
                                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-total-out-packets"):
                                                                    self.non_tcp_total_out_packets = value
                                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-bytes-saved"):
                                                                    self.tcp_bytes_saved = value
                                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-bytes-sent-rate"):
                                                                    self.tcp_bytes_sent_rate = value
                                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-compressed-packets-out"):
                                                                    self.tcp_compressed_packets_out = value
                                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-full-header-packets-out"):
                                                                    self.tcp_full_header_packets_out = value
                                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-total-out-bytes"):
                                                                    self.tcp_total_out_bytes = value
                                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-total-out-packets"):
                                                                    self.tcp_total_out_packets = value
                                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                        class ChildPolicy(Entity):
                                                            """
                                                            child policy
                                                            
                                                            .. attribute:: class_stats
                                                            
                                                            	array of classes contained in policy
                                                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                            
                                                            .. attribute:: policy_name
                                                            
                                                            	PolicyName
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: satid
                                                            
                                                            	to maintain satellite id
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: state
                                                            
                                                            	State
                                                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                            
                                                            .. attribute:: state_description
                                                            
                                                            	StateDescription
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..128
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                                self.yang_name = "child-policy"
                                                                self.yang_parent_name = "class-stats"

                                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                                self.satid = YLeaf(YType.uint32, "satid")

                                                                self.state = YLeaf(YType.enumeration, "state")

                                                                self.state_description = YLeaf(YType.str, "state-description")

                                                                self.class_stats = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("policy_name",
                                                                                "satid",
                                                                                "state",
                                                                                "state_description") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                            class ClassStats(Entity):
                                                                """
                                                                array of classes contained in policy
                                                                
                                                                .. attribute:: cac_state
                                                                
                                                                	CACState
                                                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                                
                                                                .. attribute:: cac_stats
                                                                
                                                                	bag for cac stats
                                                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                                
                                                                .. attribute:: class_name
                                                                
                                                                	ClassName
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: counter_validity_bitmask
                                                                
                                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: megabyte
                                                                
                                                                .. attribute:: general_stats
                                                                
                                                                	general stats
                                                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                                
                                                                .. attribute:: iphc_stats
                                                                
                                                                	IPHC stats
                                                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                                
                                                                .. attribute:: police_stats_array
                                                                
                                                                	array of police stats
                                                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                                
                                                                .. attribute:: queue_descr
                                                                
                                                                	Description of queue for the class
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..256
                                                                
                                                                .. attribute:: queue_stats_array
                                                                
                                                                	array of queue stats
                                                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                                
                                                                .. attribute:: shared_queue_id
                                                                
                                                                	q\-id of the  shared queue for this class
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: wred_stats_array
                                                                
                                                                	array of red stats
                                                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                                    self.yang_name = "class-stats"
                                                                    self.yang_parent_name = "child-policy"

                                                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                    self.cac_stats.parent = self
                                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                                    self._children_yang_names.add("cac-stats")

                                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                    self.general_stats.parent = self
                                                                    self._children_name_map["general_stats"] = "general-stats"
                                                                    self._children_yang_names.add("general-stats")

                                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                    self.iphc_stats.parent = self
                                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                    self._children_yang_names.add("iphc-stats")

                                                                    self.police_stats_array = YList(self)
                                                                    self.queue_stats_array = YList(self)
                                                                    self.wred_stats_array = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("cac_state",
                                                                                    "class_name",
                                                                                    "counter_validity_bitmask",
                                                                                    "queue_descr",
                                                                                    "shared_queue_id") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                                class GeneralStats(Entity):
                                                                    """
                                                                    general stats
                                                                    
                                                                    .. attribute:: match_data_rate
                                                                    
                                                                    	Incoming matched data rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: pre_policy_matched_bytes
                                                                    
                                                                    	Matched bytes before applying policy
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: pre_policy_matched_packets
                                                                    
                                                                    	Matched pkts before applying policy
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: total_drop_bytes
                                                                    
                                                                    	Dropped bytes (packets/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_packets
                                                                    
                                                                    	Dropped packets (packets/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_rate
                                                                    
                                                                    	Total drop rate (packets/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_transmit_rate
                                                                    
                                                                    	Total transmit rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: transmit_bytes
                                                                    
                                                                    	Transmitted bytes (packets/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: transmit_packets
                                                                    
                                                                    	Transmitted packets (packets/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                                        self.yang_name = "general-stats"
                                                                        self.yang_parent_name = "class-stats"

                                                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("match_data_rate",
                                                                                        "pre_policy_matched_bytes",
                                                                                        "pre_policy_matched_packets",
                                                                                        "total_drop_bytes",
                                                                                        "total_drop_packets",
                                                                                        "total_drop_rate",
                                                                                        "total_transmit_rate",
                                                                                        "transmit_bytes",
                                                                                        "transmit_packets") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.match_data_rate.is_set or
                                                                            self.pre_policy_matched_bytes.is_set or
                                                                            self.pre_policy_matched_packets.is_set or
                                                                            self.total_drop_bytes.is_set or
                                                                            self.total_drop_packets.is_set or
                                                                            self.total_drop_rate.is_set or
                                                                            self.total_transmit_rate.is_set or
                                                                            self.transmit_bytes.is_set or
                                                                            self.transmit_packets.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.match_data_rate.yfilter != YFilter.not_set or
                                                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                                                            self.transmit_packets.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "general-stats" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "match-data-rate"):
                                                                            self.match_data_rate = value
                                                                            self.match_data_rate.value_namespace = name_space
                                                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "pre-policy-matched-bytes"):
                                                                            self.pre_policy_matched_bytes = value
                                                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "pre-policy-matched-packets"):
                                                                            self.pre_policy_matched_packets = value
                                                                            self.pre_policy_matched_packets.value_namespace = name_space
                                                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "total-drop-bytes"):
                                                                            self.total_drop_bytes = value
                                                                            self.total_drop_bytes.value_namespace = name_space
                                                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "total-drop-packets"):
                                                                            self.total_drop_packets = value
                                                                            self.total_drop_packets.value_namespace = name_space
                                                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "total-drop-rate"):
                                                                            self.total_drop_rate = value
                                                                            self.total_drop_rate.value_namespace = name_space
                                                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "total-transmit-rate"):
                                                                            self.total_transmit_rate = value
                                                                            self.total_transmit_rate.value_namespace = name_space
                                                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "transmit-bytes"):
                                                                            self.transmit_bytes = value
                                                                            self.transmit_bytes.value_namespace = name_space
                                                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "transmit-packets"):
                                                                            self.transmit_packets = value
                                                                            self.transmit_packets.value_namespace = name_space
                                                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                                class IphcStats(Entity):
                                                                    """
                                                                    IPHC stats
                                                                    
                                                                    .. attribute:: non_tcp_bytes_saved
                                                                    
                                                                    	Non Tcp Bytes saved due to compression
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                                    
                                                                    	Compressed Non Tcp Bytes sent rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_compressed_packets_out
                                                                    
                                                                    	Num of non tcp compressed pkts sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: non_tcp_full_header_packets_out
                                                                    
                                                                    	Num of non tcp fullheader pkts sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: non_tcp_total_out_bytes
                                                                    
                                                                    	TotalNum of Non Tcp Bytes sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_total_out_packets
                                                                    
                                                                    	TotalNum of Non tcp pkts sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_bytes_saved
                                                                    
                                                                    	Tcp Bytes saved due to compression
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_bytes_sent_rate
                                                                    
                                                                    	Compressed Tcp Bytes sent rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_compressed_packets_out
                                                                    
                                                                    	Num of tcp compressed pkts sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_full_header_packets_out
                                                                    
                                                                    	Num of tcp fullheader pkts sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_total_out_bytes
                                                                    
                                                                    	TotalNum of Tcp Bytes sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_total_out_packets
                                                                    
                                                                    	Total Num of tcp pkts sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                                        self.yang_name = "iphc-stats"
                                                                        self.yang_parent_name = "class-stats"

                                                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("non_tcp_bytes_saved",
                                                                                        "non_tcp_bytes_sent_rate",
                                                                                        "non_tcp_compressed_packets_out",
                                                                                        "non_tcp_full_header_packets_out",
                                                                                        "non_tcp_total_out_bytes",
                                                                                        "non_tcp_total_out_packets",
                                                                                        "tcp_bytes_saved",
                                                                                        "tcp_bytes_sent_rate",
                                                                                        "tcp_compressed_packets_out",
                                                                                        "tcp_full_header_packets_out",
                                                                                        "tcp_total_out_bytes",
                                                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.non_tcp_bytes_saved.is_set or
                                                                            self.non_tcp_bytes_sent_rate.is_set or
                                                                            self.non_tcp_compressed_packets_out.is_set or
                                                                            self.non_tcp_full_header_packets_out.is_set or
                                                                            self.non_tcp_total_out_bytes.is_set or
                                                                            self.non_tcp_total_out_packets.is_set or
                                                                            self.tcp_bytes_saved.is_set or
                                                                            self.tcp_bytes_sent_rate.is_set or
                                                                            self.tcp_compressed_packets_out.is_set or
                                                                            self.tcp_full_header_packets_out.is_set or
                                                                            self.tcp_total_out_bytes.is_set or
                                                                            self.tcp_total_out_packets.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "iphc-stats" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "non-tcp-bytes-saved"):
                                                                            self.non_tcp_bytes_saved = value
                                                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                                                            self.non_tcp_bytes_sent_rate = value
                                                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "non-tcp-compressed-packets-out"):
                                                                            self.non_tcp_compressed_packets_out = value
                                                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "non-tcp-full-header-packets-out"):
                                                                            self.non_tcp_full_header_packets_out = value
                                                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "non-tcp-total-out-bytes"):
                                                                            self.non_tcp_total_out_bytes = value
                                                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "non-tcp-total-out-packets"):
                                                                            self.non_tcp_total_out_packets = value
                                                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tcp-bytes-saved"):
                                                                            self.tcp_bytes_saved = value
                                                                            self.tcp_bytes_saved.value_namespace = name_space
                                                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tcp-bytes-sent-rate"):
                                                                            self.tcp_bytes_sent_rate = value
                                                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tcp-compressed-packets-out"):
                                                                            self.tcp_compressed_packets_out = value
                                                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tcp-full-header-packets-out"):
                                                                            self.tcp_full_header_packets_out = value
                                                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tcp-total-out-bytes"):
                                                                            self.tcp_total_out_bytes = value
                                                                            self.tcp_total_out_bytes.value_namespace = name_space
                                                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tcp-total-out-packets"):
                                                                            self.tcp_total_out_packets = value
                                                                            self.tcp_total_out_packets.value_namespace = name_space
                                                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                                class CacStats(Entity):
                                                                    """
                                                                    bag for cac stats
                                                                    
                                                                    .. attribute:: admit_bytes
                                                                    
                                                                    	Admitted bytes (pkts/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: admit_rates
                                                                    
                                                                    	CAC admit rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: admitpackets
                                                                    
                                                                    	Admitted packets (pkts/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: drop_bytes
                                                                    
                                                                    	CAC dropped bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: drop_packets
                                                                    
                                                                    	CAC dropped packets
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: drop_rates
                                                                    
                                                                    	CAC dropped rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                                        self.yang_name = "cac-stats"
                                                                        self.yang_parent_name = "class-stats"

                                                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("admit_bytes",
                                                                                        "admit_rates",
                                                                                        "admitpackets",
                                                                                        "drop_bytes",
                                                                                        "drop_packets",
                                                                                        "drop_rates") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.admit_bytes.is_set or
                                                                            self.admit_rates.is_set or
                                                                            self.admitpackets.is_set or
                                                                            self.drop_bytes.is_set or
                                                                            self.drop_packets.is_set or
                                                                            self.drop_rates.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.admit_bytes.yfilter != YFilter.not_set or
                                                                            self.admit_rates.yfilter != YFilter.not_set or
                                                                            self.admitpackets.yfilter != YFilter.not_set or
                                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                                            self.drop_rates.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "cac-stats" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "admit-bytes"):
                                                                            self.admit_bytes = value
                                                                            self.admit_bytes.value_namespace = name_space
                                                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "admit-rates"):
                                                                            self.admit_rates = value
                                                                            self.admit_rates.value_namespace = name_space
                                                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "admitpackets"):
                                                                            self.admitpackets = value
                                                                            self.admitpackets.value_namespace = name_space
                                                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "drop-bytes"):
                                                                            self.drop_bytes = value
                                                                            self.drop_bytes.value_namespace = name_space
                                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "drop-packets"):
                                                                            self.drop_packets = value
                                                                            self.drop_packets.value_namespace = name_space
                                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "drop-rates"):
                                                                            self.drop_rates = value
                                                                            self.drop_rates.value_namespace = name_space
                                                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                                                class QueueStatsArray(Entity):
                                                                    """
                                                                    array of queue stats
                                                                    
                                                                    .. attribute:: atm_clp0_drop_bytes
                                                                    
                                                                    	ATP CLP 0 matched bytes dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: atm_clp0_drop_packets
                                                                    
                                                                    	ATP CLP 0 matched packets dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: atm_clp1_drop_bytes
                                                                    
                                                                    	ATP CLP 0 matched bytes dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: atm_clp1_drop_packets
                                                                    
                                                                    	ATP CLP 0 matched packets dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_bytes
                                                                    
                                                                    	Bytes that conform to the queue rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_packets
                                                                    
                                                                    	Packets that conform  to the queue rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_rate
                                                                    
                                                                    	Conform rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: exceed_bytes
                                                                    
                                                                    	Bytes that exceed  the queue rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_packets
                                                                    
                                                                    	Packets that exceed the queue rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_rate
                                                                    
                                                                    	Exceed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: forced_wred_stats_display
                                                                    
                                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: max_threshold_bytes
                                                                    
                                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: max_threshold_packets
                                                                    
                                                                    	Dropped packets with the average queue size at the max\-threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: queue_average_length
                                                                    
                                                                    	Queue average length
                                                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                                    
                                                                    .. attribute:: queue_drop_threshold
                                                                    
                                                                    	tail drop threshold of the queue in bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: queue_id
                                                                    
                                                                    	Queue Id used for Fabric Stats
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: queue_instance_length
                                                                    
                                                                    	Queue instance length
                                                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                                    
                                                                    .. attribute:: queue_max_length
                                                                    
                                                                    	Queue maximum length
                                                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                                    
                                                                    .. attribute:: random_drop_bytes
                                                                    
                                                                    	Bytes probabilistically dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: random_drop_packets
                                                                    
                                                                    	Packets probabilistically dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tail_drop_bytes
                                                                    
                                                                    	Bytes tail dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tail_drop_packets
                                                                    
                                                                    	Packets tail dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                                        self.yang_name = "queue-stats-array"
                                                                        self.yang_parent_name = "class-stats"

                                                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                                        self.queue_average_length = YList(self)
                                                                        self.queue_instance_length = YList(self)
                                                                        self.queue_max_length = YList(self)

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("atm_clp0_drop_bytes",
                                                                                        "atm_clp0_drop_packets",
                                                                                        "atm_clp1_drop_bytes",
                                                                                        "atm_clp1_drop_packets",
                                                                                        "conform_bytes",
                                                                                        "conform_packets",
                                                                                        "conform_rate",
                                                                                        "exceed_bytes",
                                                                                        "exceed_packets",
                                                                                        "exceed_rate",
                                                                                        "forced_wred_stats_display",
                                                                                        "max_threshold_bytes",
                                                                                        "max_threshold_packets",
                                                                                        "queue_drop_threshold",
                                                                                        "queue_id",
                                                                                        "random_drop_bytes",
                                                                                        "random_drop_packets",
                                                                                        "tail_drop_bytes",
                                                                                        "tail_drop_packets") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                                    class QueueInstanceLength(Entity):
                                                                        """
                                                                        Queue instance length
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-04-10'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                            self.yang_name = "queue-instance-length"
                                                                            self.yang_parent_name = "queue-stats-array"

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("unit",
                                                                                            "value") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.unit.is_set or
                                                                                self.value.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.unit.yfilter != YFilter.not_set or
                                                                                self.value.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "queue-instance-length" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "unit" or name == "value"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "unit"):
                                                                                self.unit = value
                                                                                self.unit.value_namespace = name_space
                                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "value"):
                                                                                self.value = value
                                                                                self.value.value_namespace = name_space
                                                                                self.value.value_namespace_prefix = name_space_prefix


                                                                    class QueueAverageLength(Entity):
                                                                        """
                                                                        Queue average length
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-04-10'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                            self.yang_name = "queue-average-length"
                                                                            self.yang_parent_name = "queue-stats-array"

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("unit",
                                                                                            "value") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.unit.is_set or
                                                                                self.value.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.unit.yfilter != YFilter.not_set or
                                                                                self.value.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "queue-average-length" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "unit" or name == "value"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "unit"):
                                                                                self.unit = value
                                                                                self.unit.value_namespace = name_space
                                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "value"):
                                                                                self.value = value
                                                                                self.value.value_namespace = name_space
                                                                                self.value.value_namespace_prefix = name_space_prefix


                                                                    class QueueMaxLength(Entity):
                                                                        """
                                                                        Queue maximum length
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-04-10'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                            self.yang_name = "queue-max-length"
                                                                            self.yang_parent_name = "queue-stats-array"

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("unit",
                                                                                            "value") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.unit.is_set or
                                                                                self.value.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.unit.yfilter != YFilter.not_set or
                                                                                self.value.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "queue-max-length" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "unit" or name == "value"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "unit"):
                                                                                self.unit = value
                                                                                self.unit.value_namespace = name_space
                                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "value"):
                                                                                self.value = value
                                                                                self.value.value_namespace = name_space
                                                                                self.value.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        for c in self.queue_average_length:
                                                                            if (c.has_data()):
                                                                                return True
                                                                        for c in self.queue_instance_length:
                                                                            if (c.has_data()):
                                                                                return True
                                                                        for c in self.queue_max_length:
                                                                            if (c.has_data()):
                                                                                return True
                                                                        return (
                                                                            self.atm_clp0_drop_bytes.is_set or
                                                                            self.atm_clp0_drop_packets.is_set or
                                                                            self.atm_clp1_drop_bytes.is_set or
                                                                            self.atm_clp1_drop_packets.is_set or
                                                                            self.conform_bytes.is_set or
                                                                            self.conform_packets.is_set or
                                                                            self.conform_rate.is_set or
                                                                            self.exceed_bytes.is_set or
                                                                            self.exceed_packets.is_set or
                                                                            self.exceed_rate.is_set or
                                                                            self.forced_wred_stats_display.is_set or
                                                                            self.max_threshold_bytes.is_set or
                                                                            self.max_threshold_packets.is_set or
                                                                            self.queue_drop_threshold.is_set or
                                                                            self.queue_id.is_set or
                                                                            self.random_drop_bytes.is_set or
                                                                            self.random_drop_packets.is_set or
                                                                            self.tail_drop_bytes.is_set or
                                                                            self.tail_drop_packets.is_set)

                                                                    def has_operation(self):
                                                                        for c in self.queue_average_length:
                                                                            if (c.has_operation()):
                                                                                return True
                                                                        for c in self.queue_instance_length:
                                                                            if (c.has_operation()):
                                                                                return True
                                                                        for c in self.queue_max_length:
                                                                            if (c.has_operation()):
                                                                                return True
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                            self.queue_id.yfilter != YFilter.not_set or
                                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-stats-array" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "queue-average-length"):
                                                                            for c in self.queue_average_length:
                                                                                segment = c.get_segment_path()
                                                                                if (segment_path == segment):
                                                                                    return c
                                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                            c.parent = self
                                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                                            self._local_refs[local_reference_key] = c
                                                                            self.queue_average_length.append(c)
                                                                            return c

                                                                        if (child_yang_name == "queue-instance-length"):
                                                                            for c in self.queue_instance_length:
                                                                                segment = c.get_segment_path()
                                                                                if (segment_path == segment):
                                                                                    return c
                                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                            c.parent = self
                                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                                            self._local_refs[local_reference_key] = c
                                                                            self.queue_instance_length.append(c)
                                                                            return c

                                                                        if (child_yang_name == "queue-max-length"):
                                                                            for c in self.queue_max_length:
                                                                                segment = c.get_segment_path()
                                                                                if (segment_path == segment):
                                                                                    return c
                                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                            c.parent = self
                                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                                            self._local_refs[local_reference_key] = c
                                                                            self.queue_max_length.append(c)
                                                                            return c

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "atm-clp0-drop-bytes"):
                                                                            self.atm_clp0_drop_bytes = value
                                                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "atm-clp0-drop-packets"):
                                                                            self.atm_clp0_drop_packets = value
                                                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "atm-clp1-drop-bytes"):
                                                                            self.atm_clp1_drop_bytes = value
                                                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "atm-clp1-drop-packets"):
                                                                            self.atm_clp1_drop_packets = value
                                                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-bytes"):
                                                                            self.conform_bytes = value
                                                                            self.conform_bytes.value_namespace = name_space
                                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-packets"):
                                                                            self.conform_packets = value
                                                                            self.conform_packets.value_namespace = name_space
                                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-rate"):
                                                                            self.conform_rate = value
                                                                            self.conform_rate.value_namespace = name_space
                                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-bytes"):
                                                                            self.exceed_bytes = value
                                                                            self.exceed_bytes.value_namespace = name_space
                                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-packets"):
                                                                            self.exceed_packets = value
                                                                            self.exceed_packets.value_namespace = name_space
                                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-rate"):
                                                                            self.exceed_rate = value
                                                                            self.exceed_rate.value_namespace = name_space
                                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "forced-wred-stats-display"):
                                                                            self.forced_wred_stats_display = value
                                                                            self.forced_wred_stats_display.value_namespace = name_space
                                                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "max-threshold-bytes"):
                                                                            self.max_threshold_bytes = value
                                                                            self.max_threshold_bytes.value_namespace = name_space
                                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "max-threshold-packets"):
                                                                            self.max_threshold_packets = value
                                                                            self.max_threshold_packets.value_namespace = name_space
                                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "queue-drop-threshold"):
                                                                            self.queue_drop_threshold = value
                                                                            self.queue_drop_threshold.value_namespace = name_space
                                                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "queue-id"):
                                                                            self.queue_id = value
                                                                            self.queue_id.value_namespace = name_space
                                                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "random-drop-bytes"):
                                                                            self.random_drop_bytes = value
                                                                            self.random_drop_bytes.value_namespace = name_space
                                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "random-drop-packets"):
                                                                            self.random_drop_packets = value
                                                                            self.random_drop_packets.value_namespace = name_space
                                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tail-drop-bytes"):
                                                                            self.tail_drop_bytes = value
                                                                            self.tail_drop_bytes.value_namespace = name_space
                                                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tail-drop-packets"):
                                                                            self.tail_drop_packets = value
                                                                            self.tail_drop_packets.value_namespace = name_space
                                                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                                class PoliceStatsArray(Entity):
                                                                    """
                                                                    array of police stats
                                                                    
                                                                    .. attribute:: color_class_stats
                                                                    
                                                                    	color class stats
                                                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                                    
                                                                    .. attribute:: conform_bytes
                                                                    
                                                                    	Bytes that conform to the policed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_packets
                                                                    
                                                                    	Packets that conform  to the policed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_rate
                                                                    
                                                                    	Conform rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: drop_bytes
                                                                    
                                                                    	Police dropped bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: drop_packets
                                                                    
                                                                    	Police dropped packets
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_bytes
                                                                    
                                                                    	Bytes that exceed  the policed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_packets
                                                                    
                                                                    	Packets that exceed the policed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_rate
                                                                    
                                                                    	Exceed rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: parent_drop_bytes
                                                                    
                                                                    	Dropped bytes by the parent policer
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: parent_drop_packets
                                                                    
                                                                    	Dropped pkts by the parent policer
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_bytes
                                                                    
                                                                    	Bytes that violate the policed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_packets
                                                                    
                                                                    	Packets violating the policed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_rate
                                                                    
                                                                    	Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                                        self.yang_name = "police-stats-array"
                                                                        self.yang_parent_name = "class-stats"

                                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                        self.color_class_stats.parent = self
                                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                        self._children_yang_names.add("color-class-stats")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("conform_bytes",
                                                                                        "conform_packets",
                                                                                        "conform_rate",
                                                                                        "drop_bytes",
                                                                                        "drop_packets",
                                                                                        "exceed_bytes",
                                                                                        "exceed_packets",
                                                                                        "exceed_rate",
                                                                                        "parent_drop_bytes",
                                                                                        "parent_drop_packets",
                                                                                        "violate_bytes",
                                                                                        "violate_packets",
                                                                                        "violate_rate") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                                    class ColorClassStats(Entity):
                                                                        """
                                                                        color class stats
                                                                        
                                                                        .. attribute:: conform_class_conform_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result conform
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_conform_packets
                                                                        
                                                                        	Packets with classification result conform and policer result conform
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_conform_rate
                                                                        
                                                                        	Conform Class Conform rate in kbps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: conform_class_exceed_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result exceed
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_exceed_packets
                                                                        
                                                                        	Packets with classification result conform and policer result exceed
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_exceed_rate
                                                                        
                                                                        	Conform Class Exceed rate in kbps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: conform_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result violate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_violate_packets
                                                                        
                                                                        	Packets with classification result conform and policer result violate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_violate_rate
                                                                        
                                                                        	Conform Class Violate rate in kbps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_class_exceed_bytes
                                                                        
                                                                        	Bytes with classification result exceed and policer result exceed
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_class_exceed_packets
                                                                        
                                                                        	Packets with classification result exceed and policer result exceed
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_class_exceed_rate
                                                                        
                                                                        	Exceed Class Exceed rate in kbps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result exceed and policer result violate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_class_violate_packets
                                                                        
                                                                        	Packets with classification result exceed and policer result violate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_class_violate_rate
                                                                        
                                                                        	Exceed Class Violate rate in kbps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: violate_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result violate and policer result violate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: violate_class_violate_packets
                                                                        
                                                                        	Packets with classification result violate and policer result violate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: violate_class_violate_rate
                                                                        
                                                                        	Violate Class Violate rate in kbps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-04-10'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                            self.yang_name = "color-class-stats"
                                                                            self.yang_parent_name = "police-stats-array"

                                                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("conform_class_conform_bytes",
                                                                                            "conform_class_conform_packets",
                                                                                            "conform_class_conform_rate",
                                                                                            "conform_class_exceed_bytes",
                                                                                            "conform_class_exceed_packets",
                                                                                            "conform_class_exceed_rate",
                                                                                            "conform_class_violate_bytes",
                                                                                            "conform_class_violate_packets",
                                                                                            "conform_class_violate_rate",
                                                                                            "exceed_class_exceed_bytes",
                                                                                            "exceed_class_exceed_packets",
                                                                                            "exceed_class_exceed_rate",
                                                                                            "exceed_class_violate_bytes",
                                                                                            "exceed_class_violate_packets",
                                                                                            "exceed_class_violate_rate",
                                                                                            "violate_class_violate_bytes",
                                                                                            "violate_class_violate_packets",
                                                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.conform_class_conform_bytes.is_set or
                                                                                self.conform_class_conform_packets.is_set or
                                                                                self.conform_class_conform_rate.is_set or
                                                                                self.conform_class_exceed_bytes.is_set or
                                                                                self.conform_class_exceed_packets.is_set or
                                                                                self.conform_class_exceed_rate.is_set or
                                                                                self.conform_class_violate_bytes.is_set or
                                                                                self.conform_class_violate_packets.is_set or
                                                                                self.conform_class_violate_rate.is_set or
                                                                                self.exceed_class_exceed_bytes.is_set or
                                                                                self.exceed_class_exceed_packets.is_set or
                                                                                self.exceed_class_exceed_rate.is_set or
                                                                                self.exceed_class_violate_bytes.is_set or
                                                                                self.exceed_class_violate_packets.is_set or
                                                                                self.exceed_class_violate_rate.is_set or
                                                                                self.violate_class_violate_bytes.is_set or
                                                                                self.violate_class_violate_packets.is_set or
                                                                                self.violate_class_violate_rate.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "color-class-stats" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "conform-class-conform-bytes"):
                                                                                self.conform_class_conform_bytes = value
                                                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-conform-packets"):
                                                                                self.conform_class_conform_packets = value
                                                                                self.conform_class_conform_packets.value_namespace = name_space
                                                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-conform-rate"):
                                                                                self.conform_class_conform_rate = value
                                                                                self.conform_class_conform_rate.value_namespace = name_space
                                                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-exceed-bytes"):
                                                                                self.conform_class_exceed_bytes = value
                                                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-exceed-packets"):
                                                                                self.conform_class_exceed_packets = value
                                                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-exceed-rate"):
                                                                                self.conform_class_exceed_rate = value
                                                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-violate-bytes"):
                                                                                self.conform_class_violate_bytes = value
                                                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-violate-packets"):
                                                                                self.conform_class_violate_packets = value
                                                                                self.conform_class_violate_packets.value_namespace = name_space
                                                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-violate-rate"):
                                                                                self.conform_class_violate_rate = value
                                                                                self.conform_class_violate_rate.value_namespace = name_space
                                                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "exceed-class-exceed-bytes"):
                                                                                self.exceed_class_exceed_bytes = value
                                                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "exceed-class-exceed-packets"):
                                                                                self.exceed_class_exceed_packets = value
                                                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "exceed-class-exceed-rate"):
                                                                                self.exceed_class_exceed_rate = value
                                                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "exceed-class-violate-bytes"):
                                                                                self.exceed_class_violate_bytes = value
                                                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "exceed-class-violate-packets"):
                                                                                self.exceed_class_violate_packets = value
                                                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "exceed-class-violate-rate"):
                                                                                self.exceed_class_violate_rate = value
                                                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "violate-class-violate-bytes"):
                                                                                self.violate_class_violate_bytes = value
                                                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "violate-class-violate-packets"):
                                                                                self.violate_class_violate_packets = value
                                                                                self.violate_class_violate_packets.value_namespace = name_space
                                                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "violate-class-violate-rate"):
                                                                                self.violate_class_violate_rate = value
                                                                                self.violate_class_violate_rate.value_namespace = name_space
                                                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        return (
                                                                            self.conform_bytes.is_set or
                                                                            self.conform_packets.is_set or
                                                                            self.conform_rate.is_set or
                                                                            self.drop_bytes.is_set or
                                                                            self.drop_packets.is_set or
                                                                            self.exceed_bytes.is_set or
                                                                            self.exceed_packets.is_set or
                                                                            self.exceed_rate.is_set or
                                                                            self.parent_drop_bytes.is_set or
                                                                            self.parent_drop_packets.is_set or
                                                                            self.violate_bytes.is_set or
                                                                            self.violate_packets.is_set or
                                                                            self.violate_rate.is_set or
                                                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                            self.violate_bytes.yfilter != YFilter.not_set or
                                                                            self.violate_packets.yfilter != YFilter.not_set or
                                                                            self.violate_rate.yfilter != YFilter.not_set or
                                                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "police-stats-array" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "color-class-stats"):
                                                                            if (self.color_class_stats is None):
                                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                                self.color_class_stats.parent = self
                                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                            return self.color_class_stats

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "conform-bytes"):
                                                                            self.conform_bytes = value
                                                                            self.conform_bytes.value_namespace = name_space
                                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-packets"):
                                                                            self.conform_packets = value
                                                                            self.conform_packets.value_namespace = name_space
                                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-rate"):
                                                                            self.conform_rate = value
                                                                            self.conform_rate.value_namespace = name_space
                                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "drop-bytes"):
                                                                            self.drop_bytes = value
                                                                            self.drop_bytes.value_namespace = name_space
                                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "drop-packets"):
                                                                            self.drop_packets = value
                                                                            self.drop_packets.value_namespace = name_space
                                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-bytes"):
                                                                            self.exceed_bytes = value
                                                                            self.exceed_bytes.value_namespace = name_space
                                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-packets"):
                                                                            self.exceed_packets = value
                                                                            self.exceed_packets.value_namespace = name_space
                                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-rate"):
                                                                            self.exceed_rate = value
                                                                            self.exceed_rate.value_namespace = name_space
                                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "parent-drop-bytes"):
                                                                            self.parent_drop_bytes = value
                                                                            self.parent_drop_bytes.value_namespace = name_space
                                                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "parent-drop-packets"):
                                                                            self.parent_drop_packets = value
                                                                            self.parent_drop_packets.value_namespace = name_space
                                                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-bytes"):
                                                                            self.violate_bytes = value
                                                                            self.violate_bytes.value_namespace = name_space
                                                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-packets"):
                                                                            self.violate_packets = value
                                                                            self.violate_packets.value_namespace = name_space
                                                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-rate"):
                                                                            self.violate_rate = value
                                                                            self.violate_rate.value_namespace = name_space
                                                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                                                class WredStatsArray(Entity):
                                                                    """
                                                                    array of red stats
                                                                    
                                                                    .. attribute:: max_threshold_bytes
                                                                    
                                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: max_threshold_packets
                                                                    
                                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: profile_title
                                                                    
                                                                    	ProfileTitle
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..300
                                                                    
                                                                    .. attribute:: random_drop_bytes
                                                                    
                                                                    	Probabilisticallydropped bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: random_drop_packets
                                                                    
                                                                    	Probabilistically dropped  packets
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: red_ecn_marked_bytes
                                                                    
                                                                    	ECN marked bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: red_ecn_marked_packets
                                                                    
                                                                    	ECN marked packets 
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: red_label
                                                                    
                                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                                    
                                                                    .. attribute:: red_transmit_bytes
                                                                    
                                                                    	Transmitted bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: red_transmit_packets
                                                                    
                                                                    	Transmitted packets
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                                        self.yang_name = "wred-stats-array"
                                                                        self.yang_parent_name = "class-stats"

                                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                                        self.red_label = YList(self)

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("max_threshold_bytes",
                                                                                        "max_threshold_packets",
                                                                                        "profile_title",
                                                                                        "random_drop_bytes",
                                                                                        "random_drop_packets",
                                                                                        "red_ecn_marked_bytes",
                                                                                        "red_ecn_marked_packets",
                                                                                        "red_transmit_bytes",
                                                                                        "red_transmit_packets") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                                    class RedLabel(Entity):
                                                                        """
                                                                        Array of WRED Typevalues as in PRP stats is
                                                                        available per threshold   
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	WRED value for this type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: wred_type
                                                                        
                                                                        	WRED type DSCP, EXP, PREC etc
                                                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-04-10'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                            self.yang_name = "red-label"
                                                                            self.yang_parent_name = "wred-stats-array"

                                                                            self.value = YLeaf(YType.uint8, "value")

                                                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("value",
                                                                                            "wred_type") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.value.is_set or
                                                                                self.wred_type.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.value.yfilter != YFilter.not_set or
                                                                                self.wred_type.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "red-label" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.value.get_name_leafdata())
                                                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "value" or name == "wred-type"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "value"):
                                                                                self.value = value
                                                                                self.value.value_namespace = name_space
                                                                                self.value.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "wred-type"):
                                                                                self.wred_type = value
                                                                                self.wred_type.value_namespace = name_space
                                                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        for c in self.red_label:
                                                                            if (c.has_data()):
                                                                                return True
                                                                        return (
                                                                            self.max_threshold_bytes.is_set or
                                                                            self.max_threshold_packets.is_set or
                                                                            self.profile_title.is_set or
                                                                            self.random_drop_bytes.is_set or
                                                                            self.random_drop_packets.is_set or
                                                                            self.red_ecn_marked_bytes.is_set or
                                                                            self.red_ecn_marked_packets.is_set or
                                                                            self.red_transmit_bytes.is_set or
                                                                            self.red_transmit_packets.is_set)

                                                                    def has_operation(self):
                                                                        for c in self.red_label:
                                                                            if (c.has_operation()):
                                                                                return True
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                            self.profile_title.yfilter != YFilter.not_set or
                                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "wred-stats-array" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "red-label"):
                                                                            for c in self.red_label:
                                                                                segment = c.get_segment_path()
                                                                                if (segment_path == segment):
                                                                                    return c
                                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                            c.parent = self
                                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                                            self._local_refs[local_reference_key] = c
                                                                            self.red_label.append(c)
                                                                            return c

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "max-threshold-bytes"):
                                                                            self.max_threshold_bytes = value
                                                                            self.max_threshold_bytes.value_namespace = name_space
                                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "max-threshold-packets"):
                                                                            self.max_threshold_packets = value
                                                                            self.max_threshold_packets.value_namespace = name_space
                                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "profile-title"):
                                                                            self.profile_title = value
                                                                            self.profile_title.value_namespace = name_space
                                                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "random-drop-bytes"):
                                                                            self.random_drop_bytes = value
                                                                            self.random_drop_bytes.value_namespace = name_space
                                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "random-drop-packets"):
                                                                            self.random_drop_packets = value
                                                                            self.random_drop_packets.value_namespace = name_space
                                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "red-ecn-marked-bytes"):
                                                                            self.red_ecn_marked_bytes = value
                                                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "red-ecn-marked-packets"):
                                                                            self.red_ecn_marked_packets = value
                                                                            self.red_ecn_marked_packets.value_namespace = name_space
                                                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "red-transmit-bytes"):
                                                                            self.red_transmit_bytes = value
                                                                            self.red_transmit_bytes.value_namespace = name_space
                                                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "red-transmit-packets"):
                                                                            self.red_transmit_packets = value
                                                                            self.red_transmit_packets.value_namespace = name_space
                                                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.police_stats_array:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    for c in self.queue_stats_array:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    for c in self.wred_stats_array:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return (
                                                                        self.cac_state.is_set or
                                                                        self.class_name.is_set or
                                                                        self.counter_validity_bitmask.is_set or
                                                                        self.queue_descr.is_set or
                                                                        self.shared_queue_id.is_set or
                                                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                                def has_operation(self):
                                                                    for c in self.police_stats_array:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    for c in self.queue_stats_array:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    for c in self.wred_stats_array:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.cac_state.yfilter != YFilter.not_set or
                                                                        self.class_name.yfilter != YFilter.not_set or
                                                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                                        self.queue_descr.yfilter != YFilter.not_set or
                                                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "class-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "cac-stats"):
                                                                        if (self.cac_stats is None):
                                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                            self.cac_stats.parent = self
                                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                                        return self.cac_stats

                                                                    if (child_yang_name == "general-stats"):
                                                                        if (self.general_stats is None):
                                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                            self.general_stats.parent = self
                                                                            self._children_name_map["general_stats"] = "general-stats"
                                                                        return self.general_stats

                                                                    if (child_yang_name == "iphc-stats"):
                                                                        if (self.iphc_stats is None):
                                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                            self.iphc_stats.parent = self
                                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                        return self.iphc_stats

                                                                    if (child_yang_name == "police-stats-array"):
                                                                        for c in self.police_stats_array:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.police_stats_array.append(c)
                                                                        return c

                                                                    if (child_yang_name == "queue-stats-array"):
                                                                        for c in self.queue_stats_array:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_stats_array.append(c)
                                                                        return c

                                                                    if (child_yang_name == "wred-stats-array"):
                                                                        for c in self.wred_stats_array:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.wred_stats_array.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "cac-state"):
                                                                        self.cac_state = value
                                                                        self.cac_state.value_namespace = name_space
                                                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "class-name"):
                                                                        self.class_name = value
                                                                        self.class_name.value_namespace = name_space
                                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "counter-validity-bitmask"):
                                                                        self.counter_validity_bitmask = value
                                                                        self.counter_validity_bitmask.value_namespace = name_space
                                                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "queue-descr"):
                                                                        self.queue_descr = value
                                                                        self.queue_descr.value_namespace = name_space
                                                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "shared-queue-id"):
                                                                        self.shared_queue_id = value
                                                                        self.shared_queue_id.value_namespace = name_space
                                                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.class_stats:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.policy_name.is_set or
                                                                    self.satid.is_set or
                                                                    self.state.is_set or
                                                                    self.state_description.is_set)

                                                            def has_operation(self):
                                                                for c in self.class_stats:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.policy_name.yfilter != YFilter.not_set or
                                                                    self.satid.yfilter != YFilter.not_set or
                                                                    self.state.yfilter != YFilter.not_set or
                                                                    self.state_description.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "child-policy" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.state.get_name_leafdata())
                                                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "class-stats"):
                                                                    for c in self.class_stats:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.class_stats.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "policy-name"):
                                                                    self.policy_name = value
                                                                    self.policy_name.value_namespace = name_space
                                                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "satid"):
                                                                    self.satid = value
                                                                    self.satid.value_namespace = name_space
                                                                    self.satid.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "state"):
                                                                    self.state = value
                                                                    self.state.value_namespace = name_space
                                                                    self.state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "state-description"):
                                                                    self.state_description = value
                                                                    self.state_description.value_namespace = name_space
                                                                    self.state_description.value_namespace_prefix = name_space_prefix


                                                        class CacStats(Entity):
                                                            """
                                                            bag for cac stats
                                                            
                                                            .. attribute:: admit_bytes
                                                            
                                                            	Admitted bytes (pkts/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_rates
                                                            
                                                            	CAC admit rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: admitpackets
                                                            
                                                            	Admitted packets (pkts/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	CAC dropped bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	CAC dropped packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_rates
                                                            
                                                            	CAC dropped rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__init__()

                                                                self.yang_name = "cac-stats"
                                                                self.yang_parent_name = "class-stats"

                                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("admit_bytes",
                                                                                "admit_rates",
                                                                                "admitpackets",
                                                                                "drop_bytes",
                                                                                "drop_packets",
                                                                                "drop_rates") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.admit_bytes.is_set or
                                                                    self.admit_rates.is_set or
                                                                    self.admitpackets.is_set or
                                                                    self.drop_bytes.is_set or
                                                                    self.drop_packets.is_set or
                                                                    self.drop_rates.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                                    self.drop_rates.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "cac-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "admit-bytes"):
                                                                    self.admit_bytes = value
                                                                    self.admit_bytes.value_namespace = name_space
                                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "admit-rates"):
                                                                    self.admit_rates = value
                                                                    self.admit_rates.value_namespace = name_space
                                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "admitpackets"):
                                                                    self.admitpackets = value
                                                                    self.admitpackets.value_namespace = name_space
                                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-bytes"):
                                                                    self.drop_bytes = value
                                                                    self.drop_bytes.value_namespace = name_space
                                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-packets"):
                                                                    self.drop_packets = value
                                                                    self.drop_packets.value_namespace = name_space
                                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-rates"):
                                                                    self.drop_rates = value
                                                                    self.drop_rates.value_namespace = name_space
                                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                                        class QueueStatsArray(Entity):
                                                            """
                                                            array of queue stats
                                                            
                                                            .. attribute:: atm_clp0_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp0_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp1_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp1_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: forced_wred_stats_display
                                                            
                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: queue_average_length
                                                            
                                                            	Queue average length
                                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                            
                                                            .. attribute:: queue_drop_threshold
                                                            
                                                            	tail drop threshold of the queue in bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: queue_id
                                                            
                                                            	Queue Id used for Fabric Stats
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_instance_length
                                                            
                                                            	Queue instance length
                                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                            
                                                            .. attribute:: queue_max_length
                                                            
                                                            	Queue maximum length
                                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Bytes probabilistically dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Packets probabilistically dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tail_drop_bytes
                                                            
                                                            	Bytes tail dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tail_drop_packets
                                                            
                                                            	Packets tail dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                                self.yang_name = "queue-stats-array"
                                                                self.yang_parent_name = "class-stats"

                                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                                self.queue_average_length = YList(self)
                                                                self.queue_instance_length = YList(self)
                                                                self.queue_max_length = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("atm_clp0_drop_bytes",
                                                                                "atm_clp0_drop_packets",
                                                                                "atm_clp1_drop_bytes",
                                                                                "atm_clp1_drop_packets",
                                                                                "conform_bytes",
                                                                                "conform_packets",
                                                                                "conform_rate",
                                                                                "exceed_bytes",
                                                                                "exceed_packets",
                                                                                "exceed_rate",
                                                                                "forced_wred_stats_display",
                                                                                "max_threshold_bytes",
                                                                                "max_threshold_packets",
                                                                                "queue_drop_threshold",
                                                                                "queue_id",
                                                                                "random_drop_bytes",
                                                                                "random_drop_packets",
                                                                                "tail_drop_bytes",
                                                                                "tail_drop_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                            class QueueInstanceLength(Entity):
                                                                """
                                                                Queue instance length
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                    self.yang_name = "queue-instance-length"
                                                                    self.yang_parent_name = "queue-stats-array"

                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("unit",
                                                                                    "value") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.unit.is_set or
                                                                        self.value.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.unit.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-instance-length" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "unit" or name == "value"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "unit"):
                                                                        self.unit = value
                                                                        self.unit.value_namespace = name_space
                                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix


                                                            class QueueAverageLength(Entity):
                                                                """
                                                                Queue average length
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                    self.yang_name = "queue-average-length"
                                                                    self.yang_parent_name = "queue-stats-array"

                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("unit",
                                                                                    "value") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.unit.is_set or
                                                                        self.value.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.unit.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-average-length" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "unit" or name == "value"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "unit"):
                                                                        self.unit = value
                                                                        self.unit.value_namespace = name_space
                                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix


                                                            class QueueMaxLength(Entity):
                                                                """
                                                                Queue maximum length
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                    self.yang_name = "queue-max-length"
                                                                    self.yang_parent_name = "queue-stats-array"

                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("unit",
                                                                                    "value") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.unit.is_set or
                                                                        self.value.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.unit.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-max-length" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "unit" or name == "value"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "unit"):
                                                                        self.unit = value
                                                                        self.unit.value_namespace = name_space
                                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.queue_average_length:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.queue_instance_length:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.queue_max_length:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.atm_clp0_drop_bytes.is_set or
                                                                    self.atm_clp0_drop_packets.is_set or
                                                                    self.atm_clp1_drop_bytes.is_set or
                                                                    self.atm_clp1_drop_packets.is_set or
                                                                    self.conform_bytes.is_set or
                                                                    self.conform_packets.is_set or
                                                                    self.conform_rate.is_set or
                                                                    self.exceed_bytes.is_set or
                                                                    self.exceed_packets.is_set or
                                                                    self.exceed_rate.is_set or
                                                                    self.forced_wred_stats_display.is_set or
                                                                    self.max_threshold_bytes.is_set or
                                                                    self.max_threshold_packets.is_set or
                                                                    self.queue_drop_threshold.is_set or
                                                                    self.queue_id.is_set or
                                                                    self.random_drop_bytes.is_set or
                                                                    self.random_drop_packets.is_set or
                                                                    self.tail_drop_bytes.is_set or
                                                                    self.tail_drop_packets.is_set)

                                                            def has_operation(self):
                                                                for c in self.queue_average_length:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.queue_instance_length:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.queue_max_length:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                    self.queue_id.yfilter != YFilter.not_set or
                                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-stats-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "queue-average-length"):
                                                                    for c in self.queue_average_length:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_average_length.append(c)
                                                                    return c

                                                                if (child_yang_name == "queue-instance-length"):
                                                                    for c in self.queue_instance_length:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_instance_length.append(c)
                                                                    return c

                                                                if (child_yang_name == "queue-max-length"):
                                                                    for c in self.queue_max_length:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_max_length.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "atm-clp0-drop-bytes"):
                                                                    self.atm_clp0_drop_bytes = value
                                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "atm-clp0-drop-packets"):
                                                                    self.atm_clp0_drop_packets = value
                                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "atm-clp1-drop-bytes"):
                                                                    self.atm_clp1_drop_bytes = value
                                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "atm-clp1-drop-packets"):
                                                                    self.atm_clp1_drop_packets = value
                                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-bytes"):
                                                                    self.conform_bytes = value
                                                                    self.conform_bytes.value_namespace = name_space
                                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-packets"):
                                                                    self.conform_packets = value
                                                                    self.conform_packets.value_namespace = name_space
                                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-rate"):
                                                                    self.conform_rate = value
                                                                    self.conform_rate.value_namespace = name_space
                                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-bytes"):
                                                                    self.exceed_bytes = value
                                                                    self.exceed_bytes.value_namespace = name_space
                                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-packets"):
                                                                    self.exceed_packets = value
                                                                    self.exceed_packets.value_namespace = name_space
                                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-rate"):
                                                                    self.exceed_rate = value
                                                                    self.exceed_rate.value_namespace = name_space
                                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "forced-wred-stats-display"):
                                                                    self.forced_wred_stats_display = value
                                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "max-threshold-bytes"):
                                                                    self.max_threshold_bytes = value
                                                                    self.max_threshold_bytes.value_namespace = name_space
                                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "max-threshold-packets"):
                                                                    self.max_threshold_packets = value
                                                                    self.max_threshold_packets.value_namespace = name_space
                                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "queue-drop-threshold"):
                                                                    self.queue_drop_threshold = value
                                                                    self.queue_drop_threshold.value_namespace = name_space
                                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "queue-id"):
                                                                    self.queue_id = value
                                                                    self.queue_id.value_namespace = name_space
                                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-bytes"):
                                                                    self.random_drop_bytes = value
                                                                    self.random_drop_bytes.value_namespace = name_space
                                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-packets"):
                                                                    self.random_drop_packets = value
                                                                    self.random_drop_packets.value_namespace = name_space
                                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tail-drop-bytes"):
                                                                    self.tail_drop_bytes = value
                                                                    self.tail_drop_bytes.value_namespace = name_space
                                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tail-drop-packets"):
                                                                    self.tail_drop_packets = value
                                                                    self.tail_drop_packets.value_namespace = name_space
                                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                        class PoliceStatsArray(Entity):
                                                            """
                                                            array of police stats
                                                            
                                                            .. attribute:: color_class_stats
                                                            
                                                            	color class stats
                                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	Police dropped bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	Police dropped packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: parent_drop_bytes
                                                            
                                                            	Dropped bytes by the parent policer
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: parent_drop_packets
                                                            
                                                            	Dropped pkts by the parent policer
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_bytes
                                                            
                                                            	Bytes that violate the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_packets
                                                            
                                                            	Packets violating the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_rate
                                                            
                                                            	Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                                self.yang_name = "police-stats-array"
                                                                self.yang_parent_name = "class-stats"

                                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                self._children_yang_names.add("color-class-stats")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_bytes",
                                                                                "conform_packets",
                                                                                "conform_rate",
                                                                                "drop_bytes",
                                                                                "drop_packets",
                                                                                "exceed_bytes",
                                                                                "exceed_packets",
                                                                                "exceed_rate",
                                                                                "parent_drop_bytes",
                                                                                "parent_drop_packets",
                                                                                "violate_bytes",
                                                                                "violate_packets",
                                                                                "violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                            class ColorClassStats(Entity):
                                                                """
                                                                color class stats
                                                                
                                                                .. attribute:: conform_class_conform_bytes
                                                                
                                                                	Bytes with classification result conform and policer result conform
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_conform_packets
                                                                
                                                                	Packets with classification result conform and policer result conform
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_conform_rate
                                                                
                                                                	Conform Class Conform rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_exceed_bytes
                                                                
                                                                	Bytes with classification result conform and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_exceed_packets
                                                                
                                                                	Packets with classification result conform and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_exceed_rate
                                                                
                                                                	Conform Class Exceed rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_violate_bytes
                                                                
                                                                	Bytes with classification result conform and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_violate_packets
                                                                
                                                                	Packets with classification result conform and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_violate_rate
                                                                
                                                                	Conform Class Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_exceed_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_exceed_packets
                                                                
                                                                	Packets with classification result exceed and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_exceed_rate
                                                                
                                                                	Exceed Class Exceed rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_violate_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_violate_packets
                                                                
                                                                	Packets with classification result exceed and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_violate_rate
                                                                
                                                                	Exceed Class Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_class_violate_bytes
                                                                
                                                                	Bytes with classification result violate and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_class_violate_packets
                                                                
                                                                	Packets with classification result violate and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_class_violate_rate
                                                                
                                                                	Violate Class Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                    self.yang_name = "color-class-stats"
                                                                    self.yang_parent_name = "police-stats-array"

                                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("conform_class_conform_bytes",
                                                                                    "conform_class_conform_packets",
                                                                                    "conform_class_conform_rate",
                                                                                    "conform_class_exceed_bytes",
                                                                                    "conform_class_exceed_packets",
                                                                                    "conform_class_exceed_rate",
                                                                                    "conform_class_violate_bytes",
                                                                                    "conform_class_violate_packets",
                                                                                    "conform_class_violate_rate",
                                                                                    "exceed_class_exceed_bytes",
                                                                                    "exceed_class_exceed_packets",
                                                                                    "exceed_class_exceed_rate",
                                                                                    "exceed_class_violate_bytes",
                                                                                    "exceed_class_violate_packets",
                                                                                    "exceed_class_violate_rate",
                                                                                    "violate_class_violate_bytes",
                                                                                    "violate_class_violate_packets",
                                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.conform_class_conform_bytes.is_set or
                                                                        self.conform_class_conform_packets.is_set or
                                                                        self.conform_class_conform_rate.is_set or
                                                                        self.conform_class_exceed_bytes.is_set or
                                                                        self.conform_class_exceed_packets.is_set or
                                                                        self.conform_class_exceed_rate.is_set or
                                                                        self.conform_class_violate_bytes.is_set or
                                                                        self.conform_class_violate_packets.is_set or
                                                                        self.conform_class_violate_rate.is_set or
                                                                        self.exceed_class_exceed_bytes.is_set or
                                                                        self.exceed_class_exceed_packets.is_set or
                                                                        self.exceed_class_exceed_rate.is_set or
                                                                        self.exceed_class_violate_bytes.is_set or
                                                                        self.exceed_class_violate_packets.is_set or
                                                                        self.exceed_class_violate_rate.is_set or
                                                                        self.violate_class_violate_bytes.is_set or
                                                                        self.violate_class_violate_packets.is_set or
                                                                        self.violate_class_violate_rate.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "color-class-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "conform-class-conform-bytes"):
                                                                        self.conform_class_conform_bytes = value
                                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-conform-packets"):
                                                                        self.conform_class_conform_packets = value
                                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-conform-rate"):
                                                                        self.conform_class_conform_rate = value
                                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-exceed-bytes"):
                                                                        self.conform_class_exceed_bytes = value
                                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-exceed-packets"):
                                                                        self.conform_class_exceed_packets = value
                                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-exceed-rate"):
                                                                        self.conform_class_exceed_rate = value
                                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-violate-bytes"):
                                                                        self.conform_class_violate_bytes = value
                                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-violate-packets"):
                                                                        self.conform_class_violate_packets = value
                                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-violate-rate"):
                                                                        self.conform_class_violate_rate = value
                                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                                        self.exceed_class_exceed_bytes = value
                                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-exceed-packets"):
                                                                        self.exceed_class_exceed_packets = value
                                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-exceed-rate"):
                                                                        self.exceed_class_exceed_rate = value
                                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-violate-bytes"):
                                                                        self.exceed_class_violate_bytes = value
                                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-violate-packets"):
                                                                        self.exceed_class_violate_packets = value
                                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-violate-rate"):
                                                                        self.exceed_class_violate_rate = value
                                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-class-violate-bytes"):
                                                                        self.violate_class_violate_bytes = value
                                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-class-violate-packets"):
                                                                        self.violate_class_violate_packets = value
                                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-class-violate-rate"):
                                                                        self.violate_class_violate_rate = value
                                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_bytes.is_set or
                                                                    self.conform_packets.is_set or
                                                                    self.conform_rate.is_set or
                                                                    self.drop_bytes.is_set or
                                                                    self.drop_packets.is_set or
                                                                    self.exceed_bytes.is_set or
                                                                    self.exceed_packets.is_set or
                                                                    self.exceed_rate.is_set or
                                                                    self.parent_drop_bytes.is_set or
                                                                    self.parent_drop_packets.is_set or
                                                                    self.violate_bytes.is_set or
                                                                    self.violate_packets.is_set or
                                                                    self.violate_rate.is_set or
                                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "police-stats-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "color-class-stats"):
                                                                    if (self.color_class_stats is None):
                                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                        self.color_class_stats.parent = self
                                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    return self.color_class_stats

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-bytes"):
                                                                    self.conform_bytes = value
                                                                    self.conform_bytes.value_namespace = name_space
                                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-packets"):
                                                                    self.conform_packets = value
                                                                    self.conform_packets.value_namespace = name_space
                                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-rate"):
                                                                    self.conform_rate = value
                                                                    self.conform_rate.value_namespace = name_space
                                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-bytes"):
                                                                    self.drop_bytes = value
                                                                    self.drop_bytes.value_namespace = name_space
                                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-packets"):
                                                                    self.drop_packets = value
                                                                    self.drop_packets.value_namespace = name_space
                                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-bytes"):
                                                                    self.exceed_bytes = value
                                                                    self.exceed_bytes.value_namespace = name_space
                                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-packets"):
                                                                    self.exceed_packets = value
                                                                    self.exceed_packets.value_namespace = name_space
                                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-rate"):
                                                                    self.exceed_rate = value
                                                                    self.exceed_rate.value_namespace = name_space
                                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "parent-drop-bytes"):
                                                                    self.parent_drop_bytes = value
                                                                    self.parent_drop_bytes.value_namespace = name_space
                                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "parent-drop-packets"):
                                                                    self.parent_drop_packets = value
                                                                    self.parent_drop_packets.value_namespace = name_space
                                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-bytes"):
                                                                    self.violate_bytes = value
                                                                    self.violate_bytes.value_namespace = name_space
                                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-packets"):
                                                                    self.violate_packets = value
                                                                    self.violate_packets.value_namespace = name_space
                                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-rate"):
                                                                    self.violate_rate = value
                                                                    self.violate_rate.value_namespace = name_space
                                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                                        class WredStatsArray(Entity):
                                                            """
                                                            array of red stats
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: profile_title
                                                            
                                                            	ProfileTitle
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..300
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Probabilisticallydropped bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Probabilistically dropped  packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_ecn_marked_bytes
                                                            
                                                            	ECN marked bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_ecn_marked_packets
                                                            
                                                            	ECN marked packets 
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_label
                                                            
                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                            
                                                            .. attribute:: red_transmit_bytes
                                                            
                                                            	Transmitted bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_transmit_packets
                                                            
                                                            	Transmitted packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                                self.yang_name = "wred-stats-array"
                                                                self.yang_parent_name = "class-stats"

                                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                                self.red_label = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("max_threshold_bytes",
                                                                                "max_threshold_packets",
                                                                                "profile_title",
                                                                                "random_drop_bytes",
                                                                                "random_drop_packets",
                                                                                "red_ecn_marked_bytes",
                                                                                "red_ecn_marked_packets",
                                                                                "red_transmit_bytes",
                                                                                "red_transmit_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                            class RedLabel(Entity):
                                                                """
                                                                Array of WRED Typevalues as in PRP stats is
                                                                available per threshold   
                                                                
                                                                .. attribute:: value
                                                                
                                                                	WRED value for this type
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: wred_type
                                                                
                                                                	WRED type DSCP, EXP, PREC etc
                                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                    self.yang_name = "red-label"
                                                                    self.yang_parent_name = "wred-stats-array"

                                                                    self.value = YLeaf(YType.uint8, "value")

                                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("value",
                                                                                    "wred_type") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.value.is_set or
                                                                        self.wred_type.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set or
                                                                        self.wred_type.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "red-label" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "value" or name == "wred-type"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "wred-type"):
                                                                        self.wred_type = value
                                                                        self.wred_type.value_namespace = name_space
                                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.red_label:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.max_threshold_bytes.is_set or
                                                                    self.max_threshold_packets.is_set or
                                                                    self.profile_title.is_set or
                                                                    self.random_drop_bytes.is_set or
                                                                    self.random_drop_packets.is_set or
                                                                    self.red_ecn_marked_bytes.is_set or
                                                                    self.red_ecn_marked_packets.is_set or
                                                                    self.red_transmit_bytes.is_set or
                                                                    self.red_transmit_packets.is_set)

                                                            def has_operation(self):
                                                                for c in self.red_label:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                    self.profile_title.yfilter != YFilter.not_set or
                                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "wred-stats-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "red-label"):
                                                                    for c in self.red_label:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.red_label.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "max-threshold-bytes"):
                                                                    self.max_threshold_bytes = value
                                                                    self.max_threshold_bytes.value_namespace = name_space
                                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "max-threshold-packets"):
                                                                    self.max_threshold_packets = value
                                                                    self.max_threshold_packets.value_namespace = name_space
                                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "profile-title"):
                                                                    self.profile_title = value
                                                                    self.profile_title.value_namespace = name_space
                                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-bytes"):
                                                                    self.random_drop_bytes = value
                                                                    self.random_drop_bytes.value_namespace = name_space
                                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-packets"):
                                                                    self.random_drop_packets = value
                                                                    self.random_drop_packets.value_namespace = name_space
                                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-ecn-marked-bytes"):
                                                                    self.red_ecn_marked_bytes = value
                                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-ecn-marked-packets"):
                                                                    self.red_ecn_marked_packets = value
                                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-transmit-bytes"):
                                                                    self.red_transmit_bytes = value
                                                                    self.red_transmit_bytes.value_namespace = name_space
                                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-transmit-packets"):
                                                                    self.red_transmit_packets = value
                                                                    self.red_transmit_packets.value_namespace = name_space
                                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.police_stats_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_stats_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.wred_stats_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.cac_state.is_set or
                                                                self.class_name.is_set or
                                                                self.counter_validity_bitmask.is_set or
                                                                self.queue_descr.is_set or
                                                                self.shared_queue_id.is_set or
                                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                                (self.child_policy is not None and self.child_policy.has_data()) or
                                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                        def has_operation(self):
                                                            for c in self.police_stats_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_stats_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.wred_stats_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.cac_state.yfilter != YFilter.not_set or
                                                                self.class_name.yfilter != YFilter.not_set or
                                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                                self.queue_descr.yfilter != YFilter.not_set or
                                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                                (self.child_policy is not None and self.child_policy.has_operation()) or
                                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "class-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "cac-stats"):
                                                                if (self.cac_stats is None):
                                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                                                    self.cac_stats.parent = self
                                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                                return self.cac_stats

                                                            if (child_yang_name == "child-policy"):
                                                                if (self.child_policy is None):
                                                                    self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                                                    self.child_policy.parent = self
                                                                    self._children_name_map["child_policy"] = "child-policy"
                                                                return self.child_policy

                                                            if (child_yang_name == "general-stats"):
                                                                if (self.general_stats is None):
                                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                                                    self.general_stats.parent = self
                                                                    self._children_name_map["general_stats"] = "general-stats"
                                                                return self.general_stats

                                                            if (child_yang_name == "iphc-stats"):
                                                                if (self.iphc_stats is None):
                                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                                                    self.iphc_stats.parent = self
                                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                return self.iphc_stats

                                                            if (child_yang_name == "police-stats-array"):
                                                                for c in self.police_stats_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.police_stats_array.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-stats-array"):
                                                                for c in self.queue_stats_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_stats_array.append(c)
                                                                return c

                                                            if (child_yang_name == "wred-stats-array"):
                                                                for c in self.wred_stats_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.wred_stats_array.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "cac-state"):
                                                                self.cac_state = value
                                                                self.cac_state.value_namespace = name_space
                                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "class-name"):
                                                                self.class_name = value
                                                                self.class_name.value_namespace = name_space
                                                                self.class_name.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "counter-validity-bitmask"):
                                                                self.counter_validity_bitmask = value
                                                                self.counter_validity_bitmask.value_namespace = name_space
                                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-descr"):
                                                                self.queue_descr = value
                                                                self.queue_descr.value_namespace = name_space
                                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "shared-queue-id"):
                                                                self.shared_queue_id = value
                                                                self.shared_queue_id.value_namespace = name_space
                                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.class_stats:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.policy_name.is_set or
                                                            self.satid.is_set or
                                                            self.state.is_set or
                                                            self.state_description.is_set)

                                                    def has_operation(self):
                                                        for c in self.class_stats:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.policy_name.yfilter != YFilter.not_set or
                                                            self.satid.yfilter != YFilter.not_set or
                                                            self.state.yfilter != YFilter.not_set or
                                                            self.state_description.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "statistics" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.state.get_name_leafdata())
                                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "class-stats"):
                                                            for c in self.class_stats:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.class_stats.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "policy-name"):
                                                            self.policy_name = value
                                                            self.policy_name.value_namespace = name_space
                                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "satid"):
                                                            self.satid = value
                                                            self.satid.value_namespace = name_space
                                                            self.satid.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "state"):
                                                            self.state = value
                                                            self.state.value_namespace = name_space
                                                            self.state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "state-description"):
                                                            self.state_description = value
                                                            self.state_description.value_namespace = name_space
                                                            self.state_description.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                                        (self.statistics is not None and self.statistics.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                                        (self.statistics is not None and self.statistics.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "input" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "service-policy-names"):
                                                        if (self.service_policy_names is None):
                                                            self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                                            self.service_policy_names.parent = self
                                                            self._children_name_map["service_policy_names"] = "service-policy-names"
                                                        return self.service_policy_names

                                                    if (child_yang_name == "statistics"):
                                                        if (self.statistics is None):
                                                            self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics()
                                                            self.statistics.parent = self
                                                            self._children_name_map["statistics"] = "statistics"
                                                        return self.statistics

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "service-policy-names" or name == "statistics"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class Output(Entity):
                                                """
                                                A piece of QoS policy\-map operational data for
                                                an interface
                                                
                                                .. attribute:: service_policy_names
                                                
                                                	Operational data for all Policy instance
                                                	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                                                
                                                .. attribute:: statistics
                                                
                                                	Policy\-map statistics operational data for an interface
                                                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, self).__init__()

                                                    self.yang_name = "output"
                                                    self.yang_parent_name = "satellite-id"

                                                    self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                                    self.service_policy_names.parent = self
                                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                                    self._children_yang_names.add("service-policy-names")

                                                    self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics()
                                                    self.statistics.parent = self
                                                    self._children_name_map["statistics"] = "statistics"
                                                    self._children_yang_names.add("statistics")


                                                class ServicePolicyNames(Entity):
                                                    """
                                                    Operational data for all Policy instance
                                                    
                                                    .. attribute:: service_policy_instance
                                                    
                                                    	QoS policy\-map operational data for a particular Policy 
                                                    	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                                        self.yang_name = "service-policy-names"
                                                        self.yang_parent_name = "output"

                                                        self.service_policy_instance = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in () and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)


                                                    class ServicePolicyInstance(Entity):
                                                        """
                                                        QoS policy\-map operational data for a
                                                        particular Policy 
                                                        
                                                        .. attribute:: service_policy_name  <key>
                                                        
                                                        	Name of the policy instance
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                            self.yang_name = "service-policy-instance"
                                                            self.yang_parent_name = "service-policy-names"

                                                            self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("service_policy_name") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return self.service_policy_name.is_set

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.service_policy_name.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "service-policy-name"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "service-policy-name"):
                                                                self.service_policy_name = value
                                                                self.service_policy_name.value_namespace = name_space
                                                                self.service_policy_name.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.service_policy_instance:
                                                            if (c.has_data()):
                                                                return True
                                                        return False

                                                    def has_operation(self):
                                                        for c in self.service_policy_instance:
                                                            if (c.has_operation()):
                                                                return True
                                                        return self.yfilter != YFilter.not_set

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "service-policy-names" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "service-policy-instance"):
                                                            for c in self.service_policy_instance:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.service_policy_instance.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "service-policy-instance"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass


                                                class Statistics(Entity):
                                                    """
                                                    Policy\-map statistics operational data for an
                                                    interface
                                                    
                                                    .. attribute:: class_stats
                                                    
                                                    	array of classes contained in policy
                                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats>`
                                                    
                                                    .. attribute:: policy_name
                                                    
                                                    	PolicyName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: satid
                                                    
                                                    	to maintain satellite id
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: state
                                                    
                                                    	State
                                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                    
                                                    .. attribute:: state_description
                                                    
                                                    	StateDescription
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..128
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__init__()

                                                        self.yang_name = "statistics"
                                                        self.yang_parent_name = "output"

                                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                                        self.satid = YLeaf(YType.uint32, "satid")

                                                        self.state = YLeaf(YType.enumeration, "state")

                                                        self.state_description = YLeaf(YType.str, "state-description")

                                                        self.class_stats = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("policy_name",
                                                                        "satid",
                                                                        "state",
                                                                        "state_description") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)


                                                    class ClassStats(Entity):
                                                        """
                                                        array of classes contained in policy
                                                        
                                                        .. attribute:: cac_state
                                                        
                                                        	CACState
                                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                        
                                                        .. attribute:: cac_stats
                                                        
                                                        	bag for cac stats
                                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats>`
                                                        
                                                        .. attribute:: child_policy
                                                        
                                                        	child policy
                                                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy>`
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	ClassName
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: counter_validity_bitmask
                                                        
                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: megabyte
                                                        
                                                        .. attribute:: general_stats
                                                        
                                                        	general stats
                                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats>`
                                                        
                                                        .. attribute:: iphc_stats
                                                        
                                                        	IPHC stats
                                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats>`
                                                        
                                                        .. attribute:: police_stats_array
                                                        
                                                        	array of police stats
                                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray>`
                                                        
                                                        .. attribute:: queue_descr
                                                        
                                                        	Description of queue for the class
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..256
                                                        
                                                        .. attribute:: queue_stats_array
                                                        
                                                        	array of queue stats
                                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray>`
                                                        
                                                        .. attribute:: shared_queue_id
                                                        
                                                        	q\-id of the  shared queue for this class
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: wred_stats_array
                                                        
                                                        	array of red stats
                                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__init__()

                                                            self.yang_name = "class-stats"
                                                            self.yang_parent_name = "statistics"

                                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                            self.class_name = YLeaf(YType.str, "class-name")

                                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                            self._children_yang_names.add("cac-stats")

                                                            self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                                            self.child_policy.parent = self
                                                            self._children_name_map["child_policy"] = "child-policy"
                                                            self._children_yang_names.add("child-policy")

                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"
                                                            self._children_yang_names.add("general-stats")

                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            self._children_yang_names.add("iphc-stats")

                                                            self.police_stats_array = YList(self)
                                                            self.queue_stats_array = YList(self)
                                                            self.wred_stats_array = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("cac_state",
                                                                            "class_name",
                                                                            "counter_validity_bitmask",
                                                                            "queue_descr",
                                                                            "shared_queue_id") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                                        class GeneralStats(Entity):
                                                            """
                                                            general stats
                                                            
                                                            .. attribute:: match_data_rate
                                                            
                                                            	Incoming matched data rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: pre_policy_matched_bytes
                                                            
                                                            	Matched bytes before applying policy
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: pre_policy_matched_packets
                                                            
                                                            	Matched pkts before applying policy
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: total_drop_bytes
                                                            
                                                            	Dropped bytes (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_packets
                                                            
                                                            	Dropped packets (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_rate
                                                            
                                                            	Total drop rate (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_transmit_rate
                                                            
                                                            	Total transmit rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: transmit_bytes
                                                            
                                                            	Transmitted bytes (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: transmit_packets
                                                            
                                                            	Transmitted packets (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                                                self.yang_name = "general-stats"
                                                                self.yang_parent_name = "class-stats"

                                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("match_data_rate",
                                                                                "pre_policy_matched_bytes",
                                                                                "pre_policy_matched_packets",
                                                                                "total_drop_bytes",
                                                                                "total_drop_packets",
                                                                                "total_drop_rate",
                                                                                "total_transmit_rate",
                                                                                "transmit_bytes",
                                                                                "transmit_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.match_data_rate.is_set or
                                                                    self.pre_policy_matched_bytes.is_set or
                                                                    self.pre_policy_matched_packets.is_set or
                                                                    self.total_drop_bytes.is_set or
                                                                    self.total_drop_packets.is_set or
                                                                    self.total_drop_rate.is_set or
                                                                    self.total_transmit_rate.is_set or
                                                                    self.transmit_bytes.is_set or
                                                                    self.transmit_packets.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "general-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "match-data-rate"):
                                                                    self.match_data_rate = value
                                                                    self.match_data_rate.value_namespace = name_space
                                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "pre-policy-matched-bytes"):
                                                                    self.pre_policy_matched_bytes = value
                                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "pre-policy-matched-packets"):
                                                                    self.pre_policy_matched_packets = value
                                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-drop-bytes"):
                                                                    self.total_drop_bytes = value
                                                                    self.total_drop_bytes.value_namespace = name_space
                                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-drop-packets"):
                                                                    self.total_drop_packets = value
                                                                    self.total_drop_packets.value_namespace = name_space
                                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-drop-rate"):
                                                                    self.total_drop_rate = value
                                                                    self.total_drop_rate.value_namespace = name_space
                                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-transmit-rate"):
                                                                    self.total_transmit_rate = value
                                                                    self.total_transmit_rate.value_namespace = name_space
                                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "transmit-bytes"):
                                                                    self.transmit_bytes = value
                                                                    self.transmit_bytes.value_namespace = name_space
                                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "transmit-packets"):
                                                                    self.transmit_packets = value
                                                                    self.transmit_packets.value_namespace = name_space
                                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                        class IphcStats(Entity):
                                                            """
                                                            IPHC stats
                                                            
                                                            .. attribute:: non_tcp_bytes_saved
                                                            
                                                            	Non Tcp Bytes saved due to compression
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                            
                                                            	Compressed Non Tcp Bytes sent rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_compressed_packets_out
                                                            
                                                            	Num of non tcp compressed pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_full_header_packets_out
                                                            
                                                            	Num of non tcp fullheader pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_total_out_bytes
                                                            
                                                            	TotalNum of Non Tcp Bytes sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_total_out_packets
                                                            
                                                            	TotalNum of Non tcp pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_bytes_saved
                                                            
                                                            	Tcp Bytes saved due to compression
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_bytes_sent_rate
                                                            
                                                            	Compressed Tcp Bytes sent rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_compressed_packets_out
                                                            
                                                            	Num of tcp compressed pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_full_header_packets_out
                                                            
                                                            	Num of tcp fullheader pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_bytes
                                                            
                                                            	TotalNum of Tcp Bytes sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_total_out_packets
                                                            
                                                            	Total Num of tcp pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                                                self.yang_name = "iphc-stats"
                                                                self.yang_parent_name = "class-stats"

                                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("non_tcp_bytes_saved",
                                                                                "non_tcp_bytes_sent_rate",
                                                                                "non_tcp_compressed_packets_out",
                                                                                "non_tcp_full_header_packets_out",
                                                                                "non_tcp_total_out_bytes",
                                                                                "non_tcp_total_out_packets",
                                                                                "tcp_bytes_saved",
                                                                                "tcp_bytes_sent_rate",
                                                                                "tcp_compressed_packets_out",
                                                                                "tcp_full_header_packets_out",
                                                                                "tcp_total_out_bytes",
                                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.non_tcp_bytes_saved.is_set or
                                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                                    self.non_tcp_compressed_packets_out.is_set or
                                                                    self.non_tcp_full_header_packets_out.is_set or
                                                                    self.non_tcp_total_out_bytes.is_set or
                                                                    self.non_tcp_total_out_packets.is_set or
                                                                    self.tcp_bytes_saved.is_set or
                                                                    self.tcp_bytes_sent_rate.is_set or
                                                                    self.tcp_compressed_packets_out.is_set or
                                                                    self.tcp_full_header_packets_out.is_set or
                                                                    self.tcp_total_out_bytes.is_set or
                                                                    self.tcp_total_out_packets.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "iphc-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "non-tcp-bytes-saved"):
                                                                    self.non_tcp_bytes_saved = value
                                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                                    self.non_tcp_bytes_sent_rate = value
                                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                                    self.non_tcp_compressed_packets_out = value
                                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                                    self.non_tcp_full_header_packets_out = value
                                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-total-out-bytes"):
                                                                    self.non_tcp_total_out_bytes = value
                                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-total-out-packets"):
                                                                    self.non_tcp_total_out_packets = value
                                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-bytes-saved"):
                                                                    self.tcp_bytes_saved = value
                                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-bytes-sent-rate"):
                                                                    self.tcp_bytes_sent_rate = value
                                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-compressed-packets-out"):
                                                                    self.tcp_compressed_packets_out = value
                                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-full-header-packets-out"):
                                                                    self.tcp_full_header_packets_out = value
                                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-total-out-bytes"):
                                                                    self.tcp_total_out_bytes = value
                                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-total-out-packets"):
                                                                    self.tcp_total_out_packets = value
                                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                        class ChildPolicy(Entity):
                                                            """
                                                            child policy
                                                            
                                                            .. attribute:: class_stats
                                                            
                                                            	array of classes contained in policy
                                                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                            
                                                            .. attribute:: policy_name
                                                            
                                                            	PolicyName
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: satid
                                                            
                                                            	to maintain satellite id
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: state
                                                            
                                                            	State
                                                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                            
                                                            .. attribute:: state_description
                                                            
                                                            	StateDescription
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..128
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                                self.yang_name = "child-policy"
                                                                self.yang_parent_name = "class-stats"

                                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                                self.satid = YLeaf(YType.uint32, "satid")

                                                                self.state = YLeaf(YType.enumeration, "state")

                                                                self.state_description = YLeaf(YType.str, "state-description")

                                                                self.class_stats = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("policy_name",
                                                                                "satid",
                                                                                "state",
                                                                                "state_description") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                            class ClassStats(Entity):
                                                                """
                                                                array of classes contained in policy
                                                                
                                                                .. attribute:: cac_state
                                                                
                                                                	CACState
                                                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                                
                                                                .. attribute:: cac_stats
                                                                
                                                                	bag for cac stats
                                                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                                
                                                                .. attribute:: class_name
                                                                
                                                                	ClassName
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: counter_validity_bitmask
                                                                
                                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: megabyte
                                                                
                                                                .. attribute:: general_stats
                                                                
                                                                	general stats
                                                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                                
                                                                .. attribute:: iphc_stats
                                                                
                                                                	IPHC stats
                                                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                                
                                                                .. attribute:: police_stats_array
                                                                
                                                                	array of police stats
                                                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                                
                                                                .. attribute:: queue_descr
                                                                
                                                                	Description of queue for the class
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..256
                                                                
                                                                .. attribute:: queue_stats_array
                                                                
                                                                	array of queue stats
                                                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                                
                                                                .. attribute:: shared_queue_id
                                                                
                                                                	q\-id of the  shared queue for this class
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: wred_stats_array
                                                                
                                                                	array of red stats
                                                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                                    self.yang_name = "class-stats"
                                                                    self.yang_parent_name = "child-policy"

                                                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                    self.cac_stats.parent = self
                                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                                    self._children_yang_names.add("cac-stats")

                                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                    self.general_stats.parent = self
                                                                    self._children_name_map["general_stats"] = "general-stats"
                                                                    self._children_yang_names.add("general-stats")

                                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                    self.iphc_stats.parent = self
                                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                    self._children_yang_names.add("iphc-stats")

                                                                    self.police_stats_array = YList(self)
                                                                    self.queue_stats_array = YList(self)
                                                                    self.wred_stats_array = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("cac_state",
                                                                                    "class_name",
                                                                                    "counter_validity_bitmask",
                                                                                    "queue_descr",
                                                                                    "shared_queue_id") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                                class GeneralStats(Entity):
                                                                    """
                                                                    general stats
                                                                    
                                                                    .. attribute:: match_data_rate
                                                                    
                                                                    	Incoming matched data rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: pre_policy_matched_bytes
                                                                    
                                                                    	Matched bytes before applying policy
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: pre_policy_matched_packets
                                                                    
                                                                    	Matched pkts before applying policy
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: total_drop_bytes
                                                                    
                                                                    	Dropped bytes (packets/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_packets
                                                                    
                                                                    	Dropped packets (packets/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_drop_rate
                                                                    
                                                                    	Total drop rate (packets/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: total_transmit_rate
                                                                    
                                                                    	Total transmit rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: transmit_bytes
                                                                    
                                                                    	Transmitted bytes (packets/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: transmit_packets
                                                                    
                                                                    	Transmitted packets (packets/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                                        self.yang_name = "general-stats"
                                                                        self.yang_parent_name = "class-stats"

                                                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("match_data_rate",
                                                                                        "pre_policy_matched_bytes",
                                                                                        "pre_policy_matched_packets",
                                                                                        "total_drop_bytes",
                                                                                        "total_drop_packets",
                                                                                        "total_drop_rate",
                                                                                        "total_transmit_rate",
                                                                                        "transmit_bytes",
                                                                                        "transmit_packets") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.match_data_rate.is_set or
                                                                            self.pre_policy_matched_bytes.is_set or
                                                                            self.pre_policy_matched_packets.is_set or
                                                                            self.total_drop_bytes.is_set or
                                                                            self.total_drop_packets.is_set or
                                                                            self.total_drop_rate.is_set or
                                                                            self.total_transmit_rate.is_set or
                                                                            self.transmit_bytes.is_set or
                                                                            self.transmit_packets.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.match_data_rate.yfilter != YFilter.not_set or
                                                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                                                            self.transmit_packets.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "general-stats" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "match-data-rate"):
                                                                            self.match_data_rate = value
                                                                            self.match_data_rate.value_namespace = name_space
                                                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "pre-policy-matched-bytes"):
                                                                            self.pre_policy_matched_bytes = value
                                                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "pre-policy-matched-packets"):
                                                                            self.pre_policy_matched_packets = value
                                                                            self.pre_policy_matched_packets.value_namespace = name_space
                                                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "total-drop-bytes"):
                                                                            self.total_drop_bytes = value
                                                                            self.total_drop_bytes.value_namespace = name_space
                                                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "total-drop-packets"):
                                                                            self.total_drop_packets = value
                                                                            self.total_drop_packets.value_namespace = name_space
                                                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "total-drop-rate"):
                                                                            self.total_drop_rate = value
                                                                            self.total_drop_rate.value_namespace = name_space
                                                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "total-transmit-rate"):
                                                                            self.total_transmit_rate = value
                                                                            self.total_transmit_rate.value_namespace = name_space
                                                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "transmit-bytes"):
                                                                            self.transmit_bytes = value
                                                                            self.transmit_bytes.value_namespace = name_space
                                                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "transmit-packets"):
                                                                            self.transmit_packets = value
                                                                            self.transmit_packets.value_namespace = name_space
                                                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                                class IphcStats(Entity):
                                                                    """
                                                                    IPHC stats
                                                                    
                                                                    .. attribute:: non_tcp_bytes_saved
                                                                    
                                                                    	Non Tcp Bytes saved due to compression
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                                    
                                                                    	Compressed Non Tcp Bytes sent rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_compressed_packets_out
                                                                    
                                                                    	Num of non tcp compressed pkts sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: non_tcp_full_header_packets_out
                                                                    
                                                                    	Num of non tcp fullheader pkts sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: non_tcp_total_out_bytes
                                                                    
                                                                    	TotalNum of Non Tcp Bytes sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: non_tcp_total_out_packets
                                                                    
                                                                    	TotalNum of Non tcp pkts sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_bytes_saved
                                                                    
                                                                    	Tcp Bytes saved due to compression
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_bytes_sent_rate
                                                                    
                                                                    	Compressed Tcp Bytes sent rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_compressed_packets_out
                                                                    
                                                                    	Num of tcp compressed pkts sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_full_header_packets_out
                                                                    
                                                                    	Num of tcp fullheader pkts sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tcp_total_out_bytes
                                                                    
                                                                    	TotalNum of Tcp Bytes sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tcp_total_out_packets
                                                                    
                                                                    	Total Num of tcp pkts sent
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                                        self.yang_name = "iphc-stats"
                                                                        self.yang_parent_name = "class-stats"

                                                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("non_tcp_bytes_saved",
                                                                                        "non_tcp_bytes_sent_rate",
                                                                                        "non_tcp_compressed_packets_out",
                                                                                        "non_tcp_full_header_packets_out",
                                                                                        "non_tcp_total_out_bytes",
                                                                                        "non_tcp_total_out_packets",
                                                                                        "tcp_bytes_saved",
                                                                                        "tcp_bytes_sent_rate",
                                                                                        "tcp_compressed_packets_out",
                                                                                        "tcp_full_header_packets_out",
                                                                                        "tcp_total_out_bytes",
                                                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.non_tcp_bytes_saved.is_set or
                                                                            self.non_tcp_bytes_sent_rate.is_set or
                                                                            self.non_tcp_compressed_packets_out.is_set or
                                                                            self.non_tcp_full_header_packets_out.is_set or
                                                                            self.non_tcp_total_out_bytes.is_set or
                                                                            self.non_tcp_total_out_packets.is_set or
                                                                            self.tcp_bytes_saved.is_set or
                                                                            self.tcp_bytes_sent_rate.is_set or
                                                                            self.tcp_compressed_packets_out.is_set or
                                                                            self.tcp_full_header_packets_out.is_set or
                                                                            self.tcp_total_out_bytes.is_set or
                                                                            self.tcp_total_out_packets.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "iphc-stats" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "non-tcp-bytes-saved"):
                                                                            self.non_tcp_bytes_saved = value
                                                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                                                            self.non_tcp_bytes_sent_rate = value
                                                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "non-tcp-compressed-packets-out"):
                                                                            self.non_tcp_compressed_packets_out = value
                                                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "non-tcp-full-header-packets-out"):
                                                                            self.non_tcp_full_header_packets_out = value
                                                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "non-tcp-total-out-bytes"):
                                                                            self.non_tcp_total_out_bytes = value
                                                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "non-tcp-total-out-packets"):
                                                                            self.non_tcp_total_out_packets = value
                                                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tcp-bytes-saved"):
                                                                            self.tcp_bytes_saved = value
                                                                            self.tcp_bytes_saved.value_namespace = name_space
                                                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tcp-bytes-sent-rate"):
                                                                            self.tcp_bytes_sent_rate = value
                                                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tcp-compressed-packets-out"):
                                                                            self.tcp_compressed_packets_out = value
                                                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tcp-full-header-packets-out"):
                                                                            self.tcp_full_header_packets_out = value
                                                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tcp-total-out-bytes"):
                                                                            self.tcp_total_out_bytes = value
                                                                            self.tcp_total_out_bytes.value_namespace = name_space
                                                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tcp-total-out-packets"):
                                                                            self.tcp_total_out_packets = value
                                                                            self.tcp_total_out_packets.value_namespace = name_space
                                                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                                class CacStats(Entity):
                                                                    """
                                                                    bag for cac stats
                                                                    
                                                                    .. attribute:: admit_bytes
                                                                    
                                                                    	Admitted bytes (pkts/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: admit_rates
                                                                    
                                                                    	CAC admit rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: admitpackets
                                                                    
                                                                    	Admitted packets (pkts/bytes)
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: drop_bytes
                                                                    
                                                                    	CAC dropped bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: drop_packets
                                                                    
                                                                    	CAC dropped packets
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: drop_rates
                                                                    
                                                                    	CAC dropped rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                                        self.yang_name = "cac-stats"
                                                                        self.yang_parent_name = "class-stats"

                                                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("admit_bytes",
                                                                                        "admit_rates",
                                                                                        "admitpackets",
                                                                                        "drop_bytes",
                                                                                        "drop_packets",
                                                                                        "drop_rates") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.admit_bytes.is_set or
                                                                            self.admit_rates.is_set or
                                                                            self.admitpackets.is_set or
                                                                            self.drop_bytes.is_set or
                                                                            self.drop_packets.is_set or
                                                                            self.drop_rates.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.admit_bytes.yfilter != YFilter.not_set or
                                                                            self.admit_rates.yfilter != YFilter.not_set or
                                                                            self.admitpackets.yfilter != YFilter.not_set or
                                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                                            self.drop_rates.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "cac-stats" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "admit-bytes"):
                                                                            self.admit_bytes = value
                                                                            self.admit_bytes.value_namespace = name_space
                                                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "admit-rates"):
                                                                            self.admit_rates = value
                                                                            self.admit_rates.value_namespace = name_space
                                                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "admitpackets"):
                                                                            self.admitpackets = value
                                                                            self.admitpackets.value_namespace = name_space
                                                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "drop-bytes"):
                                                                            self.drop_bytes = value
                                                                            self.drop_bytes.value_namespace = name_space
                                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "drop-packets"):
                                                                            self.drop_packets = value
                                                                            self.drop_packets.value_namespace = name_space
                                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "drop-rates"):
                                                                            self.drop_rates = value
                                                                            self.drop_rates.value_namespace = name_space
                                                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                                                class QueueStatsArray(Entity):
                                                                    """
                                                                    array of queue stats
                                                                    
                                                                    .. attribute:: atm_clp0_drop_bytes
                                                                    
                                                                    	ATP CLP 0 matched bytes dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: atm_clp0_drop_packets
                                                                    
                                                                    	ATP CLP 0 matched packets dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: atm_clp1_drop_bytes
                                                                    
                                                                    	ATP CLP 0 matched bytes dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: atm_clp1_drop_packets
                                                                    
                                                                    	ATP CLP 0 matched packets dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_bytes
                                                                    
                                                                    	Bytes that conform to the queue rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_packets
                                                                    
                                                                    	Packets that conform  to the queue rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_rate
                                                                    
                                                                    	Conform rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: exceed_bytes
                                                                    
                                                                    	Bytes that exceed  the queue rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_packets
                                                                    
                                                                    	Packets that exceed the queue rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_rate
                                                                    
                                                                    	Exceed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: forced_wred_stats_display
                                                                    
                                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                    	**type**\:  bool
                                                                    
                                                                    .. attribute:: max_threshold_bytes
                                                                    
                                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: max_threshold_packets
                                                                    
                                                                    	Dropped packets with the average queue size at the max\-threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: queue_average_length
                                                                    
                                                                    	Queue average length
                                                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                                    
                                                                    .. attribute:: queue_drop_threshold
                                                                    
                                                                    	tail drop threshold of the queue in bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: queue_id
                                                                    
                                                                    	Queue Id used for Fabric Stats
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: queue_instance_length
                                                                    
                                                                    	Queue instance length
                                                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                                    
                                                                    .. attribute:: queue_max_length
                                                                    
                                                                    	Queue maximum length
                                                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                                    
                                                                    .. attribute:: random_drop_bytes
                                                                    
                                                                    	Bytes probabilistically dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: random_drop_packets
                                                                    
                                                                    	Packets probabilistically dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: tail_drop_bytes
                                                                    
                                                                    	Bytes tail dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: tail_drop_packets
                                                                    
                                                                    	Packets tail dropped
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                                        self.yang_name = "queue-stats-array"
                                                                        self.yang_parent_name = "class-stats"

                                                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                                        self.queue_average_length = YList(self)
                                                                        self.queue_instance_length = YList(self)
                                                                        self.queue_max_length = YList(self)

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("atm_clp0_drop_bytes",
                                                                                        "atm_clp0_drop_packets",
                                                                                        "atm_clp1_drop_bytes",
                                                                                        "atm_clp1_drop_packets",
                                                                                        "conform_bytes",
                                                                                        "conform_packets",
                                                                                        "conform_rate",
                                                                                        "exceed_bytes",
                                                                                        "exceed_packets",
                                                                                        "exceed_rate",
                                                                                        "forced_wred_stats_display",
                                                                                        "max_threshold_bytes",
                                                                                        "max_threshold_packets",
                                                                                        "queue_drop_threshold",
                                                                                        "queue_id",
                                                                                        "random_drop_bytes",
                                                                                        "random_drop_packets",
                                                                                        "tail_drop_bytes",
                                                                                        "tail_drop_packets") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                                    class QueueInstanceLength(Entity):
                                                                        """
                                                                        Queue instance length
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-04-10'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                            self.yang_name = "queue-instance-length"
                                                                            self.yang_parent_name = "queue-stats-array"

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("unit",
                                                                                            "value") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.unit.is_set or
                                                                                self.value.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.unit.yfilter != YFilter.not_set or
                                                                                self.value.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "queue-instance-length" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "unit" or name == "value"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "unit"):
                                                                                self.unit = value
                                                                                self.unit.value_namespace = name_space
                                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "value"):
                                                                                self.value = value
                                                                                self.value.value_namespace = name_space
                                                                                self.value.value_namespace_prefix = name_space_prefix


                                                                    class QueueAverageLength(Entity):
                                                                        """
                                                                        Queue average length
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-04-10'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                            self.yang_name = "queue-average-length"
                                                                            self.yang_parent_name = "queue-stats-array"

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("unit",
                                                                                            "value") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.unit.is_set or
                                                                                self.value.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.unit.yfilter != YFilter.not_set or
                                                                                self.value.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "queue-average-length" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "unit" or name == "value"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "unit"):
                                                                                self.unit = value
                                                                                self.unit.value_namespace = name_space
                                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "value"):
                                                                                self.value = value
                                                                                self.value.value_namespace = name_space
                                                                                self.value.value_namespace_prefix = name_space_prefix


                                                                    class QueueMaxLength(Entity):
                                                                        """
                                                                        Queue maximum length
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-04-10'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                            self.yang_name = "queue-max-length"
                                                                            self.yang_parent_name = "queue-stats-array"

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("unit",
                                                                                            "value") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.unit.is_set or
                                                                                self.value.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.unit.yfilter != YFilter.not_set or
                                                                                self.value.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "queue-max-length" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "unit" or name == "value"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "unit"):
                                                                                self.unit = value
                                                                                self.unit.value_namespace = name_space
                                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "value"):
                                                                                self.value = value
                                                                                self.value.value_namespace = name_space
                                                                                self.value.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        for c in self.queue_average_length:
                                                                            if (c.has_data()):
                                                                                return True
                                                                        for c in self.queue_instance_length:
                                                                            if (c.has_data()):
                                                                                return True
                                                                        for c in self.queue_max_length:
                                                                            if (c.has_data()):
                                                                                return True
                                                                        return (
                                                                            self.atm_clp0_drop_bytes.is_set or
                                                                            self.atm_clp0_drop_packets.is_set or
                                                                            self.atm_clp1_drop_bytes.is_set or
                                                                            self.atm_clp1_drop_packets.is_set or
                                                                            self.conform_bytes.is_set or
                                                                            self.conform_packets.is_set or
                                                                            self.conform_rate.is_set or
                                                                            self.exceed_bytes.is_set or
                                                                            self.exceed_packets.is_set or
                                                                            self.exceed_rate.is_set or
                                                                            self.forced_wred_stats_display.is_set or
                                                                            self.max_threshold_bytes.is_set or
                                                                            self.max_threshold_packets.is_set or
                                                                            self.queue_drop_threshold.is_set or
                                                                            self.queue_id.is_set or
                                                                            self.random_drop_bytes.is_set or
                                                                            self.random_drop_packets.is_set or
                                                                            self.tail_drop_bytes.is_set or
                                                                            self.tail_drop_packets.is_set)

                                                                    def has_operation(self):
                                                                        for c in self.queue_average_length:
                                                                            if (c.has_operation()):
                                                                                return True
                                                                        for c in self.queue_instance_length:
                                                                            if (c.has_operation()):
                                                                                return True
                                                                        for c in self.queue_max_length:
                                                                            if (c.has_operation()):
                                                                                return True
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                            self.queue_id.yfilter != YFilter.not_set or
                                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-stats-array" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "queue-average-length"):
                                                                            for c in self.queue_average_length:
                                                                                segment = c.get_segment_path()
                                                                                if (segment_path == segment):
                                                                                    return c
                                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                            c.parent = self
                                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                                            self._local_refs[local_reference_key] = c
                                                                            self.queue_average_length.append(c)
                                                                            return c

                                                                        if (child_yang_name == "queue-instance-length"):
                                                                            for c in self.queue_instance_length:
                                                                                segment = c.get_segment_path()
                                                                                if (segment_path == segment):
                                                                                    return c
                                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                            c.parent = self
                                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                                            self._local_refs[local_reference_key] = c
                                                                            self.queue_instance_length.append(c)
                                                                            return c

                                                                        if (child_yang_name == "queue-max-length"):
                                                                            for c in self.queue_max_length:
                                                                                segment = c.get_segment_path()
                                                                                if (segment_path == segment):
                                                                                    return c
                                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                            c.parent = self
                                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                                            self._local_refs[local_reference_key] = c
                                                                            self.queue_max_length.append(c)
                                                                            return c

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "atm-clp0-drop-bytes"):
                                                                            self.atm_clp0_drop_bytes = value
                                                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "atm-clp0-drop-packets"):
                                                                            self.atm_clp0_drop_packets = value
                                                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "atm-clp1-drop-bytes"):
                                                                            self.atm_clp1_drop_bytes = value
                                                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "atm-clp1-drop-packets"):
                                                                            self.atm_clp1_drop_packets = value
                                                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-bytes"):
                                                                            self.conform_bytes = value
                                                                            self.conform_bytes.value_namespace = name_space
                                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-packets"):
                                                                            self.conform_packets = value
                                                                            self.conform_packets.value_namespace = name_space
                                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-rate"):
                                                                            self.conform_rate = value
                                                                            self.conform_rate.value_namespace = name_space
                                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-bytes"):
                                                                            self.exceed_bytes = value
                                                                            self.exceed_bytes.value_namespace = name_space
                                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-packets"):
                                                                            self.exceed_packets = value
                                                                            self.exceed_packets.value_namespace = name_space
                                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-rate"):
                                                                            self.exceed_rate = value
                                                                            self.exceed_rate.value_namespace = name_space
                                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "forced-wred-stats-display"):
                                                                            self.forced_wred_stats_display = value
                                                                            self.forced_wred_stats_display.value_namespace = name_space
                                                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "max-threshold-bytes"):
                                                                            self.max_threshold_bytes = value
                                                                            self.max_threshold_bytes.value_namespace = name_space
                                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "max-threshold-packets"):
                                                                            self.max_threshold_packets = value
                                                                            self.max_threshold_packets.value_namespace = name_space
                                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "queue-drop-threshold"):
                                                                            self.queue_drop_threshold = value
                                                                            self.queue_drop_threshold.value_namespace = name_space
                                                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "queue-id"):
                                                                            self.queue_id = value
                                                                            self.queue_id.value_namespace = name_space
                                                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "random-drop-bytes"):
                                                                            self.random_drop_bytes = value
                                                                            self.random_drop_bytes.value_namespace = name_space
                                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "random-drop-packets"):
                                                                            self.random_drop_packets = value
                                                                            self.random_drop_packets.value_namespace = name_space
                                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tail-drop-bytes"):
                                                                            self.tail_drop_bytes = value
                                                                            self.tail_drop_bytes.value_namespace = name_space
                                                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "tail-drop-packets"):
                                                                            self.tail_drop_packets = value
                                                                            self.tail_drop_packets.value_namespace = name_space
                                                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                                class PoliceStatsArray(Entity):
                                                                    """
                                                                    array of police stats
                                                                    
                                                                    .. attribute:: color_class_stats
                                                                    
                                                                    	color class stats
                                                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                                    
                                                                    .. attribute:: conform_bytes
                                                                    
                                                                    	Bytes that conform to the policed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_packets
                                                                    
                                                                    	Packets that conform  to the policed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_rate
                                                                    
                                                                    	Conform rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: drop_bytes
                                                                    
                                                                    	Police dropped bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: drop_packets
                                                                    
                                                                    	Police dropped packets
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_bytes
                                                                    
                                                                    	Bytes that exceed  the policed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_packets
                                                                    
                                                                    	Packets that exceed the policed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_rate
                                                                    
                                                                    	Exceed rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: parent_drop_bytes
                                                                    
                                                                    	Dropped bytes by the parent policer
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: parent_drop_packets
                                                                    
                                                                    	Dropped pkts by the parent policer
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_bytes
                                                                    
                                                                    	Bytes that violate the policed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_packets
                                                                    
                                                                    	Packets violating the policed rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_rate
                                                                    
                                                                    	Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                                        self.yang_name = "police-stats-array"
                                                                        self.yang_parent_name = "class-stats"

                                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                        self.color_class_stats.parent = self
                                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                        self._children_yang_names.add("color-class-stats")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("conform_bytes",
                                                                                        "conform_packets",
                                                                                        "conform_rate",
                                                                                        "drop_bytes",
                                                                                        "drop_packets",
                                                                                        "exceed_bytes",
                                                                                        "exceed_packets",
                                                                                        "exceed_rate",
                                                                                        "parent_drop_bytes",
                                                                                        "parent_drop_packets",
                                                                                        "violate_bytes",
                                                                                        "violate_packets",
                                                                                        "violate_rate") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                                    class ColorClassStats(Entity):
                                                                        """
                                                                        color class stats
                                                                        
                                                                        .. attribute:: conform_class_conform_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result conform
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_conform_packets
                                                                        
                                                                        	Packets with classification result conform and policer result conform
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_conform_rate
                                                                        
                                                                        	Conform Class Conform rate in kbps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: conform_class_exceed_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result exceed
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_exceed_packets
                                                                        
                                                                        	Packets with classification result conform and policer result exceed
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_exceed_rate
                                                                        
                                                                        	Conform Class Exceed rate in kbps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: conform_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result conform and policer result violate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: conform_class_violate_packets
                                                                        
                                                                        	Packets with classification result conform and policer result violate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: conform_class_violate_rate
                                                                        
                                                                        	Conform Class Violate rate in kbps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_class_exceed_bytes
                                                                        
                                                                        	Bytes with classification result exceed and policer result exceed
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_class_exceed_packets
                                                                        
                                                                        	Packets with classification result exceed and policer result exceed
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_class_exceed_rate
                                                                        
                                                                        	Exceed Class Exceed rate in kbps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: exceed_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result exceed and policer result violate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: exceed_class_violate_packets
                                                                        
                                                                        	Packets with classification result exceed and policer result violate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: exceed_class_violate_rate
                                                                        
                                                                        	Exceed Class Violate rate in kbps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        .. attribute:: violate_class_violate_bytes
                                                                        
                                                                        	Bytes with classification result violate and policer result violate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: violate_class_violate_packets
                                                                        
                                                                        	Packets with classification result violate and policer result violate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: violate_class_violate_rate
                                                                        
                                                                        	Violate Class Violate rate in kbps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: kbit/s
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-04-10'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                            self.yang_name = "color-class-stats"
                                                                            self.yang_parent_name = "police-stats-array"

                                                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("conform_class_conform_bytes",
                                                                                            "conform_class_conform_packets",
                                                                                            "conform_class_conform_rate",
                                                                                            "conform_class_exceed_bytes",
                                                                                            "conform_class_exceed_packets",
                                                                                            "conform_class_exceed_rate",
                                                                                            "conform_class_violate_bytes",
                                                                                            "conform_class_violate_packets",
                                                                                            "conform_class_violate_rate",
                                                                                            "exceed_class_exceed_bytes",
                                                                                            "exceed_class_exceed_packets",
                                                                                            "exceed_class_exceed_rate",
                                                                                            "exceed_class_violate_bytes",
                                                                                            "exceed_class_violate_packets",
                                                                                            "exceed_class_violate_rate",
                                                                                            "violate_class_violate_bytes",
                                                                                            "violate_class_violate_packets",
                                                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.conform_class_conform_bytes.is_set or
                                                                                self.conform_class_conform_packets.is_set or
                                                                                self.conform_class_conform_rate.is_set or
                                                                                self.conform_class_exceed_bytes.is_set or
                                                                                self.conform_class_exceed_packets.is_set or
                                                                                self.conform_class_exceed_rate.is_set or
                                                                                self.conform_class_violate_bytes.is_set or
                                                                                self.conform_class_violate_packets.is_set or
                                                                                self.conform_class_violate_rate.is_set or
                                                                                self.exceed_class_exceed_bytes.is_set or
                                                                                self.exceed_class_exceed_packets.is_set or
                                                                                self.exceed_class_exceed_rate.is_set or
                                                                                self.exceed_class_violate_bytes.is_set or
                                                                                self.exceed_class_violate_packets.is_set or
                                                                                self.exceed_class_violate_rate.is_set or
                                                                                self.violate_class_violate_bytes.is_set or
                                                                                self.violate_class_violate_packets.is_set or
                                                                                self.violate_class_violate_rate.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "color-class-stats" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "conform-class-conform-bytes"):
                                                                                self.conform_class_conform_bytes = value
                                                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-conform-packets"):
                                                                                self.conform_class_conform_packets = value
                                                                                self.conform_class_conform_packets.value_namespace = name_space
                                                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-conform-rate"):
                                                                                self.conform_class_conform_rate = value
                                                                                self.conform_class_conform_rate.value_namespace = name_space
                                                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-exceed-bytes"):
                                                                                self.conform_class_exceed_bytes = value
                                                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-exceed-packets"):
                                                                                self.conform_class_exceed_packets = value
                                                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-exceed-rate"):
                                                                                self.conform_class_exceed_rate = value
                                                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-violate-bytes"):
                                                                                self.conform_class_violate_bytes = value
                                                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-violate-packets"):
                                                                                self.conform_class_violate_packets = value
                                                                                self.conform_class_violate_packets.value_namespace = name_space
                                                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "conform-class-violate-rate"):
                                                                                self.conform_class_violate_rate = value
                                                                                self.conform_class_violate_rate.value_namespace = name_space
                                                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "exceed-class-exceed-bytes"):
                                                                                self.exceed_class_exceed_bytes = value
                                                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "exceed-class-exceed-packets"):
                                                                                self.exceed_class_exceed_packets = value
                                                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "exceed-class-exceed-rate"):
                                                                                self.exceed_class_exceed_rate = value
                                                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "exceed-class-violate-bytes"):
                                                                                self.exceed_class_violate_bytes = value
                                                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "exceed-class-violate-packets"):
                                                                                self.exceed_class_violate_packets = value
                                                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "exceed-class-violate-rate"):
                                                                                self.exceed_class_violate_rate = value
                                                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "violate-class-violate-bytes"):
                                                                                self.violate_class_violate_bytes = value
                                                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "violate-class-violate-packets"):
                                                                                self.violate_class_violate_packets = value
                                                                                self.violate_class_violate_packets.value_namespace = name_space
                                                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "violate-class-violate-rate"):
                                                                                self.violate_class_violate_rate = value
                                                                                self.violate_class_violate_rate.value_namespace = name_space
                                                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        return (
                                                                            self.conform_bytes.is_set or
                                                                            self.conform_packets.is_set or
                                                                            self.conform_rate.is_set or
                                                                            self.drop_bytes.is_set or
                                                                            self.drop_packets.is_set or
                                                                            self.exceed_bytes.is_set or
                                                                            self.exceed_packets.is_set or
                                                                            self.exceed_rate.is_set or
                                                                            self.parent_drop_bytes.is_set or
                                                                            self.parent_drop_packets.is_set or
                                                                            self.violate_bytes.is_set or
                                                                            self.violate_packets.is_set or
                                                                            self.violate_rate.is_set or
                                                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                            self.violate_bytes.yfilter != YFilter.not_set or
                                                                            self.violate_packets.yfilter != YFilter.not_set or
                                                                            self.violate_rate.yfilter != YFilter.not_set or
                                                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "police-stats-array" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "color-class-stats"):
                                                                            if (self.color_class_stats is None):
                                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                                self.color_class_stats.parent = self
                                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                            return self.color_class_stats

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "conform-bytes"):
                                                                            self.conform_bytes = value
                                                                            self.conform_bytes.value_namespace = name_space
                                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-packets"):
                                                                            self.conform_packets = value
                                                                            self.conform_packets.value_namespace = name_space
                                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-rate"):
                                                                            self.conform_rate = value
                                                                            self.conform_rate.value_namespace = name_space
                                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "drop-bytes"):
                                                                            self.drop_bytes = value
                                                                            self.drop_bytes.value_namespace = name_space
                                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "drop-packets"):
                                                                            self.drop_packets = value
                                                                            self.drop_packets.value_namespace = name_space
                                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-bytes"):
                                                                            self.exceed_bytes = value
                                                                            self.exceed_bytes.value_namespace = name_space
                                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-packets"):
                                                                            self.exceed_packets = value
                                                                            self.exceed_packets.value_namespace = name_space
                                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-rate"):
                                                                            self.exceed_rate = value
                                                                            self.exceed_rate.value_namespace = name_space
                                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "parent-drop-bytes"):
                                                                            self.parent_drop_bytes = value
                                                                            self.parent_drop_bytes.value_namespace = name_space
                                                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "parent-drop-packets"):
                                                                            self.parent_drop_packets = value
                                                                            self.parent_drop_packets.value_namespace = name_space
                                                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-bytes"):
                                                                            self.violate_bytes = value
                                                                            self.violate_bytes.value_namespace = name_space
                                                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-packets"):
                                                                            self.violate_packets = value
                                                                            self.violate_packets.value_namespace = name_space
                                                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-rate"):
                                                                            self.violate_rate = value
                                                                            self.violate_rate.value_namespace = name_space
                                                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                                                class WredStatsArray(Entity):
                                                                    """
                                                                    array of red stats
                                                                    
                                                                    .. attribute:: max_threshold_bytes
                                                                    
                                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: max_threshold_packets
                                                                    
                                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: profile_title
                                                                    
                                                                    	ProfileTitle
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..300
                                                                    
                                                                    .. attribute:: random_drop_bytes
                                                                    
                                                                    	Probabilisticallydropped bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: random_drop_packets
                                                                    
                                                                    	Probabilistically dropped  packets
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: red_ecn_marked_bytes
                                                                    
                                                                    	ECN marked bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: red_ecn_marked_packets
                                                                    
                                                                    	ECN marked packets 
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: red_label
                                                                    
                                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                                    
                                                                    .. attribute:: red_transmit_bytes
                                                                    
                                                                    	Transmitted bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: red_transmit_packets
                                                                    
                                                                    	Transmitted packets
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                                        self.yang_name = "wred-stats-array"
                                                                        self.yang_parent_name = "class-stats"

                                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                                        self.red_label = YList(self)

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("max_threshold_bytes",
                                                                                        "max_threshold_packets",
                                                                                        "profile_title",
                                                                                        "random_drop_bytes",
                                                                                        "random_drop_packets",
                                                                                        "red_ecn_marked_bytes",
                                                                                        "red_ecn_marked_packets",
                                                                                        "red_transmit_bytes",
                                                                                        "red_transmit_packets") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                                    class RedLabel(Entity):
                                                                        """
                                                                        Array of WRED Typevalues as in PRP stats is
                                                                        available per threshold   
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	WRED value for this type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: wred_type
                                                                        
                                                                        	WRED type DSCP, EXP, PREC etc
                                                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'qos-ma-oper'
                                                                        _revision = '2017-04-10'

                                                                        def __init__(self):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                            self.yang_name = "red-label"
                                                                            self.yang_parent_name = "wred-stats-array"

                                                                            self.value = YLeaf(YType.uint8, "value")

                                                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                                        def __setattr__(self, name, value):
                                                                            self._check_monkey_patching_error(name, value)
                                                                            with _handle_type_error():
                                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                        "Please use list append or extend method."
                                                                                                        .format(value))
                                                                                if isinstance(value, Enum.YLeaf):
                                                                                    value = value.name
                                                                                if name in ("value",
                                                                                            "wred_type") and name in self.__dict__:
                                                                                    if isinstance(value, YLeaf):
                                                                                        self.__dict__[name].set(value.get())
                                                                                    elif isinstance(value, YLeafList):
                                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                                    else:
                                                                                        self.__dict__[name].set(value)
                                                                                else:
                                                                                    if hasattr(value, "parent") and name != "parent":
                                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                            value.parent = self
                                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                            value.parent = self
                                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                                        def has_data(self):
                                                                            return (
                                                                                self.value.is_set or
                                                                                self.wred_type.is_set)

                                                                        def has_operation(self):
                                                                            return (
                                                                                self.yfilter != YFilter.not_set or
                                                                                self.value.yfilter != YFilter.not_set or
                                                                                self.wred_type.yfilter != YFilter.not_set)

                                                                        def get_segment_path(self):
                                                                            path_buffer = ""
                                                                            path_buffer = "red-label" + path_buffer

                                                                            return path_buffer

                                                                        def get_entity_path(self, ancestor):
                                                                            path_buffer = ""
                                                                            if (ancestor is None):
                                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                            else:
                                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                            leaf_name_data = LeafDataList()
                                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.value.get_name_leafdata())
                                                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                            return entity_path

                                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                            if child is not None:
                                                                                return child

                                                                            return None

                                                                        def has_leaf_or_child_of_name(self, name):
                                                                            if(name == "value" or name == "wred-type"):
                                                                                return True
                                                                            return False

                                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                            if(value_path == "value"):
                                                                                self.value = value
                                                                                self.value.value_namespace = name_space
                                                                                self.value.value_namespace_prefix = name_space_prefix
                                                                            if(value_path == "wred-type"):
                                                                                self.wred_type = value
                                                                                self.wred_type.value_namespace = name_space
                                                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                                                    def has_data(self):
                                                                        for c in self.red_label:
                                                                            if (c.has_data()):
                                                                                return True
                                                                        return (
                                                                            self.max_threshold_bytes.is_set or
                                                                            self.max_threshold_packets.is_set or
                                                                            self.profile_title.is_set or
                                                                            self.random_drop_bytes.is_set or
                                                                            self.random_drop_packets.is_set or
                                                                            self.red_ecn_marked_bytes.is_set or
                                                                            self.red_ecn_marked_packets.is_set or
                                                                            self.red_transmit_bytes.is_set or
                                                                            self.red_transmit_packets.is_set)

                                                                    def has_operation(self):
                                                                        for c in self.red_label:
                                                                            if (c.has_operation()):
                                                                                return True
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                            self.profile_title.yfilter != YFilter.not_set or
                                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "wred-stats-array" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        if (child_yang_name == "red-label"):
                                                                            for c in self.red_label:
                                                                                segment = c.get_segment_path()
                                                                                if (segment_path == segment):
                                                                                    return c
                                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                            c.parent = self
                                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                                            self._local_refs[local_reference_key] = c
                                                                            self.red_label.append(c)
                                                                            return c

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "max-threshold-bytes"):
                                                                            self.max_threshold_bytes = value
                                                                            self.max_threshold_bytes.value_namespace = name_space
                                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "max-threshold-packets"):
                                                                            self.max_threshold_packets = value
                                                                            self.max_threshold_packets.value_namespace = name_space
                                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "profile-title"):
                                                                            self.profile_title = value
                                                                            self.profile_title.value_namespace = name_space
                                                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "random-drop-bytes"):
                                                                            self.random_drop_bytes = value
                                                                            self.random_drop_bytes.value_namespace = name_space
                                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "random-drop-packets"):
                                                                            self.random_drop_packets = value
                                                                            self.random_drop_packets.value_namespace = name_space
                                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "red-ecn-marked-bytes"):
                                                                            self.red_ecn_marked_bytes = value
                                                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "red-ecn-marked-packets"):
                                                                            self.red_ecn_marked_packets = value
                                                                            self.red_ecn_marked_packets.value_namespace = name_space
                                                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "red-transmit-bytes"):
                                                                            self.red_transmit_bytes = value
                                                                            self.red_transmit_bytes.value_namespace = name_space
                                                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "red-transmit-packets"):
                                                                            self.red_transmit_packets = value
                                                                            self.red_transmit_packets.value_namespace = name_space
                                                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.police_stats_array:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    for c in self.queue_stats_array:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    for c in self.wred_stats_array:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return (
                                                                        self.cac_state.is_set or
                                                                        self.class_name.is_set or
                                                                        self.counter_validity_bitmask.is_set or
                                                                        self.queue_descr.is_set or
                                                                        self.shared_queue_id.is_set or
                                                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                                def has_operation(self):
                                                                    for c in self.police_stats_array:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    for c in self.queue_stats_array:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    for c in self.wred_stats_array:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.cac_state.yfilter != YFilter.not_set or
                                                                        self.class_name.yfilter != YFilter.not_set or
                                                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                                        self.queue_descr.yfilter != YFilter.not_set or
                                                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "class-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "cac-stats"):
                                                                        if (self.cac_stats is None):
                                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                            self.cac_stats.parent = self
                                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                                        return self.cac_stats

                                                                    if (child_yang_name == "general-stats"):
                                                                        if (self.general_stats is None):
                                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                            self.general_stats.parent = self
                                                                            self._children_name_map["general_stats"] = "general-stats"
                                                                        return self.general_stats

                                                                    if (child_yang_name == "iphc-stats"):
                                                                        if (self.iphc_stats is None):
                                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                            self.iphc_stats.parent = self
                                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                        return self.iphc_stats

                                                                    if (child_yang_name == "police-stats-array"):
                                                                        for c in self.police_stats_array:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.police_stats_array.append(c)
                                                                        return c

                                                                    if (child_yang_name == "queue-stats-array"):
                                                                        for c in self.queue_stats_array:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_stats_array.append(c)
                                                                        return c

                                                                    if (child_yang_name == "wred-stats-array"):
                                                                        for c in self.wred_stats_array:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.wred_stats_array.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "cac-state"):
                                                                        self.cac_state = value
                                                                        self.cac_state.value_namespace = name_space
                                                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "class-name"):
                                                                        self.class_name = value
                                                                        self.class_name.value_namespace = name_space
                                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "counter-validity-bitmask"):
                                                                        self.counter_validity_bitmask = value
                                                                        self.counter_validity_bitmask.value_namespace = name_space
                                                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "queue-descr"):
                                                                        self.queue_descr = value
                                                                        self.queue_descr.value_namespace = name_space
                                                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "shared-queue-id"):
                                                                        self.shared_queue_id = value
                                                                        self.shared_queue_id.value_namespace = name_space
                                                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.class_stats:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.policy_name.is_set or
                                                                    self.satid.is_set or
                                                                    self.state.is_set or
                                                                    self.state_description.is_set)

                                                            def has_operation(self):
                                                                for c in self.class_stats:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.policy_name.yfilter != YFilter.not_set or
                                                                    self.satid.yfilter != YFilter.not_set or
                                                                    self.state.yfilter != YFilter.not_set or
                                                                    self.state_description.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "child-policy" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.state.get_name_leafdata())
                                                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "class-stats"):
                                                                    for c in self.class_stats:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.class_stats.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "policy-name"):
                                                                    self.policy_name = value
                                                                    self.policy_name.value_namespace = name_space
                                                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "satid"):
                                                                    self.satid = value
                                                                    self.satid.value_namespace = name_space
                                                                    self.satid.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "state"):
                                                                    self.state = value
                                                                    self.state.value_namespace = name_space
                                                                    self.state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "state-description"):
                                                                    self.state_description = value
                                                                    self.state_description.value_namespace = name_space
                                                                    self.state_description.value_namespace_prefix = name_space_prefix


                                                        class CacStats(Entity):
                                                            """
                                                            bag for cac stats
                                                            
                                                            .. attribute:: admit_bytes
                                                            
                                                            	Admitted bytes (pkts/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_rates
                                                            
                                                            	CAC admit rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: admitpackets
                                                            
                                                            	Admitted packets (pkts/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	CAC dropped bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	CAC dropped packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_rates
                                                            
                                                            	CAC dropped rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__init__()

                                                                self.yang_name = "cac-stats"
                                                                self.yang_parent_name = "class-stats"

                                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("admit_bytes",
                                                                                "admit_rates",
                                                                                "admitpackets",
                                                                                "drop_bytes",
                                                                                "drop_packets",
                                                                                "drop_rates") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.admit_bytes.is_set or
                                                                    self.admit_rates.is_set or
                                                                    self.admitpackets.is_set or
                                                                    self.drop_bytes.is_set or
                                                                    self.drop_packets.is_set or
                                                                    self.drop_rates.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                                    self.drop_rates.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "cac-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "admit-bytes"):
                                                                    self.admit_bytes = value
                                                                    self.admit_bytes.value_namespace = name_space
                                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "admit-rates"):
                                                                    self.admit_rates = value
                                                                    self.admit_rates.value_namespace = name_space
                                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "admitpackets"):
                                                                    self.admitpackets = value
                                                                    self.admitpackets.value_namespace = name_space
                                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-bytes"):
                                                                    self.drop_bytes = value
                                                                    self.drop_bytes.value_namespace = name_space
                                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-packets"):
                                                                    self.drop_packets = value
                                                                    self.drop_packets.value_namespace = name_space
                                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-rates"):
                                                                    self.drop_rates = value
                                                                    self.drop_rates.value_namespace = name_space
                                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                                        class QueueStatsArray(Entity):
                                                            """
                                                            array of queue stats
                                                            
                                                            .. attribute:: atm_clp0_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp0_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp1_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp1_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: forced_wred_stats_display
                                                            
                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: queue_average_length
                                                            
                                                            	Queue average length
                                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                            
                                                            .. attribute:: queue_drop_threshold
                                                            
                                                            	tail drop threshold of the queue in bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: queue_id
                                                            
                                                            	Queue Id used for Fabric Stats
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_instance_length
                                                            
                                                            	Queue instance length
                                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                            
                                                            .. attribute:: queue_max_length
                                                            
                                                            	Queue maximum length
                                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Bytes probabilistically dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Packets probabilistically dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tail_drop_bytes
                                                            
                                                            	Bytes tail dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tail_drop_packets
                                                            
                                                            	Packets tail dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                                self.yang_name = "queue-stats-array"
                                                                self.yang_parent_name = "class-stats"

                                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                                self.queue_average_length = YList(self)
                                                                self.queue_instance_length = YList(self)
                                                                self.queue_max_length = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("atm_clp0_drop_bytes",
                                                                                "atm_clp0_drop_packets",
                                                                                "atm_clp1_drop_bytes",
                                                                                "atm_clp1_drop_packets",
                                                                                "conform_bytes",
                                                                                "conform_packets",
                                                                                "conform_rate",
                                                                                "exceed_bytes",
                                                                                "exceed_packets",
                                                                                "exceed_rate",
                                                                                "forced_wred_stats_display",
                                                                                "max_threshold_bytes",
                                                                                "max_threshold_packets",
                                                                                "queue_drop_threshold",
                                                                                "queue_id",
                                                                                "random_drop_bytes",
                                                                                "random_drop_packets",
                                                                                "tail_drop_bytes",
                                                                                "tail_drop_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                            class QueueInstanceLength(Entity):
                                                                """
                                                                Queue instance length
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                    self.yang_name = "queue-instance-length"
                                                                    self.yang_parent_name = "queue-stats-array"

                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("unit",
                                                                                    "value") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.unit.is_set or
                                                                        self.value.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.unit.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-instance-length" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "unit" or name == "value"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "unit"):
                                                                        self.unit = value
                                                                        self.unit.value_namespace = name_space
                                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix


                                                            class QueueAverageLength(Entity):
                                                                """
                                                                Queue average length
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                    self.yang_name = "queue-average-length"
                                                                    self.yang_parent_name = "queue-stats-array"

                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("unit",
                                                                                    "value") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.unit.is_set or
                                                                        self.value.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.unit.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-average-length" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "unit" or name == "value"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "unit"):
                                                                        self.unit = value
                                                                        self.unit.value_namespace = name_space
                                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix


                                                            class QueueMaxLength(Entity):
                                                                """
                                                                Queue maximum length
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                    self.yang_name = "queue-max-length"
                                                                    self.yang_parent_name = "queue-stats-array"

                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("unit",
                                                                                    "value") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.unit.is_set or
                                                                        self.value.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.unit.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-max-length" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "unit" or name == "value"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "unit"):
                                                                        self.unit = value
                                                                        self.unit.value_namespace = name_space
                                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.queue_average_length:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.queue_instance_length:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.queue_max_length:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.atm_clp0_drop_bytes.is_set or
                                                                    self.atm_clp0_drop_packets.is_set or
                                                                    self.atm_clp1_drop_bytes.is_set or
                                                                    self.atm_clp1_drop_packets.is_set or
                                                                    self.conform_bytes.is_set or
                                                                    self.conform_packets.is_set or
                                                                    self.conform_rate.is_set or
                                                                    self.exceed_bytes.is_set or
                                                                    self.exceed_packets.is_set or
                                                                    self.exceed_rate.is_set or
                                                                    self.forced_wred_stats_display.is_set or
                                                                    self.max_threshold_bytes.is_set or
                                                                    self.max_threshold_packets.is_set or
                                                                    self.queue_drop_threshold.is_set or
                                                                    self.queue_id.is_set or
                                                                    self.random_drop_bytes.is_set or
                                                                    self.random_drop_packets.is_set or
                                                                    self.tail_drop_bytes.is_set or
                                                                    self.tail_drop_packets.is_set)

                                                            def has_operation(self):
                                                                for c in self.queue_average_length:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.queue_instance_length:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.queue_max_length:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                    self.queue_id.yfilter != YFilter.not_set or
                                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-stats-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "queue-average-length"):
                                                                    for c in self.queue_average_length:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_average_length.append(c)
                                                                    return c

                                                                if (child_yang_name == "queue-instance-length"):
                                                                    for c in self.queue_instance_length:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_instance_length.append(c)
                                                                    return c

                                                                if (child_yang_name == "queue-max-length"):
                                                                    for c in self.queue_max_length:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_max_length.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "atm-clp0-drop-bytes"):
                                                                    self.atm_clp0_drop_bytes = value
                                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "atm-clp0-drop-packets"):
                                                                    self.atm_clp0_drop_packets = value
                                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "atm-clp1-drop-bytes"):
                                                                    self.atm_clp1_drop_bytes = value
                                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "atm-clp1-drop-packets"):
                                                                    self.atm_clp1_drop_packets = value
                                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-bytes"):
                                                                    self.conform_bytes = value
                                                                    self.conform_bytes.value_namespace = name_space
                                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-packets"):
                                                                    self.conform_packets = value
                                                                    self.conform_packets.value_namespace = name_space
                                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-rate"):
                                                                    self.conform_rate = value
                                                                    self.conform_rate.value_namespace = name_space
                                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-bytes"):
                                                                    self.exceed_bytes = value
                                                                    self.exceed_bytes.value_namespace = name_space
                                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-packets"):
                                                                    self.exceed_packets = value
                                                                    self.exceed_packets.value_namespace = name_space
                                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-rate"):
                                                                    self.exceed_rate = value
                                                                    self.exceed_rate.value_namespace = name_space
                                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "forced-wred-stats-display"):
                                                                    self.forced_wred_stats_display = value
                                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "max-threshold-bytes"):
                                                                    self.max_threshold_bytes = value
                                                                    self.max_threshold_bytes.value_namespace = name_space
                                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "max-threshold-packets"):
                                                                    self.max_threshold_packets = value
                                                                    self.max_threshold_packets.value_namespace = name_space
                                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "queue-drop-threshold"):
                                                                    self.queue_drop_threshold = value
                                                                    self.queue_drop_threshold.value_namespace = name_space
                                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "queue-id"):
                                                                    self.queue_id = value
                                                                    self.queue_id.value_namespace = name_space
                                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-bytes"):
                                                                    self.random_drop_bytes = value
                                                                    self.random_drop_bytes.value_namespace = name_space
                                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-packets"):
                                                                    self.random_drop_packets = value
                                                                    self.random_drop_packets.value_namespace = name_space
                                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tail-drop-bytes"):
                                                                    self.tail_drop_bytes = value
                                                                    self.tail_drop_bytes.value_namespace = name_space
                                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tail-drop-packets"):
                                                                    self.tail_drop_packets = value
                                                                    self.tail_drop_packets.value_namespace = name_space
                                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                        class PoliceStatsArray(Entity):
                                                            """
                                                            array of police stats
                                                            
                                                            .. attribute:: color_class_stats
                                                            
                                                            	color class stats
                                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	Police dropped bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	Police dropped packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: parent_drop_bytes
                                                            
                                                            	Dropped bytes by the parent policer
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: parent_drop_packets
                                                            
                                                            	Dropped pkts by the parent policer
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_bytes
                                                            
                                                            	Bytes that violate the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_packets
                                                            
                                                            	Packets violating the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_rate
                                                            
                                                            	Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                                self.yang_name = "police-stats-array"
                                                                self.yang_parent_name = "class-stats"

                                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                self._children_yang_names.add("color-class-stats")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_bytes",
                                                                                "conform_packets",
                                                                                "conform_rate",
                                                                                "drop_bytes",
                                                                                "drop_packets",
                                                                                "exceed_bytes",
                                                                                "exceed_packets",
                                                                                "exceed_rate",
                                                                                "parent_drop_bytes",
                                                                                "parent_drop_packets",
                                                                                "violate_bytes",
                                                                                "violate_packets",
                                                                                "violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                            class ColorClassStats(Entity):
                                                                """
                                                                color class stats
                                                                
                                                                .. attribute:: conform_class_conform_bytes
                                                                
                                                                	Bytes with classification result conform and policer result conform
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_conform_packets
                                                                
                                                                	Packets with classification result conform and policer result conform
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_conform_rate
                                                                
                                                                	Conform Class Conform rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_exceed_bytes
                                                                
                                                                	Bytes with classification result conform and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_exceed_packets
                                                                
                                                                	Packets with classification result conform and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_exceed_rate
                                                                
                                                                	Conform Class Exceed rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_violate_bytes
                                                                
                                                                	Bytes with classification result conform and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_violate_packets
                                                                
                                                                	Packets with classification result conform and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_violate_rate
                                                                
                                                                	Conform Class Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_exceed_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_exceed_packets
                                                                
                                                                	Packets with classification result exceed and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_exceed_rate
                                                                
                                                                	Exceed Class Exceed rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_violate_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_violate_packets
                                                                
                                                                	Packets with classification result exceed and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_violate_rate
                                                                
                                                                	Exceed Class Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_class_violate_bytes
                                                                
                                                                	Bytes with classification result violate and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_class_violate_packets
                                                                
                                                                	Packets with classification result violate and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_class_violate_rate
                                                                
                                                                	Violate Class Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                    self.yang_name = "color-class-stats"
                                                                    self.yang_parent_name = "police-stats-array"

                                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("conform_class_conform_bytes",
                                                                                    "conform_class_conform_packets",
                                                                                    "conform_class_conform_rate",
                                                                                    "conform_class_exceed_bytes",
                                                                                    "conform_class_exceed_packets",
                                                                                    "conform_class_exceed_rate",
                                                                                    "conform_class_violate_bytes",
                                                                                    "conform_class_violate_packets",
                                                                                    "conform_class_violate_rate",
                                                                                    "exceed_class_exceed_bytes",
                                                                                    "exceed_class_exceed_packets",
                                                                                    "exceed_class_exceed_rate",
                                                                                    "exceed_class_violate_bytes",
                                                                                    "exceed_class_violate_packets",
                                                                                    "exceed_class_violate_rate",
                                                                                    "violate_class_violate_bytes",
                                                                                    "violate_class_violate_packets",
                                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.conform_class_conform_bytes.is_set or
                                                                        self.conform_class_conform_packets.is_set or
                                                                        self.conform_class_conform_rate.is_set or
                                                                        self.conform_class_exceed_bytes.is_set or
                                                                        self.conform_class_exceed_packets.is_set or
                                                                        self.conform_class_exceed_rate.is_set or
                                                                        self.conform_class_violate_bytes.is_set or
                                                                        self.conform_class_violate_packets.is_set or
                                                                        self.conform_class_violate_rate.is_set or
                                                                        self.exceed_class_exceed_bytes.is_set or
                                                                        self.exceed_class_exceed_packets.is_set or
                                                                        self.exceed_class_exceed_rate.is_set or
                                                                        self.exceed_class_violate_bytes.is_set or
                                                                        self.exceed_class_violate_packets.is_set or
                                                                        self.exceed_class_violate_rate.is_set or
                                                                        self.violate_class_violate_bytes.is_set or
                                                                        self.violate_class_violate_packets.is_set or
                                                                        self.violate_class_violate_rate.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "color-class-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "conform-class-conform-bytes"):
                                                                        self.conform_class_conform_bytes = value
                                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-conform-packets"):
                                                                        self.conform_class_conform_packets = value
                                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-conform-rate"):
                                                                        self.conform_class_conform_rate = value
                                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-exceed-bytes"):
                                                                        self.conform_class_exceed_bytes = value
                                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-exceed-packets"):
                                                                        self.conform_class_exceed_packets = value
                                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-exceed-rate"):
                                                                        self.conform_class_exceed_rate = value
                                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-violate-bytes"):
                                                                        self.conform_class_violate_bytes = value
                                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-violate-packets"):
                                                                        self.conform_class_violate_packets = value
                                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-violate-rate"):
                                                                        self.conform_class_violate_rate = value
                                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                                        self.exceed_class_exceed_bytes = value
                                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-exceed-packets"):
                                                                        self.exceed_class_exceed_packets = value
                                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-exceed-rate"):
                                                                        self.exceed_class_exceed_rate = value
                                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-violate-bytes"):
                                                                        self.exceed_class_violate_bytes = value
                                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-violate-packets"):
                                                                        self.exceed_class_violate_packets = value
                                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-violate-rate"):
                                                                        self.exceed_class_violate_rate = value
                                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-class-violate-bytes"):
                                                                        self.violate_class_violate_bytes = value
                                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-class-violate-packets"):
                                                                        self.violate_class_violate_packets = value
                                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-class-violate-rate"):
                                                                        self.violate_class_violate_rate = value
                                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_bytes.is_set or
                                                                    self.conform_packets.is_set or
                                                                    self.conform_rate.is_set or
                                                                    self.drop_bytes.is_set or
                                                                    self.drop_packets.is_set or
                                                                    self.exceed_bytes.is_set or
                                                                    self.exceed_packets.is_set or
                                                                    self.exceed_rate.is_set or
                                                                    self.parent_drop_bytes.is_set or
                                                                    self.parent_drop_packets.is_set or
                                                                    self.violate_bytes.is_set or
                                                                    self.violate_packets.is_set or
                                                                    self.violate_rate.is_set or
                                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "police-stats-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "color-class-stats"):
                                                                    if (self.color_class_stats is None):
                                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                        self.color_class_stats.parent = self
                                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    return self.color_class_stats

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-bytes"):
                                                                    self.conform_bytes = value
                                                                    self.conform_bytes.value_namespace = name_space
                                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-packets"):
                                                                    self.conform_packets = value
                                                                    self.conform_packets.value_namespace = name_space
                                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-rate"):
                                                                    self.conform_rate = value
                                                                    self.conform_rate.value_namespace = name_space
                                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-bytes"):
                                                                    self.drop_bytes = value
                                                                    self.drop_bytes.value_namespace = name_space
                                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-packets"):
                                                                    self.drop_packets = value
                                                                    self.drop_packets.value_namespace = name_space
                                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-bytes"):
                                                                    self.exceed_bytes = value
                                                                    self.exceed_bytes.value_namespace = name_space
                                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-packets"):
                                                                    self.exceed_packets = value
                                                                    self.exceed_packets.value_namespace = name_space
                                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-rate"):
                                                                    self.exceed_rate = value
                                                                    self.exceed_rate.value_namespace = name_space
                                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "parent-drop-bytes"):
                                                                    self.parent_drop_bytes = value
                                                                    self.parent_drop_bytes.value_namespace = name_space
                                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "parent-drop-packets"):
                                                                    self.parent_drop_packets = value
                                                                    self.parent_drop_packets.value_namespace = name_space
                                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-bytes"):
                                                                    self.violate_bytes = value
                                                                    self.violate_bytes.value_namespace = name_space
                                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-packets"):
                                                                    self.violate_packets = value
                                                                    self.violate_packets.value_namespace = name_space
                                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-rate"):
                                                                    self.violate_rate = value
                                                                    self.violate_rate.value_namespace = name_space
                                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                                        class WredStatsArray(Entity):
                                                            """
                                                            array of red stats
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: profile_title
                                                            
                                                            	ProfileTitle
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..300
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Probabilisticallydropped bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Probabilistically dropped  packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_ecn_marked_bytes
                                                            
                                                            	ECN marked bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_ecn_marked_packets
                                                            
                                                            	ECN marked packets 
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_label
                                                            
                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                            
                                                            .. attribute:: red_transmit_bytes
                                                            
                                                            	Transmitted bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_transmit_packets
                                                            
                                                            	Transmitted packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                                self.yang_name = "wred-stats-array"
                                                                self.yang_parent_name = "class-stats"

                                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                                self.red_label = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("max_threshold_bytes",
                                                                                "max_threshold_packets",
                                                                                "profile_title",
                                                                                "random_drop_bytes",
                                                                                "random_drop_packets",
                                                                                "red_ecn_marked_bytes",
                                                                                "red_ecn_marked_packets",
                                                                                "red_transmit_bytes",
                                                                                "red_transmit_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                            class RedLabel(Entity):
                                                                """
                                                                Array of WRED Typevalues as in PRP stats is
                                                                available per threshold   
                                                                
                                                                .. attribute:: value
                                                                
                                                                	WRED value for this type
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: wred_type
                                                                
                                                                	WRED type DSCP, EXP, PREC etc
                                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                    self.yang_name = "red-label"
                                                                    self.yang_parent_name = "wred-stats-array"

                                                                    self.value = YLeaf(YType.uint8, "value")

                                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("value",
                                                                                    "wred_type") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.value.is_set or
                                                                        self.wred_type.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set or
                                                                        self.wred_type.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "red-label" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "value" or name == "wred-type"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "wred-type"):
                                                                        self.wred_type = value
                                                                        self.wred_type.value_namespace = name_space
                                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.red_label:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.max_threshold_bytes.is_set or
                                                                    self.max_threshold_packets.is_set or
                                                                    self.profile_title.is_set or
                                                                    self.random_drop_bytes.is_set or
                                                                    self.random_drop_packets.is_set or
                                                                    self.red_ecn_marked_bytes.is_set or
                                                                    self.red_ecn_marked_packets.is_set or
                                                                    self.red_transmit_bytes.is_set or
                                                                    self.red_transmit_packets.is_set)

                                                            def has_operation(self):
                                                                for c in self.red_label:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                    self.profile_title.yfilter != YFilter.not_set or
                                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "wred-stats-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "red-label"):
                                                                    for c in self.red_label:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.red_label.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "max-threshold-bytes"):
                                                                    self.max_threshold_bytes = value
                                                                    self.max_threshold_bytes.value_namespace = name_space
                                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "max-threshold-packets"):
                                                                    self.max_threshold_packets = value
                                                                    self.max_threshold_packets.value_namespace = name_space
                                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "profile-title"):
                                                                    self.profile_title = value
                                                                    self.profile_title.value_namespace = name_space
                                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-bytes"):
                                                                    self.random_drop_bytes = value
                                                                    self.random_drop_bytes.value_namespace = name_space
                                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-packets"):
                                                                    self.random_drop_packets = value
                                                                    self.random_drop_packets.value_namespace = name_space
                                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-ecn-marked-bytes"):
                                                                    self.red_ecn_marked_bytes = value
                                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-ecn-marked-packets"):
                                                                    self.red_ecn_marked_packets = value
                                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-transmit-bytes"):
                                                                    self.red_transmit_bytes = value
                                                                    self.red_transmit_bytes.value_namespace = name_space
                                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-transmit-packets"):
                                                                    self.red_transmit_packets = value
                                                                    self.red_transmit_packets.value_namespace = name_space
                                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.police_stats_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_stats_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.wred_stats_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.cac_state.is_set or
                                                                self.class_name.is_set or
                                                                self.counter_validity_bitmask.is_set or
                                                                self.queue_descr.is_set or
                                                                self.shared_queue_id.is_set or
                                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                                (self.child_policy is not None and self.child_policy.has_data()) or
                                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                        def has_operation(self):
                                                            for c in self.police_stats_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_stats_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.wred_stats_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.cac_state.yfilter != YFilter.not_set or
                                                                self.class_name.yfilter != YFilter.not_set or
                                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                                self.queue_descr.yfilter != YFilter.not_set or
                                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                                (self.child_policy is not None and self.child_policy.has_operation()) or
                                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "class-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "cac-stats"):
                                                                if (self.cac_stats is None):
                                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                                                    self.cac_stats.parent = self
                                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                                return self.cac_stats

                                                            if (child_yang_name == "child-policy"):
                                                                if (self.child_policy is None):
                                                                    self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                                                    self.child_policy.parent = self
                                                                    self._children_name_map["child_policy"] = "child-policy"
                                                                return self.child_policy

                                                            if (child_yang_name == "general-stats"):
                                                                if (self.general_stats is None):
                                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                                                    self.general_stats.parent = self
                                                                    self._children_name_map["general_stats"] = "general-stats"
                                                                return self.general_stats

                                                            if (child_yang_name == "iphc-stats"):
                                                                if (self.iphc_stats is None):
                                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                                                    self.iphc_stats.parent = self
                                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                return self.iphc_stats

                                                            if (child_yang_name == "police-stats-array"):
                                                                for c in self.police_stats_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.police_stats_array.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-stats-array"):
                                                                for c in self.queue_stats_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_stats_array.append(c)
                                                                return c

                                                            if (child_yang_name == "wred-stats-array"):
                                                                for c in self.wred_stats_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.wred_stats_array.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "cac-state"):
                                                                self.cac_state = value
                                                                self.cac_state.value_namespace = name_space
                                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "class-name"):
                                                                self.class_name = value
                                                                self.class_name.value_namespace = name_space
                                                                self.class_name.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "counter-validity-bitmask"):
                                                                self.counter_validity_bitmask = value
                                                                self.counter_validity_bitmask.value_namespace = name_space
                                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-descr"):
                                                                self.queue_descr = value
                                                                self.queue_descr.value_namespace = name_space
                                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "shared-queue-id"):
                                                                self.shared_queue_id = value
                                                                self.shared_queue_id.value_namespace = name_space
                                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.class_stats:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.policy_name.is_set or
                                                            self.satid.is_set or
                                                            self.state.is_set or
                                                            self.state_description.is_set)

                                                    def has_operation(self):
                                                        for c in self.class_stats:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.policy_name.yfilter != YFilter.not_set or
                                                            self.satid.yfilter != YFilter.not_set or
                                                            self.state.yfilter != YFilter.not_set or
                                                            self.state_description.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "statistics" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.state.get_name_leafdata())
                                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "class-stats"):
                                                            for c in self.class_stats:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.class_stats.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "policy-name"):
                                                            self.policy_name = value
                                                            self.policy_name.value_namespace = name_space
                                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "satid"):
                                                            self.satid = value
                                                            self.satid.value_namespace = name_space
                                                            self.satid.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "state"):
                                                            self.state = value
                                                            self.state.value_namespace = name_space
                                                            self.state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "state-description"):
                                                            self.state_description = value
                                                            self.state_description.value_namespace = name_space
                                                            self.state_description.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                                        (self.statistics is not None and self.statistics.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                                        (self.statistics is not None and self.statistics.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "output" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "service-policy-names"):
                                                        if (self.service_policy_names is None):
                                                            self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                                            self.service_policy_names.parent = self
                                                            self._children_name_map["service_policy_names"] = "service-policy-names"
                                                        return self.service_policy_names

                                                    if (child_yang_name == "statistics"):
                                                        if (self.statistics is None):
                                                            self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics()
                                                            self.statistics.parent = self
                                                            self._children_name_map["statistics"] = "statistics"
                                                        return self.statistics

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "service-policy-names" or name == "statistics"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    self.nv_satellite_id.is_set or
                                                    (self.input is not None and self.input.has_data()) or
                                                    (self.output is not None and self.output.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.nv_satellite_id.yfilter != YFilter.not_set or
                                                    (self.input is not None and self.input.has_operation()) or
                                                    (self.output is not None and self.output.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "satellite-id" + "[nv-satellite-id='" + self.nv_satellite_id.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.nv_satellite_id.is_set or self.nv_satellite_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nv_satellite_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "input"):
                                                    if (self.input is None):
                                                        self.input = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                                        self.input.parent = self
                                                        self._children_name_map["input"] = "input"
                                                    return self.input

                                                if (child_yang_name == "output"):
                                                    if (self.output is None):
                                                        self.output = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                                        self.output.parent = self
                                                        self._children_name_map["output"] = "output"
                                                    return self.output

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "input" or name == "output" or name == "nv-satellite-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "nv-satellite-id"):
                                                    self.nv_satellite_id = value
                                                    self.nv_satellite_id.value_namespace = name_space
                                                    self.nv_satellite_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.satellite_id:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.satellite_id:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "satellite-ids" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "satellite-id"):
                                                for c in self.satellite_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.satellite_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "satellite-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Input(Entity):
                                        """
                                        A piece of QoS policy\-map operational data for
                                        an interface
                                        
                                        .. attribute:: service_policy_names
                                        
                                        	Operational data for all Policy instance
                                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames>`
                                        
                                        .. attribute:: statistics
                                        
                                        	Policy\-map statistics operational data for an interface
                                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input, self).__init__()

                                            self.yang_name = "input"
                                            self.yang_parent_name = "member-interface"

                                            self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                                            self.service_policy_names.parent = self
                                            self._children_name_map["service_policy_names"] = "service-policy-names"
                                            self._children_yang_names.add("service-policy-names")

                                            self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                            self._children_yang_names.add("statistics")


                                        class ServicePolicyNames(Entity):
                                            """
                                            Operational data for all Policy instance
                                            
                                            .. attribute:: service_policy_instance
                                            
                                            	QoS policy\-map operational data for a particular Policy 
                                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__init__()

                                                self.yang_name = "service-policy-names"
                                                self.yang_parent_name = "input"

                                                self.service_policy_instance = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__setattr__(name, value)


                                            class ServicePolicyInstance(Entity):
                                                """
                                                QoS policy\-map operational data for a
                                                particular Policy 
                                                
                                                .. attribute:: service_policy_name  <key>
                                                
                                                	Name of the policy instance
                                                	**type**\:  str
                                                
                                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                    self.yang_name = "service-policy-instance"
                                                    self.yang_parent_name = "service-policy-names"

                                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("service_policy_name") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.service_policy_name.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.service_policy_name.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "service-policy-name"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "service-policy-name"):
                                                        self.service_policy_name = value
                                                        self.service_policy_name.value_namespace = name_space
                                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.service_policy_instance:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.service_policy_instance:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "service-policy-names" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "service-policy-instance"):
                                                    for c in self.service_policy_instance:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.service_policy_instance.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-instance"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class Statistics(Entity):
                                            """
                                            Policy\-map statistics operational data for an
                                            interface
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\:  str
                                            
                                            	**length:** 0..128
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics, self).__init__()

                                                self.yang_name = "statistics"
                                                self.yang_parent_name = "input"

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.satid = YLeaf(YType.uint32, "satid")

                                                self.state = YLeaf(YType.enumeration, "state")

                                                self.state_description = YLeaf(YType.str, "state-description")

                                                self.class_stats = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("policy_name",
                                                                "satid",
                                                                "state",
                                                                "state_description") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics, self).__setattr__(name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats>`
                                                
                                                .. attribute:: child_policy
                                                
                                                	child policy
                                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy>`
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\:  str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "statistics"

                                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                    self._children_yang_names.add("cac-stats")

                                                    self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"
                                                    self._children_yang_names.add("child-policy")

                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                    self._children_yang_names.add("general-stats")

                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    self._children_yang_names.add("iphc-stats")

                                                    self.police_stats_array = YList(self)
                                                    self.queue_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("cac_state",
                                                                    "class_name",
                                                                    "counter_validity_bitmask",
                                                                    "queue_descr",
                                                                    "shared_queue_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("match_data_rate",
                                                                        "pre_policy_matched_bytes",
                                                                        "pre_policy_matched_packets",
                                                                        "total_drop_bytes",
                                                                        "total_drop_packets",
                                                                        "total_drop_rate",
                                                                        "total_transmit_rate",
                                                                        "transmit_bytes",
                                                                        "transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.match_data_rate.is_set or
                                                            self.pre_policy_matched_bytes.is_set or
                                                            self.pre_policy_matched_packets.is_set or
                                                            self.total_drop_bytes.is_set or
                                                            self.total_drop_packets.is_set or
                                                            self.total_drop_rate.is_set or
                                                            self.total_transmit_rate.is_set or
                                                            self.transmit_bytes.is_set or
                                                            self.transmit_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.match_data_rate.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                                            self.transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "general-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "match-data-rate"):
                                                            self.match_data_rate = value
                                                            self.match_data_rate.value_namespace = name_space
                                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-bytes"):
                                                            self.pre_policy_matched_bytes = value
                                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-packets"):
                                                            self.pre_policy_matched_packets = value
                                                            self.pre_policy_matched_packets.value_namespace = name_space
                                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-bytes"):
                                                            self.total_drop_bytes = value
                                                            self.total_drop_bytes.value_namespace = name_space
                                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-packets"):
                                                            self.total_drop_packets = value
                                                            self.total_drop_packets.value_namespace = name_space
                                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-rate"):
                                                            self.total_drop_rate = value
                                                            self.total_drop_rate.value_namespace = name_space
                                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-transmit-rate"):
                                                            self.total_transmit_rate = value
                                                            self.total_transmit_rate.value_namespace = name_space
                                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-bytes"):
                                                            self.transmit_bytes = value
                                                            self.transmit_bytes.value_namespace = name_space
                                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-packets"):
                                                            self.transmit_packets = value
                                                            self.transmit_packets.value_namespace = name_space
                                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("non_tcp_bytes_saved",
                                                                        "non_tcp_bytes_sent_rate",
                                                                        "non_tcp_compressed_packets_out",
                                                                        "non_tcp_full_header_packets_out",
                                                                        "non_tcp_total_out_bytes",
                                                                        "non_tcp_total_out_packets",
                                                                        "tcp_bytes_saved",
                                                                        "tcp_bytes_sent_rate",
                                                                        "tcp_compressed_packets_out",
                                                                        "tcp_full_header_packets_out",
                                                                        "tcp_total_out_bytes",
                                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.non_tcp_bytes_saved.is_set or
                                                            self.non_tcp_bytes_sent_rate.is_set or
                                                            self.non_tcp_compressed_packets_out.is_set or
                                                            self.non_tcp_full_header_packets_out.is_set or
                                                            self.non_tcp_total_out_bytes.is_set or
                                                            self.non_tcp_total_out_packets.is_set or
                                                            self.tcp_bytes_saved.is_set or
                                                            self.tcp_bytes_sent_rate.is_set or
                                                            self.tcp_compressed_packets_out.is_set or
                                                            self.tcp_full_header_packets_out.is_set or
                                                            self.tcp_total_out_bytes.is_set or
                                                            self.tcp_total_out_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "iphc-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "non-tcp-bytes-saved"):
                                                            self.non_tcp_bytes_saved = value
                                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                                            self.non_tcp_bytes_sent_rate = value
                                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-compressed-packets-out"):
                                                            self.non_tcp_compressed_packets_out = value
                                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-full-header-packets-out"):
                                                            self.non_tcp_full_header_packets_out = value
                                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-bytes"):
                                                            self.non_tcp_total_out_bytes = value
                                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-packets"):
                                                            self.non_tcp_total_out_packets = value
                                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-saved"):
                                                            self.tcp_bytes_saved = value
                                                            self.tcp_bytes_saved.value_namespace = name_space
                                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-sent-rate"):
                                                            self.tcp_bytes_sent_rate = value
                                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-compressed-packets-out"):
                                                            self.tcp_compressed_packets_out = value
                                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-full-header-packets-out"):
                                                            self.tcp_full_header_packets_out = value
                                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-bytes"):
                                                            self.tcp_total_out_bytes = value
                                                            self.tcp_total_out_bytes.value_namespace = name_space
                                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-packets"):
                                                            self.tcp_total_out_packets = value
                                                            self.tcp_total_out_packets.value_namespace = name_space
                                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                class ChildPolicy(Entity):
                                                    """
                                                    child policy
                                                    
                                                    .. attribute:: class_stats
                                                    
                                                    	array of classes contained in policy
                                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                    
                                                    .. attribute:: policy_name
                                                    
                                                    	PolicyName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: satid
                                                    
                                                    	to maintain satellite id
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: state
                                                    
                                                    	State
                                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                    
                                                    .. attribute:: state_description
                                                    
                                                    	StateDescription
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..128
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                        self.yang_name = "child-policy"
                                                        self.yang_parent_name = "class-stats"

                                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                                        self.satid = YLeaf(YType.uint32, "satid")

                                                        self.state = YLeaf(YType.enumeration, "state")

                                                        self.state_description = YLeaf(YType.str, "state-description")

                                                        self.class_stats = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("policy_name",
                                                                        "satid",
                                                                        "state",
                                                                        "state_description") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                    class ClassStats(Entity):
                                                        """
                                                        array of classes contained in policy
                                                        
                                                        .. attribute:: cac_state
                                                        
                                                        	CACState
                                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                        
                                                        .. attribute:: cac_stats
                                                        
                                                        	bag for cac stats
                                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	ClassName
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: counter_validity_bitmask
                                                        
                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: megabyte
                                                        
                                                        .. attribute:: general_stats
                                                        
                                                        	general stats
                                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                        
                                                        .. attribute:: iphc_stats
                                                        
                                                        	IPHC stats
                                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                        
                                                        .. attribute:: police_stats_array
                                                        
                                                        	array of police stats
                                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                        
                                                        .. attribute:: queue_descr
                                                        
                                                        	Description of queue for the class
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..256
                                                        
                                                        .. attribute:: queue_stats_array
                                                        
                                                        	array of queue stats
                                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                        
                                                        .. attribute:: shared_queue_id
                                                        
                                                        	q\-id of the  shared queue for this class
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: wred_stats_array
                                                        
                                                        	array of red stats
                                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                            self.yang_name = "class-stats"
                                                            self.yang_parent_name = "child-policy"

                                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                            self.class_name = YLeaf(YType.str, "class-name")

                                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                            self._children_yang_names.add("cac-stats")

                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"
                                                            self._children_yang_names.add("general-stats")

                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            self._children_yang_names.add("iphc-stats")

                                                            self.police_stats_array = YList(self)
                                                            self.queue_stats_array = YList(self)
                                                            self.wred_stats_array = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("cac_state",
                                                                            "class_name",
                                                                            "counter_validity_bitmask",
                                                                            "queue_descr",
                                                                            "shared_queue_id") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                        class GeneralStats(Entity):
                                                            """
                                                            general stats
                                                            
                                                            .. attribute:: match_data_rate
                                                            
                                                            	Incoming matched data rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: pre_policy_matched_bytes
                                                            
                                                            	Matched bytes before applying policy
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: pre_policy_matched_packets
                                                            
                                                            	Matched pkts before applying policy
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: total_drop_bytes
                                                            
                                                            	Dropped bytes (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_packets
                                                            
                                                            	Dropped packets (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_rate
                                                            
                                                            	Total drop rate (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_transmit_rate
                                                            
                                                            	Total transmit rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: transmit_bytes
                                                            
                                                            	Transmitted bytes (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: transmit_packets
                                                            
                                                            	Transmitted packets (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                                self.yang_name = "general-stats"
                                                                self.yang_parent_name = "class-stats"

                                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("match_data_rate",
                                                                                "pre_policy_matched_bytes",
                                                                                "pre_policy_matched_packets",
                                                                                "total_drop_bytes",
                                                                                "total_drop_packets",
                                                                                "total_drop_rate",
                                                                                "total_transmit_rate",
                                                                                "transmit_bytes",
                                                                                "transmit_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.match_data_rate.is_set or
                                                                    self.pre_policy_matched_bytes.is_set or
                                                                    self.pre_policy_matched_packets.is_set or
                                                                    self.total_drop_bytes.is_set or
                                                                    self.total_drop_packets.is_set or
                                                                    self.total_drop_rate.is_set or
                                                                    self.total_transmit_rate.is_set or
                                                                    self.transmit_bytes.is_set or
                                                                    self.transmit_packets.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "general-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "match-data-rate"):
                                                                    self.match_data_rate = value
                                                                    self.match_data_rate.value_namespace = name_space
                                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "pre-policy-matched-bytes"):
                                                                    self.pre_policy_matched_bytes = value
                                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "pre-policy-matched-packets"):
                                                                    self.pre_policy_matched_packets = value
                                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-drop-bytes"):
                                                                    self.total_drop_bytes = value
                                                                    self.total_drop_bytes.value_namespace = name_space
                                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-drop-packets"):
                                                                    self.total_drop_packets = value
                                                                    self.total_drop_packets.value_namespace = name_space
                                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-drop-rate"):
                                                                    self.total_drop_rate = value
                                                                    self.total_drop_rate.value_namespace = name_space
                                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-transmit-rate"):
                                                                    self.total_transmit_rate = value
                                                                    self.total_transmit_rate.value_namespace = name_space
                                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "transmit-bytes"):
                                                                    self.transmit_bytes = value
                                                                    self.transmit_bytes.value_namespace = name_space
                                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "transmit-packets"):
                                                                    self.transmit_packets = value
                                                                    self.transmit_packets.value_namespace = name_space
                                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                        class IphcStats(Entity):
                                                            """
                                                            IPHC stats
                                                            
                                                            .. attribute:: non_tcp_bytes_saved
                                                            
                                                            	Non Tcp Bytes saved due to compression
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                            
                                                            	Compressed Non Tcp Bytes sent rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_compressed_packets_out
                                                            
                                                            	Num of non tcp compressed pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_full_header_packets_out
                                                            
                                                            	Num of non tcp fullheader pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_total_out_bytes
                                                            
                                                            	TotalNum of Non Tcp Bytes sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_total_out_packets
                                                            
                                                            	TotalNum of Non tcp pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_bytes_saved
                                                            
                                                            	Tcp Bytes saved due to compression
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_bytes_sent_rate
                                                            
                                                            	Compressed Tcp Bytes sent rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_compressed_packets_out
                                                            
                                                            	Num of tcp compressed pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_full_header_packets_out
                                                            
                                                            	Num of tcp fullheader pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_bytes
                                                            
                                                            	TotalNum of Tcp Bytes sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_total_out_packets
                                                            
                                                            	Total Num of tcp pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                                self.yang_name = "iphc-stats"
                                                                self.yang_parent_name = "class-stats"

                                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("non_tcp_bytes_saved",
                                                                                "non_tcp_bytes_sent_rate",
                                                                                "non_tcp_compressed_packets_out",
                                                                                "non_tcp_full_header_packets_out",
                                                                                "non_tcp_total_out_bytes",
                                                                                "non_tcp_total_out_packets",
                                                                                "tcp_bytes_saved",
                                                                                "tcp_bytes_sent_rate",
                                                                                "tcp_compressed_packets_out",
                                                                                "tcp_full_header_packets_out",
                                                                                "tcp_total_out_bytes",
                                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.non_tcp_bytes_saved.is_set or
                                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                                    self.non_tcp_compressed_packets_out.is_set or
                                                                    self.non_tcp_full_header_packets_out.is_set or
                                                                    self.non_tcp_total_out_bytes.is_set or
                                                                    self.non_tcp_total_out_packets.is_set or
                                                                    self.tcp_bytes_saved.is_set or
                                                                    self.tcp_bytes_sent_rate.is_set or
                                                                    self.tcp_compressed_packets_out.is_set or
                                                                    self.tcp_full_header_packets_out.is_set or
                                                                    self.tcp_total_out_bytes.is_set or
                                                                    self.tcp_total_out_packets.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "iphc-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "non-tcp-bytes-saved"):
                                                                    self.non_tcp_bytes_saved = value
                                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                                    self.non_tcp_bytes_sent_rate = value
                                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                                    self.non_tcp_compressed_packets_out = value
                                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                                    self.non_tcp_full_header_packets_out = value
                                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-total-out-bytes"):
                                                                    self.non_tcp_total_out_bytes = value
                                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-total-out-packets"):
                                                                    self.non_tcp_total_out_packets = value
                                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-bytes-saved"):
                                                                    self.tcp_bytes_saved = value
                                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-bytes-sent-rate"):
                                                                    self.tcp_bytes_sent_rate = value
                                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-compressed-packets-out"):
                                                                    self.tcp_compressed_packets_out = value
                                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-full-header-packets-out"):
                                                                    self.tcp_full_header_packets_out = value
                                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-total-out-bytes"):
                                                                    self.tcp_total_out_bytes = value
                                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-total-out-packets"):
                                                                    self.tcp_total_out_packets = value
                                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                        class CacStats(Entity):
                                                            """
                                                            bag for cac stats
                                                            
                                                            .. attribute:: admit_bytes
                                                            
                                                            	Admitted bytes (pkts/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_rates
                                                            
                                                            	CAC admit rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: admitpackets
                                                            
                                                            	Admitted packets (pkts/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	CAC dropped bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	CAC dropped packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_rates
                                                            
                                                            	CAC dropped rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                                self.yang_name = "cac-stats"
                                                                self.yang_parent_name = "class-stats"

                                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("admit_bytes",
                                                                                "admit_rates",
                                                                                "admitpackets",
                                                                                "drop_bytes",
                                                                                "drop_packets",
                                                                                "drop_rates") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.admit_bytes.is_set or
                                                                    self.admit_rates.is_set or
                                                                    self.admitpackets.is_set or
                                                                    self.drop_bytes.is_set or
                                                                    self.drop_packets.is_set or
                                                                    self.drop_rates.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                                    self.drop_rates.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "cac-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "admit-bytes"):
                                                                    self.admit_bytes = value
                                                                    self.admit_bytes.value_namespace = name_space
                                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "admit-rates"):
                                                                    self.admit_rates = value
                                                                    self.admit_rates.value_namespace = name_space
                                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "admitpackets"):
                                                                    self.admitpackets = value
                                                                    self.admitpackets.value_namespace = name_space
                                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-bytes"):
                                                                    self.drop_bytes = value
                                                                    self.drop_bytes.value_namespace = name_space
                                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-packets"):
                                                                    self.drop_packets = value
                                                                    self.drop_packets.value_namespace = name_space
                                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-rates"):
                                                                    self.drop_rates = value
                                                                    self.drop_rates.value_namespace = name_space
                                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                                        class QueueStatsArray(Entity):
                                                            """
                                                            array of queue stats
                                                            
                                                            .. attribute:: atm_clp0_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp0_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp1_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp1_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: forced_wred_stats_display
                                                            
                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: queue_average_length
                                                            
                                                            	Queue average length
                                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                            
                                                            .. attribute:: queue_drop_threshold
                                                            
                                                            	tail drop threshold of the queue in bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: queue_id
                                                            
                                                            	Queue Id used for Fabric Stats
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_instance_length
                                                            
                                                            	Queue instance length
                                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                            
                                                            .. attribute:: queue_max_length
                                                            
                                                            	Queue maximum length
                                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Bytes probabilistically dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Packets probabilistically dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tail_drop_bytes
                                                            
                                                            	Bytes tail dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tail_drop_packets
                                                            
                                                            	Packets tail dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                                self.yang_name = "queue-stats-array"
                                                                self.yang_parent_name = "class-stats"

                                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                                self.queue_average_length = YList(self)
                                                                self.queue_instance_length = YList(self)
                                                                self.queue_max_length = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("atm_clp0_drop_bytes",
                                                                                "atm_clp0_drop_packets",
                                                                                "atm_clp1_drop_bytes",
                                                                                "atm_clp1_drop_packets",
                                                                                "conform_bytes",
                                                                                "conform_packets",
                                                                                "conform_rate",
                                                                                "exceed_bytes",
                                                                                "exceed_packets",
                                                                                "exceed_rate",
                                                                                "forced_wred_stats_display",
                                                                                "max_threshold_bytes",
                                                                                "max_threshold_packets",
                                                                                "queue_drop_threshold",
                                                                                "queue_id",
                                                                                "random_drop_bytes",
                                                                                "random_drop_packets",
                                                                                "tail_drop_bytes",
                                                                                "tail_drop_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                            class QueueInstanceLength(Entity):
                                                                """
                                                                Queue instance length
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                    self.yang_name = "queue-instance-length"
                                                                    self.yang_parent_name = "queue-stats-array"

                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("unit",
                                                                                    "value") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.unit.is_set or
                                                                        self.value.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.unit.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-instance-length" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "unit" or name == "value"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "unit"):
                                                                        self.unit = value
                                                                        self.unit.value_namespace = name_space
                                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix


                                                            class QueueAverageLength(Entity):
                                                                """
                                                                Queue average length
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                    self.yang_name = "queue-average-length"
                                                                    self.yang_parent_name = "queue-stats-array"

                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("unit",
                                                                                    "value") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.unit.is_set or
                                                                        self.value.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.unit.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-average-length" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "unit" or name == "value"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "unit"):
                                                                        self.unit = value
                                                                        self.unit.value_namespace = name_space
                                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix


                                                            class QueueMaxLength(Entity):
                                                                """
                                                                Queue maximum length
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                    self.yang_name = "queue-max-length"
                                                                    self.yang_parent_name = "queue-stats-array"

                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("unit",
                                                                                    "value") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.unit.is_set or
                                                                        self.value.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.unit.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-max-length" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "unit" or name == "value"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "unit"):
                                                                        self.unit = value
                                                                        self.unit.value_namespace = name_space
                                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.queue_average_length:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.queue_instance_length:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.queue_max_length:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.atm_clp0_drop_bytes.is_set or
                                                                    self.atm_clp0_drop_packets.is_set or
                                                                    self.atm_clp1_drop_bytes.is_set or
                                                                    self.atm_clp1_drop_packets.is_set or
                                                                    self.conform_bytes.is_set or
                                                                    self.conform_packets.is_set or
                                                                    self.conform_rate.is_set or
                                                                    self.exceed_bytes.is_set or
                                                                    self.exceed_packets.is_set or
                                                                    self.exceed_rate.is_set or
                                                                    self.forced_wred_stats_display.is_set or
                                                                    self.max_threshold_bytes.is_set or
                                                                    self.max_threshold_packets.is_set or
                                                                    self.queue_drop_threshold.is_set or
                                                                    self.queue_id.is_set or
                                                                    self.random_drop_bytes.is_set or
                                                                    self.random_drop_packets.is_set or
                                                                    self.tail_drop_bytes.is_set or
                                                                    self.tail_drop_packets.is_set)

                                                            def has_operation(self):
                                                                for c in self.queue_average_length:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.queue_instance_length:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.queue_max_length:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                    self.queue_id.yfilter != YFilter.not_set or
                                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-stats-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "queue-average-length"):
                                                                    for c in self.queue_average_length:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_average_length.append(c)
                                                                    return c

                                                                if (child_yang_name == "queue-instance-length"):
                                                                    for c in self.queue_instance_length:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_instance_length.append(c)
                                                                    return c

                                                                if (child_yang_name == "queue-max-length"):
                                                                    for c in self.queue_max_length:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_max_length.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "atm-clp0-drop-bytes"):
                                                                    self.atm_clp0_drop_bytes = value
                                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "atm-clp0-drop-packets"):
                                                                    self.atm_clp0_drop_packets = value
                                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "atm-clp1-drop-bytes"):
                                                                    self.atm_clp1_drop_bytes = value
                                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "atm-clp1-drop-packets"):
                                                                    self.atm_clp1_drop_packets = value
                                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-bytes"):
                                                                    self.conform_bytes = value
                                                                    self.conform_bytes.value_namespace = name_space
                                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-packets"):
                                                                    self.conform_packets = value
                                                                    self.conform_packets.value_namespace = name_space
                                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-rate"):
                                                                    self.conform_rate = value
                                                                    self.conform_rate.value_namespace = name_space
                                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-bytes"):
                                                                    self.exceed_bytes = value
                                                                    self.exceed_bytes.value_namespace = name_space
                                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-packets"):
                                                                    self.exceed_packets = value
                                                                    self.exceed_packets.value_namespace = name_space
                                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-rate"):
                                                                    self.exceed_rate = value
                                                                    self.exceed_rate.value_namespace = name_space
                                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "forced-wred-stats-display"):
                                                                    self.forced_wred_stats_display = value
                                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "max-threshold-bytes"):
                                                                    self.max_threshold_bytes = value
                                                                    self.max_threshold_bytes.value_namespace = name_space
                                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "max-threshold-packets"):
                                                                    self.max_threshold_packets = value
                                                                    self.max_threshold_packets.value_namespace = name_space
                                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "queue-drop-threshold"):
                                                                    self.queue_drop_threshold = value
                                                                    self.queue_drop_threshold.value_namespace = name_space
                                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "queue-id"):
                                                                    self.queue_id = value
                                                                    self.queue_id.value_namespace = name_space
                                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-bytes"):
                                                                    self.random_drop_bytes = value
                                                                    self.random_drop_bytes.value_namespace = name_space
                                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-packets"):
                                                                    self.random_drop_packets = value
                                                                    self.random_drop_packets.value_namespace = name_space
                                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tail-drop-bytes"):
                                                                    self.tail_drop_bytes = value
                                                                    self.tail_drop_bytes.value_namespace = name_space
                                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tail-drop-packets"):
                                                                    self.tail_drop_packets = value
                                                                    self.tail_drop_packets.value_namespace = name_space
                                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                        class PoliceStatsArray(Entity):
                                                            """
                                                            array of police stats
                                                            
                                                            .. attribute:: color_class_stats
                                                            
                                                            	color class stats
                                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	Police dropped bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	Police dropped packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: parent_drop_bytes
                                                            
                                                            	Dropped bytes by the parent policer
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: parent_drop_packets
                                                            
                                                            	Dropped pkts by the parent policer
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_bytes
                                                            
                                                            	Bytes that violate the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_packets
                                                            
                                                            	Packets violating the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_rate
                                                            
                                                            	Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                                self.yang_name = "police-stats-array"
                                                                self.yang_parent_name = "class-stats"

                                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                self._children_yang_names.add("color-class-stats")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_bytes",
                                                                                "conform_packets",
                                                                                "conform_rate",
                                                                                "drop_bytes",
                                                                                "drop_packets",
                                                                                "exceed_bytes",
                                                                                "exceed_packets",
                                                                                "exceed_rate",
                                                                                "parent_drop_bytes",
                                                                                "parent_drop_packets",
                                                                                "violate_bytes",
                                                                                "violate_packets",
                                                                                "violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                            class ColorClassStats(Entity):
                                                                """
                                                                color class stats
                                                                
                                                                .. attribute:: conform_class_conform_bytes
                                                                
                                                                	Bytes with classification result conform and policer result conform
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_conform_packets
                                                                
                                                                	Packets with classification result conform and policer result conform
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_conform_rate
                                                                
                                                                	Conform Class Conform rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_exceed_bytes
                                                                
                                                                	Bytes with classification result conform and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_exceed_packets
                                                                
                                                                	Packets with classification result conform and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_exceed_rate
                                                                
                                                                	Conform Class Exceed rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_violate_bytes
                                                                
                                                                	Bytes with classification result conform and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_violate_packets
                                                                
                                                                	Packets with classification result conform and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_violate_rate
                                                                
                                                                	Conform Class Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_exceed_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_exceed_packets
                                                                
                                                                	Packets with classification result exceed and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_exceed_rate
                                                                
                                                                	Exceed Class Exceed rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_violate_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_violate_packets
                                                                
                                                                	Packets with classification result exceed and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_violate_rate
                                                                
                                                                	Exceed Class Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_class_violate_bytes
                                                                
                                                                	Bytes with classification result violate and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_class_violate_packets
                                                                
                                                                	Packets with classification result violate and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_class_violate_rate
                                                                
                                                                	Violate Class Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                    self.yang_name = "color-class-stats"
                                                                    self.yang_parent_name = "police-stats-array"

                                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("conform_class_conform_bytes",
                                                                                    "conform_class_conform_packets",
                                                                                    "conform_class_conform_rate",
                                                                                    "conform_class_exceed_bytes",
                                                                                    "conform_class_exceed_packets",
                                                                                    "conform_class_exceed_rate",
                                                                                    "conform_class_violate_bytes",
                                                                                    "conform_class_violate_packets",
                                                                                    "conform_class_violate_rate",
                                                                                    "exceed_class_exceed_bytes",
                                                                                    "exceed_class_exceed_packets",
                                                                                    "exceed_class_exceed_rate",
                                                                                    "exceed_class_violate_bytes",
                                                                                    "exceed_class_violate_packets",
                                                                                    "exceed_class_violate_rate",
                                                                                    "violate_class_violate_bytes",
                                                                                    "violate_class_violate_packets",
                                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.conform_class_conform_bytes.is_set or
                                                                        self.conform_class_conform_packets.is_set or
                                                                        self.conform_class_conform_rate.is_set or
                                                                        self.conform_class_exceed_bytes.is_set or
                                                                        self.conform_class_exceed_packets.is_set or
                                                                        self.conform_class_exceed_rate.is_set or
                                                                        self.conform_class_violate_bytes.is_set or
                                                                        self.conform_class_violate_packets.is_set or
                                                                        self.conform_class_violate_rate.is_set or
                                                                        self.exceed_class_exceed_bytes.is_set or
                                                                        self.exceed_class_exceed_packets.is_set or
                                                                        self.exceed_class_exceed_rate.is_set or
                                                                        self.exceed_class_violate_bytes.is_set or
                                                                        self.exceed_class_violate_packets.is_set or
                                                                        self.exceed_class_violate_rate.is_set or
                                                                        self.violate_class_violate_bytes.is_set or
                                                                        self.violate_class_violate_packets.is_set or
                                                                        self.violate_class_violate_rate.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "color-class-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "conform-class-conform-bytes"):
                                                                        self.conform_class_conform_bytes = value
                                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-conform-packets"):
                                                                        self.conform_class_conform_packets = value
                                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-conform-rate"):
                                                                        self.conform_class_conform_rate = value
                                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-exceed-bytes"):
                                                                        self.conform_class_exceed_bytes = value
                                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-exceed-packets"):
                                                                        self.conform_class_exceed_packets = value
                                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-exceed-rate"):
                                                                        self.conform_class_exceed_rate = value
                                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-violate-bytes"):
                                                                        self.conform_class_violate_bytes = value
                                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-violate-packets"):
                                                                        self.conform_class_violate_packets = value
                                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-violate-rate"):
                                                                        self.conform_class_violate_rate = value
                                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                                        self.exceed_class_exceed_bytes = value
                                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-exceed-packets"):
                                                                        self.exceed_class_exceed_packets = value
                                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-exceed-rate"):
                                                                        self.exceed_class_exceed_rate = value
                                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-violate-bytes"):
                                                                        self.exceed_class_violate_bytes = value
                                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-violate-packets"):
                                                                        self.exceed_class_violate_packets = value
                                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-violate-rate"):
                                                                        self.exceed_class_violate_rate = value
                                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-class-violate-bytes"):
                                                                        self.violate_class_violate_bytes = value
                                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-class-violate-packets"):
                                                                        self.violate_class_violate_packets = value
                                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-class-violate-rate"):
                                                                        self.violate_class_violate_rate = value
                                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_bytes.is_set or
                                                                    self.conform_packets.is_set or
                                                                    self.conform_rate.is_set or
                                                                    self.drop_bytes.is_set or
                                                                    self.drop_packets.is_set or
                                                                    self.exceed_bytes.is_set or
                                                                    self.exceed_packets.is_set or
                                                                    self.exceed_rate.is_set or
                                                                    self.parent_drop_bytes.is_set or
                                                                    self.parent_drop_packets.is_set or
                                                                    self.violate_bytes.is_set or
                                                                    self.violate_packets.is_set or
                                                                    self.violate_rate.is_set or
                                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "police-stats-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "color-class-stats"):
                                                                    if (self.color_class_stats is None):
                                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                        self.color_class_stats.parent = self
                                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    return self.color_class_stats

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-bytes"):
                                                                    self.conform_bytes = value
                                                                    self.conform_bytes.value_namespace = name_space
                                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-packets"):
                                                                    self.conform_packets = value
                                                                    self.conform_packets.value_namespace = name_space
                                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-rate"):
                                                                    self.conform_rate = value
                                                                    self.conform_rate.value_namespace = name_space
                                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-bytes"):
                                                                    self.drop_bytes = value
                                                                    self.drop_bytes.value_namespace = name_space
                                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-packets"):
                                                                    self.drop_packets = value
                                                                    self.drop_packets.value_namespace = name_space
                                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-bytes"):
                                                                    self.exceed_bytes = value
                                                                    self.exceed_bytes.value_namespace = name_space
                                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-packets"):
                                                                    self.exceed_packets = value
                                                                    self.exceed_packets.value_namespace = name_space
                                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-rate"):
                                                                    self.exceed_rate = value
                                                                    self.exceed_rate.value_namespace = name_space
                                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "parent-drop-bytes"):
                                                                    self.parent_drop_bytes = value
                                                                    self.parent_drop_bytes.value_namespace = name_space
                                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "parent-drop-packets"):
                                                                    self.parent_drop_packets = value
                                                                    self.parent_drop_packets.value_namespace = name_space
                                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-bytes"):
                                                                    self.violate_bytes = value
                                                                    self.violate_bytes.value_namespace = name_space
                                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-packets"):
                                                                    self.violate_packets = value
                                                                    self.violate_packets.value_namespace = name_space
                                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-rate"):
                                                                    self.violate_rate = value
                                                                    self.violate_rate.value_namespace = name_space
                                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                                        class WredStatsArray(Entity):
                                                            """
                                                            array of red stats
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: profile_title
                                                            
                                                            	ProfileTitle
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..300
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Probabilisticallydropped bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Probabilistically dropped  packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_ecn_marked_bytes
                                                            
                                                            	ECN marked bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_ecn_marked_packets
                                                            
                                                            	ECN marked packets 
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_label
                                                            
                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                            
                                                            .. attribute:: red_transmit_bytes
                                                            
                                                            	Transmitted bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_transmit_packets
                                                            
                                                            	Transmitted packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                                self.yang_name = "wred-stats-array"
                                                                self.yang_parent_name = "class-stats"

                                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                                self.red_label = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("max_threshold_bytes",
                                                                                "max_threshold_packets",
                                                                                "profile_title",
                                                                                "random_drop_bytes",
                                                                                "random_drop_packets",
                                                                                "red_ecn_marked_bytes",
                                                                                "red_ecn_marked_packets",
                                                                                "red_transmit_bytes",
                                                                                "red_transmit_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                            class RedLabel(Entity):
                                                                """
                                                                Array of WRED Typevalues as in PRP stats is
                                                                available per threshold   
                                                                
                                                                .. attribute:: value
                                                                
                                                                	WRED value for this type
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: wred_type
                                                                
                                                                	WRED type DSCP, EXP, PREC etc
                                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                    self.yang_name = "red-label"
                                                                    self.yang_parent_name = "wred-stats-array"

                                                                    self.value = YLeaf(YType.uint8, "value")

                                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("value",
                                                                                    "wred_type") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.value.is_set or
                                                                        self.wred_type.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set or
                                                                        self.wred_type.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "red-label" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "value" or name == "wred-type"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "wred-type"):
                                                                        self.wred_type = value
                                                                        self.wred_type.value_namespace = name_space
                                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.red_label:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.max_threshold_bytes.is_set or
                                                                    self.max_threshold_packets.is_set or
                                                                    self.profile_title.is_set or
                                                                    self.random_drop_bytes.is_set or
                                                                    self.random_drop_packets.is_set or
                                                                    self.red_ecn_marked_bytes.is_set or
                                                                    self.red_ecn_marked_packets.is_set or
                                                                    self.red_transmit_bytes.is_set or
                                                                    self.red_transmit_packets.is_set)

                                                            def has_operation(self):
                                                                for c in self.red_label:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                    self.profile_title.yfilter != YFilter.not_set or
                                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "wred-stats-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "red-label"):
                                                                    for c in self.red_label:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.red_label.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "max-threshold-bytes"):
                                                                    self.max_threshold_bytes = value
                                                                    self.max_threshold_bytes.value_namespace = name_space
                                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "max-threshold-packets"):
                                                                    self.max_threshold_packets = value
                                                                    self.max_threshold_packets.value_namespace = name_space
                                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "profile-title"):
                                                                    self.profile_title = value
                                                                    self.profile_title.value_namespace = name_space
                                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-bytes"):
                                                                    self.random_drop_bytes = value
                                                                    self.random_drop_bytes.value_namespace = name_space
                                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-packets"):
                                                                    self.random_drop_packets = value
                                                                    self.random_drop_packets.value_namespace = name_space
                                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-ecn-marked-bytes"):
                                                                    self.red_ecn_marked_bytes = value
                                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-ecn-marked-packets"):
                                                                    self.red_ecn_marked_packets = value
                                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-transmit-bytes"):
                                                                    self.red_transmit_bytes = value
                                                                    self.red_transmit_bytes.value_namespace = name_space
                                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-transmit-packets"):
                                                                    self.red_transmit_packets = value
                                                                    self.red_transmit_packets.value_namespace = name_space
                                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.police_stats_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_stats_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.wred_stats_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.cac_state.is_set or
                                                                self.class_name.is_set or
                                                                self.counter_validity_bitmask.is_set or
                                                                self.queue_descr.is_set or
                                                                self.shared_queue_id.is_set or
                                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                        def has_operation(self):
                                                            for c in self.police_stats_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_stats_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.wred_stats_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.cac_state.yfilter != YFilter.not_set or
                                                                self.class_name.yfilter != YFilter.not_set or
                                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                                self.queue_descr.yfilter != YFilter.not_set or
                                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "class-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "cac-stats"):
                                                                if (self.cac_stats is None):
                                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                    self.cac_stats.parent = self
                                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                                return self.cac_stats

                                                            if (child_yang_name == "general-stats"):
                                                                if (self.general_stats is None):
                                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                    self.general_stats.parent = self
                                                                    self._children_name_map["general_stats"] = "general-stats"
                                                                return self.general_stats

                                                            if (child_yang_name == "iphc-stats"):
                                                                if (self.iphc_stats is None):
                                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                    self.iphc_stats.parent = self
                                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                return self.iphc_stats

                                                            if (child_yang_name == "police-stats-array"):
                                                                for c in self.police_stats_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.police_stats_array.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-stats-array"):
                                                                for c in self.queue_stats_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_stats_array.append(c)
                                                                return c

                                                            if (child_yang_name == "wred-stats-array"):
                                                                for c in self.wred_stats_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.wred_stats_array.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "cac-state"):
                                                                self.cac_state = value
                                                                self.cac_state.value_namespace = name_space
                                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "class-name"):
                                                                self.class_name = value
                                                                self.class_name.value_namespace = name_space
                                                                self.class_name.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "counter-validity-bitmask"):
                                                                self.counter_validity_bitmask = value
                                                                self.counter_validity_bitmask.value_namespace = name_space
                                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-descr"):
                                                                self.queue_descr = value
                                                                self.queue_descr.value_namespace = name_space
                                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "shared-queue-id"):
                                                                self.shared_queue_id = value
                                                                self.shared_queue_id.value_namespace = name_space
                                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.class_stats:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.policy_name.is_set or
                                                            self.satid.is_set or
                                                            self.state.is_set or
                                                            self.state_description.is_set)

                                                    def has_operation(self):
                                                        for c in self.class_stats:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.policy_name.yfilter != YFilter.not_set or
                                                            self.satid.yfilter != YFilter.not_set or
                                                            self.state.yfilter != YFilter.not_set or
                                                            self.state_description.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "child-policy" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.state.get_name_leafdata())
                                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "class-stats"):
                                                            for c in self.class_stats:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.class_stats.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "policy-name"):
                                                            self.policy_name = value
                                                            self.policy_name.value_namespace = name_space
                                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "satid"):
                                                            self.satid = value
                                                            self.satid.value_namespace = name_space
                                                            self.satid.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "state"):
                                                            self.state = value
                                                            self.state.value_namespace = name_space
                                                            self.state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "state-description"):
                                                            self.state_description = value
                                                            self.state_description.value_namespace = name_space
                                                            self.state_description.value_namespace_prefix = name_space_prefix


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("admit_bytes",
                                                                        "admit_rates",
                                                                        "admitpackets",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "drop_rates") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.admit_bytes.is_set or
                                                            self.admit_rates.is_set or
                                                            self.admitpackets.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.drop_rates.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.admit_bytes.yfilter != YFilter.not_set or
                                                            self.admit_rates.yfilter != YFilter.not_set or
                                                            self.admitpackets.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.drop_rates.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cac-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "admit-bytes"):
                                                            self.admit_bytes = value
                                                            self.admit_bytes.value_namespace = name_space
                                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admit-rates"):
                                                            self.admit_rates = value
                                                            self.admit_rates.value_namespace = name_space
                                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admitpackets"):
                                                            self.admitpackets = value
                                                            self.admitpackets.value_namespace = name_space
                                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-rates"):
                                                            self.drop_rates = value
                                                            self.drop_rates.value_namespace = name_space
                                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                        self.queue_average_length = YList(self)
                                                        self.queue_instance_length = YList(self)
                                                        self.queue_max_length = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("atm_clp0_drop_bytes",
                                                                        "atm_clp0_drop_packets",
                                                                        "atm_clp1_drop_bytes",
                                                                        "atm_clp1_drop_packets",
                                                                        "conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "forced_wred_stats_display",
                                                                        "max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "queue_drop_threshold",
                                                                        "queue_id",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "tail_drop_bytes",
                                                                        "tail_drop_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-instance-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-average-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-max-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.atm_clp0_drop_bytes.is_set or
                                                            self.atm_clp0_drop_packets.is_set or
                                                            self.atm_clp1_drop_bytes.is_set or
                                                            self.atm_clp1_drop_packets.is_set or
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.forced_wred_stats_display.is_set or
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.queue_drop_threshold.is_set or
                                                            self.queue_id.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.tail_drop_bytes.is_set or
                                                            self.tail_drop_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                            self.queue_id.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "queue-average-length"):
                                                            for c in self.queue_average_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_average_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-instance-length"):
                                                            for c in self.queue_instance_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_instance_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-max-length"):
                                                            for c in self.queue_max_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_max_length.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "atm-clp0-drop-bytes"):
                                                            self.atm_clp0_drop_bytes = value
                                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp0-drop-packets"):
                                                            self.atm_clp0_drop_packets = value
                                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-bytes"):
                                                            self.atm_clp1_drop_bytes = value
                                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-packets"):
                                                            self.atm_clp1_drop_packets = value
                                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "forced-wred-stats-display"):
                                                            self.forced_wred_stats_display = value
                                                            self.forced_wred_stats_display.value_namespace = name_space
                                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-drop-threshold"):
                                                            self.queue_drop_threshold = value
                                                            self.queue_drop_threshold.value_namespace = name_space
                                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-id"):
                                                            self.queue_id = value
                                                            self.queue_id.value_namespace = name_space
                                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-bytes"):
                                                            self.tail_drop_bytes = value
                                                            self.tail_drop_bytes.value_namespace = name_space
                                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-packets"):
                                                            self.tail_drop_packets = value
                                                            self.tail_drop_packets.value_namespace = name_space
                                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._children_yang_names.add("color-class-stats")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "parent_drop_bytes",
                                                                        "parent_drop_packets",
                                                                        "violate_bytes",
                                                                        "violate_packets",
                                                                        "violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"

                                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_class_conform_bytes",
                                                                            "conform_class_conform_packets",
                                                                            "conform_class_conform_rate",
                                                                            "conform_class_exceed_bytes",
                                                                            "conform_class_exceed_packets",
                                                                            "conform_class_exceed_rate",
                                                                            "conform_class_violate_bytes",
                                                                            "conform_class_violate_packets",
                                                                            "conform_class_violate_rate",
                                                                            "exceed_class_exceed_bytes",
                                                                            "exceed_class_exceed_packets",
                                                                            "exceed_class_exceed_rate",
                                                                            "exceed_class_violate_bytes",
                                                                            "exceed_class_violate_packets",
                                                                            "exceed_class_violate_rate",
                                                                            "violate_class_violate_bytes",
                                                                            "violate_class_violate_packets",
                                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.conform_class_conform_bytes.is_set or
                                                                self.conform_class_conform_packets.is_set or
                                                                self.conform_class_conform_rate.is_set or
                                                                self.conform_class_exceed_bytes.is_set or
                                                                self.conform_class_exceed_packets.is_set or
                                                                self.conform_class_exceed_rate.is_set or
                                                                self.conform_class_violate_bytes.is_set or
                                                                self.conform_class_violate_packets.is_set or
                                                                self.conform_class_violate_rate.is_set or
                                                                self.exceed_class_exceed_bytes.is_set or
                                                                self.exceed_class_exceed_packets.is_set or
                                                                self.exceed_class_exceed_rate.is_set or
                                                                self.exceed_class_violate_bytes.is_set or
                                                                self.exceed_class_violate_packets.is_set or
                                                                self.exceed_class_violate_rate.is_set or
                                                                self.violate_class_violate_bytes.is_set or
                                                                self.violate_class_violate_packets.is_set or
                                                                self.violate_class_violate_rate.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "color-class-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-class-conform-bytes"):
                                                                self.conform_class_conform_bytes = value
                                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-packets"):
                                                                self.conform_class_conform_packets = value
                                                                self.conform_class_conform_packets.value_namespace = name_space
                                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-rate"):
                                                                self.conform_class_conform_rate = value
                                                                self.conform_class_conform_rate.value_namespace = name_space
                                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-bytes"):
                                                                self.conform_class_exceed_bytes = value
                                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-packets"):
                                                                self.conform_class_exceed_packets = value
                                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-rate"):
                                                                self.conform_class_exceed_rate = value
                                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-bytes"):
                                                                self.conform_class_violate_bytes = value
                                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-packets"):
                                                                self.conform_class_violate_packets = value
                                                                self.conform_class_violate_packets.value_namespace = name_space
                                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-rate"):
                                                                self.conform_class_violate_rate = value
                                                                self.conform_class_violate_rate.value_namespace = name_space
                                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-bytes"):
                                                                self.exceed_class_exceed_bytes = value
                                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-packets"):
                                                                self.exceed_class_exceed_packets = value
                                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-rate"):
                                                                self.exceed_class_exceed_rate = value
                                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-bytes"):
                                                                self.exceed_class_violate_bytes = value
                                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-packets"):
                                                                self.exceed_class_violate_packets = value
                                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-rate"):
                                                                self.exceed_class_violate_rate = value
                                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-bytes"):
                                                                self.violate_class_violate_bytes = value
                                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-packets"):
                                                                self.violate_class_violate_packets = value
                                                                self.violate_class_violate_packets.value_namespace = name_space
                                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-rate"):
                                                                self.violate_class_violate_rate = value
                                                                self.violate_class_violate_rate.value_namespace = name_space
                                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.parent_drop_bytes.is_set or
                                                            self.parent_drop_packets.is_set or
                                                            self.violate_bytes.is_set or
                                                            self.violate_packets.is_set or
                                                            self.violate_rate.is_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                                            self.violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_rate.yfilter != YFilter.not_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "color-class-stats"):
                                                            if (self.color_class_stats is None):
                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            return self.color_class_stats

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-bytes"):
                                                            self.parent_drop_bytes = value
                                                            self.parent_drop_bytes.value_namespace = name_space
                                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-packets"):
                                                            self.parent_drop_packets = value
                                                            self.parent_drop_packets.value_namespace = name_space
                                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-bytes"):
                                                            self.violate_bytes = value
                                                            self.violate_bytes.value_namespace = name_space
                                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-packets"):
                                                            self.violate_packets = value
                                                            self.violate_packets.value_namespace = name_space
                                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-rate"):
                                                            self.violate_rate = value
                                                            self.violate_rate.value_namespace = name_space
                                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                        self.red_label = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "profile_title",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "red_ecn_marked_bytes",
                                                                        "red_ecn_marked_packets",
                                                                        "red_transmit_bytes",
                                                                        "red_transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"

                                                            self.value = YLeaf(YType.uint8, "value")

                                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("value",
                                                                            "wred_type") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.value.is_set or
                                                                self.wred_type.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set or
                                                                self.wred_type.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "red-label" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())
                                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "value" or name == "wred-type"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "wred-type"):
                                                                self.wred_type = value
                                                                self.wred_type.value_namespace = name_space
                                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.red_label:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.profile_title.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.red_ecn_marked_bytes.is_set or
                                                            self.red_ecn_marked_packets.is_set or
                                                            self.red_transmit_bytes.is_set or
                                                            self.red_transmit_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.red_label:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.profile_title.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "wred-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "red-label"):
                                                            for c in self.red_label:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.red_label.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "profile-title"):
                                                            self.profile_title = value
                                                            self.profile_title.value_namespace = name_space
                                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-bytes"):
                                                            self.red_ecn_marked_bytes = value
                                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-packets"):
                                                            self.red_ecn_marked_packets = value
                                                            self.red_ecn_marked_packets.value_namespace = name_space
                                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-bytes"):
                                                            self.red_transmit_bytes = value
                                                            self.red_transmit_bytes.value_namespace = name_space
                                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-packets"):
                                                            self.red_transmit_packets = value
                                                            self.red_transmit_packets.value_namespace = name_space
                                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.cac_state.is_set or
                                                        self.class_name.is_set or
                                                        self.counter_validity_bitmask.is_set or
                                                        self.queue_descr.is_set or
                                                        self.shared_queue_id.is_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                def has_operation(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.cac_state.yfilter != YFilter.not_set or
                                                        self.class_name.yfilter != YFilter.not_set or
                                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                        self.queue_descr.yfilter != YFilter.not_set or
                                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cac-stats"):
                                                        if (self.cac_stats is None):
                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                        return self.cac_stats

                                                    if (child_yang_name == "child-policy"):
                                                        if (self.child_policy is None):
                                                            self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy()
                                                            self.child_policy.parent = self
                                                            self._children_name_map["child_policy"] = "child-policy"
                                                        return self.child_policy

                                                    if (child_yang_name == "general-stats"):
                                                        if (self.general_stats is None):
                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"
                                                        return self.general_stats

                                                    if (child_yang_name == "iphc-stats"):
                                                        if (self.iphc_stats is None):
                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        return self.iphc_stats

                                                    if (child_yang_name == "police-stats-array"):
                                                        for c in self.police_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.police_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-stats-array"):
                                                        for c in self.queue_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "wred-stats-array"):
                                                        for c in self.wred_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.wred_stats_array.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "cac-state"):
                                                        self.cac_state = value
                                                        self.cac_state.value_namespace = name_space
                                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "class-name"):
                                                        self.class_name = value
                                                        self.class_name.value_namespace = name_space
                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "counter-validity-bitmask"):
                                                        self.counter_validity_bitmask = value
                                                        self.counter_validity_bitmask.value_namespace = name_space
                                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-descr"):
                                                        self.queue_descr = value
                                                        self.queue_descr.value_namespace = name_space
                                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "shared-queue-id"):
                                                        self.shared_queue_id = value
                                                        self.shared_queue_id.value_namespace = name_space
                                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.class_stats:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.policy_name.is_set or
                                                    self.satid.is_set or
                                                    self.state.is_set or
                                                    self.state_description.is_set)

                                            def has_operation(self):
                                                for c in self.class_stats:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    self.satid.yfilter != YFilter.not_set or
                                                    self.state.yfilter != YFilter.not_set or
                                                    self.state_description.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "statistics" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state.get_name_leafdata())
                                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "class-stats"):
                                                    for c in self.class_stats:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.class_stats.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "satid"):
                                                    self.satid = value
                                                    self.satid.value_namespace = name_space
                                                    self.satid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state"):
                                                    self.state = value
                                                    self.state.value_namespace = name_space
                                                    self.state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state-description"):
                                                    self.state_description = value
                                                    self.state_description.value_namespace = name_space
                                                    self.state_description.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                                (self.statistics is not None and self.statistics.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                                (self.statistics is not None and self.statistics.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "input" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "service-policy-names"):
                                                if (self.service_policy_names is None):
                                                    self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                                                    self.service_policy_names.parent = self
                                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                                return self.service_policy_names

                                            if (child_yang_name == "statistics"):
                                                if (self.statistics is None):
                                                    self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Statistics()
                                                    self.statistics.parent = self
                                                    self._children_name_map["statistics"] = "statistics"
                                                return self.statistics

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-names" or name == "statistics"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Output(Entity):
                                        """
                                        A piece of QoS policy\-map operational data for
                                        an interface
                                        
                                        .. attribute:: service_policy_names
                                        
                                        	Operational data for all Policy instance
                                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames>`
                                        
                                        .. attribute:: statistics
                                        
                                        	Policy\-map statistics operational data for an interface
                                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output, self).__init__()

                                            self.yang_name = "output"
                                            self.yang_parent_name = "member-interface"

                                            self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                                            self.service_policy_names.parent = self
                                            self._children_name_map["service_policy_names"] = "service-policy-names"
                                            self._children_yang_names.add("service-policy-names")

                                            self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                            self._children_yang_names.add("statistics")


                                        class ServicePolicyNames(Entity):
                                            """
                                            Operational data for all Policy instance
                                            
                                            .. attribute:: service_policy_instance
                                            
                                            	QoS policy\-map operational data for a particular Policy 
                                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__init__()

                                                self.yang_name = "service-policy-names"
                                                self.yang_parent_name = "output"

                                                self.service_policy_instance = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__setattr__(name, value)


                                            class ServicePolicyInstance(Entity):
                                                """
                                                QoS policy\-map operational data for a
                                                particular Policy 
                                                
                                                .. attribute:: service_policy_name  <key>
                                                
                                                	Name of the policy instance
                                                	**type**\:  str
                                                
                                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                    self.yang_name = "service-policy-instance"
                                                    self.yang_parent_name = "service-policy-names"

                                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("service_policy_name") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.service_policy_name.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.service_policy_name.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "service-policy-name"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "service-policy-name"):
                                                        self.service_policy_name = value
                                                        self.service_policy_name.value_namespace = name_space
                                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.service_policy_instance:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.service_policy_instance:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "service-policy-names" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "service-policy-instance"):
                                                    for c in self.service_policy_instance:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.service_policy_instance.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-instance"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class Statistics(Entity):
                                            """
                                            Policy\-map statistics operational data for an
                                            interface
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\:  str
                                            
                                            	**length:** 0..128
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics, self).__init__()

                                                self.yang_name = "statistics"
                                                self.yang_parent_name = "output"

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.satid = YLeaf(YType.uint32, "satid")

                                                self.state = YLeaf(YType.enumeration, "state")

                                                self.state_description = YLeaf(YType.str, "state-description")

                                                self.class_stats = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("policy_name",
                                                                "satid",
                                                                "state",
                                                                "state_description") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics, self).__setattr__(name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats>`
                                                
                                                .. attribute:: child_policy
                                                
                                                	child policy
                                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy>`
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\:  str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "statistics"

                                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                    self._children_yang_names.add("cac-stats")

                                                    self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"
                                                    self._children_yang_names.add("child-policy")

                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                    self._children_yang_names.add("general-stats")

                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    self._children_yang_names.add("iphc-stats")

                                                    self.police_stats_array = YList(self)
                                                    self.queue_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("cac_state",
                                                                    "class_name",
                                                                    "counter_validity_bitmask",
                                                                    "queue_descr",
                                                                    "shared_queue_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("match_data_rate",
                                                                        "pre_policy_matched_bytes",
                                                                        "pre_policy_matched_packets",
                                                                        "total_drop_bytes",
                                                                        "total_drop_packets",
                                                                        "total_drop_rate",
                                                                        "total_transmit_rate",
                                                                        "transmit_bytes",
                                                                        "transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.match_data_rate.is_set or
                                                            self.pre_policy_matched_bytes.is_set or
                                                            self.pre_policy_matched_packets.is_set or
                                                            self.total_drop_bytes.is_set or
                                                            self.total_drop_packets.is_set or
                                                            self.total_drop_rate.is_set or
                                                            self.total_transmit_rate.is_set or
                                                            self.transmit_bytes.is_set or
                                                            self.transmit_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.match_data_rate.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                                            self.transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "general-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "match-data-rate"):
                                                            self.match_data_rate = value
                                                            self.match_data_rate.value_namespace = name_space
                                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-bytes"):
                                                            self.pre_policy_matched_bytes = value
                                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-packets"):
                                                            self.pre_policy_matched_packets = value
                                                            self.pre_policy_matched_packets.value_namespace = name_space
                                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-bytes"):
                                                            self.total_drop_bytes = value
                                                            self.total_drop_bytes.value_namespace = name_space
                                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-packets"):
                                                            self.total_drop_packets = value
                                                            self.total_drop_packets.value_namespace = name_space
                                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-rate"):
                                                            self.total_drop_rate = value
                                                            self.total_drop_rate.value_namespace = name_space
                                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-transmit-rate"):
                                                            self.total_transmit_rate = value
                                                            self.total_transmit_rate.value_namespace = name_space
                                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-bytes"):
                                                            self.transmit_bytes = value
                                                            self.transmit_bytes.value_namespace = name_space
                                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-packets"):
                                                            self.transmit_packets = value
                                                            self.transmit_packets.value_namespace = name_space
                                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("non_tcp_bytes_saved",
                                                                        "non_tcp_bytes_sent_rate",
                                                                        "non_tcp_compressed_packets_out",
                                                                        "non_tcp_full_header_packets_out",
                                                                        "non_tcp_total_out_bytes",
                                                                        "non_tcp_total_out_packets",
                                                                        "tcp_bytes_saved",
                                                                        "tcp_bytes_sent_rate",
                                                                        "tcp_compressed_packets_out",
                                                                        "tcp_full_header_packets_out",
                                                                        "tcp_total_out_bytes",
                                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.non_tcp_bytes_saved.is_set or
                                                            self.non_tcp_bytes_sent_rate.is_set or
                                                            self.non_tcp_compressed_packets_out.is_set or
                                                            self.non_tcp_full_header_packets_out.is_set or
                                                            self.non_tcp_total_out_bytes.is_set or
                                                            self.non_tcp_total_out_packets.is_set or
                                                            self.tcp_bytes_saved.is_set or
                                                            self.tcp_bytes_sent_rate.is_set or
                                                            self.tcp_compressed_packets_out.is_set or
                                                            self.tcp_full_header_packets_out.is_set or
                                                            self.tcp_total_out_bytes.is_set or
                                                            self.tcp_total_out_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "iphc-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "non-tcp-bytes-saved"):
                                                            self.non_tcp_bytes_saved = value
                                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                                            self.non_tcp_bytes_sent_rate = value
                                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-compressed-packets-out"):
                                                            self.non_tcp_compressed_packets_out = value
                                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-full-header-packets-out"):
                                                            self.non_tcp_full_header_packets_out = value
                                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-bytes"):
                                                            self.non_tcp_total_out_bytes = value
                                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-packets"):
                                                            self.non_tcp_total_out_packets = value
                                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-saved"):
                                                            self.tcp_bytes_saved = value
                                                            self.tcp_bytes_saved.value_namespace = name_space
                                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-sent-rate"):
                                                            self.tcp_bytes_sent_rate = value
                                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-compressed-packets-out"):
                                                            self.tcp_compressed_packets_out = value
                                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-full-header-packets-out"):
                                                            self.tcp_full_header_packets_out = value
                                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-bytes"):
                                                            self.tcp_total_out_bytes = value
                                                            self.tcp_total_out_bytes.value_namespace = name_space
                                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-packets"):
                                                            self.tcp_total_out_packets = value
                                                            self.tcp_total_out_packets.value_namespace = name_space
                                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                class ChildPolicy(Entity):
                                                    """
                                                    child policy
                                                    
                                                    .. attribute:: class_stats
                                                    
                                                    	array of classes contained in policy
                                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                    
                                                    .. attribute:: policy_name
                                                    
                                                    	PolicyName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: satid
                                                    
                                                    	to maintain satellite id
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: state
                                                    
                                                    	State
                                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                    
                                                    .. attribute:: state_description
                                                    
                                                    	StateDescription
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..128
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                        self.yang_name = "child-policy"
                                                        self.yang_parent_name = "class-stats"

                                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                                        self.satid = YLeaf(YType.uint32, "satid")

                                                        self.state = YLeaf(YType.enumeration, "state")

                                                        self.state_description = YLeaf(YType.str, "state-description")

                                                        self.class_stats = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("policy_name",
                                                                        "satid",
                                                                        "state",
                                                                        "state_description") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                    class ClassStats(Entity):
                                                        """
                                                        array of classes contained in policy
                                                        
                                                        .. attribute:: cac_state
                                                        
                                                        	CACState
                                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                        
                                                        .. attribute:: cac_stats
                                                        
                                                        	bag for cac stats
                                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	ClassName
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: counter_validity_bitmask
                                                        
                                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: megabyte
                                                        
                                                        .. attribute:: general_stats
                                                        
                                                        	general stats
                                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                        
                                                        .. attribute:: iphc_stats
                                                        
                                                        	IPHC stats
                                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                        
                                                        .. attribute:: police_stats_array
                                                        
                                                        	array of police stats
                                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                        
                                                        .. attribute:: queue_descr
                                                        
                                                        	Description of queue for the class
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..256
                                                        
                                                        .. attribute:: queue_stats_array
                                                        
                                                        	array of queue stats
                                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                        
                                                        .. attribute:: shared_queue_id
                                                        
                                                        	q\-id of the  shared queue for this class
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: wred_stats_array
                                                        
                                                        	array of red stats
                                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                            self.yang_name = "class-stats"
                                                            self.yang_parent_name = "child-policy"

                                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                            self.class_name = YLeaf(YType.str, "class-name")

                                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                            self._children_yang_names.add("cac-stats")

                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"
                                                            self._children_yang_names.add("general-stats")

                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            self._children_yang_names.add("iphc-stats")

                                                            self.police_stats_array = YList(self)
                                                            self.queue_stats_array = YList(self)
                                                            self.wred_stats_array = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("cac_state",
                                                                            "class_name",
                                                                            "counter_validity_bitmask",
                                                                            "queue_descr",
                                                                            "shared_queue_id") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                        class GeneralStats(Entity):
                                                            """
                                                            general stats
                                                            
                                                            .. attribute:: match_data_rate
                                                            
                                                            	Incoming matched data rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: pre_policy_matched_bytes
                                                            
                                                            	Matched bytes before applying policy
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: pre_policy_matched_packets
                                                            
                                                            	Matched pkts before applying policy
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: total_drop_bytes
                                                            
                                                            	Dropped bytes (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_packets
                                                            
                                                            	Dropped packets (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_drop_rate
                                                            
                                                            	Total drop rate (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: total_transmit_rate
                                                            
                                                            	Total transmit rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: transmit_bytes
                                                            
                                                            	Transmitted bytes (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: transmit_packets
                                                            
                                                            	Transmitted packets (packets/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                                self.yang_name = "general-stats"
                                                                self.yang_parent_name = "class-stats"

                                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("match_data_rate",
                                                                                "pre_policy_matched_bytes",
                                                                                "pre_policy_matched_packets",
                                                                                "total_drop_bytes",
                                                                                "total_drop_packets",
                                                                                "total_drop_rate",
                                                                                "total_transmit_rate",
                                                                                "transmit_bytes",
                                                                                "transmit_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.match_data_rate.is_set or
                                                                    self.pre_policy_matched_bytes.is_set or
                                                                    self.pre_policy_matched_packets.is_set or
                                                                    self.total_drop_bytes.is_set or
                                                                    self.total_drop_packets.is_set or
                                                                    self.total_drop_rate.is_set or
                                                                    self.total_transmit_rate.is_set or
                                                                    self.transmit_bytes.is_set or
                                                                    self.transmit_packets.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "general-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "match-data-rate"):
                                                                    self.match_data_rate = value
                                                                    self.match_data_rate.value_namespace = name_space
                                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "pre-policy-matched-bytes"):
                                                                    self.pre_policy_matched_bytes = value
                                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "pre-policy-matched-packets"):
                                                                    self.pre_policy_matched_packets = value
                                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-drop-bytes"):
                                                                    self.total_drop_bytes = value
                                                                    self.total_drop_bytes.value_namespace = name_space
                                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-drop-packets"):
                                                                    self.total_drop_packets = value
                                                                    self.total_drop_packets.value_namespace = name_space
                                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-drop-rate"):
                                                                    self.total_drop_rate = value
                                                                    self.total_drop_rate.value_namespace = name_space
                                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "total-transmit-rate"):
                                                                    self.total_transmit_rate = value
                                                                    self.total_transmit_rate.value_namespace = name_space
                                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "transmit-bytes"):
                                                                    self.transmit_bytes = value
                                                                    self.transmit_bytes.value_namespace = name_space
                                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "transmit-packets"):
                                                                    self.transmit_packets = value
                                                                    self.transmit_packets.value_namespace = name_space
                                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                        class IphcStats(Entity):
                                                            """
                                                            IPHC stats
                                                            
                                                            .. attribute:: non_tcp_bytes_saved
                                                            
                                                            	Non Tcp Bytes saved due to compression
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_bytes_sent_rate
                                                            
                                                            	Compressed Non Tcp Bytes sent rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_compressed_packets_out
                                                            
                                                            	Num of non tcp compressed pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_full_header_packets_out
                                                            
                                                            	Num of non tcp fullheader pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: non_tcp_total_out_bytes
                                                            
                                                            	TotalNum of Non Tcp Bytes sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: non_tcp_total_out_packets
                                                            
                                                            	TotalNum of Non tcp pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_bytes_saved
                                                            
                                                            	Tcp Bytes saved due to compression
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_bytes_sent_rate
                                                            
                                                            	Compressed Tcp Bytes sent rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_compressed_packets_out
                                                            
                                                            	Num of tcp compressed pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_full_header_packets_out
                                                            
                                                            	Num of tcp fullheader pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tcp_total_out_bytes
                                                            
                                                            	TotalNum of Tcp Bytes sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tcp_total_out_packets
                                                            
                                                            	Total Num of tcp pkts sent
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                                self.yang_name = "iphc-stats"
                                                                self.yang_parent_name = "class-stats"

                                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("non_tcp_bytes_saved",
                                                                                "non_tcp_bytes_sent_rate",
                                                                                "non_tcp_compressed_packets_out",
                                                                                "non_tcp_full_header_packets_out",
                                                                                "non_tcp_total_out_bytes",
                                                                                "non_tcp_total_out_packets",
                                                                                "tcp_bytes_saved",
                                                                                "tcp_bytes_sent_rate",
                                                                                "tcp_compressed_packets_out",
                                                                                "tcp_full_header_packets_out",
                                                                                "tcp_total_out_bytes",
                                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.non_tcp_bytes_saved.is_set or
                                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                                    self.non_tcp_compressed_packets_out.is_set or
                                                                    self.non_tcp_full_header_packets_out.is_set or
                                                                    self.non_tcp_total_out_bytes.is_set or
                                                                    self.non_tcp_total_out_packets.is_set or
                                                                    self.tcp_bytes_saved.is_set or
                                                                    self.tcp_bytes_sent_rate.is_set or
                                                                    self.tcp_compressed_packets_out.is_set or
                                                                    self.tcp_full_header_packets_out.is_set or
                                                                    self.tcp_total_out_bytes.is_set or
                                                                    self.tcp_total_out_packets.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "iphc-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "non-tcp-bytes-saved"):
                                                                    self.non_tcp_bytes_saved = value
                                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                                    self.non_tcp_bytes_sent_rate = value
                                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                                    self.non_tcp_compressed_packets_out = value
                                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                                    self.non_tcp_full_header_packets_out = value
                                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-total-out-bytes"):
                                                                    self.non_tcp_total_out_bytes = value
                                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "non-tcp-total-out-packets"):
                                                                    self.non_tcp_total_out_packets = value
                                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-bytes-saved"):
                                                                    self.tcp_bytes_saved = value
                                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-bytes-sent-rate"):
                                                                    self.tcp_bytes_sent_rate = value
                                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-compressed-packets-out"):
                                                                    self.tcp_compressed_packets_out = value
                                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-full-header-packets-out"):
                                                                    self.tcp_full_header_packets_out = value
                                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-total-out-bytes"):
                                                                    self.tcp_total_out_bytes = value
                                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tcp-total-out-packets"):
                                                                    self.tcp_total_out_packets = value
                                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                        class CacStats(Entity):
                                                            """
                                                            bag for cac stats
                                                            
                                                            .. attribute:: admit_bytes
                                                            
                                                            	Admitted bytes (pkts/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: admit_rates
                                                            
                                                            	CAC admit rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: admitpackets
                                                            
                                                            	Admitted packets (pkts/bytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	CAC dropped bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	CAC dropped packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: drop_rates
                                                            
                                                            	CAC dropped rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                                self.yang_name = "cac-stats"
                                                                self.yang_parent_name = "class-stats"

                                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("admit_bytes",
                                                                                "admit_rates",
                                                                                "admitpackets",
                                                                                "drop_bytes",
                                                                                "drop_packets",
                                                                                "drop_rates") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.admit_bytes.is_set or
                                                                    self.admit_rates.is_set or
                                                                    self.admitpackets.is_set or
                                                                    self.drop_bytes.is_set or
                                                                    self.drop_packets.is_set or
                                                                    self.drop_rates.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                                    self.drop_rates.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "cac-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "admit-bytes"):
                                                                    self.admit_bytes = value
                                                                    self.admit_bytes.value_namespace = name_space
                                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "admit-rates"):
                                                                    self.admit_rates = value
                                                                    self.admit_rates.value_namespace = name_space
                                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "admitpackets"):
                                                                    self.admitpackets = value
                                                                    self.admitpackets.value_namespace = name_space
                                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-bytes"):
                                                                    self.drop_bytes = value
                                                                    self.drop_bytes.value_namespace = name_space
                                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-packets"):
                                                                    self.drop_packets = value
                                                                    self.drop_packets.value_namespace = name_space
                                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-rates"):
                                                                    self.drop_rates = value
                                                                    self.drop_rates.value_namespace = name_space
                                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                                        class QueueStatsArray(Entity):
                                                            """
                                                            array of queue stats
                                                            
                                                            .. attribute:: atm_clp0_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp0_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: atm_clp1_drop_bytes
                                                            
                                                            	ATP CLP 0 matched bytes dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: atm_clp1_drop_packets
                                                            
                                                            	ATP CLP 0 matched packets dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the queue rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: forced_wred_stats_display
                                                            
                                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                            	**type**\:  bool
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: queue_average_length
                                                            
                                                            	Queue average length
                                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                            
                                                            .. attribute:: queue_drop_threshold
                                                            
                                                            	tail drop threshold of the queue in bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: queue_id
                                                            
                                                            	Queue Id used for Fabric Stats
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: queue_instance_length
                                                            
                                                            	Queue instance length
                                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                            
                                                            .. attribute:: queue_max_length
                                                            
                                                            	Queue maximum length
                                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Bytes probabilistically dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Packets probabilistically dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: tail_drop_bytes
                                                            
                                                            	Bytes tail dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: tail_drop_packets
                                                            
                                                            	Packets tail dropped
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                                self.yang_name = "queue-stats-array"
                                                                self.yang_parent_name = "class-stats"

                                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                                self.queue_average_length = YList(self)
                                                                self.queue_instance_length = YList(self)
                                                                self.queue_max_length = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("atm_clp0_drop_bytes",
                                                                                "atm_clp0_drop_packets",
                                                                                "atm_clp1_drop_bytes",
                                                                                "atm_clp1_drop_packets",
                                                                                "conform_bytes",
                                                                                "conform_packets",
                                                                                "conform_rate",
                                                                                "exceed_bytes",
                                                                                "exceed_packets",
                                                                                "exceed_rate",
                                                                                "forced_wred_stats_display",
                                                                                "max_threshold_bytes",
                                                                                "max_threshold_packets",
                                                                                "queue_drop_threshold",
                                                                                "queue_id",
                                                                                "random_drop_bytes",
                                                                                "random_drop_packets",
                                                                                "tail_drop_bytes",
                                                                                "tail_drop_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                            class QueueInstanceLength(Entity):
                                                                """
                                                                Queue instance length
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                    self.yang_name = "queue-instance-length"
                                                                    self.yang_parent_name = "queue-stats-array"

                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("unit",
                                                                                    "value") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.unit.is_set or
                                                                        self.value.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.unit.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-instance-length" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "unit" or name == "value"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "unit"):
                                                                        self.unit = value
                                                                        self.unit.value_namespace = name_space
                                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix


                                                            class QueueAverageLength(Entity):
                                                                """
                                                                Queue average length
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                    self.yang_name = "queue-average-length"
                                                                    self.yang_parent_name = "queue-stats-array"

                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("unit",
                                                                                    "value") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.unit.is_set or
                                                                        self.value.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.unit.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-average-length" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "unit" or name == "value"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "unit"):
                                                                        self.unit = value
                                                                        self.unit.value_namespace = name_space
                                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix


                                                            class QueueMaxLength(Entity):
                                                                """
                                                                Queue maximum length
                                                                
                                                                .. attribute:: unit
                                                                
                                                                	unit
                                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                    self.yang_name = "queue-max-length"
                                                                    self.yang_parent_name = "queue-stats-array"

                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("unit",
                                                                                    "value") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.unit.is_set or
                                                                        self.value.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.unit.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-max-length" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "unit" or name == "value"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "unit"):
                                                                        self.unit = value
                                                                        self.unit.value_namespace = name_space
                                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.queue_average_length:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.queue_instance_length:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.queue_max_length:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.atm_clp0_drop_bytes.is_set or
                                                                    self.atm_clp0_drop_packets.is_set or
                                                                    self.atm_clp1_drop_bytes.is_set or
                                                                    self.atm_clp1_drop_packets.is_set or
                                                                    self.conform_bytes.is_set or
                                                                    self.conform_packets.is_set or
                                                                    self.conform_rate.is_set or
                                                                    self.exceed_bytes.is_set or
                                                                    self.exceed_packets.is_set or
                                                                    self.exceed_rate.is_set or
                                                                    self.forced_wred_stats_display.is_set or
                                                                    self.max_threshold_bytes.is_set or
                                                                    self.max_threshold_packets.is_set or
                                                                    self.queue_drop_threshold.is_set or
                                                                    self.queue_id.is_set or
                                                                    self.random_drop_bytes.is_set or
                                                                    self.random_drop_packets.is_set or
                                                                    self.tail_drop_bytes.is_set or
                                                                    self.tail_drop_packets.is_set)

                                                            def has_operation(self):
                                                                for c in self.queue_average_length:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.queue_instance_length:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.queue_max_length:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                    self.queue_id.yfilter != YFilter.not_set or
                                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-stats-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "queue-average-length"):
                                                                    for c in self.queue_average_length:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_average_length.append(c)
                                                                    return c

                                                                if (child_yang_name == "queue-instance-length"):
                                                                    for c in self.queue_instance_length:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_instance_length.append(c)
                                                                    return c

                                                                if (child_yang_name == "queue-max-length"):
                                                                    for c in self.queue_max_length:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_max_length.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "atm-clp0-drop-bytes"):
                                                                    self.atm_clp0_drop_bytes = value
                                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "atm-clp0-drop-packets"):
                                                                    self.atm_clp0_drop_packets = value
                                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "atm-clp1-drop-bytes"):
                                                                    self.atm_clp1_drop_bytes = value
                                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "atm-clp1-drop-packets"):
                                                                    self.atm_clp1_drop_packets = value
                                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-bytes"):
                                                                    self.conform_bytes = value
                                                                    self.conform_bytes.value_namespace = name_space
                                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-packets"):
                                                                    self.conform_packets = value
                                                                    self.conform_packets.value_namespace = name_space
                                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-rate"):
                                                                    self.conform_rate = value
                                                                    self.conform_rate.value_namespace = name_space
                                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-bytes"):
                                                                    self.exceed_bytes = value
                                                                    self.exceed_bytes.value_namespace = name_space
                                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-packets"):
                                                                    self.exceed_packets = value
                                                                    self.exceed_packets.value_namespace = name_space
                                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-rate"):
                                                                    self.exceed_rate = value
                                                                    self.exceed_rate.value_namespace = name_space
                                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "forced-wred-stats-display"):
                                                                    self.forced_wred_stats_display = value
                                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "max-threshold-bytes"):
                                                                    self.max_threshold_bytes = value
                                                                    self.max_threshold_bytes.value_namespace = name_space
                                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "max-threshold-packets"):
                                                                    self.max_threshold_packets = value
                                                                    self.max_threshold_packets.value_namespace = name_space
                                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "queue-drop-threshold"):
                                                                    self.queue_drop_threshold = value
                                                                    self.queue_drop_threshold.value_namespace = name_space
                                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "queue-id"):
                                                                    self.queue_id = value
                                                                    self.queue_id.value_namespace = name_space
                                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-bytes"):
                                                                    self.random_drop_bytes = value
                                                                    self.random_drop_bytes.value_namespace = name_space
                                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-packets"):
                                                                    self.random_drop_packets = value
                                                                    self.random_drop_packets.value_namespace = name_space
                                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tail-drop-bytes"):
                                                                    self.tail_drop_bytes = value
                                                                    self.tail_drop_bytes.value_namespace = name_space
                                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "tail-drop-packets"):
                                                                    self.tail_drop_packets = value
                                                                    self.tail_drop_packets.value_namespace = name_space
                                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                        class PoliceStatsArray(Entity):
                                                            """
                                                            array of police stats
                                                            
                                                            .. attribute:: color_class_stats
                                                            
                                                            	color class stats
                                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                            
                                                            .. attribute:: conform_bytes
                                                            
                                                            	Bytes that conform to the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_packets
                                                            
                                                            	Packets that conform  to the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_rate
                                                            
                                                            	Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: drop_bytes
                                                            
                                                            	Police dropped bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: drop_packets
                                                            
                                                            	Police dropped packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_bytes
                                                            
                                                            	Bytes that exceed  the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_packets
                                                            
                                                            	Packets that exceed the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_rate
                                                            
                                                            	Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: parent_drop_bytes
                                                            
                                                            	Dropped bytes by the parent policer
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: parent_drop_packets
                                                            
                                                            	Dropped pkts by the parent policer
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_bytes
                                                            
                                                            	Bytes that violate the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_packets
                                                            
                                                            	Packets violating the policed rate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_rate
                                                            
                                                            	Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                                self.yang_name = "police-stats-array"
                                                                self.yang_parent_name = "class-stats"

                                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                self._children_yang_names.add("color-class-stats")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_bytes",
                                                                                "conform_packets",
                                                                                "conform_rate",
                                                                                "drop_bytes",
                                                                                "drop_packets",
                                                                                "exceed_bytes",
                                                                                "exceed_packets",
                                                                                "exceed_rate",
                                                                                "parent_drop_bytes",
                                                                                "parent_drop_packets",
                                                                                "violate_bytes",
                                                                                "violate_packets",
                                                                                "violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                            class ColorClassStats(Entity):
                                                                """
                                                                color class stats
                                                                
                                                                .. attribute:: conform_class_conform_bytes
                                                                
                                                                	Bytes with classification result conform and policer result conform
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_conform_packets
                                                                
                                                                	Packets with classification result conform and policer result conform
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_conform_rate
                                                                
                                                                	Conform Class Conform rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_exceed_bytes
                                                                
                                                                	Bytes with classification result conform and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_exceed_packets
                                                                
                                                                	Packets with classification result conform and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_exceed_rate
                                                                
                                                                	Conform Class Exceed rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: conform_class_violate_bytes
                                                                
                                                                	Bytes with classification result conform and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_class_violate_packets
                                                                
                                                                	Packets with classification result conform and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_class_violate_rate
                                                                
                                                                	Conform Class Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_exceed_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_exceed_packets
                                                                
                                                                	Packets with classification result exceed and policer result exceed
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_exceed_rate
                                                                
                                                                	Exceed Class Exceed rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: exceed_class_violate_bytes
                                                                
                                                                	Bytes with classification result exceed and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_class_violate_packets
                                                                
                                                                	Packets with classification result exceed and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_class_violate_rate
                                                                
                                                                	Exceed Class Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: violate_class_violate_bytes
                                                                
                                                                	Bytes with classification result violate and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_class_violate_packets
                                                                
                                                                	Packets with classification result violate and policer result violate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_class_violate_rate
                                                                
                                                                	Violate Class Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                    self.yang_name = "color-class-stats"
                                                                    self.yang_parent_name = "police-stats-array"

                                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("conform_class_conform_bytes",
                                                                                    "conform_class_conform_packets",
                                                                                    "conform_class_conform_rate",
                                                                                    "conform_class_exceed_bytes",
                                                                                    "conform_class_exceed_packets",
                                                                                    "conform_class_exceed_rate",
                                                                                    "conform_class_violate_bytes",
                                                                                    "conform_class_violate_packets",
                                                                                    "conform_class_violate_rate",
                                                                                    "exceed_class_exceed_bytes",
                                                                                    "exceed_class_exceed_packets",
                                                                                    "exceed_class_exceed_rate",
                                                                                    "exceed_class_violate_bytes",
                                                                                    "exceed_class_violate_packets",
                                                                                    "exceed_class_violate_rate",
                                                                                    "violate_class_violate_bytes",
                                                                                    "violate_class_violate_packets",
                                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.conform_class_conform_bytes.is_set or
                                                                        self.conform_class_conform_packets.is_set or
                                                                        self.conform_class_conform_rate.is_set or
                                                                        self.conform_class_exceed_bytes.is_set or
                                                                        self.conform_class_exceed_packets.is_set or
                                                                        self.conform_class_exceed_rate.is_set or
                                                                        self.conform_class_violate_bytes.is_set or
                                                                        self.conform_class_violate_packets.is_set or
                                                                        self.conform_class_violate_rate.is_set or
                                                                        self.exceed_class_exceed_bytes.is_set or
                                                                        self.exceed_class_exceed_packets.is_set or
                                                                        self.exceed_class_exceed_rate.is_set or
                                                                        self.exceed_class_violate_bytes.is_set or
                                                                        self.exceed_class_violate_packets.is_set or
                                                                        self.exceed_class_violate_rate.is_set or
                                                                        self.violate_class_violate_bytes.is_set or
                                                                        self.violate_class_violate_packets.is_set or
                                                                        self.violate_class_violate_rate.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "color-class-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "conform-class-conform-bytes"):
                                                                        self.conform_class_conform_bytes = value
                                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-conform-packets"):
                                                                        self.conform_class_conform_packets = value
                                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-conform-rate"):
                                                                        self.conform_class_conform_rate = value
                                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-exceed-bytes"):
                                                                        self.conform_class_exceed_bytes = value
                                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-exceed-packets"):
                                                                        self.conform_class_exceed_packets = value
                                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-exceed-rate"):
                                                                        self.conform_class_exceed_rate = value
                                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-violate-bytes"):
                                                                        self.conform_class_violate_bytes = value
                                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-violate-packets"):
                                                                        self.conform_class_violate_packets = value
                                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-class-violate-rate"):
                                                                        self.conform_class_violate_rate = value
                                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                                        self.exceed_class_exceed_bytes = value
                                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-exceed-packets"):
                                                                        self.exceed_class_exceed_packets = value
                                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-exceed-rate"):
                                                                        self.exceed_class_exceed_rate = value
                                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-violate-bytes"):
                                                                        self.exceed_class_violate_bytes = value
                                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-violate-packets"):
                                                                        self.exceed_class_violate_packets = value
                                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-class-violate-rate"):
                                                                        self.exceed_class_violate_rate = value
                                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-class-violate-bytes"):
                                                                        self.violate_class_violate_bytes = value
                                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-class-violate-packets"):
                                                                        self.violate_class_violate_packets = value
                                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-class-violate-rate"):
                                                                        self.violate_class_violate_rate = value
                                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_bytes.is_set or
                                                                    self.conform_packets.is_set or
                                                                    self.conform_rate.is_set or
                                                                    self.drop_bytes.is_set or
                                                                    self.drop_packets.is_set or
                                                                    self.exceed_bytes.is_set or
                                                                    self.exceed_packets.is_set or
                                                                    self.exceed_rate.is_set or
                                                                    self.parent_drop_bytes.is_set or
                                                                    self.parent_drop_packets.is_set or
                                                                    self.violate_bytes.is_set or
                                                                    self.violate_packets.is_set or
                                                                    self.violate_rate.is_set or
                                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "police-stats-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "color-class-stats"):
                                                                    if (self.color_class_stats is None):
                                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                        self.color_class_stats.parent = self
                                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    return self.color_class_stats

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-bytes"):
                                                                    self.conform_bytes = value
                                                                    self.conform_bytes.value_namespace = name_space
                                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-packets"):
                                                                    self.conform_packets = value
                                                                    self.conform_packets.value_namespace = name_space
                                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-rate"):
                                                                    self.conform_rate = value
                                                                    self.conform_rate.value_namespace = name_space
                                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-bytes"):
                                                                    self.drop_bytes = value
                                                                    self.drop_bytes.value_namespace = name_space
                                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "drop-packets"):
                                                                    self.drop_packets = value
                                                                    self.drop_packets.value_namespace = name_space
                                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-bytes"):
                                                                    self.exceed_bytes = value
                                                                    self.exceed_bytes.value_namespace = name_space
                                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-packets"):
                                                                    self.exceed_packets = value
                                                                    self.exceed_packets.value_namespace = name_space
                                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-rate"):
                                                                    self.exceed_rate = value
                                                                    self.exceed_rate.value_namespace = name_space
                                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "parent-drop-bytes"):
                                                                    self.parent_drop_bytes = value
                                                                    self.parent_drop_bytes.value_namespace = name_space
                                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "parent-drop-packets"):
                                                                    self.parent_drop_packets = value
                                                                    self.parent_drop_packets.value_namespace = name_space
                                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-bytes"):
                                                                    self.violate_bytes = value
                                                                    self.violate_bytes.value_namespace = name_space
                                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-packets"):
                                                                    self.violate_packets = value
                                                                    self.violate_packets.value_namespace = name_space
                                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-rate"):
                                                                    self.violate_rate = value
                                                                    self.violate_rate.value_namespace = name_space
                                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                                        class WredStatsArray(Entity):
                                                            """
                                                            array of red stats
                                                            
                                                            .. attribute:: max_threshold_bytes
                                                            
                                                            	Dropped bytes with  the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: max_threshold_packets
                                                            
                                                            	Dropped packets with  the average queue size at the max\-threshold
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: profile_title
                                                            
                                                            	ProfileTitle
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..300
                                                            
                                                            .. attribute:: random_drop_bytes
                                                            
                                                            	Probabilisticallydropped bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: random_drop_packets
                                                            
                                                            	Probabilistically dropped  packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_ecn_marked_bytes
                                                            
                                                            	ECN marked bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_ecn_marked_packets
                                                            
                                                            	ECN marked packets 
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: red_label
                                                            
                                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                            
                                                            .. attribute:: red_transmit_bytes
                                                            
                                                            	Transmitted bytes
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: red_transmit_packets
                                                            
                                                            	Transmitted packets
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                                self.yang_name = "wred-stats-array"
                                                                self.yang_parent_name = "class-stats"

                                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                                self.red_label = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("max_threshold_bytes",
                                                                                "max_threshold_packets",
                                                                                "profile_title",
                                                                                "random_drop_bytes",
                                                                                "random_drop_packets",
                                                                                "red_ecn_marked_bytes",
                                                                                "red_ecn_marked_packets",
                                                                                "red_transmit_bytes",
                                                                                "red_transmit_packets") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                            class RedLabel(Entity):
                                                                """
                                                                Array of WRED Typevalues as in PRP stats is
                                                                available per threshold   
                                                                
                                                                .. attribute:: value
                                                                
                                                                	WRED value for this type
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: wred_type
                                                                
                                                                	WRED type DSCP, EXP, PREC etc
                                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                    self.yang_name = "red-label"
                                                                    self.yang_parent_name = "wred-stats-array"

                                                                    self.value = YLeaf(YType.uint8, "value")

                                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("value",
                                                                                    "wred_type") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.value.is_set or
                                                                        self.wred_type.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.value.yfilter != YFilter.not_set or
                                                                        self.wred_type.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "red-label" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "value" or name == "wred-type"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "value"):
                                                                        self.value = value
                                                                        self.value.value_namespace = name_space
                                                                        self.value.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "wred-type"):
                                                                        self.wred_type = value
                                                                        self.wred_type.value_namespace = name_space
                                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.red_label:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.max_threshold_bytes.is_set or
                                                                    self.max_threshold_packets.is_set or
                                                                    self.profile_title.is_set or
                                                                    self.random_drop_bytes.is_set or
                                                                    self.random_drop_packets.is_set or
                                                                    self.red_ecn_marked_bytes.is_set or
                                                                    self.red_ecn_marked_packets.is_set or
                                                                    self.red_transmit_bytes.is_set or
                                                                    self.red_transmit_packets.is_set)

                                                            def has_operation(self):
                                                                for c in self.red_label:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                    self.profile_title.yfilter != YFilter.not_set or
                                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "wred-stats-array" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "red-label"):
                                                                    for c in self.red_label:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.red_label.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "max-threshold-bytes"):
                                                                    self.max_threshold_bytes = value
                                                                    self.max_threshold_bytes.value_namespace = name_space
                                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "max-threshold-packets"):
                                                                    self.max_threshold_packets = value
                                                                    self.max_threshold_packets.value_namespace = name_space
                                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "profile-title"):
                                                                    self.profile_title = value
                                                                    self.profile_title.value_namespace = name_space
                                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-bytes"):
                                                                    self.random_drop_bytes = value
                                                                    self.random_drop_bytes.value_namespace = name_space
                                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "random-drop-packets"):
                                                                    self.random_drop_packets = value
                                                                    self.random_drop_packets.value_namespace = name_space
                                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-ecn-marked-bytes"):
                                                                    self.red_ecn_marked_bytes = value
                                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-ecn-marked-packets"):
                                                                    self.red_ecn_marked_packets = value
                                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-transmit-bytes"):
                                                                    self.red_transmit_bytes = value
                                                                    self.red_transmit_bytes.value_namespace = name_space
                                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "red-transmit-packets"):
                                                                    self.red_transmit_packets = value
                                                                    self.red_transmit_packets.value_namespace = name_space
                                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.police_stats_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_stats_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.wred_stats_array:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.cac_state.is_set or
                                                                self.class_name.is_set or
                                                                self.counter_validity_bitmask.is_set or
                                                                self.queue_descr.is_set or
                                                                self.shared_queue_id.is_set or
                                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                        def has_operation(self):
                                                            for c in self.police_stats_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_stats_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.wred_stats_array:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.cac_state.yfilter != YFilter.not_set or
                                                                self.class_name.yfilter != YFilter.not_set or
                                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                                self.queue_descr.yfilter != YFilter.not_set or
                                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "class-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "cac-stats"):
                                                                if (self.cac_stats is None):
                                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                    self.cac_stats.parent = self
                                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                                return self.cac_stats

                                                            if (child_yang_name == "general-stats"):
                                                                if (self.general_stats is None):
                                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                    self.general_stats.parent = self
                                                                    self._children_name_map["general_stats"] = "general-stats"
                                                                return self.general_stats

                                                            if (child_yang_name == "iphc-stats"):
                                                                if (self.iphc_stats is None):
                                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                    self.iphc_stats.parent = self
                                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                return self.iphc_stats

                                                            if (child_yang_name == "police-stats-array"):
                                                                for c in self.police_stats_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.police_stats_array.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-stats-array"):
                                                                for c in self.queue_stats_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_stats_array.append(c)
                                                                return c

                                                            if (child_yang_name == "wred-stats-array"):
                                                                for c in self.wred_stats_array:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.wred_stats_array.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "cac-state"):
                                                                self.cac_state = value
                                                                self.cac_state.value_namespace = name_space
                                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "class-name"):
                                                                self.class_name = value
                                                                self.class_name.value_namespace = name_space
                                                                self.class_name.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "counter-validity-bitmask"):
                                                                self.counter_validity_bitmask = value
                                                                self.counter_validity_bitmask.value_namespace = name_space
                                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-descr"):
                                                                self.queue_descr = value
                                                                self.queue_descr.value_namespace = name_space
                                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "shared-queue-id"):
                                                                self.shared_queue_id = value
                                                                self.shared_queue_id.value_namespace = name_space
                                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.class_stats:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.policy_name.is_set or
                                                            self.satid.is_set or
                                                            self.state.is_set or
                                                            self.state_description.is_set)

                                                    def has_operation(self):
                                                        for c in self.class_stats:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.policy_name.yfilter != YFilter.not_set or
                                                            self.satid.yfilter != YFilter.not_set or
                                                            self.state.yfilter != YFilter.not_set or
                                                            self.state_description.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "child-policy" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.state.get_name_leafdata())
                                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "class-stats"):
                                                            for c in self.class_stats:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.class_stats.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "policy-name"):
                                                            self.policy_name = value
                                                            self.policy_name.value_namespace = name_space
                                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "satid"):
                                                            self.satid = value
                                                            self.satid.value_namespace = name_space
                                                            self.satid.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "state"):
                                                            self.state = value
                                                            self.state.value_namespace = name_space
                                                            self.state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "state-description"):
                                                            self.state_description = value
                                                            self.state_description.value_namespace = name_space
                                                            self.state_description.value_namespace_prefix = name_space_prefix


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("admit_bytes",
                                                                        "admit_rates",
                                                                        "admitpackets",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "drop_rates") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.admit_bytes.is_set or
                                                            self.admit_rates.is_set or
                                                            self.admitpackets.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.drop_rates.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.admit_bytes.yfilter != YFilter.not_set or
                                                            self.admit_rates.yfilter != YFilter.not_set or
                                                            self.admitpackets.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.drop_rates.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cac-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "admit-bytes"):
                                                            self.admit_bytes = value
                                                            self.admit_bytes.value_namespace = name_space
                                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admit-rates"):
                                                            self.admit_rates = value
                                                            self.admit_rates.value_namespace = name_space
                                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admitpackets"):
                                                            self.admitpackets = value
                                                            self.admitpackets.value_namespace = name_space
                                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-rates"):
                                                            self.drop_rates = value
                                                            self.drop_rates.value_namespace = name_space
                                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                        self.queue_average_length = YList(self)
                                                        self.queue_instance_length = YList(self)
                                                        self.queue_max_length = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("atm_clp0_drop_bytes",
                                                                        "atm_clp0_drop_packets",
                                                                        "atm_clp1_drop_bytes",
                                                                        "atm_clp1_drop_packets",
                                                                        "conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "forced_wred_stats_display",
                                                                        "max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "queue_drop_threshold",
                                                                        "queue_id",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "tail_drop_bytes",
                                                                        "tail_drop_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-instance-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-average-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-max-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.atm_clp0_drop_bytes.is_set or
                                                            self.atm_clp0_drop_packets.is_set or
                                                            self.atm_clp1_drop_bytes.is_set or
                                                            self.atm_clp1_drop_packets.is_set or
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.forced_wred_stats_display.is_set or
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.queue_drop_threshold.is_set or
                                                            self.queue_id.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.tail_drop_bytes.is_set or
                                                            self.tail_drop_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                            self.queue_id.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "queue-average-length"):
                                                            for c in self.queue_average_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_average_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-instance-length"):
                                                            for c in self.queue_instance_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_instance_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-max-length"):
                                                            for c in self.queue_max_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_max_length.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "atm-clp0-drop-bytes"):
                                                            self.atm_clp0_drop_bytes = value
                                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp0-drop-packets"):
                                                            self.atm_clp0_drop_packets = value
                                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-bytes"):
                                                            self.atm_clp1_drop_bytes = value
                                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-packets"):
                                                            self.atm_clp1_drop_packets = value
                                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "forced-wred-stats-display"):
                                                            self.forced_wred_stats_display = value
                                                            self.forced_wred_stats_display.value_namespace = name_space
                                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-drop-threshold"):
                                                            self.queue_drop_threshold = value
                                                            self.queue_drop_threshold.value_namespace = name_space
                                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-id"):
                                                            self.queue_id = value
                                                            self.queue_id.value_namespace = name_space
                                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-bytes"):
                                                            self.tail_drop_bytes = value
                                                            self.tail_drop_bytes.value_namespace = name_space
                                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-packets"):
                                                            self.tail_drop_packets = value
                                                            self.tail_drop_packets.value_namespace = name_space
                                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._children_yang_names.add("color-class-stats")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "parent_drop_bytes",
                                                                        "parent_drop_packets",
                                                                        "violate_bytes",
                                                                        "violate_packets",
                                                                        "violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"

                                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_class_conform_bytes",
                                                                            "conform_class_conform_packets",
                                                                            "conform_class_conform_rate",
                                                                            "conform_class_exceed_bytes",
                                                                            "conform_class_exceed_packets",
                                                                            "conform_class_exceed_rate",
                                                                            "conform_class_violate_bytes",
                                                                            "conform_class_violate_packets",
                                                                            "conform_class_violate_rate",
                                                                            "exceed_class_exceed_bytes",
                                                                            "exceed_class_exceed_packets",
                                                                            "exceed_class_exceed_rate",
                                                                            "exceed_class_violate_bytes",
                                                                            "exceed_class_violate_packets",
                                                                            "exceed_class_violate_rate",
                                                                            "violate_class_violate_bytes",
                                                                            "violate_class_violate_packets",
                                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.conform_class_conform_bytes.is_set or
                                                                self.conform_class_conform_packets.is_set or
                                                                self.conform_class_conform_rate.is_set or
                                                                self.conform_class_exceed_bytes.is_set or
                                                                self.conform_class_exceed_packets.is_set or
                                                                self.conform_class_exceed_rate.is_set or
                                                                self.conform_class_violate_bytes.is_set or
                                                                self.conform_class_violate_packets.is_set or
                                                                self.conform_class_violate_rate.is_set or
                                                                self.exceed_class_exceed_bytes.is_set or
                                                                self.exceed_class_exceed_packets.is_set or
                                                                self.exceed_class_exceed_rate.is_set or
                                                                self.exceed_class_violate_bytes.is_set or
                                                                self.exceed_class_violate_packets.is_set or
                                                                self.exceed_class_violate_rate.is_set or
                                                                self.violate_class_violate_bytes.is_set or
                                                                self.violate_class_violate_packets.is_set or
                                                                self.violate_class_violate_rate.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "color-class-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-class-conform-bytes"):
                                                                self.conform_class_conform_bytes = value
                                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-packets"):
                                                                self.conform_class_conform_packets = value
                                                                self.conform_class_conform_packets.value_namespace = name_space
                                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-rate"):
                                                                self.conform_class_conform_rate = value
                                                                self.conform_class_conform_rate.value_namespace = name_space
                                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-bytes"):
                                                                self.conform_class_exceed_bytes = value
                                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-packets"):
                                                                self.conform_class_exceed_packets = value
                                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-rate"):
                                                                self.conform_class_exceed_rate = value
                                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-bytes"):
                                                                self.conform_class_violate_bytes = value
                                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-packets"):
                                                                self.conform_class_violate_packets = value
                                                                self.conform_class_violate_packets.value_namespace = name_space
                                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-rate"):
                                                                self.conform_class_violate_rate = value
                                                                self.conform_class_violate_rate.value_namespace = name_space
                                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-bytes"):
                                                                self.exceed_class_exceed_bytes = value
                                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-packets"):
                                                                self.exceed_class_exceed_packets = value
                                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-rate"):
                                                                self.exceed_class_exceed_rate = value
                                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-bytes"):
                                                                self.exceed_class_violate_bytes = value
                                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-packets"):
                                                                self.exceed_class_violate_packets = value
                                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-rate"):
                                                                self.exceed_class_violate_rate = value
                                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-bytes"):
                                                                self.violate_class_violate_bytes = value
                                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-packets"):
                                                                self.violate_class_violate_packets = value
                                                                self.violate_class_violate_packets.value_namespace = name_space
                                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-rate"):
                                                                self.violate_class_violate_rate = value
                                                                self.violate_class_violate_rate.value_namespace = name_space
                                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.parent_drop_bytes.is_set or
                                                            self.parent_drop_packets.is_set or
                                                            self.violate_bytes.is_set or
                                                            self.violate_packets.is_set or
                                                            self.violate_rate.is_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                                            self.violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_rate.yfilter != YFilter.not_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "color-class-stats"):
                                                            if (self.color_class_stats is None):
                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            return self.color_class_stats

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-bytes"):
                                                            self.parent_drop_bytes = value
                                                            self.parent_drop_bytes.value_namespace = name_space
                                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-packets"):
                                                            self.parent_drop_packets = value
                                                            self.parent_drop_packets.value_namespace = name_space
                                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-bytes"):
                                                            self.violate_bytes = value
                                                            self.violate_bytes.value_namespace = name_space
                                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-packets"):
                                                            self.violate_packets = value
                                                            self.violate_packets.value_namespace = name_space
                                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-rate"):
                                                            self.violate_rate = value
                                                            self.violate_rate.value_namespace = name_space
                                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                        self.red_label = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "profile_title",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "red_ecn_marked_bytes",
                                                                        "red_ecn_marked_packets",
                                                                        "red_transmit_bytes",
                                                                        "red_transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"

                                                            self.value = YLeaf(YType.uint8, "value")

                                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("value",
                                                                            "wred_type") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.value.is_set or
                                                                self.wred_type.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set or
                                                                self.wred_type.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "red-label" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())
                                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "value" or name == "wred-type"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "wred-type"):
                                                                self.wred_type = value
                                                                self.wred_type.value_namespace = name_space
                                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.red_label:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.profile_title.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.red_ecn_marked_bytes.is_set or
                                                            self.red_ecn_marked_packets.is_set or
                                                            self.red_transmit_bytes.is_set or
                                                            self.red_transmit_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.red_label:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.profile_title.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "wred-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "red-label"):
                                                            for c in self.red_label:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.red_label.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "profile-title"):
                                                            self.profile_title = value
                                                            self.profile_title.value_namespace = name_space
                                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-bytes"):
                                                            self.red_ecn_marked_bytes = value
                                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-packets"):
                                                            self.red_ecn_marked_packets = value
                                                            self.red_ecn_marked_packets.value_namespace = name_space
                                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-bytes"):
                                                            self.red_transmit_bytes = value
                                                            self.red_transmit_bytes.value_namespace = name_space
                                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-packets"):
                                                            self.red_transmit_packets = value
                                                            self.red_transmit_packets.value_namespace = name_space
                                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.cac_state.is_set or
                                                        self.class_name.is_set or
                                                        self.counter_validity_bitmask.is_set or
                                                        self.queue_descr.is_set or
                                                        self.shared_queue_id.is_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                def has_operation(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.cac_state.yfilter != YFilter.not_set or
                                                        self.class_name.yfilter != YFilter.not_set or
                                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                        self.queue_descr.yfilter != YFilter.not_set or
                                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cac-stats"):
                                                        if (self.cac_stats is None):
                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                        return self.cac_stats

                                                    if (child_yang_name == "child-policy"):
                                                        if (self.child_policy is None):
                                                            self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy()
                                                            self.child_policy.parent = self
                                                            self._children_name_map["child_policy"] = "child-policy"
                                                        return self.child_policy

                                                    if (child_yang_name == "general-stats"):
                                                        if (self.general_stats is None):
                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"
                                                        return self.general_stats

                                                    if (child_yang_name == "iphc-stats"):
                                                        if (self.iphc_stats is None):
                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        return self.iphc_stats

                                                    if (child_yang_name == "police-stats-array"):
                                                        for c in self.police_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.police_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-stats-array"):
                                                        for c in self.queue_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "wred-stats-array"):
                                                        for c in self.wred_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.wred_stats_array.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "cac-state"):
                                                        self.cac_state = value
                                                        self.cac_state.value_namespace = name_space
                                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "class-name"):
                                                        self.class_name = value
                                                        self.class_name.value_namespace = name_space
                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "counter-validity-bitmask"):
                                                        self.counter_validity_bitmask = value
                                                        self.counter_validity_bitmask.value_namespace = name_space
                                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-descr"):
                                                        self.queue_descr = value
                                                        self.queue_descr.value_namespace = name_space
                                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "shared-queue-id"):
                                                        self.shared_queue_id = value
                                                        self.shared_queue_id.value_namespace = name_space
                                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.class_stats:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.policy_name.is_set or
                                                    self.satid.is_set or
                                                    self.state.is_set or
                                                    self.state_description.is_set)

                                            def has_operation(self):
                                                for c in self.class_stats:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    self.satid.yfilter != YFilter.not_set or
                                                    self.state.yfilter != YFilter.not_set or
                                                    self.state_description.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "statistics" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state.get_name_leafdata())
                                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "class-stats"):
                                                    for c in self.class_stats:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.class_stats.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "satid"):
                                                    self.satid = value
                                                    self.satid.value_namespace = name_space
                                                    self.satid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state"):
                                                    self.state = value
                                                    self.state.value_namespace = name_space
                                                    self.state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state-description"):
                                                    self.state_description = value
                                                    self.state_description.value_namespace = name_space
                                                    self.state_description.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                                (self.statistics is not None and self.statistics.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                                (self.statistics is not None and self.statistics.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "output" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "service-policy-names"):
                                                if (self.service_policy_names is None):
                                                    self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                                                    self.service_policy_names.parent = self
                                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                                return self.service_policy_names

                                            if (child_yang_name == "statistics"):
                                                if (self.statistics is None):
                                                    self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Statistics()
                                                    self.statistics.parent = self
                                                    self._children_name_map["statistics"] = "statistics"
                                                return self.statistics

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-names" or name == "statistics"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            (self.input is not None and self.input.has_data()) or
                                            (self.output is not None and self.output.has_data()) or
                                            (self.satellite_ids is not None and self.satellite_ids.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            (self.input is not None and self.input.has_operation()) or
                                            (self.output is not None and self.output.has_operation()) or
                                            (self.satellite_ids is not None and self.satellite_ids.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "member-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "input"):
                                            if (self.input is None):
                                                self.input = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input()
                                                self.input.parent = self
                                                self._children_name_map["input"] = "input"
                                            return self.input

                                        if (child_yang_name == "output"):
                                            if (self.output is None):
                                                self.output = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output()
                                                self.output.parent = self
                                                self._children_name_map["output"] = "output"
                                            return self.output

                                        if (child_yang_name == "satellite-ids"):
                                            if (self.satellite_ids is None):
                                                self.satellite_ids = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.SatelliteIds()
                                                self.satellite_ids.parent = self
                                                self._children_name_map["satellite_ids"] = "satellite-ids"
                                            return self.satellite_ids

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "input" or name == "output" or name == "satellite-ids" or name == "interface-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.member_interface:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.member_interface:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "member-interfaces" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "member-interface"):
                                        for c in self.member_interface:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.member_interface.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "member-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Input(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: service_policy_names
                                
                                	Operational data for all Policy instance
                                	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames>`
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input, self).__init__()

                                    self.yang_name = "input"
                                    self.yang_parent_name = "nv-satellite-interface"

                                    self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                    self._children_yang_names.add("service-policy-names")

                                    self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._children_yang_names.add("statistics")


                                class ServicePolicyNames(Entity):
                                    """
                                    Operational data for all Policy instance
                                    
                                    .. attribute:: service_policy_instance
                                    
                                    	QoS policy\-map operational data for a particular Policy 
                                    	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames, self).__init__()

                                        self.yang_name = "service-policy-names"
                                        self.yang_parent_name = "input"

                                        self.service_policy_instance = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames, self).__setattr__(name, value)


                                    class ServicePolicyInstance(Entity):
                                        """
                                        QoS policy\-map operational data for a
                                        particular Policy 
                                        
                                        .. attribute:: service_policy_name  <key>
                                        
                                        	Name of the policy instance
                                        	**type**\:  str
                                        
                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                            self.yang_name = "service-policy-instance"
                                            self.yang_parent_name = "service-policy-names"

                                            self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("service_policy_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.service_policy_name.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.service_policy_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "service-policy-name"):
                                                self.service_policy_name = value
                                                self.service_policy_name.value_namespace = name_space
                                                self.service_policy_name.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.service_policy_instance:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.service_policy_instance:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "service-policy-names" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-instance"):
                                            for c in self.service_policy_instance:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames.ServicePolicyInstance()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.service_policy_instance.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-instance"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "input"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                            self._children_yang_names.add("child-policy")

                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\:  str
                                            
                                            	**length:** 0..128
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.satid = YLeaf(YType.uint32, "satid")

                                                self.state = YLeaf(YType.enumeration, "state")

                                                self.state_description = YLeaf(YType.str, "state-description")

                                                self.class_stats = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("policy_name",
                                                                "satid",
                                                                "state",
                                                                "state_description") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\:  str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"

                                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                    self._children_yang_names.add("cac-stats")

                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                    self._children_yang_names.add("general-stats")

                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    self._children_yang_names.add("iphc-stats")

                                                    self.police_stats_array = YList(self)
                                                    self.queue_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("cac_state",
                                                                    "class_name",
                                                                    "counter_validity_bitmask",
                                                                    "queue_descr",
                                                                    "shared_queue_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("match_data_rate",
                                                                        "pre_policy_matched_bytes",
                                                                        "pre_policy_matched_packets",
                                                                        "total_drop_bytes",
                                                                        "total_drop_packets",
                                                                        "total_drop_rate",
                                                                        "total_transmit_rate",
                                                                        "transmit_bytes",
                                                                        "transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.match_data_rate.is_set or
                                                            self.pre_policy_matched_bytes.is_set or
                                                            self.pre_policy_matched_packets.is_set or
                                                            self.total_drop_bytes.is_set or
                                                            self.total_drop_packets.is_set or
                                                            self.total_drop_rate.is_set or
                                                            self.total_transmit_rate.is_set or
                                                            self.transmit_bytes.is_set or
                                                            self.transmit_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.match_data_rate.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                                            self.transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "general-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "match-data-rate"):
                                                            self.match_data_rate = value
                                                            self.match_data_rate.value_namespace = name_space
                                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-bytes"):
                                                            self.pre_policy_matched_bytes = value
                                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-packets"):
                                                            self.pre_policy_matched_packets = value
                                                            self.pre_policy_matched_packets.value_namespace = name_space
                                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-bytes"):
                                                            self.total_drop_bytes = value
                                                            self.total_drop_bytes.value_namespace = name_space
                                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-packets"):
                                                            self.total_drop_packets = value
                                                            self.total_drop_packets.value_namespace = name_space
                                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-rate"):
                                                            self.total_drop_rate = value
                                                            self.total_drop_rate.value_namespace = name_space
                                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-transmit-rate"):
                                                            self.total_transmit_rate = value
                                                            self.total_transmit_rate.value_namespace = name_space
                                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-bytes"):
                                                            self.transmit_bytes = value
                                                            self.transmit_bytes.value_namespace = name_space
                                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-packets"):
                                                            self.transmit_packets = value
                                                            self.transmit_packets.value_namespace = name_space
                                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("non_tcp_bytes_saved",
                                                                        "non_tcp_bytes_sent_rate",
                                                                        "non_tcp_compressed_packets_out",
                                                                        "non_tcp_full_header_packets_out",
                                                                        "non_tcp_total_out_bytes",
                                                                        "non_tcp_total_out_packets",
                                                                        "tcp_bytes_saved",
                                                                        "tcp_bytes_sent_rate",
                                                                        "tcp_compressed_packets_out",
                                                                        "tcp_full_header_packets_out",
                                                                        "tcp_total_out_bytes",
                                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.non_tcp_bytes_saved.is_set or
                                                            self.non_tcp_bytes_sent_rate.is_set or
                                                            self.non_tcp_compressed_packets_out.is_set or
                                                            self.non_tcp_full_header_packets_out.is_set or
                                                            self.non_tcp_total_out_bytes.is_set or
                                                            self.non_tcp_total_out_packets.is_set or
                                                            self.tcp_bytes_saved.is_set or
                                                            self.tcp_bytes_sent_rate.is_set or
                                                            self.tcp_compressed_packets_out.is_set or
                                                            self.tcp_full_header_packets_out.is_set or
                                                            self.tcp_total_out_bytes.is_set or
                                                            self.tcp_total_out_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "iphc-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "non-tcp-bytes-saved"):
                                                            self.non_tcp_bytes_saved = value
                                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                                            self.non_tcp_bytes_sent_rate = value
                                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-compressed-packets-out"):
                                                            self.non_tcp_compressed_packets_out = value
                                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-full-header-packets-out"):
                                                            self.non_tcp_full_header_packets_out = value
                                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-bytes"):
                                                            self.non_tcp_total_out_bytes = value
                                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-packets"):
                                                            self.non_tcp_total_out_packets = value
                                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-saved"):
                                                            self.tcp_bytes_saved = value
                                                            self.tcp_bytes_saved.value_namespace = name_space
                                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-sent-rate"):
                                                            self.tcp_bytes_sent_rate = value
                                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-compressed-packets-out"):
                                                            self.tcp_compressed_packets_out = value
                                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-full-header-packets-out"):
                                                            self.tcp_full_header_packets_out = value
                                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-bytes"):
                                                            self.tcp_total_out_bytes = value
                                                            self.tcp_total_out_bytes.value_namespace = name_space
                                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-packets"):
                                                            self.tcp_total_out_packets = value
                                                            self.tcp_total_out_packets.value_namespace = name_space
                                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("admit_bytes",
                                                                        "admit_rates",
                                                                        "admitpackets",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "drop_rates") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.admit_bytes.is_set or
                                                            self.admit_rates.is_set or
                                                            self.admitpackets.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.drop_rates.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.admit_bytes.yfilter != YFilter.not_set or
                                                            self.admit_rates.yfilter != YFilter.not_set or
                                                            self.admitpackets.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.drop_rates.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cac-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "admit-bytes"):
                                                            self.admit_bytes = value
                                                            self.admit_bytes.value_namespace = name_space
                                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admit-rates"):
                                                            self.admit_rates = value
                                                            self.admit_rates.value_namespace = name_space
                                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admitpackets"):
                                                            self.admitpackets = value
                                                            self.admitpackets.value_namespace = name_space
                                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-rates"):
                                                            self.drop_rates = value
                                                            self.drop_rates.value_namespace = name_space
                                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                        self.queue_average_length = YList(self)
                                                        self.queue_instance_length = YList(self)
                                                        self.queue_max_length = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("atm_clp0_drop_bytes",
                                                                        "atm_clp0_drop_packets",
                                                                        "atm_clp1_drop_bytes",
                                                                        "atm_clp1_drop_packets",
                                                                        "conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "forced_wred_stats_display",
                                                                        "max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "queue_drop_threshold",
                                                                        "queue_id",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "tail_drop_bytes",
                                                                        "tail_drop_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-instance-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-average-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-max-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.atm_clp0_drop_bytes.is_set or
                                                            self.atm_clp0_drop_packets.is_set or
                                                            self.atm_clp1_drop_bytes.is_set or
                                                            self.atm_clp1_drop_packets.is_set or
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.forced_wred_stats_display.is_set or
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.queue_drop_threshold.is_set or
                                                            self.queue_id.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.tail_drop_bytes.is_set or
                                                            self.tail_drop_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                            self.queue_id.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "queue-average-length"):
                                                            for c in self.queue_average_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_average_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-instance-length"):
                                                            for c in self.queue_instance_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_instance_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-max-length"):
                                                            for c in self.queue_max_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_max_length.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "atm-clp0-drop-bytes"):
                                                            self.atm_clp0_drop_bytes = value
                                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp0-drop-packets"):
                                                            self.atm_clp0_drop_packets = value
                                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-bytes"):
                                                            self.atm_clp1_drop_bytes = value
                                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-packets"):
                                                            self.atm_clp1_drop_packets = value
                                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "forced-wred-stats-display"):
                                                            self.forced_wred_stats_display = value
                                                            self.forced_wred_stats_display.value_namespace = name_space
                                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-drop-threshold"):
                                                            self.queue_drop_threshold = value
                                                            self.queue_drop_threshold.value_namespace = name_space
                                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-id"):
                                                            self.queue_id = value
                                                            self.queue_id.value_namespace = name_space
                                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-bytes"):
                                                            self.tail_drop_bytes = value
                                                            self.tail_drop_bytes.value_namespace = name_space
                                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-packets"):
                                                            self.tail_drop_packets = value
                                                            self.tail_drop_packets.value_namespace = name_space
                                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._children_yang_names.add("color-class-stats")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "parent_drop_bytes",
                                                                        "parent_drop_packets",
                                                                        "violate_bytes",
                                                                        "violate_packets",
                                                                        "violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"

                                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_class_conform_bytes",
                                                                            "conform_class_conform_packets",
                                                                            "conform_class_conform_rate",
                                                                            "conform_class_exceed_bytes",
                                                                            "conform_class_exceed_packets",
                                                                            "conform_class_exceed_rate",
                                                                            "conform_class_violate_bytes",
                                                                            "conform_class_violate_packets",
                                                                            "conform_class_violate_rate",
                                                                            "exceed_class_exceed_bytes",
                                                                            "exceed_class_exceed_packets",
                                                                            "exceed_class_exceed_rate",
                                                                            "exceed_class_violate_bytes",
                                                                            "exceed_class_violate_packets",
                                                                            "exceed_class_violate_rate",
                                                                            "violate_class_violate_bytes",
                                                                            "violate_class_violate_packets",
                                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.conform_class_conform_bytes.is_set or
                                                                self.conform_class_conform_packets.is_set or
                                                                self.conform_class_conform_rate.is_set or
                                                                self.conform_class_exceed_bytes.is_set or
                                                                self.conform_class_exceed_packets.is_set or
                                                                self.conform_class_exceed_rate.is_set or
                                                                self.conform_class_violate_bytes.is_set or
                                                                self.conform_class_violate_packets.is_set or
                                                                self.conform_class_violate_rate.is_set or
                                                                self.exceed_class_exceed_bytes.is_set or
                                                                self.exceed_class_exceed_packets.is_set or
                                                                self.exceed_class_exceed_rate.is_set or
                                                                self.exceed_class_violate_bytes.is_set or
                                                                self.exceed_class_violate_packets.is_set or
                                                                self.exceed_class_violate_rate.is_set or
                                                                self.violate_class_violate_bytes.is_set or
                                                                self.violate_class_violate_packets.is_set or
                                                                self.violate_class_violate_rate.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "color-class-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-class-conform-bytes"):
                                                                self.conform_class_conform_bytes = value
                                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-packets"):
                                                                self.conform_class_conform_packets = value
                                                                self.conform_class_conform_packets.value_namespace = name_space
                                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-rate"):
                                                                self.conform_class_conform_rate = value
                                                                self.conform_class_conform_rate.value_namespace = name_space
                                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-bytes"):
                                                                self.conform_class_exceed_bytes = value
                                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-packets"):
                                                                self.conform_class_exceed_packets = value
                                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-rate"):
                                                                self.conform_class_exceed_rate = value
                                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-bytes"):
                                                                self.conform_class_violate_bytes = value
                                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-packets"):
                                                                self.conform_class_violate_packets = value
                                                                self.conform_class_violate_packets.value_namespace = name_space
                                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-rate"):
                                                                self.conform_class_violate_rate = value
                                                                self.conform_class_violate_rate.value_namespace = name_space
                                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-bytes"):
                                                                self.exceed_class_exceed_bytes = value
                                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-packets"):
                                                                self.exceed_class_exceed_packets = value
                                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-rate"):
                                                                self.exceed_class_exceed_rate = value
                                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-bytes"):
                                                                self.exceed_class_violate_bytes = value
                                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-packets"):
                                                                self.exceed_class_violate_packets = value
                                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-rate"):
                                                                self.exceed_class_violate_rate = value
                                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-bytes"):
                                                                self.violate_class_violate_bytes = value
                                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-packets"):
                                                                self.violate_class_violate_packets = value
                                                                self.violate_class_violate_packets.value_namespace = name_space
                                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-rate"):
                                                                self.violate_class_violate_rate = value
                                                                self.violate_class_violate_rate.value_namespace = name_space
                                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.parent_drop_bytes.is_set or
                                                            self.parent_drop_packets.is_set or
                                                            self.violate_bytes.is_set or
                                                            self.violate_packets.is_set or
                                                            self.violate_rate.is_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                                            self.violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_rate.yfilter != YFilter.not_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "color-class-stats"):
                                                            if (self.color_class_stats is None):
                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            return self.color_class_stats

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-bytes"):
                                                            self.parent_drop_bytes = value
                                                            self.parent_drop_bytes.value_namespace = name_space
                                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-packets"):
                                                            self.parent_drop_packets = value
                                                            self.parent_drop_packets.value_namespace = name_space
                                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-bytes"):
                                                            self.violate_bytes = value
                                                            self.violate_bytes.value_namespace = name_space
                                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-packets"):
                                                            self.violate_packets = value
                                                            self.violate_packets.value_namespace = name_space
                                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-rate"):
                                                            self.violate_rate = value
                                                            self.violate_rate.value_namespace = name_space
                                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                        self.red_label = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "profile_title",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "red_ecn_marked_bytes",
                                                                        "red_ecn_marked_packets",
                                                                        "red_transmit_bytes",
                                                                        "red_transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"

                                                            self.value = YLeaf(YType.uint8, "value")

                                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("value",
                                                                            "wred_type") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.value.is_set or
                                                                self.wred_type.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set or
                                                                self.wred_type.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "red-label" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())
                                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "value" or name == "wred-type"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "wred-type"):
                                                                self.wred_type = value
                                                                self.wred_type.value_namespace = name_space
                                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.red_label:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.profile_title.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.red_ecn_marked_bytes.is_set or
                                                            self.red_ecn_marked_packets.is_set or
                                                            self.red_transmit_bytes.is_set or
                                                            self.red_transmit_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.red_label:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.profile_title.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "wred-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "red-label"):
                                                            for c in self.red_label:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.red_label.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "profile-title"):
                                                            self.profile_title = value
                                                            self.profile_title.value_namespace = name_space
                                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-bytes"):
                                                            self.red_ecn_marked_bytes = value
                                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-packets"):
                                                            self.red_ecn_marked_packets = value
                                                            self.red_ecn_marked_packets.value_namespace = name_space
                                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-bytes"):
                                                            self.red_transmit_bytes = value
                                                            self.red_transmit_bytes.value_namespace = name_space
                                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-packets"):
                                                            self.red_transmit_packets = value
                                                            self.red_transmit_packets.value_namespace = name_space
                                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.cac_state.is_set or
                                                        self.class_name.is_set or
                                                        self.counter_validity_bitmask.is_set or
                                                        self.queue_descr.is_set or
                                                        self.shared_queue_id.is_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                def has_operation(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.cac_state.yfilter != YFilter.not_set or
                                                        self.class_name.yfilter != YFilter.not_set or
                                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                        self.queue_descr.yfilter != YFilter.not_set or
                                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cac-stats"):
                                                        if (self.cac_stats is None):
                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                        return self.cac_stats

                                                    if (child_yang_name == "general-stats"):
                                                        if (self.general_stats is None):
                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"
                                                        return self.general_stats

                                                    if (child_yang_name == "iphc-stats"):
                                                        if (self.iphc_stats is None):
                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        return self.iphc_stats

                                                    if (child_yang_name == "police-stats-array"):
                                                        for c in self.police_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.police_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-stats-array"):
                                                        for c in self.queue_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "wred-stats-array"):
                                                        for c in self.wred_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.wred_stats_array.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "cac-state"):
                                                        self.cac_state = value
                                                        self.cac_state.value_namespace = name_space
                                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "class-name"):
                                                        self.class_name = value
                                                        self.class_name.value_namespace = name_space
                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "counter-validity-bitmask"):
                                                        self.counter_validity_bitmask = value
                                                        self.counter_validity_bitmask.value_namespace = name_space
                                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-descr"):
                                                        self.queue_descr = value
                                                        self.queue_descr.value_namespace = name_space
                                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "shared-queue-id"):
                                                        self.shared_queue_id = value
                                                        self.shared_queue_id.value_namespace = name_space
                                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.class_stats:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.policy_name.is_set or
                                                    self.satid.is_set or
                                                    self.state.is_set or
                                                    self.state_description.is_set)

                                            def has_operation(self):
                                                for c in self.class_stats:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    self.satid.yfilter != YFilter.not_set or
                                                    self.state.yfilter != YFilter.not_set or
                                                    self.state_description.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "child-policy" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state.get_name_leafdata())
                                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "class-stats"):
                                                    for c in self.class_stats:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.class_stats.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "satid"):
                                                    self.satid = value
                                                    self.satid.value_namespace = name_space
                                                    self.satid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state"):
                                                    self.state = value
                                                    self.state.value_namespace = name_space
                                                    self.state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state-description"):
                                                    self.state_description = value
                                                    self.state_description.value_namespace = name_space
                                                    self.state_description.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.child_policy is not None and self.child_policy.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.child_policy is not None and self.child_policy.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "child-policy"):
                                                if (self.child_policy is None):
                                                    self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"
                                                return self.child_policy

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "statistics" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                        (self.statistics is not None and self.statistics.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                        (self.statistics is not None and self.statistics.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "input" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "service-policy-names"):
                                        if (self.service_policy_names is None):
                                            self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.ServicePolicyNames()
                                            self.service_policy_names.parent = self
                                            self._children_name_map["service_policy_names"] = "service-policy-names"
                                        return self.service_policy_names

                                    if (child_yang_name == "statistics"):
                                        if (self.statistics is None):
                                            self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                        return self.statistics

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-names" or name == "statistics"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Output(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: service_policy_names
                                
                                	Operational data for all Policy instance
                                	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames>`
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output, self).__init__()

                                    self.yang_name = "output"
                                    self.yang_parent_name = "nv-satellite-interface"

                                    self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                    self._children_yang_names.add("service-policy-names")

                                    self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._children_yang_names.add("statistics")


                                class ServicePolicyNames(Entity):
                                    """
                                    Operational data for all Policy instance
                                    
                                    .. attribute:: service_policy_instance
                                    
                                    	QoS policy\-map operational data for a particular Policy 
                                    	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames, self).__init__()

                                        self.yang_name = "service-policy-names"
                                        self.yang_parent_name = "output"

                                        self.service_policy_instance = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames, self).__setattr__(name, value)


                                    class ServicePolicyInstance(Entity):
                                        """
                                        QoS policy\-map operational data for a
                                        particular Policy 
                                        
                                        .. attribute:: service_policy_name  <key>
                                        
                                        	Name of the policy instance
                                        	**type**\:  str
                                        
                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                            self.yang_name = "service-policy-instance"
                                            self.yang_parent_name = "service-policy-names"

                                            self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("service_policy_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.service_policy_name.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.service_policy_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "service-policy-name"):
                                                self.service_policy_name = value
                                                self.service_policy_name.value_namespace = name_space
                                                self.service_policy_name.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.service_policy_instance:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.service_policy_instance:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "service-policy-names" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-instance"):
                                            for c in self.service_policy_instance:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames.ServicePolicyInstance()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.service_policy_instance.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-instance"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "output"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                            self._children_yang_names.add("child-policy")

                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\:  str
                                            
                                            	**length:** 0..128
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.satid = YLeaf(YType.uint32, "satid")

                                                self.state = YLeaf(YType.enumeration, "state")

                                                self.state_description = YLeaf(YType.str, "state-description")

                                                self.class_stats = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("policy_name",
                                                                "satid",
                                                                "state",
                                                                "state_description") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\:  str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"

                                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                    self._children_yang_names.add("cac-stats")

                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                    self._children_yang_names.add("general-stats")

                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    self._children_yang_names.add("iphc-stats")

                                                    self.police_stats_array = YList(self)
                                                    self.queue_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("cac_state",
                                                                    "class_name",
                                                                    "counter_validity_bitmask",
                                                                    "queue_descr",
                                                                    "shared_queue_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("match_data_rate",
                                                                        "pre_policy_matched_bytes",
                                                                        "pre_policy_matched_packets",
                                                                        "total_drop_bytes",
                                                                        "total_drop_packets",
                                                                        "total_drop_rate",
                                                                        "total_transmit_rate",
                                                                        "transmit_bytes",
                                                                        "transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.match_data_rate.is_set or
                                                            self.pre_policy_matched_bytes.is_set or
                                                            self.pre_policy_matched_packets.is_set or
                                                            self.total_drop_bytes.is_set or
                                                            self.total_drop_packets.is_set or
                                                            self.total_drop_rate.is_set or
                                                            self.total_transmit_rate.is_set or
                                                            self.transmit_bytes.is_set or
                                                            self.transmit_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.match_data_rate.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                                            self.transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "general-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "match-data-rate"):
                                                            self.match_data_rate = value
                                                            self.match_data_rate.value_namespace = name_space
                                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-bytes"):
                                                            self.pre_policy_matched_bytes = value
                                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-packets"):
                                                            self.pre_policy_matched_packets = value
                                                            self.pre_policy_matched_packets.value_namespace = name_space
                                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-bytes"):
                                                            self.total_drop_bytes = value
                                                            self.total_drop_bytes.value_namespace = name_space
                                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-packets"):
                                                            self.total_drop_packets = value
                                                            self.total_drop_packets.value_namespace = name_space
                                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-rate"):
                                                            self.total_drop_rate = value
                                                            self.total_drop_rate.value_namespace = name_space
                                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-transmit-rate"):
                                                            self.total_transmit_rate = value
                                                            self.total_transmit_rate.value_namespace = name_space
                                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-bytes"):
                                                            self.transmit_bytes = value
                                                            self.transmit_bytes.value_namespace = name_space
                                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-packets"):
                                                            self.transmit_packets = value
                                                            self.transmit_packets.value_namespace = name_space
                                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("non_tcp_bytes_saved",
                                                                        "non_tcp_bytes_sent_rate",
                                                                        "non_tcp_compressed_packets_out",
                                                                        "non_tcp_full_header_packets_out",
                                                                        "non_tcp_total_out_bytes",
                                                                        "non_tcp_total_out_packets",
                                                                        "tcp_bytes_saved",
                                                                        "tcp_bytes_sent_rate",
                                                                        "tcp_compressed_packets_out",
                                                                        "tcp_full_header_packets_out",
                                                                        "tcp_total_out_bytes",
                                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.non_tcp_bytes_saved.is_set or
                                                            self.non_tcp_bytes_sent_rate.is_set or
                                                            self.non_tcp_compressed_packets_out.is_set or
                                                            self.non_tcp_full_header_packets_out.is_set or
                                                            self.non_tcp_total_out_bytes.is_set or
                                                            self.non_tcp_total_out_packets.is_set or
                                                            self.tcp_bytes_saved.is_set or
                                                            self.tcp_bytes_sent_rate.is_set or
                                                            self.tcp_compressed_packets_out.is_set or
                                                            self.tcp_full_header_packets_out.is_set or
                                                            self.tcp_total_out_bytes.is_set or
                                                            self.tcp_total_out_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "iphc-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "non-tcp-bytes-saved"):
                                                            self.non_tcp_bytes_saved = value
                                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                                            self.non_tcp_bytes_sent_rate = value
                                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-compressed-packets-out"):
                                                            self.non_tcp_compressed_packets_out = value
                                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-full-header-packets-out"):
                                                            self.non_tcp_full_header_packets_out = value
                                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-bytes"):
                                                            self.non_tcp_total_out_bytes = value
                                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-packets"):
                                                            self.non_tcp_total_out_packets = value
                                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-saved"):
                                                            self.tcp_bytes_saved = value
                                                            self.tcp_bytes_saved.value_namespace = name_space
                                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-sent-rate"):
                                                            self.tcp_bytes_sent_rate = value
                                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-compressed-packets-out"):
                                                            self.tcp_compressed_packets_out = value
                                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-full-header-packets-out"):
                                                            self.tcp_full_header_packets_out = value
                                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-bytes"):
                                                            self.tcp_total_out_bytes = value
                                                            self.tcp_total_out_bytes.value_namespace = name_space
                                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-packets"):
                                                            self.tcp_total_out_packets = value
                                                            self.tcp_total_out_packets.value_namespace = name_space
                                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("admit_bytes",
                                                                        "admit_rates",
                                                                        "admitpackets",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "drop_rates") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.admit_bytes.is_set or
                                                            self.admit_rates.is_set or
                                                            self.admitpackets.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.drop_rates.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.admit_bytes.yfilter != YFilter.not_set or
                                                            self.admit_rates.yfilter != YFilter.not_set or
                                                            self.admitpackets.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.drop_rates.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cac-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "admit-bytes"):
                                                            self.admit_bytes = value
                                                            self.admit_bytes.value_namespace = name_space
                                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admit-rates"):
                                                            self.admit_rates = value
                                                            self.admit_rates.value_namespace = name_space
                                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admitpackets"):
                                                            self.admitpackets = value
                                                            self.admitpackets.value_namespace = name_space
                                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-rates"):
                                                            self.drop_rates = value
                                                            self.drop_rates.value_namespace = name_space
                                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                        self.queue_average_length = YList(self)
                                                        self.queue_instance_length = YList(self)
                                                        self.queue_max_length = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("atm_clp0_drop_bytes",
                                                                        "atm_clp0_drop_packets",
                                                                        "atm_clp1_drop_bytes",
                                                                        "atm_clp1_drop_packets",
                                                                        "conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "forced_wred_stats_display",
                                                                        "max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "queue_drop_threshold",
                                                                        "queue_id",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "tail_drop_bytes",
                                                                        "tail_drop_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-instance-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-average-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-max-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.atm_clp0_drop_bytes.is_set or
                                                            self.atm_clp0_drop_packets.is_set or
                                                            self.atm_clp1_drop_bytes.is_set or
                                                            self.atm_clp1_drop_packets.is_set or
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.forced_wred_stats_display.is_set or
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.queue_drop_threshold.is_set or
                                                            self.queue_id.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.tail_drop_bytes.is_set or
                                                            self.tail_drop_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                            self.queue_id.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "queue-average-length"):
                                                            for c in self.queue_average_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_average_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-instance-length"):
                                                            for c in self.queue_instance_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_instance_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-max-length"):
                                                            for c in self.queue_max_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_max_length.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "atm-clp0-drop-bytes"):
                                                            self.atm_clp0_drop_bytes = value
                                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp0-drop-packets"):
                                                            self.atm_clp0_drop_packets = value
                                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-bytes"):
                                                            self.atm_clp1_drop_bytes = value
                                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-packets"):
                                                            self.atm_clp1_drop_packets = value
                                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "forced-wred-stats-display"):
                                                            self.forced_wred_stats_display = value
                                                            self.forced_wred_stats_display.value_namespace = name_space
                                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-drop-threshold"):
                                                            self.queue_drop_threshold = value
                                                            self.queue_drop_threshold.value_namespace = name_space
                                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-id"):
                                                            self.queue_id = value
                                                            self.queue_id.value_namespace = name_space
                                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-bytes"):
                                                            self.tail_drop_bytes = value
                                                            self.tail_drop_bytes.value_namespace = name_space
                                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-packets"):
                                                            self.tail_drop_packets = value
                                                            self.tail_drop_packets.value_namespace = name_space
                                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._children_yang_names.add("color-class-stats")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "parent_drop_bytes",
                                                                        "parent_drop_packets",
                                                                        "violate_bytes",
                                                                        "violate_packets",
                                                                        "violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"

                                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_class_conform_bytes",
                                                                            "conform_class_conform_packets",
                                                                            "conform_class_conform_rate",
                                                                            "conform_class_exceed_bytes",
                                                                            "conform_class_exceed_packets",
                                                                            "conform_class_exceed_rate",
                                                                            "conform_class_violate_bytes",
                                                                            "conform_class_violate_packets",
                                                                            "conform_class_violate_rate",
                                                                            "exceed_class_exceed_bytes",
                                                                            "exceed_class_exceed_packets",
                                                                            "exceed_class_exceed_rate",
                                                                            "exceed_class_violate_bytes",
                                                                            "exceed_class_violate_packets",
                                                                            "exceed_class_violate_rate",
                                                                            "violate_class_violate_bytes",
                                                                            "violate_class_violate_packets",
                                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.conform_class_conform_bytes.is_set or
                                                                self.conform_class_conform_packets.is_set or
                                                                self.conform_class_conform_rate.is_set or
                                                                self.conform_class_exceed_bytes.is_set or
                                                                self.conform_class_exceed_packets.is_set or
                                                                self.conform_class_exceed_rate.is_set or
                                                                self.conform_class_violate_bytes.is_set or
                                                                self.conform_class_violate_packets.is_set or
                                                                self.conform_class_violate_rate.is_set or
                                                                self.exceed_class_exceed_bytes.is_set or
                                                                self.exceed_class_exceed_packets.is_set or
                                                                self.exceed_class_exceed_rate.is_set or
                                                                self.exceed_class_violate_bytes.is_set or
                                                                self.exceed_class_violate_packets.is_set or
                                                                self.exceed_class_violate_rate.is_set or
                                                                self.violate_class_violate_bytes.is_set or
                                                                self.violate_class_violate_packets.is_set or
                                                                self.violate_class_violate_rate.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "color-class-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-class-conform-bytes"):
                                                                self.conform_class_conform_bytes = value
                                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-packets"):
                                                                self.conform_class_conform_packets = value
                                                                self.conform_class_conform_packets.value_namespace = name_space
                                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-rate"):
                                                                self.conform_class_conform_rate = value
                                                                self.conform_class_conform_rate.value_namespace = name_space
                                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-bytes"):
                                                                self.conform_class_exceed_bytes = value
                                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-packets"):
                                                                self.conform_class_exceed_packets = value
                                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-rate"):
                                                                self.conform_class_exceed_rate = value
                                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-bytes"):
                                                                self.conform_class_violate_bytes = value
                                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-packets"):
                                                                self.conform_class_violate_packets = value
                                                                self.conform_class_violate_packets.value_namespace = name_space
                                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-rate"):
                                                                self.conform_class_violate_rate = value
                                                                self.conform_class_violate_rate.value_namespace = name_space
                                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-bytes"):
                                                                self.exceed_class_exceed_bytes = value
                                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-packets"):
                                                                self.exceed_class_exceed_packets = value
                                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-rate"):
                                                                self.exceed_class_exceed_rate = value
                                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-bytes"):
                                                                self.exceed_class_violate_bytes = value
                                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-packets"):
                                                                self.exceed_class_violate_packets = value
                                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-rate"):
                                                                self.exceed_class_violate_rate = value
                                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-bytes"):
                                                                self.violate_class_violate_bytes = value
                                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-packets"):
                                                                self.violate_class_violate_packets = value
                                                                self.violate_class_violate_packets.value_namespace = name_space
                                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-rate"):
                                                                self.violate_class_violate_rate = value
                                                                self.violate_class_violate_rate.value_namespace = name_space
                                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.parent_drop_bytes.is_set or
                                                            self.parent_drop_packets.is_set or
                                                            self.violate_bytes.is_set or
                                                            self.violate_packets.is_set or
                                                            self.violate_rate.is_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                                            self.violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_rate.yfilter != YFilter.not_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "color-class-stats"):
                                                            if (self.color_class_stats is None):
                                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            return self.color_class_stats

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-bytes"):
                                                            self.parent_drop_bytes = value
                                                            self.parent_drop_bytes.value_namespace = name_space
                                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-packets"):
                                                            self.parent_drop_packets = value
                                                            self.parent_drop_packets.value_namespace = name_space
                                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-bytes"):
                                                            self.violate_bytes = value
                                                            self.violate_bytes.value_namespace = name_space
                                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-packets"):
                                                            self.violate_packets = value
                                                            self.violate_packets.value_namespace = name_space
                                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-rate"):
                                                            self.violate_rate = value
                                                            self.violate_rate.value_namespace = name_space
                                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                        self.red_label = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "profile_title",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "red_ecn_marked_bytes",
                                                                        "red_ecn_marked_packets",
                                                                        "red_transmit_bytes",
                                                                        "red_transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"

                                                            self.value = YLeaf(YType.uint8, "value")

                                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("value",
                                                                            "wred_type") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.value.is_set or
                                                                self.wred_type.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set or
                                                                self.wred_type.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "red-label" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())
                                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "value" or name == "wred-type"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "wred-type"):
                                                                self.wred_type = value
                                                                self.wred_type.value_namespace = name_space
                                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.red_label:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.profile_title.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.red_ecn_marked_bytes.is_set or
                                                            self.red_ecn_marked_packets.is_set or
                                                            self.red_transmit_bytes.is_set or
                                                            self.red_transmit_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.red_label:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.profile_title.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "wred-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "red-label"):
                                                            for c in self.red_label:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.red_label.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "profile-title"):
                                                            self.profile_title = value
                                                            self.profile_title.value_namespace = name_space
                                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-bytes"):
                                                            self.red_ecn_marked_bytes = value
                                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-packets"):
                                                            self.red_ecn_marked_packets = value
                                                            self.red_ecn_marked_packets.value_namespace = name_space
                                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-bytes"):
                                                            self.red_transmit_bytes = value
                                                            self.red_transmit_bytes.value_namespace = name_space
                                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-packets"):
                                                            self.red_transmit_packets = value
                                                            self.red_transmit_packets.value_namespace = name_space
                                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.cac_state.is_set or
                                                        self.class_name.is_set or
                                                        self.counter_validity_bitmask.is_set or
                                                        self.queue_descr.is_set or
                                                        self.shared_queue_id.is_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                def has_operation(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.cac_state.yfilter != YFilter.not_set or
                                                        self.class_name.yfilter != YFilter.not_set or
                                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                        self.queue_descr.yfilter != YFilter.not_set or
                                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cac-stats"):
                                                        if (self.cac_stats is None):
                                                            self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                        return self.cac_stats

                                                    if (child_yang_name == "general-stats"):
                                                        if (self.general_stats is None):
                                                            self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"
                                                        return self.general_stats

                                                    if (child_yang_name == "iphc-stats"):
                                                        if (self.iphc_stats is None):
                                                            self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        return self.iphc_stats

                                                    if (child_yang_name == "police-stats-array"):
                                                        for c in self.police_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.police_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-stats-array"):
                                                        for c in self.queue_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "wred-stats-array"):
                                                        for c in self.wred_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.wred_stats_array.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "cac-state"):
                                                        self.cac_state = value
                                                        self.cac_state.value_namespace = name_space
                                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "class-name"):
                                                        self.class_name = value
                                                        self.class_name.value_namespace = name_space
                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "counter-validity-bitmask"):
                                                        self.counter_validity_bitmask = value
                                                        self.counter_validity_bitmask.value_namespace = name_space
                                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-descr"):
                                                        self.queue_descr = value
                                                        self.queue_descr.value_namespace = name_space
                                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "shared-queue-id"):
                                                        self.shared_queue_id = value
                                                        self.shared_queue_id.value_namespace = name_space
                                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.class_stats:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.policy_name.is_set or
                                                    self.satid.is_set or
                                                    self.state.is_set or
                                                    self.state_description.is_set)

                                            def has_operation(self):
                                                for c in self.class_stats:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    self.satid.yfilter != YFilter.not_set or
                                                    self.state.yfilter != YFilter.not_set or
                                                    self.state_description.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "child-policy" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state.get_name_leafdata())
                                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "class-stats"):
                                                    for c in self.class_stats:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.class_stats.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "satid"):
                                                    self.satid = value
                                                    self.satid.value_namespace = name_space
                                                    self.satid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state"):
                                                    self.state = value
                                                    self.state.value_namespace = name_space
                                                    self.state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state-description"):
                                                    self.state_description = value
                                                    self.state_description.value_namespace = name_space
                                                    self.state_description.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.child_policy is not None and self.child_policy.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.child_policy is not None and self.child_policy.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "child-policy"):
                                                if (self.child_policy is None):
                                                    self.child_policy = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"
                                                return self.child_policy

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "statistics" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                        (self.statistics is not None and self.statistics.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                        (self.statistics is not None and self.statistics.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "output" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "service-policy-names"):
                                        if (self.service_policy_names is None):
                                            self.service_policy_names = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.ServicePolicyNames()
                                            self.service_policy_names.parent = self
                                            self._children_name_map["service_policy_names"] = "service-policy-names"
                                        return self.service_policy_names

                                    if (child_yang_name == "statistics"):
                                        if (self.statistics is None):
                                            self.statistics = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                        return self.statistics

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-names" or name == "statistics"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.interface_name.is_set or
                                    (self.input is not None and self.input.has_data()) or
                                    (self.member_interfaces is not None and self.member_interfaces.has_data()) or
                                    (self.output is not None and self.output.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    (self.input is not None and self.input.has_operation()) or
                                    (self.member_interfaces is not None and self.member_interfaces.has_operation()) or
                                    (self.output is not None and self.output.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nv-satellite-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "input"):
                                    if (self.input is None):
                                        self.input = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input()
                                        self.input.parent = self
                                        self._children_name_map["input"] = "input"
                                    return self.input

                                if (child_yang_name == "member-interfaces"):
                                    if (self.member_interfaces is None):
                                        self.member_interfaces = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces()
                                        self.member_interfaces.parent = self
                                        self._children_name_map["member_interfaces"] = "member-interfaces"
                                    return self.member_interfaces

                                if (child_yang_name == "output"):
                                    if (self.output is None):
                                        self.output = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output()
                                        self.output.parent = self
                                        self._children_name_map["output"] = "output"
                                    return self.output

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "input" or name == "member-interfaces" or name == "output" or name == "interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.nv_satellite_interface:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.nv_satellite_interface:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nv-satellite-interfaces" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "nv-satellite-interface"):
                                for c in self.nv_satellite_interface:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.nv_satellite_interface.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "nv-satellite-interface"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.satellite_id.is_set or
                            (self.nv_satellite_interfaces is not None and self.nv_satellite_interfaces.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.satellite_id.yfilter != YFilter.not_set or
                            (self.nv_satellite_interfaces is not None and self.nv_satellite_interfaces.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "nv-satellite-id" + "[satellite-id='" + self.satellite_id.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/nv-satellite/nv-satellite-statistics/nv-satellite-ids/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.satellite_id.is_set or self.satellite_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.satellite_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "nv-satellite-interfaces"):
                            if (self.nv_satellite_interfaces is None):
                                self.nv_satellite_interfaces = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces()
                                self.nv_satellite_interfaces.parent = self
                                self._children_name_map["nv_satellite_interfaces"] = "nv-satellite-interfaces"
                            return self.nv_satellite_interfaces

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "nv-satellite-interfaces" or name == "satellite-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "satellite-id"):
                            self.satellite_id = value
                            self.satellite_id.value_namespace = name_space
                            self.satellite_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.nv_satellite_id:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.nv_satellite_id:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "nv-satellite-ids" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/nv-satellite/nv-satellite-statistics/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "nv-satellite-id"):
                        for c in self.nv_satellite_id:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds.NvSatelliteId()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.nv_satellite_id.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "nv-satellite-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (self.nv_satellite_ids is not None and self.nv_satellite_ids.has_data())

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.nv_satellite_ids is not None and self.nv_satellite_ids.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "nv-satellite-statistics" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/nv-satellite/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "nv-satellite-ids"):
                    if (self.nv_satellite_ids is None):
                        self.nv_satellite_ids = Qos.NvSatellite.NvSatelliteStatistics.NvSatelliteIds()
                        self.nv_satellite_ids.parent = self
                        self._children_name_map["nv_satellite_ids"] = "nv-satellite-ids"
                    return self.nv_satellite_ids

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "nv-satellite-ids"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class NvSatelliteStatus(Entity):
            """
            Satellite QOS offload status based on Satellite
            ID
            
            .. attribute:: nv_satellite_ids
            
            	Satellite ID table
            	**type**\:   :py:class:`NvSatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds>`
            
            

            """

            _prefix = 'qos-ma-oper'
            _revision = '2017-04-10'

            def __init__(self):
                super(Qos.NvSatellite.NvSatelliteStatus, self).__init__()

                self.yang_name = "nv-satellite-status"
                self.yang_parent_name = "nv-satellite"

                self.nv_satellite_ids = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds()
                self.nv_satellite_ids.parent = self
                self._children_name_map["nv_satellite_ids"] = "nv-satellite-ids"
                self._children_yang_names.add("nv-satellite-ids")


            class NvSatelliteIds(Entity):
                """
                Satellite ID table
                
                .. attribute:: nv_satellite_id
                
                	Satellite ID information
                	**type**\: list of    :py:class:`NvSatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds, self).__init__()

                    self.yang_name = "nv-satellite-ids"
                    self.yang_parent_name = "nv-satellite-status"

                    self.nv_satellite_id = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds, self).__setattr__(name, value)


                class NvSatelliteId(Entity):
                    """
                    Satellite ID information
                    
                    .. attribute:: satellite_id  <key>
                    
                    	Satellite ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: nv_satellite_interfaces
                    
                    	QOS offload status of satellite interface of a particular satellite
                    	**type**\:   :py:class:`NvSatelliteInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId, self).__init__()

                        self.yang_name = "nv-satellite-id"
                        self.yang_parent_name = "nv-satellite-ids"

                        self.satellite_id = YLeaf(YType.int32, "satellite-id")

                        self.nv_satellite_interfaces = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces()
                        self.nv_satellite_interfaces.parent = self
                        self._children_name_map["nv_satellite_interfaces"] = "nv-satellite-interfaces"
                        self._children_yang_names.add("nv-satellite-interfaces")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("satellite_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId, self).__setattr__(name, value)


                    class NvSatelliteInterfaces(Entity):
                        """
                        QOS offload status of satellite interface of
                        a particular satellite
                        
                        .. attribute:: nv_satellite_interface
                        
                        	QOS offload status for a particular satellite interface
                        	**type**\: list of    :py:class:`NvSatelliteInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces, self).__init__()

                            self.yang_name = "nv-satellite-interfaces"
                            self.yang_parent_name = "nv-satellite-id"

                            self.nv_satellite_interface = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces, self).__setattr__(name, value)


                        class NvSatelliteInterface(Entity):
                            """
                            QOS offload status for a particular
                            satellite interface
                            
                            .. attribute:: interface_name  <key>
                            
                            	Name of the interface
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: input
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input>`
                            
                            .. attribute:: member_interfaces
                            
                            	Satellite member interface table
                            	**type**\:   :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces>`
                            
                            .. attribute:: output
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output>`
                            
                            .. attribute:: status
                            
                            	Policy\-map status operational data for an interface
                            	**type**\:   :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Status>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface, self).__init__()

                                self.yang_name = "nv-satellite-interface"
                                self.yang_parent_name = "nv-satellite-interfaces"

                                self.interface_name = YLeaf(YType.str, "interface-name")

                                self.input = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"
                                self._children_yang_names.add("input")

                                self.member_interfaces = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces()
                                self.member_interfaces.parent = self
                                self._children_name_map["member_interfaces"] = "member-interfaces"
                                self._children_yang_names.add("member-interfaces")

                                self.output = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                                self._children_yang_names.add("output")

                                self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Status()
                                self.status.parent = self
                                self._children_name_map["status"] = "status"
                                self._children_yang_names.add("status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface, self).__setattr__(name, value)


                            class MemberInterfaces(Entity):
                                """
                                Satellite member interface table
                                
                                .. attribute:: member_interface
                                
                                	Satellite member interface statistics
                                	**type**\: list of    :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces, self).__init__()

                                    self.yang_name = "member-interfaces"
                                    self.yang_parent_name = "nv-satellite-interface"

                                    self.member_interface = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces, self).__setattr__(name, value)


                                class MemberInterface(Entity):
                                    """
                                    Satellite member interface statistics
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	Name of member interface
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: input
                                    
                                    	A piece of QoS policy\-map operational data for an interface
                                    	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input>`
                                    
                                    .. attribute:: output
                                    
                                    	A piece of QoS policy\-map operational data for an interface
                                    	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface, self).__init__()

                                        self.yang_name = "member-interface"
                                        self.yang_parent_name = "member-interfaces"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.input = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input()
                                        self.input.parent = self
                                        self._children_name_map["input"] = "input"
                                        self._children_yang_names.add("input")

                                        self.output = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output()
                                        self.output.parent = self
                                        self._children_name_map["output"] = "output"
                                        self._children_yang_names.add("output")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface, self).__setattr__(name, value)


                                    class Input(Entity):
                                        """
                                        A piece of QoS policy\-map operational data for
                                        an interface
                                        
                                        .. attribute:: status
                                        
                                        	Policy\-map status operational data for an interface
                                        	**type**\:   :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Status>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input, self).__init__()

                                            self.yang_name = "input"
                                            self.yang_parent_name = "member-interface"

                                            self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Status()
                                            self.status.parent = self
                                            self._children_name_map["status"] = "status"
                                            self._children_yang_names.add("status")


                                        class Status(Entity):
                                            """
                                            Policy\-map status operational data for an
                                            interface
                                            
                                            .. attribute:: direction
                                            
                                            	Satellite caps type
                                            	**type**\:   :py:class:`QosMaSatCapsTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosMaSatCapsTypeEnum>`
                                            
                                            .. attribute:: error_message
                                            
                                            	Error message
                                            	**type**\:  str
                                            
                                            .. attribute:: last_operation
                                            
                                            	Previous caps operation
                                            	**type**\:   :py:class:`QosCapsOperationEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosCapsOperationEnum>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	Service policy name
                                            	**type**\:  str
                                            
                                            .. attribute:: status
                                            
                                            	Status of offload
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Status, self).__init__()

                                                self.yang_name = "status"
                                                self.yang_parent_name = "input"

                                                self.direction = YLeaf(YType.enumeration, "direction")

                                                self.error_message = YLeaf(YType.str, "error-message")

                                                self.last_operation = YLeaf(YType.enumeration, "last-operation")

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.status = YLeaf(YType.str, "status")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("direction",
                                                                "error_message",
                                                                "last_operation",
                                                                "policy_name",
                                                                "status") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Status, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Status, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.direction.is_set or
                                                    self.error_message.is_set or
                                                    self.last_operation.is_set or
                                                    self.policy_name.is_set or
                                                    self.status.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.direction.yfilter != YFilter.not_set or
                                                    self.error_message.yfilter != YFilter.not_set or
                                                    self.last_operation.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    self.status.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "status" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.direction.is_set or self.direction.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.direction.get_name_leafdata())
                                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                                if (self.last_operation.is_set or self.last_operation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_operation.get_name_leafdata())
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.status.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "direction" or name == "error-message" or name == "last-operation" or name == "policy-name" or name == "status"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "direction"):
                                                    self.direction = value
                                                    self.direction.value_namespace = name_space
                                                    self.direction.value_namespace_prefix = name_space_prefix
                                                if(value_path == "error-message"):
                                                    self.error_message = value
                                                    self.error_message.value_namespace = name_space
                                                    self.error_message.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-operation"):
                                                    self.last_operation = value
                                                    self.last_operation.value_namespace = name_space
                                                    self.last_operation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "status"):
                                                    self.status = value
                                                    self.status.value_namespace = name_space
                                                    self.status.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.status is not None and self.status.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.status is not None and self.status.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "input" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "status"):
                                                if (self.status is None):
                                                    self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input.Status()
                                                    self.status.parent = self
                                                    self._children_name_map["status"] = "status"
                                                return self.status

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "status"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Output(Entity):
                                        """
                                        A piece of QoS policy\-map operational data for
                                        an interface
                                        
                                        .. attribute:: status
                                        
                                        	Policy\-map status operational data for an interface
                                        	**type**\:   :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Status>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output, self).__init__()

                                            self.yang_name = "output"
                                            self.yang_parent_name = "member-interface"

                                            self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Status()
                                            self.status.parent = self
                                            self._children_name_map["status"] = "status"
                                            self._children_yang_names.add("status")


                                        class Status(Entity):
                                            """
                                            Policy\-map status operational data for an
                                            interface
                                            
                                            .. attribute:: direction
                                            
                                            	Satellite caps type
                                            	**type**\:   :py:class:`QosMaSatCapsTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosMaSatCapsTypeEnum>`
                                            
                                            .. attribute:: error_message
                                            
                                            	Error message
                                            	**type**\:  str
                                            
                                            .. attribute:: last_operation
                                            
                                            	Previous caps operation
                                            	**type**\:   :py:class:`QosCapsOperationEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosCapsOperationEnum>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	Service policy name
                                            	**type**\:  str
                                            
                                            .. attribute:: status
                                            
                                            	Status of offload
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Status, self).__init__()

                                                self.yang_name = "status"
                                                self.yang_parent_name = "output"

                                                self.direction = YLeaf(YType.enumeration, "direction")

                                                self.error_message = YLeaf(YType.str, "error-message")

                                                self.last_operation = YLeaf(YType.enumeration, "last-operation")

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.status = YLeaf(YType.str, "status")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("direction",
                                                                "error_message",
                                                                "last_operation",
                                                                "policy_name",
                                                                "status") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Status, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Status, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.direction.is_set or
                                                    self.error_message.is_set or
                                                    self.last_operation.is_set or
                                                    self.policy_name.is_set or
                                                    self.status.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.direction.yfilter != YFilter.not_set or
                                                    self.error_message.yfilter != YFilter.not_set or
                                                    self.last_operation.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    self.status.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "status" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.direction.is_set or self.direction.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.direction.get_name_leafdata())
                                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                                if (self.last_operation.is_set or self.last_operation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_operation.get_name_leafdata())
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.status.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "direction" or name == "error-message" or name == "last-operation" or name == "policy-name" or name == "status"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "direction"):
                                                    self.direction = value
                                                    self.direction.value_namespace = name_space
                                                    self.direction.value_namespace_prefix = name_space_prefix
                                                if(value_path == "error-message"):
                                                    self.error_message = value
                                                    self.error_message.value_namespace = name_space
                                                    self.error_message.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-operation"):
                                                    self.last_operation = value
                                                    self.last_operation.value_namespace = name_space
                                                    self.last_operation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "status"):
                                                    self.status = value
                                                    self.status.value_namespace = name_space
                                                    self.status.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.status is not None and self.status.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.status is not None and self.status.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "output" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "status"):
                                                if (self.status is None):
                                                    self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output.Status()
                                                    self.status.parent = self
                                                    self._children_name_map["status"] = "status"
                                                return self.status

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "status"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            self.interface_name.is_set or
                                            (self.input is not None and self.input.has_data()) or
                                            (self.output is not None and self.output.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            (self.input is not None and self.input.has_operation()) or
                                            (self.output is not None and self.output.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "member-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "input"):
                                            if (self.input is None):
                                                self.input = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Input()
                                                self.input.parent = self
                                                self._children_name_map["input"] = "input"
                                            return self.input

                                        if (child_yang_name == "output"):
                                            if (self.output is None):
                                                self.output = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface.Output()
                                                self.output.parent = self
                                                self._children_name_map["output"] = "output"
                                            return self.output

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "input" or name == "output" or name == "interface-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.member_interface:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.member_interface:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "member-interfaces" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "member-interface"):
                                        for c in self.member_interface:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces.MemberInterface()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.member_interface.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "member-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Input(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: status
                                
                                	Policy\-map status operational data for an interface
                                	**type**\:   :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Status>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input, self).__init__()

                                    self.yang_name = "input"
                                    self.yang_parent_name = "nv-satellite-interface"

                                    self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Status()
                                    self.status.parent = self
                                    self._children_name_map["status"] = "status"
                                    self._children_yang_names.add("status")


                                class Status(Entity):
                                    """
                                    Policy\-map status operational data for an
                                    interface
                                    
                                    .. attribute:: direction
                                    
                                    	Satellite caps type
                                    	**type**\:   :py:class:`QosMaSatCapsTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosMaSatCapsTypeEnum>`
                                    
                                    .. attribute:: error_message
                                    
                                    	Error message
                                    	**type**\:  str
                                    
                                    .. attribute:: last_operation
                                    
                                    	Previous caps operation
                                    	**type**\:   :py:class:`QosCapsOperationEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosCapsOperationEnum>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	Service policy name
                                    	**type**\:  str
                                    
                                    .. attribute:: status
                                    
                                    	Status of offload
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Status, self).__init__()

                                        self.yang_name = "status"
                                        self.yang_parent_name = "input"

                                        self.direction = YLeaf(YType.enumeration, "direction")

                                        self.error_message = YLeaf(YType.str, "error-message")

                                        self.last_operation = YLeaf(YType.enumeration, "last-operation")

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.status = YLeaf(YType.str, "status")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("direction",
                                                        "error_message",
                                                        "last_operation",
                                                        "policy_name",
                                                        "status") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Status, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Status, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.direction.is_set or
                                            self.error_message.is_set or
                                            self.last_operation.is_set or
                                            self.policy_name.is_set or
                                            self.status.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.direction.yfilter != YFilter.not_set or
                                            self.error_message.yfilter != YFilter.not_set or
                                            self.last_operation.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.status.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "status" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.direction.is_set or self.direction.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.direction.get_name_leafdata())
                                        if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.error_message.get_name_leafdata())
                                        if (self.last_operation.is_set or self.last_operation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_operation.get_name_leafdata())
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.status.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "direction" or name == "error-message" or name == "last-operation" or name == "policy-name" or name == "status"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "direction"):
                                            self.direction = value
                                            self.direction.value_namespace = name_space
                                            self.direction.value_namespace_prefix = name_space_prefix
                                        if(value_path == "error-message"):
                                            self.error_message = value
                                            self.error_message.value_namespace = name_space
                                            self.error_message.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-operation"):
                                            self.last_operation = value
                                            self.last_operation.value_namespace = name_space
                                            self.last_operation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "status"):
                                            self.status = value
                                            self.status.value_namespace = name_space
                                            self.status.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.status is not None and self.status.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.status is not None and self.status.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "input" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "status"):
                                        if (self.status is None):
                                            self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input.Status()
                                            self.status.parent = self
                                            self._children_name_map["status"] = "status"
                                        return self.status

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Status(Entity):
                                """
                                Policy\-map status operational data for an
                                interface
                                
                                .. attribute:: direction
                                
                                	Satellite caps type
                                	**type**\:   :py:class:`QosMaSatCapsTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosMaSatCapsTypeEnum>`
                                
                                .. attribute:: error_message
                                
                                	Error message
                                	**type**\:  str
                                
                                .. attribute:: last_operation
                                
                                	Previous caps operation
                                	**type**\:   :py:class:`QosCapsOperationEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosCapsOperationEnum>`
                                
                                .. attribute:: policy_name
                                
                                	Service policy name
                                	**type**\:  str
                                
                                .. attribute:: status
                                
                                	Status of offload
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Status, self).__init__()

                                    self.yang_name = "status"
                                    self.yang_parent_name = "nv-satellite-interface"

                                    self.direction = YLeaf(YType.enumeration, "direction")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.last_operation = YLeaf(YType.enumeration, "last-operation")

                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                    self.status = YLeaf(YType.str, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("direction",
                                                    "error_message",
                                                    "last_operation",
                                                    "policy_name",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Status, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Status, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.direction.is_set or
                                        self.error_message.is_set or
                                        self.last_operation.is_set or
                                        self.policy_name.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.direction.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.last_operation.yfilter != YFilter.not_set or
                                        self.policy_name.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "status" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.direction.is_set or self.direction.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.direction.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.last_operation.is_set or self.last_operation.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_operation.get_name_leafdata())
                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "direction" or name == "error-message" or name == "last-operation" or name == "policy-name" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "direction"):
                                        self.direction = value
                                        self.direction.value_namespace = name_space
                                        self.direction.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-operation"):
                                        self.last_operation = value
                                        self.last_operation.value_namespace = name_space
                                        self.last_operation.value_namespace_prefix = name_space_prefix
                                    if(value_path == "policy-name"):
                                        self.policy_name = value
                                        self.policy_name.value_namespace = name_space
                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix


                            class Output(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: status
                                
                                	Policy\-map status operational data for an interface
                                	**type**\:   :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Status>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output, self).__init__()

                                    self.yang_name = "output"
                                    self.yang_parent_name = "nv-satellite-interface"

                                    self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Status()
                                    self.status.parent = self
                                    self._children_name_map["status"] = "status"
                                    self._children_yang_names.add("status")


                                class Status(Entity):
                                    """
                                    Policy\-map status operational data for an
                                    interface
                                    
                                    .. attribute:: direction
                                    
                                    	Satellite caps type
                                    	**type**\:   :py:class:`QosMaSatCapsTypeEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosMaSatCapsTypeEnum>`
                                    
                                    .. attribute:: error_message
                                    
                                    	Error message
                                    	**type**\:  str
                                    
                                    .. attribute:: last_operation
                                    
                                    	Previous caps operation
                                    	**type**\:   :py:class:`QosCapsOperationEnum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.QosCapsOperationEnum>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	Service policy name
                                    	**type**\:  str
                                    
                                    .. attribute:: status
                                    
                                    	Status of offload
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Status, self).__init__()

                                        self.yang_name = "status"
                                        self.yang_parent_name = "output"

                                        self.direction = YLeaf(YType.enumeration, "direction")

                                        self.error_message = YLeaf(YType.str, "error-message")

                                        self.last_operation = YLeaf(YType.enumeration, "last-operation")

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.status = YLeaf(YType.str, "status")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("direction",
                                                        "error_message",
                                                        "last_operation",
                                                        "policy_name",
                                                        "status") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Status, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Status, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.direction.is_set or
                                            self.error_message.is_set or
                                            self.last_operation.is_set or
                                            self.policy_name.is_set or
                                            self.status.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.direction.yfilter != YFilter.not_set or
                                            self.error_message.yfilter != YFilter.not_set or
                                            self.last_operation.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.status.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "status" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.direction.is_set or self.direction.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.direction.get_name_leafdata())
                                        if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.error_message.get_name_leafdata())
                                        if (self.last_operation.is_set or self.last_operation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_operation.get_name_leafdata())
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.status.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "direction" or name == "error-message" or name == "last-operation" or name == "policy-name" or name == "status"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "direction"):
                                            self.direction = value
                                            self.direction.value_namespace = name_space
                                            self.direction.value_namespace_prefix = name_space_prefix
                                        if(value_path == "error-message"):
                                            self.error_message = value
                                            self.error_message.value_namespace = name_space
                                            self.error_message.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-operation"):
                                            self.last_operation = value
                                            self.last_operation.value_namespace = name_space
                                            self.last_operation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "status"):
                                            self.status = value
                                            self.status.value_namespace = name_space
                                            self.status.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.status is not None and self.status.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.status is not None and self.status.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "output" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "status"):
                                        if (self.status is None):
                                            self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output.Status()
                                            self.status.parent = self
                                            self._children_name_map["status"] = "status"
                                        return self.status

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.interface_name.is_set or
                                    (self.input is not None and self.input.has_data()) or
                                    (self.member_interfaces is not None and self.member_interfaces.has_data()) or
                                    (self.output is not None and self.output.has_data()) or
                                    (self.status is not None and self.status.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.interface_name.yfilter != YFilter.not_set or
                                    (self.input is not None and self.input.has_operation()) or
                                    (self.member_interfaces is not None and self.member_interfaces.has_operation()) or
                                    (self.output is not None and self.output.has_operation()) or
                                    (self.status is not None and self.status.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nv-satellite-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "input"):
                                    if (self.input is None):
                                        self.input = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Input()
                                        self.input.parent = self
                                        self._children_name_map["input"] = "input"
                                    return self.input

                                if (child_yang_name == "member-interfaces"):
                                    if (self.member_interfaces is None):
                                        self.member_interfaces = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.MemberInterfaces()
                                        self.member_interfaces.parent = self
                                        self._children_name_map["member_interfaces"] = "member-interfaces"
                                    return self.member_interfaces

                                if (child_yang_name == "output"):
                                    if (self.output is None):
                                        self.output = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Output()
                                        self.output.parent = self
                                        self._children_name_map["output"] = "output"
                                    return self.output

                                if (child_yang_name == "status"):
                                    if (self.status is None):
                                        self.status = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface.Status()
                                        self.status.parent = self
                                        self._children_name_map["status"] = "status"
                                    return self.status

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "input" or name == "member-interfaces" or name == "output" or name == "status" or name == "interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "interface-name"):
                                    self.interface_name = value
                                    self.interface_name.value_namespace = name_space
                                    self.interface_name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.nv_satellite_interface:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.nv_satellite_interface:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nv-satellite-interfaces" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "nv-satellite-interface"):
                                for c in self.nv_satellite_interface:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces.NvSatelliteInterface()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.nv_satellite_interface.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "nv-satellite-interface"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.satellite_id.is_set or
                            (self.nv_satellite_interfaces is not None and self.nv_satellite_interfaces.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.satellite_id.yfilter != YFilter.not_set or
                            (self.nv_satellite_interfaces is not None and self.nv_satellite_interfaces.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "nv-satellite-id" + "[satellite-id='" + self.satellite_id.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/nv-satellite/nv-satellite-status/nv-satellite-ids/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.satellite_id.is_set or self.satellite_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.satellite_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "nv-satellite-interfaces"):
                            if (self.nv_satellite_interfaces is None):
                                self.nv_satellite_interfaces = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId.NvSatelliteInterfaces()
                                self.nv_satellite_interfaces.parent = self
                                self._children_name_map["nv_satellite_interfaces"] = "nv-satellite-interfaces"
                            return self.nv_satellite_interfaces

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "nv-satellite-interfaces" or name == "satellite-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "satellite-id"):
                            self.satellite_id = value
                            self.satellite_id.value_namespace = name_space
                            self.satellite_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.nv_satellite_id:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.nv_satellite_id:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "nv-satellite-ids" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/nv-satellite/nv-satellite-status/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "nv-satellite-id"):
                        for c in self.nv_satellite_id:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds.NvSatelliteId()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.nv_satellite_id.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "nv-satellite-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (self.nv_satellite_ids is not None and self.nv_satellite_ids.has_data())

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.nv_satellite_ids is not None and self.nv_satellite_ids.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "nv-satellite-status" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/nv-satellite/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "nv-satellite-ids"):
                    if (self.nv_satellite_ids is None):
                        self.nv_satellite_ids = Qos.NvSatellite.NvSatelliteStatus.NvSatelliteIds()
                        self.nv_satellite_ids.parent = self
                        self._children_name_map["nv_satellite_ids"] = "nv-satellite-ids"
                    return self.nv_satellite_ids

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "nv-satellite-ids"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.nv_satellite_statistics is not None and self.nv_satellite_statistics.has_data()) or
                (self.nv_satellite_status is not None and self.nv_satellite_status.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.nv_satellite_statistics is not None and self.nv_satellite_statistics.has_operation()) or
                (self.nv_satellite_status is not None and self.nv_satellite_status.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "nv-satellite" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "nv-satellite-statistics"):
                if (self.nv_satellite_statistics is None):
                    self.nv_satellite_statistics = Qos.NvSatellite.NvSatelliteStatistics()
                    self.nv_satellite_statistics.parent = self
                    self._children_name_map["nv_satellite_statistics"] = "nv-satellite-statistics"
                return self.nv_satellite_statistics

            if (child_yang_name == "nv-satellite-status"):
                if (self.nv_satellite_status is None):
                    self.nv_satellite_status = Qos.NvSatellite.NvSatelliteStatus()
                    self.nv_satellite_status.parent = self
                    self._children_name_map["nv_satellite_status"] = "nv-satellite-status"
                return self.nv_satellite_status

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "nv-satellite-statistics" or name == "nv-satellite-status"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Nodes(Entity):
        """
        Node\-specific QoS operational data
        
        .. attribute:: node
        
        	QoS operational data for a particular node
        	**type**\: list of    :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node>`
        
        

        """

        _prefix = 'qos-ma-oper'
        _revision = '2017-04-10'

        def __init__(self):
            super(Qos.Nodes, self).__init__()

            self.yang_name = "nodes"
            self.yang_parent_name = "qos"

            self.node = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(Qos.Nodes, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(Qos.Nodes, self).__setattr__(name, value)


        class Node(Entity):
            """
            QoS operational data for a particular node
            
            .. attribute:: node_name  <key>
            
            	The node
            	**type**\:  str
            
            	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
            
            .. attribute:: policy_map
            
            	Operational data for policymaps
            	**type**\:   :py:class:`PolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap>`
            
            

            """

            _prefix = 'qos-ma-oper'
            _revision = '2017-04-10'

            def __init__(self):
                super(Qos.Nodes.Node, self).__init__()

                self.yang_name = "node"
                self.yang_parent_name = "nodes"

                self.node_name = YLeaf(YType.str, "node-name")

                self.policy_map = Qos.Nodes.Node.PolicyMap()
                self.policy_map.parent = self
                self._children_name_map["policy_map"] = "policy-map"
                self._children_yang_names.add("policy-map")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("node_name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(Qos.Nodes.Node, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(Qos.Nodes.Node, self).__setattr__(name, value)


            class PolicyMap(Entity):
                """
                Operational data for policymaps
                
                .. attribute:: interface_table
                
                	Operational data for all interfaces
                	**type**\:   :py:class:`InterfaceTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable>`
                
                .. attribute:: shared_policy_instances
                
                	Operational data for all SPI
                	**type**\:   :py:class:`SharedPolicyInstances <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.Nodes.Node.PolicyMap, self).__init__()

                    self.yang_name = "policy-map"
                    self.yang_parent_name = "node"

                    self.interface_table = Qos.Nodes.Node.PolicyMap.InterfaceTable()
                    self.interface_table.parent = self
                    self._children_name_map["interface_table"] = "interface-table"
                    self._children_yang_names.add("interface-table")

                    self.shared_policy_instances = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances()
                    self.shared_policy_instances.parent = self
                    self._children_name_map["shared_policy_instances"] = "shared-policy-instances"
                    self._children_yang_names.add("shared-policy-instances")


                class SharedPolicyInstances(Entity):
                    """
                    Operational data for all SPI
                    
                    .. attribute:: shared_policy_instance
                    
                    	QoS policy\-map operational data for a particular SPI 
                    	**type**\: list of    :py:class:`SharedPolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances, self).__init__()

                        self.yang_name = "shared-policy-instances"
                        self.yang_parent_name = "policy-map"

                        self.shared_policy_instance = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances, self).__setattr__(name, value)


                    class SharedPolicyInstance(Entity):
                        """
                        QoS policy\-map operational data for a
                        particular SPI 
                        
                        .. attribute:: spi_name  <key>
                        
                        	Name of the shared policy instance
                        	**type**\:  str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        .. attribute:: input
                        
                        	A piece of QoS policy\-map operational data for an interface
                        	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input>`
                        
                        .. attribute:: member_interfaces
                        
                        	QoS policy\-map member interface table
                        	**type**\:   :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces>`
                        
                        .. attribute:: output
                        
                        	A piece of QoS policy\-map operational data for an interface
                        	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance, self).__init__()

                            self.yang_name = "shared-policy-instance"
                            self.yang_parent_name = "shared-policy-instances"

                            self.spi_name = YLeaf(YType.str, "spi-name")

                            self.input = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input()
                            self.input.parent = self
                            self._children_name_map["input"] = "input"
                            self._children_yang_names.add("input")

                            self.member_interfaces = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces()
                            self.member_interfaces.parent = self
                            self._children_name_map["member_interfaces"] = "member-interfaces"
                            self._children_yang_names.add("member-interfaces")

                            self.output = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output()
                            self.output.parent = self
                            self._children_name_map["output"] = "output"
                            self._children_yang_names.add("output")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("spi_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance, self).__setattr__(name, value)


                        class MemberInterfaces(Entity):
                            """
                            QoS policy\-map member interface table
                            
                            .. attribute:: member_interface
                            
                            	QoS policy\-map member interface statistics
                            	**type**\: list of    :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces, self).__init__()

                                self.yang_name = "member-interfaces"
                                self.yang_parent_name = "shared-policy-instance"

                                self.member_interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces, self).__setattr__(name, value)


                            class MemberInterface(Entity):
                                """
                                QoS policy\-map member interface statistics
                                
                                .. attribute:: interface_name  <key>
                                
                                	Name of member interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: input
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input>`
                                
                                .. attribute:: output
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output>`
                                
                                .. attribute:: satellite_ids
                                
                                	Satellite ID information
                                	**type**\:   :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface, self).__init__()

                                    self.yang_name = "member-interface"
                                    self.yang_parent_name = "member-interfaces"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.input = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input()
                                    self.input.parent = self
                                    self._children_name_map["input"] = "input"
                                    self._children_yang_names.add("input")

                                    self.output = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output()
                                    self.output.parent = self
                                    self._children_name_map["output"] = "output"
                                    self._children_yang_names.add("output")

                                    self.satellite_ids = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds()
                                    self.satellite_ids.parent = self
                                    self._children_name_map["satellite_ids"] = "satellite-ids"
                                    self._children_yang_names.add("satellite-ids")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface, self).__setattr__(name, value)


                                class SatelliteIds(Entity):
                                    """
                                    Satellite ID information
                                    
                                    .. attribute:: satellite_id
                                    
                                    	Satellite ID information
                                    	**type**\: list of    :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds, self).__init__()

                                        self.yang_name = "satellite-ids"
                                        self.yang_parent_name = "member-interface"

                                        self.satellite_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds, self).__setattr__(name, value)


                                    class SatelliteId(Entity):
                                        """
                                        Satellite ID information
                                        
                                        .. attribute:: nv_satellite_id  <key>
                                        
                                        	Satellite ID
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: input
                                        
                                        	A piece of QoS policy\-map operational data for an interface
                                        	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input>`
                                        
                                        .. attribute:: output
                                        
                                        	A piece of QoS policy\-map operational data for an interface
                                        	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__init__()

                                            self.yang_name = "satellite-id"
                                            self.yang_parent_name = "satellite-ids"

                                            self.nv_satellite_id = YLeaf(YType.int32, "nv-satellite-id")

                                            self.input = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                            self.input.parent = self
                                            self._children_name_map["input"] = "input"
                                            self._children_yang_names.add("input")

                                            self.output = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                            self.output.parent = self
                                            self._children_name_map["output"] = "output"
                                            self._children_yang_names.add("output")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("nv_satellite_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__setattr__(name, value)


                                        class Input(Entity):
                                            """
                                            A piece of QoS policy\-map operational data for
                                            an interface
                                            
                                            .. attribute:: service_policy_names
                                            
                                            	Operational data for all Policy instance
                                            	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                                            
                                            .. attribute:: statistics
                                            
                                            	Policy\-map statistics operational data for an interface
                                            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, self).__init__()

                                                self.yang_name = "input"
                                                self.yang_parent_name = "satellite-id"

                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                                self._children_yang_names.add("service-policy-names")

                                                self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                                self._children_yang_names.add("statistics")


                                            class ServicePolicyNames(Entity):
                                                """
                                                Operational data for all Policy instance
                                                
                                                .. attribute:: service_policy_instance
                                                
                                                	QoS policy\-map operational data for a particular Policy 
                                                	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                                    self.yang_name = "service-policy-names"
                                                    self.yang_parent_name = "input"

                                                    self.service_policy_instance = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)


                                                class ServicePolicyInstance(Entity):
                                                    """
                                                    QoS policy\-map operational data for a
                                                    particular Policy 
                                                    
                                                    .. attribute:: service_policy_name  <key>
                                                    
                                                    	Name of the policy instance
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                        self.yang_name = "service-policy-instance"
                                                        self.yang_parent_name = "service-policy-names"

                                                        self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("service_policy_name") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.service_policy_name.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.service_policy_name.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "service-policy-name"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "service-policy-name"):
                                                            self.service_policy_name = value
                                                            self.service_policy_name.value_namespace = name_space
                                                            self.service_policy_name.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.service_policy_instance:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.service_policy_instance:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "service-policy-names" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "service-policy-instance"):
                                                        for c in self.service_policy_instance:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.service_policy_instance.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "service-policy-instance"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class Statistics(Entity):
                                                """
                                                Policy\-map statistics operational data for an
                                                interface
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__init__()

                                                    self.yang_name = "statistics"
                                                    self.yang_parent_name = "input"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: child_policy
                                                    
                                                    	child policy
                                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "statistics"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                        self._children_yang_names.add("child-policy")

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class ChildPolicy(Entity):
                                                        """
                                                        child policy
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                            self.yang_name = "child-policy"
                                                            self.yang_parent_name = "class-stats"

                                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                                            self.satid = YLeaf(YType.uint32, "satid")

                                                            self.state = YLeaf(YType.enumeration, "state")

                                                            self.state_description = YLeaf(YType.str, "state-description")

                                                            self.class_stats = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("policy_name",
                                                                            "satid",
                                                                            "state",
                                                                            "state_description") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                        class ClassStats(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "child-policy"

                                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                                self._children_yang_names.add("cac-stats")

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                                self._children_yang_names.add("general-stats")

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                self._children_yang_names.add("iphc-stats")

                                                                self.police_stats_array = YList(self)
                                                                self.queue_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("cac_state",
                                                                                "class_name",
                                                                                "counter_validity_bitmask",
                                                                                "queue_descr",
                                                                                "shared_queue_id") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("match_data_rate",
                                                                                    "pre_policy_matched_bytes",
                                                                                    "pre_policy_matched_packets",
                                                                                    "total_drop_bytes",
                                                                                    "total_drop_packets",
                                                                                    "total_drop_rate",
                                                                                    "total_transmit_rate",
                                                                                    "transmit_bytes",
                                                                                    "transmit_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.match_data_rate.is_set or
                                                                        self.pre_policy_matched_bytes.is_set or
                                                                        self.pre_policy_matched_packets.is_set or
                                                                        self.total_drop_bytes.is_set or
                                                                        self.total_drop_packets.is_set or
                                                                        self.total_drop_rate.is_set or
                                                                        self.total_transmit_rate.is_set or
                                                                        self.transmit_bytes.is_set or
                                                                        self.transmit_packets.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "general-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "match-data-rate"):
                                                                        self.match_data_rate = value
                                                                        self.match_data_rate.value_namespace = name_space
                                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pre-policy-matched-bytes"):
                                                                        self.pre_policy_matched_bytes = value
                                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pre-policy-matched-packets"):
                                                                        self.pre_policy_matched_packets = value
                                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-drop-bytes"):
                                                                        self.total_drop_bytes = value
                                                                        self.total_drop_bytes.value_namespace = name_space
                                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-drop-packets"):
                                                                        self.total_drop_packets = value
                                                                        self.total_drop_packets.value_namespace = name_space
                                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-drop-rate"):
                                                                        self.total_drop_rate = value
                                                                        self.total_drop_rate.value_namespace = name_space
                                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-transmit-rate"):
                                                                        self.total_transmit_rate = value
                                                                        self.total_transmit_rate.value_namespace = name_space
                                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "transmit-bytes"):
                                                                        self.transmit_bytes = value
                                                                        self.transmit_bytes.value_namespace = name_space
                                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "transmit-packets"):
                                                                        self.transmit_packets = value
                                                                        self.transmit_packets.value_namespace = name_space
                                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("non_tcp_bytes_saved",
                                                                                    "non_tcp_bytes_sent_rate",
                                                                                    "non_tcp_compressed_packets_out",
                                                                                    "non_tcp_full_header_packets_out",
                                                                                    "non_tcp_total_out_bytes",
                                                                                    "non_tcp_total_out_packets",
                                                                                    "tcp_bytes_saved",
                                                                                    "tcp_bytes_sent_rate",
                                                                                    "tcp_compressed_packets_out",
                                                                                    "tcp_full_header_packets_out",
                                                                                    "tcp_total_out_bytes",
                                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.non_tcp_bytes_saved.is_set or
                                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                                        self.non_tcp_compressed_packets_out.is_set or
                                                                        self.non_tcp_full_header_packets_out.is_set or
                                                                        self.non_tcp_total_out_bytes.is_set or
                                                                        self.non_tcp_total_out_packets.is_set or
                                                                        self.tcp_bytes_saved.is_set or
                                                                        self.tcp_bytes_sent_rate.is_set or
                                                                        self.tcp_compressed_packets_out.is_set or
                                                                        self.tcp_full_header_packets_out.is_set or
                                                                        self.tcp_total_out_bytes.is_set or
                                                                        self.tcp_total_out_packets.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "iphc-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "non-tcp-bytes-saved"):
                                                                        self.non_tcp_bytes_saved = value
                                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                                        self.non_tcp_bytes_sent_rate = value
                                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                                        self.non_tcp_compressed_packets_out = value
                                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                                        self.non_tcp_full_header_packets_out = value
                                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                                        self.non_tcp_total_out_bytes = value
                                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-total-out-packets"):
                                                                        self.non_tcp_total_out_packets = value
                                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-bytes-saved"):
                                                                        self.tcp_bytes_saved = value
                                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                                        self.tcp_bytes_sent_rate = value
                                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-compressed-packets-out"):
                                                                        self.tcp_compressed_packets_out = value
                                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-full-header-packets-out"):
                                                                        self.tcp_full_header_packets_out = value
                                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-total-out-bytes"):
                                                                        self.tcp_total_out_bytes = value
                                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-total-out-packets"):
                                                                        self.tcp_total_out_packets = value
                                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("admit_bytes",
                                                                                    "admit_rates",
                                                                                    "admitpackets",
                                                                                    "drop_bytes",
                                                                                    "drop_packets",
                                                                                    "drop_rates") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.admit_bytes.is_set or
                                                                        self.admit_rates.is_set or
                                                                        self.admitpackets.is_set or
                                                                        self.drop_bytes.is_set or
                                                                        self.drop_packets.is_set or
                                                                        self.drop_rates.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "cac-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "admit-bytes"):
                                                                        self.admit_bytes = value
                                                                        self.admit_bytes.value_namespace = name_space
                                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "admit-rates"):
                                                                        self.admit_rates = value
                                                                        self.admit_rates.value_namespace = name_space
                                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "admitpackets"):
                                                                        self.admitpackets = value
                                                                        self.admitpackets.value_namespace = name_space
                                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-bytes"):
                                                                        self.drop_bytes = value
                                                                        self.drop_bytes.value_namespace = name_space
                                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-packets"):
                                                                        self.drop_packets = value
                                                                        self.drop_packets.value_namespace = name_space
                                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-rates"):
                                                                        self.drop_rates = value
                                                                        self.drop_rates.value_namespace = name_space
                                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\:  bool
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_max_length = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("atm_clp0_drop_bytes",
                                                                                    "atm_clp0_drop_packets",
                                                                                    "atm_clp1_drop_bytes",
                                                                                    "atm_clp1_drop_packets",
                                                                                    "conform_bytes",
                                                                                    "conform_packets",
                                                                                    "conform_rate",
                                                                                    "exceed_bytes",
                                                                                    "exceed_packets",
                                                                                    "exceed_rate",
                                                                                    "forced_wred_stats_display",
                                                                                    "max_threshold_bytes",
                                                                                    "max_threshold_packets",
                                                                                    "queue_drop_threshold",
                                                                                    "queue_id",
                                                                                    "random_drop_bytes",
                                                                                    "random_drop_packets",
                                                                                    "tail_drop_bytes",
                                                                                    "tail_drop_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("unit",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.unit.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.unit.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-instance-length" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "unit" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "unit"):
                                                                            self.unit = value
                                                                            self.unit.value_namespace = name_space
                                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("unit",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.unit.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.unit.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-average-length" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "unit" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "unit"):
                                                                            self.unit = value
                                                                            self.unit.value_namespace = name_space
                                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("unit",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.unit.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.unit.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-max-length" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "unit" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "unit"):
                                                                            self.unit = value
                                                                            self.unit.value_namespace = name_space
                                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.queue_average_length:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    for c in self.queue_instance_length:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    for c in self.queue_max_length:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return (
                                                                        self.atm_clp0_drop_bytes.is_set or
                                                                        self.atm_clp0_drop_packets.is_set or
                                                                        self.atm_clp1_drop_bytes.is_set or
                                                                        self.atm_clp1_drop_packets.is_set or
                                                                        self.conform_bytes.is_set or
                                                                        self.conform_packets.is_set or
                                                                        self.conform_rate.is_set or
                                                                        self.exceed_bytes.is_set or
                                                                        self.exceed_packets.is_set or
                                                                        self.exceed_rate.is_set or
                                                                        self.forced_wred_stats_display.is_set or
                                                                        self.max_threshold_bytes.is_set or
                                                                        self.max_threshold_packets.is_set or
                                                                        self.queue_drop_threshold.is_set or
                                                                        self.queue_id.is_set or
                                                                        self.random_drop_bytes.is_set or
                                                                        self.random_drop_packets.is_set or
                                                                        self.tail_drop_bytes.is_set or
                                                                        self.tail_drop_packets.is_set)

                                                                def has_operation(self):
                                                                    for c in self.queue_average_length:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    for c in self.queue_instance_length:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    for c in self.queue_max_length:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                        self.queue_id.yfilter != YFilter.not_set or
                                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-stats-array" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "queue-average-length"):
                                                                        for c in self.queue_average_length:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_average_length.append(c)
                                                                        return c

                                                                    if (child_yang_name == "queue-instance-length"):
                                                                        for c in self.queue_instance_length:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_instance_length.append(c)
                                                                        return c

                                                                    if (child_yang_name == "queue-max-length"):
                                                                        for c in self.queue_max_length:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_max_length.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                                        self.atm_clp0_drop_bytes = value
                                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "atm-clp0-drop-packets"):
                                                                        self.atm_clp0_drop_packets = value
                                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                                        self.atm_clp1_drop_bytes = value
                                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "atm-clp1-drop-packets"):
                                                                        self.atm_clp1_drop_packets = value
                                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-bytes"):
                                                                        self.conform_bytes = value
                                                                        self.conform_bytes.value_namespace = name_space
                                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-packets"):
                                                                        self.conform_packets = value
                                                                        self.conform_packets.value_namespace = name_space
                                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-rate"):
                                                                        self.conform_rate = value
                                                                        self.conform_rate.value_namespace = name_space
                                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-bytes"):
                                                                        self.exceed_bytes = value
                                                                        self.exceed_bytes.value_namespace = name_space
                                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-packets"):
                                                                        self.exceed_packets = value
                                                                        self.exceed_packets.value_namespace = name_space
                                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-rate"):
                                                                        self.exceed_rate = value
                                                                        self.exceed_rate.value_namespace = name_space
                                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "forced-wred-stats-display"):
                                                                        self.forced_wred_stats_display = value
                                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "max-threshold-bytes"):
                                                                        self.max_threshold_bytes = value
                                                                        self.max_threshold_bytes.value_namespace = name_space
                                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "max-threshold-packets"):
                                                                        self.max_threshold_packets = value
                                                                        self.max_threshold_packets.value_namespace = name_space
                                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "queue-drop-threshold"):
                                                                        self.queue_drop_threshold = value
                                                                        self.queue_drop_threshold.value_namespace = name_space
                                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "queue-id"):
                                                                        self.queue_id = value
                                                                        self.queue_id.value_namespace = name_space
                                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-bytes"):
                                                                        self.random_drop_bytes = value
                                                                        self.random_drop_bytes.value_namespace = name_space
                                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-packets"):
                                                                        self.random_drop_packets = value
                                                                        self.random_drop_packets.value_namespace = name_space
                                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tail-drop-bytes"):
                                                                        self.tail_drop_bytes = value
                                                                        self.tail_drop_bytes.value_namespace = name_space
                                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tail-drop-packets"):
                                                                        self.tail_drop_packets = value
                                                                        self.tail_drop_packets.value_namespace = name_space
                                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._children_yang_names.add("color-class-stats")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("conform_bytes",
                                                                                    "conform_packets",
                                                                                    "conform_rate",
                                                                                    "drop_bytes",
                                                                                    "drop_packets",
                                                                                    "exceed_bytes",
                                                                                    "exceed_packets",
                                                                                    "exceed_rate",
                                                                                    "parent_drop_bytes",
                                                                                    "parent_drop_packets",
                                                                                    "violate_bytes",
                                                                                    "violate_packets",
                                                                                    "violate_rate") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"

                                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("conform_class_conform_bytes",
                                                                                        "conform_class_conform_packets",
                                                                                        "conform_class_conform_rate",
                                                                                        "conform_class_exceed_bytes",
                                                                                        "conform_class_exceed_packets",
                                                                                        "conform_class_exceed_rate",
                                                                                        "conform_class_violate_bytes",
                                                                                        "conform_class_violate_packets",
                                                                                        "conform_class_violate_rate",
                                                                                        "exceed_class_exceed_bytes",
                                                                                        "exceed_class_exceed_packets",
                                                                                        "exceed_class_exceed_rate",
                                                                                        "exceed_class_violate_bytes",
                                                                                        "exceed_class_violate_packets",
                                                                                        "exceed_class_violate_rate",
                                                                                        "violate_class_violate_bytes",
                                                                                        "violate_class_violate_packets",
                                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.conform_class_conform_bytes.is_set or
                                                                            self.conform_class_conform_packets.is_set or
                                                                            self.conform_class_conform_rate.is_set or
                                                                            self.conform_class_exceed_bytes.is_set or
                                                                            self.conform_class_exceed_packets.is_set or
                                                                            self.conform_class_exceed_rate.is_set or
                                                                            self.conform_class_violate_bytes.is_set or
                                                                            self.conform_class_violate_packets.is_set or
                                                                            self.conform_class_violate_rate.is_set or
                                                                            self.exceed_class_exceed_bytes.is_set or
                                                                            self.exceed_class_exceed_packets.is_set or
                                                                            self.exceed_class_exceed_rate.is_set or
                                                                            self.exceed_class_violate_bytes.is_set or
                                                                            self.exceed_class_violate_packets.is_set or
                                                                            self.exceed_class_violate_rate.is_set or
                                                                            self.violate_class_violate_bytes.is_set or
                                                                            self.violate_class_violate_packets.is_set or
                                                                            self.violate_class_violate_rate.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "color-class-stats" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "conform-class-conform-bytes"):
                                                                            self.conform_class_conform_bytes = value
                                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-conform-packets"):
                                                                            self.conform_class_conform_packets = value
                                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-conform-rate"):
                                                                            self.conform_class_conform_rate = value
                                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-exceed-bytes"):
                                                                            self.conform_class_exceed_bytes = value
                                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-exceed-packets"):
                                                                            self.conform_class_exceed_packets = value
                                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-exceed-rate"):
                                                                            self.conform_class_exceed_rate = value
                                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-violate-bytes"):
                                                                            self.conform_class_violate_bytes = value
                                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-violate-packets"):
                                                                            self.conform_class_violate_packets = value
                                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-violate-rate"):
                                                                            self.conform_class_violate_rate = value
                                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                                            self.exceed_class_exceed_bytes = value
                                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-exceed-packets"):
                                                                            self.exceed_class_exceed_packets = value
                                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-exceed-rate"):
                                                                            self.exceed_class_exceed_rate = value
                                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-violate-bytes"):
                                                                            self.exceed_class_violate_bytes = value
                                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-violate-packets"):
                                                                            self.exceed_class_violate_packets = value
                                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-violate-rate"):
                                                                            self.exceed_class_violate_rate = value
                                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-class-violate-bytes"):
                                                                            self.violate_class_violate_bytes = value
                                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-class-violate-packets"):
                                                                            self.violate_class_violate_packets = value
                                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-class-violate-rate"):
                                                                            self.violate_class_violate_rate = value
                                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (
                                                                        self.conform_bytes.is_set or
                                                                        self.conform_packets.is_set or
                                                                        self.conform_rate.is_set or
                                                                        self.drop_bytes.is_set or
                                                                        self.drop_packets.is_set or
                                                                        self.exceed_bytes.is_set or
                                                                        self.exceed_packets.is_set or
                                                                        self.exceed_rate.is_set or
                                                                        self.parent_drop_bytes.is_set or
                                                                        self.parent_drop_packets.is_set or
                                                                        self.violate_bytes.is_set or
                                                                        self.violate_packets.is_set or
                                                                        self.violate_rate.is_set or
                                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "police-stats-array" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "color-class-stats"):
                                                                        if (self.color_class_stats is None):
                                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                            self.color_class_stats.parent = self
                                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                        return self.color_class_stats

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "conform-bytes"):
                                                                        self.conform_bytes = value
                                                                        self.conform_bytes.value_namespace = name_space
                                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-packets"):
                                                                        self.conform_packets = value
                                                                        self.conform_packets.value_namespace = name_space
                                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-rate"):
                                                                        self.conform_rate = value
                                                                        self.conform_rate.value_namespace = name_space
                                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-bytes"):
                                                                        self.drop_bytes = value
                                                                        self.drop_bytes.value_namespace = name_space
                                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-packets"):
                                                                        self.drop_packets = value
                                                                        self.drop_packets.value_namespace = name_space
                                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-bytes"):
                                                                        self.exceed_bytes = value
                                                                        self.exceed_bytes.value_namespace = name_space
                                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-packets"):
                                                                        self.exceed_packets = value
                                                                        self.exceed_packets.value_namespace = name_space
                                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-rate"):
                                                                        self.exceed_rate = value
                                                                        self.exceed_rate.value_namespace = name_space
                                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "parent-drop-bytes"):
                                                                        self.parent_drop_bytes = value
                                                                        self.parent_drop_bytes.value_namespace = name_space
                                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "parent-drop-packets"):
                                                                        self.parent_drop_packets = value
                                                                        self.parent_drop_packets.value_namespace = name_space
                                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-bytes"):
                                                                        self.violate_bytes = value
                                                                        self.violate_bytes.value_namespace = name_space
                                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-packets"):
                                                                        self.violate_packets = value
                                                                        self.violate_packets.value_namespace = name_space
                                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-rate"):
                                                                        self.violate_rate = value
                                                                        self.violate_rate.value_namespace = name_space
                                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                                    self.red_label = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("max_threshold_bytes",
                                                                                    "max_threshold_packets",
                                                                                    "profile_title",
                                                                                    "random_drop_bytes",
                                                                                    "random_drop_packets",
                                                                                    "red_ecn_marked_bytes",
                                                                                    "red_ecn_marked_packets",
                                                                                    "red_transmit_bytes",
                                                                                    "red_transmit_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"

                                                                        self.value = YLeaf(YType.uint8, "value")

                                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("value",
                                                                                        "wred_type") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.value.is_set or
                                                                            self.wred_type.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set or
                                                                            self.wred_type.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "red-label" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "value" or name == "wred-type"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "wred-type"):
                                                                            self.wred_type = value
                                                                            self.wred_type.value_namespace = name_space
                                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.red_label:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return (
                                                                        self.max_threshold_bytes.is_set or
                                                                        self.max_threshold_packets.is_set or
                                                                        self.profile_title.is_set or
                                                                        self.random_drop_bytes.is_set or
                                                                        self.random_drop_packets.is_set or
                                                                        self.red_ecn_marked_bytes.is_set or
                                                                        self.red_ecn_marked_packets.is_set or
                                                                        self.red_transmit_bytes.is_set or
                                                                        self.red_transmit_packets.is_set)

                                                                def has_operation(self):
                                                                    for c in self.red_label:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                        self.profile_title.yfilter != YFilter.not_set or
                                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "wred-stats-array" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "red-label"):
                                                                        for c in self.red_label:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.red_label.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "max-threshold-bytes"):
                                                                        self.max_threshold_bytes = value
                                                                        self.max_threshold_bytes.value_namespace = name_space
                                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "max-threshold-packets"):
                                                                        self.max_threshold_packets = value
                                                                        self.max_threshold_packets.value_namespace = name_space
                                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "profile-title"):
                                                                        self.profile_title = value
                                                                        self.profile_title.value_namespace = name_space
                                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-bytes"):
                                                                        self.random_drop_bytes = value
                                                                        self.random_drop_bytes.value_namespace = name_space
                                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-packets"):
                                                                        self.random_drop_packets = value
                                                                        self.random_drop_packets.value_namespace = name_space
                                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-ecn-marked-bytes"):
                                                                        self.red_ecn_marked_bytes = value
                                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-ecn-marked-packets"):
                                                                        self.red_ecn_marked_packets = value
                                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-transmit-bytes"):
                                                                        self.red_transmit_bytes = value
                                                                        self.red_transmit_bytes.value_namespace = name_space
                                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-transmit-packets"):
                                                                        self.red_transmit_packets = value
                                                                        self.red_transmit_packets.value_namespace = name_space
                                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.police_stats_array:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.queue_stats_array:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.wred_stats_array:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.cac_state.is_set or
                                                                    self.class_name.is_set or
                                                                    self.counter_validity_bitmask.is_set or
                                                                    self.queue_descr.is_set or
                                                                    self.shared_queue_id.is_set or
                                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                            def has_operation(self):
                                                                for c in self.police_stats_array:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.queue_stats_array:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.wred_stats_array:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.cac_state.yfilter != YFilter.not_set or
                                                                    self.class_name.yfilter != YFilter.not_set or
                                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "cac-stats"):
                                                                    if (self.cac_stats is None):
                                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                        self.cac_stats.parent = self
                                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                                    return self.cac_stats

                                                                if (child_yang_name == "general-stats"):
                                                                    if (self.general_stats is None):
                                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                        self.general_stats.parent = self
                                                                        self._children_name_map["general_stats"] = "general-stats"
                                                                    return self.general_stats

                                                                if (child_yang_name == "iphc-stats"):
                                                                    if (self.iphc_stats is None):
                                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                        self.iphc_stats.parent = self
                                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                    return self.iphc_stats

                                                                if (child_yang_name == "police-stats-array"):
                                                                    for c in self.police_stats_array:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.police_stats_array.append(c)
                                                                    return c

                                                                if (child_yang_name == "queue-stats-array"):
                                                                    for c in self.queue_stats_array:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_stats_array.append(c)
                                                                    return c

                                                                if (child_yang_name == "wred-stats-array"):
                                                                    for c in self.wred_stats_array:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.wred_stats_array.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "cac-state"):
                                                                    self.cac_state = value
                                                                    self.cac_state.value_namespace = name_space
                                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "class-name"):
                                                                    self.class_name = value
                                                                    self.class_name.value_namespace = name_space
                                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "counter-validity-bitmask"):
                                                                    self.counter_validity_bitmask = value
                                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "queue-descr"):
                                                                    self.queue_descr = value
                                                                    self.queue_descr.value_namespace = name_space
                                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "shared-queue-id"):
                                                                    self.shared_queue_id = value
                                                                    self.shared_queue_id.value_namespace = name_space
                                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.class_stats:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.policy_name.is_set or
                                                                self.satid.is_set or
                                                                self.state.is_set or
                                                                self.state_description.is_set)

                                                        def has_operation(self):
                                                            for c in self.class_stats:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.policy_name.yfilter != YFilter.not_set or
                                                                self.satid.yfilter != YFilter.not_set or
                                                                self.state.yfilter != YFilter.not_set or
                                                                self.state_description.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "child-policy" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.state.get_name_leafdata())
                                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "class-stats"):
                                                                for c in self.class_stats:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.class_stats.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "policy-name"):
                                                                self.policy_name = value
                                                                self.policy_name.value_namespace = name_space
                                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "satid"):
                                                                self.satid = value
                                                                self.satid.value_namespace = name_space
                                                                self.satid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "state"):
                                                                self.state = value
                                                                self.state.value_namespace = name_space
                                                                self.state.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "state-description"):
                                                                self.state_description = value
                                                                self.state_description.value_namespace = name_space
                                                                self.state_description.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.child_policy is not None and self.child_policy.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.child_policy is not None and self.child_policy.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "child-policy"):
                                                            if (self.child_policy is None):
                                                                self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                                                self.child_policy.parent = self
                                                                self._children_name_map["child_policy"] = "child-policy"
                                                            return self.child_policy

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "statistics" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                                    (self.statistics is not None and self.statistics.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                                    (self.statistics is not None and self.statistics.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "input" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "service-policy-names"):
                                                    if (self.service_policy_names is None):
                                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                                        self.service_policy_names.parent = self
                                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                                    return self.service_policy_names

                                                if (child_yang_name == "statistics"):
                                                    if (self.statistics is None):
                                                        self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics()
                                                        self.statistics.parent = self
                                                        self._children_name_map["statistics"] = "statistics"
                                                    return self.statistics

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-names" or name == "statistics"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class Output(Entity):
                                            """
                                            A piece of QoS policy\-map operational data for
                                            an interface
                                            
                                            .. attribute:: service_policy_names
                                            
                                            	Operational data for all Policy instance
                                            	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                                            
                                            .. attribute:: statistics
                                            
                                            	Policy\-map statistics operational data for an interface
                                            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, self).__init__()

                                                self.yang_name = "output"
                                                self.yang_parent_name = "satellite-id"

                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                                self._children_yang_names.add("service-policy-names")

                                                self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                                self._children_yang_names.add("statistics")


                                            class ServicePolicyNames(Entity):
                                                """
                                                Operational data for all Policy instance
                                                
                                                .. attribute:: service_policy_instance
                                                
                                                	QoS policy\-map operational data for a particular Policy 
                                                	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                                    self.yang_name = "service-policy-names"
                                                    self.yang_parent_name = "output"

                                                    self.service_policy_instance = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)


                                                class ServicePolicyInstance(Entity):
                                                    """
                                                    QoS policy\-map operational data for a
                                                    particular Policy 
                                                    
                                                    .. attribute:: service_policy_name  <key>
                                                    
                                                    	Name of the policy instance
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                        self.yang_name = "service-policy-instance"
                                                        self.yang_parent_name = "service-policy-names"

                                                        self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("service_policy_name") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.service_policy_name.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.service_policy_name.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "service-policy-name"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "service-policy-name"):
                                                            self.service_policy_name = value
                                                            self.service_policy_name.value_namespace = name_space
                                                            self.service_policy_name.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.service_policy_instance:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.service_policy_instance:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "service-policy-names" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "service-policy-instance"):
                                                        for c in self.service_policy_instance:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.service_policy_instance.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "service-policy-instance"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class Statistics(Entity):
                                                """
                                                Policy\-map statistics operational data for an
                                                interface
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__init__()

                                                    self.yang_name = "statistics"
                                                    self.yang_parent_name = "output"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: child_policy
                                                    
                                                    	child policy
                                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "statistics"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                        self._children_yang_names.add("child-policy")

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class ChildPolicy(Entity):
                                                        """
                                                        child policy
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                            self.yang_name = "child-policy"
                                                            self.yang_parent_name = "class-stats"

                                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                                            self.satid = YLeaf(YType.uint32, "satid")

                                                            self.state = YLeaf(YType.enumeration, "state")

                                                            self.state_description = YLeaf(YType.str, "state-description")

                                                            self.class_stats = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("policy_name",
                                                                            "satid",
                                                                            "state",
                                                                            "state_description") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                        class ClassStats(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "child-policy"

                                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                                self._children_yang_names.add("cac-stats")

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                                self._children_yang_names.add("general-stats")

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                self._children_yang_names.add("iphc-stats")

                                                                self.police_stats_array = YList(self)
                                                                self.queue_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("cac_state",
                                                                                "class_name",
                                                                                "counter_validity_bitmask",
                                                                                "queue_descr",
                                                                                "shared_queue_id") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("match_data_rate",
                                                                                    "pre_policy_matched_bytes",
                                                                                    "pre_policy_matched_packets",
                                                                                    "total_drop_bytes",
                                                                                    "total_drop_packets",
                                                                                    "total_drop_rate",
                                                                                    "total_transmit_rate",
                                                                                    "transmit_bytes",
                                                                                    "transmit_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.match_data_rate.is_set or
                                                                        self.pre_policy_matched_bytes.is_set or
                                                                        self.pre_policy_matched_packets.is_set or
                                                                        self.total_drop_bytes.is_set or
                                                                        self.total_drop_packets.is_set or
                                                                        self.total_drop_rate.is_set or
                                                                        self.total_transmit_rate.is_set or
                                                                        self.transmit_bytes.is_set or
                                                                        self.transmit_packets.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "general-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "match-data-rate"):
                                                                        self.match_data_rate = value
                                                                        self.match_data_rate.value_namespace = name_space
                                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pre-policy-matched-bytes"):
                                                                        self.pre_policy_matched_bytes = value
                                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pre-policy-matched-packets"):
                                                                        self.pre_policy_matched_packets = value
                                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-drop-bytes"):
                                                                        self.total_drop_bytes = value
                                                                        self.total_drop_bytes.value_namespace = name_space
                                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-drop-packets"):
                                                                        self.total_drop_packets = value
                                                                        self.total_drop_packets.value_namespace = name_space
                                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-drop-rate"):
                                                                        self.total_drop_rate = value
                                                                        self.total_drop_rate.value_namespace = name_space
                                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-transmit-rate"):
                                                                        self.total_transmit_rate = value
                                                                        self.total_transmit_rate.value_namespace = name_space
                                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "transmit-bytes"):
                                                                        self.transmit_bytes = value
                                                                        self.transmit_bytes.value_namespace = name_space
                                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "transmit-packets"):
                                                                        self.transmit_packets = value
                                                                        self.transmit_packets.value_namespace = name_space
                                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("non_tcp_bytes_saved",
                                                                                    "non_tcp_bytes_sent_rate",
                                                                                    "non_tcp_compressed_packets_out",
                                                                                    "non_tcp_full_header_packets_out",
                                                                                    "non_tcp_total_out_bytes",
                                                                                    "non_tcp_total_out_packets",
                                                                                    "tcp_bytes_saved",
                                                                                    "tcp_bytes_sent_rate",
                                                                                    "tcp_compressed_packets_out",
                                                                                    "tcp_full_header_packets_out",
                                                                                    "tcp_total_out_bytes",
                                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.non_tcp_bytes_saved.is_set or
                                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                                        self.non_tcp_compressed_packets_out.is_set or
                                                                        self.non_tcp_full_header_packets_out.is_set or
                                                                        self.non_tcp_total_out_bytes.is_set or
                                                                        self.non_tcp_total_out_packets.is_set or
                                                                        self.tcp_bytes_saved.is_set or
                                                                        self.tcp_bytes_sent_rate.is_set or
                                                                        self.tcp_compressed_packets_out.is_set or
                                                                        self.tcp_full_header_packets_out.is_set or
                                                                        self.tcp_total_out_bytes.is_set or
                                                                        self.tcp_total_out_packets.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "iphc-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "non-tcp-bytes-saved"):
                                                                        self.non_tcp_bytes_saved = value
                                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                                        self.non_tcp_bytes_sent_rate = value
                                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                                        self.non_tcp_compressed_packets_out = value
                                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                                        self.non_tcp_full_header_packets_out = value
                                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                                        self.non_tcp_total_out_bytes = value
                                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-total-out-packets"):
                                                                        self.non_tcp_total_out_packets = value
                                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-bytes-saved"):
                                                                        self.tcp_bytes_saved = value
                                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                                        self.tcp_bytes_sent_rate = value
                                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-compressed-packets-out"):
                                                                        self.tcp_compressed_packets_out = value
                                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-full-header-packets-out"):
                                                                        self.tcp_full_header_packets_out = value
                                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-total-out-bytes"):
                                                                        self.tcp_total_out_bytes = value
                                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-total-out-packets"):
                                                                        self.tcp_total_out_packets = value
                                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("admit_bytes",
                                                                                    "admit_rates",
                                                                                    "admitpackets",
                                                                                    "drop_bytes",
                                                                                    "drop_packets",
                                                                                    "drop_rates") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.admit_bytes.is_set or
                                                                        self.admit_rates.is_set or
                                                                        self.admitpackets.is_set or
                                                                        self.drop_bytes.is_set or
                                                                        self.drop_packets.is_set or
                                                                        self.drop_rates.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "cac-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "admit-bytes"):
                                                                        self.admit_bytes = value
                                                                        self.admit_bytes.value_namespace = name_space
                                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "admit-rates"):
                                                                        self.admit_rates = value
                                                                        self.admit_rates.value_namespace = name_space
                                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "admitpackets"):
                                                                        self.admitpackets = value
                                                                        self.admitpackets.value_namespace = name_space
                                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-bytes"):
                                                                        self.drop_bytes = value
                                                                        self.drop_bytes.value_namespace = name_space
                                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-packets"):
                                                                        self.drop_packets = value
                                                                        self.drop_packets.value_namespace = name_space
                                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-rates"):
                                                                        self.drop_rates = value
                                                                        self.drop_rates.value_namespace = name_space
                                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\:  bool
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_max_length = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("atm_clp0_drop_bytes",
                                                                                    "atm_clp0_drop_packets",
                                                                                    "atm_clp1_drop_bytes",
                                                                                    "atm_clp1_drop_packets",
                                                                                    "conform_bytes",
                                                                                    "conform_packets",
                                                                                    "conform_rate",
                                                                                    "exceed_bytes",
                                                                                    "exceed_packets",
                                                                                    "exceed_rate",
                                                                                    "forced_wred_stats_display",
                                                                                    "max_threshold_bytes",
                                                                                    "max_threshold_packets",
                                                                                    "queue_drop_threshold",
                                                                                    "queue_id",
                                                                                    "random_drop_bytes",
                                                                                    "random_drop_packets",
                                                                                    "tail_drop_bytes",
                                                                                    "tail_drop_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("unit",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.unit.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.unit.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-instance-length" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "unit" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "unit"):
                                                                            self.unit = value
                                                                            self.unit.value_namespace = name_space
                                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("unit",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.unit.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.unit.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-average-length" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "unit" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "unit"):
                                                                            self.unit = value
                                                                            self.unit.value_namespace = name_space
                                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("unit",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.unit.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.unit.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-max-length" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "unit" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "unit"):
                                                                            self.unit = value
                                                                            self.unit.value_namespace = name_space
                                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.queue_average_length:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    for c in self.queue_instance_length:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    for c in self.queue_max_length:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return (
                                                                        self.atm_clp0_drop_bytes.is_set or
                                                                        self.atm_clp0_drop_packets.is_set or
                                                                        self.atm_clp1_drop_bytes.is_set or
                                                                        self.atm_clp1_drop_packets.is_set or
                                                                        self.conform_bytes.is_set or
                                                                        self.conform_packets.is_set or
                                                                        self.conform_rate.is_set or
                                                                        self.exceed_bytes.is_set or
                                                                        self.exceed_packets.is_set or
                                                                        self.exceed_rate.is_set or
                                                                        self.forced_wred_stats_display.is_set or
                                                                        self.max_threshold_bytes.is_set or
                                                                        self.max_threshold_packets.is_set or
                                                                        self.queue_drop_threshold.is_set or
                                                                        self.queue_id.is_set or
                                                                        self.random_drop_bytes.is_set or
                                                                        self.random_drop_packets.is_set or
                                                                        self.tail_drop_bytes.is_set or
                                                                        self.tail_drop_packets.is_set)

                                                                def has_operation(self):
                                                                    for c in self.queue_average_length:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    for c in self.queue_instance_length:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    for c in self.queue_max_length:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                        self.queue_id.yfilter != YFilter.not_set or
                                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-stats-array" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "queue-average-length"):
                                                                        for c in self.queue_average_length:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_average_length.append(c)
                                                                        return c

                                                                    if (child_yang_name == "queue-instance-length"):
                                                                        for c in self.queue_instance_length:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_instance_length.append(c)
                                                                        return c

                                                                    if (child_yang_name == "queue-max-length"):
                                                                        for c in self.queue_max_length:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_max_length.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                                        self.atm_clp0_drop_bytes = value
                                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "atm-clp0-drop-packets"):
                                                                        self.atm_clp0_drop_packets = value
                                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                                        self.atm_clp1_drop_bytes = value
                                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "atm-clp1-drop-packets"):
                                                                        self.atm_clp1_drop_packets = value
                                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-bytes"):
                                                                        self.conform_bytes = value
                                                                        self.conform_bytes.value_namespace = name_space
                                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-packets"):
                                                                        self.conform_packets = value
                                                                        self.conform_packets.value_namespace = name_space
                                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-rate"):
                                                                        self.conform_rate = value
                                                                        self.conform_rate.value_namespace = name_space
                                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-bytes"):
                                                                        self.exceed_bytes = value
                                                                        self.exceed_bytes.value_namespace = name_space
                                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-packets"):
                                                                        self.exceed_packets = value
                                                                        self.exceed_packets.value_namespace = name_space
                                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-rate"):
                                                                        self.exceed_rate = value
                                                                        self.exceed_rate.value_namespace = name_space
                                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "forced-wred-stats-display"):
                                                                        self.forced_wred_stats_display = value
                                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "max-threshold-bytes"):
                                                                        self.max_threshold_bytes = value
                                                                        self.max_threshold_bytes.value_namespace = name_space
                                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "max-threshold-packets"):
                                                                        self.max_threshold_packets = value
                                                                        self.max_threshold_packets.value_namespace = name_space
                                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "queue-drop-threshold"):
                                                                        self.queue_drop_threshold = value
                                                                        self.queue_drop_threshold.value_namespace = name_space
                                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "queue-id"):
                                                                        self.queue_id = value
                                                                        self.queue_id.value_namespace = name_space
                                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-bytes"):
                                                                        self.random_drop_bytes = value
                                                                        self.random_drop_bytes.value_namespace = name_space
                                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-packets"):
                                                                        self.random_drop_packets = value
                                                                        self.random_drop_packets.value_namespace = name_space
                                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tail-drop-bytes"):
                                                                        self.tail_drop_bytes = value
                                                                        self.tail_drop_bytes.value_namespace = name_space
                                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tail-drop-packets"):
                                                                        self.tail_drop_packets = value
                                                                        self.tail_drop_packets.value_namespace = name_space
                                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._children_yang_names.add("color-class-stats")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("conform_bytes",
                                                                                    "conform_packets",
                                                                                    "conform_rate",
                                                                                    "drop_bytes",
                                                                                    "drop_packets",
                                                                                    "exceed_bytes",
                                                                                    "exceed_packets",
                                                                                    "exceed_rate",
                                                                                    "parent_drop_bytes",
                                                                                    "parent_drop_packets",
                                                                                    "violate_bytes",
                                                                                    "violate_packets",
                                                                                    "violate_rate") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"

                                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("conform_class_conform_bytes",
                                                                                        "conform_class_conform_packets",
                                                                                        "conform_class_conform_rate",
                                                                                        "conform_class_exceed_bytes",
                                                                                        "conform_class_exceed_packets",
                                                                                        "conform_class_exceed_rate",
                                                                                        "conform_class_violate_bytes",
                                                                                        "conform_class_violate_packets",
                                                                                        "conform_class_violate_rate",
                                                                                        "exceed_class_exceed_bytes",
                                                                                        "exceed_class_exceed_packets",
                                                                                        "exceed_class_exceed_rate",
                                                                                        "exceed_class_violate_bytes",
                                                                                        "exceed_class_violate_packets",
                                                                                        "exceed_class_violate_rate",
                                                                                        "violate_class_violate_bytes",
                                                                                        "violate_class_violate_packets",
                                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.conform_class_conform_bytes.is_set or
                                                                            self.conform_class_conform_packets.is_set or
                                                                            self.conform_class_conform_rate.is_set or
                                                                            self.conform_class_exceed_bytes.is_set or
                                                                            self.conform_class_exceed_packets.is_set or
                                                                            self.conform_class_exceed_rate.is_set or
                                                                            self.conform_class_violate_bytes.is_set or
                                                                            self.conform_class_violate_packets.is_set or
                                                                            self.conform_class_violate_rate.is_set or
                                                                            self.exceed_class_exceed_bytes.is_set or
                                                                            self.exceed_class_exceed_packets.is_set or
                                                                            self.exceed_class_exceed_rate.is_set or
                                                                            self.exceed_class_violate_bytes.is_set or
                                                                            self.exceed_class_violate_packets.is_set or
                                                                            self.exceed_class_violate_rate.is_set or
                                                                            self.violate_class_violate_bytes.is_set or
                                                                            self.violate_class_violate_packets.is_set or
                                                                            self.violate_class_violate_rate.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "color-class-stats" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "conform-class-conform-bytes"):
                                                                            self.conform_class_conform_bytes = value
                                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-conform-packets"):
                                                                            self.conform_class_conform_packets = value
                                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-conform-rate"):
                                                                            self.conform_class_conform_rate = value
                                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-exceed-bytes"):
                                                                            self.conform_class_exceed_bytes = value
                                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-exceed-packets"):
                                                                            self.conform_class_exceed_packets = value
                                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-exceed-rate"):
                                                                            self.conform_class_exceed_rate = value
                                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-violate-bytes"):
                                                                            self.conform_class_violate_bytes = value
                                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-violate-packets"):
                                                                            self.conform_class_violate_packets = value
                                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-violate-rate"):
                                                                            self.conform_class_violate_rate = value
                                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                                            self.exceed_class_exceed_bytes = value
                                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-exceed-packets"):
                                                                            self.exceed_class_exceed_packets = value
                                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-exceed-rate"):
                                                                            self.exceed_class_exceed_rate = value
                                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-violate-bytes"):
                                                                            self.exceed_class_violate_bytes = value
                                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-violate-packets"):
                                                                            self.exceed_class_violate_packets = value
                                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-violate-rate"):
                                                                            self.exceed_class_violate_rate = value
                                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-class-violate-bytes"):
                                                                            self.violate_class_violate_bytes = value
                                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-class-violate-packets"):
                                                                            self.violate_class_violate_packets = value
                                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-class-violate-rate"):
                                                                            self.violate_class_violate_rate = value
                                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (
                                                                        self.conform_bytes.is_set or
                                                                        self.conform_packets.is_set or
                                                                        self.conform_rate.is_set or
                                                                        self.drop_bytes.is_set or
                                                                        self.drop_packets.is_set or
                                                                        self.exceed_bytes.is_set or
                                                                        self.exceed_packets.is_set or
                                                                        self.exceed_rate.is_set or
                                                                        self.parent_drop_bytes.is_set or
                                                                        self.parent_drop_packets.is_set or
                                                                        self.violate_bytes.is_set or
                                                                        self.violate_packets.is_set or
                                                                        self.violate_rate.is_set or
                                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "police-stats-array" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "color-class-stats"):
                                                                        if (self.color_class_stats is None):
                                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                            self.color_class_stats.parent = self
                                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                        return self.color_class_stats

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "conform-bytes"):
                                                                        self.conform_bytes = value
                                                                        self.conform_bytes.value_namespace = name_space
                                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-packets"):
                                                                        self.conform_packets = value
                                                                        self.conform_packets.value_namespace = name_space
                                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-rate"):
                                                                        self.conform_rate = value
                                                                        self.conform_rate.value_namespace = name_space
                                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-bytes"):
                                                                        self.drop_bytes = value
                                                                        self.drop_bytes.value_namespace = name_space
                                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-packets"):
                                                                        self.drop_packets = value
                                                                        self.drop_packets.value_namespace = name_space
                                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-bytes"):
                                                                        self.exceed_bytes = value
                                                                        self.exceed_bytes.value_namespace = name_space
                                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-packets"):
                                                                        self.exceed_packets = value
                                                                        self.exceed_packets.value_namespace = name_space
                                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-rate"):
                                                                        self.exceed_rate = value
                                                                        self.exceed_rate.value_namespace = name_space
                                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "parent-drop-bytes"):
                                                                        self.parent_drop_bytes = value
                                                                        self.parent_drop_bytes.value_namespace = name_space
                                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "parent-drop-packets"):
                                                                        self.parent_drop_packets = value
                                                                        self.parent_drop_packets.value_namespace = name_space
                                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-bytes"):
                                                                        self.violate_bytes = value
                                                                        self.violate_bytes.value_namespace = name_space
                                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-packets"):
                                                                        self.violate_packets = value
                                                                        self.violate_packets.value_namespace = name_space
                                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-rate"):
                                                                        self.violate_rate = value
                                                                        self.violate_rate.value_namespace = name_space
                                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                                    self.red_label = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("max_threshold_bytes",
                                                                                    "max_threshold_packets",
                                                                                    "profile_title",
                                                                                    "random_drop_bytes",
                                                                                    "random_drop_packets",
                                                                                    "red_ecn_marked_bytes",
                                                                                    "red_ecn_marked_packets",
                                                                                    "red_transmit_bytes",
                                                                                    "red_transmit_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"

                                                                        self.value = YLeaf(YType.uint8, "value")

                                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("value",
                                                                                        "wred_type") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.value.is_set or
                                                                            self.wred_type.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set or
                                                                            self.wred_type.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "red-label" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "value" or name == "wred-type"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "wred-type"):
                                                                            self.wred_type = value
                                                                            self.wred_type.value_namespace = name_space
                                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.red_label:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return (
                                                                        self.max_threshold_bytes.is_set or
                                                                        self.max_threshold_packets.is_set or
                                                                        self.profile_title.is_set or
                                                                        self.random_drop_bytes.is_set or
                                                                        self.random_drop_packets.is_set or
                                                                        self.red_ecn_marked_bytes.is_set or
                                                                        self.red_ecn_marked_packets.is_set or
                                                                        self.red_transmit_bytes.is_set or
                                                                        self.red_transmit_packets.is_set)

                                                                def has_operation(self):
                                                                    for c in self.red_label:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                        self.profile_title.yfilter != YFilter.not_set or
                                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "wred-stats-array" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "red-label"):
                                                                        for c in self.red_label:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.red_label.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "max-threshold-bytes"):
                                                                        self.max_threshold_bytes = value
                                                                        self.max_threshold_bytes.value_namespace = name_space
                                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "max-threshold-packets"):
                                                                        self.max_threshold_packets = value
                                                                        self.max_threshold_packets.value_namespace = name_space
                                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "profile-title"):
                                                                        self.profile_title = value
                                                                        self.profile_title.value_namespace = name_space
                                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-bytes"):
                                                                        self.random_drop_bytes = value
                                                                        self.random_drop_bytes.value_namespace = name_space
                                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-packets"):
                                                                        self.random_drop_packets = value
                                                                        self.random_drop_packets.value_namespace = name_space
                                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-ecn-marked-bytes"):
                                                                        self.red_ecn_marked_bytes = value
                                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-ecn-marked-packets"):
                                                                        self.red_ecn_marked_packets = value
                                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-transmit-bytes"):
                                                                        self.red_transmit_bytes = value
                                                                        self.red_transmit_bytes.value_namespace = name_space
                                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-transmit-packets"):
                                                                        self.red_transmit_packets = value
                                                                        self.red_transmit_packets.value_namespace = name_space
                                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.police_stats_array:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.queue_stats_array:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.wred_stats_array:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.cac_state.is_set or
                                                                    self.class_name.is_set or
                                                                    self.counter_validity_bitmask.is_set or
                                                                    self.queue_descr.is_set or
                                                                    self.shared_queue_id.is_set or
                                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                            def has_operation(self):
                                                                for c in self.police_stats_array:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.queue_stats_array:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.wred_stats_array:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.cac_state.yfilter != YFilter.not_set or
                                                                    self.class_name.yfilter != YFilter.not_set or
                                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "cac-stats"):
                                                                    if (self.cac_stats is None):
                                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                        self.cac_stats.parent = self
                                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                                    return self.cac_stats

                                                                if (child_yang_name == "general-stats"):
                                                                    if (self.general_stats is None):
                                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                        self.general_stats.parent = self
                                                                        self._children_name_map["general_stats"] = "general-stats"
                                                                    return self.general_stats

                                                                if (child_yang_name == "iphc-stats"):
                                                                    if (self.iphc_stats is None):
                                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                        self.iphc_stats.parent = self
                                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                    return self.iphc_stats

                                                                if (child_yang_name == "police-stats-array"):
                                                                    for c in self.police_stats_array:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.police_stats_array.append(c)
                                                                    return c

                                                                if (child_yang_name == "queue-stats-array"):
                                                                    for c in self.queue_stats_array:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_stats_array.append(c)
                                                                    return c

                                                                if (child_yang_name == "wred-stats-array"):
                                                                    for c in self.wred_stats_array:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.wred_stats_array.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "cac-state"):
                                                                    self.cac_state = value
                                                                    self.cac_state.value_namespace = name_space
                                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "class-name"):
                                                                    self.class_name = value
                                                                    self.class_name.value_namespace = name_space
                                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "counter-validity-bitmask"):
                                                                    self.counter_validity_bitmask = value
                                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "queue-descr"):
                                                                    self.queue_descr = value
                                                                    self.queue_descr.value_namespace = name_space
                                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "shared-queue-id"):
                                                                    self.shared_queue_id = value
                                                                    self.shared_queue_id.value_namespace = name_space
                                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.class_stats:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.policy_name.is_set or
                                                                self.satid.is_set or
                                                                self.state.is_set or
                                                                self.state_description.is_set)

                                                        def has_operation(self):
                                                            for c in self.class_stats:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.policy_name.yfilter != YFilter.not_set or
                                                                self.satid.yfilter != YFilter.not_set or
                                                                self.state.yfilter != YFilter.not_set or
                                                                self.state_description.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "child-policy" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.state.get_name_leafdata())
                                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "class-stats"):
                                                                for c in self.class_stats:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.class_stats.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "policy-name"):
                                                                self.policy_name = value
                                                                self.policy_name.value_namespace = name_space
                                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "satid"):
                                                                self.satid = value
                                                                self.satid.value_namespace = name_space
                                                                self.satid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "state"):
                                                                self.state = value
                                                                self.state.value_namespace = name_space
                                                                self.state.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "state-description"):
                                                                self.state_description = value
                                                                self.state_description.value_namespace = name_space
                                                                self.state_description.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.child_policy is not None and self.child_policy.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.child_policy is not None and self.child_policy.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "child-policy"):
                                                            if (self.child_policy is None):
                                                                self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                                                self.child_policy.parent = self
                                                                self._children_name_map["child_policy"] = "child-policy"
                                                            return self.child_policy

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "statistics" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                                    (self.statistics is not None and self.statistics.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                                    (self.statistics is not None and self.statistics.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "output" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "service-policy-names"):
                                                    if (self.service_policy_names is None):
                                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                                        self.service_policy_names.parent = self
                                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                                    return self.service_policy_names

                                                if (child_yang_name == "statistics"):
                                                    if (self.statistics is None):
                                                        self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics()
                                                        self.statistics.parent = self
                                                        self._children_name_map["statistics"] = "statistics"
                                                    return self.statistics

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-names" or name == "statistics"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass

                                        def has_data(self):
                                            return (
                                                self.nv_satellite_id.is_set or
                                                (self.input is not None and self.input.has_data()) or
                                                (self.output is not None and self.output.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.nv_satellite_id.yfilter != YFilter.not_set or
                                                (self.input is not None and self.input.has_operation()) or
                                                (self.output is not None and self.output.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "satellite-id" + "[nv-satellite-id='" + self.nv_satellite_id.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.nv_satellite_id.is_set or self.nv_satellite_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nv_satellite_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "input"):
                                                if (self.input is None):
                                                    self.input = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                                    self.input.parent = self
                                                    self._children_name_map["input"] = "input"
                                                return self.input

                                            if (child_yang_name == "output"):
                                                if (self.output is None):
                                                    self.output = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                                    self.output.parent = self
                                                    self._children_name_map["output"] = "output"
                                                return self.output

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "input" or name == "output" or name == "nv-satellite-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "nv-satellite-id"):
                                                self.nv_satellite_id = value
                                                self.nv_satellite_id.value_namespace = name_space
                                                self.nv_satellite_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.satellite_id:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.satellite_id:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "satellite-ids" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "satellite-id"):
                                            for c in self.satellite_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.satellite_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "satellite-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Input(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames>`
                                    
                                    .. attribute:: statistics
                                    
                                    	Policy\-map statistics operational data for an interface
                                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input, self).__init__()

                                        self.yang_name = "input"
                                        self.yang_parent_name = "member-interface"

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._children_yang_names.add("service-policy-names")

                                        self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                        self._children_yang_names.add("statistics")


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "input"

                                            self.service_policy_instance = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__setattr__(name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  <key>
                                            
                                            	Name of the policy instance
                                            	**type**\:  str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"

                                                self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("service_policy_name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.service_policy_name.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.service_policy_name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "service-policy-name"):
                                                    self.service_policy_name = value
                                                    self.service_policy_name.value_namespace = name_space
                                                    self.service_policy_name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-names" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "service-policy-instance"):
                                                for c in self.service_policy_instance:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.service_policy_instance.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-instance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Statistics(Entity):
                                        """
                                        Policy\-map statistics operational data for an
                                        interface
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics, self).__init__()

                                            self.yang_name = "statistics"
                                            self.yang_parent_name = "input"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "statistics"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                                self._children_yang_names.add("child-policy")

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "child-policy" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.child_policy is not None and self.child_policy.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.child_policy is not None and self.child_policy.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "child-policy"):
                                                    if (self.child_policy is None):
                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                    return self.child_policy

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "statistics" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                            (self.statistics is not None and self.statistics.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                            (self.statistics is not None and self.statistics.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "input" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-names"):
                                            if (self.service_policy_names is None):
                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                            return self.service_policy_names

                                        if (child_yang_name == "statistics"):
                                            if (self.statistics is None):
                                                self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                            return self.statistics

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-names" or name == "statistics"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Output(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames>`
                                    
                                    .. attribute:: statistics
                                    
                                    	Policy\-map statistics operational data for an interface
                                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output, self).__init__()

                                        self.yang_name = "output"
                                        self.yang_parent_name = "member-interface"

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._children_yang_names.add("service-policy-names")

                                        self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                        self._children_yang_names.add("statistics")


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "output"

                                            self.service_policy_instance = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__setattr__(name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  <key>
                                            
                                            	Name of the policy instance
                                            	**type**\:  str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"

                                                self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("service_policy_name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.service_policy_name.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.service_policy_name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "service-policy-name"):
                                                    self.service_policy_name = value
                                                    self.service_policy_name.value_namespace = name_space
                                                    self.service_policy_name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-names" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "service-policy-instance"):
                                                for c in self.service_policy_instance:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.service_policy_instance.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-instance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Statistics(Entity):
                                        """
                                        Policy\-map statistics operational data for an
                                        interface
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics, self).__init__()

                                            self.yang_name = "statistics"
                                            self.yang_parent_name = "output"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "statistics"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                                self._children_yang_names.add("child-policy")

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "child-policy" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.child_policy is not None and self.child_policy.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.child_policy is not None and self.child_policy.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "child-policy"):
                                                    if (self.child_policy is None):
                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                    return self.child_policy

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "statistics" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                            (self.statistics is not None and self.statistics.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                            (self.statistics is not None and self.statistics.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "output" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-names"):
                                            if (self.service_policy_names is None):
                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                            return self.service_policy_names

                                        if (child_yang_name == "statistics"):
                                            if (self.statistics is None):
                                                self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                            return self.statistics

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-names" or name == "statistics"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.interface_name.is_set or
                                        (self.input is not None and self.input.has_data()) or
                                        (self.output is not None and self.output.has_data()) or
                                        (self.satellite_ids is not None and self.satellite_ids.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        (self.input is not None and self.input.has_operation()) or
                                        (self.output is not None and self.output.has_operation()) or
                                        (self.satellite_ids is not None and self.satellite_ids.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "member-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "input"):
                                        if (self.input is None):
                                            self.input = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Input()
                                            self.input.parent = self
                                            self._children_name_map["input"] = "input"
                                        return self.input

                                    if (child_yang_name == "output"):
                                        if (self.output is None):
                                            self.output = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.Output()
                                            self.output.parent = self
                                            self._children_name_map["output"] = "output"
                                        return self.output

                                    if (child_yang_name == "satellite-ids"):
                                        if (self.satellite_ids is None):
                                            self.satellite_ids = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface.SatelliteIds()
                                            self.satellite_ids.parent = self
                                            self._children_name_map["satellite_ids"] = "satellite-ids"
                                        return self.satellite_ids

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "input" or name == "output" or name == "satellite-ids" or name == "interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.member_interface:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.member_interface:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "member-interfaces" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "member-interface"):
                                    for c in self.member_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces.MemberInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.member_interface.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "member-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Input(Entity):
                            """
                            A piece of QoS policy\-map operational data for
                            an interface
                            
                            .. attribute:: service_policy_names
                            
                            	Operational data for all Policy instance
                            	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames>`
                            
                            .. attribute:: statistics
                            
                            	Policy\-map statistics operational data for an interface
                            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input, self).__init__()

                                self.yang_name = "input"
                                self.yang_parent_name = "shared-policy-instance"

                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames()
                                self.service_policy_names.parent = self
                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                self._children_yang_names.add("service-policy-names")

                                self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                                self._children_yang_names.add("statistics")


                            class ServicePolicyNames(Entity):
                                """
                                Operational data for all Policy instance
                                
                                .. attribute:: service_policy_instance
                                
                                	QoS policy\-map operational data for a particular Policy 
                                	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames, self).__init__()

                                    self.yang_name = "service-policy-names"
                                    self.yang_parent_name = "input"

                                    self.service_policy_instance = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames, self).__setattr__(name, value)


                                class ServicePolicyInstance(Entity):
                                    """
                                    QoS policy\-map operational data for a
                                    particular Policy 
                                    
                                    .. attribute:: service_policy_name  <key>
                                    
                                    	Name of the policy instance
                                    	**type**\:  str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                        self.yang_name = "service-policy-instance"
                                        self.yang_parent_name = "service-policy-names"

                                        self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("service_policy_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.service_policy_name.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.service_policy_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "service-policy-name"):
                                            self.service_policy_name = value
                                            self.service_policy_name.value_namespace = name_space
                                            self.service_policy_name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.service_policy_instance:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.service_policy_instance:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-names" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "service-policy-instance"):
                                        for c in self.service_policy_instance:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames.ServicePolicyInstance()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.service_policy_instance.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-instance"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Statistics(Entity):
                                """
                                Policy\-map statistics operational data for an
                                interface
                                
                                .. attribute:: class_stats
                                
                                	array of classes contained in policy
                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats>`
                                
                                .. attribute:: policy_name
                                
                                	PolicyName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: satid
                                
                                	to maintain satellite id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: state
                                
                                	State
                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                
                                .. attribute:: state_description
                                
                                	StateDescription
                                	**type**\:  str
                                
                                	**length:** 0..128
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics, self).__init__()

                                    self.yang_name = "statistics"
                                    self.yang_parent_name = "input"

                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                    self.satid = YLeaf(YType.uint32, "satid")

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_description = YLeaf(YType.str, "state-description")

                                    self.class_stats = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("policy_name",
                                                    "satid",
                                                    "state",
                                                    "state_description") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics, self).__setattr__(name, value)


                                class ClassStats(Entity):
                                    """
                                    array of classes contained in policy
                                    
                                    .. attribute:: cac_state
                                    
                                    	CACState
                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                    
                                    .. attribute:: cac_stats
                                    
                                    	bag for cac stats
                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.CacStats>`
                                    
                                    .. attribute:: child_policy
                                    
                                    	child policy
                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy>`
                                    
                                    .. attribute:: class_name
                                    
                                    	ClassName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: counter_validity_bitmask
                                    
                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: megabyte
                                    
                                    .. attribute:: general_stats
                                    
                                    	general stats
                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.GeneralStats>`
                                    
                                    .. attribute:: iphc_stats
                                    
                                    	IPHC stats
                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.IphcStats>`
                                    
                                    .. attribute:: police_stats_array
                                    
                                    	array of police stats
                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.PoliceStatsArray>`
                                    
                                    .. attribute:: queue_descr
                                    
                                    	Description of queue for the class
                                    	**type**\:  str
                                    
                                    	**length:** 0..256
                                    
                                    .. attribute:: queue_stats_array
                                    
                                    	array of queue stats
                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray>`
                                    
                                    .. attribute:: shared_queue_id
                                    
                                    	q\-id of the  shared queue for this class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wred_stats_array
                                    
                                    	array of red stats
                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.WredStatsArray>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats, self).__init__()

                                        self.yang_name = "class-stats"
                                        self.yang_parent_name = "statistics"

                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                        self.class_name = YLeaf(YType.str, "class-name")

                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.CacStats()
                                        self.cac_stats.parent = self
                                        self._children_name_map["cac_stats"] = "cac-stats"
                                        self._children_yang_names.add("cac-stats")

                                        self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy()
                                        self.child_policy.parent = self
                                        self._children_name_map["child_policy"] = "child-policy"
                                        self._children_yang_names.add("child-policy")

                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.GeneralStats()
                                        self.general_stats.parent = self
                                        self._children_name_map["general_stats"] = "general-stats"
                                        self._children_yang_names.add("general-stats")

                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.IphcStats()
                                        self.iphc_stats.parent = self
                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                        self._children_yang_names.add("iphc-stats")

                                        self.police_stats_array = YList(self)
                                        self.queue_stats_array = YList(self)
                                        self.wred_stats_array = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("cac_state",
                                                        "class_name",
                                                        "counter_validity_bitmask",
                                                        "queue_descr",
                                                        "shared_queue_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                    class GeneralStats(Entity):
                                        """
                                        general stats
                                        
                                        .. attribute:: match_data_rate
                                        
                                        	Incoming matched data rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: pre_policy_matched_bytes
                                        
                                        	Matched bytes before applying policy
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: pre_policy_matched_packets
                                        
                                        	Matched pkts before applying policy
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: total_drop_bytes
                                        
                                        	Dropped bytes (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_packets
                                        
                                        	Dropped packets (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_rate
                                        
                                        	Total drop rate (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_transmit_rate
                                        
                                        	Total transmit rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: transmit_bytes
                                        
                                        	Transmitted bytes (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: transmit_packets
                                        
                                        	Transmitted packets (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                            self.yang_name = "general-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("match_data_rate",
                                                            "pre_policy_matched_bytes",
                                                            "pre_policy_matched_packets",
                                                            "total_drop_bytes",
                                                            "total_drop_packets",
                                                            "total_drop_rate",
                                                            "total_transmit_rate",
                                                            "transmit_bytes",
                                                            "transmit_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.match_data_rate.is_set or
                                                self.pre_policy_matched_bytes.is_set or
                                                self.pre_policy_matched_packets.is_set or
                                                self.total_drop_bytes.is_set or
                                                self.total_drop_packets.is_set or
                                                self.total_drop_rate.is_set or
                                                self.total_transmit_rate.is_set or
                                                self.transmit_bytes.is_set or
                                                self.transmit_packets.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                self.transmit_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "general-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "match-data-rate"):
                                                self.match_data_rate = value
                                                self.match_data_rate.value_namespace = name_space
                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pre-policy-matched-bytes"):
                                                self.pre_policy_matched_bytes = value
                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pre-policy-matched-packets"):
                                                self.pre_policy_matched_packets = value
                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-bytes"):
                                                self.total_drop_bytes = value
                                                self.total_drop_bytes.value_namespace = name_space
                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-packets"):
                                                self.total_drop_packets = value
                                                self.total_drop_packets.value_namespace = name_space
                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-rate"):
                                                self.total_drop_rate = value
                                                self.total_drop_rate.value_namespace = name_space
                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-transmit-rate"):
                                                self.total_transmit_rate = value
                                                self.total_transmit_rate.value_namespace = name_space
                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "transmit-bytes"):
                                                self.transmit_bytes = value
                                                self.transmit_bytes.value_namespace = name_space
                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "transmit-packets"):
                                                self.transmit_packets = value
                                                self.transmit_packets.value_namespace = name_space
                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                    class IphcStats(Entity):
                                        """
                                        IPHC stats
                                        
                                        .. attribute:: non_tcp_bytes_saved
                                        
                                        	Non Tcp Bytes saved due to compression
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_bytes_sent_rate
                                        
                                        	Compressed Non Tcp Bytes sent rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_compressed_packets_out
                                        
                                        	Num of non tcp compressed pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: non_tcp_full_header_packets_out
                                        
                                        	Num of non tcp fullheader pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: non_tcp_total_out_bytes
                                        
                                        	TotalNum of Non Tcp Bytes sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_total_out_packets
                                        
                                        	TotalNum of Non tcp pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_bytes_saved
                                        
                                        	Tcp Bytes saved due to compression
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_bytes_sent_rate
                                        
                                        	Compressed Tcp Bytes sent rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_compressed_packets_out
                                        
                                        	Num of tcp compressed pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_full_header_packets_out
                                        
                                        	Num of tcp fullheader pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_total_out_bytes
                                        
                                        	TotalNum of Tcp Bytes sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_total_out_packets
                                        
                                        	Total Num of tcp pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                            self.yang_name = "iphc-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("non_tcp_bytes_saved",
                                                            "non_tcp_bytes_sent_rate",
                                                            "non_tcp_compressed_packets_out",
                                                            "non_tcp_full_header_packets_out",
                                                            "non_tcp_total_out_bytes",
                                                            "non_tcp_total_out_packets",
                                                            "tcp_bytes_saved",
                                                            "tcp_bytes_sent_rate",
                                                            "tcp_compressed_packets_out",
                                                            "tcp_full_header_packets_out",
                                                            "tcp_total_out_bytes",
                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.non_tcp_bytes_saved.is_set or
                                                self.non_tcp_bytes_sent_rate.is_set or
                                                self.non_tcp_compressed_packets_out.is_set or
                                                self.non_tcp_full_header_packets_out.is_set or
                                                self.non_tcp_total_out_bytes.is_set or
                                                self.non_tcp_total_out_packets.is_set or
                                                self.tcp_bytes_saved.is_set or
                                                self.tcp_bytes_sent_rate.is_set or
                                                self.tcp_compressed_packets_out.is_set or
                                                self.tcp_full_header_packets_out.is_set or
                                                self.tcp_total_out_bytes.is_set or
                                                self.tcp_total_out_packets.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "iphc-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "non-tcp-bytes-saved"):
                                                self.non_tcp_bytes_saved = value
                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                self.non_tcp_bytes_sent_rate = value
                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                self.non_tcp_compressed_packets_out = value
                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                self.non_tcp_full_header_packets_out = value
                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-total-out-bytes"):
                                                self.non_tcp_total_out_bytes = value
                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-total-out-packets"):
                                                self.non_tcp_total_out_packets = value
                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-bytes-saved"):
                                                self.tcp_bytes_saved = value
                                                self.tcp_bytes_saved.value_namespace = name_space
                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-bytes-sent-rate"):
                                                self.tcp_bytes_sent_rate = value
                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-compressed-packets-out"):
                                                self.tcp_compressed_packets_out = value
                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-full-header-packets-out"):
                                                self.tcp_full_header_packets_out = value
                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-total-out-bytes"):
                                                self.tcp_total_out_bytes = value
                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-total-out-packets"):
                                                self.tcp_total_out_packets = value
                                                self.tcp_total_out_packets.value_namespace = name_space
                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                    class ChildPolicy(Entity):
                                        """
                                        child policy
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                            self.yang_name = "child-policy"
                                            self.yang_parent_name = "class-stats"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "child-policy"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "child-policy" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix


                                    class CacStats(Entity):
                                        """
                                        bag for cac stats
                                        
                                        .. attribute:: admit_bytes
                                        
                                        	Admitted bytes (pkts/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: admit_rates
                                        
                                        	CAC admit rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: admitpackets
                                        
                                        	Admitted packets (pkts/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_bytes
                                        
                                        	CAC dropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_packets
                                        
                                        	CAC dropped packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: drop_rates
                                        
                                        	CAC dropped rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.CacStats, self).__init__()

                                            self.yang_name = "cac-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("admit_bytes",
                                                            "admit_rates",
                                                            "admitpackets",
                                                            "drop_bytes",
                                                            "drop_packets",
                                                            "drop_rates") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.admit_bytes.is_set or
                                                self.admit_rates.is_set or
                                                self.admitpackets.is_set or
                                                self.drop_bytes.is_set or
                                                self.drop_packets.is_set or
                                                self.drop_rates.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                self.admit_rates.yfilter != YFilter.not_set or
                                                self.admitpackets.yfilter != YFilter.not_set or
                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                self.drop_packets.yfilter != YFilter.not_set or
                                                self.drop_rates.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "cac-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "admit-bytes"):
                                                self.admit_bytes = value
                                                self.admit_bytes.value_namespace = name_space
                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "admit-rates"):
                                                self.admit_rates = value
                                                self.admit_rates.value_namespace = name_space
                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                            if(value_path == "admitpackets"):
                                                self.admitpackets = value
                                                self.admitpackets.value_namespace = name_space
                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-bytes"):
                                                self.drop_bytes = value
                                                self.drop_bytes.value_namespace = name_space
                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-packets"):
                                                self.drop_packets = value
                                                self.drop_packets.value_namespace = name_space
                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-rates"):
                                                self.drop_rates = value
                                                self.drop_rates.value_namespace = name_space
                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                    class QueueStatsArray(Entity):
                                        """
                                        array of queue stats
                                        
                                        .. attribute:: atm_clp0_drop_bytes
                                        
                                        	ATP CLP 0 matched bytes dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: atm_clp0_drop_packets
                                        
                                        	ATP CLP 0 matched packets dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: atm_clp1_drop_bytes
                                        
                                        	ATP CLP 0 matched bytes dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: atm_clp1_drop_packets
                                        
                                        	ATP CLP 0 matched packets dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_bytes
                                        
                                        	Bytes that conform to the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_packets
                                        
                                        	Packets that conform  to the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_rate
                                        
                                        	Conform rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: exceed_bytes
                                        
                                        	Bytes that exceed  the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_packets
                                        
                                        	Packets that exceed the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_rate
                                        
                                        	Exceed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: forced_wred_stats_display
                                        
                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                        	**type**\:  bool
                                        
                                        .. attribute:: max_threshold_bytes
                                        
                                        	Dropped bytes with the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: max_threshold_packets
                                        
                                        	Dropped packets with the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: queue_average_length
                                        
                                        	Queue average length
                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                        
                                        .. attribute:: queue_drop_threshold
                                        
                                        	tail drop threshold of the queue in bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: queue_id
                                        
                                        	Queue Id used for Fabric Stats
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_instance_length
                                        
                                        	Queue instance length
                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                        
                                        .. attribute:: queue_max_length
                                        
                                        	Queue maximum length
                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                        
                                        .. attribute:: random_drop_bytes
                                        
                                        	Bytes probabilistically dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: random_drop_packets
                                        
                                        	Packets probabilistically dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tail_drop_bytes
                                        
                                        	Bytes tail dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tail_drop_packets
                                        
                                        	Packets tail dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                            self.yang_name = "queue-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                            self.queue_average_length = YList(self)
                                            self.queue_instance_length = YList(self)
                                            self.queue_max_length = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("atm_clp0_drop_bytes",
                                                            "atm_clp0_drop_packets",
                                                            "atm_clp1_drop_bytes",
                                                            "atm_clp1_drop_packets",
                                                            "conform_bytes",
                                                            "conform_packets",
                                                            "conform_rate",
                                                            "exceed_bytes",
                                                            "exceed_packets",
                                                            "exceed_rate",
                                                            "forced_wred_stats_display",
                                                            "max_threshold_bytes",
                                                            "max_threshold_packets",
                                                            "queue_drop_threshold",
                                                            "queue_id",
                                                            "random_drop_bytes",
                                                            "random_drop_packets",
                                                            "tail_drop_bytes",
                                                            "tail_drop_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                        class QueueInstanceLength(Entity):
                                            """
                                            Queue instance length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                self.yang_name = "queue-instance-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-instance-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class QueueAverageLength(Entity):
                                            """
                                            Queue average length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                self.yang_name = "queue-average-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-average-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class QueueMaxLength(Entity):
                                            """
                                            Queue maximum length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                self.yang_name = "queue-max-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-max-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.queue_average_length:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_instance_length:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_max_length:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.atm_clp0_drop_bytes.is_set or
                                                self.atm_clp0_drop_packets.is_set or
                                                self.atm_clp1_drop_bytes.is_set or
                                                self.atm_clp1_drop_packets.is_set or
                                                self.conform_bytes.is_set or
                                                self.conform_packets.is_set or
                                                self.conform_rate.is_set or
                                                self.exceed_bytes.is_set or
                                                self.exceed_packets.is_set or
                                                self.exceed_rate.is_set or
                                                self.forced_wred_stats_display.is_set or
                                                self.max_threshold_bytes.is_set or
                                                self.max_threshold_packets.is_set or
                                                self.queue_drop_threshold.is_set or
                                                self.queue_id.is_set or
                                                self.random_drop_bytes.is_set or
                                                self.random_drop_packets.is_set or
                                                self.tail_drop_bytes.is_set or
                                                self.tail_drop_packets.is_set)

                                        def has_operation(self):
                                            for c in self.queue_average_length:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_instance_length:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_max_length:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_packets.yfilter != YFilter.not_set or
                                                self.conform_rate.yfilter != YFilter.not_set or
                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                self.queue_id.yfilter != YFilter.not_set or
                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "queue-average-length"):
                                                for c in self.queue_average_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_average_length.append(c)
                                                return c

                                            if (child_yang_name == "queue-instance-length"):
                                                for c in self.queue_instance_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_instance_length.append(c)
                                                return c

                                            if (child_yang_name == "queue-max-length"):
                                                for c in self.queue_max_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_max_length.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "atm-clp0-drop-bytes"):
                                                self.atm_clp0_drop_bytes = value
                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp0-drop-packets"):
                                                self.atm_clp0_drop_packets = value
                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp1-drop-bytes"):
                                                self.atm_clp1_drop_bytes = value
                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp1-drop-packets"):
                                                self.atm_clp1_drop_packets = value
                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-bytes"):
                                                self.conform_bytes = value
                                                self.conform_bytes.value_namespace = name_space
                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-packets"):
                                                self.conform_packets = value
                                                self.conform_packets.value_namespace = name_space
                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-rate"):
                                                self.conform_rate = value
                                                self.conform_rate.value_namespace = name_space
                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-bytes"):
                                                self.exceed_bytes = value
                                                self.exceed_bytes.value_namespace = name_space
                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-packets"):
                                                self.exceed_packets = value
                                                self.exceed_packets.value_namespace = name_space
                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-rate"):
                                                self.exceed_rate = value
                                                self.exceed_rate.value_namespace = name_space
                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forced-wred-stats-display"):
                                                self.forced_wred_stats_display = value
                                                self.forced_wred_stats_display.value_namespace = name_space
                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-bytes"):
                                                self.max_threshold_bytes = value
                                                self.max_threshold_bytes.value_namespace = name_space
                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-packets"):
                                                self.max_threshold_packets = value
                                                self.max_threshold_packets.value_namespace = name_space
                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-drop-threshold"):
                                                self.queue_drop_threshold = value
                                                self.queue_drop_threshold.value_namespace = name_space
                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-id"):
                                                self.queue_id = value
                                                self.queue_id.value_namespace = name_space
                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-bytes"):
                                                self.random_drop_bytes = value
                                                self.random_drop_bytes.value_namespace = name_space
                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-packets"):
                                                self.random_drop_packets = value
                                                self.random_drop_packets.value_namespace = name_space
                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tail-drop-bytes"):
                                                self.tail_drop_bytes = value
                                                self.tail_drop_bytes.value_namespace = name_space
                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tail-drop-packets"):
                                                self.tail_drop_packets = value
                                                self.tail_drop_packets.value_namespace = name_space
                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                    class PoliceStatsArray(Entity):
                                        """
                                        array of police stats
                                        
                                        .. attribute:: color_class_stats
                                        
                                        	color class stats
                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                        
                                        .. attribute:: conform_bytes
                                        
                                        	Bytes that conform to the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_packets
                                        
                                        	Packets that conform  to the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_rate
                                        
                                        	Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: drop_bytes
                                        
                                        	Police dropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_packets
                                        
                                        	Police dropped packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_bytes
                                        
                                        	Bytes that exceed  the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_packets
                                        
                                        	Packets that exceed the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_rate
                                        
                                        	Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: parent_drop_bytes
                                        
                                        	Dropped bytes by the parent policer
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: parent_drop_packets
                                        
                                        	Dropped pkts by the parent policer
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_bytes
                                        
                                        	Bytes that violate the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_packets
                                        
                                        	Packets violating the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_rate
                                        
                                        	Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                            self.yang_name = "police-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                            self.color_class_stats.parent = self
                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                            self._children_yang_names.add("color-class-stats")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_bytes",
                                                            "conform_packets",
                                                            "conform_rate",
                                                            "drop_bytes",
                                                            "drop_packets",
                                                            "exceed_bytes",
                                                            "exceed_packets",
                                                            "exceed_rate",
                                                            "parent_drop_bytes",
                                                            "parent_drop_packets",
                                                            "violate_bytes",
                                                            "violate_packets",
                                                            "violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                        class ColorClassStats(Entity):
                                            """
                                            color class stats
                                            
                                            .. attribute:: conform_class_conform_bytes
                                            
                                            	Bytes with classification result conform and policer result conform
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_conform_packets
                                            
                                            	Packets with classification result conform and policer result conform
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_conform_rate
                                            
                                            	Conform Class Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: conform_class_exceed_bytes
                                            
                                            	Bytes with classification result conform and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_exceed_packets
                                            
                                            	Packets with classification result conform and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_exceed_rate
                                            
                                            	Conform Class Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: conform_class_violate_bytes
                                            
                                            	Bytes with classification result conform and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_violate_packets
                                            
                                            	Packets with classification result conform and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_violate_rate
                                            
                                            	Conform Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_class_exceed_bytes
                                            
                                            	Bytes with classification result exceed and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_class_exceed_packets
                                            
                                            	Packets with classification result exceed and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_class_exceed_rate
                                            
                                            	Exceed Class Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_class_violate_bytes
                                            
                                            	Bytes with classification result exceed and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_class_violate_packets
                                            
                                            	Packets with classification result exceed and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_class_violate_rate
                                            
                                            	Exceed Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_class_violate_bytes
                                            
                                            	Bytes with classification result violate and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_class_violate_packets
                                            
                                            	Packets with classification result violate and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_class_violate_rate
                                            
                                            	Violate Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                self.yang_name = "color-class-stats"
                                                self.yang_parent_name = "police-stats-array"

                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_class_conform_bytes",
                                                                "conform_class_conform_packets",
                                                                "conform_class_conform_rate",
                                                                "conform_class_exceed_bytes",
                                                                "conform_class_exceed_packets",
                                                                "conform_class_exceed_rate",
                                                                "conform_class_violate_bytes",
                                                                "conform_class_violate_packets",
                                                                "conform_class_violate_rate",
                                                                "exceed_class_exceed_bytes",
                                                                "exceed_class_exceed_packets",
                                                                "exceed_class_exceed_rate",
                                                                "exceed_class_violate_bytes",
                                                                "exceed_class_violate_packets",
                                                                "exceed_class_violate_rate",
                                                                "violate_class_violate_bytes",
                                                                "violate_class_violate_packets",
                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.conform_class_conform_bytes.is_set or
                                                    self.conform_class_conform_packets.is_set or
                                                    self.conform_class_conform_rate.is_set or
                                                    self.conform_class_exceed_bytes.is_set or
                                                    self.conform_class_exceed_packets.is_set or
                                                    self.conform_class_exceed_rate.is_set or
                                                    self.conform_class_violate_bytes.is_set or
                                                    self.conform_class_violate_packets.is_set or
                                                    self.conform_class_violate_rate.is_set or
                                                    self.exceed_class_exceed_bytes.is_set or
                                                    self.exceed_class_exceed_packets.is_set or
                                                    self.exceed_class_exceed_rate.is_set or
                                                    self.exceed_class_violate_bytes.is_set or
                                                    self.exceed_class_violate_packets.is_set or
                                                    self.exceed_class_violate_rate.is_set or
                                                    self.violate_class_violate_bytes.is_set or
                                                    self.violate_class_violate_packets.is_set or
                                                    self.violate_class_violate_rate.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "color-class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-class-conform-bytes"):
                                                    self.conform_class_conform_bytes = value
                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-conform-packets"):
                                                    self.conform_class_conform_packets = value
                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-conform-rate"):
                                                    self.conform_class_conform_rate = value
                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-bytes"):
                                                    self.conform_class_exceed_bytes = value
                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-packets"):
                                                    self.conform_class_exceed_packets = value
                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-rate"):
                                                    self.conform_class_exceed_rate = value
                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-bytes"):
                                                    self.conform_class_violate_bytes = value
                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-packets"):
                                                    self.conform_class_violate_packets = value
                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-rate"):
                                                    self.conform_class_violate_rate = value
                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-bytes"):
                                                    self.exceed_class_exceed_bytes = value
                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-packets"):
                                                    self.exceed_class_exceed_packets = value
                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-rate"):
                                                    self.exceed_class_exceed_rate = value
                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-bytes"):
                                                    self.exceed_class_violate_bytes = value
                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-packets"):
                                                    self.exceed_class_violate_packets = value
                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-rate"):
                                                    self.exceed_class_violate_rate = value
                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-bytes"):
                                                    self.violate_class_violate_bytes = value
                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-packets"):
                                                    self.violate_class_violate_packets = value
                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-rate"):
                                                    self.violate_class_violate_rate = value
                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.conform_bytes.is_set or
                                                self.conform_packets.is_set or
                                                self.conform_rate.is_set or
                                                self.drop_bytes.is_set or
                                                self.drop_packets.is_set or
                                                self.exceed_bytes.is_set or
                                                self.exceed_packets.is_set or
                                                self.exceed_rate.is_set or
                                                self.parent_drop_bytes.is_set or
                                                self.parent_drop_packets.is_set or
                                                self.violate_bytes.is_set or
                                                self.violate_packets.is_set or
                                                self.violate_rate.is_set or
                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_packets.yfilter != YFilter.not_set or
                                                self.conform_rate.yfilter != YFilter.not_set or
                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                self.drop_packets.yfilter != YFilter.not_set or
                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_packets.yfilter != YFilter.not_set or
                                                self.violate_rate.yfilter != YFilter.not_set or
                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "police-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "color-class-stats"):
                                                if (self.color_class_stats is None):
                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                return self.color_class_stats

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-bytes"):
                                                self.conform_bytes = value
                                                self.conform_bytes.value_namespace = name_space
                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-packets"):
                                                self.conform_packets = value
                                                self.conform_packets.value_namespace = name_space
                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-rate"):
                                                self.conform_rate = value
                                                self.conform_rate.value_namespace = name_space
                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-bytes"):
                                                self.drop_bytes = value
                                                self.drop_bytes.value_namespace = name_space
                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-packets"):
                                                self.drop_packets = value
                                                self.drop_packets.value_namespace = name_space
                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-bytes"):
                                                self.exceed_bytes = value
                                                self.exceed_bytes.value_namespace = name_space
                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-packets"):
                                                self.exceed_packets = value
                                                self.exceed_packets.value_namespace = name_space
                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-rate"):
                                                self.exceed_rate = value
                                                self.exceed_rate.value_namespace = name_space
                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "parent-drop-bytes"):
                                                self.parent_drop_bytes = value
                                                self.parent_drop_bytes.value_namespace = name_space
                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "parent-drop-packets"):
                                                self.parent_drop_packets = value
                                                self.parent_drop_packets.value_namespace = name_space
                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-bytes"):
                                                self.violate_bytes = value
                                                self.violate_bytes.value_namespace = name_space
                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-packets"):
                                                self.violate_packets = value
                                                self.violate_packets.value_namespace = name_space
                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-rate"):
                                                self.violate_rate = value
                                                self.violate_rate.value_namespace = name_space
                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                    class WredStatsArray(Entity):
                                        """
                                        array of red stats
                                        
                                        .. attribute:: max_threshold_bytes
                                        
                                        	Dropped bytes with  the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: max_threshold_packets
                                        
                                        	Dropped packets with  the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: profile_title
                                        
                                        	ProfileTitle
                                        	**type**\:  str
                                        
                                        	**length:** 0..300
                                        
                                        .. attribute:: random_drop_bytes
                                        
                                        	Probabilisticallydropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: random_drop_packets
                                        
                                        	Probabilistically dropped  packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: red_ecn_marked_bytes
                                        
                                        	ECN marked bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: red_ecn_marked_packets
                                        
                                        	ECN marked packets 
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: red_label
                                        
                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                        
                                        .. attribute:: red_transmit_bytes
                                        
                                        	Transmitted bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: red_transmit_packets
                                        
                                        	Transmitted packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                            self.yang_name = "wred-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                            self.red_label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("max_threshold_bytes",
                                                            "max_threshold_packets",
                                                            "profile_title",
                                                            "random_drop_bytes",
                                                            "random_drop_packets",
                                                            "red_ecn_marked_bytes",
                                                            "red_ecn_marked_packets",
                                                            "red_transmit_bytes",
                                                            "red_transmit_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                        class RedLabel(Entity):
                                            """
                                            Array of WRED Typevalues as in PRP stats is
                                            available per threshold   
                                            
                                            .. attribute:: value
                                            
                                            	WRED value for this type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: wred_type
                                            
                                            	WRED type DSCP, EXP, PREC etc
                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                self.yang_name = "red-label"
                                                self.yang_parent_name = "wred-stats-array"

                                                self.value = YLeaf(YType.uint8, "value")

                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("value",
                                                                "wred_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.value.is_set or
                                                    self.wred_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set or
                                                    self.wred_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "red-label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "value" or name == "wred-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "wred-type"):
                                                    self.wred_type = value
                                                    self.wred_type.value_namespace = name_space
                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.red_label:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.max_threshold_bytes.is_set or
                                                self.max_threshold_packets.is_set or
                                                self.profile_title.is_set or
                                                self.random_drop_bytes.is_set or
                                                self.random_drop_packets.is_set or
                                                self.red_ecn_marked_bytes.is_set or
                                                self.red_ecn_marked_packets.is_set or
                                                self.red_transmit_bytes.is_set or
                                                self.red_transmit_packets.is_set)

                                        def has_operation(self):
                                            for c in self.red_label:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                self.profile_title.yfilter != YFilter.not_set or
                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wred-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "red-label"):
                                                for c in self.red_label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.red_label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "max-threshold-bytes"):
                                                self.max_threshold_bytes = value
                                                self.max_threshold_bytes.value_namespace = name_space
                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-packets"):
                                                self.max_threshold_packets = value
                                                self.max_threshold_packets.value_namespace = name_space
                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-title"):
                                                self.profile_title = value
                                                self.profile_title.value_namespace = name_space
                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-bytes"):
                                                self.random_drop_bytes = value
                                                self.random_drop_bytes.value_namespace = name_space
                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-packets"):
                                                self.random_drop_packets = value
                                                self.random_drop_packets.value_namespace = name_space
                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-ecn-marked-bytes"):
                                                self.red_ecn_marked_bytes = value
                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-ecn-marked-packets"):
                                                self.red_ecn_marked_packets = value
                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-transmit-bytes"):
                                                self.red_transmit_bytes = value
                                                self.red_transmit_bytes.value_namespace = name_space
                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-transmit-packets"):
                                                self.red_transmit_packets = value
                                                self.red_transmit_packets.value_namespace = name_space
                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.police_stats_array:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_stats_array:
                                            if (c.has_data()):
                                                return True
                                        for c in self.wred_stats_array:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.cac_state.is_set or
                                            self.class_name.is_set or
                                            self.counter_validity_bitmask.is_set or
                                            self.queue_descr.is_set or
                                            self.shared_queue_id.is_set or
                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                            (self.child_policy is not None and self.child_policy.has_data()) or
                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                    def has_operation(self):
                                        for c in self.police_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.wred_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.cac_state.yfilter != YFilter.not_set or
                                            self.class_name.yfilter != YFilter.not_set or
                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                            self.queue_descr.yfilter != YFilter.not_set or
                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                            (self.child_policy is not None and self.child_policy.has_operation()) or
                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "class-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "cac-stats"):
                                            if (self.cac_stats is None):
                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                            return self.cac_stats

                                        if (child_yang_name == "child-policy"):
                                            if (self.child_policy is None):
                                                self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                            return self.child_policy

                                        if (child_yang_name == "general-stats"):
                                            if (self.general_stats is None):
                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                            return self.general_stats

                                        if (child_yang_name == "iphc-stats"):
                                            if (self.iphc_stats is None):
                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                            return self.iphc_stats

                                        if (child_yang_name == "police-stats-array"):
                                            for c in self.police_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.PoliceStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.police_stats_array.append(c)
                                            return c

                                        if (child_yang_name == "queue-stats-array"):
                                            for c in self.queue_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.QueueStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_stats_array.append(c)
                                            return c

                                        if (child_yang_name == "wred-stats-array"):
                                            for c in self.wred_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats.WredStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.wred_stats_array.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "cac-state"):
                                            self.cac_state = value
                                            self.cac_state.value_namespace = name_space
                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "class-name"):
                                            self.class_name = value
                                            self.class_name.value_namespace = name_space
                                            self.class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "counter-validity-bitmask"):
                                            self.counter_validity_bitmask = value
                                            self.counter_validity_bitmask.value_namespace = name_space
                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-descr"):
                                            self.queue_descr = value
                                            self.queue_descr.value_namespace = name_space
                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "shared-queue-id"):
                                            self.shared_queue_id = value
                                            self.shared_queue_id.value_namespace = name_space
                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.class_stats:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.policy_name.is_set or
                                        self.satid.is_set or
                                        self.state.is_set or
                                        self.state_description.is_set)

                                def has_operation(self):
                                    for c in self.class_stats:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.policy_name.yfilter != YFilter.not_set or
                                        self.satid.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_description.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "statistics" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "class-stats"):
                                        for c in self.class_stats:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics.ClassStats()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.class_stats.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "policy-name"):
                                        self.policy_name = value
                                        self.policy_name.value_namespace = name_space
                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "satid"):
                                        self.satid = value
                                        self.satid.value_namespace = name_space
                                        self.satid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-description"):
                                        self.state_description = value
                                        self.state_description.value_namespace = name_space
                                        self.state_description.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                    (self.statistics is not None and self.statistics.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                    (self.statistics is not None and self.statistics.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "input" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-names"):
                                    if (self.service_policy_names is None):
                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                    return self.service_policy_names

                                if (child_yang_name == "statistics"):
                                    if (self.statistics is None):
                                        self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                    return self.statistics

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-names" or name == "statistics"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Output(Entity):
                            """
                            A piece of QoS policy\-map operational data for
                            an interface
                            
                            .. attribute:: service_policy_names
                            
                            	Operational data for all Policy instance
                            	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames>`
                            
                            .. attribute:: statistics
                            
                            	Policy\-map statistics operational data for an interface
                            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output, self).__init__()

                                self.yang_name = "output"
                                self.yang_parent_name = "shared-policy-instance"

                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames()
                                self.service_policy_names.parent = self
                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                self._children_yang_names.add("service-policy-names")

                                self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                                self._children_yang_names.add("statistics")


                            class ServicePolicyNames(Entity):
                                """
                                Operational data for all Policy instance
                                
                                .. attribute:: service_policy_instance
                                
                                	QoS policy\-map operational data for a particular Policy 
                                	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames, self).__init__()

                                    self.yang_name = "service-policy-names"
                                    self.yang_parent_name = "output"

                                    self.service_policy_instance = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames, self).__setattr__(name, value)


                                class ServicePolicyInstance(Entity):
                                    """
                                    QoS policy\-map operational data for a
                                    particular Policy 
                                    
                                    .. attribute:: service_policy_name  <key>
                                    
                                    	Name of the policy instance
                                    	**type**\:  str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                        self.yang_name = "service-policy-instance"
                                        self.yang_parent_name = "service-policy-names"

                                        self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("service_policy_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.service_policy_name.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.service_policy_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "service-policy-name"):
                                            self.service_policy_name = value
                                            self.service_policy_name.value_namespace = name_space
                                            self.service_policy_name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.service_policy_instance:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.service_policy_instance:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-names" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "service-policy-instance"):
                                        for c in self.service_policy_instance:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames.ServicePolicyInstance()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.service_policy_instance.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-instance"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Statistics(Entity):
                                """
                                Policy\-map statistics operational data for an
                                interface
                                
                                .. attribute:: class_stats
                                
                                	array of classes contained in policy
                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats>`
                                
                                .. attribute:: policy_name
                                
                                	PolicyName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: satid
                                
                                	to maintain satellite id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: state
                                
                                	State
                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                
                                .. attribute:: state_description
                                
                                	StateDescription
                                	**type**\:  str
                                
                                	**length:** 0..128
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics, self).__init__()

                                    self.yang_name = "statistics"
                                    self.yang_parent_name = "output"

                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                    self.satid = YLeaf(YType.uint32, "satid")

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_description = YLeaf(YType.str, "state-description")

                                    self.class_stats = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("policy_name",
                                                    "satid",
                                                    "state",
                                                    "state_description") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics, self).__setattr__(name, value)


                                class ClassStats(Entity):
                                    """
                                    array of classes contained in policy
                                    
                                    .. attribute:: cac_state
                                    
                                    	CACState
                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                    
                                    .. attribute:: cac_stats
                                    
                                    	bag for cac stats
                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.CacStats>`
                                    
                                    .. attribute:: child_policy
                                    
                                    	child policy
                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy>`
                                    
                                    .. attribute:: class_name
                                    
                                    	ClassName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: counter_validity_bitmask
                                    
                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: megabyte
                                    
                                    .. attribute:: general_stats
                                    
                                    	general stats
                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.GeneralStats>`
                                    
                                    .. attribute:: iphc_stats
                                    
                                    	IPHC stats
                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.IphcStats>`
                                    
                                    .. attribute:: police_stats_array
                                    
                                    	array of police stats
                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.PoliceStatsArray>`
                                    
                                    .. attribute:: queue_descr
                                    
                                    	Description of queue for the class
                                    	**type**\:  str
                                    
                                    	**length:** 0..256
                                    
                                    .. attribute:: queue_stats_array
                                    
                                    	array of queue stats
                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray>`
                                    
                                    .. attribute:: shared_queue_id
                                    
                                    	q\-id of the  shared queue for this class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wred_stats_array
                                    
                                    	array of red stats
                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.WredStatsArray>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats, self).__init__()

                                        self.yang_name = "class-stats"
                                        self.yang_parent_name = "statistics"

                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                        self.class_name = YLeaf(YType.str, "class-name")

                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.CacStats()
                                        self.cac_stats.parent = self
                                        self._children_name_map["cac_stats"] = "cac-stats"
                                        self._children_yang_names.add("cac-stats")

                                        self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy()
                                        self.child_policy.parent = self
                                        self._children_name_map["child_policy"] = "child-policy"
                                        self._children_yang_names.add("child-policy")

                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.GeneralStats()
                                        self.general_stats.parent = self
                                        self._children_name_map["general_stats"] = "general-stats"
                                        self._children_yang_names.add("general-stats")

                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.IphcStats()
                                        self.iphc_stats.parent = self
                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                        self._children_yang_names.add("iphc-stats")

                                        self.police_stats_array = YList(self)
                                        self.queue_stats_array = YList(self)
                                        self.wred_stats_array = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("cac_state",
                                                        "class_name",
                                                        "counter_validity_bitmask",
                                                        "queue_descr",
                                                        "shared_queue_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                    class GeneralStats(Entity):
                                        """
                                        general stats
                                        
                                        .. attribute:: match_data_rate
                                        
                                        	Incoming matched data rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: pre_policy_matched_bytes
                                        
                                        	Matched bytes before applying policy
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: pre_policy_matched_packets
                                        
                                        	Matched pkts before applying policy
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: total_drop_bytes
                                        
                                        	Dropped bytes (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_packets
                                        
                                        	Dropped packets (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_rate
                                        
                                        	Total drop rate (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_transmit_rate
                                        
                                        	Total transmit rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: transmit_bytes
                                        
                                        	Transmitted bytes (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: transmit_packets
                                        
                                        	Transmitted packets (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                            self.yang_name = "general-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("match_data_rate",
                                                            "pre_policy_matched_bytes",
                                                            "pre_policy_matched_packets",
                                                            "total_drop_bytes",
                                                            "total_drop_packets",
                                                            "total_drop_rate",
                                                            "total_transmit_rate",
                                                            "transmit_bytes",
                                                            "transmit_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.match_data_rate.is_set or
                                                self.pre_policy_matched_bytes.is_set or
                                                self.pre_policy_matched_packets.is_set or
                                                self.total_drop_bytes.is_set or
                                                self.total_drop_packets.is_set or
                                                self.total_drop_rate.is_set or
                                                self.total_transmit_rate.is_set or
                                                self.transmit_bytes.is_set or
                                                self.transmit_packets.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                self.transmit_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "general-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "match-data-rate"):
                                                self.match_data_rate = value
                                                self.match_data_rate.value_namespace = name_space
                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pre-policy-matched-bytes"):
                                                self.pre_policy_matched_bytes = value
                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pre-policy-matched-packets"):
                                                self.pre_policy_matched_packets = value
                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-bytes"):
                                                self.total_drop_bytes = value
                                                self.total_drop_bytes.value_namespace = name_space
                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-packets"):
                                                self.total_drop_packets = value
                                                self.total_drop_packets.value_namespace = name_space
                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-rate"):
                                                self.total_drop_rate = value
                                                self.total_drop_rate.value_namespace = name_space
                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-transmit-rate"):
                                                self.total_transmit_rate = value
                                                self.total_transmit_rate.value_namespace = name_space
                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "transmit-bytes"):
                                                self.transmit_bytes = value
                                                self.transmit_bytes.value_namespace = name_space
                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "transmit-packets"):
                                                self.transmit_packets = value
                                                self.transmit_packets.value_namespace = name_space
                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                    class IphcStats(Entity):
                                        """
                                        IPHC stats
                                        
                                        .. attribute:: non_tcp_bytes_saved
                                        
                                        	Non Tcp Bytes saved due to compression
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_bytes_sent_rate
                                        
                                        	Compressed Non Tcp Bytes sent rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_compressed_packets_out
                                        
                                        	Num of non tcp compressed pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: non_tcp_full_header_packets_out
                                        
                                        	Num of non tcp fullheader pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: non_tcp_total_out_bytes
                                        
                                        	TotalNum of Non Tcp Bytes sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_total_out_packets
                                        
                                        	TotalNum of Non tcp pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_bytes_saved
                                        
                                        	Tcp Bytes saved due to compression
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_bytes_sent_rate
                                        
                                        	Compressed Tcp Bytes sent rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_compressed_packets_out
                                        
                                        	Num of tcp compressed pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_full_header_packets_out
                                        
                                        	Num of tcp fullheader pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_total_out_bytes
                                        
                                        	TotalNum of Tcp Bytes sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_total_out_packets
                                        
                                        	Total Num of tcp pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                            self.yang_name = "iphc-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("non_tcp_bytes_saved",
                                                            "non_tcp_bytes_sent_rate",
                                                            "non_tcp_compressed_packets_out",
                                                            "non_tcp_full_header_packets_out",
                                                            "non_tcp_total_out_bytes",
                                                            "non_tcp_total_out_packets",
                                                            "tcp_bytes_saved",
                                                            "tcp_bytes_sent_rate",
                                                            "tcp_compressed_packets_out",
                                                            "tcp_full_header_packets_out",
                                                            "tcp_total_out_bytes",
                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.non_tcp_bytes_saved.is_set or
                                                self.non_tcp_bytes_sent_rate.is_set or
                                                self.non_tcp_compressed_packets_out.is_set or
                                                self.non_tcp_full_header_packets_out.is_set or
                                                self.non_tcp_total_out_bytes.is_set or
                                                self.non_tcp_total_out_packets.is_set or
                                                self.tcp_bytes_saved.is_set or
                                                self.tcp_bytes_sent_rate.is_set or
                                                self.tcp_compressed_packets_out.is_set or
                                                self.tcp_full_header_packets_out.is_set or
                                                self.tcp_total_out_bytes.is_set or
                                                self.tcp_total_out_packets.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "iphc-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "non-tcp-bytes-saved"):
                                                self.non_tcp_bytes_saved = value
                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                self.non_tcp_bytes_sent_rate = value
                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                self.non_tcp_compressed_packets_out = value
                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                self.non_tcp_full_header_packets_out = value
                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-total-out-bytes"):
                                                self.non_tcp_total_out_bytes = value
                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-total-out-packets"):
                                                self.non_tcp_total_out_packets = value
                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-bytes-saved"):
                                                self.tcp_bytes_saved = value
                                                self.tcp_bytes_saved.value_namespace = name_space
                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-bytes-sent-rate"):
                                                self.tcp_bytes_sent_rate = value
                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-compressed-packets-out"):
                                                self.tcp_compressed_packets_out = value
                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-full-header-packets-out"):
                                                self.tcp_full_header_packets_out = value
                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-total-out-bytes"):
                                                self.tcp_total_out_bytes = value
                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-total-out-packets"):
                                                self.tcp_total_out_packets = value
                                                self.tcp_total_out_packets.value_namespace = name_space
                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                    class ChildPolicy(Entity):
                                        """
                                        child policy
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                            self.yang_name = "child-policy"
                                            self.yang_parent_name = "class-stats"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "child-policy"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "child-policy" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix


                                    class CacStats(Entity):
                                        """
                                        bag for cac stats
                                        
                                        .. attribute:: admit_bytes
                                        
                                        	Admitted bytes (pkts/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: admit_rates
                                        
                                        	CAC admit rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: admitpackets
                                        
                                        	Admitted packets (pkts/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_bytes
                                        
                                        	CAC dropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_packets
                                        
                                        	CAC dropped packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: drop_rates
                                        
                                        	CAC dropped rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.CacStats, self).__init__()

                                            self.yang_name = "cac-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("admit_bytes",
                                                            "admit_rates",
                                                            "admitpackets",
                                                            "drop_bytes",
                                                            "drop_packets",
                                                            "drop_rates") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.admit_bytes.is_set or
                                                self.admit_rates.is_set or
                                                self.admitpackets.is_set or
                                                self.drop_bytes.is_set or
                                                self.drop_packets.is_set or
                                                self.drop_rates.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                self.admit_rates.yfilter != YFilter.not_set or
                                                self.admitpackets.yfilter != YFilter.not_set or
                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                self.drop_packets.yfilter != YFilter.not_set or
                                                self.drop_rates.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "cac-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "admit-bytes"):
                                                self.admit_bytes = value
                                                self.admit_bytes.value_namespace = name_space
                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "admit-rates"):
                                                self.admit_rates = value
                                                self.admit_rates.value_namespace = name_space
                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                            if(value_path == "admitpackets"):
                                                self.admitpackets = value
                                                self.admitpackets.value_namespace = name_space
                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-bytes"):
                                                self.drop_bytes = value
                                                self.drop_bytes.value_namespace = name_space
                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-packets"):
                                                self.drop_packets = value
                                                self.drop_packets.value_namespace = name_space
                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-rates"):
                                                self.drop_rates = value
                                                self.drop_rates.value_namespace = name_space
                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                    class QueueStatsArray(Entity):
                                        """
                                        array of queue stats
                                        
                                        .. attribute:: atm_clp0_drop_bytes
                                        
                                        	ATP CLP 0 matched bytes dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: atm_clp0_drop_packets
                                        
                                        	ATP CLP 0 matched packets dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: atm_clp1_drop_bytes
                                        
                                        	ATP CLP 0 matched bytes dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: atm_clp1_drop_packets
                                        
                                        	ATP CLP 0 matched packets dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_bytes
                                        
                                        	Bytes that conform to the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_packets
                                        
                                        	Packets that conform  to the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_rate
                                        
                                        	Conform rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: exceed_bytes
                                        
                                        	Bytes that exceed  the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_packets
                                        
                                        	Packets that exceed the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_rate
                                        
                                        	Exceed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: forced_wred_stats_display
                                        
                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                        	**type**\:  bool
                                        
                                        .. attribute:: max_threshold_bytes
                                        
                                        	Dropped bytes with the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: max_threshold_packets
                                        
                                        	Dropped packets with the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: queue_average_length
                                        
                                        	Queue average length
                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                        
                                        .. attribute:: queue_drop_threshold
                                        
                                        	tail drop threshold of the queue in bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: queue_id
                                        
                                        	Queue Id used for Fabric Stats
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_instance_length
                                        
                                        	Queue instance length
                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                        
                                        .. attribute:: queue_max_length
                                        
                                        	Queue maximum length
                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                        
                                        .. attribute:: random_drop_bytes
                                        
                                        	Bytes probabilistically dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: random_drop_packets
                                        
                                        	Packets probabilistically dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tail_drop_bytes
                                        
                                        	Bytes tail dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tail_drop_packets
                                        
                                        	Packets tail dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                            self.yang_name = "queue-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                            self.queue_average_length = YList(self)
                                            self.queue_instance_length = YList(self)
                                            self.queue_max_length = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("atm_clp0_drop_bytes",
                                                            "atm_clp0_drop_packets",
                                                            "atm_clp1_drop_bytes",
                                                            "atm_clp1_drop_packets",
                                                            "conform_bytes",
                                                            "conform_packets",
                                                            "conform_rate",
                                                            "exceed_bytes",
                                                            "exceed_packets",
                                                            "exceed_rate",
                                                            "forced_wred_stats_display",
                                                            "max_threshold_bytes",
                                                            "max_threshold_packets",
                                                            "queue_drop_threshold",
                                                            "queue_id",
                                                            "random_drop_bytes",
                                                            "random_drop_packets",
                                                            "tail_drop_bytes",
                                                            "tail_drop_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                        class QueueInstanceLength(Entity):
                                            """
                                            Queue instance length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                self.yang_name = "queue-instance-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-instance-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class QueueAverageLength(Entity):
                                            """
                                            Queue average length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                self.yang_name = "queue-average-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-average-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class QueueMaxLength(Entity):
                                            """
                                            Queue maximum length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                self.yang_name = "queue-max-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-max-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.queue_average_length:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_instance_length:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_max_length:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.atm_clp0_drop_bytes.is_set or
                                                self.atm_clp0_drop_packets.is_set or
                                                self.atm_clp1_drop_bytes.is_set or
                                                self.atm_clp1_drop_packets.is_set or
                                                self.conform_bytes.is_set or
                                                self.conform_packets.is_set or
                                                self.conform_rate.is_set or
                                                self.exceed_bytes.is_set or
                                                self.exceed_packets.is_set or
                                                self.exceed_rate.is_set or
                                                self.forced_wred_stats_display.is_set or
                                                self.max_threshold_bytes.is_set or
                                                self.max_threshold_packets.is_set or
                                                self.queue_drop_threshold.is_set or
                                                self.queue_id.is_set or
                                                self.random_drop_bytes.is_set or
                                                self.random_drop_packets.is_set or
                                                self.tail_drop_bytes.is_set or
                                                self.tail_drop_packets.is_set)

                                        def has_operation(self):
                                            for c in self.queue_average_length:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_instance_length:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_max_length:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_packets.yfilter != YFilter.not_set or
                                                self.conform_rate.yfilter != YFilter.not_set or
                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                self.queue_id.yfilter != YFilter.not_set or
                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "queue-average-length"):
                                                for c in self.queue_average_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_average_length.append(c)
                                                return c

                                            if (child_yang_name == "queue-instance-length"):
                                                for c in self.queue_instance_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_instance_length.append(c)
                                                return c

                                            if (child_yang_name == "queue-max-length"):
                                                for c in self.queue_max_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_max_length.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "atm-clp0-drop-bytes"):
                                                self.atm_clp0_drop_bytes = value
                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp0-drop-packets"):
                                                self.atm_clp0_drop_packets = value
                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp1-drop-bytes"):
                                                self.atm_clp1_drop_bytes = value
                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp1-drop-packets"):
                                                self.atm_clp1_drop_packets = value
                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-bytes"):
                                                self.conform_bytes = value
                                                self.conform_bytes.value_namespace = name_space
                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-packets"):
                                                self.conform_packets = value
                                                self.conform_packets.value_namespace = name_space
                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-rate"):
                                                self.conform_rate = value
                                                self.conform_rate.value_namespace = name_space
                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-bytes"):
                                                self.exceed_bytes = value
                                                self.exceed_bytes.value_namespace = name_space
                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-packets"):
                                                self.exceed_packets = value
                                                self.exceed_packets.value_namespace = name_space
                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-rate"):
                                                self.exceed_rate = value
                                                self.exceed_rate.value_namespace = name_space
                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forced-wred-stats-display"):
                                                self.forced_wred_stats_display = value
                                                self.forced_wred_stats_display.value_namespace = name_space
                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-bytes"):
                                                self.max_threshold_bytes = value
                                                self.max_threshold_bytes.value_namespace = name_space
                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-packets"):
                                                self.max_threshold_packets = value
                                                self.max_threshold_packets.value_namespace = name_space
                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-drop-threshold"):
                                                self.queue_drop_threshold = value
                                                self.queue_drop_threshold.value_namespace = name_space
                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-id"):
                                                self.queue_id = value
                                                self.queue_id.value_namespace = name_space
                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-bytes"):
                                                self.random_drop_bytes = value
                                                self.random_drop_bytes.value_namespace = name_space
                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-packets"):
                                                self.random_drop_packets = value
                                                self.random_drop_packets.value_namespace = name_space
                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tail-drop-bytes"):
                                                self.tail_drop_bytes = value
                                                self.tail_drop_bytes.value_namespace = name_space
                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tail-drop-packets"):
                                                self.tail_drop_packets = value
                                                self.tail_drop_packets.value_namespace = name_space
                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                    class PoliceStatsArray(Entity):
                                        """
                                        array of police stats
                                        
                                        .. attribute:: color_class_stats
                                        
                                        	color class stats
                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                        
                                        .. attribute:: conform_bytes
                                        
                                        	Bytes that conform to the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_packets
                                        
                                        	Packets that conform  to the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_rate
                                        
                                        	Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: drop_bytes
                                        
                                        	Police dropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_packets
                                        
                                        	Police dropped packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_bytes
                                        
                                        	Bytes that exceed  the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_packets
                                        
                                        	Packets that exceed the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_rate
                                        
                                        	Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: parent_drop_bytes
                                        
                                        	Dropped bytes by the parent policer
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: parent_drop_packets
                                        
                                        	Dropped pkts by the parent policer
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_bytes
                                        
                                        	Bytes that violate the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_packets
                                        
                                        	Packets violating the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_rate
                                        
                                        	Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                            self.yang_name = "police-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                            self.color_class_stats.parent = self
                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                            self._children_yang_names.add("color-class-stats")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_bytes",
                                                            "conform_packets",
                                                            "conform_rate",
                                                            "drop_bytes",
                                                            "drop_packets",
                                                            "exceed_bytes",
                                                            "exceed_packets",
                                                            "exceed_rate",
                                                            "parent_drop_bytes",
                                                            "parent_drop_packets",
                                                            "violate_bytes",
                                                            "violate_packets",
                                                            "violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                        class ColorClassStats(Entity):
                                            """
                                            color class stats
                                            
                                            .. attribute:: conform_class_conform_bytes
                                            
                                            	Bytes with classification result conform and policer result conform
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_conform_packets
                                            
                                            	Packets with classification result conform and policer result conform
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_conform_rate
                                            
                                            	Conform Class Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: conform_class_exceed_bytes
                                            
                                            	Bytes with classification result conform and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_exceed_packets
                                            
                                            	Packets with classification result conform and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_exceed_rate
                                            
                                            	Conform Class Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: conform_class_violate_bytes
                                            
                                            	Bytes with classification result conform and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_violate_packets
                                            
                                            	Packets with classification result conform and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_violate_rate
                                            
                                            	Conform Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_class_exceed_bytes
                                            
                                            	Bytes with classification result exceed and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_class_exceed_packets
                                            
                                            	Packets with classification result exceed and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_class_exceed_rate
                                            
                                            	Exceed Class Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_class_violate_bytes
                                            
                                            	Bytes with classification result exceed and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_class_violate_packets
                                            
                                            	Packets with classification result exceed and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_class_violate_rate
                                            
                                            	Exceed Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_class_violate_bytes
                                            
                                            	Bytes with classification result violate and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_class_violate_packets
                                            
                                            	Packets with classification result violate and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_class_violate_rate
                                            
                                            	Violate Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                self.yang_name = "color-class-stats"
                                                self.yang_parent_name = "police-stats-array"

                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_class_conform_bytes",
                                                                "conform_class_conform_packets",
                                                                "conform_class_conform_rate",
                                                                "conform_class_exceed_bytes",
                                                                "conform_class_exceed_packets",
                                                                "conform_class_exceed_rate",
                                                                "conform_class_violate_bytes",
                                                                "conform_class_violate_packets",
                                                                "conform_class_violate_rate",
                                                                "exceed_class_exceed_bytes",
                                                                "exceed_class_exceed_packets",
                                                                "exceed_class_exceed_rate",
                                                                "exceed_class_violate_bytes",
                                                                "exceed_class_violate_packets",
                                                                "exceed_class_violate_rate",
                                                                "violate_class_violate_bytes",
                                                                "violate_class_violate_packets",
                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.conform_class_conform_bytes.is_set or
                                                    self.conform_class_conform_packets.is_set or
                                                    self.conform_class_conform_rate.is_set or
                                                    self.conform_class_exceed_bytes.is_set or
                                                    self.conform_class_exceed_packets.is_set or
                                                    self.conform_class_exceed_rate.is_set or
                                                    self.conform_class_violate_bytes.is_set or
                                                    self.conform_class_violate_packets.is_set or
                                                    self.conform_class_violate_rate.is_set or
                                                    self.exceed_class_exceed_bytes.is_set or
                                                    self.exceed_class_exceed_packets.is_set or
                                                    self.exceed_class_exceed_rate.is_set or
                                                    self.exceed_class_violate_bytes.is_set or
                                                    self.exceed_class_violate_packets.is_set or
                                                    self.exceed_class_violate_rate.is_set or
                                                    self.violate_class_violate_bytes.is_set or
                                                    self.violate_class_violate_packets.is_set or
                                                    self.violate_class_violate_rate.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "color-class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-class-conform-bytes"):
                                                    self.conform_class_conform_bytes = value
                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-conform-packets"):
                                                    self.conform_class_conform_packets = value
                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-conform-rate"):
                                                    self.conform_class_conform_rate = value
                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-bytes"):
                                                    self.conform_class_exceed_bytes = value
                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-packets"):
                                                    self.conform_class_exceed_packets = value
                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-rate"):
                                                    self.conform_class_exceed_rate = value
                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-bytes"):
                                                    self.conform_class_violate_bytes = value
                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-packets"):
                                                    self.conform_class_violate_packets = value
                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-rate"):
                                                    self.conform_class_violate_rate = value
                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-bytes"):
                                                    self.exceed_class_exceed_bytes = value
                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-packets"):
                                                    self.exceed_class_exceed_packets = value
                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-rate"):
                                                    self.exceed_class_exceed_rate = value
                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-bytes"):
                                                    self.exceed_class_violate_bytes = value
                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-packets"):
                                                    self.exceed_class_violate_packets = value
                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-rate"):
                                                    self.exceed_class_violate_rate = value
                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-bytes"):
                                                    self.violate_class_violate_bytes = value
                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-packets"):
                                                    self.violate_class_violate_packets = value
                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-rate"):
                                                    self.violate_class_violate_rate = value
                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.conform_bytes.is_set or
                                                self.conform_packets.is_set or
                                                self.conform_rate.is_set or
                                                self.drop_bytes.is_set or
                                                self.drop_packets.is_set or
                                                self.exceed_bytes.is_set or
                                                self.exceed_packets.is_set or
                                                self.exceed_rate.is_set or
                                                self.parent_drop_bytes.is_set or
                                                self.parent_drop_packets.is_set or
                                                self.violate_bytes.is_set or
                                                self.violate_packets.is_set or
                                                self.violate_rate.is_set or
                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_packets.yfilter != YFilter.not_set or
                                                self.conform_rate.yfilter != YFilter.not_set or
                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                self.drop_packets.yfilter != YFilter.not_set or
                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_packets.yfilter != YFilter.not_set or
                                                self.violate_rate.yfilter != YFilter.not_set or
                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "police-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "color-class-stats"):
                                                if (self.color_class_stats is None):
                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                return self.color_class_stats

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-bytes"):
                                                self.conform_bytes = value
                                                self.conform_bytes.value_namespace = name_space
                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-packets"):
                                                self.conform_packets = value
                                                self.conform_packets.value_namespace = name_space
                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-rate"):
                                                self.conform_rate = value
                                                self.conform_rate.value_namespace = name_space
                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-bytes"):
                                                self.drop_bytes = value
                                                self.drop_bytes.value_namespace = name_space
                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-packets"):
                                                self.drop_packets = value
                                                self.drop_packets.value_namespace = name_space
                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-bytes"):
                                                self.exceed_bytes = value
                                                self.exceed_bytes.value_namespace = name_space
                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-packets"):
                                                self.exceed_packets = value
                                                self.exceed_packets.value_namespace = name_space
                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-rate"):
                                                self.exceed_rate = value
                                                self.exceed_rate.value_namespace = name_space
                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "parent-drop-bytes"):
                                                self.parent_drop_bytes = value
                                                self.parent_drop_bytes.value_namespace = name_space
                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "parent-drop-packets"):
                                                self.parent_drop_packets = value
                                                self.parent_drop_packets.value_namespace = name_space
                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-bytes"):
                                                self.violate_bytes = value
                                                self.violate_bytes.value_namespace = name_space
                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-packets"):
                                                self.violate_packets = value
                                                self.violate_packets.value_namespace = name_space
                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-rate"):
                                                self.violate_rate = value
                                                self.violate_rate.value_namespace = name_space
                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                    class WredStatsArray(Entity):
                                        """
                                        array of red stats
                                        
                                        .. attribute:: max_threshold_bytes
                                        
                                        	Dropped bytes with  the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: max_threshold_packets
                                        
                                        	Dropped packets with  the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: profile_title
                                        
                                        	ProfileTitle
                                        	**type**\:  str
                                        
                                        	**length:** 0..300
                                        
                                        .. attribute:: random_drop_bytes
                                        
                                        	Probabilisticallydropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: random_drop_packets
                                        
                                        	Probabilistically dropped  packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: red_ecn_marked_bytes
                                        
                                        	ECN marked bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: red_ecn_marked_packets
                                        
                                        	ECN marked packets 
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: red_label
                                        
                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                        
                                        .. attribute:: red_transmit_bytes
                                        
                                        	Transmitted bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: red_transmit_packets
                                        
                                        	Transmitted packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                            self.yang_name = "wred-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                            self.red_label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("max_threshold_bytes",
                                                            "max_threshold_packets",
                                                            "profile_title",
                                                            "random_drop_bytes",
                                                            "random_drop_packets",
                                                            "red_ecn_marked_bytes",
                                                            "red_ecn_marked_packets",
                                                            "red_transmit_bytes",
                                                            "red_transmit_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                        class RedLabel(Entity):
                                            """
                                            Array of WRED Typevalues as in PRP stats is
                                            available per threshold   
                                            
                                            .. attribute:: value
                                            
                                            	WRED value for this type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: wred_type
                                            
                                            	WRED type DSCP, EXP, PREC etc
                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                self.yang_name = "red-label"
                                                self.yang_parent_name = "wred-stats-array"

                                                self.value = YLeaf(YType.uint8, "value")

                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("value",
                                                                "wred_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.value.is_set or
                                                    self.wred_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set or
                                                    self.wred_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "red-label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "value" or name == "wred-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "wred-type"):
                                                    self.wred_type = value
                                                    self.wred_type.value_namespace = name_space
                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.red_label:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.max_threshold_bytes.is_set or
                                                self.max_threshold_packets.is_set or
                                                self.profile_title.is_set or
                                                self.random_drop_bytes.is_set or
                                                self.random_drop_packets.is_set or
                                                self.red_ecn_marked_bytes.is_set or
                                                self.red_ecn_marked_packets.is_set or
                                                self.red_transmit_bytes.is_set or
                                                self.red_transmit_packets.is_set)

                                        def has_operation(self):
                                            for c in self.red_label:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                self.profile_title.yfilter != YFilter.not_set or
                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wred-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "red-label"):
                                                for c in self.red_label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.red_label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "max-threshold-bytes"):
                                                self.max_threshold_bytes = value
                                                self.max_threshold_bytes.value_namespace = name_space
                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-packets"):
                                                self.max_threshold_packets = value
                                                self.max_threshold_packets.value_namespace = name_space
                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-title"):
                                                self.profile_title = value
                                                self.profile_title.value_namespace = name_space
                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-bytes"):
                                                self.random_drop_bytes = value
                                                self.random_drop_bytes.value_namespace = name_space
                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-packets"):
                                                self.random_drop_packets = value
                                                self.random_drop_packets.value_namespace = name_space
                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-ecn-marked-bytes"):
                                                self.red_ecn_marked_bytes = value
                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-ecn-marked-packets"):
                                                self.red_ecn_marked_packets = value
                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-transmit-bytes"):
                                                self.red_transmit_bytes = value
                                                self.red_transmit_bytes.value_namespace = name_space
                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-transmit-packets"):
                                                self.red_transmit_packets = value
                                                self.red_transmit_packets.value_namespace = name_space
                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.police_stats_array:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_stats_array:
                                            if (c.has_data()):
                                                return True
                                        for c in self.wred_stats_array:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.cac_state.is_set or
                                            self.class_name.is_set or
                                            self.counter_validity_bitmask.is_set or
                                            self.queue_descr.is_set or
                                            self.shared_queue_id.is_set or
                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                            (self.child_policy is not None and self.child_policy.has_data()) or
                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                    def has_operation(self):
                                        for c in self.police_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.wred_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.cac_state.yfilter != YFilter.not_set or
                                            self.class_name.yfilter != YFilter.not_set or
                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                            self.queue_descr.yfilter != YFilter.not_set or
                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                            (self.child_policy is not None and self.child_policy.has_operation()) or
                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "class-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "cac-stats"):
                                            if (self.cac_stats is None):
                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                            return self.cac_stats

                                        if (child_yang_name == "child-policy"):
                                            if (self.child_policy is None):
                                                self.child_policy = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                            return self.child_policy

                                        if (child_yang_name == "general-stats"):
                                            if (self.general_stats is None):
                                                self.general_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                            return self.general_stats

                                        if (child_yang_name == "iphc-stats"):
                                            if (self.iphc_stats is None):
                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                            return self.iphc_stats

                                        if (child_yang_name == "police-stats-array"):
                                            for c in self.police_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.PoliceStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.police_stats_array.append(c)
                                            return c

                                        if (child_yang_name == "queue-stats-array"):
                                            for c in self.queue_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.QueueStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_stats_array.append(c)
                                            return c

                                        if (child_yang_name == "wred-stats-array"):
                                            for c in self.wred_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats.WredStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.wred_stats_array.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "cac-state"):
                                            self.cac_state = value
                                            self.cac_state.value_namespace = name_space
                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "class-name"):
                                            self.class_name = value
                                            self.class_name.value_namespace = name_space
                                            self.class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "counter-validity-bitmask"):
                                            self.counter_validity_bitmask = value
                                            self.counter_validity_bitmask.value_namespace = name_space
                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-descr"):
                                            self.queue_descr = value
                                            self.queue_descr.value_namespace = name_space
                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "shared-queue-id"):
                                            self.shared_queue_id = value
                                            self.shared_queue_id.value_namespace = name_space
                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.class_stats:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.policy_name.is_set or
                                        self.satid.is_set or
                                        self.state.is_set or
                                        self.state_description.is_set)

                                def has_operation(self):
                                    for c in self.class_stats:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.policy_name.yfilter != YFilter.not_set or
                                        self.satid.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_description.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "statistics" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "class-stats"):
                                        for c in self.class_stats:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics.ClassStats()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.class_stats.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "policy-name"):
                                        self.policy_name = value
                                        self.policy_name.value_namespace = name_space
                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "satid"):
                                        self.satid = value
                                        self.satid.value_namespace = name_space
                                        self.satid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-description"):
                                        self.state_description = value
                                        self.state_description.value_namespace = name_space
                                        self.state_description.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                    (self.statistics is not None and self.statistics.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                    (self.statistics is not None and self.statistics.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "output" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-names"):
                                    if (self.service_policy_names is None):
                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                    return self.service_policy_names

                                if (child_yang_name == "statistics"):
                                    if (self.statistics is None):
                                        self.statistics = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                    return self.statistics

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-names" or name == "statistics"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.spi_name.is_set or
                                (self.input is not None and self.input.has_data()) or
                                (self.member_interfaces is not None and self.member_interfaces.has_data()) or
                                (self.output is not None and self.output.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.spi_name.yfilter != YFilter.not_set or
                                (self.input is not None and self.input.has_operation()) or
                                (self.member_interfaces is not None and self.member_interfaces.has_operation()) or
                                (self.output is not None and self.output.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "shared-policy-instance" + "[spi-name='" + self.spi_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.spi_name.is_set or self.spi_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.spi_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "input"):
                                if (self.input is None):
                                    self.input = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Input()
                                    self.input.parent = self
                                    self._children_name_map["input"] = "input"
                                return self.input

                            if (child_yang_name == "member-interfaces"):
                                if (self.member_interfaces is None):
                                    self.member_interfaces = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.MemberInterfaces()
                                    self.member_interfaces.parent = self
                                    self._children_name_map["member_interfaces"] = "member-interfaces"
                                return self.member_interfaces

                            if (child_yang_name == "output"):
                                if (self.output is None):
                                    self.output = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance.Output()
                                    self.output.parent = self
                                    self._children_name_map["output"] = "output"
                                return self.output

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "input" or name == "member-interfaces" or name == "output" or name == "spi-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "spi-name"):
                                self.spi_name = value
                                self.spi_name.value_namespace = name_space
                                self.spi_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.shared_policy_instance:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.shared_policy_instance:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "shared-policy-instances" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "shared-policy-instance"):
                            for c in self.shared_policy_instance:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances.SharedPolicyInstance()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.shared_policy_instance.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "shared-policy-instance"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class InterfaceTable(Entity):
                    """
                    Operational data for all interfaces
                    
                    .. attribute:: interface
                    
                    	QoS policy\-map operational data for a particular interface
                    	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable, self).__init__()

                        self.yang_name = "interface-table"
                        self.yang_parent_name = "policy-map"

                        self.interface = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable, self).__setattr__(name, value)


                    class Interface(Entity):
                        """
                        QoS policy\-map operational data for a particular
                        interface
                        
                        .. attribute:: interface_name  <key>
                        
                        	Name of the interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: input
                        
                        	A piece of QoS policy\-map operational data for an interface
                        	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input>`
                        
                        .. attribute:: member_interfaces
                        
                        	QoS policy\-map member interface table
                        	**type**\:   :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces>`
                        
                        .. attribute:: nodes
                        
                        	QoS policy\-map node table
                        	**type**\:   :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes>`
                        
                        .. attribute:: output
                        
                        	A piece of QoS policy\-map operational data for an interface
                        	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output>`
                        
                        .. attribute:: satellite_ids
                        
                        	Satellite ID information
                        	**type**\:   :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface, self).__init__()

                            self.yang_name = "interface"
                            self.yang_parent_name = "interface-table"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input()
                            self.input.parent = self
                            self._children_name_map["input"] = "input"
                            self._children_yang_names.add("input")

                            self.member_interfaces = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces()
                            self.member_interfaces.parent = self
                            self._children_name_map["member_interfaces"] = "member-interfaces"
                            self._children_yang_names.add("member-interfaces")

                            self.nodes = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes()
                            self.nodes.parent = self
                            self._children_name_map["nodes"] = "nodes"
                            self._children_yang_names.add("nodes")

                            self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output()
                            self.output.parent = self
                            self._children_name_map["output"] = "output"
                            self._children_yang_names.add("output")

                            self.satellite_ids = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds()
                            self.satellite_ids.parent = self
                            self._children_name_map["satellite_ids"] = "satellite-ids"
                            self._children_yang_names.add("satellite-ids")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface, self).__setattr__(name, value)


                        class Nodes(Entity):
                            """
                            QoS policy\-map node table
                            
                            .. attribute:: node
                            
                            	QoS operational data for a particular node
                            	**type**\: list of    :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes, self).__init__()

                                self.yang_name = "nodes"
                                self.yang_parent_name = "interface"

                                self.node = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes, self).__setattr__(name, value)


                            class Node(Entity):
                                """
                                QoS operational data for a particular node
                                
                                .. attribute:: node_name  <key>
                                
                                	The node
                                	**type**\:  str
                                
                                	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
                                
                                .. attribute:: input
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input>`
                                
                                .. attribute:: output
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node, self).__init__()

                                    self.yang_name = "node"
                                    self.yang_parent_name = "nodes"

                                    self.node_name = YLeaf(YType.str, "node-name")

                                    self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input()
                                    self.input.parent = self
                                    self._children_name_map["input"] = "input"
                                    self._children_yang_names.add("input")

                                    self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output()
                                    self.output.parent = self
                                    self._children_name_map["output"] = "output"
                                    self._children_yang_names.add("output")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("node_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node, self).__setattr__(name, value)


                                class Input(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames>`
                                    
                                    .. attribute:: statistics
                                    
                                    	Policy\-map statistics operational data for an interface
                                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input, self).__init__()

                                        self.yang_name = "input"
                                        self.yang_parent_name = "node"

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._children_yang_names.add("service-policy-names")

                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                        self._children_yang_names.add("statistics")


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "input"

                                            self.service_policy_instance = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, self).__setattr__(name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  <key>
                                            
                                            	Name of the policy instance
                                            	**type**\:  str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"

                                                self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("service_policy_name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.service_policy_name.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.service_policy_name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "service-policy-name"):
                                                    self.service_policy_name = value
                                                    self.service_policy_name.value_namespace = name_space
                                                    self.service_policy_name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-names" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "service-policy-instance"):
                                                for c in self.service_policy_instance:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.service_policy_instance.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-instance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Statistics(Entity):
                                        """
                                        Policy\-map statistics operational data for an
                                        interface
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics, self).__init__()

                                            self.yang_name = "statistics"
                                            self.yang_parent_name = "input"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "statistics"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                                self._children_yang_names.add("child-policy")

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "child-policy" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.child_policy is not None and self.child_policy.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.child_policy is not None and self.child_policy.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "child-policy"):
                                                    if (self.child_policy is None):
                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                    return self.child_policy

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "statistics" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                            (self.statistics is not None and self.statistics.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                            (self.statistics is not None and self.statistics.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "input" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-names"):
                                            if (self.service_policy_names is None):
                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                            return self.service_policy_names

                                        if (child_yang_name == "statistics"):
                                            if (self.statistics is None):
                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                            return self.statistics

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-names" or name == "statistics"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Output(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames>`
                                    
                                    .. attribute:: statistics
                                    
                                    	Policy\-map statistics operational data for an interface
                                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output, self).__init__()

                                        self.yang_name = "output"
                                        self.yang_parent_name = "node"

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._children_yang_names.add("service-policy-names")

                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                        self._children_yang_names.add("statistics")


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "output"

                                            self.service_policy_instance = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, self).__setattr__(name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  <key>
                                            
                                            	Name of the policy instance
                                            	**type**\:  str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"

                                                self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("service_policy_name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.service_policy_name.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.service_policy_name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "service-policy-name"):
                                                    self.service_policy_name = value
                                                    self.service_policy_name.value_namespace = name_space
                                                    self.service_policy_name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-names" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "service-policy-instance"):
                                                for c in self.service_policy_instance:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.service_policy_instance.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-instance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Statistics(Entity):
                                        """
                                        Policy\-map statistics operational data for an
                                        interface
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics, self).__init__()

                                            self.yang_name = "statistics"
                                            self.yang_parent_name = "output"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "statistics"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                                self._children_yang_names.add("child-policy")

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "child-policy" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.child_policy is not None and self.child_policy.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.child_policy is not None and self.child_policy.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "child-policy"):
                                                    if (self.child_policy is None):
                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                    return self.child_policy

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "statistics" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                            (self.statistics is not None and self.statistics.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                            (self.statistics is not None and self.statistics.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "output" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-names"):
                                            if (self.service_policy_names is None):
                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                            return self.service_policy_names

                                        if (child_yang_name == "statistics"):
                                            if (self.statistics is None):
                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                            return self.statistics

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-names" or name == "statistics"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.node_name.is_set or
                                        (self.input is not None and self.input.has_data()) or
                                        (self.output is not None and self.output.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.node_name.yfilter != YFilter.not_set or
                                        (self.input is not None and self.input.has_operation()) or
                                        (self.output is not None and self.output.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "node" + "[node-name='" + self.node_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.node_name.is_set or self.node_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.node_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "input"):
                                        if (self.input is None):
                                            self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Input()
                                            self.input.parent = self
                                            self._children_name_map["input"] = "input"
                                        return self.input

                                    if (child_yang_name == "output"):
                                        if (self.output is None):
                                            self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node.Output()
                                            self.output.parent = self
                                            self._children_name_map["output"] = "output"
                                        return self.output

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "input" or name == "output" or name == "node-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "node-name"):
                                        self.node_name = value
                                        self.node_name.value_namespace = name_space
                                        self.node_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.node:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.node:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nodes" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "node"):
                                    for c in self.node:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes.Node()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.node.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "node"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class MemberInterfaces(Entity):
                            """
                            QoS policy\-map member interface table
                            
                            .. attribute:: member_interface
                            
                            	QoS policy\-map member interface statistics
                            	**type**\: list of    :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces, self).__init__()

                                self.yang_name = "member-interfaces"
                                self.yang_parent_name = "interface"

                                self.member_interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces, self).__setattr__(name, value)


                            class MemberInterface(Entity):
                                """
                                QoS policy\-map member interface statistics
                                
                                .. attribute:: interface_name  <key>
                                
                                	Name of member interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: input
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input>`
                                
                                .. attribute:: output
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output>`
                                
                                .. attribute:: satellite_ids
                                
                                	Satellite ID information
                                	**type**\:   :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface, self).__init__()

                                    self.yang_name = "member-interface"
                                    self.yang_parent_name = "member-interfaces"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input()
                                    self.input.parent = self
                                    self._children_name_map["input"] = "input"
                                    self._children_yang_names.add("input")

                                    self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output()
                                    self.output.parent = self
                                    self._children_name_map["output"] = "output"
                                    self._children_yang_names.add("output")

                                    self.satellite_ids = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds()
                                    self.satellite_ids.parent = self
                                    self._children_name_map["satellite_ids"] = "satellite-ids"
                                    self._children_yang_names.add("satellite-ids")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface, self).__setattr__(name, value)


                                class SatelliteIds(Entity):
                                    """
                                    Satellite ID information
                                    
                                    .. attribute:: satellite_id
                                    
                                    	Satellite ID information
                                    	**type**\: list of    :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, self).__init__()

                                        self.yang_name = "satellite-ids"
                                        self.yang_parent_name = "member-interface"

                                        self.satellite_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, self).__setattr__(name, value)


                                    class SatelliteId(Entity):
                                        """
                                        Satellite ID information
                                        
                                        .. attribute:: nv_satellite_id  <key>
                                        
                                        	Satellite ID
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: input
                                        
                                        	A piece of QoS policy\-map operational data for an interface
                                        	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input>`
                                        
                                        .. attribute:: output
                                        
                                        	A piece of QoS policy\-map operational data for an interface
                                        	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__init__()

                                            self.yang_name = "satellite-id"
                                            self.yang_parent_name = "satellite-ids"

                                            self.nv_satellite_id = YLeaf(YType.int32, "nv-satellite-id")

                                            self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                            self.input.parent = self
                                            self._children_name_map["input"] = "input"
                                            self._children_yang_names.add("input")

                                            self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                            self.output.parent = self
                                            self._children_name_map["output"] = "output"
                                            self._children_yang_names.add("output")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("nv_satellite_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__setattr__(name, value)


                                        class Input(Entity):
                                            """
                                            A piece of QoS policy\-map operational data for
                                            an interface
                                            
                                            .. attribute:: service_policy_names
                                            
                                            	Operational data for all Policy instance
                                            	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                                            
                                            .. attribute:: statistics
                                            
                                            	Policy\-map statistics operational data for an interface
                                            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, self).__init__()

                                                self.yang_name = "input"
                                                self.yang_parent_name = "satellite-id"

                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                                self._children_yang_names.add("service-policy-names")

                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                                self._children_yang_names.add("statistics")


                                            class ServicePolicyNames(Entity):
                                                """
                                                Operational data for all Policy instance
                                                
                                                .. attribute:: service_policy_instance
                                                
                                                	QoS policy\-map operational data for a particular Policy 
                                                	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                                    self.yang_name = "service-policy-names"
                                                    self.yang_parent_name = "input"

                                                    self.service_policy_instance = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)


                                                class ServicePolicyInstance(Entity):
                                                    """
                                                    QoS policy\-map operational data for a
                                                    particular Policy 
                                                    
                                                    .. attribute:: service_policy_name  <key>
                                                    
                                                    	Name of the policy instance
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                        self.yang_name = "service-policy-instance"
                                                        self.yang_parent_name = "service-policy-names"

                                                        self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("service_policy_name") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.service_policy_name.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.service_policy_name.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "service-policy-name"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "service-policy-name"):
                                                            self.service_policy_name = value
                                                            self.service_policy_name.value_namespace = name_space
                                                            self.service_policy_name.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.service_policy_instance:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.service_policy_instance:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "service-policy-names" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "service-policy-instance"):
                                                        for c in self.service_policy_instance:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.service_policy_instance.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "service-policy-instance"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class Statistics(Entity):
                                                """
                                                Policy\-map statistics operational data for an
                                                interface
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__init__()

                                                    self.yang_name = "statistics"
                                                    self.yang_parent_name = "input"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: child_policy
                                                    
                                                    	child policy
                                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "statistics"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                        self._children_yang_names.add("child-policy")

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class ChildPolicy(Entity):
                                                        """
                                                        child policy
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                            self.yang_name = "child-policy"
                                                            self.yang_parent_name = "class-stats"

                                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                                            self.satid = YLeaf(YType.uint32, "satid")

                                                            self.state = YLeaf(YType.enumeration, "state")

                                                            self.state_description = YLeaf(YType.str, "state-description")

                                                            self.class_stats = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("policy_name",
                                                                            "satid",
                                                                            "state",
                                                                            "state_description") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                        class ClassStats(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "child-policy"

                                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                                self._children_yang_names.add("cac-stats")

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                                self._children_yang_names.add("general-stats")

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                self._children_yang_names.add("iphc-stats")

                                                                self.police_stats_array = YList(self)
                                                                self.queue_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("cac_state",
                                                                                "class_name",
                                                                                "counter_validity_bitmask",
                                                                                "queue_descr",
                                                                                "shared_queue_id") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("match_data_rate",
                                                                                    "pre_policy_matched_bytes",
                                                                                    "pre_policy_matched_packets",
                                                                                    "total_drop_bytes",
                                                                                    "total_drop_packets",
                                                                                    "total_drop_rate",
                                                                                    "total_transmit_rate",
                                                                                    "transmit_bytes",
                                                                                    "transmit_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.match_data_rate.is_set or
                                                                        self.pre_policy_matched_bytes.is_set or
                                                                        self.pre_policy_matched_packets.is_set or
                                                                        self.total_drop_bytes.is_set or
                                                                        self.total_drop_packets.is_set or
                                                                        self.total_drop_rate.is_set or
                                                                        self.total_transmit_rate.is_set or
                                                                        self.transmit_bytes.is_set or
                                                                        self.transmit_packets.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "general-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "match-data-rate"):
                                                                        self.match_data_rate = value
                                                                        self.match_data_rate.value_namespace = name_space
                                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pre-policy-matched-bytes"):
                                                                        self.pre_policy_matched_bytes = value
                                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pre-policy-matched-packets"):
                                                                        self.pre_policy_matched_packets = value
                                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-drop-bytes"):
                                                                        self.total_drop_bytes = value
                                                                        self.total_drop_bytes.value_namespace = name_space
                                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-drop-packets"):
                                                                        self.total_drop_packets = value
                                                                        self.total_drop_packets.value_namespace = name_space
                                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-drop-rate"):
                                                                        self.total_drop_rate = value
                                                                        self.total_drop_rate.value_namespace = name_space
                                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-transmit-rate"):
                                                                        self.total_transmit_rate = value
                                                                        self.total_transmit_rate.value_namespace = name_space
                                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "transmit-bytes"):
                                                                        self.transmit_bytes = value
                                                                        self.transmit_bytes.value_namespace = name_space
                                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "transmit-packets"):
                                                                        self.transmit_packets = value
                                                                        self.transmit_packets.value_namespace = name_space
                                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("non_tcp_bytes_saved",
                                                                                    "non_tcp_bytes_sent_rate",
                                                                                    "non_tcp_compressed_packets_out",
                                                                                    "non_tcp_full_header_packets_out",
                                                                                    "non_tcp_total_out_bytes",
                                                                                    "non_tcp_total_out_packets",
                                                                                    "tcp_bytes_saved",
                                                                                    "tcp_bytes_sent_rate",
                                                                                    "tcp_compressed_packets_out",
                                                                                    "tcp_full_header_packets_out",
                                                                                    "tcp_total_out_bytes",
                                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.non_tcp_bytes_saved.is_set or
                                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                                        self.non_tcp_compressed_packets_out.is_set or
                                                                        self.non_tcp_full_header_packets_out.is_set or
                                                                        self.non_tcp_total_out_bytes.is_set or
                                                                        self.non_tcp_total_out_packets.is_set or
                                                                        self.tcp_bytes_saved.is_set or
                                                                        self.tcp_bytes_sent_rate.is_set or
                                                                        self.tcp_compressed_packets_out.is_set or
                                                                        self.tcp_full_header_packets_out.is_set or
                                                                        self.tcp_total_out_bytes.is_set or
                                                                        self.tcp_total_out_packets.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "iphc-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "non-tcp-bytes-saved"):
                                                                        self.non_tcp_bytes_saved = value
                                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                                        self.non_tcp_bytes_sent_rate = value
                                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                                        self.non_tcp_compressed_packets_out = value
                                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                                        self.non_tcp_full_header_packets_out = value
                                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                                        self.non_tcp_total_out_bytes = value
                                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-total-out-packets"):
                                                                        self.non_tcp_total_out_packets = value
                                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-bytes-saved"):
                                                                        self.tcp_bytes_saved = value
                                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                                        self.tcp_bytes_sent_rate = value
                                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-compressed-packets-out"):
                                                                        self.tcp_compressed_packets_out = value
                                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-full-header-packets-out"):
                                                                        self.tcp_full_header_packets_out = value
                                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-total-out-bytes"):
                                                                        self.tcp_total_out_bytes = value
                                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-total-out-packets"):
                                                                        self.tcp_total_out_packets = value
                                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("admit_bytes",
                                                                                    "admit_rates",
                                                                                    "admitpackets",
                                                                                    "drop_bytes",
                                                                                    "drop_packets",
                                                                                    "drop_rates") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.admit_bytes.is_set or
                                                                        self.admit_rates.is_set or
                                                                        self.admitpackets.is_set or
                                                                        self.drop_bytes.is_set or
                                                                        self.drop_packets.is_set or
                                                                        self.drop_rates.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "cac-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "admit-bytes"):
                                                                        self.admit_bytes = value
                                                                        self.admit_bytes.value_namespace = name_space
                                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "admit-rates"):
                                                                        self.admit_rates = value
                                                                        self.admit_rates.value_namespace = name_space
                                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "admitpackets"):
                                                                        self.admitpackets = value
                                                                        self.admitpackets.value_namespace = name_space
                                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-bytes"):
                                                                        self.drop_bytes = value
                                                                        self.drop_bytes.value_namespace = name_space
                                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-packets"):
                                                                        self.drop_packets = value
                                                                        self.drop_packets.value_namespace = name_space
                                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-rates"):
                                                                        self.drop_rates = value
                                                                        self.drop_rates.value_namespace = name_space
                                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\:  bool
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_max_length = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("atm_clp0_drop_bytes",
                                                                                    "atm_clp0_drop_packets",
                                                                                    "atm_clp1_drop_bytes",
                                                                                    "atm_clp1_drop_packets",
                                                                                    "conform_bytes",
                                                                                    "conform_packets",
                                                                                    "conform_rate",
                                                                                    "exceed_bytes",
                                                                                    "exceed_packets",
                                                                                    "exceed_rate",
                                                                                    "forced_wred_stats_display",
                                                                                    "max_threshold_bytes",
                                                                                    "max_threshold_packets",
                                                                                    "queue_drop_threshold",
                                                                                    "queue_id",
                                                                                    "random_drop_bytes",
                                                                                    "random_drop_packets",
                                                                                    "tail_drop_bytes",
                                                                                    "tail_drop_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("unit",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.unit.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.unit.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-instance-length" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "unit" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "unit"):
                                                                            self.unit = value
                                                                            self.unit.value_namespace = name_space
                                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("unit",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.unit.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.unit.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-average-length" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "unit" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "unit"):
                                                                            self.unit = value
                                                                            self.unit.value_namespace = name_space
                                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("unit",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.unit.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.unit.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-max-length" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "unit" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "unit"):
                                                                            self.unit = value
                                                                            self.unit.value_namespace = name_space
                                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.queue_average_length:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    for c in self.queue_instance_length:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    for c in self.queue_max_length:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return (
                                                                        self.atm_clp0_drop_bytes.is_set or
                                                                        self.atm_clp0_drop_packets.is_set or
                                                                        self.atm_clp1_drop_bytes.is_set or
                                                                        self.atm_clp1_drop_packets.is_set or
                                                                        self.conform_bytes.is_set or
                                                                        self.conform_packets.is_set or
                                                                        self.conform_rate.is_set or
                                                                        self.exceed_bytes.is_set or
                                                                        self.exceed_packets.is_set or
                                                                        self.exceed_rate.is_set or
                                                                        self.forced_wred_stats_display.is_set or
                                                                        self.max_threshold_bytes.is_set or
                                                                        self.max_threshold_packets.is_set or
                                                                        self.queue_drop_threshold.is_set or
                                                                        self.queue_id.is_set or
                                                                        self.random_drop_bytes.is_set or
                                                                        self.random_drop_packets.is_set or
                                                                        self.tail_drop_bytes.is_set or
                                                                        self.tail_drop_packets.is_set)

                                                                def has_operation(self):
                                                                    for c in self.queue_average_length:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    for c in self.queue_instance_length:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    for c in self.queue_max_length:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                        self.queue_id.yfilter != YFilter.not_set or
                                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-stats-array" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "queue-average-length"):
                                                                        for c in self.queue_average_length:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_average_length.append(c)
                                                                        return c

                                                                    if (child_yang_name == "queue-instance-length"):
                                                                        for c in self.queue_instance_length:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_instance_length.append(c)
                                                                        return c

                                                                    if (child_yang_name == "queue-max-length"):
                                                                        for c in self.queue_max_length:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_max_length.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                                        self.atm_clp0_drop_bytes = value
                                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "atm-clp0-drop-packets"):
                                                                        self.atm_clp0_drop_packets = value
                                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                                        self.atm_clp1_drop_bytes = value
                                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "atm-clp1-drop-packets"):
                                                                        self.atm_clp1_drop_packets = value
                                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-bytes"):
                                                                        self.conform_bytes = value
                                                                        self.conform_bytes.value_namespace = name_space
                                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-packets"):
                                                                        self.conform_packets = value
                                                                        self.conform_packets.value_namespace = name_space
                                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-rate"):
                                                                        self.conform_rate = value
                                                                        self.conform_rate.value_namespace = name_space
                                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-bytes"):
                                                                        self.exceed_bytes = value
                                                                        self.exceed_bytes.value_namespace = name_space
                                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-packets"):
                                                                        self.exceed_packets = value
                                                                        self.exceed_packets.value_namespace = name_space
                                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-rate"):
                                                                        self.exceed_rate = value
                                                                        self.exceed_rate.value_namespace = name_space
                                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "forced-wred-stats-display"):
                                                                        self.forced_wred_stats_display = value
                                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "max-threshold-bytes"):
                                                                        self.max_threshold_bytes = value
                                                                        self.max_threshold_bytes.value_namespace = name_space
                                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "max-threshold-packets"):
                                                                        self.max_threshold_packets = value
                                                                        self.max_threshold_packets.value_namespace = name_space
                                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "queue-drop-threshold"):
                                                                        self.queue_drop_threshold = value
                                                                        self.queue_drop_threshold.value_namespace = name_space
                                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "queue-id"):
                                                                        self.queue_id = value
                                                                        self.queue_id.value_namespace = name_space
                                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-bytes"):
                                                                        self.random_drop_bytes = value
                                                                        self.random_drop_bytes.value_namespace = name_space
                                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-packets"):
                                                                        self.random_drop_packets = value
                                                                        self.random_drop_packets.value_namespace = name_space
                                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tail-drop-bytes"):
                                                                        self.tail_drop_bytes = value
                                                                        self.tail_drop_bytes.value_namespace = name_space
                                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tail-drop-packets"):
                                                                        self.tail_drop_packets = value
                                                                        self.tail_drop_packets.value_namespace = name_space
                                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._children_yang_names.add("color-class-stats")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("conform_bytes",
                                                                                    "conform_packets",
                                                                                    "conform_rate",
                                                                                    "drop_bytes",
                                                                                    "drop_packets",
                                                                                    "exceed_bytes",
                                                                                    "exceed_packets",
                                                                                    "exceed_rate",
                                                                                    "parent_drop_bytes",
                                                                                    "parent_drop_packets",
                                                                                    "violate_bytes",
                                                                                    "violate_packets",
                                                                                    "violate_rate") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"

                                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("conform_class_conform_bytes",
                                                                                        "conform_class_conform_packets",
                                                                                        "conform_class_conform_rate",
                                                                                        "conform_class_exceed_bytes",
                                                                                        "conform_class_exceed_packets",
                                                                                        "conform_class_exceed_rate",
                                                                                        "conform_class_violate_bytes",
                                                                                        "conform_class_violate_packets",
                                                                                        "conform_class_violate_rate",
                                                                                        "exceed_class_exceed_bytes",
                                                                                        "exceed_class_exceed_packets",
                                                                                        "exceed_class_exceed_rate",
                                                                                        "exceed_class_violate_bytes",
                                                                                        "exceed_class_violate_packets",
                                                                                        "exceed_class_violate_rate",
                                                                                        "violate_class_violate_bytes",
                                                                                        "violate_class_violate_packets",
                                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.conform_class_conform_bytes.is_set or
                                                                            self.conform_class_conform_packets.is_set or
                                                                            self.conform_class_conform_rate.is_set or
                                                                            self.conform_class_exceed_bytes.is_set or
                                                                            self.conform_class_exceed_packets.is_set or
                                                                            self.conform_class_exceed_rate.is_set or
                                                                            self.conform_class_violate_bytes.is_set or
                                                                            self.conform_class_violate_packets.is_set or
                                                                            self.conform_class_violate_rate.is_set or
                                                                            self.exceed_class_exceed_bytes.is_set or
                                                                            self.exceed_class_exceed_packets.is_set or
                                                                            self.exceed_class_exceed_rate.is_set or
                                                                            self.exceed_class_violate_bytes.is_set or
                                                                            self.exceed_class_violate_packets.is_set or
                                                                            self.exceed_class_violate_rate.is_set or
                                                                            self.violate_class_violate_bytes.is_set or
                                                                            self.violate_class_violate_packets.is_set or
                                                                            self.violate_class_violate_rate.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "color-class-stats" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "conform-class-conform-bytes"):
                                                                            self.conform_class_conform_bytes = value
                                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-conform-packets"):
                                                                            self.conform_class_conform_packets = value
                                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-conform-rate"):
                                                                            self.conform_class_conform_rate = value
                                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-exceed-bytes"):
                                                                            self.conform_class_exceed_bytes = value
                                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-exceed-packets"):
                                                                            self.conform_class_exceed_packets = value
                                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-exceed-rate"):
                                                                            self.conform_class_exceed_rate = value
                                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-violate-bytes"):
                                                                            self.conform_class_violate_bytes = value
                                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-violate-packets"):
                                                                            self.conform_class_violate_packets = value
                                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-violate-rate"):
                                                                            self.conform_class_violate_rate = value
                                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                                            self.exceed_class_exceed_bytes = value
                                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-exceed-packets"):
                                                                            self.exceed_class_exceed_packets = value
                                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-exceed-rate"):
                                                                            self.exceed_class_exceed_rate = value
                                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-violate-bytes"):
                                                                            self.exceed_class_violate_bytes = value
                                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-violate-packets"):
                                                                            self.exceed_class_violate_packets = value
                                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-violate-rate"):
                                                                            self.exceed_class_violate_rate = value
                                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-class-violate-bytes"):
                                                                            self.violate_class_violate_bytes = value
                                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-class-violate-packets"):
                                                                            self.violate_class_violate_packets = value
                                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-class-violate-rate"):
                                                                            self.violate_class_violate_rate = value
                                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (
                                                                        self.conform_bytes.is_set or
                                                                        self.conform_packets.is_set or
                                                                        self.conform_rate.is_set or
                                                                        self.drop_bytes.is_set or
                                                                        self.drop_packets.is_set or
                                                                        self.exceed_bytes.is_set or
                                                                        self.exceed_packets.is_set or
                                                                        self.exceed_rate.is_set or
                                                                        self.parent_drop_bytes.is_set or
                                                                        self.parent_drop_packets.is_set or
                                                                        self.violate_bytes.is_set or
                                                                        self.violate_packets.is_set or
                                                                        self.violate_rate.is_set or
                                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "police-stats-array" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "color-class-stats"):
                                                                        if (self.color_class_stats is None):
                                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                            self.color_class_stats.parent = self
                                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                        return self.color_class_stats

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "conform-bytes"):
                                                                        self.conform_bytes = value
                                                                        self.conform_bytes.value_namespace = name_space
                                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-packets"):
                                                                        self.conform_packets = value
                                                                        self.conform_packets.value_namespace = name_space
                                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-rate"):
                                                                        self.conform_rate = value
                                                                        self.conform_rate.value_namespace = name_space
                                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-bytes"):
                                                                        self.drop_bytes = value
                                                                        self.drop_bytes.value_namespace = name_space
                                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-packets"):
                                                                        self.drop_packets = value
                                                                        self.drop_packets.value_namespace = name_space
                                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-bytes"):
                                                                        self.exceed_bytes = value
                                                                        self.exceed_bytes.value_namespace = name_space
                                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-packets"):
                                                                        self.exceed_packets = value
                                                                        self.exceed_packets.value_namespace = name_space
                                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-rate"):
                                                                        self.exceed_rate = value
                                                                        self.exceed_rate.value_namespace = name_space
                                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "parent-drop-bytes"):
                                                                        self.parent_drop_bytes = value
                                                                        self.parent_drop_bytes.value_namespace = name_space
                                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "parent-drop-packets"):
                                                                        self.parent_drop_packets = value
                                                                        self.parent_drop_packets.value_namespace = name_space
                                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-bytes"):
                                                                        self.violate_bytes = value
                                                                        self.violate_bytes.value_namespace = name_space
                                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-packets"):
                                                                        self.violate_packets = value
                                                                        self.violate_packets.value_namespace = name_space
                                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-rate"):
                                                                        self.violate_rate = value
                                                                        self.violate_rate.value_namespace = name_space
                                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                                    self.red_label = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("max_threshold_bytes",
                                                                                    "max_threshold_packets",
                                                                                    "profile_title",
                                                                                    "random_drop_bytes",
                                                                                    "random_drop_packets",
                                                                                    "red_ecn_marked_bytes",
                                                                                    "red_ecn_marked_packets",
                                                                                    "red_transmit_bytes",
                                                                                    "red_transmit_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"

                                                                        self.value = YLeaf(YType.uint8, "value")

                                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("value",
                                                                                        "wred_type") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.value.is_set or
                                                                            self.wred_type.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set or
                                                                            self.wred_type.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "red-label" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "value" or name == "wred-type"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "wred-type"):
                                                                            self.wred_type = value
                                                                            self.wred_type.value_namespace = name_space
                                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.red_label:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return (
                                                                        self.max_threshold_bytes.is_set or
                                                                        self.max_threshold_packets.is_set or
                                                                        self.profile_title.is_set or
                                                                        self.random_drop_bytes.is_set or
                                                                        self.random_drop_packets.is_set or
                                                                        self.red_ecn_marked_bytes.is_set or
                                                                        self.red_ecn_marked_packets.is_set or
                                                                        self.red_transmit_bytes.is_set or
                                                                        self.red_transmit_packets.is_set)

                                                                def has_operation(self):
                                                                    for c in self.red_label:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                        self.profile_title.yfilter != YFilter.not_set or
                                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "wred-stats-array" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "red-label"):
                                                                        for c in self.red_label:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.red_label.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "max-threshold-bytes"):
                                                                        self.max_threshold_bytes = value
                                                                        self.max_threshold_bytes.value_namespace = name_space
                                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "max-threshold-packets"):
                                                                        self.max_threshold_packets = value
                                                                        self.max_threshold_packets.value_namespace = name_space
                                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "profile-title"):
                                                                        self.profile_title = value
                                                                        self.profile_title.value_namespace = name_space
                                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-bytes"):
                                                                        self.random_drop_bytes = value
                                                                        self.random_drop_bytes.value_namespace = name_space
                                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-packets"):
                                                                        self.random_drop_packets = value
                                                                        self.random_drop_packets.value_namespace = name_space
                                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-ecn-marked-bytes"):
                                                                        self.red_ecn_marked_bytes = value
                                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-ecn-marked-packets"):
                                                                        self.red_ecn_marked_packets = value
                                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-transmit-bytes"):
                                                                        self.red_transmit_bytes = value
                                                                        self.red_transmit_bytes.value_namespace = name_space
                                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-transmit-packets"):
                                                                        self.red_transmit_packets = value
                                                                        self.red_transmit_packets.value_namespace = name_space
                                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.police_stats_array:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.queue_stats_array:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.wred_stats_array:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.cac_state.is_set or
                                                                    self.class_name.is_set or
                                                                    self.counter_validity_bitmask.is_set or
                                                                    self.queue_descr.is_set or
                                                                    self.shared_queue_id.is_set or
                                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                            def has_operation(self):
                                                                for c in self.police_stats_array:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.queue_stats_array:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.wred_stats_array:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.cac_state.yfilter != YFilter.not_set or
                                                                    self.class_name.yfilter != YFilter.not_set or
                                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "cac-stats"):
                                                                    if (self.cac_stats is None):
                                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                        self.cac_stats.parent = self
                                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                                    return self.cac_stats

                                                                if (child_yang_name == "general-stats"):
                                                                    if (self.general_stats is None):
                                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                        self.general_stats.parent = self
                                                                        self._children_name_map["general_stats"] = "general-stats"
                                                                    return self.general_stats

                                                                if (child_yang_name == "iphc-stats"):
                                                                    if (self.iphc_stats is None):
                                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                        self.iphc_stats.parent = self
                                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                    return self.iphc_stats

                                                                if (child_yang_name == "police-stats-array"):
                                                                    for c in self.police_stats_array:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.police_stats_array.append(c)
                                                                    return c

                                                                if (child_yang_name == "queue-stats-array"):
                                                                    for c in self.queue_stats_array:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_stats_array.append(c)
                                                                    return c

                                                                if (child_yang_name == "wred-stats-array"):
                                                                    for c in self.wred_stats_array:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.wred_stats_array.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "cac-state"):
                                                                    self.cac_state = value
                                                                    self.cac_state.value_namespace = name_space
                                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "class-name"):
                                                                    self.class_name = value
                                                                    self.class_name.value_namespace = name_space
                                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "counter-validity-bitmask"):
                                                                    self.counter_validity_bitmask = value
                                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "queue-descr"):
                                                                    self.queue_descr = value
                                                                    self.queue_descr.value_namespace = name_space
                                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "shared-queue-id"):
                                                                    self.shared_queue_id = value
                                                                    self.shared_queue_id.value_namespace = name_space
                                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.class_stats:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.policy_name.is_set or
                                                                self.satid.is_set or
                                                                self.state.is_set or
                                                                self.state_description.is_set)

                                                        def has_operation(self):
                                                            for c in self.class_stats:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.policy_name.yfilter != YFilter.not_set or
                                                                self.satid.yfilter != YFilter.not_set or
                                                                self.state.yfilter != YFilter.not_set or
                                                                self.state_description.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "child-policy" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.state.get_name_leafdata())
                                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "class-stats"):
                                                                for c in self.class_stats:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.class_stats.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "policy-name"):
                                                                self.policy_name = value
                                                                self.policy_name.value_namespace = name_space
                                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "satid"):
                                                                self.satid = value
                                                                self.satid.value_namespace = name_space
                                                                self.satid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "state"):
                                                                self.state = value
                                                                self.state.value_namespace = name_space
                                                                self.state.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "state-description"):
                                                                self.state_description = value
                                                                self.state_description.value_namespace = name_space
                                                                self.state_description.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.child_policy is not None and self.child_policy.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.child_policy is not None and self.child_policy.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "child-policy"):
                                                            if (self.child_policy is None):
                                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                                                self.child_policy.parent = self
                                                                self._children_name_map["child_policy"] = "child-policy"
                                                            return self.child_policy

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "statistics" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                                    (self.statistics is not None and self.statistics.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                                    (self.statistics is not None and self.statistics.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "input" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "service-policy-names"):
                                                    if (self.service_policy_names is None):
                                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                                        self.service_policy_names.parent = self
                                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                                    return self.service_policy_names

                                                if (child_yang_name == "statistics"):
                                                    if (self.statistics is None):
                                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics()
                                                        self.statistics.parent = self
                                                        self._children_name_map["statistics"] = "statistics"
                                                    return self.statistics

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-names" or name == "statistics"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class Output(Entity):
                                            """
                                            A piece of QoS policy\-map operational data for
                                            an interface
                                            
                                            .. attribute:: service_policy_names
                                            
                                            	Operational data for all Policy instance
                                            	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                                            
                                            .. attribute:: statistics
                                            
                                            	Policy\-map statistics operational data for an interface
                                            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, self).__init__()

                                                self.yang_name = "output"
                                                self.yang_parent_name = "satellite-id"

                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                                self._children_yang_names.add("service-policy-names")

                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                                self._children_yang_names.add("statistics")


                                            class ServicePolicyNames(Entity):
                                                """
                                                Operational data for all Policy instance
                                                
                                                .. attribute:: service_policy_instance
                                                
                                                	QoS policy\-map operational data for a particular Policy 
                                                	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                                    self.yang_name = "service-policy-names"
                                                    self.yang_parent_name = "output"

                                                    self.service_policy_instance = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)


                                                class ServicePolicyInstance(Entity):
                                                    """
                                                    QoS policy\-map operational data for a
                                                    particular Policy 
                                                    
                                                    .. attribute:: service_policy_name  <key>
                                                    
                                                    	Name of the policy instance
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                        self.yang_name = "service-policy-instance"
                                                        self.yang_parent_name = "service-policy-names"

                                                        self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("service_policy_name") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.service_policy_name.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.service_policy_name.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "service-policy-name"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "service-policy-name"):
                                                            self.service_policy_name = value
                                                            self.service_policy_name.value_namespace = name_space
                                                            self.service_policy_name.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.service_policy_instance:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.service_policy_instance:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "service-policy-names" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "service-policy-instance"):
                                                        for c in self.service_policy_instance:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.service_policy_instance.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "service-policy-instance"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class Statistics(Entity):
                                                """
                                                Policy\-map statistics operational data for an
                                                interface
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__init__()

                                                    self.yang_name = "statistics"
                                                    self.yang_parent_name = "output"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: child_policy
                                                    
                                                    	child policy
                                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "statistics"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                        self._children_yang_names.add("child-policy")

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class ChildPolicy(Entity):
                                                        """
                                                        child policy
                                                        
                                                        .. attribute:: class_stats
                                                        
                                                        	array of classes contained in policy
                                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                        
                                                        .. attribute:: policy_name
                                                        
                                                        	PolicyName
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: satid
                                                        
                                                        	to maintain satellite id
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: state
                                                        
                                                        	State
                                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                        
                                                        .. attribute:: state_description
                                                        
                                                        	StateDescription
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..128
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                            self.yang_name = "child-policy"
                                                            self.yang_parent_name = "class-stats"

                                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                                            self.satid = YLeaf(YType.uint32, "satid")

                                                            self.state = YLeaf(YType.enumeration, "state")

                                                            self.state_description = YLeaf(YType.str, "state-description")

                                                            self.class_stats = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("policy_name",
                                                                            "satid",
                                                                            "state",
                                                                            "state_description") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                        class ClassStats(Entity):
                                                            """
                                                            array of classes contained in policy
                                                            
                                                            .. attribute:: cac_state
                                                            
                                                            	CACState
                                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                            
                                                            .. attribute:: cac_stats
                                                            
                                                            	bag for cac stats
                                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	ClassName
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: counter_validity_bitmask
                                                            
                                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: megabyte
                                                            
                                                            .. attribute:: general_stats
                                                            
                                                            	general stats
                                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                            
                                                            .. attribute:: iphc_stats
                                                            
                                                            	IPHC stats
                                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                            
                                                            .. attribute:: police_stats_array
                                                            
                                                            	array of police stats
                                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                            
                                                            .. attribute:: queue_descr
                                                            
                                                            	Description of queue for the class
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..256
                                                            
                                                            .. attribute:: queue_stats_array
                                                            
                                                            	array of queue stats
                                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                            
                                                            .. attribute:: shared_queue_id
                                                            
                                                            	q\-id of the  shared queue for this class
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: wred_stats_array
                                                            
                                                            	array of red stats
                                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                                self.yang_name = "class-stats"
                                                                self.yang_parent_name = "child-policy"

                                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                                self._children_yang_names.add("cac-stats")

                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                                self._children_yang_names.add("general-stats")

                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                self._children_yang_names.add("iphc-stats")

                                                                self.police_stats_array = YList(self)
                                                                self.queue_stats_array = YList(self)
                                                                self.wred_stats_array = YList(self)

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("cac_state",
                                                                                "class_name",
                                                                                "counter_validity_bitmask",
                                                                                "queue_descr",
                                                                                "shared_queue_id") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                            class GeneralStats(Entity):
                                                                """
                                                                general stats
                                                                
                                                                .. attribute:: match_data_rate
                                                                
                                                                	Incoming matched data rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: pre_policy_matched_bytes
                                                                
                                                                	Matched bytes before applying policy
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: pre_policy_matched_packets
                                                                
                                                                	Matched pkts before applying policy
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: total_drop_bytes
                                                                
                                                                	Dropped bytes (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_packets
                                                                
                                                                	Dropped packets (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_drop_rate
                                                                
                                                                	Total drop rate (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: total_transmit_rate
                                                                
                                                                	Total transmit rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: transmit_bytes
                                                                
                                                                	Transmitted bytes (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: transmit_packets
                                                                
                                                                	Transmitted packets (packets/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                                    self.yang_name = "general-stats"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("match_data_rate",
                                                                                    "pre_policy_matched_bytes",
                                                                                    "pre_policy_matched_packets",
                                                                                    "total_drop_bytes",
                                                                                    "total_drop_packets",
                                                                                    "total_drop_rate",
                                                                                    "total_transmit_rate",
                                                                                    "transmit_bytes",
                                                                                    "transmit_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.match_data_rate.is_set or
                                                                        self.pre_policy_matched_bytes.is_set or
                                                                        self.pre_policy_matched_packets.is_set or
                                                                        self.total_drop_bytes.is_set or
                                                                        self.total_drop_packets.is_set or
                                                                        self.total_drop_rate.is_set or
                                                                        self.total_transmit_rate.is_set or
                                                                        self.transmit_bytes.is_set or
                                                                        self.transmit_packets.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "general-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "match-data-rate"):
                                                                        self.match_data_rate = value
                                                                        self.match_data_rate.value_namespace = name_space
                                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pre-policy-matched-bytes"):
                                                                        self.pre_policy_matched_bytes = value
                                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "pre-policy-matched-packets"):
                                                                        self.pre_policy_matched_packets = value
                                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-drop-bytes"):
                                                                        self.total_drop_bytes = value
                                                                        self.total_drop_bytes.value_namespace = name_space
                                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-drop-packets"):
                                                                        self.total_drop_packets = value
                                                                        self.total_drop_packets.value_namespace = name_space
                                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-drop-rate"):
                                                                        self.total_drop_rate = value
                                                                        self.total_drop_rate.value_namespace = name_space
                                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "total-transmit-rate"):
                                                                        self.total_transmit_rate = value
                                                                        self.total_transmit_rate.value_namespace = name_space
                                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "transmit-bytes"):
                                                                        self.transmit_bytes = value
                                                                        self.transmit_bytes.value_namespace = name_space
                                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "transmit-packets"):
                                                                        self.transmit_packets = value
                                                                        self.transmit_packets.value_namespace = name_space
                                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                            class IphcStats(Entity):
                                                                """
                                                                IPHC stats
                                                                
                                                                .. attribute:: non_tcp_bytes_saved
                                                                
                                                                	Non Tcp Bytes saved due to compression
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_bytes_sent_rate
                                                                
                                                                	Compressed Non Tcp Bytes sent rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_compressed_packets_out
                                                                
                                                                	Num of non tcp compressed pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_full_header_packets_out
                                                                
                                                                	Num of non tcp fullheader pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: non_tcp_total_out_bytes
                                                                
                                                                	TotalNum of Non Tcp Bytes sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: non_tcp_total_out_packets
                                                                
                                                                	TotalNum of Non tcp pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_bytes_saved
                                                                
                                                                	Tcp Bytes saved due to compression
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_bytes_sent_rate
                                                                
                                                                	Compressed Tcp Bytes sent rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_compressed_packets_out
                                                                
                                                                	Num of tcp compressed pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_full_header_packets_out
                                                                
                                                                	Num of tcp fullheader pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tcp_total_out_bytes
                                                                
                                                                	TotalNum of Tcp Bytes sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tcp_total_out_packets
                                                                
                                                                	Total Num of tcp pkts sent
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                                    self.yang_name = "iphc-stats"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("non_tcp_bytes_saved",
                                                                                    "non_tcp_bytes_sent_rate",
                                                                                    "non_tcp_compressed_packets_out",
                                                                                    "non_tcp_full_header_packets_out",
                                                                                    "non_tcp_total_out_bytes",
                                                                                    "non_tcp_total_out_packets",
                                                                                    "tcp_bytes_saved",
                                                                                    "tcp_bytes_sent_rate",
                                                                                    "tcp_compressed_packets_out",
                                                                                    "tcp_full_header_packets_out",
                                                                                    "tcp_total_out_bytes",
                                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.non_tcp_bytes_saved.is_set or
                                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                                        self.non_tcp_compressed_packets_out.is_set or
                                                                        self.non_tcp_full_header_packets_out.is_set or
                                                                        self.non_tcp_total_out_bytes.is_set or
                                                                        self.non_tcp_total_out_packets.is_set or
                                                                        self.tcp_bytes_saved.is_set or
                                                                        self.tcp_bytes_sent_rate.is_set or
                                                                        self.tcp_compressed_packets_out.is_set or
                                                                        self.tcp_full_header_packets_out.is_set or
                                                                        self.tcp_total_out_bytes.is_set or
                                                                        self.tcp_total_out_packets.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "iphc-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "non-tcp-bytes-saved"):
                                                                        self.non_tcp_bytes_saved = value
                                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                                        self.non_tcp_bytes_sent_rate = value
                                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                                        self.non_tcp_compressed_packets_out = value
                                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                                        self.non_tcp_full_header_packets_out = value
                                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                                        self.non_tcp_total_out_bytes = value
                                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "non-tcp-total-out-packets"):
                                                                        self.non_tcp_total_out_packets = value
                                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-bytes-saved"):
                                                                        self.tcp_bytes_saved = value
                                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                                        self.tcp_bytes_sent_rate = value
                                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-compressed-packets-out"):
                                                                        self.tcp_compressed_packets_out = value
                                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-full-header-packets-out"):
                                                                        self.tcp_full_header_packets_out = value
                                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-total-out-bytes"):
                                                                        self.tcp_total_out_bytes = value
                                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tcp-total-out-packets"):
                                                                        self.tcp_total_out_packets = value
                                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                            class CacStats(Entity):
                                                                """
                                                                bag for cac stats
                                                                
                                                                .. attribute:: admit_bytes
                                                                
                                                                	Admitted bytes (pkts/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: admit_rates
                                                                
                                                                	CAC admit rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: admitpackets
                                                                
                                                                	Admitted packets (pkts/bytes)
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	CAC dropped bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	CAC dropped packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: drop_rates
                                                                
                                                                	CAC dropped rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                                    self.yang_name = "cac-stats"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("admit_bytes",
                                                                                    "admit_rates",
                                                                                    "admitpackets",
                                                                                    "drop_bytes",
                                                                                    "drop_packets",
                                                                                    "drop_rates") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                                def has_data(self):
                                                                    return (
                                                                        self.admit_bytes.is_set or
                                                                        self.admit_rates.is_set or
                                                                        self.admitpackets.is_set or
                                                                        self.drop_bytes.is_set or
                                                                        self.drop_packets.is_set or
                                                                        self.drop_rates.is_set)

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "cac-stats" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "admit-bytes"):
                                                                        self.admit_bytes = value
                                                                        self.admit_bytes.value_namespace = name_space
                                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "admit-rates"):
                                                                        self.admit_rates = value
                                                                        self.admit_rates.value_namespace = name_space
                                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "admitpackets"):
                                                                        self.admitpackets = value
                                                                        self.admitpackets.value_namespace = name_space
                                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-bytes"):
                                                                        self.drop_bytes = value
                                                                        self.drop_bytes.value_namespace = name_space
                                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-packets"):
                                                                        self.drop_packets = value
                                                                        self.drop_packets.value_namespace = name_space
                                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-rates"):
                                                                        self.drop_rates = value
                                                                        self.drop_rates.value_namespace = name_space
                                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                                            class QueueStatsArray(Entity):
                                                                """
                                                                array of queue stats
                                                                
                                                                .. attribute:: atm_clp0_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp0_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: atm_clp1_drop_bytes
                                                                
                                                                	ATP CLP 0 matched bytes dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: atm_clp1_drop_packets
                                                                
                                                                	ATP CLP 0 matched packets dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the queue rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: forced_wred_stats_display
                                                                
                                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                                	**type**\:  bool
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: queue_average_length
                                                                
                                                                	Queue average length
                                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                                
                                                                .. attribute:: queue_drop_threshold
                                                                
                                                                	tail drop threshold of the queue in bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: queue_id
                                                                
                                                                	Queue Id used for Fabric Stats
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: queue_instance_length
                                                                
                                                                	Queue instance length
                                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                                
                                                                .. attribute:: queue_max_length
                                                                
                                                                	Queue maximum length
                                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Bytes probabilistically dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Packets probabilistically dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: tail_drop_bytes
                                                                
                                                                	Bytes tail dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: tail_drop_packets
                                                                
                                                                	Packets tail dropped
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                                    self.yang_name = "queue-stats-array"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                                    self.queue_average_length = YList(self)
                                                                    self.queue_instance_length = YList(self)
                                                                    self.queue_max_length = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("atm_clp0_drop_bytes",
                                                                                    "atm_clp0_drop_packets",
                                                                                    "atm_clp1_drop_bytes",
                                                                                    "atm_clp1_drop_packets",
                                                                                    "conform_bytes",
                                                                                    "conform_packets",
                                                                                    "conform_rate",
                                                                                    "exceed_bytes",
                                                                                    "exceed_packets",
                                                                                    "exceed_rate",
                                                                                    "forced_wred_stats_display",
                                                                                    "max_threshold_bytes",
                                                                                    "max_threshold_packets",
                                                                                    "queue_drop_threshold",
                                                                                    "queue_id",
                                                                                    "random_drop_bytes",
                                                                                    "random_drop_packets",
                                                                                    "tail_drop_bytes",
                                                                                    "tail_drop_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                                class QueueInstanceLength(Entity):
                                                                    """
                                                                    Queue instance length
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                        self.yang_name = "queue-instance-length"
                                                                        self.yang_parent_name = "queue-stats-array"

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("unit",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.unit.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.unit.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-instance-length" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "unit" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "unit"):
                                                                            self.unit = value
                                                                            self.unit.value_namespace = name_space
                                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class QueueAverageLength(Entity):
                                                                    """
                                                                    Queue average length
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                        self.yang_name = "queue-average-length"
                                                                        self.yang_parent_name = "queue-stats-array"

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("unit",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.unit.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.unit.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-average-length" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "unit" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "unit"):
                                                                            self.unit = value
                                                                            self.unit.value_namespace = name_space
                                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix


                                                                class QueueMaxLength(Entity):
                                                                    """
                                                                    Queue maximum length
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                        self.yang_name = "queue-max-length"
                                                                        self.yang_parent_name = "queue-stats-array"

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("unit",
                                                                                        "value") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.unit.is_set or
                                                                            self.value.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.unit.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "queue-max-length" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "unit" or name == "value"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "unit"):
                                                                            self.unit = value
                                                                            self.unit.value_namespace = name_space
                                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.queue_average_length:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    for c in self.queue_instance_length:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    for c in self.queue_max_length:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return (
                                                                        self.atm_clp0_drop_bytes.is_set or
                                                                        self.atm_clp0_drop_packets.is_set or
                                                                        self.atm_clp1_drop_bytes.is_set or
                                                                        self.atm_clp1_drop_packets.is_set or
                                                                        self.conform_bytes.is_set or
                                                                        self.conform_packets.is_set or
                                                                        self.conform_rate.is_set or
                                                                        self.exceed_bytes.is_set or
                                                                        self.exceed_packets.is_set or
                                                                        self.exceed_rate.is_set or
                                                                        self.forced_wred_stats_display.is_set or
                                                                        self.max_threshold_bytes.is_set or
                                                                        self.max_threshold_packets.is_set or
                                                                        self.queue_drop_threshold.is_set or
                                                                        self.queue_id.is_set or
                                                                        self.random_drop_bytes.is_set or
                                                                        self.random_drop_packets.is_set or
                                                                        self.tail_drop_bytes.is_set or
                                                                        self.tail_drop_packets.is_set)

                                                                def has_operation(self):
                                                                    for c in self.queue_average_length:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    for c in self.queue_instance_length:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    for c in self.queue_max_length:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                        self.queue_id.yfilter != YFilter.not_set or
                                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "queue-stats-array" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "queue-average-length"):
                                                                        for c in self.queue_average_length:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_average_length.append(c)
                                                                        return c

                                                                    if (child_yang_name == "queue-instance-length"):
                                                                        for c in self.queue_instance_length:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_instance_length.append(c)
                                                                        return c

                                                                    if (child_yang_name == "queue-max-length"):
                                                                        for c in self.queue_max_length:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.queue_max_length.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                                        self.atm_clp0_drop_bytes = value
                                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "atm-clp0-drop-packets"):
                                                                        self.atm_clp0_drop_packets = value
                                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                                        self.atm_clp1_drop_bytes = value
                                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "atm-clp1-drop-packets"):
                                                                        self.atm_clp1_drop_packets = value
                                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-bytes"):
                                                                        self.conform_bytes = value
                                                                        self.conform_bytes.value_namespace = name_space
                                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-packets"):
                                                                        self.conform_packets = value
                                                                        self.conform_packets.value_namespace = name_space
                                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-rate"):
                                                                        self.conform_rate = value
                                                                        self.conform_rate.value_namespace = name_space
                                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-bytes"):
                                                                        self.exceed_bytes = value
                                                                        self.exceed_bytes.value_namespace = name_space
                                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-packets"):
                                                                        self.exceed_packets = value
                                                                        self.exceed_packets.value_namespace = name_space
                                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-rate"):
                                                                        self.exceed_rate = value
                                                                        self.exceed_rate.value_namespace = name_space
                                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "forced-wred-stats-display"):
                                                                        self.forced_wred_stats_display = value
                                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "max-threshold-bytes"):
                                                                        self.max_threshold_bytes = value
                                                                        self.max_threshold_bytes.value_namespace = name_space
                                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "max-threshold-packets"):
                                                                        self.max_threshold_packets = value
                                                                        self.max_threshold_packets.value_namespace = name_space
                                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "queue-drop-threshold"):
                                                                        self.queue_drop_threshold = value
                                                                        self.queue_drop_threshold.value_namespace = name_space
                                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "queue-id"):
                                                                        self.queue_id = value
                                                                        self.queue_id.value_namespace = name_space
                                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-bytes"):
                                                                        self.random_drop_bytes = value
                                                                        self.random_drop_bytes.value_namespace = name_space
                                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-packets"):
                                                                        self.random_drop_packets = value
                                                                        self.random_drop_packets.value_namespace = name_space
                                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tail-drop-bytes"):
                                                                        self.tail_drop_bytes = value
                                                                        self.tail_drop_bytes.value_namespace = name_space
                                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "tail-drop-packets"):
                                                                        self.tail_drop_packets = value
                                                                        self.tail_drop_packets.value_namespace = name_space
                                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                            class PoliceStatsArray(Entity):
                                                                """
                                                                array of police stats
                                                                
                                                                .. attribute:: color_class_stats
                                                                
                                                                	color class stats
                                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                                
                                                                .. attribute:: conform_bytes
                                                                
                                                                	Bytes that conform to the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: conform_packets
                                                                
                                                                	Packets that conform  to the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: conform_rate
                                                                
                                                                	Conform rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: drop_bytes
                                                                
                                                                	Police dropped bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: drop_packets
                                                                
                                                                	Police dropped packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_bytes
                                                                
                                                                	Bytes that exceed  the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: exceed_packets
                                                                
                                                                	Packets that exceed the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: exceed_rate
                                                                
                                                                	Exceed rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                .. attribute:: parent_drop_bytes
                                                                
                                                                	Dropped bytes by the parent policer
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: parent_drop_packets
                                                                
                                                                	Dropped pkts by the parent policer
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_bytes
                                                                
                                                                	Bytes that violate the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: violate_packets
                                                                
                                                                	Packets violating the policed rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: violate_rate
                                                                
                                                                	Violate rate in kbps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: kbit/s
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                                    self.yang_name = "police-stats-array"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                    self._children_yang_names.add("color-class-stats")

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("conform_bytes",
                                                                                    "conform_packets",
                                                                                    "conform_rate",
                                                                                    "drop_bytes",
                                                                                    "drop_packets",
                                                                                    "exceed_bytes",
                                                                                    "exceed_packets",
                                                                                    "exceed_rate",
                                                                                    "parent_drop_bytes",
                                                                                    "parent_drop_packets",
                                                                                    "violate_bytes",
                                                                                    "violate_packets",
                                                                                    "violate_rate") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                                class ColorClassStats(Entity):
                                                                    """
                                                                    color class stats
                                                                    
                                                                    .. attribute:: conform_class_conform_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result conform
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_conform_packets
                                                                    
                                                                    	Packets with classification result conform and policer result conform
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_conform_rate
                                                                    
                                                                    	Conform Class Conform rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_exceed_packets
                                                                    
                                                                    	Packets with classification result conform and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_exceed_rate
                                                                    
                                                                    	Conform Class Exceed rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: conform_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result conform and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: conform_class_violate_packets
                                                                    
                                                                    	Packets with classification result conform and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: conform_class_violate_rate
                                                                    
                                                                    	Conform Class Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_exceed_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_exceed_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result exceed
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_exceed_rate
                                                                    
                                                                    	Exceed Class Exceed rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: exceed_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result exceed and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: exceed_class_violate_packets
                                                                    
                                                                    	Packets with classification result exceed and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: exceed_class_violate_rate
                                                                    
                                                                    	Exceed Class Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    .. attribute:: violate_class_violate_bytes
                                                                    
                                                                    	Bytes with classification result violate and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: violate_class_violate_packets
                                                                    
                                                                    	Packets with classification result violate and policer result violate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: violate_class_violate_rate
                                                                    
                                                                    	Violate Class Violate rate in kbps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: kbit/s
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                        self.yang_name = "color-class-stats"
                                                                        self.yang_parent_name = "police-stats-array"

                                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("conform_class_conform_bytes",
                                                                                        "conform_class_conform_packets",
                                                                                        "conform_class_conform_rate",
                                                                                        "conform_class_exceed_bytes",
                                                                                        "conform_class_exceed_packets",
                                                                                        "conform_class_exceed_rate",
                                                                                        "conform_class_violate_bytes",
                                                                                        "conform_class_violate_packets",
                                                                                        "conform_class_violate_rate",
                                                                                        "exceed_class_exceed_bytes",
                                                                                        "exceed_class_exceed_packets",
                                                                                        "exceed_class_exceed_rate",
                                                                                        "exceed_class_violate_bytes",
                                                                                        "exceed_class_violate_packets",
                                                                                        "exceed_class_violate_rate",
                                                                                        "violate_class_violate_bytes",
                                                                                        "violate_class_violate_packets",
                                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.conform_class_conform_bytes.is_set or
                                                                            self.conform_class_conform_packets.is_set or
                                                                            self.conform_class_conform_rate.is_set or
                                                                            self.conform_class_exceed_bytes.is_set or
                                                                            self.conform_class_exceed_packets.is_set or
                                                                            self.conform_class_exceed_rate.is_set or
                                                                            self.conform_class_violate_bytes.is_set or
                                                                            self.conform_class_violate_packets.is_set or
                                                                            self.conform_class_violate_rate.is_set or
                                                                            self.exceed_class_exceed_bytes.is_set or
                                                                            self.exceed_class_exceed_packets.is_set or
                                                                            self.exceed_class_exceed_rate.is_set or
                                                                            self.exceed_class_violate_bytes.is_set or
                                                                            self.exceed_class_violate_packets.is_set or
                                                                            self.exceed_class_violate_rate.is_set or
                                                                            self.violate_class_violate_bytes.is_set or
                                                                            self.violate_class_violate_packets.is_set or
                                                                            self.violate_class_violate_rate.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "color-class-stats" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "conform-class-conform-bytes"):
                                                                            self.conform_class_conform_bytes = value
                                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-conform-packets"):
                                                                            self.conform_class_conform_packets = value
                                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-conform-rate"):
                                                                            self.conform_class_conform_rate = value
                                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-exceed-bytes"):
                                                                            self.conform_class_exceed_bytes = value
                                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-exceed-packets"):
                                                                            self.conform_class_exceed_packets = value
                                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-exceed-rate"):
                                                                            self.conform_class_exceed_rate = value
                                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-violate-bytes"):
                                                                            self.conform_class_violate_bytes = value
                                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-violate-packets"):
                                                                            self.conform_class_violate_packets = value
                                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "conform-class-violate-rate"):
                                                                            self.conform_class_violate_rate = value
                                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                                            self.exceed_class_exceed_bytes = value
                                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-exceed-packets"):
                                                                            self.exceed_class_exceed_packets = value
                                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-exceed-rate"):
                                                                            self.exceed_class_exceed_rate = value
                                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-violate-bytes"):
                                                                            self.exceed_class_violate_bytes = value
                                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-violate-packets"):
                                                                            self.exceed_class_violate_packets = value
                                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "exceed-class-violate-rate"):
                                                                            self.exceed_class_violate_rate = value
                                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-class-violate-bytes"):
                                                                            self.violate_class_violate_bytes = value
                                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-class-violate-packets"):
                                                                            self.violate_class_violate_packets = value
                                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "violate-class-violate-rate"):
                                                                            self.violate_class_violate_rate = value
                                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    return (
                                                                        self.conform_bytes.is_set or
                                                                        self.conform_packets.is_set or
                                                                        self.conform_rate.is_set or
                                                                        self.drop_bytes.is_set or
                                                                        self.drop_packets.is_set or
                                                                        self.exceed_bytes.is_set or
                                                                        self.exceed_packets.is_set or
                                                                        self.exceed_rate.is_set or
                                                                        self.parent_drop_bytes.is_set or
                                                                        self.parent_drop_packets.is_set or
                                                                        self.violate_bytes.is_set or
                                                                        self.violate_packets.is_set or
                                                                        self.violate_rate.is_set or
                                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                                def has_operation(self):
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "police-stats-array" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "color-class-stats"):
                                                                        if (self.color_class_stats is None):
                                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                            self.color_class_stats.parent = self
                                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                        return self.color_class_stats

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "conform-bytes"):
                                                                        self.conform_bytes = value
                                                                        self.conform_bytes.value_namespace = name_space
                                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-packets"):
                                                                        self.conform_packets = value
                                                                        self.conform_packets.value_namespace = name_space
                                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "conform-rate"):
                                                                        self.conform_rate = value
                                                                        self.conform_rate.value_namespace = name_space
                                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-bytes"):
                                                                        self.drop_bytes = value
                                                                        self.drop_bytes.value_namespace = name_space
                                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "drop-packets"):
                                                                        self.drop_packets = value
                                                                        self.drop_packets.value_namespace = name_space
                                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-bytes"):
                                                                        self.exceed_bytes = value
                                                                        self.exceed_bytes.value_namespace = name_space
                                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-packets"):
                                                                        self.exceed_packets = value
                                                                        self.exceed_packets.value_namespace = name_space
                                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "exceed-rate"):
                                                                        self.exceed_rate = value
                                                                        self.exceed_rate.value_namespace = name_space
                                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "parent-drop-bytes"):
                                                                        self.parent_drop_bytes = value
                                                                        self.parent_drop_bytes.value_namespace = name_space
                                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "parent-drop-packets"):
                                                                        self.parent_drop_packets = value
                                                                        self.parent_drop_packets.value_namespace = name_space
                                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-bytes"):
                                                                        self.violate_bytes = value
                                                                        self.violate_bytes.value_namespace = name_space
                                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-packets"):
                                                                        self.violate_packets = value
                                                                        self.violate_packets.value_namespace = name_space
                                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "violate-rate"):
                                                                        self.violate_rate = value
                                                                        self.violate_rate.value_namespace = name_space
                                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                                            class WredStatsArray(Entity):
                                                                """
                                                                array of red stats
                                                                
                                                                .. attribute:: max_threshold_bytes
                                                                
                                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: max_threshold_packets
                                                                
                                                                	Dropped packets with  the average queue size at the max\-threshold
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: profile_title
                                                                
                                                                	ProfileTitle
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..300
                                                                
                                                                .. attribute:: random_drop_bytes
                                                                
                                                                	Probabilisticallydropped bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: random_drop_packets
                                                                
                                                                	Probabilistically dropped  packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_ecn_marked_bytes
                                                                
                                                                	ECN marked bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_ecn_marked_packets
                                                                
                                                                	ECN marked packets 
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: red_label
                                                                
                                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                                
                                                                .. attribute:: red_transmit_bytes
                                                                
                                                                	Transmitted bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: red_transmit_packets
                                                                
                                                                	Transmitted packets
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                

                                                                """

                                                                _prefix = 'qos-ma-oper'
                                                                _revision = '2017-04-10'

                                                                def __init__(self):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                                    self.yang_name = "wred-stats-array"
                                                                    self.yang_parent_name = "class-stats"

                                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                                    self.red_label = YList(self)

                                                                def __setattr__(self, name, value):
                                                                    self._check_monkey_patching_error(name, value)
                                                                    with _handle_type_error():
                                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                "Please use list append or extend method."
                                                                                                .format(value))
                                                                        if isinstance(value, Enum.YLeaf):
                                                                            value = value.name
                                                                        if name in ("max_threshold_bytes",
                                                                                    "max_threshold_packets",
                                                                                    "profile_title",
                                                                                    "random_drop_bytes",
                                                                                    "random_drop_packets",
                                                                                    "red_ecn_marked_bytes",
                                                                                    "red_ecn_marked_packets",
                                                                                    "red_transmit_bytes",
                                                                                    "red_transmit_packets") and name in self.__dict__:
                                                                            if isinstance(value, YLeaf):
                                                                                self.__dict__[name].set(value.get())
                                                                            elif isinstance(value, YLeafList):
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                            else:
                                                                                self.__dict__[name].set(value)
                                                                        else:
                                                                            if hasattr(value, "parent") and name != "parent":
                                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                    value.parent = self
                                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                    value.parent = self
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                                class RedLabel(Entity):
                                                                    """
                                                                    Array of WRED Typevalues as in PRP stats is
                                                                    available per threshold   
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	WRED value for this type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: wred_type
                                                                    
                                                                    	WRED type DSCP, EXP, PREC etc
                                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'qos-ma-oper'
                                                                    _revision = '2017-04-10'

                                                                    def __init__(self):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                        self.yang_name = "red-label"
                                                                        self.yang_parent_name = "wred-stats-array"

                                                                        self.value = YLeaf(YType.uint8, "value")

                                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                                    def __setattr__(self, name, value):
                                                                        self._check_monkey_patching_error(name, value)
                                                                        with _handle_type_error():
                                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                                    "Please use list append or extend method."
                                                                                                    .format(value))
                                                                            if isinstance(value, Enum.YLeaf):
                                                                                value = value.name
                                                                            if name in ("value",
                                                                                        "wred_type") and name in self.__dict__:
                                                                                if isinstance(value, YLeaf):
                                                                                    self.__dict__[name].set(value.get())
                                                                                elif isinstance(value, YLeafList):
                                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                                else:
                                                                                    self.__dict__[name].set(value)
                                                                            else:
                                                                                if hasattr(value, "parent") and name != "parent":
                                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                        value.parent = self
                                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                        value.parent = self
                                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                                    def has_data(self):
                                                                        return (
                                                                            self.value.is_set or
                                                                            self.wred_type.is_set)

                                                                    def has_operation(self):
                                                                        return (
                                                                            self.yfilter != YFilter.not_set or
                                                                            self.value.yfilter != YFilter.not_set or
                                                                            self.wred_type.yfilter != YFilter.not_set)

                                                                    def get_segment_path(self):
                                                                        path_buffer = ""
                                                                        path_buffer = "red-label" + path_buffer

                                                                        return path_buffer

                                                                    def get_entity_path(self, ancestor):
                                                                        path_buffer = ""
                                                                        if (ancestor is None):
                                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                        else:
                                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                        leaf_name_data = LeafDataList()
                                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                        return entity_path

                                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                        if child is not None:
                                                                            return child

                                                                        return None

                                                                    def has_leaf_or_child_of_name(self, name):
                                                                        if(name == "value" or name == "wred-type"):
                                                                            return True
                                                                        return False

                                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                        if(value_path == "value"):
                                                                            self.value = value
                                                                            self.value.value_namespace = name_space
                                                                            self.value.value_namespace_prefix = name_space_prefix
                                                                        if(value_path == "wred-type"):
                                                                            self.wred_type = value
                                                                            self.wred_type.value_namespace = name_space
                                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                                def has_data(self):
                                                                    for c in self.red_label:
                                                                        if (c.has_data()):
                                                                            return True
                                                                    return (
                                                                        self.max_threshold_bytes.is_set or
                                                                        self.max_threshold_packets.is_set or
                                                                        self.profile_title.is_set or
                                                                        self.random_drop_bytes.is_set or
                                                                        self.random_drop_packets.is_set or
                                                                        self.red_ecn_marked_bytes.is_set or
                                                                        self.red_ecn_marked_packets.is_set or
                                                                        self.red_transmit_bytes.is_set or
                                                                        self.red_transmit_packets.is_set)

                                                                def has_operation(self):
                                                                    for c in self.red_label:
                                                                        if (c.has_operation()):
                                                                            return True
                                                                    return (
                                                                        self.yfilter != YFilter.not_set or
                                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                        self.profile_title.yfilter != YFilter.not_set or
                                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                                def get_segment_path(self):
                                                                    path_buffer = ""
                                                                    path_buffer = "wred-stats-array" + path_buffer

                                                                    return path_buffer

                                                                def get_entity_path(self, ancestor):
                                                                    path_buffer = ""
                                                                    if (ancestor is None):
                                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                    else:
                                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                    leaf_name_data = LeafDataList()
                                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                    return entity_path

                                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                    if child is not None:
                                                                        return child

                                                                    if (child_yang_name == "red-label"):
                                                                        for c in self.red_label:
                                                                            segment = c.get_segment_path()
                                                                            if (segment_path == segment):
                                                                                return c
                                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                        c.parent = self
                                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                                        self._local_refs[local_reference_key] = c
                                                                        self.red_label.append(c)
                                                                        return c

                                                                    return None

                                                                def has_leaf_or_child_of_name(self, name):
                                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                        return True
                                                                    return False

                                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                    if(value_path == "max-threshold-bytes"):
                                                                        self.max_threshold_bytes = value
                                                                        self.max_threshold_bytes.value_namespace = name_space
                                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "max-threshold-packets"):
                                                                        self.max_threshold_packets = value
                                                                        self.max_threshold_packets.value_namespace = name_space
                                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "profile-title"):
                                                                        self.profile_title = value
                                                                        self.profile_title.value_namespace = name_space
                                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-bytes"):
                                                                        self.random_drop_bytes = value
                                                                        self.random_drop_bytes.value_namespace = name_space
                                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "random-drop-packets"):
                                                                        self.random_drop_packets = value
                                                                        self.random_drop_packets.value_namespace = name_space
                                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-ecn-marked-bytes"):
                                                                        self.red_ecn_marked_bytes = value
                                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-ecn-marked-packets"):
                                                                        self.red_ecn_marked_packets = value
                                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-transmit-bytes"):
                                                                        self.red_transmit_bytes = value
                                                                        self.red_transmit_bytes.value_namespace = name_space
                                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                                    if(value_path == "red-transmit-packets"):
                                                                        self.red_transmit_packets = value
                                                                        self.red_transmit_packets.value_namespace = name_space
                                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                            def has_data(self):
                                                                for c in self.police_stats_array:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.queue_stats_array:
                                                                    if (c.has_data()):
                                                                        return True
                                                                for c in self.wred_stats_array:
                                                                    if (c.has_data()):
                                                                        return True
                                                                return (
                                                                    self.cac_state.is_set or
                                                                    self.class_name.is_set or
                                                                    self.counter_validity_bitmask.is_set or
                                                                    self.queue_descr.is_set or
                                                                    self.shared_queue_id.is_set or
                                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                            def has_operation(self):
                                                                for c in self.police_stats_array:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.queue_stats_array:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                for c in self.wred_stats_array:
                                                                    if (c.has_operation()):
                                                                        return True
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.cac_state.yfilter != YFilter.not_set or
                                                                    self.class_name.yfilter != YFilter.not_set or
                                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                if (child_yang_name == "cac-stats"):
                                                                    if (self.cac_stats is None):
                                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                        self.cac_stats.parent = self
                                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                                    return self.cac_stats

                                                                if (child_yang_name == "general-stats"):
                                                                    if (self.general_stats is None):
                                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                        self.general_stats.parent = self
                                                                        self._children_name_map["general_stats"] = "general-stats"
                                                                    return self.general_stats

                                                                if (child_yang_name == "iphc-stats"):
                                                                    if (self.iphc_stats is None):
                                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                        self.iphc_stats.parent = self
                                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                                    return self.iphc_stats

                                                                if (child_yang_name == "police-stats-array"):
                                                                    for c in self.police_stats_array:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.police_stats_array.append(c)
                                                                    return c

                                                                if (child_yang_name == "queue-stats-array"):
                                                                    for c in self.queue_stats_array:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.queue_stats_array.append(c)
                                                                    return c

                                                                if (child_yang_name == "wred-stats-array"):
                                                                    for c in self.wred_stats_array:
                                                                        segment = c.get_segment_path()
                                                                        if (segment_path == segment):
                                                                            return c
                                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                                    c.parent = self
                                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                                    self._local_refs[local_reference_key] = c
                                                                    self.wred_stats_array.append(c)
                                                                    return c

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "cac-state"):
                                                                    self.cac_state = value
                                                                    self.cac_state.value_namespace = name_space
                                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "class-name"):
                                                                    self.class_name = value
                                                                    self.class_name.value_namespace = name_space
                                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "counter-validity-bitmask"):
                                                                    self.counter_validity_bitmask = value
                                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "queue-descr"):
                                                                    self.queue_descr = value
                                                                    self.queue_descr.value_namespace = name_space
                                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "shared-queue-id"):
                                                                    self.shared_queue_id = value
                                                                    self.shared_queue_id.value_namespace = name_space
                                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.class_stats:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.policy_name.is_set or
                                                                self.satid.is_set or
                                                                self.state.is_set or
                                                                self.state_description.is_set)

                                                        def has_operation(self):
                                                            for c in self.class_stats:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.policy_name.yfilter != YFilter.not_set or
                                                                self.satid.yfilter != YFilter.not_set or
                                                                self.state.yfilter != YFilter.not_set or
                                                                self.state_description.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "child-policy" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.state.get_name_leafdata())
                                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "class-stats"):
                                                                for c in self.class_stats:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.class_stats.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "policy-name"):
                                                                self.policy_name = value
                                                                self.policy_name.value_namespace = name_space
                                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "satid"):
                                                                self.satid = value
                                                                self.satid.value_namespace = name_space
                                                                self.satid.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "state"):
                                                                self.state = value
                                                                self.state.value_namespace = name_space
                                                                self.state.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "state-description"):
                                                                self.state_description = value
                                                                self.state_description.value_namespace = name_space
                                                                self.state_description.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.child_policy is not None and self.child_policy.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.child_policy is not None and self.child_policy.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "child-policy"):
                                                            if (self.child_policy is None):
                                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                                                self.child_policy.parent = self
                                                                self._children_name_map["child_policy"] = "child-policy"
                                                            return self.child_policy

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "statistics" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                                    (self.statistics is not None and self.statistics.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                                    (self.statistics is not None and self.statistics.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "output" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "service-policy-names"):
                                                    if (self.service_policy_names is None):
                                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                                        self.service_policy_names.parent = self
                                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                                    return self.service_policy_names

                                                if (child_yang_name == "statistics"):
                                                    if (self.statistics is None):
                                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics()
                                                        self.statistics.parent = self
                                                        self._children_name_map["statistics"] = "statistics"
                                                    return self.statistics

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-names" or name == "statistics"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass

                                        def has_data(self):
                                            return (
                                                self.nv_satellite_id.is_set or
                                                (self.input is not None and self.input.has_data()) or
                                                (self.output is not None and self.output.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.nv_satellite_id.yfilter != YFilter.not_set or
                                                (self.input is not None and self.input.has_operation()) or
                                                (self.output is not None and self.output.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "satellite-id" + "[nv-satellite-id='" + self.nv_satellite_id.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.nv_satellite_id.is_set or self.nv_satellite_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nv_satellite_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "input"):
                                                if (self.input is None):
                                                    self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                                    self.input.parent = self
                                                    self._children_name_map["input"] = "input"
                                                return self.input

                                            if (child_yang_name == "output"):
                                                if (self.output is None):
                                                    self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                                    self.output.parent = self
                                                    self._children_name_map["output"] = "output"
                                                return self.output

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "input" or name == "output" or name == "nv-satellite-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "nv-satellite-id"):
                                                self.nv_satellite_id = value
                                                self.nv_satellite_id.value_namespace = name_space
                                                self.nv_satellite_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.satellite_id:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.satellite_id:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "satellite-ids" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "satellite-id"):
                                            for c in self.satellite_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.satellite_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "satellite-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Input(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames>`
                                    
                                    .. attribute:: statistics
                                    
                                    	Policy\-map statistics operational data for an interface
                                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input, self).__init__()

                                        self.yang_name = "input"
                                        self.yang_parent_name = "member-interface"

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._children_yang_names.add("service-policy-names")

                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                        self._children_yang_names.add("statistics")


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "input"

                                            self.service_policy_instance = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__setattr__(name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  <key>
                                            
                                            	Name of the policy instance
                                            	**type**\:  str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"

                                                self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("service_policy_name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.service_policy_name.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.service_policy_name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "service-policy-name"):
                                                    self.service_policy_name = value
                                                    self.service_policy_name.value_namespace = name_space
                                                    self.service_policy_name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-names" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "service-policy-instance"):
                                                for c in self.service_policy_instance:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.service_policy_instance.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-instance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Statistics(Entity):
                                        """
                                        Policy\-map statistics operational data for an
                                        interface
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics, self).__init__()

                                            self.yang_name = "statistics"
                                            self.yang_parent_name = "input"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "statistics"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                                self._children_yang_names.add("child-policy")

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "child-policy" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.child_policy is not None and self.child_policy.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.child_policy is not None and self.child_policy.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "child-policy"):
                                                    if (self.child_policy is None):
                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                    return self.child_policy

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "statistics" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                            (self.statistics is not None and self.statistics.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                            (self.statistics is not None and self.statistics.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "input" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-names"):
                                            if (self.service_policy_names is None):
                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                            return self.service_policy_names

                                        if (child_yang_name == "statistics"):
                                            if (self.statistics is None):
                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                            return self.statistics

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-names" or name == "statistics"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Output(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames>`
                                    
                                    .. attribute:: statistics
                                    
                                    	Policy\-map statistics operational data for an interface
                                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output, self).__init__()

                                        self.yang_name = "output"
                                        self.yang_parent_name = "member-interface"

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._children_yang_names.add("service-policy-names")

                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                        self._children_yang_names.add("statistics")


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "output"

                                            self.service_policy_instance = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__setattr__(name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  <key>
                                            
                                            	Name of the policy instance
                                            	**type**\:  str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"

                                                self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("service_policy_name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.service_policy_name.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.service_policy_name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "service-policy-name"):
                                                    self.service_policy_name = value
                                                    self.service_policy_name.value_namespace = name_space
                                                    self.service_policy_name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-names" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "service-policy-instance"):
                                                for c in self.service_policy_instance:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.service_policy_instance.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-instance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Statistics(Entity):
                                        """
                                        Policy\-map statistics operational data for an
                                        interface
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics, self).__init__()

                                            self.yang_name = "statistics"
                                            self.yang_parent_name = "output"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "statistics"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                                self._children_yang_names.add("child-policy")

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "child-policy" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.child_policy is not None and self.child_policy.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.child_policy is not None and self.child_policy.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "child-policy"):
                                                    if (self.child_policy is None):
                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                    return self.child_policy

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "statistics" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                            (self.statistics is not None and self.statistics.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                            (self.statistics is not None and self.statistics.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "output" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-names"):
                                            if (self.service_policy_names is None):
                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                            return self.service_policy_names

                                        if (child_yang_name == "statistics"):
                                            if (self.statistics is None):
                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                            return self.statistics

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-names" or name == "statistics"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.interface_name.is_set or
                                        (self.input is not None and self.input.has_data()) or
                                        (self.output is not None and self.output.has_data()) or
                                        (self.satellite_ids is not None and self.satellite_ids.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        (self.input is not None and self.input.has_operation()) or
                                        (self.output is not None and self.output.has_operation()) or
                                        (self.satellite_ids is not None and self.satellite_ids.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "member-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "input"):
                                        if (self.input is None):
                                            self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input()
                                            self.input.parent = self
                                            self._children_name_map["input"] = "input"
                                        return self.input

                                    if (child_yang_name == "output"):
                                        if (self.output is None):
                                            self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output()
                                            self.output.parent = self
                                            self._children_name_map["output"] = "output"
                                        return self.output

                                    if (child_yang_name == "satellite-ids"):
                                        if (self.satellite_ids is None):
                                            self.satellite_ids = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds()
                                            self.satellite_ids.parent = self
                                            self._children_name_map["satellite_ids"] = "satellite-ids"
                                        return self.satellite_ids

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "input" or name == "output" or name == "satellite-ids" or name == "interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.member_interface:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.member_interface:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "member-interfaces" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "member-interface"):
                                    for c in self.member_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces.MemberInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.member_interface.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "member-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class SatelliteIds(Entity):
                            """
                            Satellite ID information
                            
                            .. attribute:: satellite_id
                            
                            	Satellite ID information
                            	**type**\: list of    :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds, self).__init__()

                                self.yang_name = "satellite-ids"
                                self.yang_parent_name = "interface"

                                self.satellite_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds, self).__setattr__(name, value)


                            class SatelliteId(Entity):
                                """
                                Satellite ID information
                                
                                .. attribute:: nv_satellite_id  <key>
                                
                                	Satellite ID
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: input
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input>`
                                
                                .. attribute:: output
                                
                                	A piece of QoS policy\-map operational data for an interface
                                	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId, self).__init__()

                                    self.yang_name = "satellite-id"
                                    self.yang_parent_name = "satellite-ids"

                                    self.nv_satellite_id = YLeaf(YType.int32, "nv-satellite-id")

                                    self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input()
                                    self.input.parent = self
                                    self._children_name_map["input"] = "input"
                                    self._children_yang_names.add("input")

                                    self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output()
                                    self.output.parent = self
                                    self._children_name_map["output"] = "output"
                                    self._children_yang_names.add("output")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("nv_satellite_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId, self).__setattr__(name, value)


                                class Input(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                                    
                                    .. attribute:: statistics
                                    
                                    	Policy\-map statistics operational data for an interface
                                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input, self).__init__()

                                        self.yang_name = "input"
                                        self.yang_parent_name = "satellite-id"

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._children_yang_names.add("service-policy-names")

                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                        self._children_yang_names.add("statistics")


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "input"

                                            self.service_policy_instance = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  <key>
                                            
                                            	Name of the policy instance
                                            	**type**\:  str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"

                                                self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("service_policy_name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.service_policy_name.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.service_policy_name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "service-policy-name"):
                                                    self.service_policy_name = value
                                                    self.service_policy_name.value_namespace = name_space
                                                    self.service_policy_name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-names" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "service-policy-instance"):
                                                for c in self.service_policy_instance:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.service_policy_instance.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-instance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Statistics(Entity):
                                        """
                                        Policy\-map statistics operational data for an
                                        interface
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics, self).__init__()

                                            self.yang_name = "statistics"
                                            self.yang_parent_name = "input"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "statistics"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                                self._children_yang_names.add("child-policy")

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "child-policy" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.child_policy is not None and self.child_policy.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.child_policy is not None and self.child_policy.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "child-policy"):
                                                    if (self.child_policy is None):
                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                    return self.child_policy

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "statistics" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                            (self.statistics is not None and self.statistics.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                            (self.statistics is not None and self.statistics.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "input" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-names"):
                                            if (self.service_policy_names is None):
                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                            return self.service_policy_names

                                        if (child_yang_name == "statistics"):
                                            if (self.statistics is None):
                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                            return self.statistics

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-names" or name == "statistics"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Output(Entity):
                                    """
                                    A piece of QoS policy\-map operational data for
                                    an interface
                                    
                                    .. attribute:: service_policy_names
                                    
                                    	Operational data for all Policy instance
                                    	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                                    
                                    .. attribute:: statistics
                                    
                                    	Policy\-map statistics operational data for an interface
                                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output, self).__init__()

                                        self.yang_name = "output"
                                        self.yang_parent_name = "satellite-id"

                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                        self._children_yang_names.add("service-policy-names")

                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                        self._children_yang_names.add("statistics")


                                    class ServicePolicyNames(Entity):
                                        """
                                        Operational data for all Policy instance
                                        
                                        .. attribute:: service_policy_instance
                                        
                                        	QoS policy\-map operational data for a particular Policy 
                                        	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                            self.yang_name = "service-policy-names"
                                            self.yang_parent_name = "output"

                                            self.service_policy_instance = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)


                                        class ServicePolicyInstance(Entity):
                                            """
                                            QoS policy\-map operational data for a
                                            particular Policy 
                                            
                                            .. attribute:: service_policy_name  <key>
                                            
                                            	Name of the policy instance
                                            	**type**\:  str
                                            
                                            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                                self.yang_name = "service-policy-instance"
                                                self.yang_parent_name = "service-policy-names"

                                                self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("service_policy_name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.service_policy_name.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.service_policy_name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "service-policy-name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "service-policy-name"):
                                                    self.service_policy_name = value
                                                    self.service_policy_name.value_namespace = name_space
                                                    self.service_policy_name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.service_policy_instance:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-names" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "service-policy-instance"):
                                                for c in self.service_policy_instance:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.service_policy_instance.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-instance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Statistics(Entity):
                                        """
                                        Policy\-map statistics operational data for an
                                        interface
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics, self).__init__()

                                            self.yang_name = "statistics"
                                            self.yang_parent_name = "output"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "statistics"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                                self._children_yang_names.add("child-policy")

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "child-policy" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.child_policy is not None and self.child_policy.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.child_policy is not None and self.child_policy.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "child-policy"):
                                                    if (self.child_policy is None):
                                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                    return self.child_policy

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "statistics" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                            (self.statistics is not None and self.statistics.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                            (self.statistics is not None and self.statistics.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "output" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-names"):
                                            if (self.service_policy_names is None):
                                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                                self.service_policy_names.parent = self
                                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                            return self.service_policy_names

                                        if (child_yang_name == "statistics"):
                                            if (self.statistics is None):
                                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics()
                                                self.statistics.parent = self
                                                self._children_name_map["statistics"] = "statistics"
                                            return self.statistics

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-names" or name == "statistics"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.nv_satellite_id.is_set or
                                        (self.input is not None and self.input.has_data()) or
                                        (self.output is not None and self.output.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.nv_satellite_id.yfilter != YFilter.not_set or
                                        (self.input is not None and self.input.has_operation()) or
                                        (self.output is not None and self.output.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "satellite-id" + "[nv-satellite-id='" + self.nv_satellite_id.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.nv_satellite_id.is_set or self.nv_satellite_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nv_satellite_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "input"):
                                        if (self.input is None):
                                            self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input()
                                            self.input.parent = self
                                            self._children_name_map["input"] = "input"
                                        return self.input

                                    if (child_yang_name == "output"):
                                        if (self.output is None):
                                            self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output()
                                            self.output.parent = self
                                            self._children_name_map["output"] = "output"
                                        return self.output

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "input" or name == "output" or name == "nv-satellite-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "nv-satellite-id"):
                                        self.nv_satellite_id = value
                                        self.nv_satellite_id.value_namespace = name_space
                                        self.nv_satellite_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.satellite_id:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.satellite_id:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "satellite-ids" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "satellite-id"):
                                    for c in self.satellite_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds.SatelliteId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.satellite_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "satellite-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Input(Entity):
                            """
                            A piece of QoS policy\-map operational data for
                            an interface
                            
                            .. attribute:: service_policy_names
                            
                            	Operational data for all Policy instance
                            	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames>`
                            
                            .. attribute:: statistics
                            
                            	Policy\-map statistics operational data for an interface
                            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input, self).__init__()

                                self.yang_name = "input"
                                self.yang_parent_name = "interface"

                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames()
                                self.service_policy_names.parent = self
                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                self._children_yang_names.add("service-policy-names")

                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                                self._children_yang_names.add("statistics")


                            class ServicePolicyNames(Entity):
                                """
                                Operational data for all Policy instance
                                
                                .. attribute:: service_policy_instance
                                
                                	QoS policy\-map operational data for a particular Policy 
                                	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames, self).__init__()

                                    self.yang_name = "service-policy-names"
                                    self.yang_parent_name = "input"

                                    self.service_policy_instance = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames, self).__setattr__(name, value)


                                class ServicePolicyInstance(Entity):
                                    """
                                    QoS policy\-map operational data for a
                                    particular Policy 
                                    
                                    .. attribute:: service_policy_name  <key>
                                    
                                    	Name of the policy instance
                                    	**type**\:  str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                        self.yang_name = "service-policy-instance"
                                        self.yang_parent_name = "service-policy-names"

                                        self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("service_policy_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.service_policy_name.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.service_policy_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "service-policy-name"):
                                            self.service_policy_name = value
                                            self.service_policy_name.value_namespace = name_space
                                            self.service_policy_name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.service_policy_instance:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.service_policy_instance:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-names" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "service-policy-instance"):
                                        for c in self.service_policy_instance:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.service_policy_instance.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-instance"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Statistics(Entity):
                                """
                                Policy\-map statistics operational data for an
                                interface
                                
                                .. attribute:: class_stats
                                
                                	array of classes contained in policy
                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats>`
                                
                                .. attribute:: policy_name
                                
                                	PolicyName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: satid
                                
                                	to maintain satellite id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: state
                                
                                	State
                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                
                                .. attribute:: state_description
                                
                                	StateDescription
                                	**type**\:  str
                                
                                	**length:** 0..128
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics, self).__init__()

                                    self.yang_name = "statistics"
                                    self.yang_parent_name = "input"

                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                    self.satid = YLeaf(YType.uint32, "satid")

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_description = YLeaf(YType.str, "state-description")

                                    self.class_stats = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("policy_name",
                                                    "satid",
                                                    "state",
                                                    "state_description") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics, self).__setattr__(name, value)


                                class ClassStats(Entity):
                                    """
                                    array of classes contained in policy
                                    
                                    .. attribute:: cac_state
                                    
                                    	CACState
                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                    
                                    .. attribute:: cac_stats
                                    
                                    	bag for cac stats
                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.CacStats>`
                                    
                                    .. attribute:: child_policy
                                    
                                    	child policy
                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy>`
                                    
                                    .. attribute:: class_name
                                    
                                    	ClassName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: counter_validity_bitmask
                                    
                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: megabyte
                                    
                                    .. attribute:: general_stats
                                    
                                    	general stats
                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats>`
                                    
                                    .. attribute:: iphc_stats
                                    
                                    	IPHC stats
                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats>`
                                    
                                    .. attribute:: police_stats_array
                                    
                                    	array of police stats
                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray>`
                                    
                                    .. attribute:: queue_descr
                                    
                                    	Description of queue for the class
                                    	**type**\:  str
                                    
                                    	**length:** 0..256
                                    
                                    .. attribute:: queue_stats_array
                                    
                                    	array of queue stats
                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray>`
                                    
                                    .. attribute:: shared_queue_id
                                    
                                    	q\-id of the  shared queue for this class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wred_stats_array
                                    
                                    	array of red stats
                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats, self).__init__()

                                        self.yang_name = "class-stats"
                                        self.yang_parent_name = "statistics"

                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                        self.class_name = YLeaf(YType.str, "class-name")

                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.CacStats()
                                        self.cac_stats.parent = self
                                        self._children_name_map["cac_stats"] = "cac-stats"
                                        self._children_yang_names.add("cac-stats")

                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy()
                                        self.child_policy.parent = self
                                        self._children_name_map["child_policy"] = "child-policy"
                                        self._children_yang_names.add("child-policy")

                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats()
                                        self.general_stats.parent = self
                                        self._children_name_map["general_stats"] = "general-stats"
                                        self._children_yang_names.add("general-stats")

                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats()
                                        self.iphc_stats.parent = self
                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                        self._children_yang_names.add("iphc-stats")

                                        self.police_stats_array = YList(self)
                                        self.queue_stats_array = YList(self)
                                        self.wred_stats_array = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("cac_state",
                                                        "class_name",
                                                        "counter_validity_bitmask",
                                                        "queue_descr",
                                                        "shared_queue_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                    class GeneralStats(Entity):
                                        """
                                        general stats
                                        
                                        .. attribute:: match_data_rate
                                        
                                        	Incoming matched data rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: pre_policy_matched_bytes
                                        
                                        	Matched bytes before applying policy
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: pre_policy_matched_packets
                                        
                                        	Matched pkts before applying policy
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: total_drop_bytes
                                        
                                        	Dropped bytes (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_packets
                                        
                                        	Dropped packets (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_rate
                                        
                                        	Total drop rate (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_transmit_rate
                                        
                                        	Total transmit rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: transmit_bytes
                                        
                                        	Transmitted bytes (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: transmit_packets
                                        
                                        	Transmitted packets (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                            self.yang_name = "general-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("match_data_rate",
                                                            "pre_policy_matched_bytes",
                                                            "pre_policy_matched_packets",
                                                            "total_drop_bytes",
                                                            "total_drop_packets",
                                                            "total_drop_rate",
                                                            "total_transmit_rate",
                                                            "transmit_bytes",
                                                            "transmit_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.match_data_rate.is_set or
                                                self.pre_policy_matched_bytes.is_set or
                                                self.pre_policy_matched_packets.is_set or
                                                self.total_drop_bytes.is_set or
                                                self.total_drop_packets.is_set or
                                                self.total_drop_rate.is_set or
                                                self.total_transmit_rate.is_set or
                                                self.transmit_bytes.is_set or
                                                self.transmit_packets.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                self.transmit_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "general-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "match-data-rate"):
                                                self.match_data_rate = value
                                                self.match_data_rate.value_namespace = name_space
                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pre-policy-matched-bytes"):
                                                self.pre_policy_matched_bytes = value
                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pre-policy-matched-packets"):
                                                self.pre_policy_matched_packets = value
                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-bytes"):
                                                self.total_drop_bytes = value
                                                self.total_drop_bytes.value_namespace = name_space
                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-packets"):
                                                self.total_drop_packets = value
                                                self.total_drop_packets.value_namespace = name_space
                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-rate"):
                                                self.total_drop_rate = value
                                                self.total_drop_rate.value_namespace = name_space
                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-transmit-rate"):
                                                self.total_transmit_rate = value
                                                self.total_transmit_rate.value_namespace = name_space
                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "transmit-bytes"):
                                                self.transmit_bytes = value
                                                self.transmit_bytes.value_namespace = name_space
                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "transmit-packets"):
                                                self.transmit_packets = value
                                                self.transmit_packets.value_namespace = name_space
                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                    class IphcStats(Entity):
                                        """
                                        IPHC stats
                                        
                                        .. attribute:: non_tcp_bytes_saved
                                        
                                        	Non Tcp Bytes saved due to compression
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_bytes_sent_rate
                                        
                                        	Compressed Non Tcp Bytes sent rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_compressed_packets_out
                                        
                                        	Num of non tcp compressed pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: non_tcp_full_header_packets_out
                                        
                                        	Num of non tcp fullheader pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: non_tcp_total_out_bytes
                                        
                                        	TotalNum of Non Tcp Bytes sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_total_out_packets
                                        
                                        	TotalNum of Non tcp pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_bytes_saved
                                        
                                        	Tcp Bytes saved due to compression
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_bytes_sent_rate
                                        
                                        	Compressed Tcp Bytes sent rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_compressed_packets_out
                                        
                                        	Num of tcp compressed pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_full_header_packets_out
                                        
                                        	Num of tcp fullheader pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_total_out_bytes
                                        
                                        	TotalNum of Tcp Bytes sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_total_out_packets
                                        
                                        	Total Num of tcp pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                            self.yang_name = "iphc-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("non_tcp_bytes_saved",
                                                            "non_tcp_bytes_sent_rate",
                                                            "non_tcp_compressed_packets_out",
                                                            "non_tcp_full_header_packets_out",
                                                            "non_tcp_total_out_bytes",
                                                            "non_tcp_total_out_packets",
                                                            "tcp_bytes_saved",
                                                            "tcp_bytes_sent_rate",
                                                            "tcp_compressed_packets_out",
                                                            "tcp_full_header_packets_out",
                                                            "tcp_total_out_bytes",
                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.non_tcp_bytes_saved.is_set or
                                                self.non_tcp_bytes_sent_rate.is_set or
                                                self.non_tcp_compressed_packets_out.is_set or
                                                self.non_tcp_full_header_packets_out.is_set or
                                                self.non_tcp_total_out_bytes.is_set or
                                                self.non_tcp_total_out_packets.is_set or
                                                self.tcp_bytes_saved.is_set or
                                                self.tcp_bytes_sent_rate.is_set or
                                                self.tcp_compressed_packets_out.is_set or
                                                self.tcp_full_header_packets_out.is_set or
                                                self.tcp_total_out_bytes.is_set or
                                                self.tcp_total_out_packets.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "iphc-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "non-tcp-bytes-saved"):
                                                self.non_tcp_bytes_saved = value
                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                self.non_tcp_bytes_sent_rate = value
                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                self.non_tcp_compressed_packets_out = value
                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                self.non_tcp_full_header_packets_out = value
                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-total-out-bytes"):
                                                self.non_tcp_total_out_bytes = value
                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-total-out-packets"):
                                                self.non_tcp_total_out_packets = value
                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-bytes-saved"):
                                                self.tcp_bytes_saved = value
                                                self.tcp_bytes_saved.value_namespace = name_space
                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-bytes-sent-rate"):
                                                self.tcp_bytes_sent_rate = value
                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-compressed-packets-out"):
                                                self.tcp_compressed_packets_out = value
                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-full-header-packets-out"):
                                                self.tcp_full_header_packets_out = value
                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-total-out-bytes"):
                                                self.tcp_total_out_bytes = value
                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-total-out-packets"):
                                                self.tcp_total_out_packets = value
                                                self.tcp_total_out_packets.value_namespace = name_space
                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                    class ChildPolicy(Entity):
                                        """
                                        child policy
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                            self.yang_name = "child-policy"
                                            self.yang_parent_name = "class-stats"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "child-policy"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "child-policy" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix


                                    class CacStats(Entity):
                                        """
                                        bag for cac stats
                                        
                                        .. attribute:: admit_bytes
                                        
                                        	Admitted bytes (pkts/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: admit_rates
                                        
                                        	CAC admit rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: admitpackets
                                        
                                        	Admitted packets (pkts/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_bytes
                                        
                                        	CAC dropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_packets
                                        
                                        	CAC dropped packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: drop_rates
                                        
                                        	CAC dropped rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.CacStats, self).__init__()

                                            self.yang_name = "cac-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("admit_bytes",
                                                            "admit_rates",
                                                            "admitpackets",
                                                            "drop_bytes",
                                                            "drop_packets",
                                                            "drop_rates") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.admit_bytes.is_set or
                                                self.admit_rates.is_set or
                                                self.admitpackets.is_set or
                                                self.drop_bytes.is_set or
                                                self.drop_packets.is_set or
                                                self.drop_rates.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                self.admit_rates.yfilter != YFilter.not_set or
                                                self.admitpackets.yfilter != YFilter.not_set or
                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                self.drop_packets.yfilter != YFilter.not_set or
                                                self.drop_rates.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "cac-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "admit-bytes"):
                                                self.admit_bytes = value
                                                self.admit_bytes.value_namespace = name_space
                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "admit-rates"):
                                                self.admit_rates = value
                                                self.admit_rates.value_namespace = name_space
                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                            if(value_path == "admitpackets"):
                                                self.admitpackets = value
                                                self.admitpackets.value_namespace = name_space
                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-bytes"):
                                                self.drop_bytes = value
                                                self.drop_bytes.value_namespace = name_space
                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-packets"):
                                                self.drop_packets = value
                                                self.drop_packets.value_namespace = name_space
                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-rates"):
                                                self.drop_rates = value
                                                self.drop_rates.value_namespace = name_space
                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                    class QueueStatsArray(Entity):
                                        """
                                        array of queue stats
                                        
                                        .. attribute:: atm_clp0_drop_bytes
                                        
                                        	ATP CLP 0 matched bytes dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: atm_clp0_drop_packets
                                        
                                        	ATP CLP 0 matched packets dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: atm_clp1_drop_bytes
                                        
                                        	ATP CLP 0 matched bytes dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: atm_clp1_drop_packets
                                        
                                        	ATP CLP 0 matched packets dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_bytes
                                        
                                        	Bytes that conform to the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_packets
                                        
                                        	Packets that conform  to the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_rate
                                        
                                        	Conform rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: exceed_bytes
                                        
                                        	Bytes that exceed  the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_packets
                                        
                                        	Packets that exceed the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_rate
                                        
                                        	Exceed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: forced_wred_stats_display
                                        
                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                        	**type**\:  bool
                                        
                                        .. attribute:: max_threshold_bytes
                                        
                                        	Dropped bytes with the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: max_threshold_packets
                                        
                                        	Dropped packets with the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: queue_average_length
                                        
                                        	Queue average length
                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                        
                                        .. attribute:: queue_drop_threshold
                                        
                                        	tail drop threshold of the queue in bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: queue_id
                                        
                                        	Queue Id used for Fabric Stats
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_instance_length
                                        
                                        	Queue instance length
                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                        
                                        .. attribute:: queue_max_length
                                        
                                        	Queue maximum length
                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                        
                                        .. attribute:: random_drop_bytes
                                        
                                        	Bytes probabilistically dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: random_drop_packets
                                        
                                        	Packets probabilistically dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tail_drop_bytes
                                        
                                        	Bytes tail dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tail_drop_packets
                                        
                                        	Packets tail dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                            self.yang_name = "queue-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                            self.queue_average_length = YList(self)
                                            self.queue_instance_length = YList(self)
                                            self.queue_max_length = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("atm_clp0_drop_bytes",
                                                            "atm_clp0_drop_packets",
                                                            "atm_clp1_drop_bytes",
                                                            "atm_clp1_drop_packets",
                                                            "conform_bytes",
                                                            "conform_packets",
                                                            "conform_rate",
                                                            "exceed_bytes",
                                                            "exceed_packets",
                                                            "exceed_rate",
                                                            "forced_wred_stats_display",
                                                            "max_threshold_bytes",
                                                            "max_threshold_packets",
                                                            "queue_drop_threshold",
                                                            "queue_id",
                                                            "random_drop_bytes",
                                                            "random_drop_packets",
                                                            "tail_drop_bytes",
                                                            "tail_drop_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                        class QueueInstanceLength(Entity):
                                            """
                                            Queue instance length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                self.yang_name = "queue-instance-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-instance-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class QueueAverageLength(Entity):
                                            """
                                            Queue average length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                self.yang_name = "queue-average-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-average-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class QueueMaxLength(Entity):
                                            """
                                            Queue maximum length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                self.yang_name = "queue-max-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-max-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.queue_average_length:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_instance_length:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_max_length:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.atm_clp0_drop_bytes.is_set or
                                                self.atm_clp0_drop_packets.is_set or
                                                self.atm_clp1_drop_bytes.is_set or
                                                self.atm_clp1_drop_packets.is_set or
                                                self.conform_bytes.is_set or
                                                self.conform_packets.is_set or
                                                self.conform_rate.is_set or
                                                self.exceed_bytes.is_set or
                                                self.exceed_packets.is_set or
                                                self.exceed_rate.is_set or
                                                self.forced_wred_stats_display.is_set or
                                                self.max_threshold_bytes.is_set or
                                                self.max_threshold_packets.is_set or
                                                self.queue_drop_threshold.is_set or
                                                self.queue_id.is_set or
                                                self.random_drop_bytes.is_set or
                                                self.random_drop_packets.is_set or
                                                self.tail_drop_bytes.is_set or
                                                self.tail_drop_packets.is_set)

                                        def has_operation(self):
                                            for c in self.queue_average_length:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_instance_length:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_max_length:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_packets.yfilter != YFilter.not_set or
                                                self.conform_rate.yfilter != YFilter.not_set or
                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                self.queue_id.yfilter != YFilter.not_set or
                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "queue-average-length"):
                                                for c in self.queue_average_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_average_length.append(c)
                                                return c

                                            if (child_yang_name == "queue-instance-length"):
                                                for c in self.queue_instance_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_instance_length.append(c)
                                                return c

                                            if (child_yang_name == "queue-max-length"):
                                                for c in self.queue_max_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_max_length.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "atm-clp0-drop-bytes"):
                                                self.atm_clp0_drop_bytes = value
                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp0-drop-packets"):
                                                self.atm_clp0_drop_packets = value
                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp1-drop-bytes"):
                                                self.atm_clp1_drop_bytes = value
                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp1-drop-packets"):
                                                self.atm_clp1_drop_packets = value
                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-bytes"):
                                                self.conform_bytes = value
                                                self.conform_bytes.value_namespace = name_space
                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-packets"):
                                                self.conform_packets = value
                                                self.conform_packets.value_namespace = name_space
                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-rate"):
                                                self.conform_rate = value
                                                self.conform_rate.value_namespace = name_space
                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-bytes"):
                                                self.exceed_bytes = value
                                                self.exceed_bytes.value_namespace = name_space
                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-packets"):
                                                self.exceed_packets = value
                                                self.exceed_packets.value_namespace = name_space
                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-rate"):
                                                self.exceed_rate = value
                                                self.exceed_rate.value_namespace = name_space
                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forced-wred-stats-display"):
                                                self.forced_wred_stats_display = value
                                                self.forced_wred_stats_display.value_namespace = name_space
                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-bytes"):
                                                self.max_threshold_bytes = value
                                                self.max_threshold_bytes.value_namespace = name_space
                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-packets"):
                                                self.max_threshold_packets = value
                                                self.max_threshold_packets.value_namespace = name_space
                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-drop-threshold"):
                                                self.queue_drop_threshold = value
                                                self.queue_drop_threshold.value_namespace = name_space
                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-id"):
                                                self.queue_id = value
                                                self.queue_id.value_namespace = name_space
                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-bytes"):
                                                self.random_drop_bytes = value
                                                self.random_drop_bytes.value_namespace = name_space
                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-packets"):
                                                self.random_drop_packets = value
                                                self.random_drop_packets.value_namespace = name_space
                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tail-drop-bytes"):
                                                self.tail_drop_bytes = value
                                                self.tail_drop_bytes.value_namespace = name_space
                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tail-drop-packets"):
                                                self.tail_drop_packets = value
                                                self.tail_drop_packets.value_namespace = name_space
                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                    class PoliceStatsArray(Entity):
                                        """
                                        array of police stats
                                        
                                        .. attribute:: color_class_stats
                                        
                                        	color class stats
                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                        
                                        .. attribute:: conform_bytes
                                        
                                        	Bytes that conform to the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_packets
                                        
                                        	Packets that conform  to the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_rate
                                        
                                        	Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: drop_bytes
                                        
                                        	Police dropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_packets
                                        
                                        	Police dropped packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_bytes
                                        
                                        	Bytes that exceed  the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_packets
                                        
                                        	Packets that exceed the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_rate
                                        
                                        	Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: parent_drop_bytes
                                        
                                        	Dropped bytes by the parent policer
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: parent_drop_packets
                                        
                                        	Dropped pkts by the parent policer
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_bytes
                                        
                                        	Bytes that violate the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_packets
                                        
                                        	Packets violating the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_rate
                                        
                                        	Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                            self.yang_name = "police-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                            self.color_class_stats.parent = self
                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                            self._children_yang_names.add("color-class-stats")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_bytes",
                                                            "conform_packets",
                                                            "conform_rate",
                                                            "drop_bytes",
                                                            "drop_packets",
                                                            "exceed_bytes",
                                                            "exceed_packets",
                                                            "exceed_rate",
                                                            "parent_drop_bytes",
                                                            "parent_drop_packets",
                                                            "violate_bytes",
                                                            "violate_packets",
                                                            "violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                        class ColorClassStats(Entity):
                                            """
                                            color class stats
                                            
                                            .. attribute:: conform_class_conform_bytes
                                            
                                            	Bytes with classification result conform and policer result conform
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_conform_packets
                                            
                                            	Packets with classification result conform and policer result conform
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_conform_rate
                                            
                                            	Conform Class Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: conform_class_exceed_bytes
                                            
                                            	Bytes with classification result conform and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_exceed_packets
                                            
                                            	Packets with classification result conform and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_exceed_rate
                                            
                                            	Conform Class Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: conform_class_violate_bytes
                                            
                                            	Bytes with classification result conform and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_violate_packets
                                            
                                            	Packets with classification result conform and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_violate_rate
                                            
                                            	Conform Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_class_exceed_bytes
                                            
                                            	Bytes with classification result exceed and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_class_exceed_packets
                                            
                                            	Packets with classification result exceed and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_class_exceed_rate
                                            
                                            	Exceed Class Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_class_violate_bytes
                                            
                                            	Bytes with classification result exceed and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_class_violate_packets
                                            
                                            	Packets with classification result exceed and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_class_violate_rate
                                            
                                            	Exceed Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_class_violate_bytes
                                            
                                            	Bytes with classification result violate and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_class_violate_packets
                                            
                                            	Packets with classification result violate and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_class_violate_rate
                                            
                                            	Violate Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                self.yang_name = "color-class-stats"
                                                self.yang_parent_name = "police-stats-array"

                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_class_conform_bytes",
                                                                "conform_class_conform_packets",
                                                                "conform_class_conform_rate",
                                                                "conform_class_exceed_bytes",
                                                                "conform_class_exceed_packets",
                                                                "conform_class_exceed_rate",
                                                                "conform_class_violate_bytes",
                                                                "conform_class_violate_packets",
                                                                "conform_class_violate_rate",
                                                                "exceed_class_exceed_bytes",
                                                                "exceed_class_exceed_packets",
                                                                "exceed_class_exceed_rate",
                                                                "exceed_class_violate_bytes",
                                                                "exceed_class_violate_packets",
                                                                "exceed_class_violate_rate",
                                                                "violate_class_violate_bytes",
                                                                "violate_class_violate_packets",
                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.conform_class_conform_bytes.is_set or
                                                    self.conform_class_conform_packets.is_set or
                                                    self.conform_class_conform_rate.is_set or
                                                    self.conform_class_exceed_bytes.is_set or
                                                    self.conform_class_exceed_packets.is_set or
                                                    self.conform_class_exceed_rate.is_set or
                                                    self.conform_class_violate_bytes.is_set or
                                                    self.conform_class_violate_packets.is_set or
                                                    self.conform_class_violate_rate.is_set or
                                                    self.exceed_class_exceed_bytes.is_set or
                                                    self.exceed_class_exceed_packets.is_set or
                                                    self.exceed_class_exceed_rate.is_set or
                                                    self.exceed_class_violate_bytes.is_set or
                                                    self.exceed_class_violate_packets.is_set or
                                                    self.exceed_class_violate_rate.is_set or
                                                    self.violate_class_violate_bytes.is_set or
                                                    self.violate_class_violate_packets.is_set or
                                                    self.violate_class_violate_rate.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "color-class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-class-conform-bytes"):
                                                    self.conform_class_conform_bytes = value
                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-conform-packets"):
                                                    self.conform_class_conform_packets = value
                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-conform-rate"):
                                                    self.conform_class_conform_rate = value
                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-bytes"):
                                                    self.conform_class_exceed_bytes = value
                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-packets"):
                                                    self.conform_class_exceed_packets = value
                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-rate"):
                                                    self.conform_class_exceed_rate = value
                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-bytes"):
                                                    self.conform_class_violate_bytes = value
                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-packets"):
                                                    self.conform_class_violate_packets = value
                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-rate"):
                                                    self.conform_class_violate_rate = value
                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-bytes"):
                                                    self.exceed_class_exceed_bytes = value
                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-packets"):
                                                    self.exceed_class_exceed_packets = value
                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-rate"):
                                                    self.exceed_class_exceed_rate = value
                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-bytes"):
                                                    self.exceed_class_violate_bytes = value
                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-packets"):
                                                    self.exceed_class_violate_packets = value
                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-rate"):
                                                    self.exceed_class_violate_rate = value
                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-bytes"):
                                                    self.violate_class_violate_bytes = value
                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-packets"):
                                                    self.violate_class_violate_packets = value
                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-rate"):
                                                    self.violate_class_violate_rate = value
                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.conform_bytes.is_set or
                                                self.conform_packets.is_set or
                                                self.conform_rate.is_set or
                                                self.drop_bytes.is_set or
                                                self.drop_packets.is_set or
                                                self.exceed_bytes.is_set or
                                                self.exceed_packets.is_set or
                                                self.exceed_rate.is_set or
                                                self.parent_drop_bytes.is_set or
                                                self.parent_drop_packets.is_set or
                                                self.violate_bytes.is_set or
                                                self.violate_packets.is_set or
                                                self.violate_rate.is_set or
                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_packets.yfilter != YFilter.not_set or
                                                self.conform_rate.yfilter != YFilter.not_set or
                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                self.drop_packets.yfilter != YFilter.not_set or
                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_packets.yfilter != YFilter.not_set or
                                                self.violate_rate.yfilter != YFilter.not_set or
                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "police-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "color-class-stats"):
                                                if (self.color_class_stats is None):
                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                return self.color_class_stats

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-bytes"):
                                                self.conform_bytes = value
                                                self.conform_bytes.value_namespace = name_space
                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-packets"):
                                                self.conform_packets = value
                                                self.conform_packets.value_namespace = name_space
                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-rate"):
                                                self.conform_rate = value
                                                self.conform_rate.value_namespace = name_space
                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-bytes"):
                                                self.drop_bytes = value
                                                self.drop_bytes.value_namespace = name_space
                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-packets"):
                                                self.drop_packets = value
                                                self.drop_packets.value_namespace = name_space
                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-bytes"):
                                                self.exceed_bytes = value
                                                self.exceed_bytes.value_namespace = name_space
                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-packets"):
                                                self.exceed_packets = value
                                                self.exceed_packets.value_namespace = name_space
                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-rate"):
                                                self.exceed_rate = value
                                                self.exceed_rate.value_namespace = name_space
                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "parent-drop-bytes"):
                                                self.parent_drop_bytes = value
                                                self.parent_drop_bytes.value_namespace = name_space
                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "parent-drop-packets"):
                                                self.parent_drop_packets = value
                                                self.parent_drop_packets.value_namespace = name_space
                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-bytes"):
                                                self.violate_bytes = value
                                                self.violate_bytes.value_namespace = name_space
                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-packets"):
                                                self.violate_packets = value
                                                self.violate_packets.value_namespace = name_space
                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-rate"):
                                                self.violate_rate = value
                                                self.violate_rate.value_namespace = name_space
                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                    class WredStatsArray(Entity):
                                        """
                                        array of red stats
                                        
                                        .. attribute:: max_threshold_bytes
                                        
                                        	Dropped bytes with  the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: max_threshold_packets
                                        
                                        	Dropped packets with  the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: profile_title
                                        
                                        	ProfileTitle
                                        	**type**\:  str
                                        
                                        	**length:** 0..300
                                        
                                        .. attribute:: random_drop_bytes
                                        
                                        	Probabilisticallydropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: random_drop_packets
                                        
                                        	Probabilistically dropped  packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: red_ecn_marked_bytes
                                        
                                        	ECN marked bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: red_ecn_marked_packets
                                        
                                        	ECN marked packets 
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: red_label
                                        
                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                        
                                        .. attribute:: red_transmit_bytes
                                        
                                        	Transmitted bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: red_transmit_packets
                                        
                                        	Transmitted packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                            self.yang_name = "wred-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                            self.red_label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("max_threshold_bytes",
                                                            "max_threshold_packets",
                                                            "profile_title",
                                                            "random_drop_bytes",
                                                            "random_drop_packets",
                                                            "red_ecn_marked_bytes",
                                                            "red_ecn_marked_packets",
                                                            "red_transmit_bytes",
                                                            "red_transmit_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                        class RedLabel(Entity):
                                            """
                                            Array of WRED Typevalues as in PRP stats is
                                            available per threshold   
                                            
                                            .. attribute:: value
                                            
                                            	WRED value for this type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: wred_type
                                            
                                            	WRED type DSCP, EXP, PREC etc
                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                self.yang_name = "red-label"
                                                self.yang_parent_name = "wred-stats-array"

                                                self.value = YLeaf(YType.uint8, "value")

                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("value",
                                                                "wred_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.value.is_set or
                                                    self.wred_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set or
                                                    self.wred_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "red-label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "value" or name == "wred-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "wred-type"):
                                                    self.wred_type = value
                                                    self.wred_type.value_namespace = name_space
                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.red_label:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.max_threshold_bytes.is_set or
                                                self.max_threshold_packets.is_set or
                                                self.profile_title.is_set or
                                                self.random_drop_bytes.is_set or
                                                self.random_drop_packets.is_set or
                                                self.red_ecn_marked_bytes.is_set or
                                                self.red_ecn_marked_packets.is_set or
                                                self.red_transmit_bytes.is_set or
                                                self.red_transmit_packets.is_set)

                                        def has_operation(self):
                                            for c in self.red_label:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                self.profile_title.yfilter != YFilter.not_set or
                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wred-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "red-label"):
                                                for c in self.red_label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.red_label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "max-threshold-bytes"):
                                                self.max_threshold_bytes = value
                                                self.max_threshold_bytes.value_namespace = name_space
                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-packets"):
                                                self.max_threshold_packets = value
                                                self.max_threshold_packets.value_namespace = name_space
                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-title"):
                                                self.profile_title = value
                                                self.profile_title.value_namespace = name_space
                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-bytes"):
                                                self.random_drop_bytes = value
                                                self.random_drop_bytes.value_namespace = name_space
                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-packets"):
                                                self.random_drop_packets = value
                                                self.random_drop_packets.value_namespace = name_space
                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-ecn-marked-bytes"):
                                                self.red_ecn_marked_bytes = value
                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-ecn-marked-packets"):
                                                self.red_ecn_marked_packets = value
                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-transmit-bytes"):
                                                self.red_transmit_bytes = value
                                                self.red_transmit_bytes.value_namespace = name_space
                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-transmit-packets"):
                                                self.red_transmit_packets = value
                                                self.red_transmit_packets.value_namespace = name_space
                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.police_stats_array:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_stats_array:
                                            if (c.has_data()):
                                                return True
                                        for c in self.wred_stats_array:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.cac_state.is_set or
                                            self.class_name.is_set or
                                            self.counter_validity_bitmask.is_set or
                                            self.queue_descr.is_set or
                                            self.shared_queue_id.is_set or
                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                            (self.child_policy is not None and self.child_policy.has_data()) or
                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                    def has_operation(self):
                                        for c in self.police_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.wred_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.cac_state.yfilter != YFilter.not_set or
                                            self.class_name.yfilter != YFilter.not_set or
                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                            self.queue_descr.yfilter != YFilter.not_set or
                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                            (self.child_policy is not None and self.child_policy.has_operation()) or
                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "class-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "cac-stats"):
                                            if (self.cac_stats is None):
                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                            return self.cac_stats

                                        if (child_yang_name == "child-policy"):
                                            if (self.child_policy is None):
                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                            return self.child_policy

                                        if (child_yang_name == "general-stats"):
                                            if (self.general_stats is None):
                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                            return self.general_stats

                                        if (child_yang_name == "iphc-stats"):
                                            if (self.iphc_stats is None):
                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                            return self.iphc_stats

                                        if (child_yang_name == "police-stats-array"):
                                            for c in self.police_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.police_stats_array.append(c)
                                            return c

                                        if (child_yang_name == "queue-stats-array"):
                                            for c in self.queue_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_stats_array.append(c)
                                            return c

                                        if (child_yang_name == "wred-stats-array"):
                                            for c in self.wred_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.wred_stats_array.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "cac-state"):
                                            self.cac_state = value
                                            self.cac_state.value_namespace = name_space
                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "class-name"):
                                            self.class_name = value
                                            self.class_name.value_namespace = name_space
                                            self.class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "counter-validity-bitmask"):
                                            self.counter_validity_bitmask = value
                                            self.counter_validity_bitmask.value_namespace = name_space
                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-descr"):
                                            self.queue_descr = value
                                            self.queue_descr.value_namespace = name_space
                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "shared-queue-id"):
                                            self.shared_queue_id = value
                                            self.shared_queue_id.value_namespace = name_space
                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.class_stats:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.policy_name.is_set or
                                        self.satid.is_set or
                                        self.state.is_set or
                                        self.state_description.is_set)

                                def has_operation(self):
                                    for c in self.class_stats:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.policy_name.yfilter != YFilter.not_set or
                                        self.satid.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_description.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "statistics" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "class-stats"):
                                        for c in self.class_stats:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics.ClassStats()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.class_stats.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "policy-name"):
                                        self.policy_name = value
                                        self.policy_name.value_namespace = name_space
                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "satid"):
                                        self.satid = value
                                        self.satid.value_namespace = name_space
                                        self.satid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-description"):
                                        self.state_description = value
                                        self.state_description.value_namespace = name_space
                                        self.state_description.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                    (self.statistics is not None and self.statistics.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                    (self.statistics is not None and self.statistics.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "input" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-names"):
                                    if (self.service_policy_names is None):
                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                    return self.service_policy_names

                                if (child_yang_name == "statistics"):
                                    if (self.statistics is None):
                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                    return self.statistics

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-names" or name == "statistics"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Output(Entity):
                            """
                            A piece of QoS policy\-map operational data for
                            an interface
                            
                            .. attribute:: service_policy_names
                            
                            	Operational data for all Policy instance
                            	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames>`
                            
                            .. attribute:: statistics
                            
                            	Policy\-map statistics operational data for an interface
                            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output, self).__init__()

                                self.yang_name = "output"
                                self.yang_parent_name = "interface"

                                self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames()
                                self.service_policy_names.parent = self
                                self._children_name_map["service_policy_names"] = "service-policy-names"
                                self._children_yang_names.add("service-policy-names")

                                self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                                self._children_yang_names.add("statistics")


                            class ServicePolicyNames(Entity):
                                """
                                Operational data for all Policy instance
                                
                                .. attribute:: service_policy_instance
                                
                                	QoS policy\-map operational data for a particular Policy 
                                	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames, self).__init__()

                                    self.yang_name = "service-policy-names"
                                    self.yang_parent_name = "output"

                                    self.service_policy_instance = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames, self).__setattr__(name, value)


                                class ServicePolicyInstance(Entity):
                                    """
                                    QoS policy\-map operational data for a
                                    particular Policy 
                                    
                                    .. attribute:: service_policy_name  <key>
                                    
                                    	Name of the policy instance
                                    	**type**\:  str
                                    
                                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                        self.yang_name = "service-policy-instance"
                                        self.yang_parent_name = "service-policy-names"

                                        self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("service_policy_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.service_policy_name.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.service_policy_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "service-policy-name"):
                                            self.service_policy_name = value
                                            self.service_policy_name.value_namespace = name_space
                                            self.service_policy_name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.service_policy_instance:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.service_policy_instance:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-names" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "service-policy-instance"):
                                        for c in self.service_policy_instance:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.service_policy_instance.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-instance"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Statistics(Entity):
                                """
                                Policy\-map statistics operational data for an
                                interface
                                
                                .. attribute:: class_stats
                                
                                	array of classes contained in policy
                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats>`
                                
                                .. attribute:: policy_name
                                
                                	PolicyName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: satid
                                
                                	to maintain satellite id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: state
                                
                                	State
                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                
                                .. attribute:: state_description
                                
                                	StateDescription
                                	**type**\:  str
                                
                                	**length:** 0..128
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics, self).__init__()

                                    self.yang_name = "statistics"
                                    self.yang_parent_name = "output"

                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                    self.satid = YLeaf(YType.uint32, "satid")

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_description = YLeaf(YType.str, "state-description")

                                    self.class_stats = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("policy_name",
                                                    "satid",
                                                    "state",
                                                    "state_description") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics, self).__setattr__(name, value)


                                class ClassStats(Entity):
                                    """
                                    array of classes contained in policy
                                    
                                    .. attribute:: cac_state
                                    
                                    	CACState
                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                    
                                    .. attribute:: cac_stats
                                    
                                    	bag for cac stats
                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.CacStats>`
                                    
                                    .. attribute:: child_policy
                                    
                                    	child policy
                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy>`
                                    
                                    .. attribute:: class_name
                                    
                                    	ClassName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: counter_validity_bitmask
                                    
                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: megabyte
                                    
                                    .. attribute:: general_stats
                                    
                                    	general stats
                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats>`
                                    
                                    .. attribute:: iphc_stats
                                    
                                    	IPHC stats
                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats>`
                                    
                                    .. attribute:: police_stats_array
                                    
                                    	array of police stats
                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray>`
                                    
                                    .. attribute:: queue_descr
                                    
                                    	Description of queue for the class
                                    	**type**\:  str
                                    
                                    	**length:** 0..256
                                    
                                    .. attribute:: queue_stats_array
                                    
                                    	array of queue stats
                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray>`
                                    
                                    .. attribute:: shared_queue_id
                                    
                                    	q\-id of the  shared queue for this class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wred_stats_array
                                    
                                    	array of red stats
                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats, self).__init__()

                                        self.yang_name = "class-stats"
                                        self.yang_parent_name = "statistics"

                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                        self.class_name = YLeaf(YType.str, "class-name")

                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.CacStats()
                                        self.cac_stats.parent = self
                                        self._children_name_map["cac_stats"] = "cac-stats"
                                        self._children_yang_names.add("cac-stats")

                                        self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy()
                                        self.child_policy.parent = self
                                        self._children_name_map["child_policy"] = "child-policy"
                                        self._children_yang_names.add("child-policy")

                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats()
                                        self.general_stats.parent = self
                                        self._children_name_map["general_stats"] = "general-stats"
                                        self._children_yang_names.add("general-stats")

                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats()
                                        self.iphc_stats.parent = self
                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                        self._children_yang_names.add("iphc-stats")

                                        self.police_stats_array = YList(self)
                                        self.queue_stats_array = YList(self)
                                        self.wred_stats_array = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("cac_state",
                                                        "class_name",
                                                        "counter_validity_bitmask",
                                                        "queue_descr",
                                                        "shared_queue_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                    class GeneralStats(Entity):
                                        """
                                        general stats
                                        
                                        .. attribute:: match_data_rate
                                        
                                        	Incoming matched data rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: pre_policy_matched_bytes
                                        
                                        	Matched bytes before applying policy
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: pre_policy_matched_packets
                                        
                                        	Matched pkts before applying policy
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: total_drop_bytes
                                        
                                        	Dropped bytes (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_packets
                                        
                                        	Dropped packets (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_rate
                                        
                                        	Total drop rate (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_transmit_rate
                                        
                                        	Total transmit rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: transmit_bytes
                                        
                                        	Transmitted bytes (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: transmit_packets
                                        
                                        	Transmitted packets (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                            self.yang_name = "general-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("match_data_rate",
                                                            "pre_policy_matched_bytes",
                                                            "pre_policy_matched_packets",
                                                            "total_drop_bytes",
                                                            "total_drop_packets",
                                                            "total_drop_rate",
                                                            "total_transmit_rate",
                                                            "transmit_bytes",
                                                            "transmit_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.match_data_rate.is_set or
                                                self.pre_policy_matched_bytes.is_set or
                                                self.pre_policy_matched_packets.is_set or
                                                self.total_drop_bytes.is_set or
                                                self.total_drop_packets.is_set or
                                                self.total_drop_rate.is_set or
                                                self.total_transmit_rate.is_set or
                                                self.transmit_bytes.is_set or
                                                self.transmit_packets.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                self.transmit_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "general-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "match-data-rate"):
                                                self.match_data_rate = value
                                                self.match_data_rate.value_namespace = name_space
                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pre-policy-matched-bytes"):
                                                self.pre_policy_matched_bytes = value
                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pre-policy-matched-packets"):
                                                self.pre_policy_matched_packets = value
                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-bytes"):
                                                self.total_drop_bytes = value
                                                self.total_drop_bytes.value_namespace = name_space
                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-packets"):
                                                self.total_drop_packets = value
                                                self.total_drop_packets.value_namespace = name_space
                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-rate"):
                                                self.total_drop_rate = value
                                                self.total_drop_rate.value_namespace = name_space
                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-transmit-rate"):
                                                self.total_transmit_rate = value
                                                self.total_transmit_rate.value_namespace = name_space
                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "transmit-bytes"):
                                                self.transmit_bytes = value
                                                self.transmit_bytes.value_namespace = name_space
                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "transmit-packets"):
                                                self.transmit_packets = value
                                                self.transmit_packets.value_namespace = name_space
                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                    class IphcStats(Entity):
                                        """
                                        IPHC stats
                                        
                                        .. attribute:: non_tcp_bytes_saved
                                        
                                        	Non Tcp Bytes saved due to compression
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_bytes_sent_rate
                                        
                                        	Compressed Non Tcp Bytes sent rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_compressed_packets_out
                                        
                                        	Num of non tcp compressed pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: non_tcp_full_header_packets_out
                                        
                                        	Num of non tcp fullheader pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: non_tcp_total_out_bytes
                                        
                                        	TotalNum of Non Tcp Bytes sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_total_out_packets
                                        
                                        	TotalNum of Non tcp pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_bytes_saved
                                        
                                        	Tcp Bytes saved due to compression
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_bytes_sent_rate
                                        
                                        	Compressed Tcp Bytes sent rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_compressed_packets_out
                                        
                                        	Num of tcp compressed pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_full_header_packets_out
                                        
                                        	Num of tcp fullheader pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_total_out_bytes
                                        
                                        	TotalNum of Tcp Bytes sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_total_out_packets
                                        
                                        	Total Num of tcp pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                            self.yang_name = "iphc-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("non_tcp_bytes_saved",
                                                            "non_tcp_bytes_sent_rate",
                                                            "non_tcp_compressed_packets_out",
                                                            "non_tcp_full_header_packets_out",
                                                            "non_tcp_total_out_bytes",
                                                            "non_tcp_total_out_packets",
                                                            "tcp_bytes_saved",
                                                            "tcp_bytes_sent_rate",
                                                            "tcp_compressed_packets_out",
                                                            "tcp_full_header_packets_out",
                                                            "tcp_total_out_bytes",
                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.non_tcp_bytes_saved.is_set or
                                                self.non_tcp_bytes_sent_rate.is_set or
                                                self.non_tcp_compressed_packets_out.is_set or
                                                self.non_tcp_full_header_packets_out.is_set or
                                                self.non_tcp_total_out_bytes.is_set or
                                                self.non_tcp_total_out_packets.is_set or
                                                self.tcp_bytes_saved.is_set or
                                                self.tcp_bytes_sent_rate.is_set or
                                                self.tcp_compressed_packets_out.is_set or
                                                self.tcp_full_header_packets_out.is_set or
                                                self.tcp_total_out_bytes.is_set or
                                                self.tcp_total_out_packets.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "iphc-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "non-tcp-bytes-saved"):
                                                self.non_tcp_bytes_saved = value
                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                self.non_tcp_bytes_sent_rate = value
                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                self.non_tcp_compressed_packets_out = value
                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                self.non_tcp_full_header_packets_out = value
                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-total-out-bytes"):
                                                self.non_tcp_total_out_bytes = value
                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-total-out-packets"):
                                                self.non_tcp_total_out_packets = value
                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-bytes-saved"):
                                                self.tcp_bytes_saved = value
                                                self.tcp_bytes_saved.value_namespace = name_space
                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-bytes-sent-rate"):
                                                self.tcp_bytes_sent_rate = value
                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-compressed-packets-out"):
                                                self.tcp_compressed_packets_out = value
                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-full-header-packets-out"):
                                                self.tcp_full_header_packets_out = value
                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-total-out-bytes"):
                                                self.tcp_total_out_bytes = value
                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-total-out-packets"):
                                                self.tcp_total_out_packets = value
                                                self.tcp_total_out_packets.value_namespace = name_space
                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                    class ChildPolicy(Entity):
                                        """
                                        child policy
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                            self.yang_name = "child-policy"
                                            self.yang_parent_name = "class-stats"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "child-policy"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "child-policy" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix


                                    class CacStats(Entity):
                                        """
                                        bag for cac stats
                                        
                                        .. attribute:: admit_bytes
                                        
                                        	Admitted bytes (pkts/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: admit_rates
                                        
                                        	CAC admit rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: admitpackets
                                        
                                        	Admitted packets (pkts/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_bytes
                                        
                                        	CAC dropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_packets
                                        
                                        	CAC dropped packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: drop_rates
                                        
                                        	CAC dropped rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.CacStats, self).__init__()

                                            self.yang_name = "cac-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("admit_bytes",
                                                            "admit_rates",
                                                            "admitpackets",
                                                            "drop_bytes",
                                                            "drop_packets",
                                                            "drop_rates") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.admit_bytes.is_set or
                                                self.admit_rates.is_set or
                                                self.admitpackets.is_set or
                                                self.drop_bytes.is_set or
                                                self.drop_packets.is_set or
                                                self.drop_rates.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                self.admit_rates.yfilter != YFilter.not_set or
                                                self.admitpackets.yfilter != YFilter.not_set or
                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                self.drop_packets.yfilter != YFilter.not_set or
                                                self.drop_rates.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "cac-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "admit-bytes"):
                                                self.admit_bytes = value
                                                self.admit_bytes.value_namespace = name_space
                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "admit-rates"):
                                                self.admit_rates = value
                                                self.admit_rates.value_namespace = name_space
                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                            if(value_path == "admitpackets"):
                                                self.admitpackets = value
                                                self.admitpackets.value_namespace = name_space
                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-bytes"):
                                                self.drop_bytes = value
                                                self.drop_bytes.value_namespace = name_space
                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-packets"):
                                                self.drop_packets = value
                                                self.drop_packets.value_namespace = name_space
                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-rates"):
                                                self.drop_rates = value
                                                self.drop_rates.value_namespace = name_space
                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                    class QueueStatsArray(Entity):
                                        """
                                        array of queue stats
                                        
                                        .. attribute:: atm_clp0_drop_bytes
                                        
                                        	ATP CLP 0 matched bytes dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: atm_clp0_drop_packets
                                        
                                        	ATP CLP 0 matched packets dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: atm_clp1_drop_bytes
                                        
                                        	ATP CLP 0 matched bytes dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: atm_clp1_drop_packets
                                        
                                        	ATP CLP 0 matched packets dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_bytes
                                        
                                        	Bytes that conform to the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_packets
                                        
                                        	Packets that conform  to the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_rate
                                        
                                        	Conform rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: exceed_bytes
                                        
                                        	Bytes that exceed  the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_packets
                                        
                                        	Packets that exceed the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_rate
                                        
                                        	Exceed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: forced_wred_stats_display
                                        
                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                        	**type**\:  bool
                                        
                                        .. attribute:: max_threshold_bytes
                                        
                                        	Dropped bytes with the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: max_threshold_packets
                                        
                                        	Dropped packets with the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: queue_average_length
                                        
                                        	Queue average length
                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                        
                                        .. attribute:: queue_drop_threshold
                                        
                                        	tail drop threshold of the queue in bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: queue_id
                                        
                                        	Queue Id used for Fabric Stats
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_instance_length
                                        
                                        	Queue instance length
                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                        
                                        .. attribute:: queue_max_length
                                        
                                        	Queue maximum length
                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                        
                                        .. attribute:: random_drop_bytes
                                        
                                        	Bytes probabilistically dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: random_drop_packets
                                        
                                        	Packets probabilistically dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tail_drop_bytes
                                        
                                        	Bytes tail dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tail_drop_packets
                                        
                                        	Packets tail dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                            self.yang_name = "queue-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                            self.queue_average_length = YList(self)
                                            self.queue_instance_length = YList(self)
                                            self.queue_max_length = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("atm_clp0_drop_bytes",
                                                            "atm_clp0_drop_packets",
                                                            "atm_clp1_drop_bytes",
                                                            "atm_clp1_drop_packets",
                                                            "conform_bytes",
                                                            "conform_packets",
                                                            "conform_rate",
                                                            "exceed_bytes",
                                                            "exceed_packets",
                                                            "exceed_rate",
                                                            "forced_wred_stats_display",
                                                            "max_threshold_bytes",
                                                            "max_threshold_packets",
                                                            "queue_drop_threshold",
                                                            "queue_id",
                                                            "random_drop_bytes",
                                                            "random_drop_packets",
                                                            "tail_drop_bytes",
                                                            "tail_drop_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                        class QueueInstanceLength(Entity):
                                            """
                                            Queue instance length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                self.yang_name = "queue-instance-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-instance-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class QueueAverageLength(Entity):
                                            """
                                            Queue average length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                self.yang_name = "queue-average-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-average-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class QueueMaxLength(Entity):
                                            """
                                            Queue maximum length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                self.yang_name = "queue-max-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-max-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.queue_average_length:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_instance_length:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_max_length:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.atm_clp0_drop_bytes.is_set or
                                                self.atm_clp0_drop_packets.is_set or
                                                self.atm_clp1_drop_bytes.is_set or
                                                self.atm_clp1_drop_packets.is_set or
                                                self.conform_bytes.is_set or
                                                self.conform_packets.is_set or
                                                self.conform_rate.is_set or
                                                self.exceed_bytes.is_set or
                                                self.exceed_packets.is_set or
                                                self.exceed_rate.is_set or
                                                self.forced_wred_stats_display.is_set or
                                                self.max_threshold_bytes.is_set or
                                                self.max_threshold_packets.is_set or
                                                self.queue_drop_threshold.is_set or
                                                self.queue_id.is_set or
                                                self.random_drop_bytes.is_set or
                                                self.random_drop_packets.is_set or
                                                self.tail_drop_bytes.is_set or
                                                self.tail_drop_packets.is_set)

                                        def has_operation(self):
                                            for c in self.queue_average_length:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_instance_length:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_max_length:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_packets.yfilter != YFilter.not_set or
                                                self.conform_rate.yfilter != YFilter.not_set or
                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                self.queue_id.yfilter != YFilter.not_set or
                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "queue-average-length"):
                                                for c in self.queue_average_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_average_length.append(c)
                                                return c

                                            if (child_yang_name == "queue-instance-length"):
                                                for c in self.queue_instance_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_instance_length.append(c)
                                                return c

                                            if (child_yang_name == "queue-max-length"):
                                                for c in self.queue_max_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_max_length.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "atm-clp0-drop-bytes"):
                                                self.atm_clp0_drop_bytes = value
                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp0-drop-packets"):
                                                self.atm_clp0_drop_packets = value
                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp1-drop-bytes"):
                                                self.atm_clp1_drop_bytes = value
                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp1-drop-packets"):
                                                self.atm_clp1_drop_packets = value
                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-bytes"):
                                                self.conform_bytes = value
                                                self.conform_bytes.value_namespace = name_space
                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-packets"):
                                                self.conform_packets = value
                                                self.conform_packets.value_namespace = name_space
                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-rate"):
                                                self.conform_rate = value
                                                self.conform_rate.value_namespace = name_space
                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-bytes"):
                                                self.exceed_bytes = value
                                                self.exceed_bytes.value_namespace = name_space
                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-packets"):
                                                self.exceed_packets = value
                                                self.exceed_packets.value_namespace = name_space
                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-rate"):
                                                self.exceed_rate = value
                                                self.exceed_rate.value_namespace = name_space
                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forced-wred-stats-display"):
                                                self.forced_wred_stats_display = value
                                                self.forced_wred_stats_display.value_namespace = name_space
                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-bytes"):
                                                self.max_threshold_bytes = value
                                                self.max_threshold_bytes.value_namespace = name_space
                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-packets"):
                                                self.max_threshold_packets = value
                                                self.max_threshold_packets.value_namespace = name_space
                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-drop-threshold"):
                                                self.queue_drop_threshold = value
                                                self.queue_drop_threshold.value_namespace = name_space
                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-id"):
                                                self.queue_id = value
                                                self.queue_id.value_namespace = name_space
                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-bytes"):
                                                self.random_drop_bytes = value
                                                self.random_drop_bytes.value_namespace = name_space
                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-packets"):
                                                self.random_drop_packets = value
                                                self.random_drop_packets.value_namespace = name_space
                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tail-drop-bytes"):
                                                self.tail_drop_bytes = value
                                                self.tail_drop_bytes.value_namespace = name_space
                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tail-drop-packets"):
                                                self.tail_drop_packets = value
                                                self.tail_drop_packets.value_namespace = name_space
                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                    class PoliceStatsArray(Entity):
                                        """
                                        array of police stats
                                        
                                        .. attribute:: color_class_stats
                                        
                                        	color class stats
                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                        
                                        .. attribute:: conform_bytes
                                        
                                        	Bytes that conform to the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_packets
                                        
                                        	Packets that conform  to the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_rate
                                        
                                        	Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: drop_bytes
                                        
                                        	Police dropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_packets
                                        
                                        	Police dropped packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_bytes
                                        
                                        	Bytes that exceed  the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_packets
                                        
                                        	Packets that exceed the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_rate
                                        
                                        	Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: parent_drop_bytes
                                        
                                        	Dropped bytes by the parent policer
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: parent_drop_packets
                                        
                                        	Dropped pkts by the parent policer
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_bytes
                                        
                                        	Bytes that violate the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_packets
                                        
                                        	Packets violating the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_rate
                                        
                                        	Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                            self.yang_name = "police-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                            self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                            self.color_class_stats.parent = self
                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                            self._children_yang_names.add("color-class-stats")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_bytes",
                                                            "conform_packets",
                                                            "conform_rate",
                                                            "drop_bytes",
                                                            "drop_packets",
                                                            "exceed_bytes",
                                                            "exceed_packets",
                                                            "exceed_rate",
                                                            "parent_drop_bytes",
                                                            "parent_drop_packets",
                                                            "violate_bytes",
                                                            "violate_packets",
                                                            "violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                        class ColorClassStats(Entity):
                                            """
                                            color class stats
                                            
                                            .. attribute:: conform_class_conform_bytes
                                            
                                            	Bytes with classification result conform and policer result conform
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_conform_packets
                                            
                                            	Packets with classification result conform and policer result conform
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_conform_rate
                                            
                                            	Conform Class Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: conform_class_exceed_bytes
                                            
                                            	Bytes with classification result conform and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_exceed_packets
                                            
                                            	Packets with classification result conform and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_exceed_rate
                                            
                                            	Conform Class Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: conform_class_violate_bytes
                                            
                                            	Bytes with classification result conform and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_violate_packets
                                            
                                            	Packets with classification result conform and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_violate_rate
                                            
                                            	Conform Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_class_exceed_bytes
                                            
                                            	Bytes with classification result exceed and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_class_exceed_packets
                                            
                                            	Packets with classification result exceed and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_class_exceed_rate
                                            
                                            	Exceed Class Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_class_violate_bytes
                                            
                                            	Bytes with classification result exceed and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_class_violate_packets
                                            
                                            	Packets with classification result exceed and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_class_violate_rate
                                            
                                            	Exceed Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_class_violate_bytes
                                            
                                            	Bytes with classification result violate and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_class_violate_packets
                                            
                                            	Packets with classification result violate and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_class_violate_rate
                                            
                                            	Violate Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                self.yang_name = "color-class-stats"
                                                self.yang_parent_name = "police-stats-array"

                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_class_conform_bytes",
                                                                "conform_class_conform_packets",
                                                                "conform_class_conform_rate",
                                                                "conform_class_exceed_bytes",
                                                                "conform_class_exceed_packets",
                                                                "conform_class_exceed_rate",
                                                                "conform_class_violate_bytes",
                                                                "conform_class_violate_packets",
                                                                "conform_class_violate_rate",
                                                                "exceed_class_exceed_bytes",
                                                                "exceed_class_exceed_packets",
                                                                "exceed_class_exceed_rate",
                                                                "exceed_class_violate_bytes",
                                                                "exceed_class_violate_packets",
                                                                "exceed_class_violate_rate",
                                                                "violate_class_violate_bytes",
                                                                "violate_class_violate_packets",
                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.conform_class_conform_bytes.is_set or
                                                    self.conform_class_conform_packets.is_set or
                                                    self.conform_class_conform_rate.is_set or
                                                    self.conform_class_exceed_bytes.is_set or
                                                    self.conform_class_exceed_packets.is_set or
                                                    self.conform_class_exceed_rate.is_set or
                                                    self.conform_class_violate_bytes.is_set or
                                                    self.conform_class_violate_packets.is_set or
                                                    self.conform_class_violate_rate.is_set or
                                                    self.exceed_class_exceed_bytes.is_set or
                                                    self.exceed_class_exceed_packets.is_set or
                                                    self.exceed_class_exceed_rate.is_set or
                                                    self.exceed_class_violate_bytes.is_set or
                                                    self.exceed_class_violate_packets.is_set or
                                                    self.exceed_class_violate_rate.is_set or
                                                    self.violate_class_violate_bytes.is_set or
                                                    self.violate_class_violate_packets.is_set or
                                                    self.violate_class_violate_rate.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "color-class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-class-conform-bytes"):
                                                    self.conform_class_conform_bytes = value
                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-conform-packets"):
                                                    self.conform_class_conform_packets = value
                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-conform-rate"):
                                                    self.conform_class_conform_rate = value
                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-bytes"):
                                                    self.conform_class_exceed_bytes = value
                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-packets"):
                                                    self.conform_class_exceed_packets = value
                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-rate"):
                                                    self.conform_class_exceed_rate = value
                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-bytes"):
                                                    self.conform_class_violate_bytes = value
                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-packets"):
                                                    self.conform_class_violate_packets = value
                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-rate"):
                                                    self.conform_class_violate_rate = value
                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-bytes"):
                                                    self.exceed_class_exceed_bytes = value
                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-packets"):
                                                    self.exceed_class_exceed_packets = value
                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-rate"):
                                                    self.exceed_class_exceed_rate = value
                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-bytes"):
                                                    self.exceed_class_violate_bytes = value
                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-packets"):
                                                    self.exceed_class_violate_packets = value
                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-rate"):
                                                    self.exceed_class_violate_rate = value
                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-bytes"):
                                                    self.violate_class_violate_bytes = value
                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-packets"):
                                                    self.violate_class_violate_packets = value
                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-rate"):
                                                    self.violate_class_violate_rate = value
                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.conform_bytes.is_set or
                                                self.conform_packets.is_set or
                                                self.conform_rate.is_set or
                                                self.drop_bytes.is_set or
                                                self.drop_packets.is_set or
                                                self.exceed_bytes.is_set or
                                                self.exceed_packets.is_set or
                                                self.exceed_rate.is_set or
                                                self.parent_drop_bytes.is_set or
                                                self.parent_drop_packets.is_set or
                                                self.violate_bytes.is_set or
                                                self.violate_packets.is_set or
                                                self.violate_rate.is_set or
                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_packets.yfilter != YFilter.not_set or
                                                self.conform_rate.yfilter != YFilter.not_set or
                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                self.drop_packets.yfilter != YFilter.not_set or
                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_packets.yfilter != YFilter.not_set or
                                                self.violate_rate.yfilter != YFilter.not_set or
                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "police-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "color-class-stats"):
                                                if (self.color_class_stats is None):
                                                    self.color_class_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                return self.color_class_stats

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-bytes"):
                                                self.conform_bytes = value
                                                self.conform_bytes.value_namespace = name_space
                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-packets"):
                                                self.conform_packets = value
                                                self.conform_packets.value_namespace = name_space
                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-rate"):
                                                self.conform_rate = value
                                                self.conform_rate.value_namespace = name_space
                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-bytes"):
                                                self.drop_bytes = value
                                                self.drop_bytes.value_namespace = name_space
                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-packets"):
                                                self.drop_packets = value
                                                self.drop_packets.value_namespace = name_space
                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-bytes"):
                                                self.exceed_bytes = value
                                                self.exceed_bytes.value_namespace = name_space
                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-packets"):
                                                self.exceed_packets = value
                                                self.exceed_packets.value_namespace = name_space
                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-rate"):
                                                self.exceed_rate = value
                                                self.exceed_rate.value_namespace = name_space
                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "parent-drop-bytes"):
                                                self.parent_drop_bytes = value
                                                self.parent_drop_bytes.value_namespace = name_space
                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "parent-drop-packets"):
                                                self.parent_drop_packets = value
                                                self.parent_drop_packets.value_namespace = name_space
                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-bytes"):
                                                self.violate_bytes = value
                                                self.violate_bytes.value_namespace = name_space
                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-packets"):
                                                self.violate_packets = value
                                                self.violate_packets.value_namespace = name_space
                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-rate"):
                                                self.violate_rate = value
                                                self.violate_rate.value_namespace = name_space
                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                    class WredStatsArray(Entity):
                                        """
                                        array of red stats
                                        
                                        .. attribute:: max_threshold_bytes
                                        
                                        	Dropped bytes with  the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: max_threshold_packets
                                        
                                        	Dropped packets with  the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: profile_title
                                        
                                        	ProfileTitle
                                        	**type**\:  str
                                        
                                        	**length:** 0..300
                                        
                                        .. attribute:: random_drop_bytes
                                        
                                        	Probabilisticallydropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: random_drop_packets
                                        
                                        	Probabilistically dropped  packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: red_ecn_marked_bytes
                                        
                                        	ECN marked bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: red_ecn_marked_packets
                                        
                                        	ECN marked packets 
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: red_label
                                        
                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                        
                                        .. attribute:: red_transmit_bytes
                                        
                                        	Transmitted bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: red_transmit_packets
                                        
                                        	Transmitted packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                            self.yang_name = "wred-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                            self.red_label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("max_threshold_bytes",
                                                            "max_threshold_packets",
                                                            "profile_title",
                                                            "random_drop_bytes",
                                                            "random_drop_packets",
                                                            "red_ecn_marked_bytes",
                                                            "red_ecn_marked_packets",
                                                            "red_transmit_bytes",
                                                            "red_transmit_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                        class RedLabel(Entity):
                                            """
                                            Array of WRED Typevalues as in PRP stats is
                                            available per threshold   
                                            
                                            .. attribute:: value
                                            
                                            	WRED value for this type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: wred_type
                                            
                                            	WRED type DSCP, EXP, PREC etc
                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                self.yang_name = "red-label"
                                                self.yang_parent_name = "wred-stats-array"

                                                self.value = YLeaf(YType.uint8, "value")

                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("value",
                                                                "wred_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.value.is_set or
                                                    self.wred_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set or
                                                    self.wred_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "red-label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "value" or name == "wred-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "wred-type"):
                                                    self.wred_type = value
                                                    self.wred_type.value_namespace = name_space
                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.red_label:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.max_threshold_bytes.is_set or
                                                self.max_threshold_packets.is_set or
                                                self.profile_title.is_set or
                                                self.random_drop_bytes.is_set or
                                                self.random_drop_packets.is_set or
                                                self.red_ecn_marked_bytes.is_set or
                                                self.red_ecn_marked_packets.is_set or
                                                self.red_transmit_bytes.is_set or
                                                self.red_transmit_packets.is_set)

                                        def has_operation(self):
                                            for c in self.red_label:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                self.profile_title.yfilter != YFilter.not_set or
                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wred-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "red-label"):
                                                for c in self.red_label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.red_label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "max-threshold-bytes"):
                                                self.max_threshold_bytes = value
                                                self.max_threshold_bytes.value_namespace = name_space
                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-packets"):
                                                self.max_threshold_packets = value
                                                self.max_threshold_packets.value_namespace = name_space
                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-title"):
                                                self.profile_title = value
                                                self.profile_title.value_namespace = name_space
                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-bytes"):
                                                self.random_drop_bytes = value
                                                self.random_drop_bytes.value_namespace = name_space
                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-packets"):
                                                self.random_drop_packets = value
                                                self.random_drop_packets.value_namespace = name_space
                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-ecn-marked-bytes"):
                                                self.red_ecn_marked_bytes = value
                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-ecn-marked-packets"):
                                                self.red_ecn_marked_packets = value
                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-transmit-bytes"):
                                                self.red_transmit_bytes = value
                                                self.red_transmit_bytes.value_namespace = name_space
                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-transmit-packets"):
                                                self.red_transmit_packets = value
                                                self.red_transmit_packets.value_namespace = name_space
                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.police_stats_array:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_stats_array:
                                            if (c.has_data()):
                                                return True
                                        for c in self.wred_stats_array:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.cac_state.is_set or
                                            self.class_name.is_set or
                                            self.counter_validity_bitmask.is_set or
                                            self.queue_descr.is_set or
                                            self.shared_queue_id.is_set or
                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                            (self.child_policy is not None and self.child_policy.has_data()) or
                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                    def has_operation(self):
                                        for c in self.police_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.wred_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.cac_state.yfilter != YFilter.not_set or
                                            self.class_name.yfilter != YFilter.not_set or
                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                            self.queue_descr.yfilter != YFilter.not_set or
                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                            (self.child_policy is not None and self.child_policy.has_operation()) or
                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "class-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "cac-stats"):
                                            if (self.cac_stats is None):
                                                self.cac_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                            return self.cac_stats

                                        if (child_yang_name == "child-policy"):
                                            if (self.child_policy is None):
                                                self.child_policy = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                            return self.child_policy

                                        if (child_yang_name == "general-stats"):
                                            if (self.general_stats is None):
                                                self.general_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                            return self.general_stats

                                        if (child_yang_name == "iphc-stats"):
                                            if (self.iphc_stats is None):
                                                self.iphc_stats = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                            return self.iphc_stats

                                        if (child_yang_name == "police-stats-array"):
                                            for c in self.police_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.police_stats_array.append(c)
                                            return c

                                        if (child_yang_name == "queue-stats-array"):
                                            for c in self.queue_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_stats_array.append(c)
                                            return c

                                        if (child_yang_name == "wred-stats-array"):
                                            for c in self.wred_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.wred_stats_array.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "cac-state"):
                                            self.cac_state = value
                                            self.cac_state.value_namespace = name_space
                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "class-name"):
                                            self.class_name = value
                                            self.class_name.value_namespace = name_space
                                            self.class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "counter-validity-bitmask"):
                                            self.counter_validity_bitmask = value
                                            self.counter_validity_bitmask.value_namespace = name_space
                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-descr"):
                                            self.queue_descr = value
                                            self.queue_descr.value_namespace = name_space
                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "shared-queue-id"):
                                            self.shared_queue_id = value
                                            self.shared_queue_id.value_namespace = name_space
                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.class_stats:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.policy_name.is_set or
                                        self.satid.is_set or
                                        self.state.is_set or
                                        self.state_description.is_set)

                                def has_operation(self):
                                    for c in self.class_stats:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.policy_name.yfilter != YFilter.not_set or
                                        self.satid.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_description.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "statistics" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "class-stats"):
                                        for c in self.class_stats:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics.ClassStats()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.class_stats.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "policy-name"):
                                        self.policy_name = value
                                        self.policy_name.value_namespace = name_space
                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "satid"):
                                        self.satid = value
                                        self.satid.value_namespace = name_space
                                        self.satid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-description"):
                                        self.state_description = value
                                        self.state_description.value_namespace = name_space
                                        self.state_description.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                    (self.statistics is not None and self.statistics.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                    (self.statistics is not None and self.statistics.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "output" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-names"):
                                    if (self.service_policy_names is None):
                                        self.service_policy_names = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.ServicePolicyNames()
                                        self.service_policy_names.parent = self
                                        self._children_name_map["service_policy_names"] = "service-policy-names"
                                    return self.service_policy_names

                                if (child_yang_name == "statistics"):
                                    if (self.statistics is None):
                                        self.statistics = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                    return self.statistics

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-names" or name == "statistics"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.interface_name.is_set or
                                (self.input is not None and self.input.has_data()) or
                                (self.member_interfaces is not None and self.member_interfaces.has_data()) or
                                (self.nodes is not None and self.nodes.has_data()) or
                                (self.output is not None and self.output.has_data()) or
                                (self.satellite_ids is not None and self.satellite_ids.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                (self.input is not None and self.input.has_operation()) or
                                (self.member_interfaces is not None and self.member_interfaces.has_operation()) or
                                (self.nodes is not None and self.nodes.has_operation()) or
                                (self.output is not None and self.output.has_operation()) or
                                (self.satellite_ids is not None and self.satellite_ids.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "input"):
                                if (self.input is None):
                                    self.input = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Input()
                                    self.input.parent = self
                                    self._children_name_map["input"] = "input"
                                return self.input

                            if (child_yang_name == "member-interfaces"):
                                if (self.member_interfaces is None):
                                    self.member_interfaces = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.MemberInterfaces()
                                    self.member_interfaces.parent = self
                                    self._children_name_map["member_interfaces"] = "member-interfaces"
                                return self.member_interfaces

                            if (child_yang_name == "nodes"):
                                if (self.nodes is None):
                                    self.nodes = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Nodes()
                                    self.nodes.parent = self
                                    self._children_name_map["nodes"] = "nodes"
                                return self.nodes

                            if (child_yang_name == "output"):
                                if (self.output is None):
                                    self.output = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.Output()
                                    self.output.parent = self
                                    self._children_name_map["output"] = "output"
                                return self.output

                            if (child_yang_name == "satellite-ids"):
                                if (self.satellite_ids is None):
                                    self.satellite_ids = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface.SatelliteIds()
                                    self.satellite_ids.parent = self
                                    self._children_name_map["satellite_ids"] = "satellite-ids"
                                return self.satellite_ids

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "input" or name == "member-interfaces" or name == "nodes" or name == "output" or name == "satellite-ids" or name == "interface-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.interface:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.interface:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "interface-table" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "interface"):
                            for c in self.interface:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Qos.Nodes.Node.PolicyMap.InterfaceTable.Interface()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.interface.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "interface"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        (self.interface_table is not None and self.interface_table.has_data()) or
                        (self.shared_policy_instances is not None and self.shared_policy_instances.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.interface_table is not None and self.interface_table.has_operation()) or
                        (self.shared_policy_instances is not None and self.shared_policy_instances.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "policy-map" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "interface-table"):
                        if (self.interface_table is None):
                            self.interface_table = Qos.Nodes.Node.PolicyMap.InterfaceTable()
                            self.interface_table.parent = self
                            self._children_name_map["interface_table"] = "interface-table"
                        return self.interface_table

                    if (child_yang_name == "shared-policy-instances"):
                        if (self.shared_policy_instances is None):
                            self.shared_policy_instances = Qos.Nodes.Node.PolicyMap.SharedPolicyInstances()
                            self.shared_policy_instances.parent = self
                            self._children_name_map["shared_policy_instances"] = "shared-policy-instances"
                        return self.shared_policy_instances

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "interface-table" or name == "shared-policy-instances"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (
                    self.node_name.is_set or
                    (self.policy_map is not None and self.policy_map.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.node_name.yfilter != YFilter.not_set or
                    (self.policy_map is not None and self.policy_map.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "node" + "[node-name='" + self.node_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/nodes/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.node_name.is_set or self.node_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "policy-map"):
                    if (self.policy_map is None):
                        self.policy_map = Qos.Nodes.Node.PolicyMap()
                        self.policy_map.parent = self
                        self._children_name_map["policy_map"] = "policy-map"
                    return self.policy_map

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "policy-map" or name == "node-name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "node-name"):
                    self.node_name = value
                    self.node_name.value_namespace = name_space
                    self.node_name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.node:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.node:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "nodes" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "node"):
                for c in self.node:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = Qos.Nodes.Node()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.node.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "node"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class QosGlobal(Entity):
        """
        For global registrations
        
        .. attribute:: vo_q
        
        	For VoQ operational data
        	**type**\:   :py:class:`VoQ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ>`
        
        

        """

        _prefix = 'qos-ma-oper'
        _revision = '2017-04-10'

        def __init__(self):
            super(Qos.QosGlobal, self).__init__()

            self.yang_name = "qos-global"
            self.yang_parent_name = "qos"

            self.vo_q = Qos.QosGlobal.VoQ()
            self.vo_q.parent = self
            self._children_name_map["vo_q"] = "vo-q"
            self._children_yang_names.add("vo-q")


        class VoQ(Entity):
            """
            For VoQ operational data
            
            .. attribute:: vo_q_statistics
            
            	For VoQ statistics
            	**type**\:   :py:class:`VoQStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics>`
            
            

            """

            _prefix = 'qos-ma-oper'
            _revision = '2017-04-10'

            def __init__(self):
                super(Qos.QosGlobal.VoQ, self).__init__()

                self.yang_name = "vo-q"
                self.yang_parent_name = "qos-global"

                self.vo_q_statistics = Qos.QosGlobal.VoQ.VoQStatistics()
                self.vo_q_statistics.parent = self
                self._children_name_map["vo_q_statistics"] = "vo-q-statistics"
                self._children_yang_names.add("vo-q-statistics")


            class VoQStatistics(Entity):
                """
                For VoQ statistics
                
                .. attribute:: vo_qinterfaces
                
                	VoQ interface
                	**type**\:   :py:class:`VoQinterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.QosGlobal.VoQ.VoQStatistics, self).__init__()

                    self.yang_name = "vo-q-statistics"
                    self.yang_parent_name = "vo-q"

                    self.vo_qinterfaces = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces()
                    self.vo_qinterfaces.parent = self
                    self._children_name_map["vo_qinterfaces"] = "vo-qinterfaces"
                    self._children_yang_names.add("vo-qinterfaces")


                class VoQinterfaces(Entity):
                    """
                    VoQ interface
                    
                    .. attribute:: vo_qinterface
                    
                    	QoS policy\-map operational data for a particular interface
                    	**type**\: list of    :py:class:`VoQinterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces, self).__init__()

                        self.yang_name = "vo-qinterfaces"
                        self.yang_parent_name = "vo-q-statistics"

                        self.vo_qinterface = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces, self).__setattr__(name, value)


                    class VoQinterface(Entity):
                        """
                        QoS policy\-map operational data for a
                        particular interface
                        
                        .. attribute:: interface_name  <key>
                        
                        	Name of the interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: output_vo_q
                        
                        	output VoQ interface
                        	**type**\:   :py:class:`OutputVoQ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ>`
                        
                        .. attribute:: vo_q_member_interfaces
                        
                        	VoQ QoS policy\-map member interface table
                        	**type**\:   :py:class:`VoQMemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface, self).__init__()

                            self.yang_name = "vo-qinterface"
                            self.yang_parent_name = "vo-qinterfaces"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.output_vo_q = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ()
                            self.output_vo_q.parent = self
                            self._children_name_map["output_vo_q"] = "output-vo-q"
                            self._children_yang_names.add("output-vo-q")

                            self.vo_q_member_interfaces = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces()
                            self.vo_q_member_interfaces.parent = self
                            self._children_name_map["vo_q_member_interfaces"] = "vo-q-member-interfaces"
                            self._children_yang_names.add("vo-q-member-interfaces")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface, self).__setattr__(name, value)


                        class OutputVoQ(Entity):
                            """
                            output VoQ interface
                            
                            .. attribute:: locationvo_qs
                            
                            	QoS policy\-map location table
                            	**type**\:   :py:class:`LocationvoQs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs>`
                            
                            .. attribute:: vo_q_stats
                            
                            	VoQ statistics operational data for an interface
                            	**type**\:   :py:class:`VoQStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ, self).__init__()

                                self.yang_name = "output-vo-q"
                                self.yang_parent_name = "vo-qinterface"

                                self.locationvo_qs = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs()
                                self.locationvo_qs.parent = self
                                self._children_name_map["locationvo_qs"] = "locationvo-qs"
                                self._children_yang_names.add("locationvo-qs")

                                self.vo_q_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats()
                                self.vo_q_stats.parent = self
                                self._children_name_map["vo_q_stats"] = "vo-q-stats"
                                self._children_yang_names.add("vo-q-stats")


                            class LocationvoQs(Entity):
                                """
                                QoS policy\-map location table
                                
                                .. attribute:: locationvo_q
                                
                                	QoS operational data for a particular location
                                	**type**\: list of    :py:class:`LocationvoQ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs, self).__init__()

                                    self.yang_name = "locationvo-qs"
                                    self.yang_parent_name = "output-vo-q"

                                    self.locationvo_q = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs, self).__setattr__(name, value)


                                class LocationvoQ(Entity):
                                    """
                                    QoS operational data for a particular
                                    location
                                    
                                    .. attribute:: node_name  <key>
                                    
                                    	The node
                                    	**type**\:  str
                                    
                                    	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
                                    
                                    .. attribute:: vo_q_stats
                                    
                                    	VoQ statistics operational data for an interface
                                    	**type**\:   :py:class:`VoQStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ, self).__init__()

                                        self.yang_name = "locationvo-q"
                                        self.yang_parent_name = "locationvo-qs"

                                        self.node_name = YLeaf(YType.str, "node-name")

                                        self.vo_q_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats()
                                        self.vo_q_stats.parent = self
                                        self._children_name_map["vo_q_stats"] = "vo-q-stats"
                                        self._children_yang_names.add("vo-q-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("node_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ, self).__setattr__(name, value)


                                    class VoQStats(Entity):
                                        """
                                        VoQ statistics operational data for an interface
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats, self).__init__()

                                            self.yang_name = "vo-q-stats"
                                            self.yang_parent_name = "locationvo-q"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.CacStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "vo-q-stats"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.child_policy = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                                self._children_yang_names.add("child-policy")

                                                self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "child-policy" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.child_policy is not None and self.child_policy.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.child_policy is not None and self.child_policy.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "child-policy"):
                                                    if (self.child_policy is None):
                                                        self.child_policy = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                    return self.child_policy

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vo-q-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.node_name.is_set or
                                            (self.vo_q_stats is not None and self.vo_q_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.node_name.yfilter != YFilter.not_set or
                                            (self.vo_q_stats is not None and self.vo_q_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "locationvo-q" + "[node-name='" + self.node_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.node_name.is_set or self.node_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.node_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "vo-q-stats"):
                                            if (self.vo_q_stats is None):
                                                self.vo_q_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ.VoQStats()
                                                self.vo_q_stats.parent = self
                                                self._children_name_map["vo_q_stats"] = "vo-q-stats"
                                            return self.vo_q_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "vo-q-stats" or name == "node-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "node-name"):
                                            self.node_name = value
                                            self.node_name.value_namespace = name_space
                                            self.node_name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.locationvo_q:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.locationvo_q:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "locationvo-qs" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "locationvo-q"):
                                        for c in self.locationvo_q:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs.LocationvoQ()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.locationvo_q.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "locationvo-q"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class VoQStats(Entity):
                                """
                                VoQ statistics operational data for an interface
                                
                                .. attribute:: class_stats
                                
                                	array of classes contained in policy
                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats>`
                                
                                .. attribute:: policy_name
                                
                                	PolicyName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: satid
                                
                                	to maintain satellite id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: state
                                
                                	State
                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                
                                .. attribute:: state_description
                                
                                	StateDescription
                                	**type**\:  str
                                
                                	**length:** 0..128
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats, self).__init__()

                                    self.yang_name = "vo-q-stats"
                                    self.yang_parent_name = "output-vo-q"

                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                    self.satid = YLeaf(YType.uint32, "satid")

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_description = YLeaf(YType.str, "state-description")

                                    self.class_stats = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("policy_name",
                                                    "satid",
                                                    "state",
                                                    "state_description") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats, self).__setattr__(name, value)


                                class ClassStats(Entity):
                                    """
                                    array of classes contained in policy
                                    
                                    .. attribute:: cac_state
                                    
                                    	CACState
                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                    
                                    .. attribute:: cac_stats
                                    
                                    	bag for cac stats
                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.CacStats>`
                                    
                                    .. attribute:: child_policy
                                    
                                    	child policy
                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy>`
                                    
                                    .. attribute:: class_name
                                    
                                    	ClassName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: counter_validity_bitmask
                                    
                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: megabyte
                                    
                                    .. attribute:: general_stats
                                    
                                    	general stats
                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.GeneralStats>`
                                    
                                    .. attribute:: iphc_stats
                                    
                                    	IPHC stats
                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.IphcStats>`
                                    
                                    .. attribute:: police_stats_array
                                    
                                    	array of police stats
                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray>`
                                    
                                    .. attribute:: queue_descr
                                    
                                    	Description of queue for the class
                                    	**type**\:  str
                                    
                                    	**length:** 0..256
                                    
                                    .. attribute:: queue_stats_array
                                    
                                    	array of queue stats
                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray>`
                                    
                                    .. attribute:: shared_queue_id
                                    
                                    	q\-id of the  shared queue for this class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wred_stats_array
                                    
                                    	array of red stats
                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats, self).__init__()

                                        self.yang_name = "class-stats"
                                        self.yang_parent_name = "vo-q-stats"

                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                        self.class_name = YLeaf(YType.str, "class-name")

                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                        self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.CacStats()
                                        self.cac_stats.parent = self
                                        self._children_name_map["cac_stats"] = "cac-stats"
                                        self._children_yang_names.add("cac-stats")

                                        self.child_policy = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy()
                                        self.child_policy.parent = self
                                        self._children_name_map["child_policy"] = "child-policy"
                                        self._children_yang_names.add("child-policy")

                                        self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.GeneralStats()
                                        self.general_stats.parent = self
                                        self._children_name_map["general_stats"] = "general-stats"
                                        self._children_yang_names.add("general-stats")

                                        self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.IphcStats()
                                        self.iphc_stats.parent = self
                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                        self._children_yang_names.add("iphc-stats")

                                        self.police_stats_array = YList(self)
                                        self.queue_stats_array = YList(self)
                                        self.wred_stats_array = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("cac_state",
                                                        "class_name",
                                                        "counter_validity_bitmask",
                                                        "queue_descr",
                                                        "shared_queue_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats, self).__setattr__(name, value)


                                    class GeneralStats(Entity):
                                        """
                                        general stats
                                        
                                        .. attribute:: match_data_rate
                                        
                                        	Incoming matched data rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: pre_policy_matched_bytes
                                        
                                        	Matched bytes before applying policy
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: pre_policy_matched_packets
                                        
                                        	Matched pkts before applying policy
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: total_drop_bytes
                                        
                                        	Dropped bytes (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_packets
                                        
                                        	Dropped packets (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_drop_rate
                                        
                                        	Total drop rate (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: total_transmit_rate
                                        
                                        	Total transmit rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: transmit_bytes
                                        
                                        	Transmitted bytes (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: transmit_packets
                                        
                                        	Transmitted packets (packets/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.GeneralStats, self).__init__()

                                            self.yang_name = "general-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("match_data_rate",
                                                            "pre_policy_matched_bytes",
                                                            "pre_policy_matched_packets",
                                                            "total_drop_bytes",
                                                            "total_drop_packets",
                                                            "total_drop_rate",
                                                            "total_transmit_rate",
                                                            "transmit_bytes",
                                                            "transmit_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.GeneralStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.match_data_rate.is_set or
                                                self.pre_policy_matched_bytes.is_set or
                                                self.pre_policy_matched_packets.is_set or
                                                self.total_drop_bytes.is_set or
                                                self.total_drop_packets.is_set or
                                                self.total_drop_rate.is_set or
                                                self.total_transmit_rate.is_set or
                                                self.transmit_bytes.is_set or
                                                self.transmit_packets.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                self.transmit_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "general-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "match-data-rate"):
                                                self.match_data_rate = value
                                                self.match_data_rate.value_namespace = name_space
                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pre-policy-matched-bytes"):
                                                self.pre_policy_matched_bytes = value
                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pre-policy-matched-packets"):
                                                self.pre_policy_matched_packets = value
                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-bytes"):
                                                self.total_drop_bytes = value
                                                self.total_drop_bytes.value_namespace = name_space
                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-packets"):
                                                self.total_drop_packets = value
                                                self.total_drop_packets.value_namespace = name_space
                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-drop-rate"):
                                                self.total_drop_rate = value
                                                self.total_drop_rate.value_namespace = name_space
                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-transmit-rate"):
                                                self.total_transmit_rate = value
                                                self.total_transmit_rate.value_namespace = name_space
                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "transmit-bytes"):
                                                self.transmit_bytes = value
                                                self.transmit_bytes.value_namespace = name_space
                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "transmit-packets"):
                                                self.transmit_packets = value
                                                self.transmit_packets.value_namespace = name_space
                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                    class IphcStats(Entity):
                                        """
                                        IPHC stats
                                        
                                        .. attribute:: non_tcp_bytes_saved
                                        
                                        	Non Tcp Bytes saved due to compression
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_bytes_sent_rate
                                        
                                        	Compressed Non Tcp Bytes sent rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_compressed_packets_out
                                        
                                        	Num of non tcp compressed pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: non_tcp_full_header_packets_out
                                        
                                        	Num of non tcp fullheader pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: non_tcp_total_out_bytes
                                        
                                        	TotalNum of Non Tcp Bytes sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: non_tcp_total_out_packets
                                        
                                        	TotalNum of Non tcp pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_bytes_saved
                                        
                                        	Tcp Bytes saved due to compression
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_bytes_sent_rate
                                        
                                        	Compressed Tcp Bytes sent rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_compressed_packets_out
                                        
                                        	Num of tcp compressed pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_full_header_packets_out
                                        
                                        	Num of tcp fullheader pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tcp_total_out_bytes
                                        
                                        	TotalNum of Tcp Bytes sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tcp_total_out_packets
                                        
                                        	Total Num of tcp pkts sent
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.IphcStats, self).__init__()

                                            self.yang_name = "iphc-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("non_tcp_bytes_saved",
                                                            "non_tcp_bytes_sent_rate",
                                                            "non_tcp_compressed_packets_out",
                                                            "non_tcp_full_header_packets_out",
                                                            "non_tcp_total_out_bytes",
                                                            "non_tcp_total_out_packets",
                                                            "tcp_bytes_saved",
                                                            "tcp_bytes_sent_rate",
                                                            "tcp_compressed_packets_out",
                                                            "tcp_full_header_packets_out",
                                                            "tcp_total_out_bytes",
                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.IphcStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.IphcStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.non_tcp_bytes_saved.is_set or
                                                self.non_tcp_bytes_sent_rate.is_set or
                                                self.non_tcp_compressed_packets_out.is_set or
                                                self.non_tcp_full_header_packets_out.is_set or
                                                self.non_tcp_total_out_bytes.is_set or
                                                self.non_tcp_total_out_packets.is_set or
                                                self.tcp_bytes_saved.is_set or
                                                self.tcp_bytes_sent_rate.is_set or
                                                self.tcp_compressed_packets_out.is_set or
                                                self.tcp_full_header_packets_out.is_set or
                                                self.tcp_total_out_bytes.is_set or
                                                self.tcp_total_out_packets.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "iphc-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "non-tcp-bytes-saved"):
                                                self.non_tcp_bytes_saved = value
                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                self.non_tcp_bytes_sent_rate = value
                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                self.non_tcp_compressed_packets_out = value
                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                self.non_tcp_full_header_packets_out = value
                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-total-out-bytes"):
                                                self.non_tcp_total_out_bytes = value
                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "non-tcp-total-out-packets"):
                                                self.non_tcp_total_out_packets = value
                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-bytes-saved"):
                                                self.tcp_bytes_saved = value
                                                self.tcp_bytes_saved.value_namespace = name_space
                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-bytes-sent-rate"):
                                                self.tcp_bytes_sent_rate = value
                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-compressed-packets-out"):
                                                self.tcp_compressed_packets_out = value
                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-full-header-packets-out"):
                                                self.tcp_full_header_packets_out = value
                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-total-out-bytes"):
                                                self.tcp_total_out_bytes = value
                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-total-out-packets"):
                                                self.tcp_total_out_packets = value
                                                self.tcp_total_out_packets.value_namespace = name_space
                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                    class ChildPolicy(Entity):
                                        """
                                        child policy
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy, self).__init__()

                                            self.yang_name = "child-policy"
                                            self.yang_parent_name = "class-stats"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "child-policy"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "child-policy" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix


                                    class CacStats(Entity):
                                        """
                                        bag for cac stats
                                        
                                        .. attribute:: admit_bytes
                                        
                                        	Admitted bytes (pkts/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: admit_rates
                                        
                                        	CAC admit rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: admitpackets
                                        
                                        	Admitted packets (pkts/bytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_bytes
                                        
                                        	CAC dropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_packets
                                        
                                        	CAC dropped packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: drop_rates
                                        
                                        	CAC dropped rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.CacStats, self).__init__()

                                            self.yang_name = "cac-stats"
                                            self.yang_parent_name = "class-stats"

                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("admit_bytes",
                                                            "admit_rates",
                                                            "admitpackets",
                                                            "drop_bytes",
                                                            "drop_packets",
                                                            "drop_rates") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.CacStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.CacStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.admit_bytes.is_set or
                                                self.admit_rates.is_set or
                                                self.admitpackets.is_set or
                                                self.drop_bytes.is_set or
                                                self.drop_packets.is_set or
                                                self.drop_rates.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                self.admit_rates.yfilter != YFilter.not_set or
                                                self.admitpackets.yfilter != YFilter.not_set or
                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                self.drop_packets.yfilter != YFilter.not_set or
                                                self.drop_rates.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "cac-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "admit-bytes"):
                                                self.admit_bytes = value
                                                self.admit_bytes.value_namespace = name_space
                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "admit-rates"):
                                                self.admit_rates = value
                                                self.admit_rates.value_namespace = name_space
                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                            if(value_path == "admitpackets"):
                                                self.admitpackets = value
                                                self.admitpackets.value_namespace = name_space
                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-bytes"):
                                                self.drop_bytes = value
                                                self.drop_bytes.value_namespace = name_space
                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-packets"):
                                                self.drop_packets = value
                                                self.drop_packets.value_namespace = name_space
                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-rates"):
                                                self.drop_rates = value
                                                self.drop_rates.value_namespace = name_space
                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                    class QueueStatsArray(Entity):
                                        """
                                        array of queue stats
                                        
                                        .. attribute:: atm_clp0_drop_bytes
                                        
                                        	ATP CLP 0 matched bytes dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: atm_clp0_drop_packets
                                        
                                        	ATP CLP 0 matched packets dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: atm_clp1_drop_bytes
                                        
                                        	ATP CLP 0 matched bytes dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: atm_clp1_drop_packets
                                        
                                        	ATP CLP 0 matched packets dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_bytes
                                        
                                        	Bytes that conform to the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_packets
                                        
                                        	Packets that conform  to the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_rate
                                        
                                        	Conform rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: exceed_bytes
                                        
                                        	Bytes that exceed  the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_packets
                                        
                                        	Packets that exceed the queue rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_rate
                                        
                                        	Exceed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: forced_wred_stats_display
                                        
                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                        	**type**\:  bool
                                        
                                        .. attribute:: max_threshold_bytes
                                        
                                        	Dropped bytes with the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: max_threshold_packets
                                        
                                        	Dropped packets with the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: queue_average_length
                                        
                                        	Queue average length
                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength>`
                                        
                                        .. attribute:: queue_drop_threshold
                                        
                                        	tail drop threshold of the queue in bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: queue_id
                                        
                                        	Queue Id used for Fabric Stats
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_instance_length
                                        
                                        	Queue instance length
                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                        
                                        .. attribute:: queue_max_length
                                        
                                        	Queue maximum length
                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength>`
                                        
                                        .. attribute:: random_drop_bytes
                                        
                                        	Bytes probabilistically dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: random_drop_packets
                                        
                                        	Packets probabilistically dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: tail_drop_bytes
                                        
                                        	Bytes tail dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: tail_drop_packets
                                        
                                        	Packets tail dropped
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray, self).__init__()

                                            self.yang_name = "queue-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                            self.queue_average_length = YList(self)
                                            self.queue_instance_length = YList(self)
                                            self.queue_max_length = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("atm_clp0_drop_bytes",
                                                            "atm_clp0_drop_packets",
                                                            "atm_clp1_drop_bytes",
                                                            "atm_clp1_drop_packets",
                                                            "conform_bytes",
                                                            "conform_packets",
                                                            "conform_rate",
                                                            "exceed_bytes",
                                                            "exceed_packets",
                                                            "exceed_rate",
                                                            "forced_wred_stats_display",
                                                            "max_threshold_bytes",
                                                            "max_threshold_packets",
                                                            "queue_drop_threshold",
                                                            "queue_id",
                                                            "random_drop_bytes",
                                                            "random_drop_packets",
                                                            "tail_drop_bytes",
                                                            "tail_drop_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                        class QueueInstanceLength(Entity):
                                            """
                                            Queue instance length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                self.yang_name = "queue-instance-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-instance-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class QueueAverageLength(Entity):
                                            """
                                            Queue average length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                self.yang_name = "queue-average-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-average-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class QueueMaxLength(Entity):
                                            """
                                            Queue maximum length
                                            
                                            .. attribute:: unit
                                            
                                            	unit
                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                self.yang_name = "queue-max-length"
                                                self.yang_parent_name = "queue-stats-array"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-max-length" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.queue_average_length:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_instance_length:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_max_length:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.atm_clp0_drop_bytes.is_set or
                                                self.atm_clp0_drop_packets.is_set or
                                                self.atm_clp1_drop_bytes.is_set or
                                                self.atm_clp1_drop_packets.is_set or
                                                self.conform_bytes.is_set or
                                                self.conform_packets.is_set or
                                                self.conform_rate.is_set or
                                                self.exceed_bytes.is_set or
                                                self.exceed_packets.is_set or
                                                self.exceed_rate.is_set or
                                                self.forced_wred_stats_display.is_set or
                                                self.max_threshold_bytes.is_set or
                                                self.max_threshold_packets.is_set or
                                                self.queue_drop_threshold.is_set or
                                                self.queue_id.is_set or
                                                self.random_drop_bytes.is_set or
                                                self.random_drop_packets.is_set or
                                                self.tail_drop_bytes.is_set or
                                                self.tail_drop_packets.is_set)

                                        def has_operation(self):
                                            for c in self.queue_average_length:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_instance_length:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_max_length:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_packets.yfilter != YFilter.not_set or
                                                self.conform_rate.yfilter != YFilter.not_set or
                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                self.queue_id.yfilter != YFilter.not_set or
                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "queue-average-length"):
                                                for c in self.queue_average_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_average_length.append(c)
                                                return c

                                            if (child_yang_name == "queue-instance-length"):
                                                for c in self.queue_instance_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_instance_length.append(c)
                                                return c

                                            if (child_yang_name == "queue-max-length"):
                                                for c in self.queue_max_length:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_max_length.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "atm-clp0-drop-bytes"):
                                                self.atm_clp0_drop_bytes = value
                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp0-drop-packets"):
                                                self.atm_clp0_drop_packets = value
                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp1-drop-bytes"):
                                                self.atm_clp1_drop_bytes = value
                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "atm-clp1-drop-packets"):
                                                self.atm_clp1_drop_packets = value
                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-bytes"):
                                                self.conform_bytes = value
                                                self.conform_bytes.value_namespace = name_space
                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-packets"):
                                                self.conform_packets = value
                                                self.conform_packets.value_namespace = name_space
                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-rate"):
                                                self.conform_rate = value
                                                self.conform_rate.value_namespace = name_space
                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-bytes"):
                                                self.exceed_bytes = value
                                                self.exceed_bytes.value_namespace = name_space
                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-packets"):
                                                self.exceed_packets = value
                                                self.exceed_packets.value_namespace = name_space
                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-rate"):
                                                self.exceed_rate = value
                                                self.exceed_rate.value_namespace = name_space
                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forced-wred-stats-display"):
                                                self.forced_wred_stats_display = value
                                                self.forced_wred_stats_display.value_namespace = name_space
                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-bytes"):
                                                self.max_threshold_bytes = value
                                                self.max_threshold_bytes.value_namespace = name_space
                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-packets"):
                                                self.max_threshold_packets = value
                                                self.max_threshold_packets.value_namespace = name_space
                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-drop-threshold"):
                                                self.queue_drop_threshold = value
                                                self.queue_drop_threshold.value_namespace = name_space
                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-id"):
                                                self.queue_id = value
                                                self.queue_id.value_namespace = name_space
                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-bytes"):
                                                self.random_drop_bytes = value
                                                self.random_drop_bytes.value_namespace = name_space
                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-packets"):
                                                self.random_drop_packets = value
                                                self.random_drop_packets.value_namespace = name_space
                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tail-drop-bytes"):
                                                self.tail_drop_bytes = value
                                                self.tail_drop_bytes.value_namespace = name_space
                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tail-drop-packets"):
                                                self.tail_drop_packets = value
                                                self.tail_drop_packets.value_namespace = name_space
                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                    class PoliceStatsArray(Entity):
                                        """
                                        array of police stats
                                        
                                        .. attribute:: color_class_stats
                                        
                                        	color class stats
                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats>`
                                        
                                        .. attribute:: conform_bytes
                                        
                                        	Bytes that conform to the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_packets
                                        
                                        	Packets that conform  to the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_rate
                                        
                                        	Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: drop_bytes
                                        
                                        	Police dropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: drop_packets
                                        
                                        	Police dropped packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_bytes
                                        
                                        	Bytes that exceed  the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_packets
                                        
                                        	Packets that exceed the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_rate
                                        
                                        	Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: parent_drop_bytes
                                        
                                        	Dropped bytes by the parent policer
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: parent_drop_packets
                                        
                                        	Dropped pkts by the parent policer
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_bytes
                                        
                                        	Bytes that violate the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_packets
                                        
                                        	Packets violating the policed rate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_rate
                                        
                                        	Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray, self).__init__()

                                            self.yang_name = "police-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                            self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats()
                                            self.color_class_stats.parent = self
                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                            self._children_yang_names.add("color-class-stats")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_bytes",
                                                            "conform_packets",
                                                            "conform_rate",
                                                            "drop_bytes",
                                                            "drop_packets",
                                                            "exceed_bytes",
                                                            "exceed_packets",
                                                            "exceed_rate",
                                                            "parent_drop_bytes",
                                                            "parent_drop_packets",
                                                            "violate_bytes",
                                                            "violate_packets",
                                                            "violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                        class ColorClassStats(Entity):
                                            """
                                            color class stats
                                            
                                            .. attribute:: conform_class_conform_bytes
                                            
                                            	Bytes with classification result conform and policer result conform
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_conform_packets
                                            
                                            	Packets with classification result conform and policer result conform
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_conform_rate
                                            
                                            	Conform Class Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: conform_class_exceed_bytes
                                            
                                            	Bytes with classification result conform and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_exceed_packets
                                            
                                            	Packets with classification result conform and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_exceed_rate
                                            
                                            	Conform Class Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: conform_class_violate_bytes
                                            
                                            	Bytes with classification result conform and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_class_violate_packets
                                            
                                            	Packets with classification result conform and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_class_violate_rate
                                            
                                            	Conform Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_class_exceed_bytes
                                            
                                            	Bytes with classification result exceed and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_class_exceed_packets
                                            
                                            	Packets with classification result exceed and policer result exceed
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_class_exceed_rate
                                            
                                            	Exceed Class Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: exceed_class_violate_bytes
                                            
                                            	Bytes with classification result exceed and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_class_violate_packets
                                            
                                            	Packets with classification result exceed and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_class_violate_rate
                                            
                                            	Exceed Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: violate_class_violate_bytes
                                            
                                            	Bytes with classification result violate and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_class_violate_packets
                                            
                                            	Packets with classification result violate and policer result violate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_class_violate_rate
                                            
                                            	Violate Class Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                self.yang_name = "color-class-stats"
                                                self.yang_parent_name = "police-stats-array"

                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_class_conform_bytes",
                                                                "conform_class_conform_packets",
                                                                "conform_class_conform_rate",
                                                                "conform_class_exceed_bytes",
                                                                "conform_class_exceed_packets",
                                                                "conform_class_exceed_rate",
                                                                "conform_class_violate_bytes",
                                                                "conform_class_violate_packets",
                                                                "conform_class_violate_rate",
                                                                "exceed_class_exceed_bytes",
                                                                "exceed_class_exceed_packets",
                                                                "exceed_class_exceed_rate",
                                                                "exceed_class_violate_bytes",
                                                                "exceed_class_violate_packets",
                                                                "exceed_class_violate_rate",
                                                                "violate_class_violate_bytes",
                                                                "violate_class_violate_packets",
                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.conform_class_conform_bytes.is_set or
                                                    self.conform_class_conform_packets.is_set or
                                                    self.conform_class_conform_rate.is_set or
                                                    self.conform_class_exceed_bytes.is_set or
                                                    self.conform_class_exceed_packets.is_set or
                                                    self.conform_class_exceed_rate.is_set or
                                                    self.conform_class_violate_bytes.is_set or
                                                    self.conform_class_violate_packets.is_set or
                                                    self.conform_class_violate_rate.is_set or
                                                    self.exceed_class_exceed_bytes.is_set or
                                                    self.exceed_class_exceed_packets.is_set or
                                                    self.exceed_class_exceed_rate.is_set or
                                                    self.exceed_class_violate_bytes.is_set or
                                                    self.exceed_class_violate_packets.is_set or
                                                    self.exceed_class_violate_rate.is_set or
                                                    self.violate_class_violate_bytes.is_set or
                                                    self.violate_class_violate_packets.is_set or
                                                    self.violate_class_violate_rate.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "color-class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-class-conform-bytes"):
                                                    self.conform_class_conform_bytes = value
                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-conform-packets"):
                                                    self.conform_class_conform_packets = value
                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-conform-rate"):
                                                    self.conform_class_conform_rate = value
                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-bytes"):
                                                    self.conform_class_exceed_bytes = value
                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-packets"):
                                                    self.conform_class_exceed_packets = value
                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-exceed-rate"):
                                                    self.conform_class_exceed_rate = value
                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-bytes"):
                                                    self.conform_class_violate_bytes = value
                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-packets"):
                                                    self.conform_class_violate_packets = value
                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-class-violate-rate"):
                                                    self.conform_class_violate_rate = value
                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-bytes"):
                                                    self.exceed_class_exceed_bytes = value
                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-packets"):
                                                    self.exceed_class_exceed_packets = value
                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-exceed-rate"):
                                                    self.exceed_class_exceed_rate = value
                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-bytes"):
                                                    self.exceed_class_violate_bytes = value
                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-packets"):
                                                    self.exceed_class_violate_packets = value
                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-class-violate-rate"):
                                                    self.exceed_class_violate_rate = value
                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-bytes"):
                                                    self.violate_class_violate_bytes = value
                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-packets"):
                                                    self.violate_class_violate_packets = value
                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-class-violate-rate"):
                                                    self.violate_class_violate_rate = value
                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.conform_bytes.is_set or
                                                self.conform_packets.is_set or
                                                self.conform_rate.is_set or
                                                self.drop_bytes.is_set or
                                                self.drop_packets.is_set or
                                                self.exceed_bytes.is_set or
                                                self.exceed_packets.is_set or
                                                self.exceed_rate.is_set or
                                                self.parent_drop_bytes.is_set or
                                                self.parent_drop_packets.is_set or
                                                self.violate_bytes.is_set or
                                                self.violate_packets.is_set or
                                                self.violate_rate.is_set or
                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_packets.yfilter != YFilter.not_set or
                                                self.conform_rate.yfilter != YFilter.not_set or
                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                self.drop_packets.yfilter != YFilter.not_set or
                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_packets.yfilter != YFilter.not_set or
                                                self.violate_rate.yfilter != YFilter.not_set or
                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "police-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "color-class-stats"):
                                                if (self.color_class_stats is None):
                                                    self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                return self.color_class_stats

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-bytes"):
                                                self.conform_bytes = value
                                                self.conform_bytes.value_namespace = name_space
                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-packets"):
                                                self.conform_packets = value
                                                self.conform_packets.value_namespace = name_space
                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-rate"):
                                                self.conform_rate = value
                                                self.conform_rate.value_namespace = name_space
                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-bytes"):
                                                self.drop_bytes = value
                                                self.drop_bytes.value_namespace = name_space
                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "drop-packets"):
                                                self.drop_packets = value
                                                self.drop_packets.value_namespace = name_space
                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-bytes"):
                                                self.exceed_bytes = value
                                                self.exceed_bytes.value_namespace = name_space
                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-packets"):
                                                self.exceed_packets = value
                                                self.exceed_packets.value_namespace = name_space
                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-rate"):
                                                self.exceed_rate = value
                                                self.exceed_rate.value_namespace = name_space
                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "parent-drop-bytes"):
                                                self.parent_drop_bytes = value
                                                self.parent_drop_bytes.value_namespace = name_space
                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "parent-drop-packets"):
                                                self.parent_drop_packets = value
                                                self.parent_drop_packets.value_namespace = name_space
                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-bytes"):
                                                self.violate_bytes = value
                                                self.violate_bytes.value_namespace = name_space
                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-packets"):
                                                self.violate_packets = value
                                                self.violate_packets.value_namespace = name_space
                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-rate"):
                                                self.violate_rate = value
                                                self.violate_rate.value_namespace = name_space
                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                    class WredStatsArray(Entity):
                                        """
                                        array of red stats
                                        
                                        .. attribute:: max_threshold_bytes
                                        
                                        	Dropped bytes with  the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: max_threshold_packets
                                        
                                        	Dropped packets with  the average queue size at the max\-threshold
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: profile_title
                                        
                                        	ProfileTitle
                                        	**type**\:  str
                                        
                                        	**length:** 0..300
                                        
                                        .. attribute:: random_drop_bytes
                                        
                                        	Probabilisticallydropped bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: random_drop_packets
                                        
                                        	Probabilistically dropped  packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: red_ecn_marked_bytes
                                        
                                        	ECN marked bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: red_ecn_marked_packets
                                        
                                        	ECN marked packets 
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: red_label
                                        
                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray.RedLabel>`
                                        
                                        .. attribute:: red_transmit_bytes
                                        
                                        	Transmitted bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: red_transmit_packets
                                        
                                        	Transmitted packets
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray, self).__init__()

                                            self.yang_name = "wred-stats-array"
                                            self.yang_parent_name = "class-stats"

                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                            self.red_label = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("max_threshold_bytes",
                                                            "max_threshold_packets",
                                                            "profile_title",
                                                            "random_drop_bytes",
                                                            "random_drop_packets",
                                                            "red_ecn_marked_bytes",
                                                            "red_ecn_marked_packets",
                                                            "red_transmit_bytes",
                                                            "red_transmit_packets") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                        class RedLabel(Entity):
                                            """
                                            Array of WRED Typevalues as in PRP stats is
                                            available per threshold   
                                            
                                            .. attribute:: value
                                            
                                            	WRED value for this type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: wred_type
                                            
                                            	WRED type DSCP, EXP, PREC etc
                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                self.yang_name = "red-label"
                                                self.yang_parent_name = "wred-stats-array"

                                                self.value = YLeaf(YType.uint8, "value")

                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("value",
                                                                "wred_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.value.is_set or
                                                    self.wred_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set or
                                                    self.wred_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "red-label" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "value" or name == "wred-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "wred-type"):
                                                    self.wred_type = value
                                                    self.wred_type.value_namespace = name_space
                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.red_label:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.max_threshold_bytes.is_set or
                                                self.max_threshold_packets.is_set or
                                                self.profile_title.is_set or
                                                self.random_drop_bytes.is_set or
                                                self.random_drop_packets.is_set or
                                                self.red_ecn_marked_bytes.is_set or
                                                self.red_ecn_marked_packets.is_set or
                                                self.red_transmit_bytes.is_set or
                                                self.red_transmit_packets.is_set)

                                        def has_operation(self):
                                            for c in self.red_label:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                self.profile_title.yfilter != YFilter.not_set or
                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wred-stats-array" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "red-label"):
                                                for c in self.red_label:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray.RedLabel()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.red_label.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "max-threshold-bytes"):
                                                self.max_threshold_bytes = value
                                                self.max_threshold_bytes.value_namespace = name_space
                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-threshold-packets"):
                                                self.max_threshold_packets = value
                                                self.max_threshold_packets.value_namespace = name_space
                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-title"):
                                                self.profile_title = value
                                                self.profile_title.value_namespace = name_space
                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-bytes"):
                                                self.random_drop_bytes = value
                                                self.random_drop_bytes.value_namespace = name_space
                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "random-drop-packets"):
                                                self.random_drop_packets = value
                                                self.random_drop_packets.value_namespace = name_space
                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-ecn-marked-bytes"):
                                                self.red_ecn_marked_bytes = value
                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-ecn-marked-packets"):
                                                self.red_ecn_marked_packets = value
                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-transmit-bytes"):
                                                self.red_transmit_bytes = value
                                                self.red_transmit_bytes.value_namespace = name_space
                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "red-transmit-packets"):
                                                self.red_transmit_packets = value
                                                self.red_transmit_packets.value_namespace = name_space
                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.police_stats_array:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_stats_array:
                                            if (c.has_data()):
                                                return True
                                        for c in self.wred_stats_array:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.cac_state.is_set or
                                            self.class_name.is_set or
                                            self.counter_validity_bitmask.is_set or
                                            self.queue_descr.is_set or
                                            self.shared_queue_id.is_set or
                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                            (self.child_policy is not None and self.child_policy.has_data()) or
                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                    def has_operation(self):
                                        for c in self.police_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.wred_stats_array:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.cac_state.yfilter != YFilter.not_set or
                                            self.class_name.yfilter != YFilter.not_set or
                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                            self.queue_descr.yfilter != YFilter.not_set or
                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                            (self.child_policy is not None and self.child_policy.has_operation()) or
                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "class-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "cac-stats"):
                                            if (self.cac_stats is None):
                                                self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                            return self.cac_stats

                                        if (child_yang_name == "child-policy"):
                                            if (self.child_policy is None):
                                                self.child_policy = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                            return self.child_policy

                                        if (child_yang_name == "general-stats"):
                                            if (self.general_stats is None):
                                                self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                            return self.general_stats

                                        if (child_yang_name == "iphc-stats"):
                                            if (self.iphc_stats is None):
                                                self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                            return self.iphc_stats

                                        if (child_yang_name == "police-stats-array"):
                                            for c in self.police_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.PoliceStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.police_stats_array.append(c)
                                            return c

                                        if (child_yang_name == "queue-stats-array"):
                                            for c in self.queue_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.QueueStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_stats_array.append(c)
                                            return c

                                        if (child_yang_name == "wred-stats-array"):
                                            for c in self.wred_stats_array:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats.WredStatsArray()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.wred_stats_array.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "cac-state"):
                                            self.cac_state = value
                                            self.cac_state.value_namespace = name_space
                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "class-name"):
                                            self.class_name = value
                                            self.class_name.value_namespace = name_space
                                            self.class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "counter-validity-bitmask"):
                                            self.counter_validity_bitmask = value
                                            self.counter_validity_bitmask.value_namespace = name_space
                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-descr"):
                                            self.queue_descr = value
                                            self.queue_descr.value_namespace = name_space
                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "shared-queue-id"):
                                            self.shared_queue_id = value
                                            self.shared_queue_id.value_namespace = name_space
                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.class_stats:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.policy_name.is_set or
                                        self.satid.is_set or
                                        self.state.is_set or
                                        self.state_description.is_set)

                                def has_operation(self):
                                    for c in self.class_stats:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.policy_name.yfilter != YFilter.not_set or
                                        self.satid.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_description.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vo-q-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "class-stats"):
                                        for c in self.class_stats:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats.ClassStats()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.class_stats.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "policy-name"):
                                        self.policy_name = value
                                        self.policy_name.value_namespace = name_space
                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "satid"):
                                        self.satid = value
                                        self.satid.value_namespace = name_space
                                        self.satid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-description"):
                                        self.state_description = value
                                        self.state_description.value_namespace = name_space
                                        self.state_description.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.locationvo_qs is not None and self.locationvo_qs.has_data()) or
                                    (self.vo_q_stats is not None and self.vo_q_stats.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.locationvo_qs is not None and self.locationvo_qs.has_operation()) or
                                    (self.vo_q_stats is not None and self.vo_q_stats.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "output-vo-q" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "locationvo-qs"):
                                    if (self.locationvo_qs is None):
                                        self.locationvo_qs = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.LocationvoQs()
                                        self.locationvo_qs.parent = self
                                        self._children_name_map["locationvo_qs"] = "locationvo-qs"
                                    return self.locationvo_qs

                                if (child_yang_name == "vo-q-stats"):
                                    if (self.vo_q_stats is None):
                                        self.vo_q_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ.VoQStats()
                                        self.vo_q_stats.parent = self
                                        self._children_name_map["vo_q_stats"] = "vo-q-stats"
                                    return self.vo_q_stats

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "locationvo-qs" or name == "vo-q-stats"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class VoQMemberInterfaces(Entity):
                            """
                            VoQ QoS policy\-map member interface table
                            
                            .. attribute:: vo_q_member_interface
                            
                            	QoS policy\-map member interface statistics
                            	**type**\: list of    :py:class:`VoQMemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces, self).__init__()

                                self.yang_name = "vo-q-member-interfaces"
                                self.yang_parent_name = "vo-qinterface"

                                self.vo_q_member_interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces, self).__setattr__(name, value)


                            class VoQMemberInterface(Entity):
                                """
                                QoS policy\-map member interface statistics
                                
                                .. attribute:: interface_name  <key>
                                
                                	Name of member interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: vo_qoutput
                                
                                	output VoQ interface
                                	**type**\:   :py:class:`VoQoutput <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface, self).__init__()

                                    self.yang_name = "vo-q-member-interface"
                                    self.yang_parent_name = "vo-q-member-interfaces"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.vo_qoutput = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput()
                                    self.vo_qoutput.parent = self
                                    self._children_name_map["vo_qoutput"] = "vo-qoutput"
                                    self._children_yang_names.add("vo-qoutput")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface, self).__setattr__(name, value)


                                class VoQoutput(Entity):
                                    """
                                    output VoQ interface
                                    
                                    .. attribute:: vo_q_stats
                                    
                                    	VoQ statistics operational data for an interface
                                    	**type**\:   :py:class:`VoQStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput, self).__init__()

                                        self.yang_name = "vo-qoutput"
                                        self.yang_parent_name = "vo-q-member-interface"

                                        self.vo_q_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats()
                                        self.vo_q_stats.parent = self
                                        self._children_name_map["vo_q_stats"] = "vo-q-stats"
                                        self._children_yang_names.add("vo-q-stats")


                                    class VoQStats(Entity):
                                        """
                                        VoQ statistics operational data for an interface
                                        
                                        .. attribute:: class_stats
                                        
                                        	array of classes contained in policy
                                        	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	PolicyName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: satid
                                        
                                        	to maintain satellite id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                        
                                        .. attribute:: state_description
                                        
                                        	StateDescription
                                        	**type**\:  str
                                        
                                        	**length:** 0..128
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats, self).__init__()

                                            self.yang_name = "vo-q-stats"
                                            self.yang_parent_name = "vo-qoutput"

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.satid = YLeaf(YType.uint32, "satid")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.state_description = YLeaf(YType.str, "state-description")

                                            self.class_stats = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policy_name",
                                                            "satid",
                                                            "state",
                                                            "state_description") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats, self).__setattr__(name, value)


                                        class ClassStats(Entity):
                                            """
                                            array of classes contained in policy
                                            
                                            .. attribute:: cac_state
                                            
                                            	CACState
                                            	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                            
                                            .. attribute:: cac_stats
                                            
                                            	bag for cac stats
                                            	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.CacStats>`
                                            
                                            .. attribute:: child_policy
                                            
                                            	child policy
                                            	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy>`
                                            
                                            .. attribute:: class_name
                                            
                                            	ClassName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: counter_validity_bitmask
                                            
                                            	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: megabyte
                                            
                                            .. attribute:: general_stats
                                            
                                            	general stats
                                            	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.GeneralStats>`
                                            
                                            .. attribute:: iphc_stats
                                            
                                            	IPHC stats
                                            	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.IphcStats>`
                                            
                                            .. attribute:: police_stats_array
                                            
                                            	array of police stats
                                            	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray>`
                                            
                                            .. attribute:: queue_descr
                                            
                                            	Description of queue for the class
                                            	**type**\:  str
                                            
                                            	**length:** 0..256
                                            
                                            .. attribute:: queue_stats_array
                                            
                                            	array of queue stats
                                            	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray>`
                                            
                                            .. attribute:: shared_queue_id
                                            
                                            	q\-id of the  shared queue for this class
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: wred_stats_array
                                            
                                            	array of red stats
                                            	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray>`
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats, self).__init__()

                                                self.yang_name = "class-stats"
                                                self.yang_parent_name = "vo-q-stats"

                                                self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.CacStats()
                                                self.cac_stats.parent = self
                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                self._children_yang_names.add("cac-stats")

                                                self.child_policy = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy()
                                                self.child_policy.parent = self
                                                self._children_name_map["child_policy"] = "child-policy"
                                                self._children_yang_names.add("child-policy")

                                                self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.GeneralStats()
                                                self.general_stats.parent = self
                                                self._children_name_map["general_stats"] = "general-stats"
                                                self._children_yang_names.add("general-stats")

                                                self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.IphcStats()
                                                self.iphc_stats.parent = self
                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                self._children_yang_names.add("iphc-stats")

                                                self.police_stats_array = YList(self)
                                                self.queue_stats_array = YList(self)
                                                self.wred_stats_array = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("cac_state",
                                                                "class_name",
                                                                "counter_validity_bitmask",
                                                                "queue_descr",
                                                                "shared_queue_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats, self).__setattr__(name, value)


                                            class GeneralStats(Entity):
                                                """
                                                general stats
                                                
                                                .. attribute:: match_data_rate
                                                
                                                	Incoming matched data rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: pre_policy_matched_bytes
                                                
                                                	Matched bytes before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: pre_policy_matched_packets
                                                
                                                	Matched pkts before applying policy
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: total_drop_bytes
                                                
                                                	Dropped bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_packets
                                                
                                                	Dropped packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_drop_rate
                                                
                                                	Total drop rate (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: total_transmit_rate
                                                
                                                	Total transmit rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: transmit_bytes
                                                
                                                	Transmitted bytes (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: transmit_packets
                                                
                                                	Transmitted packets (packets/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.GeneralStats, self).__init__()

                                                    self.yang_name = "general-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                    self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                    self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                    self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                    self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                    self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                    self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                    self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                    self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("match_data_rate",
                                                                    "pre_policy_matched_bytes",
                                                                    "pre_policy_matched_packets",
                                                                    "total_drop_bytes",
                                                                    "total_drop_packets",
                                                                    "total_drop_rate",
                                                                    "total_transmit_rate",
                                                                    "transmit_bytes",
                                                                    "transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.match_data_rate.is_set or
                                                        self.pre_policy_matched_bytes.is_set or
                                                        self.pre_policy_matched_packets.is_set or
                                                        self.total_drop_bytes.is_set or
                                                        self.total_drop_packets.is_set or
                                                        self.total_drop_rate.is_set or
                                                        self.total_transmit_rate.is_set or
                                                        self.transmit_bytes.is_set or
                                                        self.transmit_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.match_data_rate.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                        self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_bytes.yfilter != YFilter.not_set or
                                                        self.total_drop_packets.yfilter != YFilter.not_set or
                                                        self.total_drop_rate.yfilter != YFilter.not_set or
                                                        self.total_transmit_rate.yfilter != YFilter.not_set or
                                                        self.transmit_bytes.yfilter != YFilter.not_set or
                                                        self.transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "general-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                    if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                    if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                    if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                    if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                    if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                    if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                    if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                    if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "match-data-rate"):
                                                        self.match_data_rate = value
                                                        self.match_data_rate.value_namespace = name_space
                                                        self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-bytes"):
                                                        self.pre_policy_matched_bytes = value
                                                        self.pre_policy_matched_bytes.value_namespace = name_space
                                                        self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pre-policy-matched-packets"):
                                                        self.pre_policy_matched_packets = value
                                                        self.pre_policy_matched_packets.value_namespace = name_space
                                                        self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-bytes"):
                                                        self.total_drop_bytes = value
                                                        self.total_drop_bytes.value_namespace = name_space
                                                        self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-packets"):
                                                        self.total_drop_packets = value
                                                        self.total_drop_packets.value_namespace = name_space
                                                        self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-drop-rate"):
                                                        self.total_drop_rate = value
                                                        self.total_drop_rate.value_namespace = name_space
                                                        self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "total-transmit-rate"):
                                                        self.total_transmit_rate = value
                                                        self.total_transmit_rate.value_namespace = name_space
                                                        self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-bytes"):
                                                        self.transmit_bytes = value
                                                        self.transmit_bytes.value_namespace = name_space
                                                        self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "transmit-packets"):
                                                        self.transmit_packets = value
                                                        self.transmit_packets.value_namespace = name_space
                                                        self.transmit_packets.value_namespace_prefix = name_space_prefix


                                            class IphcStats(Entity):
                                                """
                                                IPHC stats
                                                
                                                .. attribute:: non_tcp_bytes_saved
                                                
                                                	Non Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_bytes_sent_rate
                                                
                                                	Compressed Non Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_compressed_packets_out
                                                
                                                	Num of non tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_full_header_packets_out
                                                
                                                	Num of non tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: non_tcp_total_out_bytes
                                                
                                                	TotalNum of Non Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: non_tcp_total_out_packets
                                                
                                                	TotalNum of Non tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_bytes_saved
                                                
                                                	Tcp Bytes saved due to compression
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_bytes_sent_rate
                                                
                                                	Compressed Tcp Bytes sent rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_compressed_packets_out
                                                
                                                	Num of tcp compressed pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_full_header_packets_out
                                                
                                                	Num of tcp fullheader pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tcp_total_out_bytes
                                                
                                                	TotalNum of Tcp Bytes sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tcp_total_out_packets
                                                
                                                	Total Num of tcp pkts sent
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.IphcStats, self).__init__()

                                                    self.yang_name = "iphc-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                    self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                    self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                    self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                    self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                    self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                    self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                    self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                    self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                    self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                    self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                    self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("non_tcp_bytes_saved",
                                                                    "non_tcp_bytes_sent_rate",
                                                                    "non_tcp_compressed_packets_out",
                                                                    "non_tcp_full_header_packets_out",
                                                                    "non_tcp_total_out_bytes",
                                                                    "non_tcp_total_out_packets",
                                                                    "tcp_bytes_saved",
                                                                    "tcp_bytes_sent_rate",
                                                                    "tcp_compressed_packets_out",
                                                                    "tcp_full_header_packets_out",
                                                                    "tcp_total_out_bytes",
                                                                    "tcp_total_out_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.IphcStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.IphcStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.non_tcp_bytes_saved.is_set or
                                                        self.non_tcp_bytes_sent_rate.is_set or
                                                        self.non_tcp_compressed_packets_out.is_set or
                                                        self.non_tcp_full_header_packets_out.is_set or
                                                        self.non_tcp_total_out_bytes.is_set or
                                                        self.non_tcp_total_out_packets.is_set or
                                                        self.tcp_bytes_saved.is_set or
                                                        self.tcp_bytes_sent_rate.is_set or
                                                        self.tcp_compressed_packets_out.is_set or
                                                        self.tcp_full_header_packets_out.is_set or
                                                        self.tcp_total_out_bytes.is_set or
                                                        self.tcp_total_out_packets.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                        self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                        self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                        self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "iphc-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                    if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                    if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                    if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                    if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                    if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                    if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                    if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "non-tcp-bytes-saved"):
                                                        self.non_tcp_bytes_saved = value
                                                        self.non_tcp_bytes_saved.value_namespace = name_space
                                                        self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-bytes-sent-rate"):
                                                        self.non_tcp_bytes_sent_rate = value
                                                        self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-compressed-packets-out"):
                                                        self.non_tcp_compressed_packets_out = value
                                                        self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                        self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-full-header-packets-out"):
                                                        self.non_tcp_full_header_packets_out = value
                                                        self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                        self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-bytes"):
                                                        self.non_tcp_total_out_bytes = value
                                                        self.non_tcp_total_out_bytes.value_namespace = name_space
                                                        self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "non-tcp-total-out-packets"):
                                                        self.non_tcp_total_out_packets = value
                                                        self.non_tcp_total_out_packets.value_namespace = name_space
                                                        self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-saved"):
                                                        self.tcp_bytes_saved = value
                                                        self.tcp_bytes_saved.value_namespace = name_space
                                                        self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-bytes-sent-rate"):
                                                        self.tcp_bytes_sent_rate = value
                                                        self.tcp_bytes_sent_rate.value_namespace = name_space
                                                        self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-compressed-packets-out"):
                                                        self.tcp_compressed_packets_out = value
                                                        self.tcp_compressed_packets_out.value_namespace = name_space
                                                        self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-full-header-packets-out"):
                                                        self.tcp_full_header_packets_out = value
                                                        self.tcp_full_header_packets_out.value_namespace = name_space
                                                        self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-bytes"):
                                                        self.tcp_total_out_bytes = value
                                                        self.tcp_total_out_bytes.value_namespace = name_space
                                                        self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tcp-total-out-packets"):
                                                        self.tcp_total_out_packets = value
                                                        self.tcp_total_out_packets.value_namespace = name_space
                                                        self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                            class ChildPolicy(Entity):
                                                """
                                                child policy
                                                
                                                .. attribute:: class_stats
                                                
                                                	array of classes contained in policy
                                                	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats>`
                                                
                                                .. attribute:: policy_name
                                                
                                                	PolicyName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: satid
                                                
                                                	to maintain satellite id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: state
                                                
                                                	State
                                                	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                                
                                                .. attribute:: state_description
                                                
                                                	StateDescription
                                                	**type**\:  str
                                                
                                                	**length:** 0..128
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy, self).__init__()

                                                    self.yang_name = "child-policy"
                                                    self.yang_parent_name = "class-stats"

                                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                                    self.satid = YLeaf(YType.uint32, "satid")

                                                    self.state = YLeaf(YType.enumeration, "state")

                                                    self.state_description = YLeaf(YType.str, "state-description")

                                                    self.class_stats = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policy_name",
                                                                    "satid",
                                                                    "state",
                                                                    "state_description") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                                class ClassStats(Entity):
                                                    """
                                                    array of classes contained in policy
                                                    
                                                    .. attribute:: cac_state
                                                    
                                                    	CACState
                                                    	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                    
                                                    .. attribute:: cac_stats
                                                    
                                                    	bag for cac stats
                                                    	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	ClassName
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: counter_validity_bitmask
                                                    
                                                    	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: megabyte
                                                    
                                                    .. attribute:: general_stats
                                                    
                                                    	general stats
                                                    	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                    
                                                    .. attribute:: iphc_stats
                                                    
                                                    	IPHC stats
                                                    	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                    
                                                    .. attribute:: police_stats_array
                                                    
                                                    	array of police stats
                                                    	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                    
                                                    .. attribute:: queue_descr
                                                    
                                                    	Description of queue for the class
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..256
                                                    
                                                    .. attribute:: queue_stats_array
                                                    
                                                    	array of queue stats
                                                    	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                    
                                                    .. attribute:: shared_queue_id
                                                    
                                                    	q\-id of the  shared queue for this class
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: wred_stats_array
                                                    
                                                    	array of red stats
                                                    	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                        self.yang_name = "class-stats"
                                                        self.yang_parent_name = "child-policy"

                                                        self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                        self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                        self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                        self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                        self._children_yang_names.add("cac-stats")

                                                        self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                        self._children_yang_names.add("general-stats")

                                                        self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        self._children_yang_names.add("iphc-stats")

                                                        self.police_stats_array = YList(self)
                                                        self.queue_stats_array = YList(self)
                                                        self.wred_stats_array = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("cac_state",
                                                                        "class_name",
                                                                        "counter_validity_bitmask",
                                                                        "queue_descr",
                                                                        "shared_queue_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                    class GeneralStats(Entity):
                                                        """
                                                        general stats
                                                        
                                                        .. attribute:: match_data_rate
                                                        
                                                        	Incoming matched data rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: pre_policy_matched_bytes
                                                        
                                                        	Matched bytes before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: pre_policy_matched_packets
                                                        
                                                        	Matched pkts before applying policy
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: total_drop_bytes
                                                        
                                                        	Dropped bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_packets
                                                        
                                                        	Dropped packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_drop_rate
                                                        
                                                        	Total drop rate (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: total_transmit_rate
                                                        
                                                        	Total transmit rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: transmit_bytes
                                                        
                                                        	Transmitted bytes (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: transmit_packets
                                                        
                                                        	Transmitted packets (packets/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                            self.yang_name = "general-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                            self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                            self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                            self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                            self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                            self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                            self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                            self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                            self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("match_data_rate",
                                                                            "pre_policy_matched_bytes",
                                                                            "pre_policy_matched_packets",
                                                                            "total_drop_bytes",
                                                                            "total_drop_packets",
                                                                            "total_drop_rate",
                                                                            "total_transmit_rate",
                                                                            "transmit_bytes",
                                                                            "transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.match_data_rate.is_set or
                                                                self.pre_policy_matched_bytes.is_set or
                                                                self.pre_policy_matched_packets.is_set or
                                                                self.total_drop_bytes.is_set or
                                                                self.total_drop_packets.is_set or
                                                                self.total_drop_rate.is_set or
                                                                self.total_transmit_rate.is_set or
                                                                self.transmit_bytes.is_set or
                                                                self.transmit_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.match_data_rate.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                                self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_bytes.yfilter != YFilter.not_set or
                                                                self.total_drop_packets.yfilter != YFilter.not_set or
                                                                self.total_drop_rate.yfilter != YFilter.not_set or
                                                                self.total_transmit_rate.yfilter != YFilter.not_set or
                                                                self.transmit_bytes.yfilter != YFilter.not_set or
                                                                self.transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "general-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                            if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                            if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                            if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                            if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                            if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                            if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                            if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                            if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "match-data-rate"):
                                                                self.match_data_rate = value
                                                                self.match_data_rate.value_namespace = name_space
                                                                self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-bytes"):
                                                                self.pre_policy_matched_bytes = value
                                                                self.pre_policy_matched_bytes.value_namespace = name_space
                                                                self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "pre-policy-matched-packets"):
                                                                self.pre_policy_matched_packets = value
                                                                self.pre_policy_matched_packets.value_namespace = name_space
                                                                self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-bytes"):
                                                                self.total_drop_bytes = value
                                                                self.total_drop_bytes.value_namespace = name_space
                                                                self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-packets"):
                                                                self.total_drop_packets = value
                                                                self.total_drop_packets.value_namespace = name_space
                                                                self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-drop-rate"):
                                                                self.total_drop_rate = value
                                                                self.total_drop_rate.value_namespace = name_space
                                                                self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "total-transmit-rate"):
                                                                self.total_transmit_rate = value
                                                                self.total_transmit_rate.value_namespace = name_space
                                                                self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-bytes"):
                                                                self.transmit_bytes = value
                                                                self.transmit_bytes.value_namespace = name_space
                                                                self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "transmit-packets"):
                                                                self.transmit_packets = value
                                                                self.transmit_packets.value_namespace = name_space
                                                                self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                    class IphcStats(Entity):
                                                        """
                                                        IPHC stats
                                                        
                                                        .. attribute:: non_tcp_bytes_saved
                                                        
                                                        	Non Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_bytes_sent_rate
                                                        
                                                        	Compressed Non Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_compressed_packets_out
                                                        
                                                        	Num of non tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_full_header_packets_out
                                                        
                                                        	Num of non tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: non_tcp_total_out_bytes
                                                        
                                                        	TotalNum of Non Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: non_tcp_total_out_packets
                                                        
                                                        	TotalNum of Non tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_bytes_saved
                                                        
                                                        	Tcp Bytes saved due to compression
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_bytes_sent_rate
                                                        
                                                        	Compressed Tcp Bytes sent rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_compressed_packets_out
                                                        
                                                        	Num of tcp compressed pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_full_header_packets_out
                                                        
                                                        	Num of tcp fullheader pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tcp_total_out_bytes
                                                        
                                                        	TotalNum of Tcp Bytes sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tcp_total_out_packets
                                                        
                                                        	Total Num of tcp pkts sent
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                            self.yang_name = "iphc-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                            self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                            self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                            self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                            self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                            self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                            self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                            self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                            self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                            self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                            self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                            self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("non_tcp_bytes_saved",
                                                                            "non_tcp_bytes_sent_rate",
                                                                            "non_tcp_compressed_packets_out",
                                                                            "non_tcp_full_header_packets_out",
                                                                            "non_tcp_total_out_bytes",
                                                                            "non_tcp_total_out_packets",
                                                                            "tcp_bytes_saved",
                                                                            "tcp_bytes_sent_rate",
                                                                            "tcp_compressed_packets_out",
                                                                            "tcp_full_header_packets_out",
                                                                            "tcp_total_out_bytes",
                                                                            "tcp_total_out_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.non_tcp_bytes_saved.is_set or
                                                                self.non_tcp_bytes_sent_rate.is_set or
                                                                self.non_tcp_compressed_packets_out.is_set or
                                                                self.non_tcp_full_header_packets_out.is_set or
                                                                self.non_tcp_total_out_bytes.is_set or
                                                                self.non_tcp_total_out_packets.is_set or
                                                                self.tcp_bytes_saved.is_set or
                                                                self.tcp_bytes_sent_rate.is_set or
                                                                self.tcp_compressed_packets_out.is_set or
                                                                self.tcp_full_header_packets_out.is_set or
                                                                self.tcp_total_out_bytes.is_set or
                                                                self.tcp_total_out_packets.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                                self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                                self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                                self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "iphc-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                            if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                            if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                            if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                            if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                            if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                            if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                            if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "non-tcp-bytes-saved"):
                                                                self.non_tcp_bytes_saved = value
                                                                self.non_tcp_bytes_saved.value_namespace = name_space
                                                                self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-bytes-sent-rate"):
                                                                self.non_tcp_bytes_sent_rate = value
                                                                self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-compressed-packets-out"):
                                                                self.non_tcp_compressed_packets_out = value
                                                                self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                                self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-full-header-packets-out"):
                                                                self.non_tcp_full_header_packets_out = value
                                                                self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                                self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-bytes"):
                                                                self.non_tcp_total_out_bytes = value
                                                                self.non_tcp_total_out_bytes.value_namespace = name_space
                                                                self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "non-tcp-total-out-packets"):
                                                                self.non_tcp_total_out_packets = value
                                                                self.non_tcp_total_out_packets.value_namespace = name_space
                                                                self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-saved"):
                                                                self.tcp_bytes_saved = value
                                                                self.tcp_bytes_saved.value_namespace = name_space
                                                                self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-bytes-sent-rate"):
                                                                self.tcp_bytes_sent_rate = value
                                                                self.tcp_bytes_sent_rate.value_namespace = name_space
                                                                self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-compressed-packets-out"):
                                                                self.tcp_compressed_packets_out = value
                                                                self.tcp_compressed_packets_out.value_namespace = name_space
                                                                self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-full-header-packets-out"):
                                                                self.tcp_full_header_packets_out = value
                                                                self.tcp_full_header_packets_out.value_namespace = name_space
                                                                self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-bytes"):
                                                                self.tcp_total_out_bytes = value
                                                                self.tcp_total_out_bytes.value_namespace = name_space
                                                                self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tcp-total-out-packets"):
                                                                self.tcp_total_out_packets = value
                                                                self.tcp_total_out_packets.value_namespace = name_space
                                                                self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                    class CacStats(Entity):
                                                        """
                                                        bag for cac stats
                                                        
                                                        .. attribute:: admit_bytes
                                                        
                                                        	Admitted bytes (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: admit_rates
                                                        
                                                        	CAC admit rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: admitpackets
                                                        
                                                        	Admitted packets (pkts/bytes)
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	CAC dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	CAC dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: drop_rates
                                                        
                                                        	CAC dropped rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                            self.yang_name = "cac-stats"
                                                            self.yang_parent_name = "class-stats"

                                                            self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                            self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                            self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("admit_bytes",
                                                                            "admit_rates",
                                                                            "admitpackets",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "drop_rates") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.admit_bytes.is_set or
                                                                self.admit_rates.is_set or
                                                                self.admitpackets.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.drop_rates.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.admit_bytes.yfilter != YFilter.not_set or
                                                                self.admit_rates.yfilter != YFilter.not_set or
                                                                self.admitpackets.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.drop_rates.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cac-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                            if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                            if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "admit-bytes"):
                                                                self.admit_bytes = value
                                                                self.admit_bytes.value_namespace = name_space
                                                                self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admit-rates"):
                                                                self.admit_rates = value
                                                                self.admit_rates.value_namespace = name_space
                                                                self.admit_rates.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "admitpackets"):
                                                                self.admitpackets = value
                                                                self.admitpackets.value_namespace = name_space
                                                                self.admitpackets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-rates"):
                                                                self.drop_rates = value
                                                                self.drop_rates.value_namespace = name_space
                                                                self.drop_rates.value_namespace_prefix = name_space_prefix


                                                    class QueueStatsArray(Entity):
                                                        """
                                                        array of queue stats
                                                        
                                                        .. attribute:: atm_clp0_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp0_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: atm_clp1_drop_bytes
                                                        
                                                        	ATP CLP 0 matched bytes dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: atm_clp1_drop_packets
                                                        
                                                        	ATP CLP 0 matched packets dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the queue rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: forced_wred_stats_display
                                                        
                                                        	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: queue_average_length
                                                        
                                                        	Queue average length
                                                        	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                        
                                                        .. attribute:: queue_drop_threshold
                                                        
                                                        	tail drop threshold of the queue in bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: queue_id
                                                        
                                                        	Queue Id used for Fabric Stats
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: queue_instance_length
                                                        
                                                        	Queue instance length
                                                        	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                        
                                                        .. attribute:: queue_max_length
                                                        
                                                        	Queue maximum length
                                                        	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Bytes probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Packets probabilistically dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: tail_drop_bytes
                                                        
                                                        	Bytes tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: tail_drop_packets
                                                        
                                                        	Packets tail dropped
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                            self.yang_name = "queue-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                            self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                            self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                            self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                            self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                            self.queue_average_length = YList(self)
                                                            self.queue_instance_length = YList(self)
                                                            self.queue_max_length = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("atm_clp0_drop_bytes",
                                                                            "atm_clp0_drop_packets",
                                                                            "atm_clp1_drop_bytes",
                                                                            "atm_clp1_drop_packets",
                                                                            "conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "forced_wred_stats_display",
                                                                            "max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "queue_drop_threshold",
                                                                            "queue_id",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "tail_drop_bytes",
                                                                            "tail_drop_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                        class QueueInstanceLength(Entity):
                                                            """
                                                            Queue instance length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                                self.yang_name = "queue-instance-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-instance-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueAverageLength(Entity):
                                                            """
                                                            Queue average length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                                self.yang_name = "queue-average-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-average-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix


                                                        class QueueMaxLength(Entity):
                                                            """
                                                            Queue maximum length
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	unit
                                                            	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                                self.yang_name = "queue-max-length"
                                                                self.yang_parent_name = "queue-stats-array"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "queue-max-length" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.atm_clp0_drop_bytes.is_set or
                                                                self.atm_clp0_drop_packets.is_set or
                                                                self.atm_clp1_drop_bytes.is_set or
                                                                self.atm_clp1_drop_packets.is_set or
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.forced_wred_stats_display.is_set or
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.queue_drop_threshold.is_set or
                                                                self.queue_id.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.tail_drop_bytes.is_set or
                                                                self.tail_drop_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.queue_average_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_instance_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            for c in self.queue_max_length:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                                self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                                self.queue_id.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                                self.tail_drop_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                            if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                            if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                            if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "queue-average-length"):
                                                                for c in self.queue_average_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_average_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-instance-length"):
                                                                for c in self.queue_instance_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_instance_length.append(c)
                                                                return c

                                                            if (child_yang_name == "queue-max-length"):
                                                                for c in self.queue_max_length:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.queue_max_length.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "atm-clp0-drop-bytes"):
                                                                self.atm_clp0_drop_bytes = value
                                                                self.atm_clp0_drop_bytes.value_namespace = name_space
                                                                self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp0-drop-packets"):
                                                                self.atm_clp0_drop_packets = value
                                                                self.atm_clp0_drop_packets.value_namespace = name_space
                                                                self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-bytes"):
                                                                self.atm_clp1_drop_bytes = value
                                                                self.atm_clp1_drop_bytes.value_namespace = name_space
                                                                self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "atm-clp1-drop-packets"):
                                                                self.atm_clp1_drop_packets = value
                                                                self.atm_clp1_drop_packets.value_namespace = name_space
                                                                self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "forced-wred-stats-display"):
                                                                self.forced_wred_stats_display = value
                                                                self.forced_wred_stats_display.value_namespace = name_space
                                                                self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-drop-threshold"):
                                                                self.queue_drop_threshold = value
                                                                self.queue_drop_threshold.value_namespace = name_space
                                                                self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "queue-id"):
                                                                self.queue_id = value
                                                                self.queue_id.value_namespace = name_space
                                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-bytes"):
                                                                self.tail_drop_bytes = value
                                                                self.tail_drop_bytes.value_namespace = name_space
                                                                self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "tail-drop-packets"):
                                                                self.tail_drop_packets = value
                                                                self.tail_drop_packets.value_namespace = name_space
                                                                self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                    class PoliceStatsArray(Entity):
                                                        """
                                                        array of police stats
                                                        
                                                        .. attribute:: color_class_stats
                                                        
                                                        	color class stats
                                                        	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                        
                                                        .. attribute:: conform_bytes
                                                        
                                                        	Bytes that conform to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_packets
                                                        
                                                        	Packets that conform  to the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_rate
                                                        
                                                        	Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: drop_bytes
                                                        
                                                        	Police dropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: drop_packets
                                                        
                                                        	Police dropped packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_bytes
                                                        
                                                        	Bytes that exceed  the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_packets
                                                        
                                                        	Packets that exceed the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_rate
                                                        
                                                        	Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: parent_drop_bytes
                                                        
                                                        	Dropped bytes by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: parent_drop_packets
                                                        
                                                        	Dropped pkts by the parent policer
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_bytes
                                                        
                                                        	Bytes that violate the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_packets
                                                        
                                                        	Packets violating the policed rate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_rate
                                                        
                                                        	Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                            self.yang_name = "police-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                            self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                            self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                            self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                            self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                            self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                            self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                            self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                            self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                            self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                            self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                            self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                            self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                            self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            self._children_yang_names.add("color-class-stats")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_bytes",
                                                                            "conform_packets",
                                                                            "conform_rate",
                                                                            "drop_bytes",
                                                                            "drop_packets",
                                                                            "exceed_bytes",
                                                                            "exceed_packets",
                                                                            "exceed_rate",
                                                                            "parent_drop_bytes",
                                                                            "parent_drop_packets",
                                                                            "violate_bytes",
                                                                            "violate_packets",
                                                                            "violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                        class ColorClassStats(Entity):
                                                            """
                                                            color class stats
                                                            
                                                            .. attribute:: conform_class_conform_bytes
                                                            
                                                            	Bytes with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_conform_packets
                                                            
                                                            	Packets with classification result conform and policer result conform
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_conform_rate
                                                            
                                                            	Conform Class Conform rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_exceed_bytes
                                                            
                                                            	Bytes with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_exceed_packets
                                                            
                                                            	Packets with classification result conform and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_exceed_rate
                                                            
                                                            	Conform Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: conform_class_violate_bytes
                                                            
                                                            	Bytes with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: conform_class_violate_packets
                                                            
                                                            	Packets with classification result conform and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: conform_class_violate_rate
                                                            
                                                            	Conform Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_exceed_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_exceed_packets
                                                            
                                                            	Packets with classification result exceed and policer result exceed
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_exceed_rate
                                                            
                                                            	Exceed Class Exceed rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: exceed_class_violate_bytes
                                                            
                                                            	Bytes with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: exceed_class_violate_packets
                                                            
                                                            	Packets with classification result exceed and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: exceed_class_violate_rate
                                                            
                                                            	Exceed Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            .. attribute:: violate_class_violate_bytes
                                                            
                                                            	Bytes with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            	**units**\: byte
                                                            
                                                            .. attribute:: violate_class_violate_packets
                                                            
                                                            	Packets with classification result violate and policer result violate
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: violate_class_violate_rate
                                                            
                                                            	Violate Class Violate rate in kbps
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            	**units**\: kbit/s
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                                self.yang_name = "color-class-stats"
                                                                self.yang_parent_name = "police-stats-array"

                                                                self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                                self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                                self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                                self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                                self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                                self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                                self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                                self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                                self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                                self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                                self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                                self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                                self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                                self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                                self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                                self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                                self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                                self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("conform_class_conform_bytes",
                                                                                "conform_class_conform_packets",
                                                                                "conform_class_conform_rate",
                                                                                "conform_class_exceed_bytes",
                                                                                "conform_class_exceed_packets",
                                                                                "conform_class_exceed_rate",
                                                                                "conform_class_violate_bytes",
                                                                                "conform_class_violate_packets",
                                                                                "conform_class_violate_rate",
                                                                                "exceed_class_exceed_bytes",
                                                                                "exceed_class_exceed_packets",
                                                                                "exceed_class_exceed_rate",
                                                                                "exceed_class_violate_bytes",
                                                                                "exceed_class_violate_packets",
                                                                                "exceed_class_violate_rate",
                                                                                "violate_class_violate_bytes",
                                                                                "violate_class_violate_packets",
                                                                                "violate_class_violate_rate") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.conform_class_conform_bytes.is_set or
                                                                    self.conform_class_conform_packets.is_set or
                                                                    self.conform_class_conform_rate.is_set or
                                                                    self.conform_class_exceed_bytes.is_set or
                                                                    self.conform_class_exceed_packets.is_set or
                                                                    self.conform_class_exceed_rate.is_set or
                                                                    self.conform_class_violate_bytes.is_set or
                                                                    self.conform_class_violate_packets.is_set or
                                                                    self.conform_class_violate_rate.is_set or
                                                                    self.exceed_class_exceed_bytes.is_set or
                                                                    self.exceed_class_exceed_packets.is_set or
                                                                    self.exceed_class_exceed_rate.is_set or
                                                                    self.exceed_class_violate_bytes.is_set or
                                                                    self.exceed_class_violate_packets.is_set or
                                                                    self.exceed_class_violate_rate.is_set or
                                                                    self.violate_class_violate_bytes.is_set or
                                                                    self.violate_class_violate_packets.is_set or
                                                                    self.violate_class_violate_rate.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                    self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "color-class-stats" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                                if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                                if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                                if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                                if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                                if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                                if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                                if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                                if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                                if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                                if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                                if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                                if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                                if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                                if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                                if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                                if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                                if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "conform-class-conform-bytes"):
                                                                    self.conform_class_conform_bytes = value
                                                                    self.conform_class_conform_bytes.value_namespace = name_space
                                                                    self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-packets"):
                                                                    self.conform_class_conform_packets = value
                                                                    self.conform_class_conform_packets.value_namespace = name_space
                                                                    self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-conform-rate"):
                                                                    self.conform_class_conform_rate = value
                                                                    self.conform_class_conform_rate.value_namespace = name_space
                                                                    self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-bytes"):
                                                                    self.conform_class_exceed_bytes = value
                                                                    self.conform_class_exceed_bytes.value_namespace = name_space
                                                                    self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-packets"):
                                                                    self.conform_class_exceed_packets = value
                                                                    self.conform_class_exceed_packets.value_namespace = name_space
                                                                    self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-exceed-rate"):
                                                                    self.conform_class_exceed_rate = value
                                                                    self.conform_class_exceed_rate.value_namespace = name_space
                                                                    self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-bytes"):
                                                                    self.conform_class_violate_bytes = value
                                                                    self.conform_class_violate_bytes.value_namespace = name_space
                                                                    self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-packets"):
                                                                    self.conform_class_violate_packets = value
                                                                    self.conform_class_violate_packets.value_namespace = name_space
                                                                    self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "conform-class-violate-rate"):
                                                                    self.conform_class_violate_rate = value
                                                                    self.conform_class_violate_rate.value_namespace = name_space
                                                                    self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-bytes"):
                                                                    self.exceed_class_exceed_bytes = value
                                                                    self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                    self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-packets"):
                                                                    self.exceed_class_exceed_packets = value
                                                                    self.exceed_class_exceed_packets.value_namespace = name_space
                                                                    self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-exceed-rate"):
                                                                    self.exceed_class_exceed_rate = value
                                                                    self.exceed_class_exceed_rate.value_namespace = name_space
                                                                    self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-bytes"):
                                                                    self.exceed_class_violate_bytes = value
                                                                    self.exceed_class_violate_bytes.value_namespace = name_space
                                                                    self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-packets"):
                                                                    self.exceed_class_violate_packets = value
                                                                    self.exceed_class_violate_packets.value_namespace = name_space
                                                                    self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "exceed-class-violate-rate"):
                                                                    self.exceed_class_violate_rate = value
                                                                    self.exceed_class_violate_rate.value_namespace = name_space
                                                                    self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-bytes"):
                                                                    self.violate_class_violate_bytes = value
                                                                    self.violate_class_violate_bytes.value_namespace = name_space
                                                                    self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-packets"):
                                                                    self.violate_class_violate_packets = value
                                                                    self.violate_class_violate_packets.value_namespace = name_space
                                                                    self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "violate-class-violate-rate"):
                                                                    self.violate_class_violate_rate = value
                                                                    self.violate_class_violate_rate.value_namespace = name_space
                                                                    self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.conform_bytes.is_set or
                                                                self.conform_packets.is_set or
                                                                self.conform_rate.is_set or
                                                                self.drop_bytes.is_set or
                                                                self.drop_packets.is_set or
                                                                self.exceed_bytes.is_set or
                                                                self.exceed_packets.is_set or
                                                                self.exceed_rate.is_set or
                                                                self.parent_drop_bytes.is_set or
                                                                self.parent_drop_packets.is_set or
                                                                self.violate_bytes.is_set or
                                                                self.violate_packets.is_set or
                                                                self.violate_rate.is_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_rate.yfilter != YFilter.not_set or
                                                                self.drop_bytes.yfilter != YFilter.not_set or
                                                                self.drop_packets.yfilter != YFilter.not_set or
                                                                self.exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_rate.yfilter != YFilter.not_set or
                                                                self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                                self.parent_drop_packets.yfilter != YFilter.not_set or
                                                                self.violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_rate.yfilter != YFilter.not_set or
                                                                (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "police-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                            if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                            if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                            if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                            if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                            if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                            if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                            if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                            if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                            if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                            if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                            if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "color-class-stats"):
                                                                if (self.color_class_stats is None):
                                                                    self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                    self.color_class_stats.parent = self
                                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                                return self.color_class_stats

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-bytes"):
                                                                self.conform_bytes = value
                                                                self.conform_bytes.value_namespace = name_space
                                                                self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-packets"):
                                                                self.conform_packets = value
                                                                self.conform_packets.value_namespace = name_space
                                                                self.conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-rate"):
                                                                self.conform_rate = value
                                                                self.conform_rate.value_namespace = name_space
                                                                self.conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-bytes"):
                                                                self.drop_bytes = value
                                                                self.drop_bytes.value_namespace = name_space
                                                                self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "drop-packets"):
                                                                self.drop_packets = value
                                                                self.drop_packets.value_namespace = name_space
                                                                self.drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-bytes"):
                                                                self.exceed_bytes = value
                                                                self.exceed_bytes.value_namespace = name_space
                                                                self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-packets"):
                                                                self.exceed_packets = value
                                                                self.exceed_packets.value_namespace = name_space
                                                                self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-rate"):
                                                                self.exceed_rate = value
                                                                self.exceed_rate.value_namespace = name_space
                                                                self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-bytes"):
                                                                self.parent_drop_bytes = value
                                                                self.parent_drop_bytes.value_namespace = name_space
                                                                self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "parent-drop-packets"):
                                                                self.parent_drop_packets = value
                                                                self.parent_drop_packets.value_namespace = name_space
                                                                self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-bytes"):
                                                                self.violate_bytes = value
                                                                self.violate_bytes.value_namespace = name_space
                                                                self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-packets"):
                                                                self.violate_packets = value
                                                                self.violate_packets.value_namespace = name_space
                                                                self.violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-rate"):
                                                                self.violate_rate = value
                                                                self.violate_rate.value_namespace = name_space
                                                                self.violate_rate.value_namespace_prefix = name_space_prefix


                                                    class WredStatsArray(Entity):
                                                        """
                                                        array of red stats
                                                        
                                                        .. attribute:: max_threshold_bytes
                                                        
                                                        	Dropped bytes with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: max_threshold_packets
                                                        
                                                        	Dropped packets with  the average queue size at the max\-threshold
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: profile_title
                                                        
                                                        	ProfileTitle
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..300
                                                        
                                                        .. attribute:: random_drop_bytes
                                                        
                                                        	Probabilisticallydropped bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: random_drop_packets
                                                        
                                                        	Probabilistically dropped  packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_ecn_marked_bytes
                                                        
                                                        	ECN marked bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_ecn_marked_packets
                                                        
                                                        	ECN marked packets 
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: red_label
                                                        
                                                        	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                        	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                        
                                                        .. attribute:: red_transmit_bytes
                                                        
                                                        	Transmitted bytes
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: red_transmit_packets
                                                        
                                                        	Transmitted packets
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                            self.yang_name = "wred-stats-array"
                                                            self.yang_parent_name = "class-stats"

                                                            self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                            self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                            self.profile_title = YLeaf(YType.str, "profile-title")

                                                            self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                            self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                            self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                            self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                            self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                            self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                            self.red_label = YList(self)

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("max_threshold_bytes",
                                                                            "max_threshold_packets",
                                                                            "profile_title",
                                                                            "random_drop_bytes",
                                                                            "random_drop_packets",
                                                                            "red_ecn_marked_bytes",
                                                                            "red_ecn_marked_packets",
                                                                            "red_transmit_bytes",
                                                                            "red_transmit_packets") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                        class RedLabel(Entity):
                                                            """
                                                            Array of WRED Typevalues as in PRP stats is
                                                            available per threshold   
                                                            
                                                            .. attribute:: value
                                                            
                                                            	WRED value for this type
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: wred_type
                                                            
                                                            	WRED type DSCP, EXP, PREC etc
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'qos-ma-oper'
                                                            _revision = '2017-04-10'

                                                            def __init__(self):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                                self.yang_name = "red-label"
                                                                self.yang_parent_name = "wred-stats-array"

                                                                self.value = YLeaf(YType.uint8, "value")

                                                                self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("value",
                                                                                "wred_type") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.value.is_set or
                                                                    self.wred_type.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set or
                                                                    self.wred_type.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "red-label" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())
                                                                if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "value" or name == "wred-type"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "wred-type"):
                                                                    self.wred_type = value
                                                                    self.wred_type.value_namespace = name_space
                                                                    self.wred_type.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            for c in self.red_label:
                                                                if (c.has_data()):
                                                                    return True
                                                            return (
                                                                self.max_threshold_bytes.is_set or
                                                                self.max_threshold_packets.is_set or
                                                                self.profile_title.is_set or
                                                                self.random_drop_bytes.is_set or
                                                                self.random_drop_packets.is_set or
                                                                self.red_ecn_marked_bytes.is_set or
                                                                self.red_ecn_marked_packets.is_set or
                                                                self.red_transmit_bytes.is_set or
                                                                self.red_transmit_packets.is_set)

                                                        def has_operation(self):
                                                            for c in self.red_label:
                                                                if (c.has_operation()):
                                                                    return True
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                                self.max_threshold_packets.yfilter != YFilter.not_set or
                                                                self.profile_title.yfilter != YFilter.not_set or
                                                                self.random_drop_bytes.yfilter != YFilter.not_set or
                                                                self.random_drop_packets.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                                self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                                self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                                self.red_transmit_packets.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "wred-stats-array" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                            if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                            if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                            if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                            if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                            if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                            if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                            if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                            if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "red-label"):
                                                                for c in self.red_label:
                                                                    segment = c.get_segment_path()
                                                                    if (segment_path == segment):
                                                                        return c
                                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                                c.parent = self
                                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                                self._local_refs[local_reference_key] = c
                                                                self.red_label.append(c)
                                                                return c

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "max-threshold-bytes"):
                                                                self.max_threshold_bytes = value
                                                                self.max_threshold_bytes.value_namespace = name_space
                                                                self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "max-threshold-packets"):
                                                                self.max_threshold_packets = value
                                                                self.max_threshold_packets.value_namespace = name_space
                                                                self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "profile-title"):
                                                                self.profile_title = value
                                                                self.profile_title.value_namespace = name_space
                                                                self.profile_title.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-bytes"):
                                                                self.random_drop_bytes = value
                                                                self.random_drop_bytes.value_namespace = name_space
                                                                self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "random-drop-packets"):
                                                                self.random_drop_packets = value
                                                                self.random_drop_packets.value_namespace = name_space
                                                                self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-bytes"):
                                                                self.red_ecn_marked_bytes = value
                                                                self.red_ecn_marked_bytes.value_namespace = name_space
                                                                self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-ecn-marked-packets"):
                                                                self.red_ecn_marked_packets = value
                                                                self.red_ecn_marked_packets.value_namespace = name_space
                                                                self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-bytes"):
                                                                self.red_transmit_bytes = value
                                                                self.red_transmit_bytes.value_namespace = name_space
                                                                self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "red-transmit-packets"):
                                                                self.red_transmit_packets = value
                                                                self.red_transmit_packets.value_namespace = name_space
                                                                self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.cac_state.is_set or
                                                            self.class_name.is_set or
                                                            self.counter_validity_bitmask.is_set or
                                                            self.queue_descr.is_set or
                                                            self.shared_queue_id.is_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                            (self.general_stats is not None and self.general_stats.has_data()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                    def has_operation(self):
                                                        for c in self.police_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.wred_stats_array:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.cac_state.yfilter != YFilter.not_set or
                                                            self.class_name.yfilter != YFilter.not_set or
                                                            self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                            self.queue_descr.yfilter != YFilter.not_set or
                                                            self.shared_queue_id.yfilter != YFilter.not_set or
                                                            (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                            (self.general_stats is not None and self.general_stats.has_operation()) or
                                                            (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                                        if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                        if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                        if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cac-stats"):
                                                            if (self.cac_stats is None):
                                                                self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                                self.cac_stats.parent = self
                                                                self._children_name_map["cac_stats"] = "cac-stats"
                                                            return self.cac_stats

                                                        if (child_yang_name == "general-stats"):
                                                            if (self.general_stats is None):
                                                                self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                                self.general_stats.parent = self
                                                                self._children_name_map["general_stats"] = "general-stats"
                                                            return self.general_stats

                                                        if (child_yang_name == "iphc-stats"):
                                                            if (self.iphc_stats is None):
                                                                self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                                self.iphc_stats.parent = self
                                                                self._children_name_map["iphc_stats"] = "iphc-stats"
                                                            return self.iphc_stats

                                                        if (child_yang_name == "police-stats-array"):
                                                            for c in self.police_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.police_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-stats-array"):
                                                            for c in self.queue_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_stats_array.append(c)
                                                            return c

                                                        if (child_yang_name == "wred-stats-array"):
                                                            for c in self.wred_stats_array:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.wred_stats_array.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "cac-state"):
                                                            self.cac_state = value
                                                            self.cac_state.value_namespace = name_space
                                                            self.cac_state.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "class-name"):
                                                            self.class_name = value
                                                            self.class_name.value_namespace = name_space
                                                            self.class_name.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "counter-validity-bitmask"):
                                                            self.counter_validity_bitmask = value
                                                            self.counter_validity_bitmask.value_namespace = name_space
                                                            self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-descr"):
                                                            self.queue_descr = value
                                                            self.queue_descr.value_namespace = name_space
                                                            self.queue_descr.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "shared-queue-id"):
                                                            self.shared_queue_id = value
                                                            self.shared_queue_id.value_namespace = name_space
                                                            self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.class_stats:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.policy_name.is_set or
                                                        self.satid.is_set or
                                                        self.state.is_set or
                                                        self.state_description.is_set)

                                                def has_operation(self):
                                                    for c in self.class_stats:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policy_name.yfilter != YFilter.not_set or
                                                        self.satid.yfilter != YFilter.not_set or
                                                        self.state.yfilter != YFilter.not_set or
                                                        self.state_description.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "child-policy" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                    if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.satid.get_name_leafdata())
                                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state.get_name_leafdata())
                                                    if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.state_description.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "class-stats"):
                                                        for c in self.class_stats:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy.ClassStats()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.class_stats.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policy-name"):
                                                        self.policy_name = value
                                                        self.policy_name.value_namespace = name_space
                                                        self.policy_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "satid"):
                                                        self.satid = value
                                                        self.satid.value_namespace = name_space
                                                        self.satid.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state"):
                                                        self.state = value
                                                        self.state.value_namespace = name_space
                                                        self.state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "state-description"):
                                                        self.state_description = value
                                                        self.state_description.value_namespace = name_space
                                                        self.state_description.value_namespace_prefix = name_space_prefix


                                            class CacStats(Entity):
                                                """
                                                bag for cac stats
                                                
                                                .. attribute:: admit_bytes
                                                
                                                	Admitted bytes (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: admit_rates
                                                
                                                	CAC admit rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: admitpackets
                                                
                                                	Admitted packets (pkts/bytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	CAC dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	CAC dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: drop_rates
                                                
                                                	CAC dropped rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.CacStats, self).__init__()

                                                    self.yang_name = "cac-stats"
                                                    self.yang_parent_name = "class-stats"

                                                    self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                    self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                    self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("admit_bytes",
                                                                    "admit_rates",
                                                                    "admitpackets",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "drop_rates") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.CacStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.CacStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.admit_bytes.is_set or
                                                        self.admit_rates.is_set or
                                                        self.admitpackets.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.drop_rates.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.admit_bytes.yfilter != YFilter.not_set or
                                                        self.admit_rates.yfilter != YFilter.not_set or
                                                        self.admitpackets.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.drop_rates.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cac-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                    if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                    if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "admit-bytes"):
                                                        self.admit_bytes = value
                                                        self.admit_bytes.value_namespace = name_space
                                                        self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admit-rates"):
                                                        self.admit_rates = value
                                                        self.admit_rates.value_namespace = name_space
                                                        self.admit_rates.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "admitpackets"):
                                                        self.admitpackets = value
                                                        self.admitpackets.value_namespace = name_space
                                                        self.admitpackets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-rates"):
                                                        self.drop_rates = value
                                                        self.drop_rates.value_namespace = name_space
                                                        self.drop_rates.value_namespace_prefix = name_space_prefix


                                            class QueueStatsArray(Entity):
                                                """
                                                array of queue stats
                                                
                                                .. attribute:: atm_clp0_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp0_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: atm_clp1_drop_bytes
                                                
                                                	ATP CLP 0 matched bytes dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: atm_clp1_drop_packets
                                                
                                                	ATP CLP 0 matched packets dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the queue rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: forced_wred_stats_display
                                                
                                                	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                	**type**\:  bool
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: queue_average_length
                                                
                                                	Queue average length
                                                	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                
                                                .. attribute:: queue_drop_threshold
                                                
                                                	tail drop threshold of the queue in bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue Id used for Fabric Stats
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_instance_length
                                                
                                                	Queue instance length
                                                	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                
                                                .. attribute:: queue_max_length
                                                
                                                	Queue maximum length
                                                	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Bytes probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Packets probabilistically dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: tail_drop_bytes
                                                
                                                	Bytes tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: tail_drop_packets
                                                
                                                	Packets tail dropped
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray, self).__init__()

                                                    self.yang_name = "queue-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                    self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                    self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                    self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                    self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                    self.queue_average_length = YList(self)
                                                    self.queue_instance_length = YList(self)
                                                    self.queue_max_length = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("atm_clp0_drop_bytes",
                                                                    "atm_clp0_drop_packets",
                                                                    "atm_clp1_drop_bytes",
                                                                    "atm_clp1_drop_packets",
                                                                    "conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "forced_wred_stats_display",
                                                                    "max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "queue_drop_threshold",
                                                                    "queue_id",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "tail_drop_bytes",
                                                                    "tail_drop_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                class QueueInstanceLength(Entity):
                                                    """
                                                    Queue instance length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                        self.yang_name = "queue-instance-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-instance-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueAverageLength(Entity):
                                                    """
                                                    Queue average length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                        self.yang_name = "queue-average-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-average-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class QueueMaxLength(Entity):
                                                    """
                                                    Queue maximum length
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	unit
                                                    	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                        self.yang_name = "queue-max-length"
                                                        self.yang_parent_name = "queue-stats-array"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-max-length" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.atm_clp0_drop_bytes.is_set or
                                                        self.atm_clp0_drop_packets.is_set or
                                                        self.atm_clp1_drop_bytes.is_set or
                                                        self.atm_clp1_drop_packets.is_set or
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.forced_wred_stats_display.is_set or
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.queue_drop_threshold.is_set or
                                                        self.queue_id.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.tail_drop_bytes.is_set or
                                                        self.tail_drop_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.queue_average_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_instance_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_max_length:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                        self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                        self.tail_drop_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                    if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                    if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                    if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "queue-average-length"):
                                                        for c in self.queue_average_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueAverageLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_average_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-instance-length"):
                                                        for c in self.queue_instance_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_instance_length.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-max-length"):
                                                        for c in self.queue_max_length:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray.QueueMaxLength()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_max_length.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "atm-clp0-drop-bytes"):
                                                        self.atm_clp0_drop_bytes = value
                                                        self.atm_clp0_drop_bytes.value_namespace = name_space
                                                        self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp0-drop-packets"):
                                                        self.atm_clp0_drop_packets = value
                                                        self.atm_clp0_drop_packets.value_namespace = name_space
                                                        self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-bytes"):
                                                        self.atm_clp1_drop_bytes = value
                                                        self.atm_clp1_drop_bytes.value_namespace = name_space
                                                        self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "atm-clp1-drop-packets"):
                                                        self.atm_clp1_drop_packets = value
                                                        self.atm_clp1_drop_packets.value_namespace = name_space
                                                        self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forced-wred-stats-display"):
                                                        self.forced_wred_stats_display = value
                                                        self.forced_wred_stats_display.value_namespace = name_space
                                                        self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-drop-threshold"):
                                                        self.queue_drop_threshold = value
                                                        self.queue_drop_threshold.value_namespace = name_space
                                                        self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-bytes"):
                                                        self.tail_drop_bytes = value
                                                        self.tail_drop_bytes.value_namespace = name_space
                                                        self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "tail-drop-packets"):
                                                        self.tail_drop_packets = value
                                                        self.tail_drop_packets.value_namespace = name_space
                                                        self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                            class PoliceStatsArray(Entity):
                                                """
                                                array of police stats
                                                
                                                .. attribute:: color_class_stats
                                                
                                                	color class stats
                                                	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                
                                                .. attribute:: conform_bytes
                                                
                                                	Bytes that conform to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_packets
                                                
                                                	Packets that conform  to the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_rate
                                                
                                                	Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: drop_bytes
                                                
                                                	Police dropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: drop_packets
                                                
                                                	Police dropped packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_bytes
                                                
                                                	Bytes that exceed  the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_packets
                                                
                                                	Packets that exceed the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_rate
                                                
                                                	Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: parent_drop_bytes
                                                
                                                	Dropped bytes by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: parent_drop_packets
                                                
                                                	Dropped pkts by the parent policer
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_bytes
                                                
                                                	Bytes that violate the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_packets
                                                
                                                	Packets violating the policed rate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_rate
                                                
                                                	Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray, self).__init__()

                                                    self.yang_name = "police-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                    self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                    self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                    self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                    self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                    self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                    self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                    self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                    self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                    self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                    self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                    self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                    self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                    self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats()
                                                    self.color_class_stats.parent = self
                                                    self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    self._children_yang_names.add("color-class-stats")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_bytes",
                                                                    "conform_packets",
                                                                    "conform_rate",
                                                                    "drop_bytes",
                                                                    "drop_packets",
                                                                    "exceed_bytes",
                                                                    "exceed_packets",
                                                                    "exceed_rate",
                                                                    "parent_drop_bytes",
                                                                    "parent_drop_packets",
                                                                    "violate_bytes",
                                                                    "violate_packets",
                                                                    "violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                class ColorClassStats(Entity):
                                                    """
                                                    color class stats
                                                    
                                                    .. attribute:: conform_class_conform_bytes
                                                    
                                                    	Bytes with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_conform_packets
                                                    
                                                    	Packets with classification result conform and policer result conform
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_conform_rate
                                                    
                                                    	Conform Class Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_exceed_bytes
                                                    
                                                    	Bytes with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_exceed_packets
                                                    
                                                    	Packets with classification result conform and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_exceed_rate
                                                    
                                                    	Conform Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: conform_class_violate_bytes
                                                    
                                                    	Bytes with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_class_violate_packets
                                                    
                                                    	Packets with classification result conform and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_class_violate_rate
                                                    
                                                    	Conform Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_exceed_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_exceed_packets
                                                    
                                                    	Packets with classification result exceed and policer result exceed
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_exceed_rate
                                                    
                                                    	Exceed Class Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: exceed_class_violate_bytes
                                                    
                                                    	Bytes with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_class_violate_packets
                                                    
                                                    	Packets with classification result exceed and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_class_violate_rate
                                                    
                                                    	Exceed Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: violate_class_violate_bytes
                                                    
                                                    	Bytes with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_class_violate_packets
                                                    
                                                    	Packets with classification result violate and policer result violate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_class_violate_rate
                                                    
                                                    	Violate Class Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                        self.yang_name = "color-class-stats"
                                                        self.yang_parent_name = "police-stats-array"

                                                        self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                        self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                        self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                        self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                        self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                        self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                        self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                        self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                        self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                        self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                        self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                        self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                        self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                        self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                        self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                        self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                        self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                        self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_class_conform_bytes",
                                                                        "conform_class_conform_packets",
                                                                        "conform_class_conform_rate",
                                                                        "conform_class_exceed_bytes",
                                                                        "conform_class_exceed_packets",
                                                                        "conform_class_exceed_rate",
                                                                        "conform_class_violate_bytes",
                                                                        "conform_class_violate_packets",
                                                                        "conform_class_violate_rate",
                                                                        "exceed_class_exceed_bytes",
                                                                        "exceed_class_exceed_packets",
                                                                        "exceed_class_exceed_rate",
                                                                        "exceed_class_violate_bytes",
                                                                        "exceed_class_violate_packets",
                                                                        "exceed_class_violate_rate",
                                                                        "violate_class_violate_bytes",
                                                                        "violate_class_violate_packets",
                                                                        "violate_class_violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.conform_class_conform_bytes.is_set or
                                                            self.conform_class_conform_packets.is_set or
                                                            self.conform_class_conform_rate.is_set or
                                                            self.conform_class_exceed_bytes.is_set or
                                                            self.conform_class_exceed_packets.is_set or
                                                            self.conform_class_exceed_rate.is_set or
                                                            self.conform_class_violate_bytes.is_set or
                                                            self.conform_class_violate_packets.is_set or
                                                            self.conform_class_violate_rate.is_set or
                                                            self.exceed_class_exceed_bytes.is_set or
                                                            self.exceed_class_exceed_packets.is_set or
                                                            self.exceed_class_exceed_rate.is_set or
                                                            self.exceed_class_violate_bytes.is_set or
                                                            self.exceed_class_violate_packets.is_set or
                                                            self.exceed_class_violate_rate.is_set or
                                                            self.violate_class_violate_bytes.is_set or
                                                            self.violate_class_violate_packets.is_set or
                                                            self.violate_class_violate_rate.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "color-class-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                        if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                        if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                        if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                        if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                        if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                        if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                        if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                        if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                        if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                        if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                        if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                        if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                        if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                        if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                        if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                        if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-class-conform-bytes"):
                                                            self.conform_class_conform_bytes = value
                                                            self.conform_class_conform_bytes.value_namespace = name_space
                                                            self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-packets"):
                                                            self.conform_class_conform_packets = value
                                                            self.conform_class_conform_packets.value_namespace = name_space
                                                            self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-conform-rate"):
                                                            self.conform_class_conform_rate = value
                                                            self.conform_class_conform_rate.value_namespace = name_space
                                                            self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-bytes"):
                                                            self.conform_class_exceed_bytes = value
                                                            self.conform_class_exceed_bytes.value_namespace = name_space
                                                            self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-packets"):
                                                            self.conform_class_exceed_packets = value
                                                            self.conform_class_exceed_packets.value_namespace = name_space
                                                            self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-exceed-rate"):
                                                            self.conform_class_exceed_rate = value
                                                            self.conform_class_exceed_rate.value_namespace = name_space
                                                            self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-bytes"):
                                                            self.conform_class_violate_bytes = value
                                                            self.conform_class_violate_bytes.value_namespace = name_space
                                                            self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-packets"):
                                                            self.conform_class_violate_packets = value
                                                            self.conform_class_violate_packets.value_namespace = name_space
                                                            self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-class-violate-rate"):
                                                            self.conform_class_violate_rate = value
                                                            self.conform_class_violate_rate.value_namespace = name_space
                                                            self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-bytes"):
                                                            self.exceed_class_exceed_bytes = value
                                                            self.exceed_class_exceed_bytes.value_namespace = name_space
                                                            self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-packets"):
                                                            self.exceed_class_exceed_packets = value
                                                            self.exceed_class_exceed_packets.value_namespace = name_space
                                                            self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-exceed-rate"):
                                                            self.exceed_class_exceed_rate = value
                                                            self.exceed_class_exceed_rate.value_namespace = name_space
                                                            self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-bytes"):
                                                            self.exceed_class_violate_bytes = value
                                                            self.exceed_class_violate_bytes.value_namespace = name_space
                                                            self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-packets"):
                                                            self.exceed_class_violate_packets = value
                                                            self.exceed_class_violate_packets.value_namespace = name_space
                                                            self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-class-violate-rate"):
                                                            self.exceed_class_violate_rate = value
                                                            self.exceed_class_violate_rate.value_namespace = name_space
                                                            self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-bytes"):
                                                            self.violate_class_violate_bytes = value
                                                            self.violate_class_violate_bytes.value_namespace = name_space
                                                            self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-packets"):
                                                            self.violate_class_violate_packets = value
                                                            self.violate_class_violate_packets.value_namespace = name_space
                                                            self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-class-violate-rate"):
                                                            self.violate_class_violate_rate = value
                                                            self.violate_class_violate_rate.value_namespace = name_space
                                                            self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.conform_bytes.is_set or
                                                        self.conform_packets.is_set or
                                                        self.conform_rate.is_set or
                                                        self.drop_bytes.is_set or
                                                        self.drop_packets.is_set or
                                                        self.exceed_bytes.is_set or
                                                        self.exceed_packets.is_set or
                                                        self.exceed_rate.is_set or
                                                        self.parent_drop_bytes.is_set or
                                                        self.parent_drop_packets.is_set or
                                                        self.violate_bytes.is_set or
                                                        self.violate_packets.is_set or
                                                        self.violate_rate.is_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_rate.yfilter != YFilter.not_set or
                                                        self.drop_bytes.yfilter != YFilter.not_set or
                                                        self.drop_packets.yfilter != YFilter.not_set or
                                                        self.exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_rate.yfilter != YFilter.not_set or
                                                        self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                        self.parent_drop_packets.yfilter != YFilter.not_set or
                                                        self.violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_rate.yfilter != YFilter.not_set or
                                                        (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                    if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                    if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                    if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                    if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                    if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                    if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                    if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                    if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                    if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                    if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                    if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "color-class-stats"):
                                                        if (self.color_class_stats is None):
                                                            self.color_class_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray.ColorClassStats()
                                                            self.color_class_stats.parent = self
                                                            self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        return self.color_class_stats

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-bytes"):
                                                        self.conform_bytes = value
                                                        self.conform_bytes.value_namespace = name_space
                                                        self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-packets"):
                                                        self.conform_packets = value
                                                        self.conform_packets.value_namespace = name_space
                                                        self.conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-rate"):
                                                        self.conform_rate = value
                                                        self.conform_rate.value_namespace = name_space
                                                        self.conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-bytes"):
                                                        self.drop_bytes = value
                                                        self.drop_bytes.value_namespace = name_space
                                                        self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "drop-packets"):
                                                        self.drop_packets = value
                                                        self.drop_packets.value_namespace = name_space
                                                        self.drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-bytes"):
                                                        self.exceed_bytes = value
                                                        self.exceed_bytes.value_namespace = name_space
                                                        self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-packets"):
                                                        self.exceed_packets = value
                                                        self.exceed_packets.value_namespace = name_space
                                                        self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-rate"):
                                                        self.exceed_rate = value
                                                        self.exceed_rate.value_namespace = name_space
                                                        self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-bytes"):
                                                        self.parent_drop_bytes = value
                                                        self.parent_drop_bytes.value_namespace = name_space
                                                        self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "parent-drop-packets"):
                                                        self.parent_drop_packets = value
                                                        self.parent_drop_packets.value_namespace = name_space
                                                        self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-bytes"):
                                                        self.violate_bytes = value
                                                        self.violate_bytes.value_namespace = name_space
                                                        self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-packets"):
                                                        self.violate_packets = value
                                                        self.violate_packets.value_namespace = name_space
                                                        self.violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-rate"):
                                                        self.violate_rate = value
                                                        self.violate_rate.value_namespace = name_space
                                                        self.violate_rate.value_namespace_prefix = name_space_prefix


                                            class WredStatsArray(Entity):
                                                """
                                                array of red stats
                                                
                                                .. attribute:: max_threshold_bytes
                                                
                                                	Dropped bytes with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: max_threshold_packets
                                                
                                                	Dropped packets with  the average queue size at the max\-threshold
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: profile_title
                                                
                                                	ProfileTitle
                                                	**type**\:  str
                                                
                                                	**length:** 0..300
                                                
                                                .. attribute:: random_drop_bytes
                                                
                                                	Probabilisticallydropped bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: random_drop_packets
                                                
                                                	Probabilistically dropped  packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_ecn_marked_bytes
                                                
                                                	ECN marked bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_ecn_marked_packets
                                                
                                                	ECN marked packets 
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: red_label
                                                
                                                	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray.RedLabel>`
                                                
                                                .. attribute:: red_transmit_bytes
                                                
                                                	Transmitted bytes
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: red_transmit_packets
                                                
                                                	Transmitted packets
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray, self).__init__()

                                                    self.yang_name = "wred-stats-array"
                                                    self.yang_parent_name = "class-stats"

                                                    self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                    self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                    self.profile_title = YLeaf(YType.str, "profile-title")

                                                    self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                    self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                    self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                    self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                    self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                    self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                    self.red_label = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("max_threshold_bytes",
                                                                    "max_threshold_packets",
                                                                    "profile_title",
                                                                    "random_drop_bytes",
                                                                    "random_drop_packets",
                                                                    "red_ecn_marked_bytes",
                                                                    "red_ecn_marked_packets",
                                                                    "red_transmit_bytes",
                                                                    "red_transmit_packets") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                class RedLabel(Entity):
                                                    """
                                                    Array of WRED Typevalues as in PRP stats is
                                                    available per threshold   
                                                    
                                                    .. attribute:: value
                                                    
                                                    	WRED value for this type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: wred_type
                                                    
                                                    	WRED type DSCP, EXP, PREC etc
                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                        self.yang_name = "red-label"
                                                        self.yang_parent_name = "wred-stats-array"

                                                        self.value = YLeaf(YType.uint8, "value")

                                                        self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("value",
                                                                        "wred_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.value.is_set or
                                                            self.wred_type.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set or
                                                            self.wred_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "red-label" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())
                                                        if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "value" or name == "wred-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "wred-type"):
                                                            self.wred_type = value
                                                            self.wred_type.value_namespace = name_space
                                                            self.wred_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.red_label:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.max_threshold_bytes.is_set or
                                                        self.max_threshold_packets.is_set or
                                                        self.profile_title.is_set or
                                                        self.random_drop_bytes.is_set or
                                                        self.random_drop_packets.is_set or
                                                        self.red_ecn_marked_bytes.is_set or
                                                        self.red_ecn_marked_packets.is_set or
                                                        self.red_transmit_bytes.is_set or
                                                        self.red_transmit_packets.is_set)

                                                def has_operation(self):
                                                    for c in self.red_label:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                        self.max_threshold_packets.yfilter != YFilter.not_set or
                                                        self.profile_title.yfilter != YFilter.not_set or
                                                        self.random_drop_bytes.yfilter != YFilter.not_set or
                                                        self.random_drop_packets.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                        self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                        self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                        self.red_transmit_packets.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred-stats-array" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                    if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                    if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                    if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                    if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                    if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                    if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                    if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                    if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "red-label"):
                                                        for c in self.red_label:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray.RedLabel()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.red_label.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "max-threshold-bytes"):
                                                        self.max_threshold_bytes = value
                                                        self.max_threshold_bytes.value_namespace = name_space
                                                        self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "max-threshold-packets"):
                                                        self.max_threshold_packets = value
                                                        self.max_threshold_packets.value_namespace = name_space
                                                        self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-title"):
                                                        self.profile_title = value
                                                        self.profile_title.value_namespace = name_space
                                                        self.profile_title.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-bytes"):
                                                        self.random_drop_bytes = value
                                                        self.random_drop_bytes.value_namespace = name_space
                                                        self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "random-drop-packets"):
                                                        self.random_drop_packets = value
                                                        self.random_drop_packets.value_namespace = name_space
                                                        self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-bytes"):
                                                        self.red_ecn_marked_bytes = value
                                                        self.red_ecn_marked_bytes.value_namespace = name_space
                                                        self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-ecn-marked-packets"):
                                                        self.red_ecn_marked_packets = value
                                                        self.red_ecn_marked_packets.value_namespace = name_space
                                                        self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-bytes"):
                                                        self.red_transmit_bytes = value
                                                        self.red_transmit_bytes.value_namespace = name_space
                                                        self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "red-transmit-packets"):
                                                        self.red_transmit_packets = value
                                                        self.red_transmit_packets.value_namespace = name_space
                                                        self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.cac_state.is_set or
                                                    self.class_name.is_set or
                                                    self.counter_validity_bitmask.is_set or
                                                    self.queue_descr.is_set or
                                                    self.shared_queue_id.is_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                    (self.child_policy is not None and self.child_policy.has_data()) or
                                                    (self.general_stats is not None and self.general_stats.has_data()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                            def has_operation(self):
                                                for c in self.police_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.wred_stats_array:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.cac_state.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                    self.queue_descr.yfilter != YFilter.not_set or
                                                    self.shared_queue_id.yfilter != YFilter.not_set or
                                                    (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                    (self.child_policy is not None and self.child_policy.has_operation()) or
                                                    (self.general_stats is not None and self.general_stats.has_operation()) or
                                                    (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "class-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cac-stats"):
                                                    if (self.cac_stats is None):
                                                        self.cac_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.CacStats()
                                                        self.cac_stats.parent = self
                                                        self._children_name_map["cac_stats"] = "cac-stats"
                                                    return self.cac_stats

                                                if (child_yang_name == "child-policy"):
                                                    if (self.child_policy is None):
                                                        self.child_policy = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.ChildPolicy()
                                                        self.child_policy.parent = self
                                                        self._children_name_map["child_policy"] = "child-policy"
                                                    return self.child_policy

                                                if (child_yang_name == "general-stats"):
                                                    if (self.general_stats is None):
                                                        self.general_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.GeneralStats()
                                                        self.general_stats.parent = self
                                                        self._children_name_map["general_stats"] = "general-stats"
                                                    return self.general_stats

                                                if (child_yang_name == "iphc-stats"):
                                                    if (self.iphc_stats is None):
                                                        self.iphc_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.IphcStats()
                                                        self.iphc_stats.parent = self
                                                        self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    return self.iphc_stats

                                                if (child_yang_name == "police-stats-array"):
                                                    for c in self.police_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.PoliceStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.police_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "queue-stats-array"):
                                                    for c in self.queue_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.QueueStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_stats_array.append(c)
                                                    return c

                                                if (child_yang_name == "wred-stats-array"):
                                                    for c in self.wred_stats_array:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats.WredStatsArray()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.wred_stats_array.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "cac-state"):
                                                    self.cac_state = value
                                                    self.cac_state.value_namespace = name_space
                                                    self.cac_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "counter-validity-bitmask"):
                                                    self.counter_validity_bitmask = value
                                                    self.counter_validity_bitmask.value_namespace = name_space
                                                    self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-descr"):
                                                    self.queue_descr = value
                                                    self.queue_descr.value_namespace = name_space
                                                    self.queue_descr.value_namespace_prefix = name_space_prefix
                                                if(value_path == "shared-queue-id"):
                                                    self.shared_queue_id = value
                                                    self.shared_queue_id.value_namespace = name_space
                                                    self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.class_stats:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.policy_name.is_set or
                                                self.satid.is_set or
                                                self.state.is_set or
                                                self.state_description.is_set)

                                        def has_operation(self):
                                            for c in self.class_stats:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                self.satid.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.state_description.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vo-q-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())
                                            if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.satid.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state_description.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "class-stats"):
                                                for c in self.class_stats:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats.ClassStats()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.class_stats.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "satid"):
                                                self.satid = value
                                                self.satid.value_namespace = name_space
                                                self.satid.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state-description"):
                                                self.state_description = value
                                                self.state_description.value_namespace = name_space
                                                self.state_description.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.vo_q_stats is not None and self.vo_q_stats.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.vo_q_stats is not None and self.vo_q_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vo-qoutput" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "vo-q-stats"):
                                            if (self.vo_q_stats is None):
                                                self.vo_q_stats = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput.VoQStats()
                                                self.vo_q_stats.parent = self
                                                self._children_name_map["vo_q_stats"] = "vo-q-stats"
                                            return self.vo_q_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "vo-q-stats"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.interface_name.is_set or
                                        (self.vo_qoutput is not None and self.vo_qoutput.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        (self.vo_qoutput is not None and self.vo_qoutput.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vo-q-member-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "vo-qoutput"):
                                        if (self.vo_qoutput is None):
                                            self.vo_qoutput = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface.VoQoutput()
                                            self.vo_qoutput.parent = self
                                            self._children_name_map["vo_qoutput"] = "vo-qoutput"
                                        return self.vo_qoutput

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "vo-qoutput" or name == "interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.vo_q_member_interface:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.vo_q_member_interface:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vo-q-member-interfaces" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "vo-q-member-interface"):
                                    for c in self.vo_q_member_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces.VoQMemberInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.vo_q_member_interface.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "vo-q-member-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.interface_name.is_set or
                                (self.output_vo_q is not None and self.output_vo_q.has_data()) or
                                (self.vo_q_member_interfaces is not None and self.vo_q_member_interfaces.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                (self.output_vo_q is not None and self.output_vo_q.has_operation()) or
                                (self.vo_q_member_interfaces is not None and self.vo_q_member_interfaces.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vo-qinterface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/qos-global/vo-q/vo-q-statistics/vo-qinterfaces/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "output-vo-q"):
                                if (self.output_vo_q is None):
                                    self.output_vo_q = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.OutputVoQ()
                                    self.output_vo_q.parent = self
                                    self._children_name_map["output_vo_q"] = "output-vo-q"
                                return self.output_vo_q

                            if (child_yang_name == "vo-q-member-interfaces"):
                                if (self.vo_q_member_interfaces is None):
                                    self.vo_q_member_interfaces = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface.VoQMemberInterfaces()
                                    self.vo_q_member_interfaces.parent = self
                                    self._children_name_map["vo_q_member_interfaces"] = "vo-q-member-interfaces"
                                return self.vo_q_member_interfaces

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "output-vo-q" or name == "vo-q-member-interfaces" or name == "interface-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.vo_qinterface:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.vo_qinterface:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vo-qinterfaces" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/qos-global/vo-q/vo-q-statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "vo-qinterface"):
                            for c in self.vo_qinterface:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces.VoQinterface()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.vo_qinterface.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "vo-qinterface"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (self.vo_qinterfaces is not None and self.vo_qinterfaces.has_data())

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.vo_qinterfaces is not None and self.vo_qinterfaces.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "vo-q-statistics" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/qos-global/vo-q/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "vo-qinterfaces"):
                        if (self.vo_qinterfaces is None):
                            self.vo_qinterfaces = Qos.QosGlobal.VoQ.VoQStatistics.VoQinterfaces()
                            self.vo_qinterfaces.parent = self
                            self._children_name_map["vo_qinterfaces"] = "vo-qinterfaces"
                        return self.vo_qinterfaces

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "vo-qinterfaces"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (self.vo_q_statistics is not None and self.vo_q_statistics.has_data())

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.vo_q_statistics is not None and self.vo_q_statistics.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "vo-q" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/qos-global/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "vo-q-statistics"):
                    if (self.vo_q_statistics is None):
                        self.vo_q_statistics = Qos.QosGlobal.VoQ.VoQStatistics()
                        self.vo_q_statistics.parent = self
                        self._children_name_map["vo_q_statistics"] = "vo-q-statistics"
                    return self.vo_q_statistics

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "vo-q-statistics"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (self.vo_q is not None and self.vo_q.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.vo_q is not None and self.vo_q.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "qos-global" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "vo-q"):
                if (self.vo_q is None):
                    self.vo_q = Qos.QosGlobal.VoQ()
                    self.vo_q.parent = self
                    self._children_name_map["vo_q"] = "vo-q"
                return self.vo_q

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "vo-q"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class InterfaceTable(Entity):
        """
        Operational data for all interfaces
        
        .. attribute:: interface
        
        	QoS policy\-map operational data for a particular interface
        	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface>`
        
        

        """

        _prefix = 'qos-ma-oper'
        _revision = '2017-04-10'

        def __init__(self):
            super(Qos.InterfaceTable, self).__init__()

            self.yang_name = "interface-table"
            self.yang_parent_name = "qos"

            self.interface = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(Qos.InterfaceTable, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(Qos.InterfaceTable, self).__setattr__(name, value)


        class Interface(Entity):
            """
            QoS policy\-map operational data for a particular
            interface
            
            .. attribute:: interface_name  <key>
            
            	Name of the interface
            	**type**\:  str
            
            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
            
            .. attribute:: input
            
            	A piece of QoS policy\-map operational data for an interface
            	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input>`
            
            .. attribute:: member_interfaces
            
            	QoS policy\-map member interface table
            	**type**\:   :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces>`
            
            .. attribute:: nodes
            
            	QoS policy\-map node table
            	**type**\:   :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes>`
            
            .. attribute:: output
            
            	A piece of QoS policy\-map operational data for an interface
            	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output>`
            
            .. attribute:: satellite_ids
            
            	Satellite ID information
            	**type**\:   :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds>`
            
            

            """

            _prefix = 'qos-ma-oper'
            _revision = '2017-04-10'

            def __init__(self):
                super(Qos.InterfaceTable.Interface, self).__init__()

                self.yang_name = "interface"
                self.yang_parent_name = "interface-table"

                self.interface_name = YLeaf(YType.str, "interface-name")

                self.input = Qos.InterfaceTable.Interface.Input()
                self.input.parent = self
                self._children_name_map["input"] = "input"
                self._children_yang_names.add("input")

                self.member_interfaces = Qos.InterfaceTable.Interface.MemberInterfaces()
                self.member_interfaces.parent = self
                self._children_name_map["member_interfaces"] = "member-interfaces"
                self._children_yang_names.add("member-interfaces")

                self.nodes = Qos.InterfaceTable.Interface.Nodes()
                self.nodes.parent = self
                self._children_name_map["nodes"] = "nodes"
                self._children_yang_names.add("nodes")

                self.output = Qos.InterfaceTable.Interface.Output()
                self.output.parent = self
                self._children_name_map["output"] = "output"
                self._children_yang_names.add("output")

                self.satellite_ids = Qos.InterfaceTable.Interface.SatelliteIds()
                self.satellite_ids.parent = self
                self._children_name_map["satellite_ids"] = "satellite-ids"
                self._children_yang_names.add("satellite-ids")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("interface_name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(Qos.InterfaceTable.Interface, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(Qos.InterfaceTable.Interface, self).__setattr__(name, value)


            class Nodes(Entity):
                """
                QoS policy\-map node table
                
                .. attribute:: node
                
                	QoS operational data for a particular node
                	**type**\: list of    :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.InterfaceTable.Interface.Nodes, self).__init__()

                    self.yang_name = "nodes"
                    self.yang_parent_name = "interface"

                    self.node = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Qos.InterfaceTable.Interface.Nodes, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Qos.InterfaceTable.Interface.Nodes, self).__setattr__(name, value)


                class Node(Entity):
                    """
                    QoS operational data for a particular node
                    
                    .. attribute:: node_name  <key>
                    
                    	The node
                    	**type**\:  str
                    
                    	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
                    
                    .. attribute:: input
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input>`
                    
                    .. attribute:: output
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.InterfaceTable.Interface.Nodes.Node, self).__init__()

                        self.yang_name = "node"
                        self.yang_parent_name = "nodes"

                        self.node_name = YLeaf(YType.str, "node-name")

                        self.input = Qos.InterfaceTable.Interface.Nodes.Node.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"
                        self._children_yang_names.add("input")

                        self.output = Qos.InterfaceTable.Interface.Nodes.Node.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._children_yang_names.add("output")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("node_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.InterfaceTable.Interface.Nodes.Node, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.InterfaceTable.Interface.Nodes.Node, self).__setattr__(name, value)


                    class Input(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames>`
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "node"

                            self.service_policy_names = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._children_yang_names.add("service-policy-names")

                            self.statistics = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "input"

                                self.service_policy_instance = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames, self).__setattr__(name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  <key>
                                
                                	Name of the policy instance
                                	**type**\:  str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"

                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("service_policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.service_policy_name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.service_policy_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "service-policy-name"):
                                        self.service_policy_name = value
                                        self.service_policy_name.value_namespace = name_space
                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.service_policy_instance:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.service_policy_instance:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "service-policy-names" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-instance"):
                                    for c in self.service_policy_instance:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames.ServicePolicyInstance()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.service_policy_instance.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-instance"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "input"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.child_policy = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                    self._children_yang_names.add("child-policy")

                                    self.general_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.general_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "child-policy" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "child-policy"):
                                        if (self.child_policy is None):
                                            self.child_policy = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                        return self.child_policy

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "input" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "service-policy-names"):
                                if (self.service_policy_names is None):
                                    self.service_policy_names = Qos.InterfaceTable.Interface.Nodes.Node.Input.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                return self.service_policy_names

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = Qos.InterfaceTable.Interface.Nodes.Node.Input.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-names" or name == "statistics"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Output(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames>`
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "node"

                            self.service_policy_names = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._children_yang_names.add("service-policy-names")

                            self.statistics = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "output"

                                self.service_policy_instance = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames, self).__setattr__(name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  <key>
                                
                                	Name of the policy instance
                                	**type**\:  str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"

                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("service_policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.service_policy_name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.service_policy_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "service-policy-name"):
                                        self.service_policy_name = value
                                        self.service_policy_name.value_namespace = name_space
                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.service_policy_instance:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.service_policy_instance:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "service-policy-names" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-instance"):
                                    for c in self.service_policy_instance:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames.ServicePolicyInstance()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.service_policy_instance.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-instance"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "output"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.child_policy = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                    self._children_yang_names.add("child-policy")

                                    self.general_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.general_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "child-policy" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "child-policy"):
                                        if (self.child_policy is None):
                                            self.child_policy = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                        return self.child_policy

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "output" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "service-policy-names"):
                                if (self.service_policy_names is None):
                                    self.service_policy_names = Qos.InterfaceTable.Interface.Nodes.Node.Output.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                return self.service_policy_names

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = Qos.InterfaceTable.Interface.Nodes.Node.Output.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-names" or name == "statistics"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.node_name.is_set or
                            (self.input is not None and self.input.has_data()) or
                            (self.output is not None and self.output.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.node_name.yfilter != YFilter.not_set or
                            (self.input is not None and self.input.has_operation()) or
                            (self.output is not None and self.output.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "node" + "[node-name='" + self.node_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.node_name.is_set or self.node_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.node_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "input"):
                            if (self.input is None):
                                self.input = Qos.InterfaceTable.Interface.Nodes.Node.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"
                            return self.input

                        if (child_yang_name == "output"):
                            if (self.output is None):
                                self.output = Qos.InterfaceTable.Interface.Nodes.Node.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                            return self.output

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "input" or name == "output" or name == "node-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "node-name"):
                            self.node_name = value
                            self.node_name.value_namespace = name_space
                            self.node_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.node:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.node:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "nodes" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "node"):
                        for c in self.node:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Qos.InterfaceTable.Interface.Nodes.Node()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.node.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "node"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class MemberInterfaces(Entity):
                """
                QoS policy\-map member interface table
                
                .. attribute:: member_interface
                
                	QoS policy\-map member interface statistics
                	**type**\: list of    :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.InterfaceTable.Interface.MemberInterfaces, self).__init__()

                    self.yang_name = "member-interfaces"
                    self.yang_parent_name = "interface"

                    self.member_interface = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Qos.InterfaceTable.Interface.MemberInterfaces, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Qos.InterfaceTable.Interface.MemberInterfaces, self).__setattr__(name, value)


                class MemberInterface(Entity):
                    """
                    QoS policy\-map member interface statistics
                    
                    .. attribute:: interface_name  <key>
                    
                    	Name of member interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: input
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input>`
                    
                    .. attribute:: output
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output>`
                    
                    .. attribute:: satellite_ids
                    
                    	Satellite ID information
                    	**type**\:   :py:class:`SatelliteIds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface, self).__init__()

                        self.yang_name = "member-interface"
                        self.yang_parent_name = "member-interfaces"

                        self.interface_name = YLeaf(YType.str, "interface-name")

                        self.input = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"
                        self._children_yang_names.add("input")

                        self.output = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._children_yang_names.add("output")

                        self.satellite_ids = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds()
                        self.satellite_ids.parent = self
                        self._children_name_map["satellite_ids"] = "satellite-ids"
                        self._children_yang_names.add("satellite-ids")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("interface_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface, self).__setattr__(name, value)


                    class SatelliteIds(Entity):
                        """
                        Satellite ID information
                        
                        .. attribute:: satellite_id
                        
                        	Satellite ID information
                        	**type**\: list of    :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, self).__init__()

                            self.yang_name = "satellite-ids"
                            self.yang_parent_name = "member-interface"

                            self.satellite_id = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds, self).__setattr__(name, value)


                        class SatelliteId(Entity):
                            """
                            Satellite ID information
                            
                            .. attribute:: nv_satellite_id  <key>
                            
                            	Satellite ID
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: input
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input>`
                            
                            .. attribute:: output
                            
                            	A piece of QoS policy\-map operational data for an interface
                            	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__init__()

                                self.yang_name = "satellite-id"
                                self.yang_parent_name = "satellite-ids"

                                self.nv_satellite_id = YLeaf(YType.int32, "nv-satellite-id")

                                self.input = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"
                                self._children_yang_names.add("input")

                                self.output = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                                self._children_yang_names.add("output")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nv_satellite_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId, self).__setattr__(name, value)


                            class Input(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: service_policy_names
                                
                                	Operational data for all Policy instance
                                	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input, self).__init__()

                                    self.yang_name = "input"
                                    self.yang_parent_name = "satellite-id"

                                    self.service_policy_names = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                    self._children_yang_names.add("service-policy-names")

                                    self.statistics = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._children_yang_names.add("statistics")


                                class ServicePolicyNames(Entity):
                                    """
                                    Operational data for all Policy instance
                                    
                                    .. attribute:: service_policy_instance
                                    
                                    	QoS policy\-map operational data for a particular Policy 
                                    	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                        self.yang_name = "service-policy-names"
                                        self.yang_parent_name = "input"

                                        self.service_policy_instance = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)


                                    class ServicePolicyInstance(Entity):
                                        """
                                        QoS policy\-map operational data for a
                                        particular Policy 
                                        
                                        .. attribute:: service_policy_name  <key>
                                        
                                        	Name of the policy instance
                                        	**type**\:  str
                                        
                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                            self.yang_name = "service-policy-instance"
                                            self.yang_parent_name = "service-policy-names"

                                            self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("service_policy_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.service_policy_name.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.service_policy_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "service-policy-name"):
                                                self.service_policy_name = value
                                                self.service_policy_name.value_namespace = name_space
                                                self.service_policy_name.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.service_policy_instance:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.service_policy_instance:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "service-policy-names" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-instance"):
                                            for c in self.service_policy_instance:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.service_policy_instance.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-instance"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "input"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.child_policy = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                            self._children_yang_names.add("child-policy")

                                            self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\:  str
                                            
                                            	**length:** 0..128
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.satid = YLeaf(YType.uint32, "satid")

                                                self.state = YLeaf(YType.enumeration, "state")

                                                self.state_description = YLeaf(YType.str, "state-description")

                                                self.class_stats = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("policy_name",
                                                                "satid",
                                                                "state",
                                                                "state_description") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\:  str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"

                                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                    self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                    self._children_yang_names.add("cac-stats")

                                                    self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                    self._children_yang_names.add("general-stats")

                                                    self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    self._children_yang_names.add("iphc-stats")

                                                    self.police_stats_array = YList(self)
                                                    self.queue_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("cac_state",
                                                                    "class_name",
                                                                    "counter_validity_bitmask",
                                                                    "queue_descr",
                                                                    "shared_queue_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("match_data_rate",
                                                                        "pre_policy_matched_bytes",
                                                                        "pre_policy_matched_packets",
                                                                        "total_drop_bytes",
                                                                        "total_drop_packets",
                                                                        "total_drop_rate",
                                                                        "total_transmit_rate",
                                                                        "transmit_bytes",
                                                                        "transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.match_data_rate.is_set or
                                                            self.pre_policy_matched_bytes.is_set or
                                                            self.pre_policy_matched_packets.is_set or
                                                            self.total_drop_bytes.is_set or
                                                            self.total_drop_packets.is_set or
                                                            self.total_drop_rate.is_set or
                                                            self.total_transmit_rate.is_set or
                                                            self.transmit_bytes.is_set or
                                                            self.transmit_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.match_data_rate.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                                            self.transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "general-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "match-data-rate"):
                                                            self.match_data_rate = value
                                                            self.match_data_rate.value_namespace = name_space
                                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-bytes"):
                                                            self.pre_policy_matched_bytes = value
                                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-packets"):
                                                            self.pre_policy_matched_packets = value
                                                            self.pre_policy_matched_packets.value_namespace = name_space
                                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-bytes"):
                                                            self.total_drop_bytes = value
                                                            self.total_drop_bytes.value_namespace = name_space
                                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-packets"):
                                                            self.total_drop_packets = value
                                                            self.total_drop_packets.value_namespace = name_space
                                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-rate"):
                                                            self.total_drop_rate = value
                                                            self.total_drop_rate.value_namespace = name_space
                                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-transmit-rate"):
                                                            self.total_transmit_rate = value
                                                            self.total_transmit_rate.value_namespace = name_space
                                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-bytes"):
                                                            self.transmit_bytes = value
                                                            self.transmit_bytes.value_namespace = name_space
                                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-packets"):
                                                            self.transmit_packets = value
                                                            self.transmit_packets.value_namespace = name_space
                                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("non_tcp_bytes_saved",
                                                                        "non_tcp_bytes_sent_rate",
                                                                        "non_tcp_compressed_packets_out",
                                                                        "non_tcp_full_header_packets_out",
                                                                        "non_tcp_total_out_bytes",
                                                                        "non_tcp_total_out_packets",
                                                                        "tcp_bytes_saved",
                                                                        "tcp_bytes_sent_rate",
                                                                        "tcp_compressed_packets_out",
                                                                        "tcp_full_header_packets_out",
                                                                        "tcp_total_out_bytes",
                                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.non_tcp_bytes_saved.is_set or
                                                            self.non_tcp_bytes_sent_rate.is_set or
                                                            self.non_tcp_compressed_packets_out.is_set or
                                                            self.non_tcp_full_header_packets_out.is_set or
                                                            self.non_tcp_total_out_bytes.is_set or
                                                            self.non_tcp_total_out_packets.is_set or
                                                            self.tcp_bytes_saved.is_set or
                                                            self.tcp_bytes_sent_rate.is_set or
                                                            self.tcp_compressed_packets_out.is_set or
                                                            self.tcp_full_header_packets_out.is_set or
                                                            self.tcp_total_out_bytes.is_set or
                                                            self.tcp_total_out_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "iphc-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "non-tcp-bytes-saved"):
                                                            self.non_tcp_bytes_saved = value
                                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                                            self.non_tcp_bytes_sent_rate = value
                                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-compressed-packets-out"):
                                                            self.non_tcp_compressed_packets_out = value
                                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-full-header-packets-out"):
                                                            self.non_tcp_full_header_packets_out = value
                                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-bytes"):
                                                            self.non_tcp_total_out_bytes = value
                                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-packets"):
                                                            self.non_tcp_total_out_packets = value
                                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-saved"):
                                                            self.tcp_bytes_saved = value
                                                            self.tcp_bytes_saved.value_namespace = name_space
                                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-sent-rate"):
                                                            self.tcp_bytes_sent_rate = value
                                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-compressed-packets-out"):
                                                            self.tcp_compressed_packets_out = value
                                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-full-header-packets-out"):
                                                            self.tcp_full_header_packets_out = value
                                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-bytes"):
                                                            self.tcp_total_out_bytes = value
                                                            self.tcp_total_out_bytes.value_namespace = name_space
                                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-packets"):
                                                            self.tcp_total_out_packets = value
                                                            self.tcp_total_out_packets.value_namespace = name_space
                                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("admit_bytes",
                                                                        "admit_rates",
                                                                        "admitpackets",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "drop_rates") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.admit_bytes.is_set or
                                                            self.admit_rates.is_set or
                                                            self.admitpackets.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.drop_rates.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.admit_bytes.yfilter != YFilter.not_set or
                                                            self.admit_rates.yfilter != YFilter.not_set or
                                                            self.admitpackets.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.drop_rates.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cac-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "admit-bytes"):
                                                            self.admit_bytes = value
                                                            self.admit_bytes.value_namespace = name_space
                                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admit-rates"):
                                                            self.admit_rates = value
                                                            self.admit_rates.value_namespace = name_space
                                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admitpackets"):
                                                            self.admitpackets = value
                                                            self.admitpackets.value_namespace = name_space
                                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-rates"):
                                                            self.drop_rates = value
                                                            self.drop_rates.value_namespace = name_space
                                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                        self.queue_average_length = YList(self)
                                                        self.queue_instance_length = YList(self)
                                                        self.queue_max_length = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("atm_clp0_drop_bytes",
                                                                        "atm_clp0_drop_packets",
                                                                        "atm_clp1_drop_bytes",
                                                                        "atm_clp1_drop_packets",
                                                                        "conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "forced_wred_stats_display",
                                                                        "max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "queue_drop_threshold",
                                                                        "queue_id",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "tail_drop_bytes",
                                                                        "tail_drop_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-instance-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-average-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-max-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.atm_clp0_drop_bytes.is_set or
                                                            self.atm_clp0_drop_packets.is_set or
                                                            self.atm_clp1_drop_bytes.is_set or
                                                            self.atm_clp1_drop_packets.is_set or
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.forced_wred_stats_display.is_set or
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.queue_drop_threshold.is_set or
                                                            self.queue_id.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.tail_drop_bytes.is_set or
                                                            self.tail_drop_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                            self.queue_id.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "queue-average-length"):
                                                            for c in self.queue_average_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_average_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-instance-length"):
                                                            for c in self.queue_instance_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_instance_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-max-length"):
                                                            for c in self.queue_max_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_max_length.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "atm-clp0-drop-bytes"):
                                                            self.atm_clp0_drop_bytes = value
                                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp0-drop-packets"):
                                                            self.atm_clp0_drop_packets = value
                                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-bytes"):
                                                            self.atm_clp1_drop_bytes = value
                                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-packets"):
                                                            self.atm_clp1_drop_packets = value
                                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "forced-wred-stats-display"):
                                                            self.forced_wred_stats_display = value
                                                            self.forced_wred_stats_display.value_namespace = name_space
                                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-drop-threshold"):
                                                            self.queue_drop_threshold = value
                                                            self.queue_drop_threshold.value_namespace = name_space
                                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-id"):
                                                            self.queue_id = value
                                                            self.queue_id.value_namespace = name_space
                                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-bytes"):
                                                            self.tail_drop_bytes = value
                                                            self.tail_drop_bytes.value_namespace = name_space
                                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-packets"):
                                                            self.tail_drop_packets = value
                                                            self.tail_drop_packets.value_namespace = name_space
                                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                        self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._children_yang_names.add("color-class-stats")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "parent_drop_bytes",
                                                                        "parent_drop_packets",
                                                                        "violate_bytes",
                                                                        "violate_packets",
                                                                        "violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"

                                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_class_conform_bytes",
                                                                            "conform_class_conform_packets",
                                                                            "conform_class_conform_rate",
                                                                            "conform_class_exceed_bytes",
                                                                            "conform_class_exceed_packets",
                                                                            "conform_class_exceed_rate",
                                                                            "conform_class_violate_bytes",
                                                                            "conform_class_violate_packets",
                                                                            "conform_class_violate_rate",
                                                                            "exceed_class_exceed_bytes",
                                                                            "exceed_class_exceed_packets",
                                                                            "exceed_class_exceed_rate",
                                                                            "exceed_class_violate_bytes",
                                                                            "exceed_class_violate_packets",
                                                                            "exceed_class_violate_rate",
                                                                            "violate_class_violate_bytes",
                                                                            "violate_class_violate_packets",
                                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.conform_class_conform_bytes.is_set or
                                                                self.conform_class_conform_packets.is_set or
                                                                self.conform_class_conform_rate.is_set or
                                                                self.conform_class_exceed_bytes.is_set or
                                                                self.conform_class_exceed_packets.is_set or
                                                                self.conform_class_exceed_rate.is_set or
                                                                self.conform_class_violate_bytes.is_set or
                                                                self.conform_class_violate_packets.is_set or
                                                                self.conform_class_violate_rate.is_set or
                                                                self.exceed_class_exceed_bytes.is_set or
                                                                self.exceed_class_exceed_packets.is_set or
                                                                self.exceed_class_exceed_rate.is_set or
                                                                self.exceed_class_violate_bytes.is_set or
                                                                self.exceed_class_violate_packets.is_set or
                                                                self.exceed_class_violate_rate.is_set or
                                                                self.violate_class_violate_bytes.is_set or
                                                                self.violate_class_violate_packets.is_set or
                                                                self.violate_class_violate_rate.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "color-class-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-class-conform-bytes"):
                                                                self.conform_class_conform_bytes = value
                                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-packets"):
                                                                self.conform_class_conform_packets = value
                                                                self.conform_class_conform_packets.value_namespace = name_space
                                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-rate"):
                                                                self.conform_class_conform_rate = value
                                                                self.conform_class_conform_rate.value_namespace = name_space
                                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-bytes"):
                                                                self.conform_class_exceed_bytes = value
                                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-packets"):
                                                                self.conform_class_exceed_packets = value
                                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-rate"):
                                                                self.conform_class_exceed_rate = value
                                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-bytes"):
                                                                self.conform_class_violate_bytes = value
                                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-packets"):
                                                                self.conform_class_violate_packets = value
                                                                self.conform_class_violate_packets.value_namespace = name_space
                                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-rate"):
                                                                self.conform_class_violate_rate = value
                                                                self.conform_class_violate_rate.value_namespace = name_space
                                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-bytes"):
                                                                self.exceed_class_exceed_bytes = value
                                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-packets"):
                                                                self.exceed_class_exceed_packets = value
                                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-rate"):
                                                                self.exceed_class_exceed_rate = value
                                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-bytes"):
                                                                self.exceed_class_violate_bytes = value
                                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-packets"):
                                                                self.exceed_class_violate_packets = value
                                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-rate"):
                                                                self.exceed_class_violate_rate = value
                                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-bytes"):
                                                                self.violate_class_violate_bytes = value
                                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-packets"):
                                                                self.violate_class_violate_packets = value
                                                                self.violate_class_violate_packets.value_namespace = name_space
                                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-rate"):
                                                                self.violate_class_violate_rate = value
                                                                self.violate_class_violate_rate.value_namespace = name_space
                                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.parent_drop_bytes.is_set or
                                                            self.parent_drop_packets.is_set or
                                                            self.violate_bytes.is_set or
                                                            self.violate_packets.is_set or
                                                            self.violate_rate.is_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                                            self.violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_rate.yfilter != YFilter.not_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "color-class-stats"):
                                                            if (self.color_class_stats is None):
                                                                self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            return self.color_class_stats

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-bytes"):
                                                            self.parent_drop_bytes = value
                                                            self.parent_drop_bytes.value_namespace = name_space
                                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-packets"):
                                                            self.parent_drop_packets = value
                                                            self.parent_drop_packets.value_namespace = name_space
                                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-bytes"):
                                                            self.violate_bytes = value
                                                            self.violate_bytes.value_namespace = name_space
                                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-packets"):
                                                            self.violate_packets = value
                                                            self.violate_packets.value_namespace = name_space
                                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-rate"):
                                                            self.violate_rate = value
                                                            self.violate_rate.value_namespace = name_space
                                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                        self.red_label = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "profile_title",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "red_ecn_marked_bytes",
                                                                        "red_ecn_marked_packets",
                                                                        "red_transmit_bytes",
                                                                        "red_transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"

                                                            self.value = YLeaf(YType.uint8, "value")

                                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("value",
                                                                            "wred_type") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.value.is_set or
                                                                self.wred_type.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set or
                                                                self.wred_type.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "red-label" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())
                                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "value" or name == "wred-type"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "wred-type"):
                                                                self.wred_type = value
                                                                self.wred_type.value_namespace = name_space
                                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.red_label:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.profile_title.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.red_ecn_marked_bytes.is_set or
                                                            self.red_ecn_marked_packets.is_set or
                                                            self.red_transmit_bytes.is_set or
                                                            self.red_transmit_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.red_label:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.profile_title.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "wred-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "red-label"):
                                                            for c in self.red_label:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.red_label.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "profile-title"):
                                                            self.profile_title = value
                                                            self.profile_title.value_namespace = name_space
                                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-bytes"):
                                                            self.red_ecn_marked_bytes = value
                                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-packets"):
                                                            self.red_ecn_marked_packets = value
                                                            self.red_ecn_marked_packets.value_namespace = name_space
                                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-bytes"):
                                                            self.red_transmit_bytes = value
                                                            self.red_transmit_bytes.value_namespace = name_space
                                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-packets"):
                                                            self.red_transmit_packets = value
                                                            self.red_transmit_packets.value_namespace = name_space
                                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.cac_state.is_set or
                                                        self.class_name.is_set or
                                                        self.counter_validity_bitmask.is_set or
                                                        self.queue_descr.is_set or
                                                        self.shared_queue_id.is_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                def has_operation(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.cac_state.yfilter != YFilter.not_set or
                                                        self.class_name.yfilter != YFilter.not_set or
                                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                        self.queue_descr.yfilter != YFilter.not_set or
                                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cac-stats"):
                                                        if (self.cac_stats is None):
                                                            self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                        return self.cac_stats

                                                    if (child_yang_name == "general-stats"):
                                                        if (self.general_stats is None):
                                                            self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"
                                                        return self.general_stats

                                                    if (child_yang_name == "iphc-stats"):
                                                        if (self.iphc_stats is None):
                                                            self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        return self.iphc_stats

                                                    if (child_yang_name == "police-stats-array"):
                                                        for c in self.police_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.police_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-stats-array"):
                                                        for c in self.queue_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "wred-stats-array"):
                                                        for c in self.wred_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.wred_stats_array.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "cac-state"):
                                                        self.cac_state = value
                                                        self.cac_state.value_namespace = name_space
                                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "class-name"):
                                                        self.class_name = value
                                                        self.class_name.value_namespace = name_space
                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "counter-validity-bitmask"):
                                                        self.counter_validity_bitmask = value
                                                        self.counter_validity_bitmask.value_namespace = name_space
                                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-descr"):
                                                        self.queue_descr = value
                                                        self.queue_descr.value_namespace = name_space
                                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "shared-queue-id"):
                                                        self.shared_queue_id = value
                                                        self.shared_queue_id.value_namespace = name_space
                                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.class_stats:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.policy_name.is_set or
                                                    self.satid.is_set or
                                                    self.state.is_set or
                                                    self.state_description.is_set)

                                            def has_operation(self):
                                                for c in self.class_stats:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    self.satid.yfilter != YFilter.not_set or
                                                    self.state.yfilter != YFilter.not_set or
                                                    self.state_description.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "child-policy" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state.get_name_leafdata())
                                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "class-stats"):
                                                    for c in self.class_stats:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.class_stats.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "satid"):
                                                    self.satid = value
                                                    self.satid.value_namespace = name_space
                                                    self.satid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state"):
                                                    self.state = value
                                                    self.state.value_namespace = name_space
                                                    self.state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state-description"):
                                                    self.state_description = value
                                                    self.state_description.value_namespace = name_space
                                                    self.state_description.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.child_policy is not None and self.child_policy.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.child_policy is not None and self.child_policy.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "child-policy"):
                                                if (self.child_policy is None):
                                                    self.child_policy = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"
                                                return self.child_policy

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "statistics" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                        (self.statistics is not None and self.statistics.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                        (self.statistics is not None and self.statistics.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "input" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "service-policy-names"):
                                        if (self.service_policy_names is None):
                                            self.service_policy_names = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                            self.service_policy_names.parent = self
                                            self._children_name_map["service_policy_names"] = "service-policy-names"
                                        return self.service_policy_names

                                    if (child_yang_name == "statistics"):
                                        if (self.statistics is None):
                                            self.statistics = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                        return self.statistics

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-names" or name == "statistics"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Output(Entity):
                                """
                                A piece of QoS policy\-map operational data for
                                an interface
                                
                                .. attribute:: service_policy_names
                                
                                	Operational data for all Policy instance
                                	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                                
                                .. attribute:: statistics
                                
                                	Policy\-map statistics operational data for an interface
                                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output, self).__init__()

                                    self.yang_name = "output"
                                    self.yang_parent_name = "satellite-id"

                                    self.service_policy_names = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                    self._children_yang_names.add("service-policy-names")

                                    self.statistics = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._children_yang_names.add("statistics")


                                class ServicePolicyNames(Entity):
                                    """
                                    Operational data for all Policy instance
                                    
                                    .. attribute:: service_policy_instance
                                    
                                    	QoS policy\-map operational data for a particular Policy 
                                    	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                        self.yang_name = "service-policy-names"
                                        self.yang_parent_name = "output"

                                        self.service_policy_instance = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)


                                    class ServicePolicyInstance(Entity):
                                        """
                                        QoS policy\-map operational data for a
                                        particular Policy 
                                        
                                        .. attribute:: service_policy_name  <key>
                                        
                                        	Name of the policy instance
                                        	**type**\:  str
                                        
                                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                            self.yang_name = "service-policy-instance"
                                            self.yang_parent_name = "service-policy-names"

                                            self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("service_policy_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.service_policy_name.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.service_policy_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "service-policy-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "service-policy-name"):
                                                self.service_policy_name = value
                                                self.service_policy_name.value_namespace = name_space
                                                self.service_policy_name.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.service_policy_instance:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.service_policy_instance:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "service-policy-names" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "service-policy-instance"):
                                            for c in self.service_policy_instance:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.service_policy_instance.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "service-policy-instance"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Statistics(Entity):
                                    """
                                    Policy\-map statistics operational data for an
                                    interface
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "output"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats>`
                                        
                                        .. attribute:: child_policy
                                        
                                        	child policy
                                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "statistics"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.child_policy = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                            self._children_yang_names.add("child-policy")

                                            self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class ChildPolicy(Entity):
                                            """
                                            child policy
                                            
                                            .. attribute:: class_stats
                                            
                                            	array of classes contained in policy
                                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	PolicyName
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: satid
                                            
                                            	to maintain satellite id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: state
                                            
                                            	State
                                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                            
                                            .. attribute:: state_description
                                            
                                            	StateDescription
                                            	**type**\:  str
                                            
                                            	**length:** 0..128
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                                self.yang_name = "child-policy"
                                                self.yang_parent_name = "class-stats"

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.satid = YLeaf(YType.uint32, "satid")

                                                self.state = YLeaf(YType.enumeration, "state")

                                                self.state_description = YLeaf(YType.str, "state-description")

                                                self.class_stats = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("policy_name",
                                                                "satid",
                                                                "state",
                                                                "state_description") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                            class ClassStats(Entity):
                                                """
                                                array of classes contained in policy
                                                
                                                .. attribute:: cac_state
                                                
                                                	CACState
                                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                                
                                                .. attribute:: cac_stats
                                                
                                                	bag for cac stats
                                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                                
                                                .. attribute:: class_name
                                                
                                                	ClassName
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: counter_validity_bitmask
                                                
                                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: megabyte
                                                
                                                .. attribute:: general_stats
                                                
                                                	general stats
                                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                                
                                                .. attribute:: iphc_stats
                                                
                                                	IPHC stats
                                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                                
                                                .. attribute:: police_stats_array
                                                
                                                	array of police stats
                                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                                
                                                .. attribute:: queue_descr
                                                
                                                	Description of queue for the class
                                                	**type**\:  str
                                                
                                                	**length:** 0..256
                                                
                                                .. attribute:: queue_stats_array
                                                
                                                	array of queue stats
                                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                                
                                                .. attribute:: shared_queue_id
                                                
                                                	q\-id of the  shared queue for this class
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: wred_stats_array
                                                
                                                	array of red stats
                                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                                    self.yang_name = "class-stats"
                                                    self.yang_parent_name = "child-policy"

                                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                                    self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                    self._children_yang_names.add("cac-stats")

                                                    self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                    self._children_yang_names.add("general-stats")

                                                    self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                    self._children_yang_names.add("iphc-stats")

                                                    self.police_stats_array = YList(self)
                                                    self.queue_stats_array = YList(self)
                                                    self.wred_stats_array = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("cac_state",
                                                                    "class_name",
                                                                    "counter_validity_bitmask",
                                                                    "queue_descr",
                                                                    "shared_queue_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                                class GeneralStats(Entity):
                                                    """
                                                    general stats
                                                    
                                                    .. attribute:: match_data_rate
                                                    
                                                    	Incoming matched data rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: pre_policy_matched_bytes
                                                    
                                                    	Matched bytes before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: pre_policy_matched_packets
                                                    
                                                    	Matched pkts before applying policy
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: total_drop_bytes
                                                    
                                                    	Dropped bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_packets
                                                    
                                                    	Dropped packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_drop_rate
                                                    
                                                    	Total drop rate (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: total_transmit_rate
                                                    
                                                    	Total transmit rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: transmit_bytes
                                                    
                                                    	Transmitted bytes (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: transmit_packets
                                                    
                                                    	Transmitted packets (packets/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                        self.yang_name = "general-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("match_data_rate",
                                                                        "pre_policy_matched_bytes",
                                                                        "pre_policy_matched_packets",
                                                                        "total_drop_bytes",
                                                                        "total_drop_packets",
                                                                        "total_drop_rate",
                                                                        "total_transmit_rate",
                                                                        "transmit_bytes",
                                                                        "transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.match_data_rate.is_set or
                                                            self.pre_policy_matched_bytes.is_set or
                                                            self.pre_policy_matched_packets.is_set or
                                                            self.total_drop_bytes.is_set or
                                                            self.total_drop_packets.is_set or
                                                            self.total_drop_rate.is_set or
                                                            self.total_transmit_rate.is_set or
                                                            self.transmit_bytes.is_set or
                                                            self.transmit_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.match_data_rate.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                                            self.transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "general-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "match-data-rate"):
                                                            self.match_data_rate = value
                                                            self.match_data_rate.value_namespace = name_space
                                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-bytes"):
                                                            self.pre_policy_matched_bytes = value
                                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "pre-policy-matched-packets"):
                                                            self.pre_policy_matched_packets = value
                                                            self.pre_policy_matched_packets.value_namespace = name_space
                                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-bytes"):
                                                            self.total_drop_bytes = value
                                                            self.total_drop_bytes.value_namespace = name_space
                                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-packets"):
                                                            self.total_drop_packets = value
                                                            self.total_drop_packets.value_namespace = name_space
                                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-drop-rate"):
                                                            self.total_drop_rate = value
                                                            self.total_drop_rate.value_namespace = name_space
                                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "total-transmit-rate"):
                                                            self.total_transmit_rate = value
                                                            self.total_transmit_rate.value_namespace = name_space
                                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-bytes"):
                                                            self.transmit_bytes = value
                                                            self.transmit_bytes.value_namespace = name_space
                                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "transmit-packets"):
                                                            self.transmit_packets = value
                                                            self.transmit_packets.value_namespace = name_space
                                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                                class IphcStats(Entity):
                                                    """
                                                    IPHC stats
                                                    
                                                    .. attribute:: non_tcp_bytes_saved
                                                    
                                                    	Non Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_bytes_sent_rate
                                                    
                                                    	Compressed Non Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_compressed_packets_out
                                                    
                                                    	Num of non tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_full_header_packets_out
                                                    
                                                    	Num of non tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: non_tcp_total_out_bytes
                                                    
                                                    	TotalNum of Non Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: non_tcp_total_out_packets
                                                    
                                                    	TotalNum of Non tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_bytes_saved
                                                    
                                                    	Tcp Bytes saved due to compression
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_bytes_sent_rate
                                                    
                                                    	Compressed Tcp Bytes sent rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_compressed_packets_out
                                                    
                                                    	Num of tcp compressed pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_full_header_packets_out
                                                    
                                                    	Num of tcp fullheader pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tcp_total_out_bytes
                                                    
                                                    	TotalNum of Tcp Bytes sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tcp_total_out_packets
                                                    
                                                    	Total Num of tcp pkts sent
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                        self.yang_name = "iphc-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("non_tcp_bytes_saved",
                                                                        "non_tcp_bytes_sent_rate",
                                                                        "non_tcp_compressed_packets_out",
                                                                        "non_tcp_full_header_packets_out",
                                                                        "non_tcp_total_out_bytes",
                                                                        "non_tcp_total_out_packets",
                                                                        "tcp_bytes_saved",
                                                                        "tcp_bytes_sent_rate",
                                                                        "tcp_compressed_packets_out",
                                                                        "tcp_full_header_packets_out",
                                                                        "tcp_total_out_bytes",
                                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.non_tcp_bytes_saved.is_set or
                                                            self.non_tcp_bytes_sent_rate.is_set or
                                                            self.non_tcp_compressed_packets_out.is_set or
                                                            self.non_tcp_full_header_packets_out.is_set or
                                                            self.non_tcp_total_out_bytes.is_set or
                                                            self.non_tcp_total_out_packets.is_set or
                                                            self.tcp_bytes_saved.is_set or
                                                            self.tcp_bytes_sent_rate.is_set or
                                                            self.tcp_compressed_packets_out.is_set or
                                                            self.tcp_full_header_packets_out.is_set or
                                                            self.tcp_total_out_bytes.is_set or
                                                            self.tcp_total_out_packets.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "iphc-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "non-tcp-bytes-saved"):
                                                            self.non_tcp_bytes_saved = value
                                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                                            self.non_tcp_bytes_sent_rate = value
                                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-compressed-packets-out"):
                                                            self.non_tcp_compressed_packets_out = value
                                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-full-header-packets-out"):
                                                            self.non_tcp_full_header_packets_out = value
                                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-bytes"):
                                                            self.non_tcp_total_out_bytes = value
                                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "non-tcp-total-out-packets"):
                                                            self.non_tcp_total_out_packets = value
                                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-saved"):
                                                            self.tcp_bytes_saved = value
                                                            self.tcp_bytes_saved.value_namespace = name_space
                                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-bytes-sent-rate"):
                                                            self.tcp_bytes_sent_rate = value
                                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-compressed-packets-out"):
                                                            self.tcp_compressed_packets_out = value
                                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-full-header-packets-out"):
                                                            self.tcp_full_header_packets_out = value
                                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-bytes"):
                                                            self.tcp_total_out_bytes = value
                                                            self.tcp_total_out_bytes.value_namespace = name_space
                                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tcp-total-out-packets"):
                                                            self.tcp_total_out_packets = value
                                                            self.tcp_total_out_packets.value_namespace = name_space
                                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                                class CacStats(Entity):
                                                    """
                                                    bag for cac stats
                                                    
                                                    .. attribute:: admit_bytes
                                                    
                                                    	Admitted bytes (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: admit_rates
                                                    
                                                    	CAC admit rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: admitpackets
                                                    
                                                    	Admitted packets (pkts/bytes)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	CAC dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	CAC dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: drop_rates
                                                    
                                                    	CAC dropped rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                        self.yang_name = "cac-stats"
                                                        self.yang_parent_name = "class-stats"

                                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("admit_bytes",
                                                                        "admit_rates",
                                                                        "admitpackets",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "drop_rates") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.admit_bytes.is_set or
                                                            self.admit_rates.is_set or
                                                            self.admitpackets.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.drop_rates.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.admit_bytes.yfilter != YFilter.not_set or
                                                            self.admit_rates.yfilter != YFilter.not_set or
                                                            self.admitpackets.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.drop_rates.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cac-stats" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "admit-bytes"):
                                                            self.admit_bytes = value
                                                            self.admit_bytes.value_namespace = name_space
                                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admit-rates"):
                                                            self.admit_rates = value
                                                            self.admit_rates.value_namespace = name_space
                                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "admitpackets"):
                                                            self.admitpackets = value
                                                            self.admitpackets.value_namespace = name_space
                                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-rates"):
                                                            self.drop_rates = value
                                                            self.drop_rates.value_namespace = name_space
                                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                                class QueueStatsArray(Entity):
                                                    """
                                                    array of queue stats
                                                    
                                                    .. attribute:: atm_clp0_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp0_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: atm_clp1_drop_bytes
                                                    
                                                    	ATP CLP 0 matched bytes dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: atm_clp1_drop_packets
                                                    
                                                    	ATP CLP 0 matched packets dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the queue rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: forced_wred_stats_display
                                                    
                                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: queue_average_length
                                                    
                                                    	Queue average length
                                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                                    
                                                    .. attribute:: queue_drop_threshold
                                                    
                                                    	tail drop threshold of the queue in bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: queue_id
                                                    
                                                    	Queue Id used for Fabric Stats
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: queue_instance_length
                                                    
                                                    	Queue instance length
                                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                                    
                                                    .. attribute:: queue_max_length
                                                    
                                                    	Queue maximum length
                                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Bytes probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Packets probabilistically dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: tail_drop_bytes
                                                    
                                                    	Bytes tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: tail_drop_packets
                                                    
                                                    	Packets tail dropped
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                        self.yang_name = "queue-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                        self.queue_average_length = YList(self)
                                                        self.queue_instance_length = YList(self)
                                                        self.queue_max_length = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("atm_clp0_drop_bytes",
                                                                        "atm_clp0_drop_packets",
                                                                        "atm_clp1_drop_bytes",
                                                                        "atm_clp1_drop_packets",
                                                                        "conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "forced_wred_stats_display",
                                                                        "max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "queue_drop_threshold",
                                                                        "queue_id",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "tail_drop_bytes",
                                                                        "tail_drop_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                                    class QueueInstanceLength(Entity):
                                                        """
                                                        Queue instance length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                            self.yang_name = "queue-instance-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-instance-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueAverageLength(Entity):
                                                        """
                                                        Queue average length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                            self.yang_name = "queue-average-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-average-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class QueueMaxLength(Entity):
                                                        """
                                                        Queue maximum length
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	unit
                                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                            self.yang_name = "queue-max-length"
                                                            self.yang_parent_name = "queue-stats-array"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "queue-max-length" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_data()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.atm_clp0_drop_bytes.is_set or
                                                            self.atm_clp0_drop_packets.is_set or
                                                            self.atm_clp1_drop_bytes.is_set or
                                                            self.atm_clp1_drop_packets.is_set or
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.forced_wred_stats_display.is_set or
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.queue_drop_threshold.is_set or
                                                            self.queue_id.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.tail_drop_bytes.is_set or
                                                            self.tail_drop_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.queue_average_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_instance_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        for c in self.queue_max_length:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                            self.queue_id.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "queue-average-length"):
                                                            for c in self.queue_average_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_average_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-instance-length"):
                                                            for c in self.queue_instance_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_instance_length.append(c)
                                                            return c

                                                        if (child_yang_name == "queue-max-length"):
                                                            for c in self.queue_max_length:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.queue_max_length.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "atm-clp0-drop-bytes"):
                                                            self.atm_clp0_drop_bytes = value
                                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp0-drop-packets"):
                                                            self.atm_clp0_drop_packets = value
                                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-bytes"):
                                                            self.atm_clp1_drop_bytes = value
                                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "atm-clp1-drop-packets"):
                                                            self.atm_clp1_drop_packets = value
                                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "forced-wred-stats-display"):
                                                            self.forced_wred_stats_display = value
                                                            self.forced_wred_stats_display.value_namespace = name_space
                                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-drop-threshold"):
                                                            self.queue_drop_threshold = value
                                                            self.queue_drop_threshold.value_namespace = name_space
                                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "queue-id"):
                                                            self.queue_id = value
                                                            self.queue_id.value_namespace = name_space
                                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-bytes"):
                                                            self.tail_drop_bytes = value
                                                            self.tail_drop_bytes.value_namespace = name_space
                                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "tail-drop-packets"):
                                                            self.tail_drop_packets = value
                                                            self.tail_drop_packets.value_namespace = name_space
                                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                                class PoliceStatsArray(Entity):
                                                    """
                                                    array of police stats
                                                    
                                                    .. attribute:: color_class_stats
                                                    
                                                    	color class stats
                                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                                    
                                                    .. attribute:: conform_bytes
                                                    
                                                    	Bytes that conform to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: conform_packets
                                                    
                                                    	Packets that conform  to the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: conform_rate
                                                    
                                                    	Conform rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: drop_bytes
                                                    
                                                    	Police dropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: drop_packets
                                                    
                                                    	Police dropped packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_bytes
                                                    
                                                    	Bytes that exceed  the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: exceed_packets
                                                    
                                                    	Packets that exceed the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: exceed_rate
                                                    
                                                    	Exceed rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    .. attribute:: parent_drop_bytes
                                                    
                                                    	Dropped bytes by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: parent_drop_packets
                                                    
                                                    	Dropped pkts by the parent policer
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_bytes
                                                    
                                                    	Bytes that violate the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: violate_packets
                                                    
                                                    	Packets violating the policed rate
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: violate_rate
                                                    
                                                    	Violate rate in kbps
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    	**units**\: kbit/s
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                        self.yang_name = "police-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                        self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                        self._children_yang_names.add("color-class-stats")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("conform_bytes",
                                                                        "conform_packets",
                                                                        "conform_rate",
                                                                        "drop_bytes",
                                                                        "drop_packets",
                                                                        "exceed_bytes",
                                                                        "exceed_packets",
                                                                        "exceed_rate",
                                                                        "parent_drop_bytes",
                                                                        "parent_drop_packets",
                                                                        "violate_bytes",
                                                                        "violate_packets",
                                                                        "violate_rate") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                                    class ColorClassStats(Entity):
                                                        """
                                                        color class stats
                                                        
                                                        .. attribute:: conform_class_conform_bytes
                                                        
                                                        	Bytes with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_conform_packets
                                                        
                                                        	Packets with classification result conform and policer result conform
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_conform_rate
                                                        
                                                        	Conform Class Conform rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_exceed_bytes
                                                        
                                                        	Bytes with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_exceed_packets
                                                        
                                                        	Packets with classification result conform and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_exceed_rate
                                                        
                                                        	Conform Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: conform_class_violate_bytes
                                                        
                                                        	Bytes with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: conform_class_violate_packets
                                                        
                                                        	Packets with classification result conform and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: conform_class_violate_rate
                                                        
                                                        	Conform Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_exceed_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_exceed_packets
                                                        
                                                        	Packets with classification result exceed and policer result exceed
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_exceed_rate
                                                        
                                                        	Exceed Class Exceed rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: exceed_class_violate_bytes
                                                        
                                                        	Bytes with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: exceed_class_violate_packets
                                                        
                                                        	Packets with classification result exceed and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: exceed_class_violate_rate
                                                        
                                                        	Exceed Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        .. attribute:: violate_class_violate_bytes
                                                        
                                                        	Bytes with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        	**units**\: byte
                                                        
                                                        .. attribute:: violate_class_violate_packets
                                                        
                                                        	Packets with classification result violate and policer result violate
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: violate_class_violate_rate
                                                        
                                                        	Violate Class Violate rate in kbps
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        	**units**\: kbit/s
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                            self.yang_name = "color-class-stats"
                                                            self.yang_parent_name = "police-stats-array"

                                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("conform_class_conform_bytes",
                                                                            "conform_class_conform_packets",
                                                                            "conform_class_conform_rate",
                                                                            "conform_class_exceed_bytes",
                                                                            "conform_class_exceed_packets",
                                                                            "conform_class_exceed_rate",
                                                                            "conform_class_violate_bytes",
                                                                            "conform_class_violate_packets",
                                                                            "conform_class_violate_rate",
                                                                            "exceed_class_exceed_bytes",
                                                                            "exceed_class_exceed_packets",
                                                                            "exceed_class_exceed_rate",
                                                                            "exceed_class_violate_bytes",
                                                                            "exceed_class_violate_packets",
                                                                            "exceed_class_violate_rate",
                                                                            "violate_class_violate_bytes",
                                                                            "violate_class_violate_packets",
                                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.conform_class_conform_bytes.is_set or
                                                                self.conform_class_conform_packets.is_set or
                                                                self.conform_class_conform_rate.is_set or
                                                                self.conform_class_exceed_bytes.is_set or
                                                                self.conform_class_exceed_packets.is_set or
                                                                self.conform_class_exceed_rate.is_set or
                                                                self.conform_class_violate_bytes.is_set or
                                                                self.conform_class_violate_packets.is_set or
                                                                self.conform_class_violate_rate.is_set or
                                                                self.exceed_class_exceed_bytes.is_set or
                                                                self.exceed_class_exceed_packets.is_set or
                                                                self.exceed_class_exceed_rate.is_set or
                                                                self.exceed_class_violate_bytes.is_set or
                                                                self.exceed_class_violate_packets.is_set or
                                                                self.exceed_class_violate_rate.is_set or
                                                                self.violate_class_violate_bytes.is_set or
                                                                self.violate_class_violate_packets.is_set or
                                                                self.violate_class_violate_rate.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "color-class-stats" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "conform-class-conform-bytes"):
                                                                self.conform_class_conform_bytes = value
                                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-packets"):
                                                                self.conform_class_conform_packets = value
                                                                self.conform_class_conform_packets.value_namespace = name_space
                                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-conform-rate"):
                                                                self.conform_class_conform_rate = value
                                                                self.conform_class_conform_rate.value_namespace = name_space
                                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-bytes"):
                                                                self.conform_class_exceed_bytes = value
                                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-packets"):
                                                                self.conform_class_exceed_packets = value
                                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-exceed-rate"):
                                                                self.conform_class_exceed_rate = value
                                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-bytes"):
                                                                self.conform_class_violate_bytes = value
                                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-packets"):
                                                                self.conform_class_violate_packets = value
                                                                self.conform_class_violate_packets.value_namespace = name_space
                                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "conform-class-violate-rate"):
                                                                self.conform_class_violate_rate = value
                                                                self.conform_class_violate_rate.value_namespace = name_space
                                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-bytes"):
                                                                self.exceed_class_exceed_bytes = value
                                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-packets"):
                                                                self.exceed_class_exceed_packets = value
                                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-exceed-rate"):
                                                                self.exceed_class_exceed_rate = value
                                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-bytes"):
                                                                self.exceed_class_violate_bytes = value
                                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-packets"):
                                                                self.exceed_class_violate_packets = value
                                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "exceed-class-violate-rate"):
                                                                self.exceed_class_violate_rate = value
                                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-bytes"):
                                                                self.violate_class_violate_bytes = value
                                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-packets"):
                                                                self.violate_class_violate_packets = value
                                                                self.violate_class_violate_packets.value_namespace = name_space
                                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "violate-class-violate-rate"):
                                                                self.violate_class_violate_rate = value
                                                                self.violate_class_violate_rate.value_namespace = name_space
                                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.conform_bytes.is_set or
                                                            self.conform_packets.is_set or
                                                            self.conform_rate.is_set or
                                                            self.drop_bytes.is_set or
                                                            self.drop_packets.is_set or
                                                            self.exceed_bytes.is_set or
                                                            self.exceed_packets.is_set or
                                                            self.exceed_rate.is_set or
                                                            self.parent_drop_bytes.is_set or
                                                            self.parent_drop_packets.is_set or
                                                            self.violate_bytes.is_set or
                                                            self.violate_packets.is_set or
                                                            self.violate_rate.is_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.conform_bytes.yfilter != YFilter.not_set or
                                                            self.conform_packets.yfilter != YFilter.not_set or
                                                            self.conform_rate.yfilter != YFilter.not_set or
                                                            self.drop_bytes.yfilter != YFilter.not_set or
                                                            self.drop_packets.yfilter != YFilter.not_set or
                                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                                            self.exceed_packets.yfilter != YFilter.not_set or
                                                            self.exceed_rate.yfilter != YFilter.not_set or
                                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                                            self.violate_bytes.yfilter != YFilter.not_set or
                                                            self.violate_packets.yfilter != YFilter.not_set or
                                                            self.violate_rate.yfilter != YFilter.not_set or
                                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "color-class-stats"):
                                                            if (self.color_class_stats is None):
                                                                self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                                self.color_class_stats.parent = self
                                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                            return self.color_class_stats

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "conform-bytes"):
                                                            self.conform_bytes = value
                                                            self.conform_bytes.value_namespace = name_space
                                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-packets"):
                                                            self.conform_packets = value
                                                            self.conform_packets.value_namespace = name_space
                                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "conform-rate"):
                                                            self.conform_rate = value
                                                            self.conform_rate.value_namespace = name_space
                                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-bytes"):
                                                            self.drop_bytes = value
                                                            self.drop_bytes.value_namespace = name_space
                                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "drop-packets"):
                                                            self.drop_packets = value
                                                            self.drop_packets.value_namespace = name_space
                                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-bytes"):
                                                            self.exceed_bytes = value
                                                            self.exceed_bytes.value_namespace = name_space
                                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-packets"):
                                                            self.exceed_packets = value
                                                            self.exceed_packets.value_namespace = name_space
                                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exceed-rate"):
                                                            self.exceed_rate = value
                                                            self.exceed_rate.value_namespace = name_space
                                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-bytes"):
                                                            self.parent_drop_bytes = value
                                                            self.parent_drop_bytes.value_namespace = name_space
                                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "parent-drop-packets"):
                                                            self.parent_drop_packets = value
                                                            self.parent_drop_packets.value_namespace = name_space
                                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-bytes"):
                                                            self.violate_bytes = value
                                                            self.violate_bytes.value_namespace = name_space
                                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-packets"):
                                                            self.violate_packets = value
                                                            self.violate_packets.value_namespace = name_space
                                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "violate-rate"):
                                                            self.violate_rate = value
                                                            self.violate_rate.value_namespace = name_space
                                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                                class WredStatsArray(Entity):
                                                    """
                                                    array of red stats
                                                    
                                                    .. attribute:: max_threshold_bytes
                                                    
                                                    	Dropped bytes with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: max_threshold_packets
                                                    
                                                    	Dropped packets with  the average queue size at the max\-threshold
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: profile_title
                                                    
                                                    	ProfileTitle
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..300
                                                    
                                                    .. attribute:: random_drop_bytes
                                                    
                                                    	Probabilisticallydropped bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: random_drop_packets
                                                    
                                                    	Probabilistically dropped  packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_ecn_marked_bytes
                                                    
                                                    	ECN marked bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_ecn_marked_packets
                                                    
                                                    	ECN marked packets 
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: red_label
                                                    
                                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                                    
                                                    .. attribute:: red_transmit_bytes
                                                    
                                                    	Transmitted bytes
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    	**units**\: byte
                                                    
                                                    .. attribute:: red_transmit_packets
                                                    
                                                    	Transmitted packets
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'qos-ma-oper'
                                                    _revision = '2017-04-10'

                                                    def __init__(self):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                        self.yang_name = "wred-stats-array"
                                                        self.yang_parent_name = "class-stats"

                                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                        self.red_label = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("max_threshold_bytes",
                                                                        "max_threshold_packets",
                                                                        "profile_title",
                                                                        "random_drop_bytes",
                                                                        "random_drop_packets",
                                                                        "red_ecn_marked_bytes",
                                                                        "red_ecn_marked_packets",
                                                                        "red_transmit_bytes",
                                                                        "red_transmit_packets") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                                    class RedLabel(Entity):
                                                        """
                                                        Array of WRED Typevalues as in PRP stats is
                                                        available per threshold   
                                                        
                                                        .. attribute:: value
                                                        
                                                        	WRED value for this type
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: wred_type
                                                        
                                                        	WRED type DSCP, EXP, PREC etc
                                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'qos-ma-oper'
                                                        _revision = '2017-04-10'

                                                        def __init__(self):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                            self.yang_name = "red-label"
                                                            self.yang_parent_name = "wred-stats-array"

                                                            self.value = YLeaf(YType.uint8, "value")

                                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("value",
                                                                            "wred_type") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.value.is_set or
                                                                self.wred_type.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set or
                                                                self.wred_type.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "red-label" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())
                                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "value" or name == "wred-type"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "wred-type"):
                                                                self.wred_type = value
                                                                self.wred_type.value_namespace = name_space
                                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.red_label:
                                                            if (c.has_data()):
                                                                return True
                                                        return (
                                                            self.max_threshold_bytes.is_set or
                                                            self.max_threshold_packets.is_set or
                                                            self.profile_title.is_set or
                                                            self.random_drop_bytes.is_set or
                                                            self.random_drop_packets.is_set or
                                                            self.red_ecn_marked_bytes.is_set or
                                                            self.red_ecn_marked_packets.is_set or
                                                            self.red_transmit_bytes.is_set or
                                                            self.red_transmit_packets.is_set)

                                                    def has_operation(self):
                                                        for c in self.red_label:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                                            self.profile_title.yfilter != YFilter.not_set or
                                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "wred-stats-array" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "red-label"):
                                                            for c in self.red_label:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.red_label.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "max-threshold-bytes"):
                                                            self.max_threshold_bytes = value
                                                            self.max_threshold_bytes.value_namespace = name_space
                                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "max-threshold-packets"):
                                                            self.max_threshold_packets = value
                                                            self.max_threshold_packets.value_namespace = name_space
                                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "profile-title"):
                                                            self.profile_title = value
                                                            self.profile_title.value_namespace = name_space
                                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-bytes"):
                                                            self.random_drop_bytes = value
                                                            self.random_drop_bytes.value_namespace = name_space
                                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "random-drop-packets"):
                                                            self.random_drop_packets = value
                                                            self.random_drop_packets.value_namespace = name_space
                                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-bytes"):
                                                            self.red_ecn_marked_bytes = value
                                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-ecn-marked-packets"):
                                                            self.red_ecn_marked_packets = value
                                                            self.red_ecn_marked_packets.value_namespace = name_space
                                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-bytes"):
                                                            self.red_transmit_bytes = value
                                                            self.red_transmit_bytes.value_namespace = name_space
                                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "red-transmit-packets"):
                                                            self.red_transmit_packets = value
                                                            self.red_transmit_packets.value_namespace = name_space
                                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.cac_state.is_set or
                                                        self.class_name.is_set or
                                                        self.counter_validity_bitmask.is_set or
                                                        self.queue_descr.is_set or
                                                        self.shared_queue_id.is_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                                def has_operation(self):
                                                    for c in self.police_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.queue_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.wred_stats_array:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.cac_state.yfilter != YFilter.not_set or
                                                        self.class_name.yfilter != YFilter.not_set or
                                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                        self.queue_descr.yfilter != YFilter.not_set or
                                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cac-stats"):
                                                        if (self.cac_stats is None):
                                                            self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                            self.cac_stats.parent = self
                                                            self._children_name_map["cac_stats"] = "cac-stats"
                                                        return self.cac_stats

                                                    if (child_yang_name == "general-stats"):
                                                        if (self.general_stats is None):
                                                            self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                            self.general_stats.parent = self
                                                            self._children_name_map["general_stats"] = "general-stats"
                                                        return self.general_stats

                                                    if (child_yang_name == "iphc-stats"):
                                                        if (self.iphc_stats is None):
                                                            self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                            self.iphc_stats.parent = self
                                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                                        return self.iphc_stats

                                                    if (child_yang_name == "police-stats-array"):
                                                        for c in self.police_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.police_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "queue-stats-array"):
                                                        for c in self.queue_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.queue_stats_array.append(c)
                                                        return c

                                                    if (child_yang_name == "wred-stats-array"):
                                                        for c in self.wred_stats_array:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.wred_stats_array.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "cac-state"):
                                                        self.cac_state = value
                                                        self.cac_state.value_namespace = name_space
                                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "class-name"):
                                                        self.class_name = value
                                                        self.class_name.value_namespace = name_space
                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "counter-validity-bitmask"):
                                                        self.counter_validity_bitmask = value
                                                        self.counter_validity_bitmask.value_namespace = name_space
                                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-descr"):
                                                        self.queue_descr = value
                                                        self.queue_descr.value_namespace = name_space
                                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "shared-queue-id"):
                                                        self.shared_queue_id = value
                                                        self.shared_queue_id.value_namespace = name_space
                                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.class_stats:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.policy_name.is_set or
                                                    self.satid.is_set or
                                                    self.state.is_set or
                                                    self.state_description.is_set)

                                            def has_operation(self):
                                                for c in self.class_stats:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    self.satid.yfilter != YFilter.not_set or
                                                    self.state.yfilter != YFilter.not_set or
                                                    self.state_description.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "child-policy" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state.get_name_leafdata())
                                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "class-stats"):
                                                    for c in self.class_stats:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.class_stats.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "satid"):
                                                    self.satid = value
                                                    self.satid.value_namespace = name_space
                                                    self.satid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state"):
                                                    self.state = value
                                                    self.state.value_namespace = name_space
                                                    self.state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "state-description"):
                                                    self.state_description = value
                                                    self.state_description.value_namespace = name_space
                                                    self.state_description.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.child_policy is not None and self.child_policy.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.child_policy is not None and self.child_policy.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "child-policy"):
                                                if (self.child_policy is None):
                                                    self.child_policy = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                                    self.child_policy.parent = self
                                                    self._children_name_map["child_policy"] = "child-policy"
                                                return self.child_policy

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "statistics" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                        (self.statistics is not None and self.statistics.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                        (self.statistics is not None and self.statistics.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "output" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "service-policy-names"):
                                        if (self.service_policy_names is None):
                                            self.service_policy_names = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                            self.service_policy_names.parent = self
                                            self._children_name_map["service_policy_names"] = "service-policy-names"
                                        return self.service_policy_names

                                    if (child_yang_name == "statistics"):
                                        if (self.statistics is None):
                                            self.statistics = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                        return self.statistics

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-names" or name == "statistics"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.nv_satellite_id.is_set or
                                    (self.input is not None and self.input.has_data()) or
                                    (self.output is not None and self.output.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nv_satellite_id.yfilter != YFilter.not_set or
                                    (self.input is not None and self.input.has_operation()) or
                                    (self.output is not None and self.output.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "satellite-id" + "[nv-satellite-id='" + self.nv_satellite_id.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nv_satellite_id.is_set or self.nv_satellite_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nv_satellite_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "input"):
                                    if (self.input is None):
                                        self.input = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Input()
                                        self.input.parent = self
                                        self._children_name_map["input"] = "input"
                                    return self.input

                                if (child_yang_name == "output"):
                                    if (self.output is None):
                                        self.output = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId.Output()
                                        self.output.parent = self
                                        self._children_name_map["output"] = "output"
                                    return self.output

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "input" or name == "output" or name == "nv-satellite-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nv-satellite-id"):
                                    self.nv_satellite_id = value
                                    self.nv_satellite_id.value_namespace = name_space
                                    self.nv_satellite_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.satellite_id:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.satellite_id:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "satellite-ids" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "satellite-id"):
                                for c in self.satellite_id:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds.SatelliteId()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.satellite_id.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "satellite-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Input(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames>`
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "member-interface"

                            self.service_policy_names = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._children_yang_names.add("service-policy-names")

                            self.statistics = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "input"

                                self.service_policy_instance = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames, self).__setattr__(name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  <key>
                                
                                	Name of the policy instance
                                	**type**\:  str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"

                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("service_policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.service_policy_name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.service_policy_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "service-policy-name"):
                                        self.service_policy_name = value
                                        self.service_policy_name.value_namespace = name_space
                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.service_policy_instance:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.service_policy_instance:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "service-policy-names" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-instance"):
                                    for c in self.service_policy_instance:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames.ServicePolicyInstance()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.service_policy_instance.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-instance"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "input"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.child_policy = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                    self._children_yang_names.add("child-policy")

                                    self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "child-policy" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "child-policy"):
                                        if (self.child_policy is None):
                                            self.child_policy = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                        return self.child_policy

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "input" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "service-policy-names"):
                                if (self.service_policy_names is None):
                                    self.service_policy_names = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                return self.service_policy_names

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-names" or name == "statistics"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Output(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames>`
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "member-interface"

                            self.service_policy_names = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._children_yang_names.add("service-policy-names")

                            self.statistics = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "output"

                                self.service_policy_instance = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames, self).__setattr__(name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  <key>
                                
                                	Name of the policy instance
                                	**type**\:  str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"

                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("service_policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.service_policy_name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.service_policy_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "service-policy-name"):
                                        self.service_policy_name = value
                                        self.service_policy_name.value_namespace = name_space
                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.service_policy_instance:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.service_policy_instance:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "service-policy-names" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-instance"):
                                    for c in self.service_policy_instance:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames.ServicePolicyInstance()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.service_policy_instance.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-instance"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "output"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.child_policy = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                    self._children_yang_names.add("child-policy")

                                    self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "child-policy" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "child-policy"):
                                        if (self.child_policy is None):
                                            self.child_policy = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                        return self.child_policy

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "output" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "service-policy-names"):
                                if (self.service_policy_names is None):
                                    self.service_policy_names = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                return self.service_policy_names

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-names" or name == "statistics"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.interface_name.is_set or
                            (self.input is not None and self.input.has_data()) or
                            (self.output is not None and self.output.has_data()) or
                            (self.satellite_ids is not None and self.satellite_ids.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.interface_name.yfilter != YFilter.not_set or
                            (self.input is not None and self.input.has_operation()) or
                            (self.output is not None and self.output.has_operation()) or
                            (self.satellite_ids is not None and self.satellite_ids.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "member-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "input"):
                            if (self.input is None):
                                self.input = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"
                            return self.input

                        if (child_yang_name == "output"):
                            if (self.output is None):
                                self.output = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                            return self.output

                        if (child_yang_name == "satellite-ids"):
                            if (self.satellite_ids is None):
                                self.satellite_ids = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface.SatelliteIds()
                                self.satellite_ids.parent = self
                                self._children_name_map["satellite_ids"] = "satellite-ids"
                            return self.satellite_ids

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "input" or name == "output" or name == "satellite-ids" or name == "interface-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "interface-name"):
                            self.interface_name = value
                            self.interface_name.value_namespace = name_space
                            self.interface_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.member_interface:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.member_interface:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "member-interfaces" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "member-interface"):
                        for c in self.member_interface:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Qos.InterfaceTable.Interface.MemberInterfaces.MemberInterface()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.member_interface.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "member-interface"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class SatelliteIds(Entity):
                """
                Satellite ID information
                
                .. attribute:: satellite_id
                
                	Satellite ID information
                	**type**\: list of    :py:class:`SatelliteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.InterfaceTable.Interface.SatelliteIds, self).__init__()

                    self.yang_name = "satellite-ids"
                    self.yang_parent_name = "interface"

                    self.satellite_id = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(Qos.InterfaceTable.Interface.SatelliteIds, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(Qos.InterfaceTable.Interface.SatelliteIds, self).__setattr__(name, value)


                class SatelliteId(Entity):
                    """
                    Satellite ID information
                    
                    .. attribute:: nv_satellite_id  <key>
                    
                    	Satellite ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: input
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input>`
                    
                    .. attribute:: output
                    
                    	A piece of QoS policy\-map operational data for an interface
                    	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId, self).__init__()

                        self.yang_name = "satellite-id"
                        self.yang_parent_name = "satellite-ids"

                        self.nv_satellite_id = YLeaf(YType.int32, "nv-satellite-id")

                        self.input = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"
                        self._children_yang_names.add("input")

                        self.output = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._children_yang_names.add("output")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("nv_satellite_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId, self).__setattr__(name, value)


                    class Input(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames>`
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "satellite-id"

                            self.service_policy_names = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._children_yang_names.add("service-policy-names")

                            self.statistics = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "input"

                                self.service_policy_instance = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames, self).__setattr__(name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  <key>
                                
                                	Name of the policy instance
                                	**type**\:  str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"

                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("service_policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.service_policy_name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.service_policy_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "service-policy-name"):
                                        self.service_policy_name = value
                                        self.service_policy_name.value_namespace = name_space
                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.service_policy_instance:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.service_policy_instance:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "service-policy-names" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-instance"):
                                    for c in self.service_policy_instance:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames.ServicePolicyInstance()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.service_policy_instance.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-instance"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "input"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.child_policy = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                    self._children_yang_names.add("child-policy")

                                    self.general_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.general_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "child-policy" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "child-policy"):
                                        if (self.child_policy is None):
                                            self.child_policy = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                        return self.child_policy

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "input" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "service-policy-names"):
                                if (self.service_policy_names is None):
                                    self.service_policy_names = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                return self.service_policy_names

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-names" or name == "statistics"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Output(Entity):
                        """
                        A piece of QoS policy\-map operational data for
                        an interface
                        
                        .. attribute:: service_policy_names
                        
                        	Operational data for all Policy instance
                        	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames>`
                        
                        .. attribute:: statistics
                        
                        	Policy\-map statistics operational data for an interface
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "satellite-id"

                            self.service_policy_names = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                            self._children_yang_names.add("service-policy-names")

                            self.statistics = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")


                        class ServicePolicyNames(Entity):
                            """
                            Operational data for all Policy instance
                            
                            .. attribute:: service_policy_instance
                            
                            	QoS policy\-map operational data for a particular Policy 
                            	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance>`
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__init__()

                                self.yang_name = "service-policy-names"
                                self.yang_parent_name = "output"

                                self.service_policy_instance = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames, self).__setattr__(name, value)


                            class ServicePolicyInstance(Entity):
                                """
                                QoS policy\-map operational data for a
                                particular Policy 
                                
                                .. attribute:: service_policy_name  <key>
                                
                                	Name of the policy instance
                                	**type**\:  str
                                
                                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                                    self.yang_name = "service-policy-instance"
                                    self.yang_parent_name = "service-policy-names"

                                    self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("service_policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.service_policy_name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.service_policy_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "service-policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "service-policy-name"):
                                        self.service_policy_name = value
                                        self.service_policy_name.value_namespace = name_space
                                        self.service_policy_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.service_policy_instance:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.service_policy_instance:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "service-policy-names" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "service-policy-instance"):
                                    for c in self.service_policy_instance:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames.ServicePolicyInstance()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.service_policy_instance.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "service-policy-instance"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Statistics(Entity):
                            """
                            Policy\-map statistics operational data for an
                            interface
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "output"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats>`
                                
                                .. attribute:: child_policy
                                
                                	child policy
                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "statistics"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.child_policy = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                    self._children_yang_names.add("child-policy")

                                    self.general_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class ChildPolicy(Entity):
                                    """
                                    child policy
                                    
                                    .. attribute:: class_stats
                                    
                                    	array of classes contained in policy
                                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	PolicyName
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: satid
                                    
                                    	to maintain satellite id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                                    
                                    .. attribute:: state_description
                                    
                                    	StateDescription
                                    	**type**\:  str
                                    
                                    	**length:** 0..128
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                        self.yang_name = "child-policy"
                                        self.yang_parent_name = "class-stats"

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.satid = YLeaf(YType.uint32, "satid")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.state_description = YLeaf(YType.str, "state-description")

                                        self.class_stats = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("policy_name",
                                                        "satid",
                                                        "state",
                                                        "state_description") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                                    class ClassStats(Entity):
                                        """
                                        array of classes contained in policy
                                        
                                        .. attribute:: cac_state
                                        
                                        	CACState
                                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                        
                                        .. attribute:: cac_stats
                                        
                                        	bag for cac stats
                                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                        
                                        .. attribute:: class_name
                                        
                                        	ClassName
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: counter_validity_bitmask
                                        
                                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: megabyte
                                        
                                        .. attribute:: general_stats
                                        
                                        	general stats
                                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                        
                                        .. attribute:: iphc_stats
                                        
                                        	IPHC stats
                                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                        
                                        .. attribute:: police_stats_array
                                        
                                        	array of police stats
                                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                        
                                        .. attribute:: queue_descr
                                        
                                        	Description of queue for the class
                                        	**type**\:  str
                                        
                                        	**length:** 0..256
                                        
                                        .. attribute:: queue_stats_array
                                        
                                        	array of queue stats
                                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                        
                                        .. attribute:: shared_queue_id
                                        
                                        	q\-id of the  shared queue for this class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wred_stats_array
                                        
                                        	array of red stats
                                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                            self.yang_name = "class-stats"
                                            self.yang_parent_name = "child-policy"

                                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                            self.cac_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                            self._children_yang_names.add("cac-stats")

                                            self.general_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                            self._children_yang_names.add("general-stats")

                                            self.iphc_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                            self._children_yang_names.add("iphc-stats")

                                            self.police_stats_array = YList(self)
                                            self.queue_stats_array = YList(self)
                                            self.wred_stats_array = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cac_state",
                                                            "class_name",
                                                            "counter_validity_bitmask",
                                                            "queue_descr",
                                                            "shared_queue_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                        class GeneralStats(Entity):
                                            """
                                            general stats
                                            
                                            .. attribute:: match_data_rate
                                            
                                            	Incoming matched data rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: pre_policy_matched_bytes
                                            
                                            	Matched bytes before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: pre_policy_matched_packets
                                            
                                            	Matched pkts before applying policy
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: total_drop_bytes
                                            
                                            	Dropped bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_packets
                                            
                                            	Dropped packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_drop_rate
                                            
                                            	Total drop rate (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: total_transmit_rate
                                            
                                            	Total transmit rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: transmit_bytes
                                            
                                            	Transmitted bytes (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: transmit_packets
                                            
                                            	Transmitted packets (packets/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                                self.yang_name = "general-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match_data_rate",
                                                                "pre_policy_matched_bytes",
                                                                "pre_policy_matched_packets",
                                                                "total_drop_bytes",
                                                                "total_drop_packets",
                                                                "total_drop_rate",
                                                                "total_transmit_rate",
                                                                "transmit_bytes",
                                                                "transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.match_data_rate.is_set or
                                                    self.pre_policy_matched_bytes.is_set or
                                                    self.pre_policy_matched_packets.is_set or
                                                    self.total_drop_bytes.is_set or
                                                    self.total_drop_packets.is_set or
                                                    self.total_drop_rate.is_set or
                                                    self.total_transmit_rate.is_set or
                                                    self.transmit_bytes.is_set or
                                                    self.transmit_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match_data_rate.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                                    self.transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "general-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match-data-rate"):
                                                    self.match_data_rate = value
                                                    self.match_data_rate.value_namespace = name_space
                                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-bytes"):
                                                    self.pre_policy_matched_bytes = value
                                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "pre-policy-matched-packets"):
                                                    self.pre_policy_matched_packets = value
                                                    self.pre_policy_matched_packets.value_namespace = name_space
                                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-bytes"):
                                                    self.total_drop_bytes = value
                                                    self.total_drop_bytes.value_namespace = name_space
                                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-packets"):
                                                    self.total_drop_packets = value
                                                    self.total_drop_packets.value_namespace = name_space
                                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-drop-rate"):
                                                    self.total_drop_rate = value
                                                    self.total_drop_rate.value_namespace = name_space
                                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "total-transmit-rate"):
                                                    self.total_transmit_rate = value
                                                    self.total_transmit_rate.value_namespace = name_space
                                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-bytes"):
                                                    self.transmit_bytes = value
                                                    self.transmit_bytes.value_namespace = name_space
                                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "transmit-packets"):
                                                    self.transmit_packets = value
                                                    self.transmit_packets.value_namespace = name_space
                                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                                        class IphcStats(Entity):
                                            """
                                            IPHC stats
                                            
                                            .. attribute:: non_tcp_bytes_saved
                                            
                                            	Non Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_bytes_sent_rate
                                            
                                            	Compressed Non Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_compressed_packets_out
                                            
                                            	Num of non tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_full_header_packets_out
                                            
                                            	Num of non tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: non_tcp_total_out_bytes
                                            
                                            	TotalNum of Non Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: non_tcp_total_out_packets
                                            
                                            	TotalNum of Non tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_bytes_saved
                                            
                                            	Tcp Bytes saved due to compression
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_bytes_sent_rate
                                            
                                            	Compressed Tcp Bytes sent rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_compressed_packets_out
                                            
                                            	Num of tcp compressed pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_full_header_packets_out
                                            
                                            	Num of tcp fullheader pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tcp_total_out_bytes
                                            
                                            	TotalNum of Tcp Bytes sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tcp_total_out_packets
                                            
                                            	Total Num of tcp pkts sent
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                                self.yang_name = "iphc-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("non_tcp_bytes_saved",
                                                                "non_tcp_bytes_sent_rate",
                                                                "non_tcp_compressed_packets_out",
                                                                "non_tcp_full_header_packets_out",
                                                                "non_tcp_total_out_bytes",
                                                                "non_tcp_total_out_packets",
                                                                "tcp_bytes_saved",
                                                                "tcp_bytes_sent_rate",
                                                                "tcp_compressed_packets_out",
                                                                "tcp_full_header_packets_out",
                                                                "tcp_total_out_bytes",
                                                                "tcp_total_out_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.non_tcp_bytes_saved.is_set or
                                                    self.non_tcp_bytes_sent_rate.is_set or
                                                    self.non_tcp_compressed_packets_out.is_set or
                                                    self.non_tcp_full_header_packets_out.is_set or
                                                    self.non_tcp_total_out_bytes.is_set or
                                                    self.non_tcp_total_out_packets.is_set or
                                                    self.tcp_bytes_saved.is_set or
                                                    self.tcp_bytes_sent_rate.is_set or
                                                    self.tcp_compressed_packets_out.is_set or
                                                    self.tcp_full_header_packets_out.is_set or
                                                    self.tcp_total_out_bytes.is_set or
                                                    self.tcp_total_out_packets.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "iphc-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "non-tcp-bytes-saved"):
                                                    self.non_tcp_bytes_saved = value
                                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-bytes-sent-rate"):
                                                    self.non_tcp_bytes_sent_rate = value
                                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-compressed-packets-out"):
                                                    self.non_tcp_compressed_packets_out = value
                                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-full-header-packets-out"):
                                                    self.non_tcp_full_header_packets_out = value
                                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-bytes"):
                                                    self.non_tcp_total_out_bytes = value
                                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "non-tcp-total-out-packets"):
                                                    self.non_tcp_total_out_packets = value
                                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-saved"):
                                                    self.tcp_bytes_saved = value
                                                    self.tcp_bytes_saved.value_namespace = name_space
                                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-bytes-sent-rate"):
                                                    self.tcp_bytes_sent_rate = value
                                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-compressed-packets-out"):
                                                    self.tcp_compressed_packets_out = value
                                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-full-header-packets-out"):
                                                    self.tcp_full_header_packets_out = value
                                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-bytes"):
                                                    self.tcp_total_out_bytes = value
                                                    self.tcp_total_out_bytes.value_namespace = name_space
                                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tcp-total-out-packets"):
                                                    self.tcp_total_out_packets = value
                                                    self.tcp_total_out_packets.value_namespace = name_space
                                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                        class CacStats(Entity):
                                            """
                                            bag for cac stats
                                            
                                            .. attribute:: admit_bytes
                                            
                                            	Admitted bytes (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: admit_rates
                                            
                                            	CAC admit rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: admitpackets
                                            
                                            	Admitted packets (pkts/bytes)
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	CAC dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	CAC dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: drop_rates
                                            
                                            	CAC dropped rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                                self.yang_name = "cac-stats"
                                                self.yang_parent_name = "class-stats"

                                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("admit_bytes",
                                                                "admit_rates",
                                                                "admitpackets",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "drop_rates") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.admit_bytes.is_set or
                                                    self.admit_rates.is_set or
                                                    self.admitpackets.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.drop_rates.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.admit_bytes.yfilter != YFilter.not_set or
                                                    self.admit_rates.yfilter != YFilter.not_set or
                                                    self.admitpackets.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.drop_rates.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cac-stats" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "admit-bytes"):
                                                    self.admit_bytes = value
                                                    self.admit_bytes.value_namespace = name_space
                                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admit-rates"):
                                                    self.admit_rates = value
                                                    self.admit_rates.value_namespace = name_space
                                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                                if(value_path == "admitpackets"):
                                                    self.admitpackets = value
                                                    self.admitpackets.value_namespace = name_space
                                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-rates"):
                                                    self.drop_rates = value
                                                    self.drop_rates.value_namespace = name_space
                                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                                        class QueueStatsArray(Entity):
                                            """
                                            array of queue stats
                                            
                                            .. attribute:: atm_clp0_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp0_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: atm_clp1_drop_bytes
                                            
                                            	ATP CLP 0 matched bytes dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: atm_clp1_drop_packets
                                            
                                            	ATP CLP 0 matched packets dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the queue rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forced_wred_stats_display
                                            
                                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                            	**type**\:  bool
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: queue_average_length
                                            
                                            	Queue average length
                                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                            
                                            .. attribute:: queue_drop_threshold
                                            
                                            	tail drop threshold of the queue in bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: queue_id
                                            
                                            	Queue Id used for Fabric Stats
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: queue_instance_length
                                            
                                            	Queue instance length
                                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                            
                                            .. attribute:: queue_max_length
                                            
                                            	Queue maximum length
                                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Bytes probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Packets probabilistically dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: tail_drop_bytes
                                            
                                            	Bytes tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: tail_drop_packets
                                            
                                            	Packets tail dropped
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                                self.yang_name = "queue-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                                self.queue_average_length = YList(self)
                                                self.queue_instance_length = YList(self)
                                                self.queue_max_length = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("atm_clp0_drop_bytes",
                                                                "atm_clp0_drop_packets",
                                                                "atm_clp1_drop_bytes",
                                                                "atm_clp1_drop_packets",
                                                                "conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "forced_wred_stats_display",
                                                                "max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "queue_drop_threshold",
                                                                "queue_id",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "tail_drop_bytes",
                                                                "tail_drop_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                            class QueueInstanceLength(Entity):
                                                """
                                                Queue instance length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                                    self.yang_name = "queue-instance-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-instance-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueAverageLength(Entity):
                                                """
                                                Queue average length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                                    self.yang_name = "queue-average-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-average-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class QueueMaxLength(Entity):
                                                """
                                                Queue maximum length
                                                
                                                .. attribute:: unit
                                                
                                                	unit
                                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                                    self.yang_name = "queue-max-length"
                                                    self.yang_parent_name = "queue-stats-array"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-max-length" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.atm_clp0_drop_bytes.is_set or
                                                    self.atm_clp0_drop_packets.is_set or
                                                    self.atm_clp1_drop_bytes.is_set or
                                                    self.atm_clp1_drop_packets.is_set or
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.forced_wred_stats_display.is_set or
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.queue_drop_threshold.is_set or
                                                    self.queue_id.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.tail_drop_bytes.is_set or
                                                    self.tail_drop_packets.is_set)

                                            def has_operation(self):
                                                for c in self.queue_average_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_instance_length:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.queue_max_length:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                                    self.queue_id.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "queue-average-length"):
                                                    for c in self.queue_average_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_average_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-instance-length"):
                                                    for c in self.queue_instance_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_instance_length.append(c)
                                                    return c

                                                if (child_yang_name == "queue-max-length"):
                                                    for c in self.queue_max_length:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.queue_max_length.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "atm-clp0-drop-bytes"):
                                                    self.atm_clp0_drop_bytes = value
                                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp0-drop-packets"):
                                                    self.atm_clp0_drop_packets = value
                                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-bytes"):
                                                    self.atm_clp1_drop_bytes = value
                                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "atm-clp1-drop-packets"):
                                                    self.atm_clp1_drop_packets = value
                                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forced-wred-stats-display"):
                                                    self.forced_wred_stats_display = value
                                                    self.forced_wred_stats_display.value_namespace = name_space
                                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-drop-threshold"):
                                                    self.queue_drop_threshold = value
                                                    self.queue_drop_threshold.value_namespace = name_space
                                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                                if(value_path == "queue-id"):
                                                    self.queue_id = value
                                                    self.queue_id.value_namespace = name_space
                                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-bytes"):
                                                    self.tail_drop_bytes = value
                                                    self.tail_drop_bytes.value_namespace = name_space
                                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tail-drop-packets"):
                                                    self.tail_drop_packets = value
                                                    self.tail_drop_packets.value_namespace = name_space
                                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                        class PoliceStatsArray(Entity):
                                            """
                                            array of police stats
                                            
                                            .. attribute:: color_class_stats
                                            
                                            	color class stats
                                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                            
                                            .. attribute:: conform_bytes
                                            
                                            	Bytes that conform to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: conform_packets
                                            
                                            	Packets that conform  to the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: conform_rate
                                            
                                            	Conform rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: drop_bytes
                                            
                                            	Police dropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: drop_packets
                                            
                                            	Police dropped packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_bytes
                                            
                                            	Bytes that exceed  the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: exceed_packets
                                            
                                            	Packets that exceed the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: exceed_rate
                                            
                                            	Exceed rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            .. attribute:: parent_drop_bytes
                                            
                                            	Dropped bytes by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: parent_drop_packets
                                            
                                            	Dropped pkts by the parent policer
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_bytes
                                            
                                            	Bytes that violate the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: violate_packets
                                            
                                            	Packets violating the policed rate
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: violate_rate
                                            
                                            	Violate rate in kbps
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: kbit/s
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                                self.yang_name = "police-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                                self.color_class_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                                self._children_yang_names.add("color-class-stats")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("conform_bytes",
                                                                "conform_packets",
                                                                "conform_rate",
                                                                "drop_bytes",
                                                                "drop_packets",
                                                                "exceed_bytes",
                                                                "exceed_packets",
                                                                "exceed_rate",
                                                                "parent_drop_bytes",
                                                                "parent_drop_packets",
                                                                "violate_bytes",
                                                                "violate_packets",
                                                                "violate_rate") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                            class ColorClassStats(Entity):
                                                """
                                                color class stats
                                                
                                                .. attribute:: conform_class_conform_bytes
                                                
                                                	Bytes with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_conform_packets
                                                
                                                	Packets with classification result conform and policer result conform
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_conform_rate
                                                
                                                	Conform Class Conform rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_exceed_bytes
                                                
                                                	Bytes with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_exceed_packets
                                                
                                                	Packets with classification result conform and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_exceed_rate
                                                
                                                	Conform Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: conform_class_violate_bytes
                                                
                                                	Bytes with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: conform_class_violate_packets
                                                
                                                	Packets with classification result conform and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: conform_class_violate_rate
                                                
                                                	Conform Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_exceed_bytes
                                                
                                                	Bytes with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_exceed_packets
                                                
                                                	Packets with classification result exceed and policer result exceed
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_exceed_rate
                                                
                                                	Exceed Class Exceed rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: exceed_class_violate_bytes
                                                
                                                	Bytes with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: exceed_class_violate_packets
                                                
                                                	Packets with classification result exceed and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: exceed_class_violate_rate
                                                
                                                	Exceed Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                .. attribute:: violate_class_violate_bytes
                                                
                                                	Bytes with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                	**units**\: byte
                                                
                                                .. attribute:: violate_class_violate_packets
                                                
                                                	Packets with classification result violate and policer result violate
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: violate_class_violate_rate
                                                
                                                	Violate Class Violate rate in kbps
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                	**units**\: kbit/s
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                                    self.yang_name = "color-class-stats"
                                                    self.yang_parent_name = "police-stats-array"

                                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("conform_class_conform_bytes",
                                                                    "conform_class_conform_packets",
                                                                    "conform_class_conform_rate",
                                                                    "conform_class_exceed_bytes",
                                                                    "conform_class_exceed_packets",
                                                                    "conform_class_exceed_rate",
                                                                    "conform_class_violate_bytes",
                                                                    "conform_class_violate_packets",
                                                                    "conform_class_violate_rate",
                                                                    "exceed_class_exceed_bytes",
                                                                    "exceed_class_exceed_packets",
                                                                    "exceed_class_exceed_rate",
                                                                    "exceed_class_violate_bytes",
                                                                    "exceed_class_violate_packets",
                                                                    "exceed_class_violate_rate",
                                                                    "violate_class_violate_bytes",
                                                                    "violate_class_violate_packets",
                                                                    "violate_class_violate_rate") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.conform_class_conform_bytes.is_set or
                                                        self.conform_class_conform_packets.is_set or
                                                        self.conform_class_conform_rate.is_set or
                                                        self.conform_class_exceed_bytes.is_set or
                                                        self.conform_class_exceed_packets.is_set or
                                                        self.conform_class_exceed_rate.is_set or
                                                        self.conform_class_violate_bytes.is_set or
                                                        self.conform_class_violate_packets.is_set or
                                                        self.conform_class_violate_rate.is_set or
                                                        self.exceed_class_exceed_bytes.is_set or
                                                        self.exceed_class_exceed_packets.is_set or
                                                        self.exceed_class_exceed_rate.is_set or
                                                        self.exceed_class_violate_bytes.is_set or
                                                        self.exceed_class_violate_packets.is_set or
                                                        self.exceed_class_violate_rate.is_set or
                                                        self.violate_class_violate_bytes.is_set or
                                                        self.violate_class_violate_packets.is_set or
                                                        self.violate_class_violate_rate.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "color-class-stats" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "conform-class-conform-bytes"):
                                                        self.conform_class_conform_bytes = value
                                                        self.conform_class_conform_bytes.value_namespace = name_space
                                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-packets"):
                                                        self.conform_class_conform_packets = value
                                                        self.conform_class_conform_packets.value_namespace = name_space
                                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-conform-rate"):
                                                        self.conform_class_conform_rate = value
                                                        self.conform_class_conform_rate.value_namespace = name_space
                                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-bytes"):
                                                        self.conform_class_exceed_bytes = value
                                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-packets"):
                                                        self.conform_class_exceed_packets = value
                                                        self.conform_class_exceed_packets.value_namespace = name_space
                                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-exceed-rate"):
                                                        self.conform_class_exceed_rate = value
                                                        self.conform_class_exceed_rate.value_namespace = name_space
                                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-bytes"):
                                                        self.conform_class_violate_bytes = value
                                                        self.conform_class_violate_bytes.value_namespace = name_space
                                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-packets"):
                                                        self.conform_class_violate_packets = value
                                                        self.conform_class_violate_packets.value_namespace = name_space
                                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "conform-class-violate-rate"):
                                                        self.conform_class_violate_rate = value
                                                        self.conform_class_violate_rate.value_namespace = name_space
                                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-bytes"):
                                                        self.exceed_class_exceed_bytes = value
                                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-packets"):
                                                        self.exceed_class_exceed_packets = value
                                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-exceed-rate"):
                                                        self.exceed_class_exceed_rate = value
                                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-bytes"):
                                                        self.exceed_class_violate_bytes = value
                                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-packets"):
                                                        self.exceed_class_violate_packets = value
                                                        self.exceed_class_violate_packets.value_namespace = name_space
                                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exceed-class-violate-rate"):
                                                        self.exceed_class_violate_rate = value
                                                        self.exceed_class_violate_rate.value_namespace = name_space
                                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-bytes"):
                                                        self.violate_class_violate_bytes = value
                                                        self.violate_class_violate_bytes.value_namespace = name_space
                                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-packets"):
                                                        self.violate_class_violate_packets = value
                                                        self.violate_class_violate_packets.value_namespace = name_space
                                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "violate-class-violate-rate"):
                                                        self.violate_class_violate_rate = value
                                                        self.violate_class_violate_rate.value_namespace = name_space
                                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.conform_bytes.is_set or
                                                    self.conform_packets.is_set or
                                                    self.conform_rate.is_set or
                                                    self.drop_bytes.is_set or
                                                    self.drop_packets.is_set or
                                                    self.exceed_bytes.is_set or
                                                    self.exceed_packets.is_set or
                                                    self.exceed_rate.is_set or
                                                    self.parent_drop_bytes.is_set or
                                                    self.parent_drop_packets.is_set or
                                                    self.violate_bytes.is_set or
                                                    self.violate_packets.is_set or
                                                    self.violate_rate.is_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.conform_bytes.yfilter != YFilter.not_set or
                                                    self.conform_packets.yfilter != YFilter.not_set or
                                                    self.conform_rate.yfilter != YFilter.not_set or
                                                    self.drop_bytes.yfilter != YFilter.not_set or
                                                    self.drop_packets.yfilter != YFilter.not_set or
                                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                                    self.exceed_packets.yfilter != YFilter.not_set or
                                                    self.exceed_rate.yfilter != YFilter.not_set or
                                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                                    self.violate_bytes.yfilter != YFilter.not_set or
                                                    self.violate_packets.yfilter != YFilter.not_set or
                                                    self.violate_rate.yfilter != YFilter.not_set or
                                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "color-class-stats"):
                                                    if (self.color_class_stats is None):
                                                        self.color_class_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                        self.color_class_stats.parent = self
                                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                                    return self.color_class_stats

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "conform-bytes"):
                                                    self.conform_bytes = value
                                                    self.conform_bytes.value_namespace = name_space
                                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-packets"):
                                                    self.conform_packets = value
                                                    self.conform_packets.value_namespace = name_space
                                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "conform-rate"):
                                                    self.conform_rate = value
                                                    self.conform_rate.value_namespace = name_space
                                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-bytes"):
                                                    self.drop_bytes = value
                                                    self.drop_bytes.value_namespace = name_space
                                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "drop-packets"):
                                                    self.drop_packets = value
                                                    self.drop_packets.value_namespace = name_space
                                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-bytes"):
                                                    self.exceed_bytes = value
                                                    self.exceed_bytes.value_namespace = name_space
                                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-packets"):
                                                    self.exceed_packets = value
                                                    self.exceed_packets.value_namespace = name_space
                                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exceed-rate"):
                                                    self.exceed_rate = value
                                                    self.exceed_rate.value_namespace = name_space
                                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-bytes"):
                                                    self.parent_drop_bytes = value
                                                    self.parent_drop_bytes.value_namespace = name_space
                                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-drop-packets"):
                                                    self.parent_drop_packets = value
                                                    self.parent_drop_packets.value_namespace = name_space
                                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-bytes"):
                                                    self.violate_bytes = value
                                                    self.violate_bytes.value_namespace = name_space
                                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-packets"):
                                                    self.violate_packets = value
                                                    self.violate_packets.value_namespace = name_space
                                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "violate-rate"):
                                                    self.violate_rate = value
                                                    self.violate_rate.value_namespace = name_space
                                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                                        class WredStatsArray(Entity):
                                            """
                                            array of red stats
                                            
                                            .. attribute:: max_threshold_bytes
                                            
                                            	Dropped bytes with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: max_threshold_packets
                                            
                                            	Dropped packets with  the average queue size at the max\-threshold
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: profile_title
                                            
                                            	ProfileTitle
                                            	**type**\:  str
                                            
                                            	**length:** 0..300
                                            
                                            .. attribute:: random_drop_bytes
                                            
                                            	Probabilisticallydropped bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: random_drop_packets
                                            
                                            	Probabilistically dropped  packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_ecn_marked_bytes
                                            
                                            	ECN marked bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_ecn_marked_packets
                                            
                                            	ECN marked packets 
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: red_label
                                            
                                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                            
                                            .. attribute:: red_transmit_bytes
                                            
                                            	Transmitted bytes
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            	**units**\: byte
                                            
                                            .. attribute:: red_transmit_packets
                                            
                                            	Transmitted packets
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            

                                            """

                                            _prefix = 'qos-ma-oper'
                                            _revision = '2017-04-10'

                                            def __init__(self):
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                                self.yang_name = "wred-stats-array"
                                                self.yang_parent_name = "class-stats"

                                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                                self.profile_title = YLeaf(YType.str, "profile-title")

                                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                                self.red_label = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("max_threshold_bytes",
                                                                "max_threshold_packets",
                                                                "profile_title",
                                                                "random_drop_bytes",
                                                                "random_drop_packets",
                                                                "red_ecn_marked_bytes",
                                                                "red_ecn_marked_packets",
                                                                "red_transmit_bytes",
                                                                "red_transmit_packets") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                            class RedLabel(Entity):
                                                """
                                                Array of WRED Typevalues as in PRP stats is
                                                available per threshold   
                                                
                                                .. attribute:: value
                                                
                                                	WRED value for this type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: wred_type
                                                
                                                	WRED type DSCP, EXP, PREC etc
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'qos-ma-oper'
                                                _revision = '2017-04-10'

                                                def __init__(self):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                                    self.yang_name = "red-label"
                                                    self.yang_parent_name = "wred-stats-array"

                                                    self.value = YLeaf(YType.uint8, "value")

                                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("value",
                                                                    "wred_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.value.is_set or
                                                        self.wred_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set or
                                                        self.wred_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "red-label" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())
                                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "value" or name == "wred-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "wred-type"):
                                                        self.wred_type = value
                                                        self.wred_type.value_namespace = name_space
                                                        self.wred_type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.red_label:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.max_threshold_bytes.is_set or
                                                    self.max_threshold_packets.is_set or
                                                    self.profile_title.is_set or
                                                    self.random_drop_bytes.is_set or
                                                    self.random_drop_packets.is_set or
                                                    self.red_ecn_marked_bytes.is_set or
                                                    self.red_ecn_marked_packets.is_set or
                                                    self.red_transmit_bytes.is_set or
                                                    self.red_transmit_packets.is_set)

                                            def has_operation(self):
                                                for c in self.red_label:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                                    self.profile_title.yfilter != YFilter.not_set or
                                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wred-stats-array" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "red-label"):
                                                    for c in self.red_label:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.red_label.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "max-threshold-bytes"):
                                                    self.max_threshold_bytes = value
                                                    self.max_threshold_bytes.value_namespace = name_space
                                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-threshold-packets"):
                                                    self.max_threshold_packets = value
                                                    self.max_threshold_packets.value_namespace = name_space
                                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-title"):
                                                    self.profile_title = value
                                                    self.profile_title.value_namespace = name_space
                                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-bytes"):
                                                    self.random_drop_bytes = value
                                                    self.random_drop_bytes.value_namespace = name_space
                                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "random-drop-packets"):
                                                    self.random_drop_packets = value
                                                    self.random_drop_packets.value_namespace = name_space
                                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-bytes"):
                                                    self.red_ecn_marked_bytes = value
                                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-ecn-marked-packets"):
                                                    self.red_ecn_marked_packets = value
                                                    self.red_ecn_marked_packets.value_namespace = name_space
                                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-bytes"):
                                                    self.red_transmit_bytes = value
                                                    self.red_transmit_bytes.value_namespace = name_space
                                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                                if(value_path == "red-transmit-packets"):
                                                    self.red_transmit_packets = value
                                                    self.red_transmit_packets.value_namespace = name_space
                                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.police_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.cac_state.is_set or
                                                self.class_name.is_set or
                                                self.counter_validity_bitmask.is_set or
                                                self.queue_descr.is_set or
                                                self.shared_queue_id.is_set or
                                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                                (self.general_stats is not None and self.general_stats.has_data()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                        def has_operation(self):
                                            for c in self.police_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.queue_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.wred_stats_array:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cac_state.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                                self.queue_descr.yfilter != YFilter.not_set or
                                                self.shared_queue_id.yfilter != YFilter.not_set or
                                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cac-stats"):
                                                if (self.cac_stats is None):
                                                    self.cac_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                                    self.cac_stats.parent = self
                                                    self._children_name_map["cac_stats"] = "cac-stats"
                                                return self.cac_stats

                                            if (child_yang_name == "general-stats"):
                                                if (self.general_stats is None):
                                                    self.general_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                                    self.general_stats.parent = self
                                                    self._children_name_map["general_stats"] = "general-stats"
                                                return self.general_stats

                                            if (child_yang_name == "iphc-stats"):
                                                if (self.iphc_stats is None):
                                                    self.iphc_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                                    self.iphc_stats.parent = self
                                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                                return self.iphc_stats

                                            if (child_yang_name == "police-stats-array"):
                                                for c in self.police_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.police_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "queue-stats-array"):
                                                for c in self.queue_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.queue_stats_array.append(c)
                                                return c

                                            if (child_yang_name == "wred-stats-array"):
                                                for c in self.wred_stats_array:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.wred_stats_array.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cac-state"):
                                                self.cac_state = value
                                                self.cac_state.value_namespace = name_space
                                                self.cac_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "counter-validity-bitmask"):
                                                self.counter_validity_bitmask = value
                                                self.counter_validity_bitmask.value_namespace = name_space
                                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-descr"):
                                                self.queue_descr = value
                                                self.queue_descr.value_namespace = name_space
                                                self.queue_descr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "shared-queue-id"):
                                                self.shared_queue_id = value
                                                self.shared_queue_id.value_namespace = name_space
                                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.class_stats:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.policy_name.is_set or
                                            self.satid.is_set or
                                            self.state.is_set or
                                            self.state_description.is_set)

                                    def has_operation(self):
                                        for c in self.class_stats:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            self.satid.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.state_description.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "child-policy" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.satid.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state_description.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "class-stats"):
                                            for c in self.class_stats:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.class_stats.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "satid"):
                                            self.satid = value
                                            self.satid.value_namespace = name_space
                                            self.satid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state-description"):
                                            self.state_description = value
                                            self.state_description.value_namespace = name_space
                                            self.state_description.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.child_policy is not None and self.child_policy.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.child_policy is not None and self.child_policy.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "child-policy"):
                                        if (self.child_policy is None):
                                            self.child_policy = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.ChildPolicy()
                                            self.child_policy.parent = self
                                            self._children_name_map["child_policy"] = "child-policy"
                                        return self.child_policy

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "output" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "service-policy-names"):
                                if (self.service_policy_names is None):
                                    self.service_policy_names = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.ServicePolicyNames()
                                    self.service_policy_names.parent = self
                                    self._children_name_map["service_policy_names"] = "service-policy-names"
                                return self.service_policy_names

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-names" or name == "statistics"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.nv_satellite_id.is_set or
                            (self.input is not None and self.input.has_data()) or
                            (self.output is not None and self.output.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.nv_satellite_id.yfilter != YFilter.not_set or
                            (self.input is not None and self.input.has_operation()) or
                            (self.output is not None and self.output.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "satellite-id" + "[nv-satellite-id='" + self.nv_satellite_id.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.nv_satellite_id.is_set or self.nv_satellite_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nv_satellite_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "input"):
                            if (self.input is None):
                                self.input = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"
                            return self.input

                        if (child_yang_name == "output"):
                            if (self.output is None):
                                self.output = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                            return self.output

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "input" or name == "output" or name == "nv-satellite-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "nv-satellite-id"):
                            self.nv_satellite_id = value
                            self.nv_satellite_id.value_namespace = name_space
                            self.nv_satellite_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.satellite_id:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.satellite_id:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "satellite-ids" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "satellite-id"):
                        for c in self.satellite_id:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = Qos.InterfaceTable.Interface.SatelliteIds.SatelliteId()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.satellite_id.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "satellite-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Input(Entity):
                """
                A piece of QoS policy\-map operational data for
                an interface
                
                .. attribute:: service_policy_names
                
                	Operational data for all Policy instance
                	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames>`
                
                .. attribute:: statistics
                
                	Policy\-map statistics operational data for an interface
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.InterfaceTable.Interface.Input, self).__init__()

                    self.yang_name = "input"
                    self.yang_parent_name = "interface"

                    self.service_policy_names = Qos.InterfaceTable.Interface.Input.ServicePolicyNames()
                    self.service_policy_names.parent = self
                    self._children_name_map["service_policy_names"] = "service-policy-names"
                    self._children_yang_names.add("service-policy-names")

                    self.statistics = Qos.InterfaceTable.Interface.Input.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")


                class ServicePolicyNames(Entity):
                    """
                    Operational data for all Policy instance
                    
                    .. attribute:: service_policy_instance
                    
                    	QoS policy\-map operational data for a particular Policy 
                    	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames, self).__init__()

                        self.yang_name = "service-policy-names"
                        self.yang_parent_name = "input"

                        self.service_policy_instance = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames, self).__setattr__(name, value)


                    class ServicePolicyInstance(Entity):
                        """
                        QoS policy\-map operational data for a
                        particular Policy 
                        
                        .. attribute:: service_policy_name  <key>
                        
                        	Name of the policy instance
                        	**type**\:  str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                            self.yang_name = "service-policy-instance"
                            self.yang_parent_name = "service-policy-names"

                            self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("service_policy_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                        def has_data(self):
                            return self.service_policy_name.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.service_policy_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "service-policy-name"):
                                self.service_policy_name = value
                                self.service_policy_name.value_namespace = name_space
                                self.service_policy_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.service_policy_instance:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.service_policy_instance:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "service-policy-names" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "service-policy-instance"):
                            for c in self.service_policy_instance:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Qos.InterfaceTable.Interface.Input.ServicePolicyNames.ServicePolicyInstance()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.service_policy_instance.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "service-policy-instance"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Statistics(Entity):
                    """
                    Policy\-map statistics operational data for an
                    interface
                    
                    .. attribute:: class_stats
                    
                    	array of classes contained in policy
                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats>`
                    
                    .. attribute:: policy_name
                    
                    	PolicyName
                    	**type**\:  str
                    
                    	**length:** 0..65
                    
                    .. attribute:: satid
                    
                    	to maintain satellite id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: state
                    
                    	State
                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                    
                    .. attribute:: state_description
                    
                    	StateDescription
                    	**type**\:  str
                    
                    	**length:** 0..128
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.InterfaceTable.Interface.Input.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "input"

                        self.policy_name = YLeaf(YType.str, "policy-name")

                        self.satid = YLeaf(YType.uint32, "satid")

                        self.state = YLeaf(YType.enumeration, "state")

                        self.state_description = YLeaf(YType.str, "state-description")

                        self.class_stats = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("policy_name",
                                        "satid",
                                        "state",
                                        "state_description") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.InterfaceTable.Interface.Input.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.InterfaceTable.Interface.Input.Statistics, self).__setattr__(name, value)


                    class ClassStats(Entity):
                        """
                        array of classes contained in policy
                        
                        .. attribute:: cac_state
                        
                        	CACState
                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                        
                        .. attribute:: cac_stats
                        
                        	bag for cac stats
                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.CacStats>`
                        
                        .. attribute:: child_policy
                        
                        	child policy
                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy>`
                        
                        .. attribute:: class_name
                        
                        	ClassName
                        	**type**\:  str
                        
                        	**length:** 0..65
                        
                        .. attribute:: counter_validity_bitmask
                        
                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: megabyte
                        
                        .. attribute:: general_stats
                        
                        	general stats
                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats>`
                        
                        .. attribute:: iphc_stats
                        
                        	IPHC stats
                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats>`
                        
                        .. attribute:: police_stats_array
                        
                        	array of police stats
                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray>`
                        
                        .. attribute:: queue_descr
                        
                        	Description of queue for the class
                        	**type**\:  str
                        
                        	**length:** 0..256
                        
                        .. attribute:: queue_stats_array
                        
                        	array of queue stats
                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray>`
                        
                        .. attribute:: shared_queue_id
                        
                        	q\-id of the  shared queue for this class
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: wred_stats_array
                        
                        	array of red stats
                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats, self).__init__()

                            self.yang_name = "class-stats"
                            self.yang_parent_name = "statistics"

                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                            self.class_name = YLeaf(YType.str, "class-name")

                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                            self.cac_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.CacStats()
                            self.cac_stats.parent = self
                            self._children_name_map["cac_stats"] = "cac-stats"
                            self._children_yang_names.add("cac-stats")

                            self.child_policy = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy()
                            self.child_policy.parent = self
                            self._children_name_map["child_policy"] = "child-policy"
                            self._children_yang_names.add("child-policy")

                            self.general_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats()
                            self.general_stats.parent = self
                            self._children_name_map["general_stats"] = "general-stats"
                            self._children_yang_names.add("general-stats")

                            self.iphc_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats()
                            self.iphc_stats.parent = self
                            self._children_name_map["iphc_stats"] = "iphc-stats"
                            self._children_yang_names.add("iphc-stats")

                            self.police_stats_array = YList(self)
                            self.queue_stats_array = YList(self)
                            self.wred_stats_array = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("cac_state",
                                            "class_name",
                                            "counter_validity_bitmask",
                                            "queue_descr",
                                            "shared_queue_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats, self).__setattr__(name, value)


                        class GeneralStats(Entity):
                            """
                            general stats
                            
                            .. attribute:: match_data_rate
                            
                            	Incoming matched data rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: pre_policy_matched_bytes
                            
                            	Matched bytes before applying policy
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: pre_policy_matched_packets
                            
                            	Matched pkts before applying policy
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: total_drop_bytes
                            
                            	Dropped bytes (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: total_drop_packets
                            
                            	Dropped packets (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: total_drop_rate
                            
                            	Total drop rate (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: total_transmit_rate
                            
                            	Total transmit rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: transmit_bytes
                            
                            	Transmitted bytes (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: transmit_packets
                            
                            	Transmitted packets (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats, self).__init__()

                                self.yang_name = "general-stats"
                                self.yang_parent_name = "class-stats"

                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("match_data_rate",
                                                "pre_policy_matched_bytes",
                                                "pre_policy_matched_packets",
                                                "total_drop_bytes",
                                                "total_drop_packets",
                                                "total_drop_rate",
                                                "total_transmit_rate",
                                                "transmit_bytes",
                                                "transmit_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.match_data_rate.is_set or
                                    self.pre_policy_matched_bytes.is_set or
                                    self.pre_policy_matched_packets.is_set or
                                    self.total_drop_bytes.is_set or
                                    self.total_drop_packets.is_set or
                                    self.total_drop_rate.is_set or
                                    self.total_transmit_rate.is_set or
                                    self.transmit_bytes.is_set or
                                    self.transmit_packets.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.match_data_rate.yfilter != YFilter.not_set or
                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                    self.transmit_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "general-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "match-data-rate"):
                                    self.match_data_rate = value
                                    self.match_data_rate.value_namespace = name_space
                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "pre-policy-matched-bytes"):
                                    self.pre_policy_matched_bytes = value
                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "pre-policy-matched-packets"):
                                    self.pre_policy_matched_packets = value
                                    self.pre_policy_matched_packets.value_namespace = name_space
                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-drop-bytes"):
                                    self.total_drop_bytes = value
                                    self.total_drop_bytes.value_namespace = name_space
                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-drop-packets"):
                                    self.total_drop_packets = value
                                    self.total_drop_packets.value_namespace = name_space
                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-drop-rate"):
                                    self.total_drop_rate = value
                                    self.total_drop_rate.value_namespace = name_space
                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-transmit-rate"):
                                    self.total_transmit_rate = value
                                    self.total_transmit_rate.value_namespace = name_space
                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "transmit-bytes"):
                                    self.transmit_bytes = value
                                    self.transmit_bytes.value_namespace = name_space
                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "transmit-packets"):
                                    self.transmit_packets = value
                                    self.transmit_packets.value_namespace = name_space
                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                        class IphcStats(Entity):
                            """
                            IPHC stats
                            
                            .. attribute:: non_tcp_bytes_saved
                            
                            	Non Tcp Bytes saved due to compression
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: non_tcp_bytes_sent_rate
                            
                            	Compressed Non Tcp Bytes sent rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: non_tcp_compressed_packets_out
                            
                            	Num of non tcp compressed pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: non_tcp_full_header_packets_out
                            
                            	Num of non tcp fullheader pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: non_tcp_total_out_bytes
                            
                            	TotalNum of Non Tcp Bytes sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: non_tcp_total_out_packets
                            
                            	TotalNum of Non tcp pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tcp_bytes_saved
                            
                            	Tcp Bytes saved due to compression
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: tcp_bytes_sent_rate
                            
                            	Compressed Tcp Bytes sent rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: tcp_compressed_packets_out
                            
                            	Num of tcp compressed pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tcp_full_header_packets_out
                            
                            	Num of tcp fullheader pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tcp_total_out_bytes
                            
                            	TotalNum of Tcp Bytes sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: tcp_total_out_packets
                            
                            	Total Num of tcp pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats, self).__init__()

                                self.yang_name = "iphc-stats"
                                self.yang_parent_name = "class-stats"

                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("non_tcp_bytes_saved",
                                                "non_tcp_bytes_sent_rate",
                                                "non_tcp_compressed_packets_out",
                                                "non_tcp_full_header_packets_out",
                                                "non_tcp_total_out_bytes",
                                                "non_tcp_total_out_packets",
                                                "tcp_bytes_saved",
                                                "tcp_bytes_sent_rate",
                                                "tcp_compressed_packets_out",
                                                "tcp_full_header_packets_out",
                                                "tcp_total_out_bytes",
                                                "tcp_total_out_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.non_tcp_bytes_saved.is_set or
                                    self.non_tcp_bytes_sent_rate.is_set or
                                    self.non_tcp_compressed_packets_out.is_set or
                                    self.non_tcp_full_header_packets_out.is_set or
                                    self.non_tcp_total_out_bytes.is_set or
                                    self.non_tcp_total_out_packets.is_set or
                                    self.tcp_bytes_saved.is_set or
                                    self.tcp_bytes_sent_rate.is_set or
                                    self.tcp_compressed_packets_out.is_set or
                                    self.tcp_full_header_packets_out.is_set or
                                    self.tcp_total_out_bytes.is_set or
                                    self.tcp_total_out_packets.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "iphc-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "non-tcp-bytes-saved"):
                                    self.non_tcp_bytes_saved = value
                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-bytes-sent-rate"):
                                    self.non_tcp_bytes_sent_rate = value
                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-compressed-packets-out"):
                                    self.non_tcp_compressed_packets_out = value
                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-full-header-packets-out"):
                                    self.non_tcp_full_header_packets_out = value
                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-total-out-bytes"):
                                    self.non_tcp_total_out_bytes = value
                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-total-out-packets"):
                                    self.non_tcp_total_out_packets = value
                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-bytes-saved"):
                                    self.tcp_bytes_saved = value
                                    self.tcp_bytes_saved.value_namespace = name_space
                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-bytes-sent-rate"):
                                    self.tcp_bytes_sent_rate = value
                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-compressed-packets-out"):
                                    self.tcp_compressed_packets_out = value
                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-full-header-packets-out"):
                                    self.tcp_full_header_packets_out = value
                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-total-out-bytes"):
                                    self.tcp_total_out_bytes = value
                                    self.tcp_total_out_bytes.value_namespace = name_space
                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-total-out-packets"):
                                    self.tcp_total_out_packets = value
                                    self.tcp_total_out_packets.value_namespace = name_space
                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                        class ChildPolicy(Entity):
                            """
                            child policy
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy, self).__init__()

                                self.yang_name = "child-policy"
                                self.yang_parent_name = "class-stats"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "child-policy"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.general_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "child-policy" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix


                        class CacStats(Entity):
                            """
                            bag for cac stats
                            
                            .. attribute:: admit_bytes
                            
                            	Admitted bytes (pkts/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: admit_rates
                            
                            	CAC admit rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: admitpackets
                            
                            	Admitted packets (pkts/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: drop_bytes
                            
                            	CAC dropped bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: drop_packets
                            
                            	CAC dropped packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: drop_rates
                            
                            	CAC dropped rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.CacStats, self).__init__()

                                self.yang_name = "cac-stats"
                                self.yang_parent_name = "class-stats"

                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("admit_bytes",
                                                "admit_rates",
                                                "admitpackets",
                                                "drop_bytes",
                                                "drop_packets",
                                                "drop_rates") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.admit_bytes.is_set or
                                    self.admit_rates.is_set or
                                    self.admitpackets.is_set or
                                    self.drop_bytes.is_set or
                                    self.drop_packets.is_set or
                                    self.drop_rates.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.admit_bytes.yfilter != YFilter.not_set or
                                    self.admit_rates.yfilter != YFilter.not_set or
                                    self.admitpackets.yfilter != YFilter.not_set or
                                    self.drop_bytes.yfilter != YFilter.not_set or
                                    self.drop_packets.yfilter != YFilter.not_set or
                                    self.drop_rates.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "cac-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "admit-bytes"):
                                    self.admit_bytes = value
                                    self.admit_bytes.value_namespace = name_space
                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "admit-rates"):
                                    self.admit_rates = value
                                    self.admit_rates.value_namespace = name_space
                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                if(value_path == "admitpackets"):
                                    self.admitpackets = value
                                    self.admitpackets.value_namespace = name_space
                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-bytes"):
                                    self.drop_bytes = value
                                    self.drop_bytes.value_namespace = name_space
                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-packets"):
                                    self.drop_packets = value
                                    self.drop_packets.value_namespace = name_space
                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-rates"):
                                    self.drop_rates = value
                                    self.drop_rates.value_namespace = name_space
                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                        class QueueStatsArray(Entity):
                            """
                            array of queue stats
                            
                            .. attribute:: atm_clp0_drop_bytes
                            
                            	ATP CLP 0 matched bytes dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: atm_clp0_drop_packets
                            
                            	ATP CLP 0 matched packets dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: atm_clp1_drop_bytes
                            
                            	ATP CLP 0 matched bytes dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: atm_clp1_drop_packets
                            
                            	ATP CLP 0 matched packets dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: conform_bytes
                            
                            	Bytes that conform to the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: conform_packets
                            
                            	Packets that conform  to the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: conform_rate
                            
                            	Conform rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: exceed_bytes
                            
                            	Bytes that exceed  the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: exceed_packets
                            
                            	Packets that exceed the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: exceed_rate
                            
                            	Exceed rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: forced_wred_stats_display
                            
                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                            	**type**\:  bool
                            
                            .. attribute:: max_threshold_bytes
                            
                            	Dropped bytes with the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: max_threshold_packets
                            
                            	Dropped packets with the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: queue_average_length
                            
                            	Queue average length
                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                            
                            .. attribute:: queue_drop_threshold
                            
                            	tail drop threshold of the queue in bytes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: queue_id
                            
                            	Queue Id used for Fabric Stats
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: queue_instance_length
                            
                            	Queue instance length
                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                            
                            .. attribute:: queue_max_length
                            
                            	Queue maximum length
                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                            
                            .. attribute:: random_drop_bytes
                            
                            	Bytes probabilistically dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: random_drop_packets
                            
                            	Packets probabilistically dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tail_drop_bytes
                            
                            	Bytes tail dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: tail_drop_packets
                            
                            	Packets tail dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                self.yang_name = "queue-stats-array"
                                self.yang_parent_name = "class-stats"

                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                self.queue_average_length = YList(self)
                                self.queue_instance_length = YList(self)
                                self.queue_max_length = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("atm_clp0_drop_bytes",
                                                "atm_clp0_drop_packets",
                                                "atm_clp1_drop_bytes",
                                                "atm_clp1_drop_packets",
                                                "conform_bytes",
                                                "conform_packets",
                                                "conform_rate",
                                                "exceed_bytes",
                                                "exceed_packets",
                                                "exceed_rate",
                                                "forced_wred_stats_display",
                                                "max_threshold_bytes",
                                                "max_threshold_packets",
                                                "queue_drop_threshold",
                                                "queue_id",
                                                "random_drop_bytes",
                                                "random_drop_packets",
                                                "tail_drop_bytes",
                                                "tail_drop_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                            class QueueInstanceLength(Entity):
                                """
                                Queue instance length
                                
                                .. attribute:: unit
                                
                                	unit
                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                
                                .. attribute:: value
                                
                                	value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                    self.yang_name = "queue-instance-length"
                                    self.yang_parent_name = "queue-stats-array"

                                    self.unit = YLeaf(YType.enumeration, "unit")

                                    self.value = YLeaf(YType.uint32, "value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("unit",
                                                    "value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.unit.is_set or
                                        self.value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.unit.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "queue-instance-length" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "unit" or name == "value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "unit"):
                                        self.unit = value
                                        self.unit.value_namespace = name_space
                                        self.unit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix


                            class QueueAverageLength(Entity):
                                """
                                Queue average length
                                
                                .. attribute:: unit
                                
                                	unit
                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                
                                .. attribute:: value
                                
                                	value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                    self.yang_name = "queue-average-length"
                                    self.yang_parent_name = "queue-stats-array"

                                    self.unit = YLeaf(YType.enumeration, "unit")

                                    self.value = YLeaf(YType.uint32, "value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("unit",
                                                    "value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.unit.is_set or
                                        self.value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.unit.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "queue-average-length" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "unit" or name == "value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "unit"):
                                        self.unit = value
                                        self.unit.value_namespace = name_space
                                        self.unit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix


                            class QueueMaxLength(Entity):
                                """
                                Queue maximum length
                                
                                .. attribute:: unit
                                
                                	unit
                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                
                                .. attribute:: value
                                
                                	value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                    self.yang_name = "queue-max-length"
                                    self.yang_parent_name = "queue-stats-array"

                                    self.unit = YLeaf(YType.enumeration, "unit")

                                    self.value = YLeaf(YType.uint32, "value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("unit",
                                                    "value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.unit.is_set or
                                        self.value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.unit.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "queue-max-length" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "unit" or name == "value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "unit"):
                                        self.unit = value
                                        self.unit.value_namespace = name_space
                                        self.unit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.queue_average_length:
                                    if (c.has_data()):
                                        return True
                                for c in self.queue_instance_length:
                                    if (c.has_data()):
                                        return True
                                for c in self.queue_max_length:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.atm_clp0_drop_bytes.is_set or
                                    self.atm_clp0_drop_packets.is_set or
                                    self.atm_clp1_drop_bytes.is_set or
                                    self.atm_clp1_drop_packets.is_set or
                                    self.conform_bytes.is_set or
                                    self.conform_packets.is_set or
                                    self.conform_rate.is_set or
                                    self.exceed_bytes.is_set or
                                    self.exceed_packets.is_set or
                                    self.exceed_rate.is_set or
                                    self.forced_wred_stats_display.is_set or
                                    self.max_threshold_bytes.is_set or
                                    self.max_threshold_packets.is_set or
                                    self.queue_drop_threshold.is_set or
                                    self.queue_id.is_set or
                                    self.random_drop_bytes.is_set or
                                    self.random_drop_packets.is_set or
                                    self.tail_drop_bytes.is_set or
                                    self.tail_drop_packets.is_set)

                            def has_operation(self):
                                for c in self.queue_average_length:
                                    if (c.has_operation()):
                                        return True
                                for c in self.queue_instance_length:
                                    if (c.has_operation()):
                                        return True
                                for c in self.queue_max_length:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                    self.conform_bytes.yfilter != YFilter.not_set or
                                    self.conform_packets.yfilter != YFilter.not_set or
                                    self.conform_rate.yfilter != YFilter.not_set or
                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                    self.exceed_packets.yfilter != YFilter.not_set or
                                    self.exceed_rate.yfilter != YFilter.not_set or
                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                    self.queue_id.yfilter != YFilter.not_set or
                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "queue-stats-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "queue-average-length"):
                                    for c in self.queue_average_length:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.queue_average_length.append(c)
                                    return c

                                if (child_yang_name == "queue-instance-length"):
                                    for c in self.queue_instance_length:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.queue_instance_length.append(c)
                                    return c

                                if (child_yang_name == "queue-max-length"):
                                    for c in self.queue_max_length:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.queue_max_length.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "atm-clp0-drop-bytes"):
                                    self.atm_clp0_drop_bytes = value
                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "atm-clp0-drop-packets"):
                                    self.atm_clp0_drop_packets = value
                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "atm-clp1-drop-bytes"):
                                    self.atm_clp1_drop_bytes = value
                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "atm-clp1-drop-packets"):
                                    self.atm_clp1_drop_packets = value
                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-bytes"):
                                    self.conform_bytes = value
                                    self.conform_bytes.value_namespace = name_space
                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-packets"):
                                    self.conform_packets = value
                                    self.conform_packets.value_namespace = name_space
                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-rate"):
                                    self.conform_rate = value
                                    self.conform_rate.value_namespace = name_space
                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-bytes"):
                                    self.exceed_bytes = value
                                    self.exceed_bytes.value_namespace = name_space
                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-packets"):
                                    self.exceed_packets = value
                                    self.exceed_packets.value_namespace = name_space
                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-rate"):
                                    self.exceed_rate = value
                                    self.exceed_rate.value_namespace = name_space
                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "forced-wred-stats-display"):
                                    self.forced_wred_stats_display = value
                                    self.forced_wred_stats_display.value_namespace = name_space
                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-threshold-bytes"):
                                    self.max_threshold_bytes = value
                                    self.max_threshold_bytes.value_namespace = name_space
                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-threshold-packets"):
                                    self.max_threshold_packets = value
                                    self.max_threshold_packets.value_namespace = name_space
                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "queue-drop-threshold"):
                                    self.queue_drop_threshold = value
                                    self.queue_drop_threshold.value_namespace = name_space
                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                if(value_path == "queue-id"):
                                    self.queue_id = value
                                    self.queue_id.value_namespace = name_space
                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-bytes"):
                                    self.random_drop_bytes = value
                                    self.random_drop_bytes.value_namespace = name_space
                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-packets"):
                                    self.random_drop_packets = value
                                    self.random_drop_packets.value_namespace = name_space
                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "tail-drop-bytes"):
                                    self.tail_drop_bytes = value
                                    self.tail_drop_bytes.value_namespace = name_space
                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "tail-drop-packets"):
                                    self.tail_drop_packets = value
                                    self.tail_drop_packets.value_namespace = name_space
                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                        class PoliceStatsArray(Entity):
                            """
                            array of police stats
                            
                            .. attribute:: color_class_stats
                            
                            	color class stats
                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                            
                            .. attribute:: conform_bytes
                            
                            	Bytes that conform to the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: conform_packets
                            
                            	Packets that conform  to the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: conform_rate
                            
                            	Conform rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: drop_bytes
                            
                            	Police dropped bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: drop_packets
                            
                            	Police dropped packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: exceed_bytes
                            
                            	Bytes that exceed  the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: exceed_packets
                            
                            	Packets that exceed the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: exceed_rate
                            
                            	Exceed rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: parent_drop_bytes
                            
                            	Dropped bytes by the parent policer
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: parent_drop_packets
                            
                            	Dropped pkts by the parent policer
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: violate_bytes
                            
                            	Bytes that violate the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: violate_packets
                            
                            	Packets violating the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: violate_rate
                            
                            	Violate rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                self.yang_name = "police-stats-array"
                                self.yang_parent_name = "class-stats"

                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                self.color_class_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                self.color_class_stats.parent = self
                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                self._children_yang_names.add("color-class-stats")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("conform_bytes",
                                                "conform_packets",
                                                "conform_rate",
                                                "drop_bytes",
                                                "drop_packets",
                                                "exceed_bytes",
                                                "exceed_packets",
                                                "exceed_rate",
                                                "parent_drop_bytes",
                                                "parent_drop_packets",
                                                "violate_bytes",
                                                "violate_packets",
                                                "violate_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                            class ColorClassStats(Entity):
                                """
                                color class stats
                                
                                .. attribute:: conform_class_conform_bytes
                                
                                	Bytes with classification result conform and policer result conform
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: conform_class_conform_packets
                                
                                	Packets with classification result conform and policer result conform
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: conform_class_conform_rate
                                
                                	Conform Class Conform rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: conform_class_exceed_bytes
                                
                                	Bytes with classification result conform and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: conform_class_exceed_packets
                                
                                	Packets with classification result conform and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: conform_class_exceed_rate
                                
                                	Conform Class Exceed rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: conform_class_violate_bytes
                                
                                	Bytes with classification result conform and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: conform_class_violate_packets
                                
                                	Packets with classification result conform and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: conform_class_violate_rate
                                
                                	Conform Class Violate rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: exceed_class_exceed_bytes
                                
                                	Bytes with classification result exceed and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: exceed_class_exceed_packets
                                
                                	Packets with classification result exceed and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: exceed_class_exceed_rate
                                
                                	Exceed Class Exceed rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: exceed_class_violate_bytes
                                
                                	Bytes with classification result exceed and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: exceed_class_violate_packets
                                
                                	Packets with classification result exceed and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: exceed_class_violate_rate
                                
                                	Exceed Class Violate rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: violate_class_violate_bytes
                                
                                	Bytes with classification result violate and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: violate_class_violate_packets
                                
                                	Packets with classification result violate and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: violate_class_violate_rate
                                
                                	Violate Class Violate rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                    self.yang_name = "color-class-stats"
                                    self.yang_parent_name = "police-stats-array"

                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("conform_class_conform_bytes",
                                                    "conform_class_conform_packets",
                                                    "conform_class_conform_rate",
                                                    "conform_class_exceed_bytes",
                                                    "conform_class_exceed_packets",
                                                    "conform_class_exceed_rate",
                                                    "conform_class_violate_bytes",
                                                    "conform_class_violate_packets",
                                                    "conform_class_violate_rate",
                                                    "exceed_class_exceed_bytes",
                                                    "exceed_class_exceed_packets",
                                                    "exceed_class_exceed_rate",
                                                    "exceed_class_violate_bytes",
                                                    "exceed_class_violate_packets",
                                                    "exceed_class_violate_rate",
                                                    "violate_class_violate_bytes",
                                                    "violate_class_violate_packets",
                                                    "violate_class_violate_rate") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.conform_class_conform_bytes.is_set or
                                        self.conform_class_conform_packets.is_set or
                                        self.conform_class_conform_rate.is_set or
                                        self.conform_class_exceed_bytes.is_set or
                                        self.conform_class_exceed_packets.is_set or
                                        self.conform_class_exceed_rate.is_set or
                                        self.conform_class_violate_bytes.is_set or
                                        self.conform_class_violate_packets.is_set or
                                        self.conform_class_violate_rate.is_set or
                                        self.exceed_class_exceed_bytes.is_set or
                                        self.exceed_class_exceed_packets.is_set or
                                        self.exceed_class_exceed_rate.is_set or
                                        self.exceed_class_violate_bytes.is_set or
                                        self.exceed_class_violate_packets.is_set or
                                        self.exceed_class_violate_rate.is_set or
                                        self.violate_class_violate_bytes.is_set or
                                        self.violate_class_violate_packets.is_set or
                                        self.violate_class_violate_rate.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "color-class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "conform-class-conform-bytes"):
                                        self.conform_class_conform_bytes = value
                                        self.conform_class_conform_bytes.value_namespace = name_space
                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-conform-packets"):
                                        self.conform_class_conform_packets = value
                                        self.conform_class_conform_packets.value_namespace = name_space
                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-conform-rate"):
                                        self.conform_class_conform_rate = value
                                        self.conform_class_conform_rate.value_namespace = name_space
                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-exceed-bytes"):
                                        self.conform_class_exceed_bytes = value
                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-exceed-packets"):
                                        self.conform_class_exceed_packets = value
                                        self.conform_class_exceed_packets.value_namespace = name_space
                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-exceed-rate"):
                                        self.conform_class_exceed_rate = value
                                        self.conform_class_exceed_rate.value_namespace = name_space
                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-violate-bytes"):
                                        self.conform_class_violate_bytes = value
                                        self.conform_class_violate_bytes.value_namespace = name_space
                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-violate-packets"):
                                        self.conform_class_violate_packets = value
                                        self.conform_class_violate_packets.value_namespace = name_space
                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-violate-rate"):
                                        self.conform_class_violate_rate = value
                                        self.conform_class_violate_rate.value_namespace = name_space
                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-exceed-bytes"):
                                        self.exceed_class_exceed_bytes = value
                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-exceed-packets"):
                                        self.exceed_class_exceed_packets = value
                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-exceed-rate"):
                                        self.exceed_class_exceed_rate = value
                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-violate-bytes"):
                                        self.exceed_class_violate_bytes = value
                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-violate-packets"):
                                        self.exceed_class_violate_packets = value
                                        self.exceed_class_violate_packets.value_namespace = name_space
                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-violate-rate"):
                                        self.exceed_class_violate_rate = value
                                        self.exceed_class_violate_rate.value_namespace = name_space
                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "violate-class-violate-bytes"):
                                        self.violate_class_violate_bytes = value
                                        self.violate_class_violate_bytes.value_namespace = name_space
                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "violate-class-violate-packets"):
                                        self.violate_class_violate_packets = value
                                        self.violate_class_violate_packets.value_namespace = name_space
                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "violate-class-violate-rate"):
                                        self.violate_class_violate_rate = value
                                        self.violate_class_violate_rate.value_namespace = name_space
                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.conform_bytes.is_set or
                                    self.conform_packets.is_set or
                                    self.conform_rate.is_set or
                                    self.drop_bytes.is_set or
                                    self.drop_packets.is_set or
                                    self.exceed_bytes.is_set or
                                    self.exceed_packets.is_set or
                                    self.exceed_rate.is_set or
                                    self.parent_drop_bytes.is_set or
                                    self.parent_drop_packets.is_set or
                                    self.violate_bytes.is_set or
                                    self.violate_packets.is_set or
                                    self.violate_rate.is_set or
                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.conform_bytes.yfilter != YFilter.not_set or
                                    self.conform_packets.yfilter != YFilter.not_set or
                                    self.conform_rate.yfilter != YFilter.not_set or
                                    self.drop_bytes.yfilter != YFilter.not_set or
                                    self.drop_packets.yfilter != YFilter.not_set or
                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                    self.exceed_packets.yfilter != YFilter.not_set or
                                    self.exceed_rate.yfilter != YFilter.not_set or
                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                    self.violate_bytes.yfilter != YFilter.not_set or
                                    self.violate_packets.yfilter != YFilter.not_set or
                                    self.violate_rate.yfilter != YFilter.not_set or
                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "police-stats-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "color-class-stats"):
                                    if (self.color_class_stats is None):
                                        self.color_class_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                    return self.color_class_stats

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "conform-bytes"):
                                    self.conform_bytes = value
                                    self.conform_bytes.value_namespace = name_space
                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-packets"):
                                    self.conform_packets = value
                                    self.conform_packets.value_namespace = name_space
                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-rate"):
                                    self.conform_rate = value
                                    self.conform_rate.value_namespace = name_space
                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-bytes"):
                                    self.drop_bytes = value
                                    self.drop_bytes.value_namespace = name_space
                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-packets"):
                                    self.drop_packets = value
                                    self.drop_packets.value_namespace = name_space
                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-bytes"):
                                    self.exceed_bytes = value
                                    self.exceed_bytes.value_namespace = name_space
                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-packets"):
                                    self.exceed_packets = value
                                    self.exceed_packets.value_namespace = name_space
                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-rate"):
                                    self.exceed_rate = value
                                    self.exceed_rate.value_namespace = name_space
                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-drop-bytes"):
                                    self.parent_drop_bytes = value
                                    self.parent_drop_bytes.value_namespace = name_space
                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-drop-packets"):
                                    self.parent_drop_packets = value
                                    self.parent_drop_packets.value_namespace = name_space
                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "violate-bytes"):
                                    self.violate_bytes = value
                                    self.violate_bytes.value_namespace = name_space
                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "violate-packets"):
                                    self.violate_packets = value
                                    self.violate_packets.value_namespace = name_space
                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "violate-rate"):
                                    self.violate_rate = value
                                    self.violate_rate.value_namespace = name_space
                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                        class WredStatsArray(Entity):
                            """
                            array of red stats
                            
                            .. attribute:: max_threshold_bytes
                            
                            	Dropped bytes with  the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: max_threshold_packets
                            
                            	Dropped packets with  the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: profile_title
                            
                            	ProfileTitle
                            	**type**\:  str
                            
                            	**length:** 0..300
                            
                            .. attribute:: random_drop_bytes
                            
                            	Probabilisticallydropped bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: random_drop_packets
                            
                            	Probabilistically dropped  packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: red_ecn_marked_bytes
                            
                            	ECN marked bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: red_ecn_marked_packets
                            
                            	ECN marked packets 
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: red_label
                            
                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel>`
                            
                            .. attribute:: red_transmit_bytes
                            
                            	Transmitted bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: red_transmit_packets
                            
                            	Transmitted packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray, self).__init__()

                                self.yang_name = "wred-stats-array"
                                self.yang_parent_name = "class-stats"

                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                self.profile_title = YLeaf(YType.str, "profile-title")

                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                self.red_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("max_threshold_bytes",
                                                "max_threshold_packets",
                                                "profile_title",
                                                "random_drop_bytes",
                                                "random_drop_packets",
                                                "red_ecn_marked_bytes",
                                                "red_ecn_marked_packets",
                                                "red_transmit_bytes",
                                                "red_transmit_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                            class RedLabel(Entity):
                                """
                                Array of WRED Typevalues as in PRP stats is
                                available per threshold   
                                
                                .. attribute:: value
                                
                                	WRED value for this type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: wred_type
                                
                                	WRED type DSCP, EXP, PREC etc
                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                    self.yang_name = "red-label"
                                    self.yang_parent_name = "wred-stats-array"

                                    self.value = YLeaf(YType.uint8, "value")

                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("value",
                                                    "wred_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.value.is_set or
                                        self.wred_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set or
                                        self.wred_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "red-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())
                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "value" or name == "wred-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix
                                    if(value_path == "wred-type"):
                                        self.wred_type = value
                                        self.wred_type.value_namespace = name_space
                                        self.wred_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.red_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.max_threshold_bytes.is_set or
                                    self.max_threshold_packets.is_set or
                                    self.profile_title.is_set or
                                    self.random_drop_bytes.is_set or
                                    self.random_drop_packets.is_set or
                                    self.red_ecn_marked_bytes.is_set or
                                    self.red_ecn_marked_packets.is_set or
                                    self.red_transmit_bytes.is_set or
                                    self.red_transmit_packets.is_set)

                            def has_operation(self):
                                for c in self.red_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                    self.profile_title.yfilter != YFilter.not_set or
                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "wred-stats-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "red-label"):
                                    for c in self.red_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray.RedLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.red_label.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "max-threshold-bytes"):
                                    self.max_threshold_bytes = value
                                    self.max_threshold_bytes.value_namespace = name_space
                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-threshold-packets"):
                                    self.max_threshold_packets = value
                                    self.max_threshold_packets.value_namespace = name_space
                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "profile-title"):
                                    self.profile_title = value
                                    self.profile_title.value_namespace = name_space
                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-bytes"):
                                    self.random_drop_bytes = value
                                    self.random_drop_bytes.value_namespace = name_space
                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-packets"):
                                    self.random_drop_packets = value
                                    self.random_drop_packets.value_namespace = name_space
                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-ecn-marked-bytes"):
                                    self.red_ecn_marked_bytes = value
                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-ecn-marked-packets"):
                                    self.red_ecn_marked_packets = value
                                    self.red_ecn_marked_packets.value_namespace = name_space
                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-transmit-bytes"):
                                    self.red_transmit_bytes = value
                                    self.red_transmit_bytes.value_namespace = name_space
                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-transmit-packets"):
                                    self.red_transmit_packets = value
                                    self.red_transmit_packets.value_namespace = name_space
                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.police_stats_array:
                                if (c.has_data()):
                                    return True
                            for c in self.queue_stats_array:
                                if (c.has_data()):
                                    return True
                            for c in self.wred_stats_array:
                                if (c.has_data()):
                                    return True
                            return (
                                self.cac_state.is_set or
                                self.class_name.is_set or
                                self.counter_validity_bitmask.is_set or
                                self.queue_descr.is_set or
                                self.shared_queue_id.is_set or
                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                (self.child_policy is not None and self.child_policy.has_data()) or
                                (self.general_stats is not None and self.general_stats.has_data()) or
                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                        def has_operation(self):
                            for c in self.police_stats_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.queue_stats_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.wred_stats_array:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.cac_state.yfilter != YFilter.not_set or
                                self.class_name.yfilter != YFilter.not_set or
                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                self.queue_descr.yfilter != YFilter.not_set or
                                self.shared_queue_id.yfilter != YFilter.not_set or
                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                (self.child_policy is not None and self.child_policy.has_operation()) or
                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "class-stats" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.class_name.get_name_leafdata())
                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "cac-stats"):
                                if (self.cac_stats is None):
                                    self.cac_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                return self.cac_stats

                            if (child_yang_name == "child-policy"):
                                if (self.child_policy is None):
                                    self.child_policy = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                return self.child_policy

                            if (child_yang_name == "general-stats"):
                                if (self.general_stats is None):
                                    self.general_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                return self.general_stats

                            if (child_yang_name == "iphc-stats"):
                                if (self.iphc_stats is None):
                                    self.iphc_stats = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                return self.iphc_stats

                            if (child_yang_name == "police-stats-array"):
                                for c in self.police_stats_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.PoliceStatsArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.police_stats_array.append(c)
                                return c

                            if (child_yang_name == "queue-stats-array"):
                                for c in self.queue_stats_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.QueueStatsArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.queue_stats_array.append(c)
                                return c

                            if (child_yang_name == "wred-stats-array"):
                                for c in self.wred_stats_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats.WredStatsArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.wred_stats_array.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "cac-state"):
                                self.cac_state = value
                                self.cac_state.value_namespace = name_space
                                self.cac_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "class-name"):
                                self.class_name = value
                                self.class_name.value_namespace = name_space
                                self.class_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "counter-validity-bitmask"):
                                self.counter_validity_bitmask = value
                                self.counter_validity_bitmask.value_namespace = name_space
                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                            if(value_path == "queue-descr"):
                                self.queue_descr = value
                                self.queue_descr.value_namespace = name_space
                                self.queue_descr.value_namespace_prefix = name_space_prefix
                            if(value_path == "shared-queue-id"):
                                self.shared_queue_id = value
                                self.shared_queue_id.value_namespace = name_space
                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.class_stats:
                            if (c.has_data()):
                                return True
                        return (
                            self.policy_name.is_set or
                            self.satid.is_set or
                            self.state.is_set or
                            self.state_description.is_set)

                    def has_operation(self):
                        for c in self.class_stats:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.policy_name.yfilter != YFilter.not_set or
                            self.satid.yfilter != YFilter.not_set or
                            self.state.yfilter != YFilter.not_set or
                            self.state_description.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.satid.get_name_leafdata())
                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.state.get_name_leafdata())
                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.state_description.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "class-stats"):
                            for c in self.class_stats:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Qos.InterfaceTable.Interface.Input.Statistics.ClassStats()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.class_stats.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "policy-name"):
                            self.policy_name = value
                            self.policy_name.value_namespace = name_space
                            self.policy_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "satid"):
                            self.satid = value
                            self.satid.value_namespace = name_space
                            self.satid.value_namespace_prefix = name_space_prefix
                        if(value_path == "state"):
                            self.state = value
                            self.state.value_namespace = name_space
                            self.state.value_namespace_prefix = name_space_prefix
                        if(value_path == "state-description"):
                            self.state_description = value
                            self.state_description.value_namespace = name_space
                            self.state_description.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "input" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "service-policy-names"):
                        if (self.service_policy_names is None):
                            self.service_policy_names = Qos.InterfaceTable.Interface.Input.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                        return self.service_policy_names

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = Qos.InterfaceTable.Interface.Input.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "service-policy-names" or name == "statistics"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Output(Entity):
                """
                A piece of QoS policy\-map operational data for
                an interface
                
                .. attribute:: service_policy_names
                
                	Operational data for all Policy instance
                	**type**\:   :py:class:`ServicePolicyNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames>`
                
                .. attribute:: statistics
                
                	Policy\-map statistics operational data for an interface
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics>`
                
                

                """

                _prefix = 'qos-ma-oper'
                _revision = '2017-04-10'

                def __init__(self):
                    super(Qos.InterfaceTable.Interface.Output, self).__init__()

                    self.yang_name = "output"
                    self.yang_parent_name = "interface"

                    self.service_policy_names = Qos.InterfaceTable.Interface.Output.ServicePolicyNames()
                    self.service_policy_names.parent = self
                    self._children_name_map["service_policy_names"] = "service-policy-names"
                    self._children_yang_names.add("service-policy-names")

                    self.statistics = Qos.InterfaceTable.Interface.Output.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")


                class ServicePolicyNames(Entity):
                    """
                    Operational data for all Policy instance
                    
                    .. attribute:: service_policy_instance
                    
                    	QoS policy\-map operational data for a particular Policy 
                    	**type**\: list of    :py:class:`ServicePolicyInstance <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance>`
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames, self).__init__()

                        self.yang_name = "service-policy-names"
                        self.yang_parent_name = "output"

                        self.service_policy_instance = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames, self).__setattr__(name, value)


                    class ServicePolicyInstance(Entity):
                        """
                        QoS policy\-map operational data for a
                        particular Policy 
                        
                        .. attribute:: service_policy_name  <key>
                        
                        	Name of the policy instance
                        	**type**\:  str
                        
                        	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, self).__init__()

                            self.yang_name = "service-policy-instance"
                            self.yang_parent_name = "service-policy-names"

                            self.service_policy_name = YLeaf(YType.str, "service-policy-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("service_policy_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance, self).__setattr__(name, value)

                        def has_data(self):
                            return self.service_policy_name.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.service_policy_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "service-policy-instance" + "[service-policy-name='" + self.service_policy_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.service_policy_name.is_set or self.service_policy_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.service_policy_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "service-policy-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "service-policy-name"):
                                self.service_policy_name = value
                                self.service_policy_name.value_namespace = name_space
                                self.service_policy_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.service_policy_instance:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.service_policy_instance:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "service-policy-names" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "service-policy-instance"):
                            for c in self.service_policy_instance:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Qos.InterfaceTable.Interface.Output.ServicePolicyNames.ServicePolicyInstance()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.service_policy_instance.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "service-policy-instance"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Statistics(Entity):
                    """
                    Policy\-map statistics operational data for an
                    interface
                    
                    .. attribute:: class_stats
                    
                    	array of classes contained in policy
                    	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats>`
                    
                    .. attribute:: policy_name
                    
                    	PolicyName
                    	**type**\:  str
                    
                    	**length:** 0..65
                    
                    .. attribute:: satid
                    
                    	to maintain satellite id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: state
                    
                    	State
                    	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                    
                    .. attribute:: state_description
                    
                    	StateDescription
                    	**type**\:  str
                    
                    	**length:** 0..128
                    
                    

                    """

                    _prefix = 'qos-ma-oper'
                    _revision = '2017-04-10'

                    def __init__(self):
                        super(Qos.InterfaceTable.Interface.Output.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "output"

                        self.policy_name = YLeaf(YType.str, "policy-name")

                        self.satid = YLeaf(YType.uint32, "satid")

                        self.state = YLeaf(YType.enumeration, "state")

                        self.state_description = YLeaf(YType.str, "state-description")

                        self.class_stats = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("policy_name",
                                        "satid",
                                        "state",
                                        "state_description") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(Qos.InterfaceTable.Interface.Output.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(Qos.InterfaceTable.Interface.Output.Statistics, self).__setattr__(name, value)


                    class ClassStats(Entity):
                        """
                        array of classes contained in policy
                        
                        .. attribute:: cac_state
                        
                        	CACState
                        	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                        
                        .. attribute:: cac_stats
                        
                        	bag for cac stats
                        	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.CacStats>`
                        
                        .. attribute:: child_policy
                        
                        	child policy
                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy>`
                        
                        .. attribute:: class_name
                        
                        	ClassName
                        	**type**\:  str
                        
                        	**length:** 0..65
                        
                        .. attribute:: counter_validity_bitmask
                        
                        	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: megabyte
                        
                        .. attribute:: general_stats
                        
                        	general stats
                        	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats>`
                        
                        .. attribute:: iphc_stats
                        
                        	IPHC stats
                        	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats>`
                        
                        .. attribute:: police_stats_array
                        
                        	array of police stats
                        	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray>`
                        
                        .. attribute:: queue_descr
                        
                        	Description of queue for the class
                        	**type**\:  str
                        
                        	**length:** 0..256
                        
                        .. attribute:: queue_stats_array
                        
                        	array of queue stats
                        	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray>`
                        
                        .. attribute:: shared_queue_id
                        
                        	q\-id of the  shared queue for this class
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: wred_stats_array
                        
                        	array of red stats
                        	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray>`
                        
                        

                        """

                        _prefix = 'qos-ma-oper'
                        _revision = '2017-04-10'

                        def __init__(self):
                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats, self).__init__()

                            self.yang_name = "class-stats"
                            self.yang_parent_name = "statistics"

                            self.cac_state = YLeaf(YType.enumeration, "cac-state")

                            self.class_name = YLeaf(YType.str, "class-name")

                            self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                            self.queue_descr = YLeaf(YType.str, "queue-descr")

                            self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                            self.cac_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.CacStats()
                            self.cac_stats.parent = self
                            self._children_name_map["cac_stats"] = "cac-stats"
                            self._children_yang_names.add("cac-stats")

                            self.child_policy = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy()
                            self.child_policy.parent = self
                            self._children_name_map["child_policy"] = "child-policy"
                            self._children_yang_names.add("child-policy")

                            self.general_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats()
                            self.general_stats.parent = self
                            self._children_name_map["general_stats"] = "general-stats"
                            self._children_yang_names.add("general-stats")

                            self.iphc_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats()
                            self.iphc_stats.parent = self
                            self._children_name_map["iphc_stats"] = "iphc-stats"
                            self._children_yang_names.add("iphc-stats")

                            self.police_stats_array = YList(self)
                            self.queue_stats_array = YList(self)
                            self.wred_stats_array = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("cac_state",
                                            "class_name",
                                            "counter_validity_bitmask",
                                            "queue_descr",
                                            "shared_queue_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats, self).__setattr__(name, value)


                        class GeneralStats(Entity):
                            """
                            general stats
                            
                            .. attribute:: match_data_rate
                            
                            	Incoming matched data rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: pre_policy_matched_bytes
                            
                            	Matched bytes before applying policy
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: pre_policy_matched_packets
                            
                            	Matched pkts before applying policy
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: total_drop_bytes
                            
                            	Dropped bytes (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: total_drop_packets
                            
                            	Dropped packets (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: total_drop_rate
                            
                            	Total drop rate (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: total_transmit_rate
                            
                            	Total transmit rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: transmit_bytes
                            
                            	Transmitted bytes (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: transmit_packets
                            
                            	Transmitted packets (packets/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats, self).__init__()

                                self.yang_name = "general-stats"
                                self.yang_parent_name = "class-stats"

                                self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("match_data_rate",
                                                "pre_policy_matched_bytes",
                                                "pre_policy_matched_packets",
                                                "total_drop_bytes",
                                                "total_drop_packets",
                                                "total_drop_rate",
                                                "total_transmit_rate",
                                                "transmit_bytes",
                                                "transmit_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.match_data_rate.is_set or
                                    self.pre_policy_matched_bytes.is_set or
                                    self.pre_policy_matched_packets.is_set or
                                    self.total_drop_bytes.is_set or
                                    self.total_drop_packets.is_set or
                                    self.total_drop_rate.is_set or
                                    self.total_transmit_rate.is_set or
                                    self.transmit_bytes.is_set or
                                    self.transmit_packets.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.match_data_rate.yfilter != YFilter.not_set or
                                    self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                    self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                    self.total_drop_bytes.yfilter != YFilter.not_set or
                                    self.total_drop_packets.yfilter != YFilter.not_set or
                                    self.total_drop_rate.yfilter != YFilter.not_set or
                                    self.total_transmit_rate.yfilter != YFilter.not_set or
                                    self.transmit_bytes.yfilter != YFilter.not_set or
                                    self.transmit_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "general-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "match-data-rate"):
                                    self.match_data_rate = value
                                    self.match_data_rate.value_namespace = name_space
                                    self.match_data_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "pre-policy-matched-bytes"):
                                    self.pre_policy_matched_bytes = value
                                    self.pre_policy_matched_bytes.value_namespace = name_space
                                    self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "pre-policy-matched-packets"):
                                    self.pre_policy_matched_packets = value
                                    self.pre_policy_matched_packets.value_namespace = name_space
                                    self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-drop-bytes"):
                                    self.total_drop_bytes = value
                                    self.total_drop_bytes.value_namespace = name_space
                                    self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-drop-packets"):
                                    self.total_drop_packets = value
                                    self.total_drop_packets.value_namespace = name_space
                                    self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-drop-rate"):
                                    self.total_drop_rate = value
                                    self.total_drop_rate.value_namespace = name_space
                                    self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-transmit-rate"):
                                    self.total_transmit_rate = value
                                    self.total_transmit_rate.value_namespace = name_space
                                    self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "transmit-bytes"):
                                    self.transmit_bytes = value
                                    self.transmit_bytes.value_namespace = name_space
                                    self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "transmit-packets"):
                                    self.transmit_packets = value
                                    self.transmit_packets.value_namespace = name_space
                                    self.transmit_packets.value_namespace_prefix = name_space_prefix


                        class IphcStats(Entity):
                            """
                            IPHC stats
                            
                            .. attribute:: non_tcp_bytes_saved
                            
                            	Non Tcp Bytes saved due to compression
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: non_tcp_bytes_sent_rate
                            
                            	Compressed Non Tcp Bytes sent rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: non_tcp_compressed_packets_out
                            
                            	Num of non tcp compressed pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: non_tcp_full_header_packets_out
                            
                            	Num of non tcp fullheader pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: non_tcp_total_out_bytes
                            
                            	TotalNum of Non Tcp Bytes sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: non_tcp_total_out_packets
                            
                            	TotalNum of Non tcp pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tcp_bytes_saved
                            
                            	Tcp Bytes saved due to compression
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: tcp_bytes_sent_rate
                            
                            	Compressed Tcp Bytes sent rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: tcp_compressed_packets_out
                            
                            	Num of tcp compressed pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tcp_full_header_packets_out
                            
                            	Num of tcp fullheader pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tcp_total_out_bytes
                            
                            	TotalNum of Tcp Bytes sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: tcp_total_out_packets
                            
                            	Total Num of tcp pkts sent
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats, self).__init__()

                                self.yang_name = "iphc-stats"
                                self.yang_parent_name = "class-stats"

                                self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("non_tcp_bytes_saved",
                                                "non_tcp_bytes_sent_rate",
                                                "non_tcp_compressed_packets_out",
                                                "non_tcp_full_header_packets_out",
                                                "non_tcp_total_out_bytes",
                                                "non_tcp_total_out_packets",
                                                "tcp_bytes_saved",
                                                "tcp_bytes_sent_rate",
                                                "tcp_compressed_packets_out",
                                                "tcp_full_header_packets_out",
                                                "tcp_total_out_bytes",
                                                "tcp_total_out_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.non_tcp_bytes_saved.is_set or
                                    self.non_tcp_bytes_sent_rate.is_set or
                                    self.non_tcp_compressed_packets_out.is_set or
                                    self.non_tcp_full_header_packets_out.is_set or
                                    self.non_tcp_total_out_bytes.is_set or
                                    self.non_tcp_total_out_packets.is_set or
                                    self.tcp_bytes_saved.is_set or
                                    self.tcp_bytes_sent_rate.is_set or
                                    self.tcp_compressed_packets_out.is_set or
                                    self.tcp_full_header_packets_out.is_set or
                                    self.tcp_total_out_bytes.is_set or
                                    self.tcp_total_out_packets.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                    self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                    self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                    self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                    self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                    self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                    self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                    self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                    self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                    self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                    self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                    self.tcp_total_out_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "iphc-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "non-tcp-bytes-saved"):
                                    self.non_tcp_bytes_saved = value
                                    self.non_tcp_bytes_saved.value_namespace = name_space
                                    self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-bytes-sent-rate"):
                                    self.non_tcp_bytes_sent_rate = value
                                    self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                    self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-compressed-packets-out"):
                                    self.non_tcp_compressed_packets_out = value
                                    self.non_tcp_compressed_packets_out.value_namespace = name_space
                                    self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-full-header-packets-out"):
                                    self.non_tcp_full_header_packets_out = value
                                    self.non_tcp_full_header_packets_out.value_namespace = name_space
                                    self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-total-out-bytes"):
                                    self.non_tcp_total_out_bytes = value
                                    self.non_tcp_total_out_bytes.value_namespace = name_space
                                    self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "non-tcp-total-out-packets"):
                                    self.non_tcp_total_out_packets = value
                                    self.non_tcp_total_out_packets.value_namespace = name_space
                                    self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-bytes-saved"):
                                    self.tcp_bytes_saved = value
                                    self.tcp_bytes_saved.value_namespace = name_space
                                    self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-bytes-sent-rate"):
                                    self.tcp_bytes_sent_rate = value
                                    self.tcp_bytes_sent_rate.value_namespace = name_space
                                    self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-compressed-packets-out"):
                                    self.tcp_compressed_packets_out = value
                                    self.tcp_compressed_packets_out.value_namespace = name_space
                                    self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-full-header-packets-out"):
                                    self.tcp_full_header_packets_out = value
                                    self.tcp_full_header_packets_out.value_namespace = name_space
                                    self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-total-out-bytes"):
                                    self.tcp_total_out_bytes = value
                                    self.tcp_total_out_bytes.value_namespace = name_space
                                    self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcp-total-out-packets"):
                                    self.tcp_total_out_packets = value
                                    self.tcp_total_out_packets.value_namespace = name_space
                                    self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                        class ChildPolicy(Entity):
                            """
                            child policy
                            
                            .. attribute:: class_stats
                            
                            	array of classes contained in policy
                            	**type**\: list of    :py:class:`ClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats>`
                            
                            .. attribute:: policy_name
                            
                            	PolicyName
                            	**type**\:  str
                            
                            	**length:** 0..65
                            
                            .. attribute:: satid
                            
                            	to maintain satellite id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: state
                            
                            	State
                            	**type**\:   :py:class:`PolicyState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyState>`
                            
                            .. attribute:: state_description
                            
                            	StateDescription
                            	**type**\:  str
                            
                            	**length:** 0..128
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy, self).__init__()

                                self.yang_name = "child-policy"
                                self.yang_parent_name = "class-stats"

                                self.policy_name = YLeaf(YType.str, "policy-name")

                                self.satid = YLeaf(YType.uint32, "satid")

                                self.state = YLeaf(YType.enumeration, "state")

                                self.state_description = YLeaf(YType.str, "state-description")

                                self.class_stats = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("policy_name",
                                                "satid",
                                                "state",
                                                "state_description") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy, self).__setattr__(name, value)


                            class ClassStats(Entity):
                                """
                                array of classes contained in policy
                                
                                .. attribute:: cac_state
                                
                                	CACState
                                	**type**\:   :py:class:`CacState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.CacState>`
                                
                                .. attribute:: cac_stats
                                
                                	bag for cac stats
                                	**type**\:   :py:class:`CacStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats>`
                                
                                .. attribute:: class_name
                                
                                	ClassName
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: counter_validity_bitmask
                                
                                	 Bitmask to indicate which counter or counters are undetermined. Counters will be marked undetermined when one or more classes share queues with class\-default because in such cases the value of counters for each class is invalid. Based on the flag(s) set, the following counters will be marked undetermined. For example, if value of this object returned is 0x00000101, counters TransmitPackets/TransmitBytes/TotalTransmitRate and DropPackets/DropBytes are undetermined .0x00000001 \- Transmit (TransmitPackets/TransmitBytes/TotalTransmitRate ), 0x00000002 \- Total drop (TotalDropPackets/TotalDropBytes/TotalDropRate), 0x00000004 \- Match (MatchDataRate/PrepolicyMatchedPackets /PrepolicyMatchedBytes), 0x00000100 \- Police drop (DropPackets/DropBytes), 0x00000200 \- Police conform (ConformPackets/ConformBytes/ConformRate), 0x00000400 \- Police exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00000800 \- Police violate (ViolatePackets/ViolateBytes/ViolateRate), 0x00001000 \- Parent policer drop (ParentDropPackets/ParentDropBytes), 0x00010000 \- Queueing drop (TailDropPackets/TailDropBytes), 0x00020000 \- Red queue drop (RandomDropPackets/RandomDropBytes), 0x00040000 \- Queue maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes), 0x00080000 \- Queue conform (ConformPackets/ConformBytes/ConformRate), 0x00100000 \- Queue exceed (ExceedPackets/ExceedBytes/ExceedRate), 0x00200000 \- CLP limit drop (ATM\_CLP0DropPackets/ATM\_CLP0DropBytes /ATM\_CLP1DropPackets/ATM\_CLP1DropBytes), 0x01000000 \- RED transmit (RedTransmitPackets/RedTransmitBytes), 0x02000000 \- RED drop (RandomDropPackets/RandomDropBytes), 0x04000000 \- RED maximum threshold drop (MaxThresholdPackets/MaxThresholdBytes)
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: megabyte
                                
                                .. attribute:: general_stats
                                
                                	general stats
                                	**type**\:   :py:class:`GeneralStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats>`
                                
                                .. attribute:: iphc_stats
                                
                                	IPHC stats
                                	**type**\:   :py:class:`IphcStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats>`
                                
                                .. attribute:: police_stats_array
                                
                                	array of police stats
                                	**type**\: list of    :py:class:`PoliceStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray>`
                                
                                .. attribute:: queue_descr
                                
                                	Description of queue for the class
                                	**type**\:  str
                                
                                	**length:** 0..256
                                
                                .. attribute:: queue_stats_array
                                
                                	array of queue stats
                                	**type**\: list of    :py:class:`QueueStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray>`
                                
                                .. attribute:: shared_queue_id
                                
                                	q\-id of the  shared queue for this class
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: wred_stats_array
                                
                                	array of red stats
                                	**type**\: list of    :py:class:`WredStatsArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__init__()

                                    self.yang_name = "class-stats"
                                    self.yang_parent_name = "child-policy"

                                    self.cac_state = YLeaf(YType.enumeration, "cac-state")

                                    self.class_name = YLeaf(YType.str, "class-name")

                                    self.counter_validity_bitmask = YLeaf(YType.uint64, "counter-validity-bitmask")

                                    self.queue_descr = YLeaf(YType.str, "queue-descr")

                                    self.shared_queue_id = YLeaf(YType.uint32, "shared-queue-id")

                                    self.cac_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                    self._children_yang_names.add("cac-stats")

                                    self.general_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                    self._children_yang_names.add("general-stats")

                                    self.iphc_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                    self._children_yang_names.add("iphc-stats")

                                    self.police_stats_array = YList(self)
                                    self.queue_stats_array = YList(self)
                                    self.wred_stats_array = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cac_state",
                                                    "class_name",
                                                    "counter_validity_bitmask",
                                                    "queue_descr",
                                                    "shared_queue_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats, self).__setattr__(name, value)


                                class GeneralStats(Entity):
                                    """
                                    general stats
                                    
                                    .. attribute:: match_data_rate
                                    
                                    	Incoming matched data rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: pre_policy_matched_bytes
                                    
                                    	Matched bytes before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: pre_policy_matched_packets
                                    
                                    	Matched pkts before applying policy
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: total_drop_bytes
                                    
                                    	Dropped bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_packets
                                    
                                    	Dropped packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_drop_rate
                                    
                                    	Total drop rate (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: total_transmit_rate
                                    
                                    	Total transmit rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: transmit_bytes
                                    
                                    	Transmitted bytes (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: transmit_packets
                                    
                                    	Transmitted packets (packets/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__init__()

                                        self.yang_name = "general-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.match_data_rate = YLeaf(YType.uint32, "match-data-rate")

                                        self.pre_policy_matched_bytes = YLeaf(YType.uint64, "pre-policy-matched-bytes")

                                        self.pre_policy_matched_packets = YLeaf(YType.uint64, "pre-policy-matched-packets")

                                        self.total_drop_bytes = YLeaf(YType.uint64, "total-drop-bytes")

                                        self.total_drop_packets = YLeaf(YType.uint64, "total-drop-packets")

                                        self.total_drop_rate = YLeaf(YType.uint32, "total-drop-rate")

                                        self.total_transmit_rate = YLeaf(YType.uint32, "total-transmit-rate")

                                        self.transmit_bytes = YLeaf(YType.uint64, "transmit-bytes")

                                        self.transmit_packets = YLeaf(YType.uint64, "transmit-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("match_data_rate",
                                                        "pre_policy_matched_bytes",
                                                        "pre_policy_matched_packets",
                                                        "total_drop_bytes",
                                                        "total_drop_packets",
                                                        "total_drop_rate",
                                                        "total_transmit_rate",
                                                        "transmit_bytes",
                                                        "transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.match_data_rate.is_set or
                                            self.pre_policy_matched_bytes.is_set or
                                            self.pre_policy_matched_packets.is_set or
                                            self.total_drop_bytes.is_set or
                                            self.total_drop_packets.is_set or
                                            self.total_drop_rate.is_set or
                                            self.total_transmit_rate.is_set or
                                            self.transmit_bytes.is_set or
                                            self.transmit_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.match_data_rate.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_bytes.yfilter != YFilter.not_set or
                                            self.pre_policy_matched_packets.yfilter != YFilter.not_set or
                                            self.total_drop_bytes.yfilter != YFilter.not_set or
                                            self.total_drop_packets.yfilter != YFilter.not_set or
                                            self.total_drop_rate.yfilter != YFilter.not_set or
                                            self.total_transmit_rate.yfilter != YFilter.not_set or
                                            self.transmit_bytes.yfilter != YFilter.not_set or
                                            self.transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "general-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.match_data_rate.is_set or self.match_data_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.match_data_rate.get_name_leafdata())
                                        if (self.pre_policy_matched_bytes.is_set or self.pre_policy_matched_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_bytes.get_name_leafdata())
                                        if (self.pre_policy_matched_packets.is_set or self.pre_policy_matched_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pre_policy_matched_packets.get_name_leafdata())
                                        if (self.total_drop_bytes.is_set or self.total_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_bytes.get_name_leafdata())
                                        if (self.total_drop_packets.is_set or self.total_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_packets.get_name_leafdata())
                                        if (self.total_drop_rate.is_set or self.total_drop_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_drop_rate.get_name_leafdata())
                                        if (self.total_transmit_rate.is_set or self.total_transmit_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_transmit_rate.get_name_leafdata())
                                        if (self.transmit_bytes.is_set or self.transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_bytes.get_name_leafdata())
                                        if (self.transmit_packets.is_set or self.transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "match-data-rate" or name == "pre-policy-matched-bytes" or name == "pre-policy-matched-packets" or name == "total-drop-bytes" or name == "total-drop-packets" or name == "total-drop-rate" or name == "total-transmit-rate" or name == "transmit-bytes" or name == "transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "match-data-rate"):
                                            self.match_data_rate = value
                                            self.match_data_rate.value_namespace = name_space
                                            self.match_data_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-bytes"):
                                            self.pre_policy_matched_bytes = value
                                            self.pre_policy_matched_bytes.value_namespace = name_space
                                            self.pre_policy_matched_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pre-policy-matched-packets"):
                                            self.pre_policy_matched_packets = value
                                            self.pre_policy_matched_packets.value_namespace = name_space
                                            self.pre_policy_matched_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-bytes"):
                                            self.total_drop_bytes = value
                                            self.total_drop_bytes.value_namespace = name_space
                                            self.total_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-packets"):
                                            self.total_drop_packets = value
                                            self.total_drop_packets.value_namespace = name_space
                                            self.total_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-drop-rate"):
                                            self.total_drop_rate = value
                                            self.total_drop_rate.value_namespace = name_space
                                            self.total_drop_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-transmit-rate"):
                                            self.total_transmit_rate = value
                                            self.total_transmit_rate.value_namespace = name_space
                                            self.total_transmit_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-bytes"):
                                            self.transmit_bytes = value
                                            self.transmit_bytes.value_namespace = name_space
                                            self.transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "transmit-packets"):
                                            self.transmit_packets = value
                                            self.transmit_packets.value_namespace = name_space
                                            self.transmit_packets.value_namespace_prefix = name_space_prefix


                                class IphcStats(Entity):
                                    """
                                    IPHC stats
                                    
                                    .. attribute:: non_tcp_bytes_saved
                                    
                                    	Non Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_bytes_sent_rate
                                    
                                    	Compressed Non Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_compressed_packets_out
                                    
                                    	Num of non tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_full_header_packets_out
                                    
                                    	Num of non tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: non_tcp_total_out_bytes
                                    
                                    	TotalNum of Non Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: non_tcp_total_out_packets
                                    
                                    	TotalNum of Non tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_bytes_saved
                                    
                                    	Tcp Bytes saved due to compression
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_bytes_sent_rate
                                    
                                    	Compressed Tcp Bytes sent rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_compressed_packets_out
                                    
                                    	Num of tcp compressed pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_full_header_packets_out
                                    
                                    	Num of tcp fullheader pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tcp_total_out_bytes
                                    
                                    	TotalNum of Tcp Bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tcp_total_out_packets
                                    
                                    	Total Num of tcp pkts sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__init__()

                                        self.yang_name = "iphc-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.non_tcp_bytes_saved = YLeaf(YType.uint64, "non-tcp-bytes-saved")

                                        self.non_tcp_bytes_sent_rate = YLeaf(YType.uint32, "non-tcp-bytes-sent-rate")

                                        self.non_tcp_compressed_packets_out = YLeaf(YType.uint64, "non-tcp-compressed-packets-out")

                                        self.non_tcp_full_header_packets_out = YLeaf(YType.uint64, "non-tcp-full-header-packets-out")

                                        self.non_tcp_total_out_bytes = YLeaf(YType.uint64, "non-tcp-total-out-bytes")

                                        self.non_tcp_total_out_packets = YLeaf(YType.uint64, "non-tcp-total-out-packets")

                                        self.tcp_bytes_saved = YLeaf(YType.uint64, "tcp-bytes-saved")

                                        self.tcp_bytes_sent_rate = YLeaf(YType.uint32, "tcp-bytes-sent-rate")

                                        self.tcp_compressed_packets_out = YLeaf(YType.uint64, "tcp-compressed-packets-out")

                                        self.tcp_full_header_packets_out = YLeaf(YType.uint64, "tcp-full-header-packets-out")

                                        self.tcp_total_out_bytes = YLeaf(YType.uint64, "tcp-total-out-bytes")

                                        self.tcp_total_out_packets = YLeaf(YType.uint64, "tcp-total-out-packets")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("non_tcp_bytes_saved",
                                                        "non_tcp_bytes_sent_rate",
                                                        "non_tcp_compressed_packets_out",
                                                        "non_tcp_full_header_packets_out",
                                                        "non_tcp_total_out_bytes",
                                                        "non_tcp_total_out_packets",
                                                        "tcp_bytes_saved",
                                                        "tcp_bytes_sent_rate",
                                                        "tcp_compressed_packets_out",
                                                        "tcp_full_header_packets_out",
                                                        "tcp_total_out_bytes",
                                                        "tcp_total_out_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.non_tcp_bytes_saved.is_set or
                                            self.non_tcp_bytes_sent_rate.is_set or
                                            self.non_tcp_compressed_packets_out.is_set or
                                            self.non_tcp_full_header_packets_out.is_set or
                                            self.non_tcp_total_out_bytes.is_set or
                                            self.non_tcp_total_out_packets.is_set or
                                            self.tcp_bytes_saved.is_set or
                                            self.tcp_bytes_sent_rate.is_set or
                                            self.tcp_compressed_packets_out.is_set or
                                            self.tcp_full_header_packets_out.is_set or
                                            self.tcp_total_out_bytes.is_set or
                                            self.tcp_total_out_packets.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.non_tcp_total_out_packets.yfilter != YFilter.not_set or
                                            self.tcp_bytes_saved.yfilter != YFilter.not_set or
                                            self.tcp_bytes_sent_rate.yfilter != YFilter.not_set or
                                            self.tcp_compressed_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_full_header_packets_out.yfilter != YFilter.not_set or
                                            self.tcp_total_out_bytes.yfilter != YFilter.not_set or
                                            self.tcp_total_out_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "iphc-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.non_tcp_bytes_saved.is_set or self.non_tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_saved.get_name_leafdata())
                                        if (self.non_tcp_bytes_sent_rate.is_set or self.non_tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.non_tcp_compressed_packets_out.is_set or self.non_tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.non_tcp_full_header_packets_out.is_set or self.non_tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.non_tcp_total_out_bytes.is_set or self.non_tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_bytes.get_name_leafdata())
                                        if (self.non_tcp_total_out_packets.is_set or self.non_tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.non_tcp_total_out_packets.get_name_leafdata())
                                        if (self.tcp_bytes_saved.is_set or self.tcp_bytes_saved.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_saved.get_name_leafdata())
                                        if (self.tcp_bytes_sent_rate.is_set or self.tcp_bytes_sent_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_bytes_sent_rate.get_name_leafdata())
                                        if (self.tcp_compressed_packets_out.is_set or self.tcp_compressed_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_compressed_packets_out.get_name_leafdata())
                                        if (self.tcp_full_header_packets_out.is_set or self.tcp_full_header_packets_out.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_full_header_packets_out.get_name_leafdata())
                                        if (self.tcp_total_out_bytes.is_set or self.tcp_total_out_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_bytes.get_name_leafdata())
                                        if (self.tcp_total_out_packets.is_set or self.tcp_total_out_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_total_out_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "non-tcp-bytes-saved" or name == "non-tcp-bytes-sent-rate" or name == "non-tcp-compressed-packets-out" or name == "non-tcp-full-header-packets-out" or name == "non-tcp-total-out-bytes" or name == "non-tcp-total-out-packets" or name == "tcp-bytes-saved" or name == "tcp-bytes-sent-rate" or name == "tcp-compressed-packets-out" or name == "tcp-full-header-packets-out" or name == "tcp-total-out-bytes" or name == "tcp-total-out-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "non-tcp-bytes-saved"):
                                            self.non_tcp_bytes_saved = value
                                            self.non_tcp_bytes_saved.value_namespace = name_space
                                            self.non_tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-bytes-sent-rate"):
                                            self.non_tcp_bytes_sent_rate = value
                                            self.non_tcp_bytes_sent_rate.value_namespace = name_space
                                            self.non_tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-compressed-packets-out"):
                                            self.non_tcp_compressed_packets_out = value
                                            self.non_tcp_compressed_packets_out.value_namespace = name_space
                                            self.non_tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-full-header-packets-out"):
                                            self.non_tcp_full_header_packets_out = value
                                            self.non_tcp_full_header_packets_out.value_namespace = name_space
                                            self.non_tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-bytes"):
                                            self.non_tcp_total_out_bytes = value
                                            self.non_tcp_total_out_bytes.value_namespace = name_space
                                            self.non_tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "non-tcp-total-out-packets"):
                                            self.non_tcp_total_out_packets = value
                                            self.non_tcp_total_out_packets.value_namespace = name_space
                                            self.non_tcp_total_out_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-saved"):
                                            self.tcp_bytes_saved = value
                                            self.tcp_bytes_saved.value_namespace = name_space
                                            self.tcp_bytes_saved.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-bytes-sent-rate"):
                                            self.tcp_bytes_sent_rate = value
                                            self.tcp_bytes_sent_rate.value_namespace = name_space
                                            self.tcp_bytes_sent_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-compressed-packets-out"):
                                            self.tcp_compressed_packets_out = value
                                            self.tcp_compressed_packets_out.value_namespace = name_space
                                            self.tcp_compressed_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-full-header-packets-out"):
                                            self.tcp_full_header_packets_out = value
                                            self.tcp_full_header_packets_out.value_namespace = name_space
                                            self.tcp_full_header_packets_out.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-bytes"):
                                            self.tcp_total_out_bytes = value
                                            self.tcp_total_out_bytes.value_namespace = name_space
                                            self.tcp_total_out_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-total-out-packets"):
                                            self.tcp_total_out_packets = value
                                            self.tcp_total_out_packets.value_namespace = name_space
                                            self.tcp_total_out_packets.value_namespace_prefix = name_space_prefix


                                class CacStats(Entity):
                                    """
                                    bag for cac stats
                                    
                                    .. attribute:: admit_bytes
                                    
                                    	Admitted bytes (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: admit_rates
                                    
                                    	CAC admit rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: admitpackets
                                    
                                    	Admitted packets (pkts/bytes)
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	CAC dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	CAC dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: drop_rates
                                    
                                    	CAC dropped rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__init__()

                                        self.yang_name = "cac-stats"
                                        self.yang_parent_name = "class-stats"

                                        self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                        self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                        self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("admit_bytes",
                                                        "admit_rates",
                                                        "admitpackets",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "drop_rates") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.admit_bytes.is_set or
                                            self.admit_rates.is_set or
                                            self.admitpackets.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.drop_rates.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.admit_bytes.yfilter != YFilter.not_set or
                                            self.admit_rates.yfilter != YFilter.not_set or
                                            self.admitpackets.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.drop_rates.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "cac-stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                        if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                        if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "admit-bytes"):
                                            self.admit_bytes = value
                                            self.admit_bytes.value_namespace = name_space
                                            self.admit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admit-rates"):
                                            self.admit_rates = value
                                            self.admit_rates.value_namespace = name_space
                                            self.admit_rates.value_namespace_prefix = name_space_prefix
                                        if(value_path == "admitpackets"):
                                            self.admitpackets = value
                                            self.admitpackets.value_namespace = name_space
                                            self.admitpackets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-rates"):
                                            self.drop_rates = value
                                            self.drop_rates.value_namespace = name_space
                                            self.drop_rates.value_namespace_prefix = name_space_prefix


                                class QueueStatsArray(Entity):
                                    """
                                    array of queue stats
                                    
                                    .. attribute:: atm_clp0_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp0_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: atm_clp1_drop_bytes
                                    
                                    	ATP CLP 0 matched bytes dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: atm_clp1_drop_packets
                                    
                                    	ATP CLP 0 matched packets dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the queue rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: forced_wred_stats_display
                                    
                                    	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                                    	**type**\:  bool
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: queue_average_length
                                    
                                    	Queue average length
                                    	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength>`
                                    
                                    .. attribute:: queue_drop_threshold
                                    
                                    	tail drop threshold of the queue in bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: queue_id
                                    
                                    	Queue Id used for Fabric Stats
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: queue_instance_length
                                    
                                    	Queue instance length
                                    	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength>`
                                    
                                    .. attribute:: queue_max_length
                                    
                                    	Queue maximum length
                                    	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength>`
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Bytes probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Packets probabilistically dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: tail_drop_bytes
                                    
                                    	Bytes tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: tail_drop_packets
                                    
                                    	Packets tail dropped
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__init__()

                                        self.yang_name = "queue-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                        self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                        self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                        self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                        self.queue_id = YLeaf(YType.uint32, "queue-id")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                        self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                        self.queue_average_length = YList(self)
                                        self.queue_instance_length = YList(self)
                                        self.queue_max_length = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("atm_clp0_drop_bytes",
                                                        "atm_clp0_drop_packets",
                                                        "atm_clp1_drop_bytes",
                                                        "atm_clp1_drop_packets",
                                                        "conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "forced_wred_stats_display",
                                                        "max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "queue_drop_threshold",
                                                        "queue_id",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "tail_drop_bytes",
                                                        "tail_drop_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                                    class QueueInstanceLength(Entity):
                                        """
                                        Queue instance length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                            self.yang_name = "queue-instance-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-instance-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueAverageLength(Entity):
                                        """
                                        Queue average length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                            self.yang_name = "queue-average-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-average-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class QueueMaxLength(Entity):
                                        """
                                        Queue maximum length
                                        
                                        .. attribute:: unit
                                        
                                        	unit
                                        	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                            self.yang_name = "queue-max-length"
                                            self.yang_parent_name = "queue-stats-array"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-max-length" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.queue_average_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_data()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.atm_clp0_drop_bytes.is_set or
                                            self.atm_clp0_drop_packets.is_set or
                                            self.atm_clp1_drop_bytes.is_set or
                                            self.atm_clp1_drop_packets.is_set or
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.forced_wred_stats_display.is_set or
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.queue_drop_threshold.is_set or
                                            self.queue_id.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.tail_drop_bytes.is_set or
                                            self.tail_drop_packets.is_set)

                                    def has_operation(self):
                                        for c in self.queue_average_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_instance_length:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.queue_max_length:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                            self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.queue_drop_threshold.yfilter != YFilter.not_set or
                                            self.queue_id.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.tail_drop_bytes.yfilter != YFilter.not_set or
                                            self.tail_drop_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "queue-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                        if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                        if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                        if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.queue_id.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                        if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "queue-average-length"):
                                            for c in self.queue_average_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueAverageLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_average_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-instance-length"):
                                            for c in self.queue_instance_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueInstanceLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_instance_length.append(c)
                                            return c

                                        if (child_yang_name == "queue-max-length"):
                                            for c in self.queue_max_length:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray.QueueMaxLength()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.queue_max_length.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "atm-clp0-drop-bytes"):
                                            self.atm_clp0_drop_bytes = value
                                            self.atm_clp0_drop_bytes.value_namespace = name_space
                                            self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp0-drop-packets"):
                                            self.atm_clp0_drop_packets = value
                                            self.atm_clp0_drop_packets.value_namespace = name_space
                                            self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-bytes"):
                                            self.atm_clp1_drop_bytes = value
                                            self.atm_clp1_drop_bytes.value_namespace = name_space
                                            self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "atm-clp1-drop-packets"):
                                            self.atm_clp1_drop_packets = value
                                            self.atm_clp1_drop_packets.value_namespace = name_space
                                            self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forced-wred-stats-display"):
                                            self.forced_wred_stats_display = value
                                            self.forced_wred_stats_display.value_namespace = name_space
                                            self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-drop-threshold"):
                                            self.queue_drop_threshold = value
                                            self.queue_drop_threshold.value_namespace = name_space
                                            self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                        if(value_path == "queue-id"):
                                            self.queue_id = value
                                            self.queue_id.value_namespace = name_space
                                            self.queue_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-bytes"):
                                            self.tail_drop_bytes = value
                                            self.tail_drop_bytes.value_namespace = name_space
                                            self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tail-drop-packets"):
                                            self.tail_drop_packets = value
                                            self.tail_drop_packets.value_namespace = name_space
                                            self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                                class PoliceStatsArray(Entity):
                                    """
                                    array of police stats
                                    
                                    .. attribute:: color_class_stats
                                    
                                    	color class stats
                                    	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats>`
                                    
                                    .. attribute:: conform_bytes
                                    
                                    	Bytes that conform to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: conform_packets
                                    
                                    	Packets that conform  to the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: conform_rate
                                    
                                    	Conform rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: drop_bytes
                                    
                                    	Police dropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: drop_packets
                                    
                                    	Police dropped packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_bytes
                                    
                                    	Bytes that exceed  the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: exceed_packets
                                    
                                    	Packets that exceed the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: exceed_rate
                                    
                                    	Exceed rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: parent_drop_bytes
                                    
                                    	Dropped bytes by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: parent_drop_packets
                                    
                                    	Dropped pkts by the parent policer
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_bytes
                                    
                                    	Bytes that violate the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: violate_packets
                                    
                                    	Packets violating the policed rate
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: violate_rate
                                    
                                    	Violate rate in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__init__()

                                        self.yang_name = "police-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                        self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                        self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                        self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                        self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                        self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                        self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                        self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                        self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                        self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                        self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                        self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                        self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                        self.color_class_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                        self._children_yang_names.add("color-class-stats")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("conform_bytes",
                                                        "conform_packets",
                                                        "conform_rate",
                                                        "drop_bytes",
                                                        "drop_packets",
                                                        "exceed_bytes",
                                                        "exceed_packets",
                                                        "exceed_rate",
                                                        "parent_drop_bytes",
                                                        "parent_drop_packets",
                                                        "violate_bytes",
                                                        "violate_packets",
                                                        "violate_rate") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                                    class ColorClassStats(Entity):
                                        """
                                        color class stats
                                        
                                        .. attribute:: conform_class_conform_bytes
                                        
                                        	Bytes with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_conform_packets
                                        
                                        	Packets with classification result conform and policer result conform
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_conform_rate
                                        
                                        	Conform Class Conform rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_exceed_bytes
                                        
                                        	Bytes with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_exceed_packets
                                        
                                        	Packets with classification result conform and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_exceed_rate
                                        
                                        	Conform Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: conform_class_violate_bytes
                                        
                                        	Bytes with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: conform_class_violate_packets
                                        
                                        	Packets with classification result conform and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: conform_class_violate_rate
                                        
                                        	Conform Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_exceed_bytes
                                        
                                        	Bytes with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_exceed_packets
                                        
                                        	Packets with classification result exceed and policer result exceed
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_exceed_rate
                                        
                                        	Exceed Class Exceed rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: exceed_class_violate_bytes
                                        
                                        	Bytes with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: exceed_class_violate_packets
                                        
                                        	Packets with classification result exceed and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: exceed_class_violate_rate
                                        
                                        	Exceed Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: violate_class_violate_bytes
                                        
                                        	Bytes with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: violate_class_violate_packets
                                        
                                        	Packets with classification result violate and policer result violate
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: violate_class_violate_rate
                                        
                                        	Violate Class Violate rate in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                            self.yang_name = "color-class-stats"
                                            self.yang_parent_name = "police-stats-array"

                                            self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                            self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                            self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                            self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                            self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                            self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                            self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                            self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                            self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                            self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                            self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                            self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                            self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                            self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                            self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                            self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                            self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                            self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("conform_class_conform_bytes",
                                                            "conform_class_conform_packets",
                                                            "conform_class_conform_rate",
                                                            "conform_class_exceed_bytes",
                                                            "conform_class_exceed_packets",
                                                            "conform_class_exceed_rate",
                                                            "conform_class_violate_bytes",
                                                            "conform_class_violate_packets",
                                                            "conform_class_violate_rate",
                                                            "exceed_class_exceed_bytes",
                                                            "exceed_class_exceed_packets",
                                                            "exceed_class_exceed_rate",
                                                            "exceed_class_violate_bytes",
                                                            "exceed_class_violate_packets",
                                                            "exceed_class_violate_rate",
                                                            "violate_class_violate_bytes",
                                                            "violate_class_violate_packets",
                                                            "violate_class_violate_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.conform_class_conform_bytes.is_set or
                                                self.conform_class_conform_packets.is_set or
                                                self.conform_class_conform_rate.is_set or
                                                self.conform_class_exceed_bytes.is_set or
                                                self.conform_class_exceed_packets.is_set or
                                                self.conform_class_exceed_rate.is_set or
                                                self.conform_class_violate_bytes.is_set or
                                                self.conform_class_violate_packets.is_set or
                                                self.conform_class_violate_rate.is_set or
                                                self.exceed_class_exceed_bytes.is_set or
                                                self.exceed_class_exceed_packets.is_set or
                                                self.exceed_class_exceed_rate.is_set or
                                                self.exceed_class_violate_bytes.is_set or
                                                self.exceed_class_violate_packets.is_set or
                                                self.exceed_class_violate_rate.is_set or
                                                self.violate_class_violate_bytes.is_set or
                                                self.violate_class_violate_packets.is_set or
                                                self.violate_class_violate_rate.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                                self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                                self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                                self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                                self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                                self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                                self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "color-class-stats" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                            if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                            if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                            if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                            if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                            if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                            if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                            if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                            if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                            if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                            if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                            if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                            if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                            if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                            if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                            if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                            if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                            if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "conform-class-conform-bytes"):
                                                self.conform_class_conform_bytes = value
                                                self.conform_class_conform_bytes.value_namespace = name_space
                                                self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-packets"):
                                                self.conform_class_conform_packets = value
                                                self.conform_class_conform_packets.value_namespace = name_space
                                                self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-conform-rate"):
                                                self.conform_class_conform_rate = value
                                                self.conform_class_conform_rate.value_namespace = name_space
                                                self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-bytes"):
                                                self.conform_class_exceed_bytes = value
                                                self.conform_class_exceed_bytes.value_namespace = name_space
                                                self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-packets"):
                                                self.conform_class_exceed_packets = value
                                                self.conform_class_exceed_packets.value_namespace = name_space
                                                self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-exceed-rate"):
                                                self.conform_class_exceed_rate = value
                                                self.conform_class_exceed_rate.value_namespace = name_space
                                                self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-bytes"):
                                                self.conform_class_violate_bytes = value
                                                self.conform_class_violate_bytes.value_namespace = name_space
                                                self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-packets"):
                                                self.conform_class_violate_packets = value
                                                self.conform_class_violate_packets.value_namespace = name_space
                                                self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "conform-class-violate-rate"):
                                                self.conform_class_violate_rate = value
                                                self.conform_class_violate_rate.value_namespace = name_space
                                                self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-bytes"):
                                                self.exceed_class_exceed_bytes = value
                                                self.exceed_class_exceed_bytes.value_namespace = name_space
                                                self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-packets"):
                                                self.exceed_class_exceed_packets = value
                                                self.exceed_class_exceed_packets.value_namespace = name_space
                                                self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-exceed-rate"):
                                                self.exceed_class_exceed_rate = value
                                                self.exceed_class_exceed_rate.value_namespace = name_space
                                                self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-bytes"):
                                                self.exceed_class_violate_bytes = value
                                                self.exceed_class_violate_bytes.value_namespace = name_space
                                                self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-packets"):
                                                self.exceed_class_violate_packets = value
                                                self.exceed_class_violate_packets.value_namespace = name_space
                                                self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exceed-class-violate-rate"):
                                                self.exceed_class_violate_rate = value
                                                self.exceed_class_violate_rate.value_namespace = name_space
                                                self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-bytes"):
                                                self.violate_class_violate_bytes = value
                                                self.violate_class_violate_bytes.value_namespace = name_space
                                                self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-packets"):
                                                self.violate_class_violate_packets = value
                                                self.violate_class_violate_packets.value_namespace = name_space
                                                self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                            if(value_path == "violate-class-violate-rate"):
                                                self.violate_class_violate_rate = value
                                                self.violate_class_violate_rate.value_namespace = name_space
                                                self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.conform_bytes.is_set or
                                            self.conform_packets.is_set or
                                            self.conform_rate.is_set or
                                            self.drop_bytes.is_set or
                                            self.drop_packets.is_set or
                                            self.exceed_bytes.is_set or
                                            self.exceed_packets.is_set or
                                            self.exceed_rate.is_set or
                                            self.parent_drop_bytes.is_set or
                                            self.parent_drop_packets.is_set or
                                            self.violate_bytes.is_set or
                                            self.violate_packets.is_set or
                                            self.violate_rate.is_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.conform_bytes.yfilter != YFilter.not_set or
                                            self.conform_packets.yfilter != YFilter.not_set or
                                            self.conform_rate.yfilter != YFilter.not_set or
                                            self.drop_bytes.yfilter != YFilter.not_set or
                                            self.drop_packets.yfilter != YFilter.not_set or
                                            self.exceed_bytes.yfilter != YFilter.not_set or
                                            self.exceed_packets.yfilter != YFilter.not_set or
                                            self.exceed_rate.yfilter != YFilter.not_set or
                                            self.parent_drop_bytes.yfilter != YFilter.not_set or
                                            self.parent_drop_packets.yfilter != YFilter.not_set or
                                            self.violate_bytes.yfilter != YFilter.not_set or
                                            self.violate_packets.yfilter != YFilter.not_set or
                                            self.violate_rate.yfilter != YFilter.not_set or
                                            (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "police-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                        if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                        if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                        if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                        if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                        if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                        if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                        if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                        if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                        if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                        if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                        if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                        if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "color-class-stats"):
                                            if (self.color_class_stats is None):
                                                self.color_class_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray.ColorClassStats()
                                                self.color_class_stats.parent = self
                                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                            return self.color_class_stats

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "conform-bytes"):
                                            self.conform_bytes = value
                                            self.conform_bytes.value_namespace = name_space
                                            self.conform_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-packets"):
                                            self.conform_packets = value
                                            self.conform_packets.value_namespace = name_space
                                            self.conform_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "conform-rate"):
                                            self.conform_rate = value
                                            self.conform_rate.value_namespace = name_space
                                            self.conform_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-bytes"):
                                            self.drop_bytes = value
                                            self.drop_bytes.value_namespace = name_space
                                            self.drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "drop-packets"):
                                            self.drop_packets = value
                                            self.drop_packets.value_namespace = name_space
                                            self.drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-bytes"):
                                            self.exceed_bytes = value
                                            self.exceed_bytes.value_namespace = name_space
                                            self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-packets"):
                                            self.exceed_packets = value
                                            self.exceed_packets.value_namespace = name_space
                                            self.exceed_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exceed-rate"):
                                            self.exceed_rate = value
                                            self.exceed_rate.value_namespace = name_space
                                            self.exceed_rate.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-bytes"):
                                            self.parent_drop_bytes = value
                                            self.parent_drop_bytes.value_namespace = name_space
                                            self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-drop-packets"):
                                            self.parent_drop_packets = value
                                            self.parent_drop_packets.value_namespace = name_space
                                            self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-bytes"):
                                            self.violate_bytes = value
                                            self.violate_bytes.value_namespace = name_space
                                            self.violate_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-packets"):
                                            self.violate_packets = value
                                            self.violate_packets.value_namespace = name_space
                                            self.violate_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "violate-rate"):
                                            self.violate_rate = value
                                            self.violate_rate.value_namespace = name_space
                                            self.violate_rate.value_namespace_prefix = name_space_prefix


                                class WredStatsArray(Entity):
                                    """
                                    array of red stats
                                    
                                    .. attribute:: max_threshold_bytes
                                    
                                    	Dropped bytes with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: max_threshold_packets
                                    
                                    	Dropped packets with  the average queue size at the max\-threshold
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: profile_title
                                    
                                    	ProfileTitle
                                    	**type**\:  str
                                    
                                    	**length:** 0..300
                                    
                                    .. attribute:: random_drop_bytes
                                    
                                    	Probabilisticallydropped bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: random_drop_packets
                                    
                                    	Probabilistically dropped  packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_ecn_marked_bytes
                                    
                                    	ECN marked bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_ecn_marked_packets
                                    
                                    	ECN marked packets 
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: red_label
                                    
                                    	Array of WRED Typevalues as in PRP stats is available per threshold   
                                    	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel>`
                                    
                                    .. attribute:: red_transmit_bytes
                                    
                                    	Transmitted bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: red_transmit_packets
                                    
                                    	Transmitted packets
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'qos-ma-oper'
                                    _revision = '2017-04-10'

                                    def __init__(self):
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__init__()

                                        self.yang_name = "wred-stats-array"
                                        self.yang_parent_name = "class-stats"

                                        self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                        self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                        self.profile_title = YLeaf(YType.str, "profile-title")

                                        self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                        self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                        self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                        self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                        self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                        self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                        self.red_label = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("max_threshold_bytes",
                                                        "max_threshold_packets",
                                                        "profile_title",
                                                        "random_drop_bytes",
                                                        "random_drop_packets",
                                                        "red_ecn_marked_bytes",
                                                        "red_ecn_marked_packets",
                                                        "red_transmit_bytes",
                                                        "red_transmit_packets") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray, self).__setattr__(name, value)


                                    class RedLabel(Entity):
                                        """
                                        Array of WRED Typevalues as in PRP stats is
                                        available per threshold   
                                        
                                        .. attribute:: value
                                        
                                        	WRED value for this type
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: wred_type
                                        
                                        	WRED type DSCP, EXP, PREC etc
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'qos-ma-oper'
                                        _revision = '2017-04-10'

                                        def __init__(self):
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                            self.yang_name = "red-label"
                                            self.yang_parent_name = "wred-stats-array"

                                            self.value = YLeaf(YType.uint8, "value")

                                            self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("value",
                                                            "wred_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.value.is_set or
                                                self.wred_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set or
                                                self.wred_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "red-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())
                                            if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wred_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "value" or name == "wred-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wred-type"):
                                                self.wred_type = value
                                                self.wred_type.value_namespace = name_space
                                                self.wred_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.red_label:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.max_threshold_bytes.is_set or
                                            self.max_threshold_packets.is_set or
                                            self.profile_title.is_set or
                                            self.random_drop_bytes.is_set or
                                            self.random_drop_packets.is_set or
                                            self.red_ecn_marked_bytes.is_set or
                                            self.red_ecn_marked_packets.is_set or
                                            self.red_transmit_bytes.is_set or
                                            self.red_transmit_packets.is_set)

                                    def has_operation(self):
                                        for c in self.red_label:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.max_threshold_bytes.yfilter != YFilter.not_set or
                                            self.max_threshold_packets.yfilter != YFilter.not_set or
                                            self.profile_title.yfilter != YFilter.not_set or
                                            self.random_drop_bytes.yfilter != YFilter.not_set or
                                            self.random_drop_packets.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                            self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                            self.red_transmit_bytes.yfilter != YFilter.not_set or
                                            self.red_transmit_packets.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wred-stats-array" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                        if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                        if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.profile_title.get_name_leafdata())
                                        if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                        if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                        if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                        if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                        if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                        if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "red-label"):
                                            for c in self.red_label:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray.RedLabel()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.red_label.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "max-threshold-bytes"):
                                            self.max_threshold_bytes = value
                                            self.max_threshold_bytes.value_namespace = name_space
                                            self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "max-threshold-packets"):
                                            self.max_threshold_packets = value
                                            self.max_threshold_packets.value_namespace = name_space
                                            self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "profile-title"):
                                            self.profile_title = value
                                            self.profile_title.value_namespace = name_space
                                            self.profile_title.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-bytes"):
                                            self.random_drop_bytes = value
                                            self.random_drop_bytes.value_namespace = name_space
                                            self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "random-drop-packets"):
                                            self.random_drop_packets = value
                                            self.random_drop_packets.value_namespace = name_space
                                            self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-bytes"):
                                            self.red_ecn_marked_bytes = value
                                            self.red_ecn_marked_bytes.value_namespace = name_space
                                            self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-ecn-marked-packets"):
                                            self.red_ecn_marked_packets = value
                                            self.red_ecn_marked_packets.value_namespace = name_space
                                            self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-bytes"):
                                            self.red_transmit_bytes = value
                                            self.red_transmit_bytes.value_namespace = name_space
                                            self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "red-transmit-packets"):
                                            self.red_transmit_packets = value
                                            self.red_transmit_packets.value_namespace = name_space
                                            self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.police_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_data()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.cac_state.is_set or
                                        self.class_name.is_set or
                                        self.counter_validity_bitmask.is_set or
                                        self.queue_descr.is_set or
                                        self.shared_queue_id.is_set or
                                        (self.cac_stats is not None and self.cac_stats.has_data()) or
                                        (self.general_stats is not None and self.general_stats.has_data()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_data()))

                                def has_operation(self):
                                    for c in self.police_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.queue_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.wred_stats_array:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cac_state.yfilter != YFilter.not_set or
                                        self.class_name.yfilter != YFilter.not_set or
                                        self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                        self.queue_descr.yfilter != YFilter.not_set or
                                        self.shared_queue_id.yfilter != YFilter.not_set or
                                        (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                        (self.general_stats is not None and self.general_stats.has_operation()) or
                                        (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cac_state.get_name_leafdata())
                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                    if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                                    if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.queue_descr.get_name_leafdata())
                                    if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "cac-stats"):
                                        if (self.cac_stats is None):
                                            self.cac_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.CacStats()
                                            self.cac_stats.parent = self
                                            self._children_name_map["cac_stats"] = "cac-stats"
                                        return self.cac_stats

                                    if (child_yang_name == "general-stats"):
                                        if (self.general_stats is None):
                                            self.general_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.GeneralStats()
                                            self.general_stats.parent = self
                                            self._children_name_map["general_stats"] = "general-stats"
                                        return self.general_stats

                                    if (child_yang_name == "iphc-stats"):
                                        if (self.iphc_stats is None):
                                            self.iphc_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.IphcStats()
                                            self.iphc_stats.parent = self
                                            self._children_name_map["iphc_stats"] = "iphc-stats"
                                        return self.iphc_stats

                                    if (child_yang_name == "police-stats-array"):
                                        for c in self.police_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.PoliceStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.police_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "queue-stats-array"):
                                        for c in self.queue_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.QueueStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.queue_stats_array.append(c)
                                        return c

                                    if (child_yang_name == "wred-stats-array"):
                                        for c in self.wred_stats_array:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats.WredStatsArray()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.wred_stats_array.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "cac-stats" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cac-state"):
                                        self.cac_state = value
                                        self.cac_state.value_namespace = name_space
                                        self.cac_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "class-name"):
                                        self.class_name = value
                                        self.class_name.value_namespace = name_space
                                        self.class_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "counter-validity-bitmask"):
                                        self.counter_validity_bitmask = value
                                        self.counter_validity_bitmask.value_namespace = name_space
                                        self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                                    if(value_path == "queue-descr"):
                                        self.queue_descr = value
                                        self.queue_descr.value_namespace = name_space
                                        self.queue_descr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "shared-queue-id"):
                                        self.shared_queue_id = value
                                        self.shared_queue_id.value_namespace = name_space
                                        self.shared_queue_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.class_stats:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.policy_name.is_set or
                                    self.satid.is_set or
                                    self.state.is_set or
                                    self.state_description.is_set)

                            def has_operation(self):
                                for c in self.class_stats:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.policy_name.yfilter != YFilter.not_set or
                                    self.satid.yfilter != YFilter.not_set or
                                    self.state.yfilter != YFilter.not_set or
                                    self.state_description.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "child-policy" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_name.get_name_leafdata())
                                if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.satid.get_name_leafdata())
                                if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state.get_name_leafdata())
                                if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.state_description.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "class-stats"):
                                    for c in self.class_stats:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy.ClassStats()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.class_stats.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "policy-name"):
                                    self.policy_name = value
                                    self.policy_name.value_namespace = name_space
                                    self.policy_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "satid"):
                                    self.satid = value
                                    self.satid.value_namespace = name_space
                                    self.satid.value_namespace_prefix = name_space_prefix
                                if(value_path == "state"):
                                    self.state = value
                                    self.state.value_namespace = name_space
                                    self.state.value_namespace_prefix = name_space_prefix
                                if(value_path == "state-description"):
                                    self.state_description = value
                                    self.state_description.value_namespace = name_space
                                    self.state_description.value_namespace_prefix = name_space_prefix


                        class CacStats(Entity):
                            """
                            bag for cac stats
                            
                            .. attribute:: admit_bytes
                            
                            	Admitted bytes (pkts/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: admit_rates
                            
                            	CAC admit rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: admitpackets
                            
                            	Admitted packets (pkts/bytes)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: drop_bytes
                            
                            	CAC dropped bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: drop_packets
                            
                            	CAC dropped packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: drop_rates
                            
                            	CAC dropped rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.CacStats, self).__init__()

                                self.yang_name = "cac-stats"
                                self.yang_parent_name = "class-stats"

                                self.admit_bytes = YLeaf(YType.uint64, "admit-bytes")

                                self.admit_rates = YLeaf(YType.uint32, "admit-rates")

                                self.admitpackets = YLeaf(YType.uint64, "admitpackets")

                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                self.drop_rates = YLeaf(YType.uint32, "drop-rates")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("admit_bytes",
                                                "admit_rates",
                                                "admitpackets",
                                                "drop_bytes",
                                                "drop_packets",
                                                "drop_rates") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.CacStats, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.admit_bytes.is_set or
                                    self.admit_rates.is_set or
                                    self.admitpackets.is_set or
                                    self.drop_bytes.is_set or
                                    self.drop_packets.is_set or
                                    self.drop_rates.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.admit_bytes.yfilter != YFilter.not_set or
                                    self.admit_rates.yfilter != YFilter.not_set or
                                    self.admitpackets.yfilter != YFilter.not_set or
                                    self.drop_bytes.yfilter != YFilter.not_set or
                                    self.drop_packets.yfilter != YFilter.not_set or
                                    self.drop_rates.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "cac-stats" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.admit_bytes.is_set or self.admit_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admit_bytes.get_name_leafdata())
                                if (self.admit_rates.is_set or self.admit_rates.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admit_rates.get_name_leafdata())
                                if (self.admitpackets.is_set or self.admitpackets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admitpackets.get_name_leafdata())
                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                if (self.drop_rates.is_set or self.drop_rates.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_rates.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "admit-bytes" or name == "admit-rates" or name == "admitpackets" or name == "drop-bytes" or name == "drop-packets" or name == "drop-rates"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "admit-bytes"):
                                    self.admit_bytes = value
                                    self.admit_bytes.value_namespace = name_space
                                    self.admit_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "admit-rates"):
                                    self.admit_rates = value
                                    self.admit_rates.value_namespace = name_space
                                    self.admit_rates.value_namespace_prefix = name_space_prefix
                                if(value_path == "admitpackets"):
                                    self.admitpackets = value
                                    self.admitpackets.value_namespace = name_space
                                    self.admitpackets.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-bytes"):
                                    self.drop_bytes = value
                                    self.drop_bytes.value_namespace = name_space
                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-packets"):
                                    self.drop_packets = value
                                    self.drop_packets.value_namespace = name_space
                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-rates"):
                                    self.drop_rates = value
                                    self.drop_rates.value_namespace = name_space
                                    self.drop_rates.value_namespace_prefix = name_space_prefix


                        class QueueStatsArray(Entity):
                            """
                            array of queue stats
                            
                            .. attribute:: atm_clp0_drop_bytes
                            
                            	ATP CLP 0 matched bytes dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: atm_clp0_drop_packets
                            
                            	ATP CLP 0 matched packets dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: atm_clp1_drop_bytes
                            
                            	ATP CLP 0 matched bytes dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: atm_clp1_drop_packets
                            
                            	ATP CLP 0 matched packets dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: conform_bytes
                            
                            	Bytes that conform to the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: conform_packets
                            
                            	Packets that conform  to the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: conform_rate
                            
                            	Conform rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: exceed_bytes
                            
                            	Bytes that exceed  the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: exceed_packets
                            
                            	Packets that exceed the queue rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: exceed_rate
                            
                            	Exceed rate
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: forced_wred_stats_display
                            
                            	flag to forcedisplay of WRED even when per WredWRED profile stats is not available
                            	**type**\:  bool
                            
                            .. attribute:: max_threshold_bytes
                            
                            	Dropped bytes with the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: max_threshold_packets
                            
                            	Dropped packets with the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: queue_average_length
                            
                            	Queue average length
                            	**type**\: list of    :py:class:`QueueAverageLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength>`
                            
                            .. attribute:: queue_drop_threshold
                            
                            	tail drop threshold of the queue in bytes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: byte
                            
                            .. attribute:: queue_id
                            
                            	Queue Id used for Fabric Stats
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: queue_instance_length
                            
                            	Queue instance length
                            	**type**\: list of    :py:class:`QueueInstanceLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength>`
                            
                            .. attribute:: queue_max_length
                            
                            	Queue maximum length
                            	**type**\: list of    :py:class:`QueueMaxLength <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength>`
                            
                            .. attribute:: random_drop_bytes
                            
                            	Bytes probabilistically dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: random_drop_packets
                            
                            	Packets probabilistically dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: tail_drop_bytes
                            
                            	Bytes tail dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: tail_drop_packets
                            
                            	Packets tail dropped
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray, self).__init__()

                                self.yang_name = "queue-stats-array"
                                self.yang_parent_name = "class-stats"

                                self.atm_clp0_drop_bytes = YLeaf(YType.uint64, "atm-clp0-drop-bytes")

                                self.atm_clp0_drop_packets = YLeaf(YType.uint64, "atm-clp0-drop-packets")

                                self.atm_clp1_drop_bytes = YLeaf(YType.uint64, "atm-clp1-drop-bytes")

                                self.atm_clp1_drop_packets = YLeaf(YType.uint64, "atm-clp1-drop-packets")

                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                self.forced_wred_stats_display = YLeaf(YType.boolean, "forced-wred-stats-display")

                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                self.queue_drop_threshold = YLeaf(YType.uint32, "queue-drop-threshold")

                                self.queue_id = YLeaf(YType.uint32, "queue-id")

                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                self.tail_drop_bytes = YLeaf(YType.uint64, "tail-drop-bytes")

                                self.tail_drop_packets = YLeaf(YType.uint64, "tail-drop-packets")

                                self.queue_average_length = YList(self)
                                self.queue_instance_length = YList(self)
                                self.queue_max_length = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("atm_clp0_drop_bytes",
                                                "atm_clp0_drop_packets",
                                                "atm_clp1_drop_bytes",
                                                "atm_clp1_drop_packets",
                                                "conform_bytes",
                                                "conform_packets",
                                                "conform_rate",
                                                "exceed_bytes",
                                                "exceed_packets",
                                                "exceed_rate",
                                                "forced_wred_stats_display",
                                                "max_threshold_bytes",
                                                "max_threshold_packets",
                                                "queue_drop_threshold",
                                                "queue_id",
                                                "random_drop_bytes",
                                                "random_drop_packets",
                                                "tail_drop_bytes",
                                                "tail_drop_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray, self).__setattr__(name, value)


                            class QueueInstanceLength(Entity):
                                """
                                Queue instance length
                                
                                .. attribute:: unit
                                
                                	unit
                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                
                                .. attribute:: value
                                
                                	value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__init__()

                                    self.yang_name = "queue-instance-length"
                                    self.yang_parent_name = "queue-stats-array"

                                    self.unit = YLeaf(YType.enumeration, "unit")

                                    self.value = YLeaf(YType.uint32, "value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("unit",
                                                    "value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.unit.is_set or
                                        self.value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.unit.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "queue-instance-length" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "unit" or name == "value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "unit"):
                                        self.unit = value
                                        self.unit.value_namespace = name_space
                                        self.unit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix


                            class QueueAverageLength(Entity):
                                """
                                Queue average length
                                
                                .. attribute:: unit
                                
                                	unit
                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                
                                .. attribute:: value
                                
                                	value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__init__()

                                    self.yang_name = "queue-average-length"
                                    self.yang_parent_name = "queue-stats-array"

                                    self.unit = YLeaf(YType.enumeration, "unit")

                                    self.value = YLeaf(YType.uint32, "value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("unit",
                                                    "value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.unit.is_set or
                                        self.value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.unit.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "queue-average-length" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "unit" or name == "value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "unit"):
                                        self.unit = value
                                        self.unit.value_namespace = name_space
                                        self.unit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix


                            class QueueMaxLength(Entity):
                                """
                                Queue maximum length
                                
                                .. attribute:: unit
                                
                                	unit
                                	**type**\:   :py:class:`PolicyParamUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.PolicyParamUnit>`
                                
                                .. attribute:: value
                                
                                	value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__init__()

                                    self.yang_name = "queue-max-length"
                                    self.yang_parent_name = "queue-stats-array"

                                    self.unit = YLeaf(YType.enumeration, "unit")

                                    self.value = YLeaf(YType.uint32, "value")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("unit",
                                                    "value") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.unit.is_set or
                                        self.value.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.unit.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "queue-max-length" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "unit" or name == "value"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "unit"):
                                        self.unit = value
                                        self.unit.value_namespace = name_space
                                        self.unit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.queue_average_length:
                                    if (c.has_data()):
                                        return True
                                for c in self.queue_instance_length:
                                    if (c.has_data()):
                                        return True
                                for c in self.queue_max_length:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.atm_clp0_drop_bytes.is_set or
                                    self.atm_clp0_drop_packets.is_set or
                                    self.atm_clp1_drop_bytes.is_set or
                                    self.atm_clp1_drop_packets.is_set or
                                    self.conform_bytes.is_set or
                                    self.conform_packets.is_set or
                                    self.conform_rate.is_set or
                                    self.exceed_bytes.is_set or
                                    self.exceed_packets.is_set or
                                    self.exceed_rate.is_set or
                                    self.forced_wred_stats_display.is_set or
                                    self.max_threshold_bytes.is_set or
                                    self.max_threshold_packets.is_set or
                                    self.queue_drop_threshold.is_set or
                                    self.queue_id.is_set or
                                    self.random_drop_bytes.is_set or
                                    self.random_drop_packets.is_set or
                                    self.tail_drop_bytes.is_set or
                                    self.tail_drop_packets.is_set)

                            def has_operation(self):
                                for c in self.queue_average_length:
                                    if (c.has_operation()):
                                        return True
                                for c in self.queue_instance_length:
                                    if (c.has_operation()):
                                        return True
                                for c in self.queue_max_length:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.atm_clp0_drop_bytes.yfilter != YFilter.not_set or
                                    self.atm_clp0_drop_packets.yfilter != YFilter.not_set or
                                    self.atm_clp1_drop_bytes.yfilter != YFilter.not_set or
                                    self.atm_clp1_drop_packets.yfilter != YFilter.not_set or
                                    self.conform_bytes.yfilter != YFilter.not_set or
                                    self.conform_packets.yfilter != YFilter.not_set or
                                    self.conform_rate.yfilter != YFilter.not_set or
                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                    self.exceed_packets.yfilter != YFilter.not_set or
                                    self.exceed_rate.yfilter != YFilter.not_set or
                                    self.forced_wred_stats_display.yfilter != YFilter.not_set or
                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                    self.queue_drop_threshold.yfilter != YFilter.not_set or
                                    self.queue_id.yfilter != YFilter.not_set or
                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                    self.tail_drop_bytes.yfilter != YFilter.not_set or
                                    self.tail_drop_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "queue-stats-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.atm_clp0_drop_bytes.is_set or self.atm_clp0_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp0_drop_bytes.get_name_leafdata())
                                if (self.atm_clp0_drop_packets.is_set or self.atm_clp0_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp0_drop_packets.get_name_leafdata())
                                if (self.atm_clp1_drop_bytes.is_set or self.atm_clp1_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp1_drop_bytes.get_name_leafdata())
                                if (self.atm_clp1_drop_packets.is_set or self.atm_clp1_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.atm_clp1_drop_packets.get_name_leafdata())
                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                if (self.forced_wred_stats_display.is_set or self.forced_wred_stats_display.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forced_wred_stats_display.get_name_leafdata())
                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                if (self.queue_drop_threshold.is_set or self.queue_drop_threshold.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.queue_drop_threshold.get_name_leafdata())
                                if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.queue_id.get_name_leafdata())
                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                if (self.tail_drop_bytes.is_set or self.tail_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tail_drop_bytes.get_name_leafdata())
                                if (self.tail_drop_packets.is_set or self.tail_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tail_drop_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "queue-average-length"):
                                    for c in self.queue_average_length:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueAverageLength()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.queue_average_length.append(c)
                                    return c

                                if (child_yang_name == "queue-instance-length"):
                                    for c in self.queue_instance_length:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueInstanceLength()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.queue_instance_length.append(c)
                                    return c

                                if (child_yang_name == "queue-max-length"):
                                    for c in self.queue_max_length:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray.QueueMaxLength()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.queue_max_length.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "queue-average-length" or name == "queue-instance-length" or name == "queue-max-length" or name == "atm-clp0-drop-bytes" or name == "atm-clp0-drop-packets" or name == "atm-clp1-drop-bytes" or name == "atm-clp1-drop-packets" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "forced-wred-stats-display" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "queue-drop-threshold" or name == "queue-id" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "tail-drop-bytes" or name == "tail-drop-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "atm-clp0-drop-bytes"):
                                    self.atm_clp0_drop_bytes = value
                                    self.atm_clp0_drop_bytes.value_namespace = name_space
                                    self.atm_clp0_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "atm-clp0-drop-packets"):
                                    self.atm_clp0_drop_packets = value
                                    self.atm_clp0_drop_packets.value_namespace = name_space
                                    self.atm_clp0_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "atm-clp1-drop-bytes"):
                                    self.atm_clp1_drop_bytes = value
                                    self.atm_clp1_drop_bytes.value_namespace = name_space
                                    self.atm_clp1_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "atm-clp1-drop-packets"):
                                    self.atm_clp1_drop_packets = value
                                    self.atm_clp1_drop_packets.value_namespace = name_space
                                    self.atm_clp1_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-bytes"):
                                    self.conform_bytes = value
                                    self.conform_bytes.value_namespace = name_space
                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-packets"):
                                    self.conform_packets = value
                                    self.conform_packets.value_namespace = name_space
                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-rate"):
                                    self.conform_rate = value
                                    self.conform_rate.value_namespace = name_space
                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-bytes"):
                                    self.exceed_bytes = value
                                    self.exceed_bytes.value_namespace = name_space
                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-packets"):
                                    self.exceed_packets = value
                                    self.exceed_packets.value_namespace = name_space
                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-rate"):
                                    self.exceed_rate = value
                                    self.exceed_rate.value_namespace = name_space
                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "forced-wred-stats-display"):
                                    self.forced_wred_stats_display = value
                                    self.forced_wred_stats_display.value_namespace = name_space
                                    self.forced_wred_stats_display.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-threshold-bytes"):
                                    self.max_threshold_bytes = value
                                    self.max_threshold_bytes.value_namespace = name_space
                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-threshold-packets"):
                                    self.max_threshold_packets = value
                                    self.max_threshold_packets.value_namespace = name_space
                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "queue-drop-threshold"):
                                    self.queue_drop_threshold = value
                                    self.queue_drop_threshold.value_namespace = name_space
                                    self.queue_drop_threshold.value_namespace_prefix = name_space_prefix
                                if(value_path == "queue-id"):
                                    self.queue_id = value
                                    self.queue_id.value_namespace = name_space
                                    self.queue_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-bytes"):
                                    self.random_drop_bytes = value
                                    self.random_drop_bytes.value_namespace = name_space
                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-packets"):
                                    self.random_drop_packets = value
                                    self.random_drop_packets.value_namespace = name_space
                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "tail-drop-bytes"):
                                    self.tail_drop_bytes = value
                                    self.tail_drop_bytes.value_namespace = name_space
                                    self.tail_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "tail-drop-packets"):
                                    self.tail_drop_packets = value
                                    self.tail_drop_packets.value_namespace = name_space
                                    self.tail_drop_packets.value_namespace_prefix = name_space_prefix


                        class PoliceStatsArray(Entity):
                            """
                            array of police stats
                            
                            .. attribute:: color_class_stats
                            
                            	color class stats
                            	**type**\:   :py:class:`ColorClassStats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats>`
                            
                            .. attribute:: conform_bytes
                            
                            	Bytes that conform to the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: conform_packets
                            
                            	Packets that conform  to the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: conform_rate
                            
                            	Conform rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: drop_bytes
                            
                            	Police dropped bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: drop_packets
                            
                            	Police dropped packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: exceed_bytes
                            
                            	Bytes that exceed  the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: exceed_packets
                            
                            	Packets that exceed the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: exceed_rate
                            
                            	Exceed rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: parent_drop_bytes
                            
                            	Dropped bytes by the parent policer
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: parent_drop_packets
                            
                            	Dropped pkts by the parent policer
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: violate_bytes
                            
                            	Bytes that violate the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: violate_packets
                            
                            	Packets violating the policed rate
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: violate_rate
                            
                            	Violate rate in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray, self).__init__()

                                self.yang_name = "police-stats-array"
                                self.yang_parent_name = "class-stats"

                                self.conform_bytes = YLeaf(YType.uint64, "conform-bytes")

                                self.conform_packets = YLeaf(YType.uint64, "conform-packets")

                                self.conform_rate = YLeaf(YType.uint32, "conform-rate")

                                self.drop_bytes = YLeaf(YType.uint64, "drop-bytes")

                                self.drop_packets = YLeaf(YType.uint64, "drop-packets")

                                self.exceed_bytes = YLeaf(YType.uint64, "exceed-bytes")

                                self.exceed_packets = YLeaf(YType.uint64, "exceed-packets")

                                self.exceed_rate = YLeaf(YType.uint32, "exceed-rate")

                                self.parent_drop_bytes = YLeaf(YType.uint64, "parent-drop-bytes")

                                self.parent_drop_packets = YLeaf(YType.uint64, "parent-drop-packets")

                                self.violate_bytes = YLeaf(YType.uint64, "violate-bytes")

                                self.violate_packets = YLeaf(YType.uint64, "violate-packets")

                                self.violate_rate = YLeaf(YType.uint32, "violate-rate")

                                self.color_class_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                self.color_class_stats.parent = self
                                self._children_name_map["color_class_stats"] = "color-class-stats"
                                self._children_yang_names.add("color-class-stats")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("conform_bytes",
                                                "conform_packets",
                                                "conform_rate",
                                                "drop_bytes",
                                                "drop_packets",
                                                "exceed_bytes",
                                                "exceed_packets",
                                                "exceed_rate",
                                                "parent_drop_bytes",
                                                "parent_drop_packets",
                                                "violate_bytes",
                                                "violate_packets",
                                                "violate_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray, self).__setattr__(name, value)


                            class ColorClassStats(Entity):
                                """
                                color class stats
                                
                                .. attribute:: conform_class_conform_bytes
                                
                                	Bytes with classification result conform and policer result conform
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: conform_class_conform_packets
                                
                                	Packets with classification result conform and policer result conform
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: conform_class_conform_rate
                                
                                	Conform Class Conform rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: conform_class_exceed_bytes
                                
                                	Bytes with classification result conform and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: conform_class_exceed_packets
                                
                                	Packets with classification result conform and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: conform_class_exceed_rate
                                
                                	Conform Class Exceed rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: conform_class_violate_bytes
                                
                                	Bytes with classification result conform and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: conform_class_violate_packets
                                
                                	Packets with classification result conform and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: conform_class_violate_rate
                                
                                	Conform Class Violate rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: exceed_class_exceed_bytes
                                
                                	Bytes with classification result exceed and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: exceed_class_exceed_packets
                                
                                	Packets with classification result exceed and policer result exceed
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: exceed_class_exceed_rate
                                
                                	Exceed Class Exceed rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: exceed_class_violate_bytes
                                
                                	Bytes with classification result exceed and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: exceed_class_violate_packets
                                
                                	Packets with classification result exceed and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: exceed_class_violate_rate
                                
                                	Exceed Class Violate rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: violate_class_violate_bytes
                                
                                	Bytes with classification result violate and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                	**units**\: byte
                                
                                .. attribute:: violate_class_violate_packets
                                
                                	Packets with classification result violate and policer result violate
                                	**type**\:  int
                                
                                	**range:** 0..18446744073709551615
                                
                                .. attribute:: violate_class_violate_rate
                                
                                	Violate Class Violate rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__init__()

                                    self.yang_name = "color-class-stats"
                                    self.yang_parent_name = "police-stats-array"

                                    self.conform_class_conform_bytes = YLeaf(YType.uint64, "conform-class-conform-bytes")

                                    self.conform_class_conform_packets = YLeaf(YType.uint64, "conform-class-conform-packets")

                                    self.conform_class_conform_rate = YLeaf(YType.uint32, "conform-class-conform-rate")

                                    self.conform_class_exceed_bytes = YLeaf(YType.uint64, "conform-class-exceed-bytes")

                                    self.conform_class_exceed_packets = YLeaf(YType.uint64, "conform-class-exceed-packets")

                                    self.conform_class_exceed_rate = YLeaf(YType.uint32, "conform-class-exceed-rate")

                                    self.conform_class_violate_bytes = YLeaf(YType.uint64, "conform-class-violate-bytes")

                                    self.conform_class_violate_packets = YLeaf(YType.uint64, "conform-class-violate-packets")

                                    self.conform_class_violate_rate = YLeaf(YType.uint32, "conform-class-violate-rate")

                                    self.exceed_class_exceed_bytes = YLeaf(YType.uint64, "exceed-class-exceed-bytes")

                                    self.exceed_class_exceed_packets = YLeaf(YType.uint64, "exceed-class-exceed-packets")

                                    self.exceed_class_exceed_rate = YLeaf(YType.uint32, "exceed-class-exceed-rate")

                                    self.exceed_class_violate_bytes = YLeaf(YType.uint64, "exceed-class-violate-bytes")

                                    self.exceed_class_violate_packets = YLeaf(YType.uint64, "exceed-class-violate-packets")

                                    self.exceed_class_violate_rate = YLeaf(YType.uint32, "exceed-class-violate-rate")

                                    self.violate_class_violate_bytes = YLeaf(YType.uint64, "violate-class-violate-bytes")

                                    self.violate_class_violate_packets = YLeaf(YType.uint64, "violate-class-violate-packets")

                                    self.violate_class_violate_rate = YLeaf(YType.uint32, "violate-class-violate-rate")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("conform_class_conform_bytes",
                                                    "conform_class_conform_packets",
                                                    "conform_class_conform_rate",
                                                    "conform_class_exceed_bytes",
                                                    "conform_class_exceed_packets",
                                                    "conform_class_exceed_rate",
                                                    "conform_class_violate_bytes",
                                                    "conform_class_violate_packets",
                                                    "conform_class_violate_rate",
                                                    "exceed_class_exceed_bytes",
                                                    "exceed_class_exceed_packets",
                                                    "exceed_class_exceed_rate",
                                                    "exceed_class_violate_bytes",
                                                    "exceed_class_violate_packets",
                                                    "exceed_class_violate_rate",
                                                    "violate_class_violate_bytes",
                                                    "violate_class_violate_packets",
                                                    "violate_class_violate_rate") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.conform_class_conform_bytes.is_set or
                                        self.conform_class_conform_packets.is_set or
                                        self.conform_class_conform_rate.is_set or
                                        self.conform_class_exceed_bytes.is_set or
                                        self.conform_class_exceed_packets.is_set or
                                        self.conform_class_exceed_rate.is_set or
                                        self.conform_class_violate_bytes.is_set or
                                        self.conform_class_violate_packets.is_set or
                                        self.conform_class_violate_rate.is_set or
                                        self.exceed_class_exceed_bytes.is_set or
                                        self.exceed_class_exceed_packets.is_set or
                                        self.exceed_class_exceed_rate.is_set or
                                        self.exceed_class_violate_bytes.is_set or
                                        self.exceed_class_violate_packets.is_set or
                                        self.exceed_class_violate_rate.is_set or
                                        self.violate_class_violate_bytes.is_set or
                                        self.violate_class_violate_packets.is_set or
                                        self.violate_class_violate_rate.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.conform_class_conform_bytes.yfilter != YFilter.not_set or
                                        self.conform_class_conform_packets.yfilter != YFilter.not_set or
                                        self.conform_class_conform_rate.yfilter != YFilter.not_set or
                                        self.conform_class_exceed_bytes.yfilter != YFilter.not_set or
                                        self.conform_class_exceed_packets.yfilter != YFilter.not_set or
                                        self.conform_class_exceed_rate.yfilter != YFilter.not_set or
                                        self.conform_class_violate_bytes.yfilter != YFilter.not_set or
                                        self.conform_class_violate_packets.yfilter != YFilter.not_set or
                                        self.conform_class_violate_rate.yfilter != YFilter.not_set or
                                        self.exceed_class_exceed_bytes.yfilter != YFilter.not_set or
                                        self.exceed_class_exceed_packets.yfilter != YFilter.not_set or
                                        self.exceed_class_exceed_rate.yfilter != YFilter.not_set or
                                        self.exceed_class_violate_bytes.yfilter != YFilter.not_set or
                                        self.exceed_class_violate_packets.yfilter != YFilter.not_set or
                                        self.exceed_class_violate_rate.yfilter != YFilter.not_set or
                                        self.violate_class_violate_bytes.yfilter != YFilter.not_set or
                                        self.violate_class_violate_packets.yfilter != YFilter.not_set or
                                        self.violate_class_violate_rate.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "color-class-stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.conform_class_conform_bytes.is_set or self.conform_class_conform_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_conform_bytes.get_name_leafdata())
                                    if (self.conform_class_conform_packets.is_set or self.conform_class_conform_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_conform_packets.get_name_leafdata())
                                    if (self.conform_class_conform_rate.is_set or self.conform_class_conform_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_conform_rate.get_name_leafdata())
                                    if (self.conform_class_exceed_bytes.is_set or self.conform_class_exceed_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_exceed_bytes.get_name_leafdata())
                                    if (self.conform_class_exceed_packets.is_set or self.conform_class_exceed_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_exceed_packets.get_name_leafdata())
                                    if (self.conform_class_exceed_rate.is_set or self.conform_class_exceed_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_exceed_rate.get_name_leafdata())
                                    if (self.conform_class_violate_bytes.is_set or self.conform_class_violate_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_violate_bytes.get_name_leafdata())
                                    if (self.conform_class_violate_packets.is_set or self.conform_class_violate_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_violate_packets.get_name_leafdata())
                                    if (self.conform_class_violate_rate.is_set or self.conform_class_violate_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.conform_class_violate_rate.get_name_leafdata())
                                    if (self.exceed_class_exceed_bytes.is_set or self.exceed_class_exceed_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_exceed_bytes.get_name_leafdata())
                                    if (self.exceed_class_exceed_packets.is_set or self.exceed_class_exceed_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_exceed_packets.get_name_leafdata())
                                    if (self.exceed_class_exceed_rate.is_set or self.exceed_class_exceed_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_exceed_rate.get_name_leafdata())
                                    if (self.exceed_class_violate_bytes.is_set or self.exceed_class_violate_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_violate_bytes.get_name_leafdata())
                                    if (self.exceed_class_violate_packets.is_set or self.exceed_class_violate_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_violate_packets.get_name_leafdata())
                                    if (self.exceed_class_violate_rate.is_set or self.exceed_class_violate_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exceed_class_violate_rate.get_name_leafdata())
                                    if (self.violate_class_violate_bytes.is_set or self.violate_class_violate_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.violate_class_violate_bytes.get_name_leafdata())
                                    if (self.violate_class_violate_packets.is_set or self.violate_class_violate_packets.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.violate_class_violate_packets.get_name_leafdata())
                                    if (self.violate_class_violate_rate.is_set or self.violate_class_violate_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.violate_class_violate_rate.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "conform-class-conform-bytes" or name == "conform-class-conform-packets" or name == "conform-class-conform-rate" or name == "conform-class-exceed-bytes" or name == "conform-class-exceed-packets" or name == "conform-class-exceed-rate" or name == "conform-class-violate-bytes" or name == "conform-class-violate-packets" or name == "conform-class-violate-rate" or name == "exceed-class-exceed-bytes" or name == "exceed-class-exceed-packets" or name == "exceed-class-exceed-rate" or name == "exceed-class-violate-bytes" or name == "exceed-class-violate-packets" or name == "exceed-class-violate-rate" or name == "violate-class-violate-bytes" or name == "violate-class-violate-packets" or name == "violate-class-violate-rate"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "conform-class-conform-bytes"):
                                        self.conform_class_conform_bytes = value
                                        self.conform_class_conform_bytes.value_namespace = name_space
                                        self.conform_class_conform_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-conform-packets"):
                                        self.conform_class_conform_packets = value
                                        self.conform_class_conform_packets.value_namespace = name_space
                                        self.conform_class_conform_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-conform-rate"):
                                        self.conform_class_conform_rate = value
                                        self.conform_class_conform_rate.value_namespace = name_space
                                        self.conform_class_conform_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-exceed-bytes"):
                                        self.conform_class_exceed_bytes = value
                                        self.conform_class_exceed_bytes.value_namespace = name_space
                                        self.conform_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-exceed-packets"):
                                        self.conform_class_exceed_packets = value
                                        self.conform_class_exceed_packets.value_namespace = name_space
                                        self.conform_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-exceed-rate"):
                                        self.conform_class_exceed_rate = value
                                        self.conform_class_exceed_rate.value_namespace = name_space
                                        self.conform_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-violate-bytes"):
                                        self.conform_class_violate_bytes = value
                                        self.conform_class_violate_bytes.value_namespace = name_space
                                        self.conform_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-violate-packets"):
                                        self.conform_class_violate_packets = value
                                        self.conform_class_violate_packets.value_namespace = name_space
                                        self.conform_class_violate_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "conform-class-violate-rate"):
                                        self.conform_class_violate_rate = value
                                        self.conform_class_violate_rate.value_namespace = name_space
                                        self.conform_class_violate_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-exceed-bytes"):
                                        self.exceed_class_exceed_bytes = value
                                        self.exceed_class_exceed_bytes.value_namespace = name_space
                                        self.exceed_class_exceed_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-exceed-packets"):
                                        self.exceed_class_exceed_packets = value
                                        self.exceed_class_exceed_packets.value_namespace = name_space
                                        self.exceed_class_exceed_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-exceed-rate"):
                                        self.exceed_class_exceed_rate = value
                                        self.exceed_class_exceed_rate.value_namespace = name_space
                                        self.exceed_class_exceed_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-violate-bytes"):
                                        self.exceed_class_violate_bytes = value
                                        self.exceed_class_violate_bytes.value_namespace = name_space
                                        self.exceed_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-violate-packets"):
                                        self.exceed_class_violate_packets = value
                                        self.exceed_class_violate_packets.value_namespace = name_space
                                        self.exceed_class_violate_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exceed-class-violate-rate"):
                                        self.exceed_class_violate_rate = value
                                        self.exceed_class_violate_rate.value_namespace = name_space
                                        self.exceed_class_violate_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "violate-class-violate-bytes"):
                                        self.violate_class_violate_bytes = value
                                        self.violate_class_violate_bytes.value_namespace = name_space
                                        self.violate_class_violate_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "violate-class-violate-packets"):
                                        self.violate_class_violate_packets = value
                                        self.violate_class_violate_packets.value_namespace = name_space
                                        self.violate_class_violate_packets.value_namespace_prefix = name_space_prefix
                                    if(value_path == "violate-class-violate-rate"):
                                        self.violate_class_violate_rate = value
                                        self.violate_class_violate_rate.value_namespace = name_space
                                        self.violate_class_violate_rate.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.conform_bytes.is_set or
                                    self.conform_packets.is_set or
                                    self.conform_rate.is_set or
                                    self.drop_bytes.is_set or
                                    self.drop_packets.is_set or
                                    self.exceed_bytes.is_set or
                                    self.exceed_packets.is_set or
                                    self.exceed_rate.is_set or
                                    self.parent_drop_bytes.is_set or
                                    self.parent_drop_packets.is_set or
                                    self.violate_bytes.is_set or
                                    self.violate_packets.is_set or
                                    self.violate_rate.is_set or
                                    (self.color_class_stats is not None and self.color_class_stats.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.conform_bytes.yfilter != YFilter.not_set or
                                    self.conform_packets.yfilter != YFilter.not_set or
                                    self.conform_rate.yfilter != YFilter.not_set or
                                    self.drop_bytes.yfilter != YFilter.not_set or
                                    self.drop_packets.yfilter != YFilter.not_set or
                                    self.exceed_bytes.yfilter != YFilter.not_set or
                                    self.exceed_packets.yfilter != YFilter.not_set or
                                    self.exceed_rate.yfilter != YFilter.not_set or
                                    self.parent_drop_bytes.yfilter != YFilter.not_set or
                                    self.parent_drop_packets.yfilter != YFilter.not_set or
                                    self.violate_bytes.yfilter != YFilter.not_set or
                                    self.violate_packets.yfilter != YFilter.not_set or
                                    self.violate_rate.yfilter != YFilter.not_set or
                                    (self.color_class_stats is not None and self.color_class_stats.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "police-stats-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.conform_bytes.is_set or self.conform_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_bytes.get_name_leafdata())
                                if (self.conform_packets.is_set or self.conform_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_packets.get_name_leafdata())
                                if (self.conform_rate.is_set or self.conform_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.conform_rate.get_name_leafdata())
                                if (self.drop_bytes.is_set or self.drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_bytes.get_name_leafdata())
                                if (self.drop_packets.is_set or self.drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.drop_packets.get_name_leafdata())
                                if (self.exceed_bytes.is_set or self.exceed_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_bytes.get_name_leafdata())
                                if (self.exceed_packets.is_set or self.exceed_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_packets.get_name_leafdata())
                                if (self.exceed_rate.is_set or self.exceed_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exceed_rate.get_name_leafdata())
                                if (self.parent_drop_bytes.is_set or self.parent_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_drop_bytes.get_name_leafdata())
                                if (self.parent_drop_packets.is_set or self.parent_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_drop_packets.get_name_leafdata())
                                if (self.violate_bytes.is_set or self.violate_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.violate_bytes.get_name_leafdata())
                                if (self.violate_packets.is_set or self.violate_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.violate_packets.get_name_leafdata())
                                if (self.violate_rate.is_set or self.violate_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.violate_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "color-class-stats"):
                                    if (self.color_class_stats is None):
                                        self.color_class_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray.ColorClassStats()
                                        self.color_class_stats.parent = self
                                        self._children_name_map["color_class_stats"] = "color-class-stats"
                                    return self.color_class_stats

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "color-class-stats" or name == "conform-bytes" or name == "conform-packets" or name == "conform-rate" or name == "drop-bytes" or name == "drop-packets" or name == "exceed-bytes" or name == "exceed-packets" or name == "exceed-rate" or name == "parent-drop-bytes" or name == "parent-drop-packets" or name == "violate-bytes" or name == "violate-packets" or name == "violate-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "conform-bytes"):
                                    self.conform_bytes = value
                                    self.conform_bytes.value_namespace = name_space
                                    self.conform_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-packets"):
                                    self.conform_packets = value
                                    self.conform_packets.value_namespace = name_space
                                    self.conform_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "conform-rate"):
                                    self.conform_rate = value
                                    self.conform_rate.value_namespace = name_space
                                    self.conform_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-bytes"):
                                    self.drop_bytes = value
                                    self.drop_bytes.value_namespace = name_space
                                    self.drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "drop-packets"):
                                    self.drop_packets = value
                                    self.drop_packets.value_namespace = name_space
                                    self.drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-bytes"):
                                    self.exceed_bytes = value
                                    self.exceed_bytes.value_namespace = name_space
                                    self.exceed_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-packets"):
                                    self.exceed_packets = value
                                    self.exceed_packets.value_namespace = name_space
                                    self.exceed_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "exceed-rate"):
                                    self.exceed_rate = value
                                    self.exceed_rate.value_namespace = name_space
                                    self.exceed_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-drop-bytes"):
                                    self.parent_drop_bytes = value
                                    self.parent_drop_bytes.value_namespace = name_space
                                    self.parent_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-drop-packets"):
                                    self.parent_drop_packets = value
                                    self.parent_drop_packets.value_namespace = name_space
                                    self.parent_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "violate-bytes"):
                                    self.violate_bytes = value
                                    self.violate_bytes.value_namespace = name_space
                                    self.violate_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "violate-packets"):
                                    self.violate_packets = value
                                    self.violate_packets.value_namespace = name_space
                                    self.violate_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "violate-rate"):
                                    self.violate_rate = value
                                    self.violate_rate.value_namespace = name_space
                                    self.violate_rate.value_namespace_prefix = name_space_prefix


                        class WredStatsArray(Entity):
                            """
                            array of red stats
                            
                            .. attribute:: max_threshold_bytes
                            
                            	Dropped bytes with  the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: max_threshold_packets
                            
                            	Dropped packets with  the average queue size at the max\-threshold
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: profile_title
                            
                            	ProfileTitle
                            	**type**\:  str
                            
                            	**length:** 0..300
                            
                            .. attribute:: random_drop_bytes
                            
                            	Probabilisticallydropped bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: random_drop_packets
                            
                            	Probabilistically dropped  packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: red_ecn_marked_bytes
                            
                            	ECN marked bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: red_ecn_marked_packets
                            
                            	ECN marked packets 
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: red_label
                            
                            	Array of WRED Typevalues as in PRP stats is available per threshold   
                            	**type**\: list of    :py:class:`RedLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel>`
                            
                            .. attribute:: red_transmit_bytes
                            
                            	Transmitted bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: red_transmit_packets
                            
                            	Transmitted packets
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            

                            """

                            _prefix = 'qos-ma-oper'
                            _revision = '2017-04-10'

                            def __init__(self):
                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray, self).__init__()

                                self.yang_name = "wred-stats-array"
                                self.yang_parent_name = "class-stats"

                                self.max_threshold_bytes = YLeaf(YType.uint64, "max-threshold-bytes")

                                self.max_threshold_packets = YLeaf(YType.uint64, "max-threshold-packets")

                                self.profile_title = YLeaf(YType.str, "profile-title")

                                self.random_drop_bytes = YLeaf(YType.uint64, "random-drop-bytes")

                                self.random_drop_packets = YLeaf(YType.uint64, "random-drop-packets")

                                self.red_ecn_marked_bytes = YLeaf(YType.uint64, "red-ecn-marked-bytes")

                                self.red_ecn_marked_packets = YLeaf(YType.uint64, "red-ecn-marked-packets")

                                self.red_transmit_bytes = YLeaf(YType.uint64, "red-transmit-bytes")

                                self.red_transmit_packets = YLeaf(YType.uint64, "red-transmit-packets")

                                self.red_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("max_threshold_bytes",
                                                "max_threshold_packets",
                                                "profile_title",
                                                "random_drop_bytes",
                                                "random_drop_packets",
                                                "red_ecn_marked_bytes",
                                                "red_ecn_marked_packets",
                                                "red_transmit_bytes",
                                                "red_transmit_packets") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray, self).__setattr__(name, value)


                            class RedLabel(Entity):
                                """
                                Array of WRED Typevalues as in PRP stats is
                                available per threshold   
                                
                                .. attribute:: value
                                
                                	WRED value for this type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: wred_type
                                
                                	WRED type DSCP, EXP, PREC etc
                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_qos_ma_oper.Wred>`
                                
                                

                                """

                                _prefix = 'qos-ma-oper'
                                _revision = '2017-04-10'

                                def __init__(self):
                                    super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__init__()

                                    self.yang_name = "red-label"
                                    self.yang_parent_name = "wred-stats-array"

                                    self.value = YLeaf(YType.uint8, "value")

                                    self.wred_type = YLeaf(YType.enumeration, "wred-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("value",
                                                    "wred_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.value.is_set or
                                        self.wred_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.value.yfilter != YFilter.not_set or
                                        self.wred_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "red-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.value.get_name_leafdata())
                                    if (self.wred_type.is_set or self.wred_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.wred_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "value" or name == "wred-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "value"):
                                        self.value = value
                                        self.value.value_namespace = name_space
                                        self.value.value_namespace_prefix = name_space_prefix
                                    if(value_path == "wred-type"):
                                        self.wred_type = value
                                        self.wred_type.value_namespace = name_space
                                        self.wred_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.red_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.max_threshold_bytes.is_set or
                                    self.max_threshold_packets.is_set or
                                    self.profile_title.is_set or
                                    self.random_drop_bytes.is_set or
                                    self.random_drop_packets.is_set or
                                    self.red_ecn_marked_bytes.is_set or
                                    self.red_ecn_marked_packets.is_set or
                                    self.red_transmit_bytes.is_set or
                                    self.red_transmit_packets.is_set)

                            def has_operation(self):
                                for c in self.red_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.max_threshold_bytes.yfilter != YFilter.not_set or
                                    self.max_threshold_packets.yfilter != YFilter.not_set or
                                    self.profile_title.yfilter != YFilter.not_set or
                                    self.random_drop_bytes.yfilter != YFilter.not_set or
                                    self.random_drop_packets.yfilter != YFilter.not_set or
                                    self.red_ecn_marked_bytes.yfilter != YFilter.not_set or
                                    self.red_ecn_marked_packets.yfilter != YFilter.not_set or
                                    self.red_transmit_bytes.yfilter != YFilter.not_set or
                                    self.red_transmit_packets.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "wred-stats-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.max_threshold_bytes.is_set or self.max_threshold_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_bytes.get_name_leafdata())
                                if (self.max_threshold_packets.is_set or self.max_threshold_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.max_threshold_packets.get_name_leafdata())
                                if (self.profile_title.is_set or self.profile_title.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.profile_title.get_name_leafdata())
                                if (self.random_drop_bytes.is_set or self.random_drop_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_bytes.get_name_leafdata())
                                if (self.random_drop_packets.is_set or self.random_drop_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.random_drop_packets.get_name_leafdata())
                                if (self.red_ecn_marked_bytes.is_set or self.red_ecn_marked_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_ecn_marked_bytes.get_name_leafdata())
                                if (self.red_ecn_marked_packets.is_set or self.red_ecn_marked_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_ecn_marked_packets.get_name_leafdata())
                                if (self.red_transmit_bytes.is_set or self.red_transmit_bytes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_transmit_bytes.get_name_leafdata())
                                if (self.red_transmit_packets.is_set or self.red_transmit_packets.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.red_transmit_packets.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "red-label"):
                                    for c in self.red_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray.RedLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.red_label.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "red-label" or name == "max-threshold-bytes" or name == "max-threshold-packets" or name == "profile-title" or name == "random-drop-bytes" or name == "random-drop-packets" or name == "red-ecn-marked-bytes" or name == "red-ecn-marked-packets" or name == "red-transmit-bytes" or name == "red-transmit-packets"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "max-threshold-bytes"):
                                    self.max_threshold_bytes = value
                                    self.max_threshold_bytes.value_namespace = name_space
                                    self.max_threshold_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "max-threshold-packets"):
                                    self.max_threshold_packets = value
                                    self.max_threshold_packets.value_namespace = name_space
                                    self.max_threshold_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "profile-title"):
                                    self.profile_title = value
                                    self.profile_title.value_namespace = name_space
                                    self.profile_title.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-bytes"):
                                    self.random_drop_bytes = value
                                    self.random_drop_bytes.value_namespace = name_space
                                    self.random_drop_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "random-drop-packets"):
                                    self.random_drop_packets = value
                                    self.random_drop_packets.value_namespace = name_space
                                    self.random_drop_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-ecn-marked-bytes"):
                                    self.red_ecn_marked_bytes = value
                                    self.red_ecn_marked_bytes.value_namespace = name_space
                                    self.red_ecn_marked_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-ecn-marked-packets"):
                                    self.red_ecn_marked_packets = value
                                    self.red_ecn_marked_packets.value_namespace = name_space
                                    self.red_ecn_marked_packets.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-transmit-bytes"):
                                    self.red_transmit_bytes = value
                                    self.red_transmit_bytes.value_namespace = name_space
                                    self.red_transmit_bytes.value_namespace_prefix = name_space_prefix
                                if(value_path == "red-transmit-packets"):
                                    self.red_transmit_packets = value
                                    self.red_transmit_packets.value_namespace = name_space
                                    self.red_transmit_packets.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.police_stats_array:
                                if (c.has_data()):
                                    return True
                            for c in self.queue_stats_array:
                                if (c.has_data()):
                                    return True
                            for c in self.wred_stats_array:
                                if (c.has_data()):
                                    return True
                            return (
                                self.cac_state.is_set or
                                self.class_name.is_set or
                                self.counter_validity_bitmask.is_set or
                                self.queue_descr.is_set or
                                self.shared_queue_id.is_set or
                                (self.cac_stats is not None and self.cac_stats.has_data()) or
                                (self.child_policy is not None and self.child_policy.has_data()) or
                                (self.general_stats is not None and self.general_stats.has_data()) or
                                (self.iphc_stats is not None and self.iphc_stats.has_data()))

                        def has_operation(self):
                            for c in self.police_stats_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.queue_stats_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.wred_stats_array:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.cac_state.yfilter != YFilter.not_set or
                                self.class_name.yfilter != YFilter.not_set or
                                self.counter_validity_bitmask.yfilter != YFilter.not_set or
                                self.queue_descr.yfilter != YFilter.not_set or
                                self.shared_queue_id.yfilter != YFilter.not_set or
                                (self.cac_stats is not None and self.cac_stats.has_operation()) or
                                (self.child_policy is not None and self.child_policy.has_operation()) or
                                (self.general_stats is not None and self.general_stats.has_operation()) or
                                (self.iphc_stats is not None and self.iphc_stats.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "class-stats" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.cac_state.is_set or self.cac_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.cac_state.get_name_leafdata())
                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.class_name.get_name_leafdata())
                            if (self.counter_validity_bitmask.is_set or self.counter_validity_bitmask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.counter_validity_bitmask.get_name_leafdata())
                            if (self.queue_descr.is_set or self.queue_descr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.queue_descr.get_name_leafdata())
                            if (self.shared_queue_id.is_set or self.shared_queue_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared_queue_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "cac-stats"):
                                if (self.cac_stats is None):
                                    self.cac_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.CacStats()
                                    self.cac_stats.parent = self
                                    self._children_name_map["cac_stats"] = "cac-stats"
                                return self.cac_stats

                            if (child_yang_name == "child-policy"):
                                if (self.child_policy is None):
                                    self.child_policy = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.ChildPolicy()
                                    self.child_policy.parent = self
                                    self._children_name_map["child_policy"] = "child-policy"
                                return self.child_policy

                            if (child_yang_name == "general-stats"):
                                if (self.general_stats is None):
                                    self.general_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.GeneralStats()
                                    self.general_stats.parent = self
                                    self._children_name_map["general_stats"] = "general-stats"
                                return self.general_stats

                            if (child_yang_name == "iphc-stats"):
                                if (self.iphc_stats is None):
                                    self.iphc_stats = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.IphcStats()
                                    self.iphc_stats.parent = self
                                    self._children_name_map["iphc_stats"] = "iphc-stats"
                                return self.iphc_stats

                            if (child_yang_name == "police-stats-array"):
                                for c in self.police_stats_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.PoliceStatsArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.police_stats_array.append(c)
                                return c

                            if (child_yang_name == "queue-stats-array"):
                                for c in self.queue_stats_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.QueueStatsArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.queue_stats_array.append(c)
                                return c

                            if (child_yang_name == "wred-stats-array"):
                                for c in self.wred_stats_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats.WredStatsArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.wred_stats_array.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "cac-stats" or name == "child-policy" or name == "general-stats" or name == "iphc-stats" or name == "police-stats-array" or name == "queue-stats-array" or name == "wred-stats-array" or name == "cac-state" or name == "class-name" or name == "counter-validity-bitmask" or name == "queue-descr" or name == "shared-queue-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "cac-state"):
                                self.cac_state = value
                                self.cac_state.value_namespace = name_space
                                self.cac_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "class-name"):
                                self.class_name = value
                                self.class_name.value_namespace = name_space
                                self.class_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "counter-validity-bitmask"):
                                self.counter_validity_bitmask = value
                                self.counter_validity_bitmask.value_namespace = name_space
                                self.counter_validity_bitmask.value_namespace_prefix = name_space_prefix
                            if(value_path == "queue-descr"):
                                self.queue_descr = value
                                self.queue_descr.value_namespace = name_space
                                self.queue_descr.value_namespace_prefix = name_space_prefix
                            if(value_path == "shared-queue-id"):
                                self.shared_queue_id = value
                                self.shared_queue_id.value_namespace = name_space
                                self.shared_queue_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.class_stats:
                            if (c.has_data()):
                                return True
                        return (
                            self.policy_name.is_set or
                            self.satid.is_set or
                            self.state.is_set or
                            self.state_description.is_set)

                    def has_operation(self):
                        for c in self.class_stats:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.policy_name.yfilter != YFilter.not_set or
                            self.satid.yfilter != YFilter.not_set or
                            self.state.yfilter != YFilter.not_set or
                            self.state_description.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.policy_name.get_name_leafdata())
                        if (self.satid.is_set or self.satid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.satid.get_name_leafdata())
                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.state.get_name_leafdata())
                        if (self.state_description.is_set or self.state_description.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.state_description.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "class-stats"):
                            for c in self.class_stats:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = Qos.InterfaceTable.Interface.Output.Statistics.ClassStats()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.class_stats.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "class-stats" or name == "policy-name" or name == "satid" or name == "state" or name == "state-description"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "policy-name"):
                            self.policy_name = value
                            self.policy_name.value_namespace = name_space
                            self.policy_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "satid"):
                            self.satid = value
                            self.satid.value_namespace = name_space
                            self.satid.value_namespace_prefix = name_space_prefix
                        if(value_path == "state"):
                            self.state = value
                            self.state.value_namespace = name_space
                            self.state.value_namespace_prefix = name_space_prefix
                        if(value_path == "state-description"):
                            self.state_description = value
                            self.state_description.value_namespace = name_space
                            self.state_description.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        (self.service_policy_names is not None and self.service_policy_names.has_data()) or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.service_policy_names is not None and self.service_policy_names.has_operation()) or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "output" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "service-policy-names"):
                        if (self.service_policy_names is None):
                            self.service_policy_names = Qos.InterfaceTable.Interface.Output.ServicePolicyNames()
                            self.service_policy_names.parent = self
                            self._children_name_map["service_policy_names"] = "service-policy-names"
                        return self.service_policy_names

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = Qos.InterfaceTable.Interface.Output.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "service-policy-names" or name == "statistics"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (
                    self.interface_name.is_set or
                    (self.input is not None and self.input.has_data()) or
                    (self.member_interfaces is not None and self.member_interfaces.has_data()) or
                    (self.nodes is not None and self.nodes.has_data()) or
                    (self.output is not None and self.output.has_data()) or
                    (self.satellite_ids is not None and self.satellite_ids.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.interface_name.yfilter != YFilter.not_set or
                    (self.input is not None and self.input.has_operation()) or
                    (self.member_interfaces is not None and self.member_interfaces.has_operation()) or
                    (self.nodes is not None and self.nodes.has_operation()) or
                    (self.output is not None and self.output.has_operation()) or
                    (self.satellite_ids is not None and self.satellite_ids.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/interface-table/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.interface_name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "input"):
                    if (self.input is None):
                        self.input = Qos.InterfaceTable.Interface.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"
                    return self.input

                if (child_yang_name == "member-interfaces"):
                    if (self.member_interfaces is None):
                        self.member_interfaces = Qos.InterfaceTable.Interface.MemberInterfaces()
                        self.member_interfaces.parent = self
                        self._children_name_map["member_interfaces"] = "member-interfaces"
                    return self.member_interfaces

                if (child_yang_name == "nodes"):
                    if (self.nodes is None):
                        self.nodes = Qos.InterfaceTable.Interface.Nodes()
                        self.nodes.parent = self
                        self._children_name_map["nodes"] = "nodes"
                    return self.nodes

                if (child_yang_name == "output"):
                    if (self.output is None):
                        self.output = Qos.InterfaceTable.Interface.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                    return self.output

                if (child_yang_name == "satellite-ids"):
                    if (self.satellite_ids is None):
                        self.satellite_ids = Qos.InterfaceTable.Interface.SatelliteIds()
                        self.satellite_ids.parent = self
                        self._children_name_map["satellite_ids"] = "satellite-ids"
                    return self.satellite_ids

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "input" or name == "member-interfaces" or name == "nodes" or name == "output" or name == "satellite-ids" or name == "interface-name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "interface-name"):
                    self.interface_name = value
                    self.interface_name.value_namespace = name_space
                    self.interface_name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.interface:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.interface:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "interface-table" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "interface"):
                for c in self.interface:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = Qos.InterfaceTable.Interface()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.interface.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "interface"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass

    def has_data(self):
        return (
            (self.interface_table is not None and self.interface_table.has_data()) or
            (self.nodes is not None and self.nodes.has_data()) or
            (self.nv_interface_table is not None and self.nv_interface_table.has_data()) or
            (self.nv_satellite is not None and self.nv_satellite.has_data()) or
            (self.qos_global is not None and self.qos_global.has_data()))

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.interface_table is not None and self.interface_table.has_operation()) or
            (self.nodes is not None and self.nodes.has_operation()) or
            (self.nv_interface_table is not None and self.nv_interface_table.has_operation()) or
            (self.nv_satellite is not None and self.nv_satellite.has_operation()) or
            (self.qos_global is not None and self.qos_global.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-qos-ma-oper:qos" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "interface-table"):
            if (self.interface_table is None):
                self.interface_table = Qos.InterfaceTable()
                self.interface_table.parent = self
                self._children_name_map["interface_table"] = "interface-table"
            return self.interface_table

        if (child_yang_name == "nodes"):
            if (self.nodes is None):
                self.nodes = Qos.Nodes()
                self.nodes.parent = self
                self._children_name_map["nodes"] = "nodes"
            return self.nodes

        if (child_yang_name == "nv-interface-table"):
            if (self.nv_interface_table is None):
                self.nv_interface_table = Qos.NvInterfaceTable()
                self.nv_interface_table.parent = self
                self._children_name_map["nv_interface_table"] = "nv-interface-table"
            return self.nv_interface_table

        if (child_yang_name == "nv-satellite"):
            if (self.nv_satellite is None):
                self.nv_satellite = Qos.NvSatellite()
                self.nv_satellite.parent = self
                self._children_name_map["nv_satellite"] = "nv-satellite"
            return self.nv_satellite

        if (child_yang_name == "qos-global"):
            if (self.qos_global is None):
                self.qos_global = Qos.QosGlobal()
                self.qos_global.parent = self
                self._children_name_map["qos_global"] = "qos-global"
            return self.qos_global

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "interface-table" or name == "nodes" or name == "nv-interface-table" or name == "nv-satellite" or name == "qos-global"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = Qos()
        return self._top_entity

